/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM $SRCDIR/comm/mailnews/protocols/ews/src/IEwsClient.idl
 */

#ifndef __gen_IEwsClient_h__
#define __gen_IEwsClient_h__


#include "nsISupports.h"

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIMsgDBHdr; /* forward declaration */

class nsIStreamListener; /* forward declaration */

class IEwsIncomingServer; /* forward declaration */

class IEwsFolderCallbacks; /* forward declaration */

class IEwsMessageCallbacks; /* forward declaration */


/* starting interface:    IEwsClient */
#define IEWSCLIENT_IID_STR "4a117361-653b-48a5-9ddb-588482ef9dbb"

#define IEWSCLIENT_IID \
  {0x4a117361, 0x653b, 0x48a5, \
    { 0x9d, 0xdb, 0x58, 0x84, 0x82, 0xef, 0x9d, 0xbb }}

class NS_NO_VTABLE IEwsClient : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(IEWSCLIENT_IID)

  /* void initialize (in AUTF8String endpoint, in IEwsIncomingServer server); */
  NS_IMETHOD Initialize(const nsACString& endpoint, IEwsIncomingServer *server) = 0;

  enum Error : uint8_t {
    EWS_ERR_AUTHENTICATION_FAILED = 0,
    EWS_ERR_UNEXPECTED = 1,
  };

  /* void syncFolderHierarchy (in IEwsFolderCallbacks callbacks, in AUTF8String syncStateToken); */
  NS_IMETHOD SyncFolderHierarchy(IEwsFolderCallbacks *callbacks, const nsACString& syncStateToken) = 0;

  /* void syncMessagesForFolder (in IEwsMessageCallbacks callbacks, in AUTF8String folderId, in AUTF8String syncStateToken); */
  NS_IMETHOD SyncMessagesForFolder(IEwsMessageCallbacks *callbacks, const nsACString& folderId, const nsACString& syncStateToken) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(IEwsClient, IEWSCLIENT_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_IEWSCLIENT \
  NS_IMETHOD Initialize(const nsACString& endpoint, IEwsIncomingServer *server) override; \
  NS_IMETHOD SyncFolderHierarchy(IEwsFolderCallbacks *callbacks, const nsACString& syncStateToken) override; \
  NS_IMETHOD SyncMessagesForFolder(IEwsMessageCallbacks *callbacks, const nsACString& folderId, const nsACString& syncStateToken) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_IEWSCLIENT \
  nsresult Initialize(const nsACString& endpoint, IEwsIncomingServer *server); \
  nsresult SyncFolderHierarchy(IEwsFolderCallbacks *callbacks, const nsACString& syncStateToken); \
  nsresult SyncMessagesForFolder(IEwsMessageCallbacks *callbacks, const nsACString& folderId, const nsACString& syncStateToken); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_IEWSCLIENT(_to) \
  NS_IMETHOD Initialize(const nsACString& endpoint, IEwsIncomingServer *server) override { return _to Initialize(endpoint, server); } \
  NS_IMETHOD SyncFolderHierarchy(IEwsFolderCallbacks *callbacks, const nsACString& syncStateToken) override { return _to SyncFolderHierarchy(callbacks, syncStateToken); } \
  NS_IMETHOD SyncMessagesForFolder(IEwsMessageCallbacks *callbacks, const nsACString& folderId, const nsACString& syncStateToken) override { return _to SyncMessagesForFolder(callbacks, folderId, syncStateToken); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_IEWSCLIENT(_to) \
  NS_IMETHOD Initialize(const nsACString& endpoint, IEwsIncomingServer *server) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Initialize(endpoint, server); } \
  NS_IMETHOD SyncFolderHierarchy(IEwsFolderCallbacks *callbacks, const nsACString& syncStateToken) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SyncFolderHierarchy(callbacks, syncStateToken); } \
  NS_IMETHOD SyncMessagesForFolder(IEwsMessageCallbacks *callbacks, const nsACString& folderId, const nsACString& syncStateToken) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SyncMessagesForFolder(callbacks, folderId, syncStateToken); } 


/* starting interface:    IEwsFolderCallbacks */
#define IEWSFOLDERCALLBACKS_IID_STR "5dacc994-30e0-42f7-94c8-52756638add5"

#define IEWSFOLDERCALLBACKS_IID \
  {0x5dacc994, 0x30e0, 0x42f7, \
    { 0x94, 0xc8, 0x52, 0x75, 0x66, 0x38, 0xad, 0xd5 }}

class NS_NO_VTABLE IEwsFolderCallbacks : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(IEWSFOLDERCALLBACKS_IID)

  /* void recordRootFolder (in AUTF8String id); */
  NS_IMETHOD RecordRootFolder(const nsACString& id) = 0;

  /* void create (in AUTF8String id, in AUTF8String parentId, in AString name, in unsigned long flags); */
  NS_IMETHOD Create(const nsACString& id, const nsACString& parentId, const nsAString& name, uint32_t flags) = 0;

  /* void update (in AUTF8String id, in AUTF8String name); */
  NS_IMETHOD Update(const nsACString& id, const nsACString& name) = 0;

  /* void delete (in AUTF8String id); */
  NS_IMETHOD Delete(const nsACString& id) = 0;

  /* void updateSyncState (in AUTF8String syncStateToken); */
  NS_IMETHOD UpdateSyncState(const nsACString& syncStateToken) = 0;

  /* void onError (in IEwsClient_Error err, in AUTF8String desc); */
  NS_IMETHOD OnError(IEwsClient::Error err, const nsACString& desc) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(IEwsFolderCallbacks, IEWSFOLDERCALLBACKS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_IEWSFOLDERCALLBACKS \
  NS_IMETHOD RecordRootFolder(const nsACString& id) override; \
  NS_IMETHOD Create(const nsACString& id, const nsACString& parentId, const nsAString& name, uint32_t flags) override; \
  NS_IMETHOD Update(const nsACString& id, const nsACString& name) override; \
  NS_IMETHOD Delete(const nsACString& id) override; \
  NS_IMETHOD UpdateSyncState(const nsACString& syncStateToken) override; \
  NS_IMETHOD OnError(IEwsClient::Error err, const nsACString& desc) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_IEWSFOLDERCALLBACKS \
  nsresult RecordRootFolder(const nsACString& id); \
  nsresult Create(const nsACString& id, const nsACString& parentId, const nsAString& name, uint32_t flags); \
  nsresult Update(const nsACString& id, const nsACString& name); \
  nsresult Delete(const nsACString& id); \
  nsresult UpdateSyncState(const nsACString& syncStateToken); \
  nsresult OnError(IEwsClient::Error err, const nsACString& desc); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_IEWSFOLDERCALLBACKS(_to) \
  NS_IMETHOD RecordRootFolder(const nsACString& id) override { return _to RecordRootFolder(id); } \
  NS_IMETHOD Create(const nsACString& id, const nsACString& parentId, const nsAString& name, uint32_t flags) override { return _to Create(id, parentId, name, flags); } \
  NS_IMETHOD Update(const nsACString& id, const nsACString& name) override { return _to Update(id, name); } \
  NS_IMETHOD Delete(const nsACString& id) override { return _to Delete(id); } \
  NS_IMETHOD UpdateSyncState(const nsACString& syncStateToken) override { return _to UpdateSyncState(syncStateToken); } \
  NS_IMETHOD OnError(IEwsClient::Error err, const nsACString& desc) override { return _to OnError(err, desc); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_IEWSFOLDERCALLBACKS(_to) \
  NS_IMETHOD RecordRootFolder(const nsACString& id) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RecordRootFolder(id); } \
  NS_IMETHOD Create(const nsACString& id, const nsACString& parentId, const nsAString& name, uint32_t flags) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Create(id, parentId, name, flags); } \
  NS_IMETHOD Update(const nsACString& id, const nsACString& name) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Update(id, name); } \
  NS_IMETHOD Delete(const nsACString& id) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Delete(id); } \
  NS_IMETHOD UpdateSyncState(const nsACString& syncStateToken) override { return !_to ? NS_ERROR_NULL_POINTER : _to->UpdateSyncState(syncStateToken); } \
  NS_IMETHOD OnError(IEwsClient::Error err, const nsACString& desc) override { return !_to ? NS_ERROR_NULL_POINTER : _to->OnError(err, desc); } 


/* starting interface:    IEwsMessageCallbacks */
#define IEWSMESSAGECALLBACKS_IID_STR "dec2ddd5-b5a2-4724-bfc7-e5de31840f76"

#define IEWSMESSAGECALLBACKS_IID \
  {0xdec2ddd5, 0xb5a2, 0x4724, \
    { 0xbf, 0xc7, 0xe5, 0xde, 0x31, 0x84, 0x0f, 0x76 }}

class NS_NO_VTABLE IEwsMessageCallbacks : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(IEWSMESSAGECALLBACKS_IID)

  /* nsIMsgDBHdr createNewHeader (); */
  NS_IMETHOD CreateNewHeader(nsIMsgDBHdr **_retval) = 0;

  /* void commitHeader (in nsIMsgDBHdr hdr); */
  NS_IMETHOD CommitHeader(nsIMsgDBHdr *hdr) = 0;

  /* void updateSyncState (in AUTF8String syncStateToken); */
  NS_IMETHOD UpdateSyncState(const nsACString& syncStateToken) = 0;

  /* void onError (in IEwsClient_Error err, in AUTF8String desc); */
  NS_IMETHOD OnError(IEwsClient::Error err, const nsACString& desc) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(IEwsMessageCallbacks, IEWSMESSAGECALLBACKS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_IEWSMESSAGECALLBACKS \
  NS_IMETHOD CreateNewHeader(nsIMsgDBHdr **_retval) override; \
  NS_IMETHOD CommitHeader(nsIMsgDBHdr *hdr) override; \
  NS_IMETHOD UpdateSyncState(const nsACString& syncStateToken) override; \
  NS_IMETHOD OnError(IEwsClient::Error err, const nsACString& desc) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_IEWSMESSAGECALLBACKS \
  nsresult CreateNewHeader(nsIMsgDBHdr **_retval); \
  nsresult CommitHeader(nsIMsgDBHdr *hdr); \
  nsresult UpdateSyncState(const nsACString& syncStateToken); \
  nsresult OnError(IEwsClient::Error err, const nsACString& desc); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_IEWSMESSAGECALLBACKS(_to) \
  NS_IMETHOD CreateNewHeader(nsIMsgDBHdr **_retval) override { return _to CreateNewHeader(_retval); } \
  NS_IMETHOD CommitHeader(nsIMsgDBHdr *hdr) override { return _to CommitHeader(hdr); } \
  NS_IMETHOD UpdateSyncState(const nsACString& syncStateToken) override { return _to UpdateSyncState(syncStateToken); } \
  NS_IMETHOD OnError(IEwsClient::Error err, const nsACString& desc) override { return _to OnError(err, desc); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_IEWSMESSAGECALLBACKS(_to) \
  NS_IMETHOD CreateNewHeader(nsIMsgDBHdr **_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateNewHeader(_retval); } \
  NS_IMETHOD CommitHeader(nsIMsgDBHdr *hdr) override { return !_to ? NS_ERROR_NULL_POINTER : _to->CommitHeader(hdr); } \
  NS_IMETHOD UpdateSyncState(const nsACString& syncStateToken) override { return !_to ? NS_ERROR_NULL_POINTER : _to->UpdateSyncState(syncStateToken); } \
  NS_IMETHOD OnError(IEwsClient::Error err, const nsACString& desc) override { return !_to ? NS_ERROR_NULL_POINTER : _to->OnError(err, desc); } 


#endif /* __gen_IEwsClient_h__ */
