#ifndef DOM_BINDINGNAMES_H_
#define DOM_BINDINGNAMES_H_

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioData = 335,
  AudioDecoder = 345,
  AudioDestinationNode = 358,
  AudioEncoder = 379,
  AudioListener = 392,
  AudioNode = 406,
  AudioParam = 416,
  AudioParamMap = 427,
  AudioProcessingEvent = 441,
  AudioScheduledSourceNode = 462,
  AudioTrack = 487,
  AudioTrackList = 498,
  AudioWorklet = 513,
  AudioWorkletGlobalScope = 526,
  AudioWorkletNode = 550,
  AudioWorkletProcessor = 567,
  AuthenticatorAssertionResponse = 589,
  AuthenticatorAttestationResponse = 620,
  AuthenticatorResponse = 653,
  BarProp = 675,
  BaseAudioContext = 683,
  BatteryManager = 700,
  BeforeUnloadEvent = 715,
  BiquadFilterNode = 733,
  Blob = 750,
  BlobEvent = 755,
  BroadcastChannel = 765,
  BrowsingContext = 782,
  BrowsingContextGroup = 798,
  ByteLengthQueuingStrategy = 819,
  CDATASection = 845,
  CSS = 858,
  CSS2Properties = 862,
  CSSAnimation = 877,
  CSSConditionRule = 890,
  CSSContainerRule = 907,
  CSSCounterStyleRule = 924,
  CSSCustomPropertyRegisteredEvent = 944,
  CSSFontFaceRule = 977,
  CSSFontFeatureValuesRule = 993,
  CSSFontPaletteValuesRule = 1018,
  CSSGroupingRule = 1043,
  CSSImportRule = 1059,
  CSSKeyframeRule = 1073,
  CSSKeyframesRule = 1089,
  CSSLayerBlockRule = 1106,
  CSSLayerStatementRule = 1124,
  CSSMarginRule = 1146,
  CSSMediaRule = 1160,
  CSSMozDocumentRule = 1173,
  CSSNamespaceRule = 1192,
  CSSPageRule = 1209,
  CSSPropertyRule = 1221,
  CSSPseudoElement = 1237,
  CSSRule = 1254,
  CSSRuleList = 1262,
  CSSScopeRule = 1274,
  CSSStartingStyleRule = 1287,
  CSSStyleDeclaration = 1308,
  CSSStyleRule = 1328,
  CSSStyleSheet = 1341,
  CSSSupportsRule = 1355,
  CSSTransition = 1371,
  Cache = 1385,
  CacheStorage = 1391,
  CallbackDebuggerNotification = 1404,
  CanonicalBrowsingContext = 1433,
  CanvasCaptureMediaStream = 1458,
  CanvasGradient = 1483,
  CanvasPattern = 1498,
  CanvasRenderingContext2D = 1512,
  CaretPosition = 1537,
  CaretStateChangedEvent = 1551,
  ChannelMergerNode = 1574,
  ChannelSplitterNode = 1592,
  ChannelWrapper = 1612,
  CharacterData = 1627,
  CheckerboardReportService = 1641,
  ChildProcessMessageManager = 1667,
  ChildSHistory = 1694,
  ChromeMessageBroadcaster = 1708,
  ChromeMessageSender = 1733,
  ChromeNodeList = 1753,
  ChromeUtils = 1768,
  ChromeWorker = 1780,
  Client = 1793,
  Clients = 1800,
  Clipboard = 1808,
  ClipboardEvent = 1818,
  ClipboardItem = 1833,
  ClonedErrorHolder = 1847,
  CloseEvent = 1865,
  CommandEvent = 1876,
  Comment = 1889,
  CompositionEvent = 1897,
  CompressionStream = 1914,
  ConsoleInstance = 1932,
  ConstantSourceNode = 1948,
  ContentFrameMessageManager = 1967,
  ContentProcessMessageManager = 1994,
  ContentVisibilityAutoStateChangeEvent = 2023,
  ConvolverNode = 2061,
  CountQueuingStrategy = 2075,
  CreateOfferRequest = 2096,
  Credential = 2115,
  CredentialsContainer = 2126,
  Crypto = 2147,
  CryptoKey = 2154,
  CustomElementRegistry = 2164,
  CustomEvent = 2186,
  CustomStateSet = 2198,
  DOMException = 2213,
  DOMImplementation = 2226,
  DOMLocalization = 2244,
  DOMMatrix = 2260,
  DOMMatrixReadOnly = 2270,
  DOMParser = 2288,
  DOMPoint = 2298,
  DOMPointReadOnly = 2307,
  DOMQuad = 2324,
  DOMRect = 2332,
  DOMRectList = 2340,
  DOMRectReadOnly = 2352,
  DOMStringList = 2368,
  DOMStringMap = 2382,
  DOMTokenList = 2395,
  DataTransfer = 2408,
  DataTransferItem = 2421,
  DataTransferItemList = 2438,
  DebuggerNotification = 2459,
  DebuggerNotificationObserver = 2480,
  DecompressionStream = 2509,
  DedicatedWorkerGlobalScope = 2529,
  DelayNode = 2556,
  DeprecationReportBody = 2566,
  DeviceAcceleration = 2588,
  DeviceLightEvent = 2607,
  DeviceMotionEvent = 2624,
  DeviceOrientationEvent = 2642,
  DeviceRotationRate = 2665,
  Directory = 2684,
  Document = 2694,
  DocumentFragment = 2703,
  DocumentL10n = 2720,
  DocumentTimeline = 2733,
  DocumentType = 2750,
  DominatorTree = 2763,
  DragEvent = 2777,
  DynamicsCompressorNode = 2787,
  EXT_blend_minmax = 2810,
  EXT_color_buffer_float = 2827,
  EXT_color_buffer_half_float = 2850,
  EXT_disjoint_timer_query = 2878,
  EXT_float_blend = 2903,
  EXT_frag_depth = 2919,
  EXT_sRGB = 2934,
  EXT_shader_texture_lod = 2943,
  EXT_texture_compression_bptc = 2966,
  EXT_texture_compression_rgtc = 2995,
  EXT_texture_filter_anisotropic = 3024,
  EXT_texture_norm16 = 3055,
  Element = 3074,
  ElementInternals = 3082,
  EncodedAudioChunk = 3099,
  EncodedVideoChunk = 3117,
  ErrorEvent = 3135,
  Event = 3146,
  EventCallbackDebuggerNotification = 3152,
  EventCounts = 3186,
  EventSource = 3198,
  EventTarget = 3210,
  Exception = 3222,
  ExtendableEvent = 3232,
  ExtendableMessageEvent = 3248,
  ExtensionAlarms = 3271,
  ExtensionBrowser = 3287,
  ExtensionBrowserSettings = 3304,
  ExtensionBrowserSettingsColorManagement = 3329,
  ExtensionDns = 3369,
  ExtensionEventManager = 3382,
  ExtensionMockAPI = 3404,
  ExtensionPort = 3421,
  ExtensionProxy = 3435,
  ExtensionRuntime = 3450,
  ExtensionScripting = 3467,
  ExtensionSetting = 3486,
  ExtensionTest = 3503,
  External = 3517,
  FeaturePolicy = 3526,
  FeaturePolicyViolationReportBody = 3540,
  FetchEvent = 3573,
  FetchObserver = 3584,
  File = 3598,
  FileList = 3603,
  FileReader = 3612,
  FileReaderSync = 3623,
  FileSystem = 3638,
  FileSystemDirectoryEntry = 3649,
  FileSystemDirectoryHandle = 3674,
  FileSystemDirectoryHandle_AsyncIterator = 3700,
  FileSystemDirectoryIterator = 3740,
  FileSystemDirectoryReader = 3768,
  FileSystemEntry = 3794,
  FileSystemFileEntry = 3810,
  FileSystemFileHandle = 3830,
  FileSystemHandle = 3851,
  FileSystemSyncAccessHandle = 3868,
  FileSystemWritableFileStream = 3895,
  Flex = 3924,
  FlexItemValues = 3929,
  FlexLineValues = 3944,
  FluentBundle = 3959,
  FluentBundleAsyncIterator = 3972,
  FluentBundleIterator = 3998,
  FluentPattern = 4019,
  FluentResource = 4033,
  FocusEvent = 4048,
  FontFace = 4059,
  FontFaceSet = 4068,
  FontFaceSetIterator = 4080,
  FontFaceSetLoadEvent = 4100,
  FormData = 4121,
  FormData_Iterator = 4130,
  FormDataEvent = 4148,
  FragmentDirective = 4162,
  FrameCrashedEvent = 4180,
  FrameLoader = 4198,
  GPU = 4210,
  GPUAdapter = 4214,
  GPUAdapterInfo = 4225,
  GPUBindGroup = 4240,
  GPUBindGroupLayout = 4253,
  GPUBuffer = 4272,
  GPUBufferUsage = 4282,
  GPUCanvasContext = 4297,
  GPUColorWrite = 4314,
  GPUCommandBuffer = 4328,
  GPUCommandEncoder = 4345,
  GPUCompilationInfo = 4363,
  GPUCompilationMessage = 4382,
  GPUComputePassEncoder = 4404,
  GPUComputePipeline = 4426,
  GPUDevice = 4445,
  GPUDeviceLostInfo = 4455,
  GPUError = 4473,
  GPUInternalError = 4482,
  GPUMapMode = 4499,
  GPUOutOfMemoryError = 4510,
  GPUPipelineLayout = 4530,
  GPUQuerySet = 4548,
  GPUQueue = 4560,
  GPURenderBundle = 4569,
  GPURenderBundleEncoder = 4585,
  GPURenderPassEncoder = 4608,
  GPURenderPipeline = 4629,
  GPUSampler = 4647,
  GPUShaderModule = 4658,
  GPUShaderStage = 4674,
  GPUSupportedFeatures = 4689,
  GPUSupportedLimits = 4710,
  GPUTexture = 4729,
  GPUTextureUsage = 4740,
  GPUTextureView = 4756,
  GPUUncapturedErrorEvent = 4771,
  GPUValidationError = 4795,
  GainNode = 4814,
  Gamepad = 4823,
  GamepadAxisMoveEvent = 4831,
  GamepadButton = 4852,
  GamepadButtonEvent = 4866,
  GamepadEvent = 4885,
  GamepadHapticActuator = 4898,
  GamepadLightIndicator = 4920,
  GamepadPose = 4942,
  GamepadServiceTest = 4954,
  GamepadTouch = 4973,
  Geolocation = 4986,
  GeolocationCoordinates = 4998,
  GeolocationPosition = 5021,
  GeolocationPositionError = 5041,
  GetUserMediaRequest = 5066,
  GleanBoolean = 5086,
  GleanCategory = 5099,
  GleanCounter = 5113,
  GleanCustomDistribution = 5126,
  GleanDatetime = 5150,
  GleanDenominator = 5164,
  GleanEvent = 5181,
  GleanImpl = 5192,
  GleanLabeled = 5202,
  GleanMemoryDistribution = 5215,
  GleanMetric = 5239,
  GleanNumerator = 5251,
  GleanObject = 5266,
  GleanPingsImpl = 5278,
  GleanQuantity = 5293,
  GleanRate = 5307,
  GleanString = 5317,
  GleanStringList = 5329,
  GleanText = 5345,
  GleanTimespan = 5355,
  GleanTimingDistribution = 5369,
  GleanUrl = 5393,
  GleanUuid = 5402,
  Grid = 5412,
  GridArea = 5417,
  GridDimension = 5426,
  GridLine = 5440,
  GridLines = 5449,
  GridTrack = 5459,
  GridTracks = 5469,
  HTMLAllCollection = 5480,
  HTMLAnchorElement = 5498,
  HTMLAreaElement = 5516,
  HTMLAudioElement = 5532,
  HTMLBRElement = 5549,
  HTMLBaseElement = 5563,
  HTMLBodyElement = 5579,
  HTMLButtonElement = 5595,
  HTMLCanvasElement = 5613,
  HTMLCollection = 5631,
  HTMLDListElement = 5646,
  HTMLDataElement = 5663,
  HTMLDataListElement = 5679,
  HTMLDetailsElement = 5699,
  HTMLDialogElement = 5718,
  HTMLDirectoryElement = 5736,
  HTMLDivElement = 5757,
  HTMLDocument = 5772,
  HTMLElement = 5785,
  HTMLEmbedElement = 5797,
  HTMLFieldSetElement = 5814,
  HTMLFontElement = 5834,
  HTMLFormControlsCollection = 5850,
  HTMLFormElement = 5877,
  HTMLFrameElement = 5893,
  HTMLFrameSetElement = 5910,
  HTMLHRElement = 5930,
  HTMLHeadElement = 5944,
  HTMLHeadingElement = 5960,
  HTMLHtmlElement = 5979,
  HTMLIFrameElement = 5995,
  HTMLImageElement = 6013,
  HTMLInputElement = 6030,
  HTMLLIElement = 6047,
  HTMLLabelElement = 6061,
  HTMLLegendElement = 6078,
  HTMLLinkElement = 6096,
  HTMLMapElement = 6112,
  HTMLMarqueeElement = 6127,
  HTMLMediaElement = 6146,
  HTMLMenuElement = 6163,
  HTMLMetaElement = 6179,
  HTMLMeterElement = 6195,
  HTMLModElement = 6212,
  HTMLOListElement = 6227,
  HTMLObjectElement = 6244,
  HTMLOptGroupElement = 6262,
  HTMLOptionElement = 6282,
  HTMLOptionsCollection = 6300,
  HTMLOutputElement = 6322,
  HTMLParagraphElement = 6340,
  HTMLParamElement = 6361,
  HTMLPictureElement = 6378,
  HTMLPreElement = 6397,
  HTMLProgressElement = 6412,
  HTMLQuoteElement = 6432,
  HTMLScriptElement = 6449,
  HTMLSelectElement = 6467,
  HTMLSlotElement = 6485,
  HTMLSourceElement = 6501,
  HTMLSpanElement = 6519,
  HTMLStyleElement = 6535,
  HTMLTableCaptionElement = 6552,
  HTMLTableCellElement = 6576,
  HTMLTableColElement = 6597,
  HTMLTableElement = 6617,
  HTMLTableRowElement = 6634,
  HTMLTableSectionElement = 6654,
  HTMLTemplateElement = 6678,
  HTMLTextAreaElement = 6698,
  HTMLTimeElement = 6718,
  HTMLTitleElement = 6734,
  HTMLTrackElement = 6751,
  HTMLUListElement = 6768,
  HTMLUnknownElement = 6785,
  HTMLVideoElement = 6804,
  HashChangeEvent = 6821,
  Headers = 6837,
  Headers_Iterator = 6845,
  HeapSnapshot = 6862,
  Highlight = 6875,
  HighlightRegistry = 6885,
  History = 6903,
  IDBCursor = 6911,
  IDBCursorWithValue = 6921,
  IDBDatabase = 6940,
  IDBFactory = 6952,
  IDBIndex = 6963,
  IDBKeyRange = 6972,
  IDBObjectStore = 6984,
  IDBOpenDBRequest = 6999,
  IDBRequest = 7016,
  IDBTransaction = 7027,
  IDBVersionChangeEvent = 7042,
  IIRFilterNode = 7064,
  IOUtils = 7078,
  IdentityCredential = 7086,
  IdleDeadline = 7105,
  Image = 7118,
  ImageBitmap = 7124,
  ImageBitmapRenderingContext = 7136,
  ImageCapture = 7164,
  ImageCaptureError = 7177,
  ImageCaptureErrorEvent = 7195,
  ImageData = 7218,
  ImageDocument = 7228,
  InputEvent = 7242,
  InspectorCSSParser = 7253,
  InspectorFontFace = 7272,
  InspectorUtils = 7290,
  InstallTriggerImpl = 7305,
  IntersectionObserver = 7324,
  IntersectionObserverEntry = 7345,
  IntlUtils = 7371,
  InvokeEvent = 7381,
  JSProcessActorChild = 7393,
  JSProcessActorParent = 7413,
  JSWindowActorChild = 7434,
  JSWindowActorParent = 7453,
  KeyEvent = 7473,
  KeyboardEvent = 7482,
  KeyframeEffect = 7496,
  L10nFileSource = 7511,
  L10nOverlays = 7526,
  L10nRegistry = 7539,
  LargestContentfulPaint = 7552,
  LegacyMozTCPSocket = 7575,
  Localization = 7594,
  Location = 7607,
  Lock = 7616,
  LockManager = 7621,
  MIDIAccess = 7633,
  MIDIConnectionEvent = 7644,
  MIDIInput = 7664,
  MIDIInputMap = 7674,
  MIDIMessageEvent = 7687,
  MIDIOutput = 7704,
  MIDIOutputMap = 7715,
  MIDIPort = 7729,
  MOZ_debug = 7738,
  MatchGlob = 7748,
  MatchPattern = 7758,
  MatchPatternSet = 7771,
  MathMLElement = 7787,
  MediaCapabilities = 7801,
  MediaCapabilitiesInfo = 7819,
  MediaControlService = 7841,
  MediaController = 7861,
  MediaDeviceInfo = 7877,
  MediaDevices = 7893,
  MediaElementAudioSourceNode = 7906,
  MediaEncryptedEvent = 7934,
  MediaError = 7954,
  MediaKeyError = 7965,
  MediaKeyMessageEvent = 7979,
  MediaKeySession = 8000,
  MediaKeyStatusMap = 8016,
  MediaKeyStatusMap_Iterator = 8034,
  MediaKeySystemAccess = 8061,
  MediaKeys = 8082,
  MediaList = 8092,
  MediaMetadata = 8102,
  MediaQueryList = 8116,
  MediaQueryListEvent = 8131,
  MediaRecorder = 8151,
  MediaRecorderErrorEvent = 8165,
  MediaSession = 8189,
  MediaSource = 8202,
  MediaStream = 8214,
  MediaStreamAudioDestinationNode = 8226,
  MediaStreamAudioSourceNode = 8258,
  MediaStreamError = 8285,
  MediaStreamEvent = 8302,
  MediaStreamTrack = 8319,
  MediaStreamTrackAudioSourceNode = 8336,
  MediaStreamTrackEvent = 8368,
  MerchantValidationEvent = 8390,
  MessageBroadcaster = 8414,
  MessageChannel = 8433,
  MessageEvent = 8448,
  MessageListenerManager = 8461,
  MessagePort = 8484,
  MessageSender = 8496,
  MimeType = 8510,
  MimeTypeArray = 8519,
  MouseEvent = 8533,
  MouseScrollEvent = 8544,
  MozCanvasPrintState = 8561,
  MozDocumentMatcher = 8581,
  MozDocumentObserver = 8600,
  MozQueryInterface = 8620,
  MozSharedMap = 8638,
  MozSharedMap_Iterator = 8651,
  MozSharedMapChangeEvent = 8673,
  MozStorageAsyncStatementParams = 8697,
  MozStorageStatementParams = 8728,
  MozStorageStatementRow = 8754,
  MozWritableSharedMap = 8777,
  MutationEvent = 8798,
  MutationObserver = 8812,
  MutationRecord = 8829,
  NamedNodeMap = 8844,
  NavigationPreloadManager = 8857,
  Navigator = 8882,
  NetworkInformation = 8892,
  Node = 8911,
  NodeFilter = 8916,
  NodeIterator = 8927,
  NodeList = 8940,
  Notification = 8949,
  NotificationEvent = 8962,
  NotifyPaintEvent = 8980,
  OES_draw_buffers_indexed = 8997,
  OES_element_index_uint = 9022,
  OES_fbo_render_mipmap = 9045,
  OES_standard_derivatives = 9067,
  OES_texture_float = 9092,
  OES_texture_float_linear = 9110,
  OES_texture_half_float = 9135,
  OES_texture_half_float_linear = 9158,
  OES_vertex_array_object = 9188,
  OVR_multiview2 = 9212,
  OfflineAudioCompletionEvent = 9227,
  OfflineAudioContext = 9255,
  OffscreenCanvas = 9275,
  OffscreenCanvasRenderingContext2D = 9291,
  OnlyForUseInConstructor = 9325,
  Option = 9349,
  OscillatorNode = 9356,
  PageTransitionEvent = 9371,
  PaintRequest = 9391,
  PaintRequestList = 9404,
  PaintWorkletGlobalScope = 9421,
  PannerNode = 9445,
  ParentProcessMessageManager = 9456,
  Path2D = 9484,
  PathUtils = 9491,
  PaymentAddress = 9501,
  PaymentMethodChangeEvent = 9516,
  PaymentRequest = 9541,
  PaymentRequestUpdateEvent = 9556,
  PaymentResponse = 9582,
  PeerConnectionImpl = 9598,
  PeerConnectionObserver = 9617,
  Performance = 9640,
  PerformanceEntry = 9652,
  PerformanceEntryEvent = 9669,
  PerformanceEventTiming = 9691,
  PerformanceMark = 9714,
  PerformanceMeasure = 9730,
  PerformanceNavigation = 9749,
  PerformanceNavigationTiming = 9771,
  PerformanceObserver = 9799,
  PerformanceObserverEntryList = 9819,
  PerformancePaintTiming = 9848,
  PerformanceResourceTiming = 9871,
  PerformanceServerTiming = 9897,
  PerformanceTiming = 9921,
  PeriodicWave = 9939,
  PermissionStatus = 9952,
  Permissions = 9969,
  PlacesBookmark = 9981,
  PlacesBookmarkAddition = 9996,
  PlacesBookmarkChanged = 10019,
  PlacesBookmarkGuid = 10041,
  PlacesBookmarkKeyword = 10060,
  PlacesBookmarkMoved = 10082,
  PlacesBookmarkRemoved = 10102,
  PlacesBookmarkTags = 10124,
  PlacesBookmarkTime = 10143,
  PlacesBookmarkTitle = 10162,
  PlacesBookmarkUrl = 10182,
  PlacesEvent = 10200,
  PlacesEventCounts = 10212,
  PlacesFavicon = 10230,
  PlacesHistoryCleared = 10244,
  PlacesObservers = 10265,
  PlacesPurgeCaches = 10281,
  PlacesRanking = 10299,
  PlacesVisit = 10313,
  PlacesVisitRemoved = 10325,
  PlacesVisitTitle = 10344,
  PlacesWeakCallbackWrapper = 10361,
  Plugin = 10387,
  PluginArray = 10394,
  PluginCrashedEvent = 10406,
  PointerEvent = 10425,
  PopStateEvent = 10438,
  PopupBlockedEvent = 10452,
  PopupPositionedEvent = 10470,
  PositionStateEvent = 10491,
  PrecompiledScript = 10510,
  PrivateAttribution = 10528,
  ProcessMessageManager = 10547,
  ProcessingInstruction = 10569,
  ProgressEvent = 10591,
  PromiseDebugging = 10605,
  PromiseNativeHandler = 10622,
  PromiseRejectionEvent = 10643,
  PublicKeyCredential = 10665,
  PushEvent = 10685,
  PushManager = 10695,
  PushManagerImpl = 10707,
  PushMessageData = 10723,
  PushSubscription = 10739,
  PushSubscriptionOptions = 10756,
  RTCCertificate = 10780,
  RTCDTMFSender = 10795,
  RTCDTMFToneChangeEvent = 10809,
  RTCDataChannel = 10832,
  RTCDataChannelEvent = 10847,
  RTCDtlsTransport = 10867,
  RTCEncodedAudioFrame = 10884,
  RTCEncodedVideoFrame = 10905,
  RTCIceCandidate = 10926,
  RTCIceTransport = 10942,
  RTCIdentityProviderRegistrar = 10958,
  RTCPeerConnection = 10987,
  RTCPeerConnectionIceEvent = 11005,
  RTCPeerConnectionStatic = 11031,
  RTCRtpReceiver = 11055,
  RTCRtpScriptTransform = 11070,
  RTCRtpScriptTransformer = 11092,
  RTCRtpSender = 11116,
  RTCRtpTransceiver = 11129,
  RTCSctpTransport = 11147,
  RTCSessionDescription = 11164,
  RTCStatsReport = 11186,
  RTCTrackEvent = 11201,
  RTCTransformEvent = 11215,
  RadioNodeList = 11233,
  Range = 11247,
  ReadableByteStreamController = 11253,
  ReadableStream = 11282,
  ReadableStream_AsyncIterator = 11297,
  ReadableStreamBYOBReader = 11326,
  ReadableStreamBYOBRequest = 11351,
  ReadableStreamDefaultController = 11377,
  ReadableStreamDefaultReader = 11409,
  Report = 11437,
  ReportBody = 11444,
  ReportingObserver = 11455,
  Request = 11473,
  ResizeObserver = 11481,
  ResizeObserverEntry = 11496,
  ResizeObserverSize = 11516,
  Response = 11535,
  SVGAElement = 11544,
  SVGAngle = 11556,
  SVGAnimateElement = 11565,
  SVGAnimateMotionElement = 11583,
  SVGAnimateTransformElement = 11607,
  SVGAnimatedAngle = 11634,
  SVGAnimatedBoolean = 11651,
  SVGAnimatedEnumeration = 11670,
  SVGAnimatedInteger = 11693,
  SVGAnimatedLength = 11712,
  SVGAnimatedLengthList = 11730,
  SVGAnimatedNumber = 11752,
  SVGAnimatedNumberList = 11770,
  SVGAnimatedPreserveAspectRatio = 11792,
  SVGAnimatedRect = 11823,
  SVGAnimatedString = 11839,
  SVGAnimatedTransformList = 11857,
  SVGAnimationElement = 11882,
  SVGCircleElement = 11902,
  SVGClipPathElement = 11919,
  SVGComponentTransferFunctionElement = 11938,
  SVGDefsElement = 11974,
  SVGDescElement = 11989,
  SVGElement = 12004,
  SVGEllipseElement = 12015,
  SVGFEBlendElement = 12033,
  SVGFEColorMatrixElement = 12051,
  SVGFEComponentTransferElement = 12075,
  SVGFECompositeElement = 12105,
  SVGFEConvolveMatrixElement = 12127,
  SVGFEDiffuseLightingElement = 12154,
  SVGFEDisplacementMapElement = 12182,
  SVGFEDistantLightElement = 12210,
  SVGFEDropShadowElement = 12235,
  SVGFEFloodElement = 12258,
  SVGFEFuncAElement = 12276,
  SVGFEFuncBElement = 12294,
  SVGFEFuncGElement = 12312,
  SVGFEFuncRElement = 12330,
  SVGFEGaussianBlurElement = 12348,
  SVGFEImageElement = 12373,
  SVGFEMergeElement = 12391,
  SVGFEMergeNodeElement = 12409,
  SVGFEMorphologyElement = 12431,
  SVGFEOffsetElement = 12454,
  SVGFEPointLightElement = 12473,
  SVGFESpecularLightingElement = 12496,
  SVGFESpotLightElement = 12525,
  SVGFETileElement = 12547,
  SVGFETurbulenceElement = 12564,
  SVGFilterElement = 12587,
  SVGForeignObjectElement = 12604,
  SVGGElement = 12628,
  SVGGeometryElement = 12640,
  SVGGradientElement = 12659,
  SVGGraphicsElement = 12678,
  SVGImageElement = 12697,
  SVGLength = 12713,
  SVGLengthList = 12723,
  SVGLineElement = 12737,
  SVGLinearGradientElement = 12752,
  SVGMPathElement = 12777,
  SVGMarkerElement = 12793,
  SVGMaskElement = 12810,
  SVGMatrix = 12825,
  SVGMetadataElement = 12835,
  SVGNumber = 12854,
  SVGNumberList = 12864,
  SVGPathElement = 12878,
  SVGPathSeg = 12893,
  SVGPathSegArcAbs = 12904,
  SVGPathSegArcRel = 12921,
  SVGPathSegClosePath = 12938,
  SVGPathSegCurvetoCubicAbs = 12958,
  SVGPathSegCurvetoCubicRel = 12984,
  SVGPathSegCurvetoCubicSmoothAbs = 13010,
  SVGPathSegCurvetoCubicSmoothRel = 13042,
  SVGPathSegCurvetoQuadraticAbs = 13074,
  SVGPathSegCurvetoQuadraticRel = 13104,
  SVGPathSegCurvetoQuadraticSmoothAbs = 13134,
  SVGPathSegCurvetoQuadraticSmoothRel = 13170,
  SVGPathSegLinetoAbs = 13206,
  SVGPathSegLinetoHorizontalAbs = 13226,
  SVGPathSegLinetoHorizontalRel = 13256,
  SVGPathSegLinetoRel = 13286,
  SVGPathSegLinetoVerticalAbs = 13306,
  SVGPathSegLinetoVerticalRel = 13334,
  SVGPathSegList = 13362,
  SVGPathSegMovetoAbs = 13377,
  SVGPathSegMovetoRel = 13397,
  SVGPatternElement = 13417,
  SVGPoint = 13435,
  SVGPointList = 13444,
  SVGPolygonElement = 13457,
  SVGPolylineElement = 13475,
  SVGPreserveAspectRatio = 13494,
  SVGRadialGradientElement = 13517,
  SVGRect = 13542,
  SVGRectElement = 13550,
  SVGSVGElement = 13565,
  SVGScriptElement = 13579,
  SVGSetElement = 13596,
  SVGStopElement = 13610,
  SVGStringList = 13625,
  SVGStyleElement = 13639,
  SVGSwitchElement = 13655,
  SVGSymbolElement = 13672,
  SVGTSpanElement = 13689,
  SVGTextContentElement = 13705,
  SVGTextElement = 13727,
  SVGTextPathElement = 13742,
  SVGTextPositioningElement = 13761,
  SVGTitleElement = 13787,
  SVGTransform = 13803,
  SVGTransformList = 13816,
  SVGUnitTypes = 13833,
  SVGUseElement = 13846,
  SVGViewElement = 13860,
  Sanitizer = 13875,
  Scheduler = 13885,
  Screen = 13895,
  ScreenLuminance = 13902,
  ScreenOrientation = 13918,
  ScriptProcessorNode = 13936,
  ScrollAreaEvent = 13956,
  ScrollViewChangeEvent = 13972,
  SecurityPolicyViolationEvent = 13994,
  Selection = 14023,
  ServiceWorker = 14033,
  ServiceWorkerContainer = 14047,
  ServiceWorkerGlobalScope = 14070,
  ServiceWorkerRegistration = 14095,
  SessionStoreFormData = 14121,
  SessionStoreScrollData = 14142,
  SessionStoreUtils = 14165,
  ShadowRealmGlobalScope = 14183,
  ShadowRoot = 14206,
  SharedWorker = 14217,
  SharedWorkerGlobalScope = 14230,
  SimpleGestureEvent = 14254,
  SourceBuffer = 14273,
  SourceBufferList = 14286,
  SpeechGrammar = 14303,
  SpeechGrammarList = 14317,
  SpeechRecognition = 14335,
  SpeechRecognitionAlternative = 14353,
  SpeechRecognitionError = 14382,
  SpeechRecognitionEvent = 14405,
  SpeechRecognitionResult = 14428,
  SpeechRecognitionResultList = 14452,
  SpeechSynthesis = 14480,
  SpeechSynthesisErrorEvent = 14496,
  SpeechSynthesisEvent = 14522,
  SpeechSynthesisUtterance = 14543,
  SpeechSynthesisVoice = 14568,
  StaticRange = 14589,
  StereoPannerNode = 14601,
  Storage = 14618,
  StorageEvent = 14626,
  StorageManager = 14639,
  StreamFilter = 14654,
  StreamFilterDataEvent = 14667,
  StructuredCloneHolder = 14689,
  StructuredCloneTester = 14711,
  StyleSheet = 14733,
  StyleSheetApplicableStateChangeEvent = 14744,
  StyleSheetList = 14781,
  StyleSheetRemovedEvent = 14796,
  SubmitEvent = 14819,
  SubtleCrypto = 14831,
  SyncMessageSender = 14844,
  SyncReadFile = 14862,
  TCPServerSocket = 14875,
  TCPServerSocketEvent = 14891,
  TCPSocket = 14912,
  TCPSocketErrorEvent = 14922,
  TCPSocketEvent = 14942,
  TaskController = 14957,
  TaskPriorityChangeEvent = 14972,
  TaskSignal = 14996,
  TelemetryStopwatch = 15007,
  TestAttributesOnTypes = 15026,
  TestCEReactionsInterface = 15048,
  TestCImplementedInterface = 15073,
  TestCImplementedInterface2 = 15099,
  TestCallbackDictUnionOverload = 15126,
  TestChildInterface = 15156,
  TestConstructorForFuncInterface = 15175,
  TestConstructorForPrefInterface = 15207,
  TestConstructorForSCInterface = 15239,
  TestCppKeywordNamedMethodsInterface = 15269,
  TestDeprecatedInterface = 15305,
  TestExampleInterface = 15329,
  TestExampleProxyInterface = 15350,
  TestExampleThrowingConstructorInterface = 15376,
  TestExampleWorkerInterface = 15416,
  TestFuncConstructorForDifferentFuncInterface = 15443,
  TestFuncConstructorForInterface = 15488,
  TestHTMLConstructorInterface = 15520,
  TestIndexedAndNamedGetterAndSetterInterface = 15549,
  TestIndexedAndNamedGetterInterface = 15593,
  TestIndexedAndNamedSetterInterface = 15628,
  TestIndexedGetterAndSetterAndNamedGetterInterface = 15663,
  TestIndexedGetterInterface = 15713,
  TestIndexedSetterInterface = 15740,
  TestInterface = 15767,
  TestInterfaceWithPromiseConstructorArg = 15781,
  TestJSImplInterface = 15820,
  TestJSImplInterface2 = 15840,
  TestJSImplInterface3 = 15861,
  TestJSImplInterface4 = 15882,
  TestJSImplInterface5 = 15903,
  TestJSImplInterface6 = 15924,
  TestJSImplNoInterfaceObject = 15945,
  TestLegacyFactoryFunctionInterface = 15973,
  TestLegacyFactoryFunctionInterface2 = 16008,
  TestNamedDeleterInterface = 16044,
  TestNamedDeleterWithRetvalInterface = 16070,
  TestNamedGetterInterface = 16106,
  TestNamedSetterInterface = 16131,
  TestNamespace = 16156,
  TestNonWrapperCacheInterface = 16170,
  TestParentInterface = 16199,
  TestPrefChromeOnlySCFuncConstructorForInterface = 16219,
  TestPrefConstructorForDifferentPrefInterface = 16267,
  TestPrefConstructorForInterface = 16312,
  TestProtoObjectHackedNamespace = 16344,
  TestRenamedInterface = 16375,
  TestRenamedNamespace = 16396,
  TestSCConstructorForInterface = 16417,
  TestSecureContextInterface = 16447,
  TestThrowingConstructorInterface = 16474,
  TestUtils = 16507,
  TestWorkerExposedInterface = 16517,
  TestingDeprecatedInterface = 16544,
  Text = 16571,
  TextClause = 16576,
  TextDecoder = 16587,
  TextDecoderStream = 16599,
  TextEncoder = 16617,
  TextEncoderStream = 16629,
  TextEvent = 16647,
  TextMetrics = 16657,
  TextTrack = 16669,
  TextTrackCue = 16679,
  TextTrackCueList = 16692,
  TextTrackList = 16709,
  TimeEvent = 16723,
  TimeRanges = 16733,
  ToggleEvent = 16744,
  Touch = 16756,
  TouchEvent = 16762,
  TouchList = 16773,
  TrackEvent = 16783,
  TransformStream = 16794,
  TransformStreamDefaultController = 16810,
  TransitionEvent = 16843,
  TreeColumn = 16859,
  TreeColumns = 16870,
  TreeContentView = 16882,
  TreeWalker = 16898,
  TrustedHTML = 16909,
  TrustedScript = 16921,
  TrustedScriptURL = 16935,
  TrustedTypePolicy = 16952,
  TrustedTypePolicyFactory = 16970,
  UDPMessageEvent = 16995,
  UDPSocket = 17011,
  UIEvent = 17021,
  URL = 17029,
  URLSearchParams = 17033,
  URLSearchParams_Iterator = 17049,
  UniFFIPointer = 17074,
  UniFFIScaffolding = 17088,
  UserActivation = 17106,
  UserInteraction = 17121,
  UserProximityEvent = 17137,
  VRDisplay = 17156,
  VRDisplayCapabilities = 17166,
  VRDisplayEvent = 17188,
  VREyeParameters = 17203,
  VRFieldOfView = 17219,
  VRFrameData = 17233,
  VRMockController = 17245,
  VRMockDisplay = 17262,
  VRPose = 17276,
  VRServiceTest = 17283,
  VRStageParameters = 17297,
  VTTCue = 17315,
  VTTRegion = 17322,
  ValidityState = 17332,
  VideoColorSpace = 17346,
  VideoDecoder = 17362,
  VideoEncoder = 17375,
  VideoFrame = 17388,
  VideoPlaybackQuality = 17399,
  VideoTrack = 17420,
  VideoTrackList = 17431,
  VisualViewport = 17446,
  WEBGL_color_buffer_float = 17461,
  WEBGL_compressed_texture_astc = 17486,
  WEBGL_compressed_texture_etc = 17516,
  WEBGL_compressed_texture_etc1 = 17545,
  WEBGL_compressed_texture_pvrtc = 17575,
  WEBGL_compressed_texture_s3tc = 17606,
  WEBGL_compressed_texture_s3tc_srgb = 17636,
  WEBGL_debug_renderer_info = 17671,
  WEBGL_debug_shaders = 17697,
  WEBGL_depth_texture = 17717,
  WEBGL_draw_buffers = 17737,
  WEBGL_explicit_present = 17756,
  WEBGL_lose_context = 17779,
  WEBGL_provoking_vertex = 17798,
  WakeLock = 17821,
  WakeLockSentinel = 17830,
  WaveShaperNode = 17847,
  WebExtensionContentScript = 17862,
  WebExtensionPolicy = 17888,
  WebGL2RenderingContext = 17907,
  WebGLActiveInfo = 17930,
  WebGLBuffer = 17946,
  WebGLContextEvent = 17958,
  WebGLFramebuffer = 17976,
  WebGLProgram = 17993,
  WebGLQuery = 18006,
  WebGLRenderbuffer = 18017,
  WebGLRenderingContext = 18035,
  WebGLSampler = 18057,
  WebGLShader = 18070,
  WebGLShaderPrecisionFormat = 18082,
  WebGLSync = 18109,
  WebGLTexture = 18119,
  WebGLTransformFeedback = 18132,
  WebGLUniformLocation = 18155,
  WebGLVertexArrayObject = 18176,
  WebKitCSSMatrix = 18199,
  WebSocket = 18215,
  WebTransport = 18225,
  WebTransportBidirectionalStream = 18238,
  WebTransportDatagramDuplexStream = 18270,
  WebTransportError = 18303,
  WebTransportReceiveStream = 18321,
  WebTransportSendStream = 18347,
  WebrtcGlobalInformation = 18370,
  WheelEvent = 18394,
  Window = 18405,
  WindowClient = 18412,
  WindowContext = 18425,
  WindowGlobalChild = 18439,
  WindowGlobalParent = 18457,
  WindowRoot = 18476,
  Worker = 18487,
  WorkerDebuggerGlobalScope = 18494,
  WorkerGlobalScope = 18520,
  WorkerLocation = 18538,
  WorkerNavigator = 18553,
  WorkerTestUtils = 18569,
  Worklet = 18585,
  WorkletGlobalScope = 18593,
  WritableStream = 18612,
  WritableStreamDefaultController = 18627,
  WritableStreamDefaultWriter = 18659,
  XMLDocument = 18687,
  XMLHttpRequest = 18699,
  XMLHttpRequestEventTarget = 18714,
  XMLHttpRequestUpload = 18740,
  XMLSerializer = 18761,
  XPathEvaluator = 18775,
  XPathExpression = 18790,
  XPathResult = 18806,
  XRBoundedReferenceSpace = 18818,
  XRFrame = 18842,
  XRInputSource = 18850,
  XRInputSourceArray = 18864,
  XRInputSourceEvent = 18883,
  XRInputSourcesChangeEvent = 18902,
  XRPose = 18928,
  XRReferenceSpace = 18935,
  XRReferenceSpaceEvent = 18952,
  XRRenderState = 18974,
  XRRigidTransform = 18988,
  XRSession = 19005,
  XRSessionEvent = 19015,
  XRSpace = 19030,
  XRSystem = 19038,
  XRView = 19047,
  XRViewerPose = 19054,
  XRViewport = 19067,
  XRWebGLLayer = 19078,
  XSLTProcessor = 19091,
  XULCommandEvent = 19105,
  XULElement = 19121,
  XULFrameElement = 19132,
  XULMenuElement = 19148,
  XULPopupElement = 19163,
  XULResizerElement = 19179,
  XULTextElement = 19197,
  XULTreeElement = 19212,
  console = 19227,
  webkitSpeechGrammar = 19235,
  webkitSpeechGrammarList = 19255,
  webkitSpeechRecognition = 19279,
  webkitURL = 19303,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // DOM_BINDINGNAMES_H_
