/* THIS FILE IS AUTOGENERATED FROM CaretStateChangedEvent.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_CARETSTATECHANGEDEVENTBINDING_H_
#define DOM_CARETSTATECHANGEDEVENTBINDING_H_

#include "EventBinding.h"
#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/EnumTypeTraits.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/DOMRect.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

class CaretStateChangedEvent;
struct CaretStateChangedEventInitAtoms;
class DOMRectReadOnly;
struct NativePropertyHooks;
class ProtoAndIfaceCache;

} // namespace dom
} // namespace mozilla

namespace mozilla {

namespace dom {

enum class CaretChangedReason : uint8_t {
  Visibilitychange,
  Updateposition,
  Longpressonemptycontent,
  Taponcaret,
  Presscaret,
  Releasecaret,
  Scroll,
  Dragcaret,
};

namespace binding_detail {
template <> struct EnumStrings<CaretChangedReason> {
  static const nsLiteralCString Values[8];
};
} // namespace binding_detail

bool
ToJSValue(JSContext* aCx, CaretChangedReason aArgument, JS::MutableHandle<JS::Value> aValue);


struct CaretStateChangedEventInit : public EventInit
{
  MOZ_INIT_OUTSIDE_CTOR RefPtr<mozilla::dom::DOMRectReadOnly> mBoundingClientRect;
  MOZ_INIT_OUTSIDE_CTOR bool mCaretVisible;
  MOZ_INIT_OUTSIDE_CTOR bool mCaretVisuallyVisible;
  MOZ_INIT_OUTSIDE_CTOR int32_t mClientX;
  MOZ_INIT_OUTSIDE_CTOR int32_t mClientY;
  MOZ_INIT_OUTSIDE_CTOR bool mCollapsed;
  MOZ_INIT_OUTSIDE_CTOR CaretChangedReason mReason;
  MOZ_INIT_OUTSIDE_CTOR nsString mSelectedTextContent;
  MOZ_INIT_OUTSIDE_CTOR bool mSelectionEditable;
  MOZ_INIT_OUTSIDE_CTOR bool mSelectionVisible;

  CaretStateChangedEventInit();

  explicit inline CaretStateChangedEventInit(const FastDictionaryInitializer& )
    : EventInit(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  CaretStateChangedEventInit(CaretStateChangedEventInit&& aOther) = default;

  explicit inline CaretStateChangedEventInit(const CaretStateChangedEventInit& aOther)
    : EventInit(FastDictionaryInitializer())
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  inline void
  TraverseForCC(nsCycleCollectionTraversalCallback& aCallback, uint32_t aFlags)
  {
    ImplCycleCollectionTraverse(aCallback, mBoundingClientRect, "mBoundingClientRect", aFlags);
  }

  inline void
  UnlinkForCC()
  {
    ImplCycleCollectionUnlink(mBoundingClientRect);
  }

  CaretStateChangedEventInit&
  operator=(const CaretStateChangedEventInit& aOther);

private:
  static bool
  InitIds(JSContext* cx, CaretStateChangedEventInitAtoms* atomsCache);
};

namespace binding_detail {
struct FastCaretStateChangedEventInit : public CaretStateChangedEventInit
{
  inline FastCaretStateChangedEventInit()
    : CaretStateChangedEventInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace CaretStateChangedEvent_Binding {

  typedef mozilla::dom::CaretStateChangedEvent NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::CaretStateChangedEvent* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::CaretStateChangedEvent,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::CheckExposure);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::CaretStateChangedEvent,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::CheckExposure);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

  inline bool CreateAndDefineOnGlobal(JSContext* aCx)
  {
    // Get the interface or namespace object for this class. This will
    // create the object as needed and always define the properties for
    // it on the global. The caller should make sure the interface or
    // namespace is exposed on the global before calling this.
    return GetPerInterfaceObjectHandle(aCx, constructors::id::CaretStateChangedEvent,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::Always);

  }

} // namespace CaretStateChangedEvent_Binding



} // namespace dom


template <>
struct MaxContiguousEnumValue<dom::CaretChangedReason>
{
  static constexpr dom::CaretChangedReason value = dom::CaretChangedReason::Dragcaret;

  static_assert(static_cast<uint8_t>(dom::CaretChangedReason::Visibilitychange) == 0,
                "We rely on this in ContiguousEnumValues");
  static_assert(mozilla::ArrayLength(dom::binding_detail::EnumStrings<dom::CaretChangedReason>::Values) - 1 == UnderlyingValue(value),
                "Mismatch between enum strings and enum count");
};


} // namespace mozilla

#endif // DOM_CARETSTATECHANGEDEVENTBINDING_H_
