/* THIS FILE IS AUTOGENERATED FROM ElementInternals.webidl BY Codegen.py - DO NOT EDIT */

#ifndef DOM_ELEMENTINTERNALSBINDING_H_
#define DOM_ELEMENTINTERNALSBINDING_H_

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

class CustomStateSet;
class ElementInternals;
struct NativePropertyHooks;
class ProtoAndIfaceCache;
struct ValidityStateFlagsAtoms;

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

struct ValidityStateFlags : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR bool mBadInput;
  MOZ_INIT_OUTSIDE_CTOR bool mCustomError;
  MOZ_INIT_OUTSIDE_CTOR bool mPatternMismatch;
  MOZ_INIT_OUTSIDE_CTOR bool mRangeOverflow;
  MOZ_INIT_OUTSIDE_CTOR bool mRangeUnderflow;
  MOZ_INIT_OUTSIDE_CTOR bool mStepMismatch;
  MOZ_INIT_OUTSIDE_CTOR bool mTooLong;
  MOZ_INIT_OUTSIDE_CTOR bool mTooShort;
  MOZ_INIT_OUTSIDE_CTOR bool mTypeMismatch;
  MOZ_INIT_OUTSIDE_CTOR bool mValueMissing;

  ValidityStateFlags();

  explicit inline ValidityStateFlags(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  ValidityStateFlags(ValidityStateFlags&& aOther) = default;

  explicit inline ValidityStateFlags(const ValidityStateFlags& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  ValidityStateFlags&
  operator=(const ValidityStateFlags& aOther);

private:
  static bool
  InitIds(JSContext* cx, ValidityStateFlagsAtoms* atomsCache);
};

namespace binding_detail {
struct FastValidityStateFlags : public ValidityStateFlags
{
  inline FastValidityStateFlags()
    : ValidityStateFlags(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace CustomStateSet_Binding {

  typedef mozilla::dom::CustomStateSet NativeType;

  namespace SetlikeHelpers {
  void
  Clear(mozilla::dom::CustomStateSet* self, ErrorResult& aRv);
  bool
  Delete(mozilla::dom::CustomStateSet* self, const nsAString& aKey, ErrorResult& aRv);
  bool
  Has(mozilla::dom::CustomStateSet* self, const nsAString& aKey, ErrorResult& aRv);
  void
  Add(mozilla::dom::CustomStateSet* self, const nsAString& aKey, ErrorResult& aRv);
  } // namespace SetlikeHelpers

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  bool
  Wrap(JSContext* aCx, mozilla::dom::CustomStateSet* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::CustomStateSet,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::CheckExposure);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::CustomStateSet,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::CheckExposure);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

  inline bool CreateAndDefineOnGlobal(JSContext* aCx)
  {
    // Get the interface or namespace object for this class. This will
    // create the object as needed and always define the properties for
    // it on the global. The caller should make sure the interface or
    // namespace is exposed on the global before calling this.
    return GetPerInterfaceObjectHandle(aCx, constructors::id::CustomStateSet,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::Always);

  }

} // namespace CustomStateSet_Binding



namespace ElementInternals_Binding {

  typedef mozilla::dom::ElementInternals NativeType;

  bool
  Wrap(JSContext* aCx, mozilla::dom::ElementInternals* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, DefineInterfaceProperty aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::ElementInternals,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::CheckExposure);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::ElementInternals,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::CheckExposure);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

  inline bool CreateAndDefineOnGlobal(JSContext* aCx)
  {
    // Get the interface or namespace object for this class. This will
    // create the object as needed and always define the properties for
    // it on the global. The caller should make sure the interface or
    // namespace is exposed on the global before calling this.
    return GetPerInterfaceObjectHandle(aCx, constructors::id::ElementInternals,
                                       &CreateInterfaceObjects,
                                       DefineInterfaceProperty::Always);

  }

} // namespace ElementInternals_Binding



} // namespace mozilla::dom

#endif // DOM_ELEMENTINTERNALSBINDING_H_
