//
// DO NOT EDIT.  THIS FILE IS GENERATED FROM $SRCDIR/comm/mailnews/protocols/ews/src/IEwsClient.idl
//


/// `interface IEwsClient : nsISupports`
///


// The actual type definition for the interface. This struct has methods
// declared on it which will call through its vtable. You never want to pass
// this type around by value, always pass it behind a reference.

#[repr(C)]
pub struct IEwsClient {
    vtable: &'static IEwsClientVTable,

    /// This field is a phantomdata to ensure that the VTable type and any
    /// struct containing it is not safe to send across threads by default, as
    /// XPCOM is generally not threadsafe.
    ///
    /// If this type is marked as [rust_sync], there will be explicit `Send` and
    /// `Sync` implementations on this type, which will override the inherited
    /// negative impls from `Rc`.
    __nosync: ::std::marker::PhantomData<::std::rc::Rc<u8>>,

    // Make the rust compiler aware that there might be interior mutability
    // in what actually implements the interface. This works around UB
    // introduced by https://github.com/llvm/llvm-project/commit/01859da84bad95fd51d6a03b08b60c660e642a4f
    // that a rust lint would make blatantly obvious, but doesn't exist.
    // (See https://github.com/rust-lang/rust/issues/111229).
    // This prevents optimizations, but those optimizations weren't available
    // before rustc switched to LLVM 16, and they now cause problems because
    // of the UB.
    // Until there's a lint available to find all our UB, it's simpler to
    // avoid the UB in the first place, at the cost of preventing optimizations
    // in places that don't cause UB. But again, those optimizations weren't
    // available before.
    __maybe_interior_mutability: ::std::cell::UnsafeCell<[u8; 0]>,
}

// Implementing XpCom for an interface exposes its IID, which allows for easy
// use of the `.query_interface<T>` helper method. This also defines that
// method for IEwsClient.
unsafe impl XpCom for IEwsClient {
    const IID: nsIID = nsID(0x4a117361, 0x653b, 0x48a5,
        [0x9d, 0xdb, 0x58, 0x84, 0x82, 0xef, 0x9d, 0xbb]);
}

// We need to implement the RefCounted trait so we can be used with `RefPtr`.
// This trait teaches `RefPtr` how to manage our memory.
unsafe impl RefCounted for IEwsClient {
    #[inline]
    unsafe fn addref(&self) {
        self.AddRef();
    }
    #[inline]
    unsafe fn release(&self) {
        self.Release();
    }
}

// This trait is implemented on all types which can be coerced to from IEwsClient.
// It is used in the implementation of `fn coerce<T>`. We hide it from the
// documentation, because it clutters it up a lot.
#[doc(hidden)]
pub trait IEwsClientCoerce {
    /// Cheaply cast a value of this type from a `IEwsClient`.
    fn coerce_from(v: &IEwsClient) -> &Self;
}

// The trivial implementation: We can obviously coerce ourselves to ourselves.
impl IEwsClientCoerce for IEwsClient {
    #[inline]
    fn coerce_from(v: &IEwsClient) -> &Self {
        v
    }
}

impl IEwsClient {
    /// Cast this `IEwsClient` to one of its base interfaces.
    #[inline]
    pub fn coerce<T: IEwsClientCoerce>(&self) -> &T {
        T::coerce_from(self)
    }
}

// Every interface struct type implements `Deref` to its base interface. This
// causes methods on the base interfaces to be directly avaliable on the
// object. For example, you can call `.AddRef` or `.QueryInterface` directly
// on any interface which inherits from `nsISupports`.
impl ::std::ops::Deref for IEwsClient {
    type Target = nsISupports;
    #[inline]
    fn deref(&self) -> &nsISupports {
        unsafe {
            ::std::mem::transmute(self)
        }
    }
}

// Ensure we can use .coerce() to cast to our base types as well. Any type which
// our base interface can coerce from should be coercable from us as well.
impl<T: nsISupportsCoerce> IEwsClientCoerce for T {
    #[inline]
    fn coerce_from(v: &IEwsClient) -> &Self {
        T::coerce_from(v)
    }
}

// This struct represents the interface's VTable. A pointer to a statically
// allocated version of this struct is at the beginning of every IEwsClient
// object. It contains one pointer field for each method in the interface. In
// the case where we can't generate a binding for a method, we include a void
// pointer.
#[doc(hidden)]
#[repr(C)]
pub struct IEwsClientVTable {
    /// We need to include the members from the base interface's vtable at the start
    /// of the VTable definition.
    pub __base: nsISupportsVTable,

    /* void initialize (in AUTF8String endpoint, in IEwsIncomingServer server); */
    pub Initialize: unsafe extern "system" fn (this: *const IEwsClient, endpoint: *const ::nsstring::nsACString, server: *const IEwsIncomingServer) -> ::nserror::nsresult,

    /* void syncFolderHierarchy (in IEwsFolderCallbacks callbacks, in AUTF8String syncStateToken); */
    pub SyncFolderHierarchy: unsafe extern "system" fn (this: *const IEwsClient, callbacks: *const IEwsFolderCallbacks, syncStateToken: *const ::nsstring::nsACString) -> ::nserror::nsresult,

    /* void syncMessagesForFolder (in IEwsMessageCallbacks callbacks, in AUTF8String folderId, in AUTF8String syncStateToken); */
    pub SyncMessagesForFolder: unsafe extern "system" fn (this: *const IEwsClient, callbacks: *const IEwsMessageCallbacks, folderId: *const ::nsstring::nsACString, syncStateToken: *const ::nsstring::nsACString) -> ::nserror::nsresult,
}


// The implementations of the function wrappers which are exposed to rust code.
// Call these methods rather than manually calling through the VTable struct.
impl IEwsClient {

    pub const EWS_ERR_AUTHENTICATION_FAILED:  u8 = 0;


    pub const EWS_ERR_UNEXPECTED:  u8 = 1;


    /// `void initialize (in AUTF8String endpoint, in IEwsIncomingServer server);`
    #[inline]
    pub unsafe fn Initialize(&self, endpoint: *const ::nsstring::nsACString, server: *const IEwsIncomingServer) -> ::nserror::nsresult {
        ((*self.vtable).Initialize)(self, endpoint, server)
    }



    /// `void syncFolderHierarchy (in IEwsFolderCallbacks callbacks, in AUTF8String syncStateToken);`
    #[inline]
    pub unsafe fn SyncFolderHierarchy(&self, callbacks: *const IEwsFolderCallbacks, syncStateToken: *const ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).SyncFolderHierarchy)(self, callbacks, syncStateToken)
    }



    /// `void syncMessagesForFolder (in IEwsMessageCallbacks callbacks, in AUTF8String folderId, in AUTF8String syncStateToken);`
    #[inline]
    pub unsafe fn SyncMessagesForFolder(&self, callbacks: *const IEwsMessageCallbacks, folderId: *const ::nsstring::nsACString, syncStateToken: *const ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).SyncMessagesForFolder)(self, callbacks, folderId, syncStateToken)
    }


}


/// `interface IEwsFolderCallbacks : nsISupports`
///


// The actual type definition for the interface. This struct has methods
// declared on it which will call through its vtable. You never want to pass
// this type around by value, always pass it behind a reference.

#[repr(C)]
pub struct IEwsFolderCallbacks {
    vtable: &'static IEwsFolderCallbacksVTable,

    /// This field is a phantomdata to ensure that the VTable type and any
    /// struct containing it is not safe to send across threads by default, as
    /// XPCOM is generally not threadsafe.
    ///
    /// If this type is marked as [rust_sync], there will be explicit `Send` and
    /// `Sync` implementations on this type, which will override the inherited
    /// negative impls from `Rc`.
    __nosync: ::std::marker::PhantomData<::std::rc::Rc<u8>>,

    // Make the rust compiler aware that there might be interior mutability
    // in what actually implements the interface. This works around UB
    // introduced by https://github.com/llvm/llvm-project/commit/01859da84bad95fd51d6a03b08b60c660e642a4f
    // that a rust lint would make blatantly obvious, but doesn't exist.
    // (See https://github.com/rust-lang/rust/issues/111229).
    // This prevents optimizations, but those optimizations weren't available
    // before rustc switched to LLVM 16, and they now cause problems because
    // of the UB.
    // Until there's a lint available to find all our UB, it's simpler to
    // avoid the UB in the first place, at the cost of preventing optimizations
    // in places that don't cause UB. But again, those optimizations weren't
    // available before.
    __maybe_interior_mutability: ::std::cell::UnsafeCell<[u8; 0]>,
}

// Implementing XpCom for an interface exposes its IID, which allows for easy
// use of the `.query_interface<T>` helper method. This also defines that
// method for IEwsFolderCallbacks.
unsafe impl XpCom for IEwsFolderCallbacks {
    const IID: nsIID = nsID(0x5dacc994, 0x30e0, 0x42f7,
        [0x94, 0xc8, 0x52, 0x75, 0x66, 0x38, 0xad, 0xd5]);
}

// We need to implement the RefCounted trait so we can be used with `RefPtr`.
// This trait teaches `RefPtr` how to manage our memory.
unsafe impl RefCounted for IEwsFolderCallbacks {
    #[inline]
    unsafe fn addref(&self) {
        self.AddRef();
    }
    #[inline]
    unsafe fn release(&self) {
        self.Release();
    }
}

// This trait is implemented on all types which can be coerced to from IEwsFolderCallbacks.
// It is used in the implementation of `fn coerce<T>`. We hide it from the
// documentation, because it clutters it up a lot.
#[doc(hidden)]
pub trait IEwsFolderCallbacksCoerce {
    /// Cheaply cast a value of this type from a `IEwsFolderCallbacks`.
    fn coerce_from(v: &IEwsFolderCallbacks) -> &Self;
}

// The trivial implementation: We can obviously coerce ourselves to ourselves.
impl IEwsFolderCallbacksCoerce for IEwsFolderCallbacks {
    #[inline]
    fn coerce_from(v: &IEwsFolderCallbacks) -> &Self {
        v
    }
}

impl IEwsFolderCallbacks {
    /// Cast this `IEwsFolderCallbacks` to one of its base interfaces.
    #[inline]
    pub fn coerce<T: IEwsFolderCallbacksCoerce>(&self) -> &T {
        T::coerce_from(self)
    }
}

// Every interface struct type implements `Deref` to its base interface. This
// causes methods on the base interfaces to be directly avaliable on the
// object. For example, you can call `.AddRef` or `.QueryInterface` directly
// on any interface which inherits from `nsISupports`.
impl ::std::ops::Deref for IEwsFolderCallbacks {
    type Target = nsISupports;
    #[inline]
    fn deref(&self) -> &nsISupports {
        unsafe {
            ::std::mem::transmute(self)
        }
    }
}

// Ensure we can use .coerce() to cast to our base types as well. Any type which
// our base interface can coerce from should be coercable from us as well.
impl<T: nsISupportsCoerce> IEwsFolderCallbacksCoerce for T {
    #[inline]
    fn coerce_from(v: &IEwsFolderCallbacks) -> &Self {
        T::coerce_from(v)
    }
}

// This struct represents the interface's VTable. A pointer to a statically
// allocated version of this struct is at the beginning of every IEwsFolderCallbacks
// object. It contains one pointer field for each method in the interface. In
// the case where we can't generate a binding for a method, we include a void
// pointer.
#[doc(hidden)]
#[repr(C)]
pub struct IEwsFolderCallbacksVTable {
    /// We need to include the members from the base interface's vtable at the start
    /// of the VTable definition.
    pub __base: nsISupportsVTable,

    /* void recordRootFolder (in AUTF8String id); */
    pub RecordRootFolder: unsafe extern "system" fn (this: *const IEwsFolderCallbacks, id: *const ::nsstring::nsACString) -> ::nserror::nsresult,

    /* void create (in AUTF8String id, in AUTF8String parentId, in AString name, in unsigned long flags); */
    pub Create: unsafe extern "system" fn (this: *const IEwsFolderCallbacks, id: *const ::nsstring::nsACString, parentId: *const ::nsstring::nsACString, name: *const ::nsstring::nsAString, flags: u32) -> ::nserror::nsresult,

    /* void update (in AUTF8String id, in AUTF8String name); */
    pub Update: unsafe extern "system" fn (this: *const IEwsFolderCallbacks, id: *const ::nsstring::nsACString, name: *const ::nsstring::nsACString) -> ::nserror::nsresult,

    /* void delete (in AUTF8String id); */
    pub Delete: unsafe extern "system" fn (this: *const IEwsFolderCallbacks, id: *const ::nsstring::nsACString) -> ::nserror::nsresult,

    /* void updateSyncState (in AUTF8String syncStateToken); */
    pub UpdateSyncState: unsafe extern "system" fn (this: *const IEwsFolderCallbacks, syncStateToken: *const ::nsstring::nsACString) -> ::nserror::nsresult,

    /* void onError (in IEwsClient_Error err, in AUTF8String desc); */
    pub OnError: unsafe extern "system" fn (this: *const IEwsFolderCallbacks, err:  u8, desc: *const ::nsstring::nsACString) -> ::nserror::nsresult,
}


// The implementations of the function wrappers which are exposed to rust code.
// Call these methods rather than manually calling through the VTable struct.
impl IEwsFolderCallbacks {


    /// `void recordRootFolder (in AUTF8String id);`
    #[inline]
    pub unsafe fn RecordRootFolder(&self, id: *const ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).RecordRootFolder)(self, id)
    }



    /// `void create (in AUTF8String id, in AUTF8String parentId, in AString name, in unsigned long flags);`
    #[inline]
    pub unsafe fn Create(&self, id: *const ::nsstring::nsACString, parentId: *const ::nsstring::nsACString, name: *const ::nsstring::nsAString, flags: u32) -> ::nserror::nsresult {
        ((*self.vtable).Create)(self, id, parentId, name, flags)
    }



    /// `void update (in AUTF8String id, in AUTF8String name);`
    #[inline]
    pub unsafe fn Update(&self, id: *const ::nsstring::nsACString, name: *const ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).Update)(self, id, name)
    }



    /// `void delete (in AUTF8String id);`
    #[inline]
    pub unsafe fn Delete(&self, id: *const ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).Delete)(self, id)
    }



    /// `void updateSyncState (in AUTF8String syncStateToken);`
    #[inline]
    pub unsafe fn UpdateSyncState(&self, syncStateToken: *const ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).UpdateSyncState)(self, syncStateToken)
    }



    /// `void onError (in IEwsClient_Error err, in AUTF8String desc);`
    #[inline]
    pub unsafe fn OnError(&self, err:  u8, desc: *const ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).OnError)(self, err, desc)
    }


}


/// `interface IEwsMessageCallbacks : nsISupports`
///


// The actual type definition for the interface. This struct has methods
// declared on it which will call through its vtable. You never want to pass
// this type around by value, always pass it behind a reference.

#[repr(C)]
pub struct IEwsMessageCallbacks {
    vtable: &'static IEwsMessageCallbacksVTable,

    /// This field is a phantomdata to ensure that the VTable type and any
    /// struct containing it is not safe to send across threads by default, as
    /// XPCOM is generally not threadsafe.
    ///
    /// If this type is marked as [rust_sync], there will be explicit `Send` and
    /// `Sync` implementations on this type, which will override the inherited
    /// negative impls from `Rc`.
    __nosync: ::std::marker::PhantomData<::std::rc::Rc<u8>>,

    // Make the rust compiler aware that there might be interior mutability
    // in what actually implements the interface. This works around UB
    // introduced by https://github.com/llvm/llvm-project/commit/01859da84bad95fd51d6a03b08b60c660e642a4f
    // that a rust lint would make blatantly obvious, but doesn't exist.
    // (See https://github.com/rust-lang/rust/issues/111229).
    // This prevents optimizations, but those optimizations weren't available
    // before rustc switched to LLVM 16, and they now cause problems because
    // of the UB.
    // Until there's a lint available to find all our UB, it's simpler to
    // avoid the UB in the first place, at the cost of preventing optimizations
    // in places that don't cause UB. But again, those optimizations weren't
    // available before.
    __maybe_interior_mutability: ::std::cell::UnsafeCell<[u8; 0]>,
}

// Implementing XpCom for an interface exposes its IID, which allows for easy
// use of the `.query_interface<T>` helper method. This also defines that
// method for IEwsMessageCallbacks.
unsafe impl XpCom for IEwsMessageCallbacks {
    const IID: nsIID = nsID(0xdec2ddd5, 0xb5a2, 0x4724,
        [0xbf, 0xc7, 0xe5, 0xde, 0x31, 0x84, 0x0f, 0x76]);
}

// We need to implement the RefCounted trait so we can be used with `RefPtr`.
// This trait teaches `RefPtr` how to manage our memory.
unsafe impl RefCounted for IEwsMessageCallbacks {
    #[inline]
    unsafe fn addref(&self) {
        self.AddRef();
    }
    #[inline]
    unsafe fn release(&self) {
        self.Release();
    }
}

// This trait is implemented on all types which can be coerced to from IEwsMessageCallbacks.
// It is used in the implementation of `fn coerce<T>`. We hide it from the
// documentation, because it clutters it up a lot.
#[doc(hidden)]
pub trait IEwsMessageCallbacksCoerce {
    /// Cheaply cast a value of this type from a `IEwsMessageCallbacks`.
    fn coerce_from(v: &IEwsMessageCallbacks) -> &Self;
}

// The trivial implementation: We can obviously coerce ourselves to ourselves.
impl IEwsMessageCallbacksCoerce for IEwsMessageCallbacks {
    #[inline]
    fn coerce_from(v: &IEwsMessageCallbacks) -> &Self {
        v
    }
}

impl IEwsMessageCallbacks {
    /// Cast this `IEwsMessageCallbacks` to one of its base interfaces.
    #[inline]
    pub fn coerce<T: IEwsMessageCallbacksCoerce>(&self) -> &T {
        T::coerce_from(self)
    }
}

// Every interface struct type implements `Deref` to its base interface. This
// causes methods on the base interfaces to be directly avaliable on the
// object. For example, you can call `.AddRef` or `.QueryInterface` directly
// on any interface which inherits from `nsISupports`.
impl ::std::ops::Deref for IEwsMessageCallbacks {
    type Target = nsISupports;
    #[inline]
    fn deref(&self) -> &nsISupports {
        unsafe {
            ::std::mem::transmute(self)
        }
    }
}

// Ensure we can use .coerce() to cast to our base types as well. Any type which
// our base interface can coerce from should be coercable from us as well.
impl<T: nsISupportsCoerce> IEwsMessageCallbacksCoerce for T {
    #[inline]
    fn coerce_from(v: &IEwsMessageCallbacks) -> &Self {
        T::coerce_from(v)
    }
}

// This struct represents the interface's VTable. A pointer to a statically
// allocated version of this struct is at the beginning of every IEwsMessageCallbacks
// object. It contains one pointer field for each method in the interface. In
// the case where we can't generate a binding for a method, we include a void
// pointer.
#[doc(hidden)]
#[repr(C)]
pub struct IEwsMessageCallbacksVTable {
    /// We need to include the members from the base interface's vtable at the start
    /// of the VTable definition.
    pub __base: nsISupportsVTable,

    /* nsIMsgDBHdr createNewHeader (); */
    pub CreateNewHeader: unsafe extern "system" fn (this: *const IEwsMessageCallbacks, _retval: *mut*const nsIMsgDBHdr) -> ::nserror::nsresult,

    /* void commitHeader (in nsIMsgDBHdr hdr); */
    pub CommitHeader: unsafe extern "system" fn (this: *const IEwsMessageCallbacks, hdr: *const nsIMsgDBHdr) -> ::nserror::nsresult,

    /* void updateSyncState (in AUTF8String syncStateToken); */
    pub UpdateSyncState: unsafe extern "system" fn (this: *const IEwsMessageCallbacks, syncStateToken: *const ::nsstring::nsACString) -> ::nserror::nsresult,

    /* void onError (in IEwsClient_Error err, in AUTF8String desc); */
    pub OnError: unsafe extern "system" fn (this: *const IEwsMessageCallbacks, err:  u8, desc: *const ::nsstring::nsACString) -> ::nserror::nsresult,
}


// The implementations of the function wrappers which are exposed to rust code.
// Call these methods rather than manually calling through the VTable struct.
impl IEwsMessageCallbacks {


    /// `nsIMsgDBHdr createNewHeader ();`
    #[inline]
    pub unsafe fn CreateNewHeader(&self, _retval: *mut*const nsIMsgDBHdr) -> ::nserror::nsresult {
        ((*self.vtable).CreateNewHeader)(self, _retval)
    }



    /// `void commitHeader (in nsIMsgDBHdr hdr);`
    #[inline]
    pub unsafe fn CommitHeader(&self, hdr: *const nsIMsgDBHdr) -> ::nserror::nsresult {
        ((*self.vtable).CommitHeader)(self, hdr)
    }



    /// `void updateSyncState (in AUTF8String syncStateToken);`
    #[inline]
    pub unsafe fn UpdateSyncState(&self, syncStateToken: *const ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).UpdateSyncState)(self, syncStateToken)
    }



    /// `void onError (in IEwsClient_Error err, in AUTF8String desc);`
    #[inline]
    pub unsafe fn OnError(&self, err:  u8, desc: *const ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).OnError)(self, err, desc)
    }


}


