//
// DO NOT EDIT.  THIS FILE IS GENERATED FROM $SRCDIR/comm/mailnews/protocols/ews/src/IEwsIncomingServer.idl
//


/// `interface IEwsAuthStringListener : nsISupports`
///


// The actual type definition for the interface. This struct has methods
// declared on it which will call through its vtable. You never want to pass
// this type around by value, always pass it behind a reference.

#[repr(C)]
pub struct IEwsAuthStringListener {
    vtable: &'static IEwsAuthStringListenerVTable,

    /// This field is a phantomdata to ensure that the VTable type and any
    /// struct containing it is not safe to send across threads by default, as
    /// XPCOM is generally not threadsafe.
    ///
    /// If this type is marked as [rust_sync], there will be explicit `Send` and
    /// `Sync` implementations on this type, which will override the inherited
    /// negative impls from `Rc`.
    __nosync: ::std::marker::PhantomData<::std::rc::Rc<u8>>,

    // Make the rust compiler aware that there might be interior mutability
    // in what actually implements the interface. This works around UB
    // introduced by https://github.com/llvm/llvm-project/commit/01859da84bad95fd51d6a03b08b60c660e642a4f
    // that a rust lint would make blatantly obvious, but doesn't exist.
    // (See https://github.com/rust-lang/rust/issues/111229).
    // This prevents optimizations, but those optimizations weren't available
    // before rustc switched to LLVM 16, and they now cause problems because
    // of the UB.
    // Until there's a lint available to find all our UB, it's simpler to
    // avoid the UB in the first place, at the cost of preventing optimizations
    // in places that don't cause UB. But again, those optimizations weren't
    // available before.
    __maybe_interior_mutability: ::std::cell::UnsafeCell<[u8; 0]>,
}

// Implementing XpCom for an interface exposes its IID, which allows for easy
// use of the `.query_interface<T>` helper method. This also defines that
// method for IEwsAuthStringListener.
unsafe impl XpCom for IEwsAuthStringListener {
    const IID: nsIID = nsID(0xdca19e42, 0xeafc, 0x11ee,
        [0xa4, 0x4c, 0xb4, 0x2e, 0x99, 0xed, 0x15, 0xca]);
}

// We need to implement the RefCounted trait so we can be used with `RefPtr`.
// This trait teaches `RefPtr` how to manage our memory.
unsafe impl RefCounted for IEwsAuthStringListener {
    #[inline]
    unsafe fn addref(&self) {
        self.AddRef();
    }
    #[inline]
    unsafe fn release(&self) {
        self.Release();
    }
}

// This trait is implemented on all types which can be coerced to from IEwsAuthStringListener.
// It is used in the implementation of `fn coerce<T>`. We hide it from the
// documentation, because it clutters it up a lot.
#[doc(hidden)]
pub trait IEwsAuthStringListenerCoerce {
    /// Cheaply cast a value of this type from a `IEwsAuthStringListener`.
    fn coerce_from(v: &IEwsAuthStringListener) -> &Self;
}

// The trivial implementation: We can obviously coerce ourselves to ourselves.
impl IEwsAuthStringListenerCoerce for IEwsAuthStringListener {
    #[inline]
    fn coerce_from(v: &IEwsAuthStringListener) -> &Self {
        v
    }
}

impl IEwsAuthStringListener {
    /// Cast this `IEwsAuthStringListener` to one of its base interfaces.
    #[inline]
    pub fn coerce<T: IEwsAuthStringListenerCoerce>(&self) -> &T {
        T::coerce_from(self)
    }
}

// Every interface struct type implements `Deref` to its base interface. This
// causes methods on the base interfaces to be directly avaliable on the
// object. For example, you can call `.AddRef` or `.QueryInterface` directly
// on any interface which inherits from `nsISupports`.
impl ::std::ops::Deref for IEwsAuthStringListener {
    type Target = nsISupports;
    #[inline]
    fn deref(&self) -> &nsISupports {
        unsafe {
            ::std::mem::transmute(self)
        }
    }
}

// Ensure we can use .coerce() to cast to our base types as well. Any type which
// our base interface can coerce from should be coercable from us as well.
impl<T: nsISupportsCoerce> IEwsAuthStringListenerCoerce for T {
    #[inline]
    fn coerce_from(v: &IEwsAuthStringListener) -> &Self {
        T::coerce_from(v)
    }
}

// This struct represents the interface's VTable. A pointer to a statically
// allocated version of this struct is at the beginning of every IEwsAuthStringListener
// object. It contains one pointer field for each method in the interface. In
// the case where we can't generate a binding for a method, we include a void
// pointer.
#[doc(hidden)]
#[repr(C)]
pub struct IEwsAuthStringListenerVTable {
    /// We need to include the members from the base interface's vtable at the start
    /// of the VTable definition.
    pub __base: nsISupportsVTable,

    /* void onAuthAvailable (in ACString authString); */
    pub OnAuthAvailable: unsafe extern "system" fn (this: *const IEwsAuthStringListener, authString: *const ::nsstring::nsACString) -> ::nserror::nsresult,

    /* void onError (in nsresult err); */
    pub OnError: unsafe extern "system" fn (this: *const IEwsAuthStringListener, err: nserror::nsresult) -> ::nserror::nsresult,
}


// The implementations of the function wrappers which are exposed to rust code.
// Call these methods rather than manually calling through the VTable struct.
impl IEwsAuthStringListener {


    /// `void onAuthAvailable (in ACString authString);`
    #[inline]
    pub unsafe fn OnAuthAvailable(&self, authString: *const ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).OnAuthAvailable)(self, authString)
    }



    /// `void onError (in nsresult err);`
    #[inline]
    pub unsafe fn OnError(&self, err: nserror::nsresult) -> ::nserror::nsresult {
        ((*self.vtable).OnError)(self, err)
    }


}


/// `interface IEwsIncomingServer : nsISupports`
///

/// ```text
/// /**
///  * IEwsIncomingServer is intended as a workaround for limitations in the folder
///  * lookup service.
///  *
///  * EWS folders require an EWS client object in order to fetch new messages. The
///  * folder itself, however, does not have access to all of the details needed to
///  * create such a client. This information is part of the incoming server.
///  *
///  * Due to depending on the folder lookup service to create new folders, it is
///  * not possible to give the folder a direct handle to its associated server, so
///  * we are forced to go through XPCOM.
///  */
/// ```
///

// The actual type definition for the interface. This struct has methods
// declared on it which will call through its vtable. You never want to pass
// this type around by value, always pass it behind a reference.

#[repr(C)]
pub struct IEwsIncomingServer {
    vtable: &'static IEwsIncomingServerVTable,

    /// This field is a phantomdata to ensure that the VTable type and any
    /// struct containing it is not safe to send across threads by default, as
    /// XPCOM is generally not threadsafe.
    ///
    /// If this type is marked as [rust_sync], there will be explicit `Send` and
    /// `Sync` implementations on this type, which will override the inherited
    /// negative impls from `Rc`.
    __nosync: ::std::marker::PhantomData<::std::rc::Rc<u8>>,

    // Make the rust compiler aware that there might be interior mutability
    // in what actually implements the interface. This works around UB
    // introduced by https://github.com/llvm/llvm-project/commit/01859da84bad95fd51d6a03b08b60c660e642a4f
    // that a rust lint would make blatantly obvious, but doesn't exist.
    // (See https://github.com/rust-lang/rust/issues/111229).
    // This prevents optimizations, but those optimizations weren't available
    // before rustc switched to LLVM 16, and they now cause problems because
    // of the UB.
    // Until there's a lint available to find all our UB, it's simpler to
    // avoid the UB in the first place, at the cost of preventing optimizations
    // in places that don't cause UB. But again, those optimizations weren't
    // available before.
    __maybe_interior_mutability: ::std::cell::UnsafeCell<[u8; 0]>,
}

// Implementing XpCom for an interface exposes its IID, which allows for easy
// use of the `.query_interface<T>` helper method. This also defines that
// method for IEwsIncomingServer.
unsafe impl XpCom for IEwsIncomingServer {
    const IID: nsIID = nsID(0x3b22cadc, 0xda49, 0x11ee,
        [0x99, 0xb2, 0xb4, 0x2e, 0x99, 0xed, 0x15, 0xca]);
}

// We need to implement the RefCounted trait so we can be used with `RefPtr`.
// This trait teaches `RefPtr` how to manage our memory.
unsafe impl RefCounted for IEwsIncomingServer {
    #[inline]
    unsafe fn addref(&self) {
        self.AddRef();
    }
    #[inline]
    unsafe fn release(&self) {
        self.Release();
    }
}

// This trait is implemented on all types which can be coerced to from IEwsIncomingServer.
// It is used in the implementation of `fn coerce<T>`. We hide it from the
// documentation, because it clutters it up a lot.
#[doc(hidden)]
pub trait IEwsIncomingServerCoerce {
    /// Cheaply cast a value of this type from a `IEwsIncomingServer`.
    fn coerce_from(v: &IEwsIncomingServer) -> &Self;
}

// The trivial implementation: We can obviously coerce ourselves to ourselves.
impl IEwsIncomingServerCoerce for IEwsIncomingServer {
    #[inline]
    fn coerce_from(v: &IEwsIncomingServer) -> &Self {
        v
    }
}

impl IEwsIncomingServer {
    /// Cast this `IEwsIncomingServer` to one of its base interfaces.
    #[inline]
    pub fn coerce<T: IEwsIncomingServerCoerce>(&self) -> &T {
        T::coerce_from(self)
    }
}

// Every interface struct type implements `Deref` to its base interface. This
// causes methods on the base interfaces to be directly avaliable on the
// object. For example, you can call `.AddRef` or `.QueryInterface` directly
// on any interface which inherits from `nsISupports`.
impl ::std::ops::Deref for IEwsIncomingServer {
    type Target = nsISupports;
    #[inline]
    fn deref(&self) -> &nsISupports {
        unsafe {
            ::std::mem::transmute(self)
        }
    }
}

// Ensure we can use .coerce() to cast to our base types as well. Any type which
// our base interface can coerce from should be coercable from us as well.
impl<T: nsISupportsCoerce> IEwsIncomingServerCoerce for T {
    #[inline]
    fn coerce_from(v: &IEwsIncomingServer) -> &Self {
        T::coerce_from(v)
    }
}

// This struct represents the interface's VTable. A pointer to a statically
// allocated version of this struct is at the beginning of every IEwsIncomingServer
// object. It contains one pointer field for each method in the interface. In
// the case where we can't generate a binding for a method, we include a void
// pointer.
#[doc(hidden)]
#[repr(C)]
pub struct IEwsIncomingServerVTable {
    /// We need to include the members from the base interface's vtable at the start
    /// of the VTable definition.
    pub __base: nsISupportsVTable,

    /* IEwsClient getEwsClient (); */
    pub GetEwsClient: unsafe extern "system" fn (this: *const IEwsIncomingServer, _retval: *mut*const IEwsClient) -> ::nserror::nsresult,

    /* void getAuthString (in IEwsAuthStringListener listener); */
    pub GetAuthString: unsafe extern "system" fn (this: *const IEwsIncomingServer, listener: *const IEwsAuthStringListener) -> ::nserror::nsresult,
}


// The implementations of the function wrappers which are exposed to rust code.
// Call these methods rather than manually calling through the VTable struct.
impl IEwsIncomingServer {


    /// `IEwsClient getEwsClient ();`
    #[inline]
    pub unsafe fn GetEwsClient(&self, _retval: *mut*const IEwsClient) -> ::nserror::nsresult {
        ((*self.vtable).GetEwsClient)(self, _retval)
    }


    /// ```text
    /// /**
    ///    * Gets a value suitable for use as the body of an HTTP `Authorization`
    ///    * header, based on the settings and credentials available to the server
    ///    * object.
    ///    */
    /// ```
    ///

    /// `void getAuthString (in IEwsAuthStringListener listener);`
    #[inline]
    pub unsafe fn GetAuthString(&self, listener: *const IEwsAuthStringListener) -> ::nserror::nsresult {
        ((*self.vtable).GetAuthString)(self, listener)
    }


}


