#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioData" "\0"
  /*   345 */ "AudioDecoder" "\0"
  /*   358 */ "AudioDestinationNode" "\0"
  /*   379 */ "AudioEncoder" "\0"
  /*   392 */ "AudioListener" "\0"
  /*   406 */ "AudioNode" "\0"
  /*   416 */ "AudioParam" "\0"
  /*   427 */ "AudioParamMap" "\0"
  /*   441 */ "AudioProcessingEvent" "\0"
  /*   462 */ "AudioScheduledSourceNode" "\0"
  /*   487 */ "AudioTrack" "\0"
  /*   498 */ "AudioTrackList" "\0"
  /*   513 */ "AudioWorklet" "\0"
  /*   526 */ "AudioWorkletGlobalScope" "\0"
  /*   550 */ "AudioWorkletNode" "\0"
  /*   567 */ "AudioWorkletProcessor" "\0"
  /*   589 */ "AuthenticatorAssertionResponse" "\0"
  /*   620 */ "AuthenticatorAttestationResponse" "\0"
  /*   653 */ "AuthenticatorResponse" "\0"
  /*   675 */ "BarProp" "\0"
  /*   683 */ "BaseAudioContext" "\0"
  /*   700 */ "BatteryManager" "\0"
  /*   715 */ "BeforeUnloadEvent" "\0"
  /*   733 */ "BiquadFilterNode" "\0"
  /*   750 */ "Blob" "\0"
  /*   755 */ "BlobEvent" "\0"
  /*   765 */ "BroadcastChannel" "\0"
  /*   782 */ "BrowsingContext" "\0"
  /*   798 */ "BrowsingContextGroup" "\0"
  /*   819 */ "ByteLengthQueuingStrategy" "\0"
  /*   845 */ "CDATASection" "\0"
  /*   858 */ "CSS" "\0"
  /*   862 */ "CSS2Properties" "\0"
  /*   877 */ "CSSAnimation" "\0"
  /*   890 */ "CSSConditionRule" "\0"
  /*   907 */ "CSSContainerRule" "\0"
  /*   924 */ "CSSCounterStyleRule" "\0"
  /*   944 */ "CSSCustomPropertyRegisteredEvent" "\0"
  /*   977 */ "CSSFontFaceRule" "\0"
  /*   993 */ "CSSFontFeatureValuesRule" "\0"
  /*  1018 */ "CSSFontPaletteValuesRule" "\0"
  /*  1043 */ "CSSGroupingRule" "\0"
  /*  1059 */ "CSSImportRule" "\0"
  /*  1073 */ "CSSKeyframeRule" "\0"
  /*  1089 */ "CSSKeyframesRule" "\0"
  /*  1106 */ "CSSLayerBlockRule" "\0"
  /*  1124 */ "CSSLayerStatementRule" "\0"
  /*  1146 */ "CSSMarginRule" "\0"
  /*  1160 */ "CSSMediaRule" "\0"
  /*  1173 */ "CSSMozDocumentRule" "\0"
  /*  1192 */ "CSSNamespaceRule" "\0"
  /*  1209 */ "CSSPageRule" "\0"
  /*  1221 */ "CSSPropertyRule" "\0"
  /*  1237 */ "CSSPseudoElement" "\0"
  /*  1254 */ "CSSRule" "\0"
  /*  1262 */ "CSSRuleList" "\0"
  /*  1274 */ "CSSScopeRule" "\0"
  /*  1287 */ "CSSStartingStyleRule" "\0"
  /*  1308 */ "CSSStyleDeclaration" "\0"
  /*  1328 */ "CSSStyleRule" "\0"
  /*  1341 */ "CSSStyleSheet" "\0"
  /*  1355 */ "CSSSupportsRule" "\0"
  /*  1371 */ "CSSTransition" "\0"
  /*  1385 */ "Cache" "\0"
  /*  1391 */ "CacheStorage" "\0"
  /*  1404 */ "CallbackDebuggerNotification" "\0"
  /*  1433 */ "CanonicalBrowsingContext" "\0"
  /*  1458 */ "CanvasCaptureMediaStream" "\0"
  /*  1483 */ "CanvasGradient" "\0"
  /*  1498 */ "CanvasPattern" "\0"
  /*  1512 */ "CanvasRenderingContext2D" "\0"
  /*  1537 */ "CaretPosition" "\0"
  /*  1551 */ "CaretStateChangedEvent" "\0"
  /*  1574 */ "ChannelMergerNode" "\0"
  /*  1592 */ "ChannelSplitterNode" "\0"
  /*  1612 */ "ChannelWrapper" "\0"
  /*  1627 */ "CharacterData" "\0"
  /*  1641 */ "CheckerboardReportService" "\0"
  /*  1667 */ "ChildProcessMessageManager" "\0"
  /*  1694 */ "ChildSHistory" "\0"
  /*  1708 */ "ChromeMessageBroadcaster" "\0"
  /*  1733 */ "ChromeMessageSender" "\0"
  /*  1753 */ "ChromeNodeList" "\0"
  /*  1768 */ "ChromeUtils" "\0"
  /*  1780 */ "ChromeWorker" "\0"
  /*  1793 */ "Client" "\0"
  /*  1800 */ "Clients" "\0"
  /*  1808 */ "Clipboard" "\0"
  /*  1818 */ "ClipboardEvent" "\0"
  /*  1833 */ "ClipboardItem" "\0"
  /*  1847 */ "ClonedErrorHolder" "\0"
  /*  1865 */ "CloseEvent" "\0"
  /*  1876 */ "CommandEvent" "\0"
  /*  1889 */ "Comment" "\0"
  /*  1897 */ "CompositionEvent" "\0"
  /*  1914 */ "CompressionStream" "\0"
  /*  1932 */ "ConsoleInstance" "\0"
  /*  1948 */ "ConstantSourceNode" "\0"
  /*  1967 */ "ContentFrameMessageManager" "\0"
  /*  1994 */ "ContentProcessMessageManager" "\0"
  /*  2023 */ "ContentVisibilityAutoStateChangeEvent" "\0"
  /*  2061 */ "ConvolverNode" "\0"
  /*  2075 */ "CountQueuingStrategy" "\0"
  /*  2096 */ "CreateOfferRequest" "\0"
  /*  2115 */ "Credential" "\0"
  /*  2126 */ "CredentialsContainer" "\0"
  /*  2147 */ "Crypto" "\0"
  /*  2154 */ "CryptoKey" "\0"
  /*  2164 */ "CustomElementRegistry" "\0"
  /*  2186 */ "CustomEvent" "\0"
  /*  2198 */ "CustomStateSet" "\0"
  /*  2213 */ "DOMException" "\0"
  /*  2226 */ "DOMImplementation" "\0"
  /*  2244 */ "DOMLocalization" "\0"
  /*  2260 */ "DOMMatrix" "\0"
  /*  2270 */ "DOMMatrixReadOnly" "\0"
  /*  2288 */ "DOMParser" "\0"
  /*  2298 */ "DOMPoint" "\0"
  /*  2307 */ "DOMPointReadOnly" "\0"
  /*  2324 */ "DOMQuad" "\0"
  /*  2332 */ "DOMRect" "\0"
  /*  2340 */ "DOMRectList" "\0"
  /*  2352 */ "DOMRectReadOnly" "\0"
  /*  2368 */ "DOMStringList" "\0"
  /*  2382 */ "DOMStringMap" "\0"
  /*  2395 */ "DOMTokenList" "\0"
  /*  2408 */ "DataTransfer" "\0"
  /*  2421 */ "DataTransferItem" "\0"
  /*  2438 */ "DataTransferItemList" "\0"
  /*  2459 */ "DebuggerNotification" "\0"
  /*  2480 */ "DebuggerNotificationObserver" "\0"
  /*  2509 */ "DecompressionStream" "\0"
  /*  2529 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2556 */ "DelayNode" "\0"
  /*  2566 */ "DeprecationReportBody" "\0"
  /*  2588 */ "DeviceAcceleration" "\0"
  /*  2607 */ "DeviceLightEvent" "\0"
  /*  2624 */ "DeviceMotionEvent" "\0"
  /*  2642 */ "DeviceOrientationEvent" "\0"
  /*  2665 */ "DeviceRotationRate" "\0"
  /*  2684 */ "Directory" "\0"
  /*  2694 */ "Document" "\0"
  /*  2703 */ "DocumentFragment" "\0"
  /*  2720 */ "DocumentL10n" "\0"
  /*  2733 */ "DocumentTimeline" "\0"
  /*  2750 */ "DocumentType" "\0"
  /*  2763 */ "DominatorTree" "\0"
  /*  2777 */ "DragEvent" "\0"
  /*  2787 */ "DynamicsCompressorNode" "\0"
  /*  2810 */ "EXT_blend_minmax" "\0"
  /*  2827 */ "EXT_color_buffer_float" "\0"
  /*  2850 */ "EXT_color_buffer_half_float" "\0"
  /*  2878 */ "EXT_disjoint_timer_query" "\0"
  /*  2903 */ "EXT_float_blend" "\0"
  /*  2919 */ "EXT_frag_depth" "\0"
  /*  2934 */ "EXT_sRGB" "\0"
  /*  2943 */ "EXT_shader_texture_lod" "\0"
  /*  2966 */ "EXT_texture_compression_bptc" "\0"
  /*  2995 */ "EXT_texture_compression_rgtc" "\0"
  /*  3024 */ "EXT_texture_filter_anisotropic" "\0"
  /*  3055 */ "EXT_texture_norm16" "\0"
  /*  3074 */ "Element" "\0"
  /*  3082 */ "ElementInternals" "\0"
  /*  3099 */ "EncodedAudioChunk" "\0"
  /*  3117 */ "EncodedVideoChunk" "\0"
  /*  3135 */ "ErrorEvent" "\0"
  /*  3146 */ "Event" "\0"
  /*  3152 */ "EventCallbackDebuggerNotification" "\0"
  /*  3186 */ "EventCounts" "\0"
  /*  3198 */ "EventSource" "\0"
  /*  3210 */ "EventTarget" "\0"
  /*  3222 */ "Exception" "\0"
  /*  3232 */ "ExtendableEvent" "\0"
  /*  3248 */ "ExtendableMessageEvent" "\0"
  /*  3271 */ "ExtensionAlarms" "\0"
  /*  3287 */ "ExtensionBrowser" "\0"
  /*  3304 */ "ExtensionBrowserSettings" "\0"
  /*  3329 */ "ExtensionBrowserSettingsColorManagement" "\0"
  /*  3369 */ "ExtensionDns" "\0"
  /*  3382 */ "ExtensionEventManager" "\0"
  /*  3404 */ "ExtensionMockAPI" "\0"
  /*  3421 */ "ExtensionPort" "\0"
  /*  3435 */ "ExtensionProxy" "\0"
  /*  3450 */ "ExtensionRuntime" "\0"
  /*  3467 */ "ExtensionScripting" "\0"
  /*  3486 */ "ExtensionSetting" "\0"
  /*  3503 */ "ExtensionTest" "\0"
  /*  3517 */ "External" "\0"
  /*  3526 */ "FeaturePolicy" "\0"
  /*  3540 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3573 */ "FetchEvent" "\0"
  /*  3584 */ "FetchObserver" "\0"
  /*  3598 */ "File" "\0"
  /*  3603 */ "FileList" "\0"
  /*  3612 */ "FileReader" "\0"
  /*  3623 */ "FileReaderSync" "\0"
  /*  3638 */ "FileSystem" "\0"
  /*  3649 */ "FileSystemDirectoryEntry" "\0"
  /*  3674 */ "FileSystemDirectoryHandle" "\0"
  /*  3700 */ "FileSystemDirectoryHandle AsyncIterator" "\0"
  /*  3740 */ "FileSystemDirectoryIterator" "\0"
  /*  3768 */ "FileSystemDirectoryReader" "\0"
  /*  3794 */ "FileSystemEntry" "\0"
  /*  3810 */ "FileSystemFileEntry" "\0"
  /*  3830 */ "FileSystemFileHandle" "\0"
  /*  3851 */ "FileSystemHandle" "\0"
  /*  3868 */ "FileSystemSyncAccessHandle" "\0"
  /*  3895 */ "FileSystemWritableFileStream" "\0"
  /*  3924 */ "Flex" "\0"
  /*  3929 */ "FlexItemValues" "\0"
  /*  3944 */ "FlexLineValues" "\0"
  /*  3959 */ "FluentBundle" "\0"
  /*  3972 */ "FluentBundleAsyncIterator" "\0"
  /*  3998 */ "FluentBundleIterator" "\0"
  /*  4019 */ "FluentPattern" "\0"
  /*  4033 */ "FluentResource" "\0"
  /*  4048 */ "FocusEvent" "\0"
  /*  4059 */ "FontFace" "\0"
  /*  4068 */ "FontFaceSet" "\0"
  /*  4080 */ "FontFaceSetIterator" "\0"
  /*  4100 */ "FontFaceSetLoadEvent" "\0"
  /*  4121 */ "FormData" "\0"
  /*  4130 */ "FormData Iterator" "\0"
  /*  4148 */ "FormDataEvent" "\0"
  /*  4162 */ "FragmentDirective" "\0"
  /*  4180 */ "FrameCrashedEvent" "\0"
  /*  4198 */ "FrameLoader" "\0"
  /*  4210 */ "GPU" "\0"
  /*  4214 */ "GPUAdapter" "\0"
  /*  4225 */ "GPUAdapterInfo" "\0"
  /*  4240 */ "GPUBindGroup" "\0"
  /*  4253 */ "GPUBindGroupLayout" "\0"
  /*  4272 */ "GPUBuffer" "\0"
  /*  4282 */ "GPUBufferUsage" "\0"
  /*  4297 */ "GPUCanvasContext" "\0"
  /*  4314 */ "GPUColorWrite" "\0"
  /*  4328 */ "GPUCommandBuffer" "\0"
  /*  4345 */ "GPUCommandEncoder" "\0"
  /*  4363 */ "GPUCompilationInfo" "\0"
  /*  4382 */ "GPUCompilationMessage" "\0"
  /*  4404 */ "GPUComputePassEncoder" "\0"
  /*  4426 */ "GPUComputePipeline" "\0"
  /*  4445 */ "GPUDevice" "\0"
  /*  4455 */ "GPUDeviceLostInfo" "\0"
  /*  4473 */ "GPUError" "\0"
  /*  4482 */ "GPUInternalError" "\0"
  /*  4499 */ "GPUMapMode" "\0"
  /*  4510 */ "GPUOutOfMemoryError" "\0"
  /*  4530 */ "GPUPipelineLayout" "\0"
  /*  4548 */ "GPUQuerySet" "\0"
  /*  4560 */ "GPUQueue" "\0"
  /*  4569 */ "GPURenderBundle" "\0"
  /*  4585 */ "GPURenderBundleEncoder" "\0"
  /*  4608 */ "GPURenderPassEncoder" "\0"
  /*  4629 */ "GPURenderPipeline" "\0"
  /*  4647 */ "GPUSampler" "\0"
  /*  4658 */ "GPUShaderModule" "\0"
  /*  4674 */ "GPUShaderStage" "\0"
  /*  4689 */ "GPUSupportedFeatures" "\0"
  /*  4710 */ "GPUSupportedLimits" "\0"
  /*  4729 */ "GPUTexture" "\0"
  /*  4740 */ "GPUTextureUsage" "\0"
  /*  4756 */ "GPUTextureView" "\0"
  /*  4771 */ "GPUUncapturedErrorEvent" "\0"
  /*  4795 */ "GPUValidationError" "\0"
  /*  4814 */ "GainNode" "\0"
  /*  4823 */ "Gamepad" "\0"
  /*  4831 */ "GamepadAxisMoveEvent" "\0"
  /*  4852 */ "GamepadButton" "\0"
  /*  4866 */ "GamepadButtonEvent" "\0"
  /*  4885 */ "GamepadEvent" "\0"
  /*  4898 */ "GamepadHapticActuator" "\0"
  /*  4920 */ "GamepadLightIndicator" "\0"
  /*  4942 */ "GamepadPose" "\0"
  /*  4954 */ "GamepadServiceTest" "\0"
  /*  4973 */ "GamepadTouch" "\0"
  /*  4986 */ "Geolocation" "\0"
  /*  4998 */ "GeolocationCoordinates" "\0"
  /*  5021 */ "GeolocationPosition" "\0"
  /*  5041 */ "GeolocationPositionError" "\0"
  /*  5066 */ "GetUserMediaRequest" "\0"
  /*  5086 */ "GleanBoolean" "\0"
  /*  5099 */ "GleanCategory" "\0"
  /*  5113 */ "GleanCounter" "\0"
  /*  5126 */ "GleanCustomDistribution" "\0"
  /*  5150 */ "GleanDatetime" "\0"
  /*  5164 */ "GleanDenominator" "\0"
  /*  5181 */ "GleanEvent" "\0"
  /*  5192 */ "GleanImpl" "\0"
  /*  5202 */ "GleanLabeled" "\0"
  /*  5215 */ "GleanMemoryDistribution" "\0"
  /*  5239 */ "GleanMetric" "\0"
  /*  5251 */ "GleanNumerator" "\0"
  /*  5266 */ "GleanObject" "\0"
  /*  5278 */ "GleanPingsImpl" "\0"
  /*  5293 */ "GleanQuantity" "\0"
  /*  5307 */ "GleanRate" "\0"
  /*  5317 */ "GleanString" "\0"
  /*  5329 */ "GleanStringList" "\0"
  /*  5345 */ "GleanText" "\0"
  /*  5355 */ "GleanTimespan" "\0"
  /*  5369 */ "GleanTimingDistribution" "\0"
  /*  5393 */ "GleanUrl" "\0"
  /*  5402 */ "GleanUuid" "\0"
  /*  5412 */ "Grid" "\0"
  /*  5417 */ "GridArea" "\0"
  /*  5426 */ "GridDimension" "\0"
  /*  5440 */ "GridLine" "\0"
  /*  5449 */ "GridLines" "\0"
  /*  5459 */ "GridTrack" "\0"
  /*  5469 */ "GridTracks" "\0"
  /*  5480 */ "HTMLAllCollection" "\0"
  /*  5498 */ "HTMLAnchorElement" "\0"
  /*  5516 */ "HTMLAreaElement" "\0"
  /*  5532 */ "HTMLAudioElement" "\0"
  /*  5549 */ "HTMLBRElement" "\0"
  /*  5563 */ "HTMLBaseElement" "\0"
  /*  5579 */ "HTMLBodyElement" "\0"
  /*  5595 */ "HTMLButtonElement" "\0"
  /*  5613 */ "HTMLCanvasElement" "\0"
  /*  5631 */ "HTMLCollection" "\0"
  /*  5646 */ "HTMLDListElement" "\0"
  /*  5663 */ "HTMLDataElement" "\0"
  /*  5679 */ "HTMLDataListElement" "\0"
  /*  5699 */ "HTMLDetailsElement" "\0"
  /*  5718 */ "HTMLDialogElement" "\0"
  /*  5736 */ "HTMLDirectoryElement" "\0"
  /*  5757 */ "HTMLDivElement" "\0"
  /*  5772 */ "HTMLDocument" "\0"
  /*  5785 */ "HTMLElement" "\0"
  /*  5797 */ "HTMLEmbedElement" "\0"
  /*  5814 */ "HTMLFieldSetElement" "\0"
  /*  5834 */ "HTMLFontElement" "\0"
  /*  5850 */ "HTMLFormControlsCollection" "\0"
  /*  5877 */ "HTMLFormElement" "\0"
  /*  5893 */ "HTMLFrameElement" "\0"
  /*  5910 */ "HTMLFrameSetElement" "\0"
  /*  5930 */ "HTMLHRElement" "\0"
  /*  5944 */ "HTMLHeadElement" "\0"
  /*  5960 */ "HTMLHeadingElement" "\0"
  /*  5979 */ "HTMLHtmlElement" "\0"
  /*  5995 */ "HTMLIFrameElement" "\0"
  /*  6013 */ "HTMLImageElement" "\0"
  /*  6030 */ "HTMLInputElement" "\0"
  /*  6047 */ "HTMLLIElement" "\0"
  /*  6061 */ "HTMLLabelElement" "\0"
  /*  6078 */ "HTMLLegendElement" "\0"
  /*  6096 */ "HTMLLinkElement" "\0"
  /*  6112 */ "HTMLMapElement" "\0"
  /*  6127 */ "HTMLMarqueeElement" "\0"
  /*  6146 */ "HTMLMediaElement" "\0"
  /*  6163 */ "HTMLMenuElement" "\0"
  /*  6179 */ "HTMLMetaElement" "\0"
  /*  6195 */ "HTMLMeterElement" "\0"
  /*  6212 */ "HTMLModElement" "\0"
  /*  6227 */ "HTMLOListElement" "\0"
  /*  6244 */ "HTMLObjectElement" "\0"
  /*  6262 */ "HTMLOptGroupElement" "\0"
  /*  6282 */ "HTMLOptionElement" "\0"
  /*  6300 */ "HTMLOptionsCollection" "\0"
  /*  6322 */ "HTMLOutputElement" "\0"
  /*  6340 */ "HTMLParagraphElement" "\0"
  /*  6361 */ "HTMLParamElement" "\0"
  /*  6378 */ "HTMLPictureElement" "\0"
  /*  6397 */ "HTMLPreElement" "\0"
  /*  6412 */ "HTMLProgressElement" "\0"
  /*  6432 */ "HTMLQuoteElement" "\0"
  /*  6449 */ "HTMLScriptElement" "\0"
  /*  6467 */ "HTMLSelectElement" "\0"
  /*  6485 */ "HTMLSlotElement" "\0"
  /*  6501 */ "HTMLSourceElement" "\0"
  /*  6519 */ "HTMLSpanElement" "\0"
  /*  6535 */ "HTMLStyleElement" "\0"
  /*  6552 */ "HTMLTableCaptionElement" "\0"
  /*  6576 */ "HTMLTableCellElement" "\0"
  /*  6597 */ "HTMLTableColElement" "\0"
  /*  6617 */ "HTMLTableElement" "\0"
  /*  6634 */ "HTMLTableRowElement" "\0"
  /*  6654 */ "HTMLTableSectionElement" "\0"
  /*  6678 */ "HTMLTemplateElement" "\0"
  /*  6698 */ "HTMLTextAreaElement" "\0"
  /*  6718 */ "HTMLTimeElement" "\0"
  /*  6734 */ "HTMLTitleElement" "\0"
  /*  6751 */ "HTMLTrackElement" "\0"
  /*  6768 */ "HTMLUListElement" "\0"
  /*  6785 */ "HTMLUnknownElement" "\0"
  /*  6804 */ "HTMLVideoElement" "\0"
  /*  6821 */ "HashChangeEvent" "\0"
  /*  6837 */ "Headers" "\0"
  /*  6845 */ "Headers Iterator" "\0"
  /*  6862 */ "HeapSnapshot" "\0"
  /*  6875 */ "Highlight" "\0"
  /*  6885 */ "HighlightRegistry" "\0"
  /*  6903 */ "History" "\0"
  /*  6911 */ "IDBCursor" "\0"
  /*  6921 */ "IDBCursorWithValue" "\0"
  /*  6940 */ "IDBDatabase" "\0"
  /*  6952 */ "IDBFactory" "\0"
  /*  6963 */ "IDBIndex" "\0"
  /*  6972 */ "IDBKeyRange" "\0"
  /*  6984 */ "IDBObjectStore" "\0"
  /*  6999 */ "IDBOpenDBRequest" "\0"
  /*  7016 */ "IDBRequest" "\0"
  /*  7027 */ "IDBTransaction" "\0"
  /*  7042 */ "IDBVersionChangeEvent" "\0"
  /*  7064 */ "IIRFilterNode" "\0"
  /*  7078 */ "IOUtils" "\0"
  /*  7086 */ "IdentityCredential" "\0"
  /*  7105 */ "IdleDeadline" "\0"
  /*  7118 */ "Image" "\0"
  /*  7124 */ "ImageBitmap" "\0"
  /*  7136 */ "ImageBitmapRenderingContext" "\0"
  /*  7164 */ "ImageCapture" "\0"
  /*  7177 */ "ImageCaptureError" "\0"
  /*  7195 */ "ImageCaptureErrorEvent" "\0"
  /*  7218 */ "ImageData" "\0"
  /*  7228 */ "ImageDocument" "\0"
  /*  7242 */ "InputEvent" "\0"
  /*  7253 */ "InspectorCSSParser" "\0"
  /*  7272 */ "InspectorFontFace" "\0"
  /*  7290 */ "InspectorUtils" "\0"
  /*  7305 */ "InstallTriggerImpl" "\0"
  /*  7324 */ "IntersectionObserver" "\0"
  /*  7345 */ "IntersectionObserverEntry" "\0"
  /*  7371 */ "IntlUtils" "\0"
  /*  7381 */ "InvokeEvent" "\0"
  /*  7393 */ "JSProcessActorChild" "\0"
  /*  7413 */ "JSProcessActorParent" "\0"
  /*  7434 */ "JSWindowActorChild" "\0"
  /*  7453 */ "JSWindowActorParent" "\0"
  /*  7473 */ "KeyEvent" "\0"
  /*  7482 */ "KeyboardEvent" "\0"
  /*  7496 */ "KeyframeEffect" "\0"
  /*  7511 */ "L10nFileSource" "\0"
  /*  7526 */ "L10nOverlays" "\0"
  /*  7539 */ "L10nRegistry" "\0"
  /*  7552 */ "LargestContentfulPaint" "\0"
  /*  7575 */ "LegacyMozTCPSocket" "\0"
  /*  7594 */ "Localization" "\0"
  /*  7607 */ "Location" "\0"
  /*  7616 */ "Lock" "\0"
  /*  7621 */ "LockManager" "\0"
  /*  7633 */ "MIDIAccess" "\0"
  /*  7644 */ "MIDIConnectionEvent" "\0"
  /*  7664 */ "MIDIInput" "\0"
  /*  7674 */ "MIDIInputMap" "\0"
  /*  7687 */ "MIDIMessageEvent" "\0"
  /*  7704 */ "MIDIOutput" "\0"
  /*  7715 */ "MIDIOutputMap" "\0"
  /*  7729 */ "MIDIPort" "\0"
  /*  7738 */ "MOZ_debug" "\0"
  /*  7748 */ "MatchGlob" "\0"
  /*  7758 */ "MatchPattern" "\0"
  /*  7771 */ "MatchPatternSet" "\0"
  /*  7787 */ "MathMLElement" "\0"
  /*  7801 */ "MediaCapabilities" "\0"
  /*  7819 */ "MediaCapabilitiesInfo" "\0"
  /*  7841 */ "MediaControlService" "\0"
  /*  7861 */ "MediaController" "\0"
  /*  7877 */ "MediaDeviceInfo" "\0"
  /*  7893 */ "MediaDevices" "\0"
  /*  7906 */ "MediaElementAudioSourceNode" "\0"
  /*  7934 */ "MediaEncryptedEvent" "\0"
  /*  7954 */ "MediaError" "\0"
  /*  7965 */ "MediaKeyError" "\0"
  /*  7979 */ "MediaKeyMessageEvent" "\0"
  /*  8000 */ "MediaKeySession" "\0"
  /*  8016 */ "MediaKeyStatusMap" "\0"
  /*  8034 */ "MediaKeyStatusMap Iterator" "\0"
  /*  8061 */ "MediaKeySystemAccess" "\0"
  /*  8082 */ "MediaKeys" "\0"
  /*  8092 */ "MediaList" "\0"
  /*  8102 */ "MediaMetadata" "\0"
  /*  8116 */ "MediaQueryList" "\0"
  /*  8131 */ "MediaQueryListEvent" "\0"
  /*  8151 */ "MediaRecorder" "\0"
  /*  8165 */ "MediaRecorderErrorEvent" "\0"
  /*  8189 */ "MediaSession" "\0"
  /*  8202 */ "MediaSource" "\0"
  /*  8214 */ "MediaStream" "\0"
  /*  8226 */ "MediaStreamAudioDestinationNode" "\0"
  /*  8258 */ "MediaStreamAudioSourceNode" "\0"
  /*  8285 */ "MediaStreamError" "\0"
  /*  8302 */ "MediaStreamEvent" "\0"
  /*  8319 */ "MediaStreamTrack" "\0"
  /*  8336 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  8368 */ "MediaStreamTrackEvent" "\0"
  /*  8390 */ "MerchantValidationEvent" "\0"
  /*  8414 */ "MessageBroadcaster" "\0"
  /*  8433 */ "MessageChannel" "\0"
  /*  8448 */ "MessageEvent" "\0"
  /*  8461 */ "MessageListenerManager" "\0"
  /*  8484 */ "MessagePort" "\0"
  /*  8496 */ "MessageSender" "\0"
  /*  8510 */ "MimeType" "\0"
  /*  8519 */ "MimeTypeArray" "\0"
  /*  8533 */ "MouseEvent" "\0"
  /*  8544 */ "MouseScrollEvent" "\0"
  /*  8561 */ "MozCanvasPrintState" "\0"
  /*  8581 */ "MozDocumentMatcher" "\0"
  /*  8600 */ "MozDocumentObserver" "\0"
  /*  8620 */ "MozQueryInterface" "\0"
  /*  8638 */ "MozSharedMap" "\0"
  /*  8651 */ "MozSharedMap Iterator" "\0"
  /*  8673 */ "MozSharedMapChangeEvent" "\0"
  /*  8697 */ "MozStorageAsyncStatementParams" "\0"
  /*  8728 */ "MozStorageStatementParams" "\0"
  /*  8754 */ "MozStorageStatementRow" "\0"
  /*  8777 */ "MozWritableSharedMap" "\0"
  /*  8798 */ "MutationEvent" "\0"
  /*  8812 */ "MutationObserver" "\0"
  /*  8829 */ "MutationRecord" "\0"
  /*  8844 */ "NamedNodeMap" "\0"
  /*  8857 */ "NavigationPreloadManager" "\0"
  /*  8882 */ "Navigator" "\0"
  /*  8892 */ "NetworkInformation" "\0"
  /*  8911 */ "Node" "\0"
  /*  8916 */ "NodeFilter" "\0"
  /*  8927 */ "NodeIterator" "\0"
  /*  8940 */ "NodeList" "\0"
  /*  8949 */ "Notification" "\0"
  /*  8962 */ "NotificationEvent" "\0"
  /*  8980 */ "NotifyPaintEvent" "\0"
  /*  8997 */ "OES_draw_buffers_indexed" "\0"
  /*  9022 */ "OES_element_index_uint" "\0"
  /*  9045 */ "OES_fbo_render_mipmap" "\0"
  /*  9067 */ "OES_standard_derivatives" "\0"
  /*  9092 */ "OES_texture_float" "\0"
  /*  9110 */ "OES_texture_float_linear" "\0"
  /*  9135 */ "OES_texture_half_float" "\0"
  /*  9158 */ "OES_texture_half_float_linear" "\0"
  /*  9188 */ "OES_vertex_array_object" "\0"
  /*  9212 */ "OVR_multiview2" "\0"
  /*  9227 */ "OfflineAudioCompletionEvent" "\0"
  /*  9255 */ "OfflineAudioContext" "\0"
  /*  9275 */ "OffscreenCanvas" "\0"
  /*  9291 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  9325 */ "OnlyForUseInConstructor" "\0"
  /*  9349 */ "Option" "\0"
  /*  9356 */ "OscillatorNode" "\0"
  /*  9371 */ "PageTransitionEvent" "\0"
  /*  9391 */ "PaintRequest" "\0"
  /*  9404 */ "PaintRequestList" "\0"
  /*  9421 */ "PaintWorkletGlobalScope" "\0"
  /*  9445 */ "PannerNode" "\0"
  /*  9456 */ "ParentProcessMessageManager" "\0"
  /*  9484 */ "Path2D" "\0"
  /*  9491 */ "PathUtils" "\0"
  /*  9501 */ "PaymentAddress" "\0"
  /*  9516 */ "PaymentMethodChangeEvent" "\0"
  /*  9541 */ "PaymentRequest" "\0"
  /*  9556 */ "PaymentRequestUpdateEvent" "\0"
  /*  9582 */ "PaymentResponse" "\0"
  /*  9598 */ "PeerConnectionImpl" "\0"
  /*  9617 */ "PeerConnectionObserver" "\0"
  /*  9640 */ "Performance" "\0"
  /*  9652 */ "PerformanceEntry" "\0"
  /*  9669 */ "PerformanceEntryEvent" "\0"
  /*  9691 */ "PerformanceEventTiming" "\0"
  /*  9714 */ "PerformanceMark" "\0"
  /*  9730 */ "PerformanceMeasure" "\0"
  /*  9749 */ "PerformanceNavigation" "\0"
  /*  9771 */ "PerformanceNavigationTiming" "\0"
  /*  9799 */ "PerformanceObserver" "\0"
  /*  9819 */ "PerformanceObserverEntryList" "\0"
  /*  9848 */ "PerformancePaintTiming" "\0"
  /*  9871 */ "PerformanceResourceTiming" "\0"
  /*  9897 */ "PerformanceServerTiming" "\0"
  /*  9921 */ "PerformanceTiming" "\0"
  /*  9939 */ "PeriodicWave" "\0"
  /*  9952 */ "PermissionStatus" "\0"
  /*  9969 */ "Permissions" "\0"
  /*  9981 */ "PlacesBookmark" "\0"
  /*  9996 */ "PlacesBookmarkAddition" "\0"
  /* 10019 */ "PlacesBookmarkChanged" "\0"
  /* 10041 */ "PlacesBookmarkGuid" "\0"
  /* 10060 */ "PlacesBookmarkKeyword" "\0"
  /* 10082 */ "PlacesBookmarkMoved" "\0"
  /* 10102 */ "PlacesBookmarkRemoved" "\0"
  /* 10124 */ "PlacesBookmarkTags" "\0"
  /* 10143 */ "PlacesBookmarkTime" "\0"
  /* 10162 */ "PlacesBookmarkTitle" "\0"
  /* 10182 */ "PlacesBookmarkUrl" "\0"
  /* 10200 */ "PlacesEvent" "\0"
  /* 10212 */ "PlacesEventCounts" "\0"
  /* 10230 */ "PlacesFavicon" "\0"
  /* 10244 */ "PlacesHistoryCleared" "\0"
  /* 10265 */ "PlacesObservers" "\0"
  /* 10281 */ "PlacesPurgeCaches" "\0"
  /* 10299 */ "PlacesRanking" "\0"
  /* 10313 */ "PlacesVisit" "\0"
  /* 10325 */ "PlacesVisitRemoved" "\0"
  /* 10344 */ "PlacesVisitTitle" "\0"
  /* 10361 */ "PlacesWeakCallbackWrapper" "\0"
  /* 10387 */ "Plugin" "\0"
  /* 10394 */ "PluginArray" "\0"
  /* 10406 */ "PluginCrashedEvent" "\0"
  /* 10425 */ "PointerEvent" "\0"
  /* 10438 */ "PopStateEvent" "\0"
  /* 10452 */ "PopupBlockedEvent" "\0"
  /* 10470 */ "PopupPositionedEvent" "\0"
  /* 10491 */ "PositionStateEvent" "\0"
  /* 10510 */ "PrecompiledScript" "\0"
  /* 10528 */ "PrivateAttribution" "\0"
  /* 10547 */ "ProcessMessageManager" "\0"
  /* 10569 */ "ProcessingInstruction" "\0"
  /* 10591 */ "ProgressEvent" "\0"
  /* 10605 */ "PromiseDebugging" "\0"
  /* 10622 */ "PromiseNativeHandler" "\0"
  /* 10643 */ "PromiseRejectionEvent" "\0"
  /* 10665 */ "PublicKeyCredential" "\0"
  /* 10685 */ "PushEvent" "\0"
  /* 10695 */ "PushManager" "\0"
  /* 10707 */ "PushManagerImpl" "\0"
  /* 10723 */ "PushMessageData" "\0"
  /* 10739 */ "PushSubscription" "\0"
  /* 10756 */ "PushSubscriptionOptions" "\0"
  /* 10780 */ "RTCCertificate" "\0"
  /* 10795 */ "RTCDTMFSender" "\0"
  /* 10809 */ "RTCDTMFToneChangeEvent" "\0"
  /* 10832 */ "RTCDataChannel" "\0"
  /* 10847 */ "RTCDataChannelEvent" "\0"
  /* 10867 */ "RTCDtlsTransport" "\0"
  /* 10884 */ "RTCEncodedAudioFrame" "\0"
  /* 10905 */ "RTCEncodedVideoFrame" "\0"
  /* 10926 */ "RTCIceCandidate" "\0"
  /* 10942 */ "RTCIceTransport" "\0"
  /* 10958 */ "RTCIdentityProviderRegistrar" "\0"
  /* 10987 */ "RTCPeerConnection" "\0"
  /* 11005 */ "RTCPeerConnectionIceEvent" "\0"
  /* 11031 */ "RTCPeerConnectionStatic" "\0"
  /* 11055 */ "RTCRtpReceiver" "\0"
  /* 11070 */ "RTCRtpScriptTransform" "\0"
  /* 11092 */ "RTCRtpScriptTransformer" "\0"
  /* 11116 */ "RTCRtpSender" "\0"
  /* 11129 */ "RTCRtpTransceiver" "\0"
  /* 11147 */ "RTCSctpTransport" "\0"
  /* 11164 */ "RTCSessionDescription" "\0"
  /* 11186 */ "RTCStatsReport" "\0"
  /* 11201 */ "RTCTrackEvent" "\0"
  /* 11215 */ "RTCTransformEvent" "\0"
  /* 11233 */ "RadioNodeList" "\0"
  /* 11247 */ "Range" "\0"
  /* 11253 */ "ReadableByteStreamController" "\0"
  /* 11282 */ "ReadableStream" "\0"
  /* 11297 */ "ReadableStream AsyncIterator" "\0"
  /* 11326 */ "ReadableStreamBYOBReader" "\0"
  /* 11351 */ "ReadableStreamBYOBRequest" "\0"
  /* 11377 */ "ReadableStreamDefaultController" "\0"
  /* 11409 */ "ReadableStreamDefaultReader" "\0"
  /* 11437 */ "Report" "\0"
  /* 11444 */ "ReportBody" "\0"
  /* 11455 */ "ReportingObserver" "\0"
  /* 11473 */ "Request" "\0"
  /* 11481 */ "ResizeObserver" "\0"
  /* 11496 */ "ResizeObserverEntry" "\0"
  /* 11516 */ "ResizeObserverSize" "\0"
  /* 11535 */ "Response" "\0"
  /* 11544 */ "SVGAElement" "\0"
  /* 11556 */ "SVGAngle" "\0"
  /* 11565 */ "SVGAnimateElement" "\0"
  /* 11583 */ "SVGAnimateMotionElement" "\0"
  /* 11607 */ "SVGAnimateTransformElement" "\0"
  /* 11634 */ "SVGAnimatedAngle" "\0"
  /* 11651 */ "SVGAnimatedBoolean" "\0"
  /* 11670 */ "SVGAnimatedEnumeration" "\0"
  /* 11693 */ "SVGAnimatedInteger" "\0"
  /* 11712 */ "SVGAnimatedLength" "\0"
  /* 11730 */ "SVGAnimatedLengthList" "\0"
  /* 11752 */ "SVGAnimatedNumber" "\0"
  /* 11770 */ "SVGAnimatedNumberList" "\0"
  /* 11792 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 11823 */ "SVGAnimatedRect" "\0"
  /* 11839 */ "SVGAnimatedString" "\0"
  /* 11857 */ "SVGAnimatedTransformList" "\0"
  /* 11882 */ "SVGAnimationElement" "\0"
  /* 11902 */ "SVGCircleElement" "\0"
  /* 11919 */ "SVGClipPathElement" "\0"
  /* 11938 */ "SVGComponentTransferFunctionElement" "\0"
  /* 11974 */ "SVGDefsElement" "\0"
  /* 11989 */ "SVGDescElement" "\0"
  /* 12004 */ "SVGElement" "\0"
  /* 12015 */ "SVGEllipseElement" "\0"
  /* 12033 */ "SVGFEBlendElement" "\0"
  /* 12051 */ "SVGFEColorMatrixElement" "\0"
  /* 12075 */ "SVGFEComponentTransferElement" "\0"
  /* 12105 */ "SVGFECompositeElement" "\0"
  /* 12127 */ "SVGFEConvolveMatrixElement" "\0"
  /* 12154 */ "SVGFEDiffuseLightingElement" "\0"
  /* 12182 */ "SVGFEDisplacementMapElement" "\0"
  /* 12210 */ "SVGFEDistantLightElement" "\0"
  /* 12235 */ "SVGFEDropShadowElement" "\0"
  /* 12258 */ "SVGFEFloodElement" "\0"
  /* 12276 */ "SVGFEFuncAElement" "\0"
  /* 12294 */ "SVGFEFuncBElement" "\0"
  /* 12312 */ "SVGFEFuncGElement" "\0"
  /* 12330 */ "SVGFEFuncRElement" "\0"
  /* 12348 */ "SVGFEGaussianBlurElement" "\0"
  /* 12373 */ "SVGFEImageElement" "\0"
  /* 12391 */ "SVGFEMergeElement" "\0"
  /* 12409 */ "SVGFEMergeNodeElement" "\0"
  /* 12431 */ "SVGFEMorphologyElement" "\0"
  /* 12454 */ "SVGFEOffsetElement" "\0"
  /* 12473 */ "SVGFEPointLightElement" "\0"
  /* 12496 */ "SVGFESpecularLightingElement" "\0"
  /* 12525 */ "SVGFESpotLightElement" "\0"
  /* 12547 */ "SVGFETileElement" "\0"
  /* 12564 */ "SVGFETurbulenceElement" "\0"
  /* 12587 */ "SVGFilterElement" "\0"
  /* 12604 */ "SVGForeignObjectElement" "\0"
  /* 12628 */ "SVGGElement" "\0"
  /* 12640 */ "SVGGeometryElement" "\0"
  /* 12659 */ "SVGGradientElement" "\0"
  /* 12678 */ "SVGGraphicsElement" "\0"
  /* 12697 */ "SVGImageElement" "\0"
  /* 12713 */ "SVGLength" "\0"
  /* 12723 */ "SVGLengthList" "\0"
  /* 12737 */ "SVGLineElement" "\0"
  /* 12752 */ "SVGLinearGradientElement" "\0"
  /* 12777 */ "SVGMPathElement" "\0"
  /* 12793 */ "SVGMarkerElement" "\0"
  /* 12810 */ "SVGMaskElement" "\0"
  /* 12825 */ "SVGMatrix" "\0"
  /* 12835 */ "SVGMetadataElement" "\0"
  /* 12854 */ "SVGNumber" "\0"
  /* 12864 */ "SVGNumberList" "\0"
  /* 12878 */ "SVGPathElement" "\0"
  /* 12893 */ "SVGPathSeg" "\0"
  /* 12904 */ "SVGPathSegArcAbs" "\0"
  /* 12921 */ "SVGPathSegArcRel" "\0"
  /* 12938 */ "SVGPathSegClosePath" "\0"
  /* 12958 */ "SVGPathSegCurvetoCubicAbs" "\0"
  /* 12984 */ "SVGPathSegCurvetoCubicRel" "\0"
  /* 13010 */ "SVGPathSegCurvetoCubicSmoothAbs" "\0"
  /* 13042 */ "SVGPathSegCurvetoCubicSmoothRel" "\0"
  /* 13074 */ "SVGPathSegCurvetoQuadraticAbs" "\0"
  /* 13104 */ "SVGPathSegCurvetoQuadraticRel" "\0"
  /* 13134 */ "SVGPathSegCurvetoQuadraticSmoothAbs" "\0"
  /* 13170 */ "SVGPathSegCurvetoQuadraticSmoothRel" "\0"
  /* 13206 */ "SVGPathSegLinetoAbs" "\0"
  /* 13226 */ "SVGPathSegLinetoHorizontalAbs" "\0"
  /* 13256 */ "SVGPathSegLinetoHorizontalRel" "\0"
  /* 13286 */ "SVGPathSegLinetoRel" "\0"
  /* 13306 */ "SVGPathSegLinetoVerticalAbs" "\0"
  /* 13334 */ "SVGPathSegLinetoVerticalRel" "\0"
  /* 13362 */ "SVGPathSegList" "\0"
  /* 13377 */ "SVGPathSegMovetoAbs" "\0"
  /* 13397 */ "SVGPathSegMovetoRel" "\0"
  /* 13417 */ "SVGPatternElement" "\0"
  /* 13435 */ "SVGPoint" "\0"
  /* 13444 */ "SVGPointList" "\0"
  /* 13457 */ "SVGPolygonElement" "\0"
  /* 13475 */ "SVGPolylineElement" "\0"
  /* 13494 */ "SVGPreserveAspectRatio" "\0"
  /* 13517 */ "SVGRadialGradientElement" "\0"
  /* 13542 */ "SVGRect" "\0"
  /* 13550 */ "SVGRectElement" "\0"
  /* 13565 */ "SVGSVGElement" "\0"
  /* 13579 */ "SVGScriptElement" "\0"
  /* 13596 */ "SVGSetElement" "\0"
  /* 13610 */ "SVGStopElement" "\0"
  /* 13625 */ "SVGStringList" "\0"
  /* 13639 */ "SVGStyleElement" "\0"
  /* 13655 */ "SVGSwitchElement" "\0"
  /* 13672 */ "SVGSymbolElement" "\0"
  /* 13689 */ "SVGTSpanElement" "\0"
  /* 13705 */ "SVGTextContentElement" "\0"
  /* 13727 */ "SVGTextElement" "\0"
  /* 13742 */ "SVGTextPathElement" "\0"
  /* 13761 */ "SVGTextPositioningElement" "\0"
  /* 13787 */ "SVGTitleElement" "\0"
  /* 13803 */ "SVGTransform" "\0"
  /* 13816 */ "SVGTransformList" "\0"
  /* 13833 */ "SVGUnitTypes" "\0"
  /* 13846 */ "SVGUseElement" "\0"
  /* 13860 */ "SVGViewElement" "\0"
  /* 13875 */ "Sanitizer" "\0"
  /* 13885 */ "Scheduler" "\0"
  /* 13895 */ "Screen" "\0"
  /* 13902 */ "ScreenLuminance" "\0"
  /* 13918 */ "ScreenOrientation" "\0"
  /* 13936 */ "ScriptProcessorNode" "\0"
  /* 13956 */ "ScrollAreaEvent" "\0"
  /* 13972 */ "ScrollViewChangeEvent" "\0"
  /* 13994 */ "SecurityPolicyViolationEvent" "\0"
  /* 14023 */ "Selection" "\0"
  /* 14033 */ "ServiceWorker" "\0"
  /* 14047 */ "ServiceWorkerContainer" "\0"
  /* 14070 */ "ServiceWorkerGlobalScope" "\0"
  /* 14095 */ "ServiceWorkerRegistration" "\0"
  /* 14121 */ "SessionStoreFormData" "\0"
  /* 14142 */ "SessionStoreScrollData" "\0"
  /* 14165 */ "SessionStoreUtils" "\0"
  /* 14183 */ "ShadowRealmGlobalScope" "\0"
  /* 14206 */ "ShadowRoot" "\0"
  /* 14217 */ "SharedWorker" "\0"
  /* 14230 */ "SharedWorkerGlobalScope" "\0"
  /* 14254 */ "SimpleGestureEvent" "\0"
  /* 14273 */ "SourceBuffer" "\0"
  /* 14286 */ "SourceBufferList" "\0"
  /* 14303 */ "SpeechGrammar" "\0"
  /* 14317 */ "SpeechGrammarList" "\0"
  /* 14335 */ "SpeechRecognition" "\0"
  /* 14353 */ "SpeechRecognitionAlternative" "\0"
  /* 14382 */ "SpeechRecognitionError" "\0"
  /* 14405 */ "SpeechRecognitionEvent" "\0"
  /* 14428 */ "SpeechRecognitionResult" "\0"
  /* 14452 */ "SpeechRecognitionResultList" "\0"
  /* 14480 */ "SpeechSynthesis" "\0"
  /* 14496 */ "SpeechSynthesisErrorEvent" "\0"
  /* 14522 */ "SpeechSynthesisEvent" "\0"
  /* 14543 */ "SpeechSynthesisUtterance" "\0"
  /* 14568 */ "SpeechSynthesisVoice" "\0"
  /* 14589 */ "StaticRange" "\0"
  /* 14601 */ "StereoPannerNode" "\0"
  /* 14618 */ "Storage" "\0"
  /* 14626 */ "StorageEvent" "\0"
  /* 14639 */ "StorageManager" "\0"
  /* 14654 */ "StreamFilter" "\0"
  /* 14667 */ "StreamFilterDataEvent" "\0"
  /* 14689 */ "StructuredCloneHolder" "\0"
  /* 14711 */ "StructuredCloneTester" "\0"
  /* 14733 */ "StyleSheet" "\0"
  /* 14744 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 14781 */ "StyleSheetList" "\0"
  /* 14796 */ "StyleSheetRemovedEvent" "\0"
  /* 14819 */ "SubmitEvent" "\0"
  /* 14831 */ "SubtleCrypto" "\0"
  /* 14844 */ "SyncMessageSender" "\0"
  /* 14862 */ "SyncReadFile" "\0"
  /* 14875 */ "TCPServerSocket" "\0"
  /* 14891 */ "TCPServerSocketEvent" "\0"
  /* 14912 */ "TCPSocket" "\0"
  /* 14922 */ "TCPSocketErrorEvent" "\0"
  /* 14942 */ "TCPSocketEvent" "\0"
  /* 14957 */ "TaskController" "\0"
  /* 14972 */ "TaskPriorityChangeEvent" "\0"
  /* 14996 */ "TaskSignal" "\0"
  /* 15007 */ "TelemetryStopwatch" "\0"
  /* 15026 */ "TestAttributesOnTypes" "\0"
  /* 15048 */ "TestCEReactionsInterface" "\0"
  /* 15073 */ "TestCImplementedInterface" "\0"
  /* 15099 */ "TestCImplementedInterface2" "\0"
  /* 15126 */ "TestCallbackDictUnionOverload" "\0"
  /* 15156 */ "TestChildInterface" "\0"
  /* 15175 */ "TestConstructorForFuncInterface" "\0"
  /* 15207 */ "TestConstructorForPrefInterface" "\0"
  /* 15239 */ "TestConstructorForSCInterface" "\0"
  /* 15269 */ "TestCppKeywordNamedMethodsInterface" "\0"
  /* 15305 */ "TestDeprecatedInterface" "\0"
  /* 15329 */ "TestExampleInterface" "\0"
  /* 15350 */ "TestExampleProxyInterface" "\0"
  /* 15376 */ "TestExampleThrowingConstructorInterface" "\0"
  /* 15416 */ "TestExampleWorkerInterface" "\0"
  /* 15443 */ "TestFuncConstructorForDifferentFuncInterface" "\0"
  /* 15488 */ "TestFuncConstructorForInterface" "\0"
  /* 15520 */ "TestHTMLConstructorInterface" "\0"
  /* 15549 */ "TestIndexedAndNamedGetterAndSetterInterface" "\0"
  /* 15593 */ "TestIndexedAndNamedGetterInterface" "\0"
  /* 15628 */ "TestIndexedAndNamedSetterInterface" "\0"
  /* 15663 */ "TestIndexedGetterAndSetterAndNamedGetterInterface" "\0"
  /* 15713 */ "TestIndexedGetterInterface" "\0"
  /* 15740 */ "TestIndexedSetterInterface" "\0"
  /* 15767 */ "TestInterface" "\0"
  /* 15781 */ "TestInterfaceWithPromiseConstructorArg" "\0"
  /* 15820 */ "TestJSImplInterface" "\0"
  /* 15840 */ "TestJSImplInterface2" "\0"
  /* 15861 */ "TestJSImplInterface3" "\0"
  /* 15882 */ "TestJSImplInterface4" "\0"
  /* 15903 */ "TestJSImplInterface5" "\0"
  /* 15924 */ "TestJSImplInterface6" "\0"
  /* 15945 */ "TestJSImplNoInterfaceObject" "\0"
  /* 15973 */ "TestLegacyFactoryFunctionInterface" "\0"
  /* 16008 */ "TestLegacyFactoryFunctionInterface2" "\0"
  /* 16044 */ "TestNamedDeleterInterface" "\0"
  /* 16070 */ "TestNamedDeleterWithRetvalInterface" "\0"
  /* 16106 */ "TestNamedGetterInterface" "\0"
  /* 16131 */ "TestNamedSetterInterface" "\0"
  /* 16156 */ "TestNamespace" "\0"
  /* 16170 */ "TestNonWrapperCacheInterface" "\0"
  /* 16199 */ "TestParentInterface" "\0"
  /* 16219 */ "TestPrefChromeOnlySCFuncConstructorForInterface" "\0"
  /* 16267 */ "TestPrefConstructorForDifferentPrefInterface" "\0"
  /* 16312 */ "TestPrefConstructorForInterface" "\0"
  /* 16344 */ "TestProtoObjectHackedNamespace" "\0"
  /* 16375 */ "TestRenamedInterface" "\0"
  /* 16396 */ "TestRenamedNamespace" "\0"
  /* 16417 */ "TestSCConstructorForInterface" "\0"
  /* 16447 */ "TestSecureContextInterface" "\0"
  /* 16474 */ "TestThrowingConstructorInterface" "\0"
  /* 16507 */ "TestUtils" "\0"
  /* 16517 */ "TestWorkerExposedInterface" "\0"
  /* 16544 */ "TestingDeprecatedInterface" "\0"
  /* 16571 */ "Text" "\0"
  /* 16576 */ "TextClause" "\0"
  /* 16587 */ "TextDecoder" "\0"
  /* 16599 */ "TextDecoderStream" "\0"
  /* 16617 */ "TextEncoder" "\0"
  /* 16629 */ "TextEncoderStream" "\0"
  /* 16647 */ "TextEvent" "\0"
  /* 16657 */ "TextMetrics" "\0"
  /* 16669 */ "TextTrack" "\0"
  /* 16679 */ "TextTrackCue" "\0"
  /* 16692 */ "TextTrackCueList" "\0"
  /* 16709 */ "TextTrackList" "\0"
  /* 16723 */ "TimeEvent" "\0"
  /* 16733 */ "TimeRanges" "\0"
  /* 16744 */ "ToggleEvent" "\0"
  /* 16756 */ "Touch" "\0"
  /* 16762 */ "TouchEvent" "\0"
  /* 16773 */ "TouchList" "\0"
  /* 16783 */ "TrackEvent" "\0"
  /* 16794 */ "TransformStream" "\0"
  /* 16810 */ "TransformStreamDefaultController" "\0"
  /* 16843 */ "TransitionEvent" "\0"
  /* 16859 */ "TreeColumn" "\0"
  /* 16870 */ "TreeColumns" "\0"
  /* 16882 */ "TreeContentView" "\0"
  /* 16898 */ "TreeWalker" "\0"
  /* 16909 */ "TrustedHTML" "\0"
  /* 16921 */ "TrustedScript" "\0"
  /* 16935 */ "TrustedScriptURL" "\0"
  /* 16952 */ "TrustedTypePolicy" "\0"
  /* 16970 */ "TrustedTypePolicyFactory" "\0"
  /* 16995 */ "UDPMessageEvent" "\0"
  /* 17011 */ "UDPSocket" "\0"
  /* 17021 */ "UIEvent" "\0"
  /* 17029 */ "URL" "\0"
  /* 17033 */ "URLSearchParams" "\0"
  /* 17049 */ "URLSearchParams Iterator" "\0"
  /* 17074 */ "UniFFIPointer" "\0"
  /* 17088 */ "UniFFIScaffolding" "\0"
  /* 17106 */ "UserActivation" "\0"
  /* 17121 */ "UserInteraction" "\0"
  /* 17137 */ "UserProximityEvent" "\0"
  /* 17156 */ "VRDisplay" "\0"
  /* 17166 */ "VRDisplayCapabilities" "\0"
  /* 17188 */ "VRDisplayEvent" "\0"
  /* 17203 */ "VREyeParameters" "\0"
  /* 17219 */ "VRFieldOfView" "\0"
  /* 17233 */ "VRFrameData" "\0"
  /* 17245 */ "VRMockController" "\0"
  /* 17262 */ "VRMockDisplay" "\0"
  /* 17276 */ "VRPose" "\0"
  /* 17283 */ "VRServiceTest" "\0"
  /* 17297 */ "VRStageParameters" "\0"
  /* 17315 */ "VTTCue" "\0"
  /* 17322 */ "VTTRegion" "\0"
  /* 17332 */ "ValidityState" "\0"
  /* 17346 */ "VideoColorSpace" "\0"
  /* 17362 */ "VideoDecoder" "\0"
  /* 17375 */ "VideoEncoder" "\0"
  /* 17388 */ "VideoFrame" "\0"
  /* 17399 */ "VideoPlaybackQuality" "\0"
  /* 17420 */ "VideoTrack" "\0"
  /* 17431 */ "VideoTrackList" "\0"
  /* 17446 */ "VisualViewport" "\0"
  /* 17461 */ "WEBGL_color_buffer_float" "\0"
  /* 17486 */ "WEBGL_compressed_texture_astc" "\0"
  /* 17516 */ "WEBGL_compressed_texture_etc" "\0"
  /* 17545 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 17575 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 17606 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 17636 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 17671 */ "WEBGL_debug_renderer_info" "\0"
  /* 17697 */ "WEBGL_debug_shaders" "\0"
  /* 17717 */ "WEBGL_depth_texture" "\0"
  /* 17737 */ "WEBGL_draw_buffers" "\0"
  /* 17756 */ "WEBGL_explicit_present" "\0"
  /* 17779 */ "WEBGL_lose_context" "\0"
  /* 17798 */ "WEBGL_provoking_vertex" "\0"
  /* 17821 */ "WakeLock" "\0"
  /* 17830 */ "WakeLockSentinel" "\0"
  /* 17847 */ "WaveShaperNode" "\0"
  /* 17862 */ "WebExtensionContentScript" "\0"
  /* 17888 */ "WebExtensionPolicy" "\0"
  /* 17907 */ "WebGL2RenderingContext" "\0"
  /* 17930 */ "WebGLActiveInfo" "\0"
  /* 17946 */ "WebGLBuffer" "\0"
  /* 17958 */ "WebGLContextEvent" "\0"
  /* 17976 */ "WebGLFramebuffer" "\0"
  /* 17993 */ "WebGLProgram" "\0"
  /* 18006 */ "WebGLQuery" "\0"
  /* 18017 */ "WebGLRenderbuffer" "\0"
  /* 18035 */ "WebGLRenderingContext" "\0"
  /* 18057 */ "WebGLSampler" "\0"
  /* 18070 */ "WebGLShader" "\0"
  /* 18082 */ "WebGLShaderPrecisionFormat" "\0"
  /* 18109 */ "WebGLSync" "\0"
  /* 18119 */ "WebGLTexture" "\0"
  /* 18132 */ "WebGLTransformFeedback" "\0"
  /* 18155 */ "WebGLUniformLocation" "\0"
  /* 18176 */ "WebGLVertexArrayObject" "\0"
  /* 18199 */ "WebKitCSSMatrix" "\0"
  /* 18215 */ "WebSocket" "\0"
  /* 18225 */ "WebTransport" "\0"
  /* 18238 */ "WebTransportBidirectionalStream" "\0"
  /* 18270 */ "WebTransportDatagramDuplexStream" "\0"
  /* 18303 */ "WebTransportError" "\0"
  /* 18321 */ "WebTransportReceiveStream" "\0"
  /* 18347 */ "WebTransportSendStream" "\0"
  /* 18370 */ "WebrtcGlobalInformation" "\0"
  /* 18394 */ "WheelEvent" "\0"
  /* 18405 */ "Window" "\0"
  /* 18412 */ "WindowClient" "\0"
  /* 18425 */ "WindowContext" "\0"
  /* 18439 */ "WindowGlobalChild" "\0"
  /* 18457 */ "WindowGlobalParent" "\0"
  /* 18476 */ "WindowRoot" "\0"
  /* 18487 */ "Worker" "\0"
  /* 18494 */ "WorkerDebuggerGlobalScope" "\0"
  /* 18520 */ "WorkerGlobalScope" "\0"
  /* 18538 */ "WorkerLocation" "\0"
  /* 18553 */ "WorkerNavigator" "\0"
  /* 18569 */ "WorkerTestUtils" "\0"
  /* 18585 */ "Worklet" "\0"
  /* 18593 */ "WorkletGlobalScope" "\0"
  /* 18612 */ "WritableStream" "\0"
  /* 18627 */ "WritableStreamDefaultController" "\0"
  /* 18659 */ "WritableStreamDefaultWriter" "\0"
  /* 18687 */ "XMLDocument" "\0"
  /* 18699 */ "XMLHttpRequest" "\0"
  /* 18714 */ "XMLHttpRequestEventTarget" "\0"
  /* 18740 */ "XMLHttpRequestUpload" "\0"
  /* 18761 */ "XMLSerializer" "\0"
  /* 18775 */ "XPathEvaluator" "\0"
  /* 18790 */ "XPathExpression" "\0"
  /* 18806 */ "XPathResult" "\0"
  /* 18818 */ "XRBoundedReferenceSpace" "\0"
  /* 18842 */ "XRFrame" "\0"
  /* 18850 */ "XRInputSource" "\0"
  /* 18864 */ "XRInputSourceArray" "\0"
  /* 18883 */ "XRInputSourceEvent" "\0"
  /* 18902 */ "XRInputSourcesChangeEvent" "\0"
  /* 18928 */ "XRPose" "\0"
  /* 18935 */ "XRReferenceSpace" "\0"
  /* 18952 */ "XRReferenceSpaceEvent" "\0"
  /* 18974 */ "XRRenderState" "\0"
  /* 18988 */ "XRRigidTransform" "\0"
  /* 19005 */ "XRSession" "\0"
  /* 19015 */ "XRSessionEvent" "\0"
  /* 19030 */ "XRSpace" "\0"
  /* 19038 */ "XRSystem" "\0"
  /* 19047 */ "XRView" "\0"
  /* 19054 */ "XRViewerPose" "\0"
  /* 19067 */ "XRViewport" "\0"
  /* 19078 */ "XRWebGLLayer" "\0"
  /* 19091 */ "XSLTProcessor" "\0"
  /* 19105 */ "XULCommandEvent" "\0"
  /* 19121 */ "XULElement" "\0"
  /* 19132 */ "XULFrameElement" "\0"
  /* 19148 */ "XULMenuElement" "\0"
  /* 19163 */ "XULPopupElement" "\0"
  /* 19179 */ "XULResizerElement" "\0"
  /* 19197 */ "XULTextElement" "\0"
  /* 19212 */ "XULTreeElement" "\0"
  /* 19227 */ "console" "\0"
  /* 19235 */ "webkitSpeechGrammar" "\0"
  /* 19255 */ "webkitSpeechGrammarList" "\0"
  /* 19279 */ "webkitSpeechRecognition" "\0"
  /* 19303 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

