//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PProfilerChild_h
#define PProfilerChild_h

#include "mozilla/PProfiler.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
namespace mozilla {
class TimeStamp;
} // namespace mozilla

namespace mozilla {
struct ProfileGenerationAdditionalInformation;
} // namespace mozilla

namespace mozilla {


class PProfilerChild :
    public mozilla::ipc::IToplevelProtocol
{
private:
public:
    static constexpr ::mozilla::ipc::ProtocolId kProtocolId = PProfilerMsgStart;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::mozilla::GatherProfileProgress GatherProfileProgress;
    typedef ::mozilla::IPCProfileAndAdditionalInformation IPCProfileAndAdditionalInformation;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef base::ProcessId ProcessId;
    typedef ::mozilla::ProfileBufferChunkManagerUpdate ProfileBufferChunkManagerUpdate;
    typedef ::mozilla::ProfileBufferChunkMetadata ProfileBufferChunkMetadata;
    typedef ::mozilla::ProfileGenerationAdditionalInformation ProfileGenerationAdditionalInformation;
    typedef ::mozilla::ProfilerInitParams ProfilerInitParams;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    typedef ::mozilla::TimeStamp TimeStamp;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

public:
    typedef std::function<void(const bool&)> StartResolver;
    typedef std::function<void(const bool&)> EnsureStartedResolver;
    typedef std::function<void(const bool&)> StopResolver;
    typedef std::function<void(const bool&)> PauseResolver;
    typedef std::function<void(const bool&)> ResumeResolver;
    typedef std::function<void(const bool&)> PauseSamplingResolver;
    typedef std::function<void(const bool&)> ResumeSamplingResolver;
    typedef std::function<void(const bool&)> WaitOnePeriodicSamplingResolver;
    typedef std::function<void(const ProfileBufferChunkManagerUpdate&)> AwaitNextChunkManagerUpdateResolver;
    typedef std::function<void(const IPCProfileAndAdditionalInformation&)> GatherProfileResolver;
    typedef std::function<void(const GatherProfileProgress&)> GetGatherProfileProgressResolver;

protected:
    virtual mozilla::ipc::IPCResult
    RecvStart(
            const ProfilerInitParams& params,
            StartResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnsureStarted(
            const ProfilerInitParams& params,
            EnsureStartedResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvStop(StopResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvPause(PauseResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvResume(ResumeResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvPauseSampling(PauseSamplingResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvResumeSampling(ResumeSamplingResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvWaitOnePeriodicSampling(WaitOnePeriodicSamplingResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAwaitNextChunkManagerUpdate(AwaitNextChunkManagerUpdateResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDestroyReleasedChunksAtOrBefore(const TimeStamp& timeStamp) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGatherProfile(GatherProfileResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetGatherProfileProgress(GetGatherProfileProgressResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvClearAllPages() = 0;
    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PProfilerChild();

    virtual ~PProfilerChild();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    mozilla::Span<mozilla::ipc::ProtocolId const>
    ManagedProtocolIds() const final;

    UntypedManagedContainer*
    GetManagedActors(mozilla::ipc::ProtocolId aProtocol) final;

    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
};


} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::PProfilerChild*>
{
    typedef ::mozilla::PProfilerChild* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PProfilerChild_h
