//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PRDDParent_h
#define PRDDParent_h

#include "mozilla/PRDD.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
class nsIFile;

// Headers for things that cannot be forward declared
#include "MediaCodecsSupport.h"
#include "gfxTelemetry.h"
#include "mozilla/TelemetryComms.h"
#include "mozilla/dom/NativeThreadId.h"
#include "mozilla/dom/ipc/IdType.h"
#include "mozilla/gfx/D3D11Checks.h"
#include "mozilla/gfx/Point.h"
#include "mozilla/gfx/Types.h"

namespace mozilla {
class PProfilerParent;
} // namespace mozilla
namespace mozilla {
class PProfilerChild;
} // namespace mozilla

namespace mozilla {
class PRemoteDecoderManagerParent;
} // namespace mozilla
namespace mozilla {
class PRemoteDecoderManagerChild;
} // namespace mozilla

namespace mozilla {
namespace layers {
class PVideoBridgeParent;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PVideoBridgeChild;
} // namespace layers
} // namespace mozilla

struct DxgiAdapterDesc;

namespace mozilla {
struct null_t;
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
struct null_t;
} // namespace mozilla

namespace mozilla {


class PRDDParent :
    public mozilla::ipc::IToplevelProtocol
{
private:
public:
    static constexpr ::mozilla::ipc::ProtocolId kProtocolId = PRDDMsgStart;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::gfx::BackendType BackendType;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::Telemetry::ChildEventData ChildEventData;
    typedef ::mozilla::gfx::ContentDeviceData ContentDeviceData;
    typedef ::mozilla::dom::ContentParentId ContentParentId;
    typedef ::mozilla::gfx::D3D11DeviceStatus D3D11DeviceStatus;
    typedef ::mozilla::gfx::DevicePrefs DevicePrefs;
    typedef ::mozilla::Telemetry::DiscardedData DiscardedData;
    typedef ::DxgiAdapterDesc DxgiAdapterDesc;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::gfx::FeatureFailure FeatureFailure;
    typedef ::mozilla::gfx::FeatureStatus FeatureStatus;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::mozilla::gfx::GPUDeviceData GPUDeviceData;
    typedef ::mozilla::gfx::GfxInfoFeatureStatus GfxInfoFeatureStatus;
    typedef ::mozilla::gfx::GfxVarUpdate GfxVarUpdate;
    typedef ::mozilla::gfx::GfxVarValue GfxVarValue;
    typedef ::mozilla::Telemetry::HistogramAccumulation HistogramAccumulation;
    typedef ::mozilla::gfx::IntSize IntSize;
    typedef ::mozilla::Telemetry::KeyedHistogramAccumulation KeyedHistogramAccumulation;
    typedef ::mozilla::Telemetry::KeyedScalarAction KeyedScalarAction;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::media::MediaCodecsSupported MediaCodecsSupported;
    typedef ::mozilla::dom::MemoryReport MemoryReport;
    typedef ::mozilla::dom::NativeThreadId NativeThreadId;
    typedef ::mozilla::PProfilerChild PProfilerChild;
    typedef ::mozilla::PProfilerParent PProfilerParent;
    typedef ::mozilla::PRemoteDecoderManagerChild PRemoteDecoderManagerChild;
    typedef ::mozilla::PRemoteDecoderManagerParent PRemoteDecoderManagerParent;
    typedef ::mozilla::layers::PVideoBridgeChild PVideoBridgeChild;
    typedef ::mozilla::layers::PVideoBridgeParent PVideoBridgeParent;
    typedef ::mozilla::dom::Pref Pref;
    typedef ::mozilla::dom::PrefValue PrefValue;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::Telemetry::ScalarAction ScalarAction;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::mozilla::gfx::D3D11Checks::VideoFormatOption VideoFormatOption;
    typedef ::mozilla::gfx::D3D11Checks::VideoFormatOptionSet VideoFormatOptionSet;
    typedef ::gfxImageFormat gfxImageFormat;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::mozilla::null_t null_t;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;
    typedef ::mozilla::void_t void_t;

public:
    typedef std::function<void(const uint32_t&)> RequestMemoryReportResolver;
    typedef std::function<void(ByteBuf&&)> FlushFOGDataResolver;
    typedef std::function<void(const bool&)> TestTriggerMetricsResolver;

protected:
    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PRDDParent();

    virtual ~PRDDParent();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    ::base::ProcessId
    OtherPid() const;

    mozilla::Span<mozilla::ipc::ProtocolId const>
    ManagedProtocolIds() const final;

    UntypedManagedContainer*
    GetManagedActors(mozilla::ipc::ProtocolId aProtocol) final;

    [[nodiscard]] bool
    SendInitCrashReporter(const NativeThreadId& threadId);

    [[nodiscard]] bool
    SendAddMemoryReport(const MemoryReport& aReport);

    [[nodiscard]] bool
    SendUpdateMediaCodecsSupported(const MediaCodecsSupported& aSupported);

    [[nodiscard]] bool
    SendAccumulateChildHistograms(mozilla::Span<HistogramAccumulation const> accumulations);

    [[nodiscard]] bool
    SendAccumulateChildKeyedHistograms(mozilla::Span<KeyedHistogramAccumulation const> accumulations);

    [[nodiscard]] bool
    SendUpdateChildScalars(mozilla::Span<ScalarAction const> actions);

    [[nodiscard]] bool
    SendUpdateChildKeyedScalars(mozilla::Span<KeyedScalarAction const> actions);

    [[nodiscard]] bool
    SendRecordChildEvents(mozilla::Span<ChildEventData const> events);

    [[nodiscard]] bool
    SendRecordDiscardedData(const DiscardedData& data);

    [[nodiscard]] bool
    SendFOGData(ByteBuf&& buf);

    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
};


} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::PRDDParent*>
{
    typedef ::mozilla::PRDDParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PRDDParent_h
