//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PDocAccessible_h
#define PDocAccessible_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/IPCForwards.h"
#include "mozilla/ipc/Shmem.h"

// Headers for typedefs
#include "mozilla/a11y/IPCTypes.h"
#include "mozilla/ipc/IPDLStructMember.h"
#include "mozilla/a11y/DocAccessibleTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct AccessibleData|
//
namespace mozilla {
namespace a11y {
class AccessibleData final
{
private:
    typedef ::uint64_t uint64_t;
    typedef ::mozilla::a11y::role role;
    typedef ::uint32_t uint32_t;
    typedef ::mozilla::a11y::AccType AccType;
    typedef ::mozilla::a11y::AccGenericType AccGenericType;
    typedef ::uint8_t uint8_t;
    typedef ::mozilla::a11y::AccAttributes AccAttributes;

public:
#ifdef __clang__
#  pragma clang diagnostic push
#  if __has_warning("-Wdefaulted-function-deleted")
#    pragma clang diagnostic ignored "-Wdefaulted-function-deleted"
#  endif
#endif
    AccessibleData() = default;
#ifdef __clang__
#  pragma clang diagnostic pop
#endif

    MOZ_IMPLICIT AccessibleData(
            const uint64_t& _ID,
            const role& _Role,
            const uint64_t& _ParentID,
            const uint32_t& _IndexInParent,
            const AccType& _Type,
            const AccGenericType& _GenericTypes,
            const uint8_t& _RoleMapEntryIndex,
            AccAttributes* _CacheFields) :
        Role_(_Role),
        Type_(_Type),
        GenericTypes_(_GenericTypes),
        CacheFields_(_CacheFields),
        ID_(_ID),
        ParentID_(_ParentID),
        IndexInParent_(_IndexInParent),
        RoleMapEntryIndex_(_RoleMapEntryIndex)
    {
    }

    MOZ_IMPLICIT AccessibleData(
            uint64_t&& _ID,
            role&& _Role,
            uint64_t&& _ParentID,
            uint32_t&& _IndexInParent,
            AccType&& _Type,
            AccGenericType&& _GenericTypes,
            uint8_t&& _RoleMapEntryIndex,
            RefPtr<AccAttributes>&& _CacheFields) :
        Role_(std::move(_Role)),
        Type_(std::move(_Type)),
        GenericTypes_(std::move(_GenericTypes)),
        CacheFields_(std::move(_CacheFields)),
        ID_(std::move(_ID)),
        ParentID_(std::move(_ParentID)),
        IndexInParent_(std::move(_IndexInParent)),
        RoleMapEntryIndex_(std::move(_RoleMapEntryIndex))
    {
    }

    uint64_t&
    ID()
    {
        return ID_;
    }
    const uint64_t&
    ID() const
    {
        return ID_;
    }

    role&
    Role()
    {
        return Role_;
    }
    const role&
    Role() const
    {
        return Role_;
    }

    uint64_t&
    ParentID()
    {
        return ParentID_;
    }
    const uint64_t&
    ParentID() const
    {
        return ParentID_;
    }

    uint32_t&
    IndexInParent()
    {
        return IndexInParent_;
    }
    const uint32_t&
    IndexInParent() const
    {
        return IndexInParent_;
    }

    AccType&
    Type()
    {
        return Type_;
    }
    const AccType&
    Type() const
    {
        return Type_;
    }

    AccGenericType&
    GenericTypes()
    {
        return GenericTypes_;
    }
    const AccGenericType&
    GenericTypes() const
    {
        return GenericTypes_;
    }

    uint8_t&
    RoleMapEntryIndex()
    {
        return RoleMapEntryIndex_;
    }
    const uint8_t&
    RoleMapEntryIndex() const
    {
        return RoleMapEntryIndex_;
    }

    RefPtr<AccAttributes>&
    CacheFields()
    {
        return CacheFields_;
    }
    AccAttributes*
    CacheFields() const
    {
        return CacheFields_;
    }

private:
    void
    StaticAssertions() const;
    ::mozilla::ipc::IPDLStructMember<role> Role_;
    ::mozilla::ipc::IPDLStructMember<AccType> Type_;
    ::mozilla::ipc::IPDLStructMember<AccGenericType> GenericTypes_;
    ::mozilla::ipc::IPDLStructMember<RefPtr<AccAttributes>> CacheFields_;
    ::mozilla::ipc::IPDLStructMember<uint64_t> ID_;
    ::mozilla::ipc::IPDLStructMember<uint64_t> ParentID_;
    ::mozilla::ipc::IPDLStructMember<uint32_t> IndexInParent_;
    ::mozilla::ipc::IPDLStructMember<uint8_t> RoleMapEntryIndex_;
};
} // namespace a11y
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <::mozilla::a11y::AccessibleData>
{
    typedef ::mozilla::a11y::AccessibleData paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TextRangeData|
//
namespace mozilla {
namespace a11y {
class TextRangeData final
{
private:
    typedef ::uint64_t uint64_t;
    typedef ::int32_t int32_t;

public:
#ifdef __clang__
#  pragma clang diagnostic push
#  if __has_warning("-Wdefaulted-function-deleted")
#    pragma clang diagnostic ignored "-Wdefaulted-function-deleted"
#  endif
#endif
    TextRangeData() = default;
#ifdef __clang__
#  pragma clang diagnostic pop
#endif

    MOZ_IMPLICIT TextRangeData(
            const uint64_t& _StartID,
            const uint64_t& _EndID,
            const int32_t& _StartOffset,
            const int32_t& _EndOffset) :
        StartID_(_StartID),
        EndID_(_EndID),
        StartOffset_(_StartOffset),
        EndOffset_(_EndOffset)
    {
    }

    MOZ_IMPLICIT TextRangeData(
            uint64_t&& _StartID,
            uint64_t&& _EndID,
            int32_t&& _StartOffset,
            int32_t&& _EndOffset) :
        StartID_(std::move(_StartID)),
        EndID_(std::move(_EndID)),
        StartOffset_(std::move(_StartOffset)),
        EndOffset_(std::move(_EndOffset))
    {
    }

    uint64_t&
    StartID()
    {
        return StartID_;
    }
    const uint64_t&
    StartID() const
    {
        return StartID_;
    }

    uint64_t&
    EndID()
    {
        return EndID_;
    }
    const uint64_t&
    EndID() const
    {
        return EndID_;
    }

    int32_t&
    StartOffset()
    {
        return StartOffset_;
    }
    const int32_t&
    StartOffset() const
    {
        return StartOffset_;
    }

    int32_t&
    EndOffset()
    {
        return EndOffset_;
    }
    const int32_t&
    EndOffset() const
    {
        return EndOffset_;
    }

private:
    void
    StaticAssertions() const;
    ::mozilla::ipc::IPDLStructMember<uint64_t> StartID_;
    ::mozilla::ipc::IPDLStructMember<uint64_t> EndID_;
    ::mozilla::ipc::IPDLStructMember<int32_t> StartOffset_;
    ::mozilla::ipc::IPDLStructMember<int32_t> EndOffset_;
};
} // namespace a11y
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <::mozilla::a11y::TextRangeData>
{
    typedef ::mozilla::a11y::TextRangeData paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

namespace mozilla {
namespace a11y {
class PDocAccessibleParent;
} // namespace a11y
} // namespace mozilla
namespace mozilla {
namespace a11y {
class PDocAccessibleChild;
} // namespace a11y
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PDocAccessibleChild and PDocAccessibleParent
//
namespace mozilla {
namespace a11y {
namespace PDocAccessible {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<::mozilla::a11y::PDocAccessibleParent>* aParent,
        mozilla::ipc::Endpoint<::mozilla::a11y::PDocAccessibleChild>* aChild);

enum MessageType {
    PDocAccessibleStart = PDocAccessibleMsgStart << 16,
    Msg_Shutdown__ID,
    Msg_Event__ID,
    Msg_ShowEvent__ID,
    Msg_HideEvent__ID,
    Msg_StateChangeEvent__ID,
    Msg_CaretMoveEvent__ID,
    Msg_TextChangeEvent__ID,
    Msg_SelectionEvent__ID,
    Msg_RoleChangedEvent__ID,
    Msg_FocusEvent__ID,
    Msg_ScrollingEvent__ID,
    Msg_AnnouncementEvent__ID,
    Msg_TextSelectionChangeEvent__ID,
    Msg_BindChildDoc__ID,
    Msg_Cache__ID,
    Msg_SelectedAccessiblesChanged__ID,
    Msg_AccessiblesWillMove__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_RestoreFocus__ID,
    Msg_ScrollTo__ID,
    Msg_ScrollToPoint__ID,
    Msg_Announce__ID,
    Msg_SetCaretOffset__ID,
    Msg_SetTextSelection__ID,
    Msg_RemoveTextSelection__ID,
    Msg_ScrollTextLeafRangeIntoView__ID,
    Msg_ScrollSubstringToPoint__ID,
    Msg_ReplaceText__ID,
    Msg_InsertText__ID,
    Msg_CopyText__ID,
    Msg_CutText__ID,
    Msg_DeleteText__ID,
    Msg_PasteText__ID,
    Msg_TakeSelection__ID,
    Msg_SetSelected__ID,
    Msg_DoActionAsync__ID,
    Msg_SetCurValue__ID,
    Msg_TakeFocus__ID,
    Msg_VerifyCache__ID,
    PDocAccessibleEnd
};

mozilla::UniquePtr<IPC::Message>
Msg_Shutdown(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_Event(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_ShowEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_HideEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_StateChangeEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_CaretMoveEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_TextChangeEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_SelectionEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RoleChangedEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_FocusEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_ScrollingEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_AnnouncementEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_TextSelectionChangeEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_BindChildDoc(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_Cache(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_SelectedAccessiblesChanged(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_AccessiblesWillMove(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg___delete__(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply___delete__(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RestoreFocus(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_ScrollTo(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_ScrollToPoint(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_Announce(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_SetCaretOffset(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_SetTextSelection(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RemoveTextSelection(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_ScrollTextLeafRangeIntoView(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_ScrollSubstringToPoint(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_ReplaceText(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_InsertText(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_CopyText(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_CutText(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_DeleteText(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_PasteText(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_TakeSelection(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_SetSelected(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_DoActionAsync(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_SetCurValue(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_TakeFocus(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_VerifyCache(int32_t routingId);



} // namespace PDocAccessible
} // namespace a11y
} // namespace mozilla

#endif // ifndef PDocAccessible_h
