//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMediaTransportParent_h
#define PMediaTransportParent_h

#include "mozilla/dom/PMediaTransport.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
class nsIFile;

// Headers for things that cannot be forward declared
#include "mozilla/dom/RTCConfigurationBinding.h"
#include "mozilla/dom/ipc/IdType.h"
#include "mozilla/media/webrtc/WebrtcGlobal.h"
#include "mozilla/media/webrtc/WebrtcIPCTraits.h"
#include "mozilla/net/PStunAddrsParams.h"
#include "string"
#include "transport/mediapacket.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
struct RTCStatsCollection;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PMediaTransportParent :
    public mozilla::ipc::IToplevelProtocol
{
private:
public:
    static constexpr ::mozilla::ipc::ProtocolId kProtocolId = PMediaTransportMsgStart;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::CandidateInfo CandidateInfo;
    typedef ::mozilla::DtlsDigestList DtlsDigestList;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::MediaPacket MediaPacket;
    typedef ::mozilla::net::NrIceStunAddrArray NrIceStunAddrArray;
    typedef ::mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef ::mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef ::mozilla::dom::RTCIceServer RTCIceServer;
    typedef ::mozilla::dom::RTCIceTransportPolicy RTCIceTransportPolicy;
    typedef ::mozilla::dom::RTCStatsCollection RTCStatsCollection;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    typedef ::mozilla::StringVector StringVector;
    typedef ::mozilla::dom::TabId TabId;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::WebrtcGlobalLog WebrtcGlobalLog;
    typedef ::mozilla::net::WebrtcProxyConfig WebrtcProxyConfig;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::std::string string;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

public:
    typedef std::function<void(const WebrtcGlobalLog&)> GetIceLogResolver;
    typedef std::function<void(const UniquePtr<RTCStatsCollection>&)> GetIceStatsResolver;

protected:
    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PMediaTransportParent();

    virtual ~PMediaTransportParent();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    mozilla::Span<mozilla::ipc::ProtocolId const>
    ManagedProtocolIds() const final;

    UntypedManagedContainer*
    GetManagedActors(mozilla::ipc::ProtocolId aProtocol) final;

    [[nodiscard]] bool
    SendOnCandidate(
            const string& transportId,
            const CandidateInfo& candidateInfo);

    [[nodiscard]] bool
    SendOnAlpnNegotiated(const string& alpn);

    [[nodiscard]] bool
    SendOnGatheringStateChange(
            const string& transportId,
            const int& state);

    [[nodiscard]] bool
    SendOnConnectionStateChange(
            const string& transportId,
            const int& state);

    [[nodiscard]] bool
    SendOnPacketReceived(
            const string& transportId,
            const MediaPacket& packet);

    [[nodiscard]] bool
    SendOnEncryptedSending(
            const string& transportId,
            const MediaPacket& packet);

    [[nodiscard]] bool
    SendOnStateChange(
            const string& transportId,
            const int& state);

    [[nodiscard]] bool
    SendOnRtcpStateChange(
            const string& transportId,
            const int& state);

    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
};


} // namespace dom
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::dom::PMediaTransportParent*>
{
    typedef ::mozilla::dom::PMediaTransportParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PMediaTransportParent_h
