//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PServiceWorkerRegistrationChild_h
#define PServiceWorkerRegistrationChild_h

#include "mozilla/dom/PServiceWorkerRegistration.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/ServiceWorkerRegistrationBinding.h"

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PServiceWorkerRegistrationChild :
    public mozilla::ipc::IRefCountedProtocol
{
private:
    friend class ::mozilla::ipc::PBackgroundChild;
public:
    static constexpr ::mozilla::ipc::ProtocolId kProtocolId = PServiceWorkerRegistrationMsgStart;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::CopyableErrorResult CopyableErrorResult;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::mozilla::dom::IPCNavigationPreloadState IPCNavigationPreloadState;
    typedef ::mozilla::dom::IPCServiceWorkerRegistrationDescriptor IPCServiceWorkerRegistrationDescriptor;
    typedef ::mozilla::dom::IPCServiceWorkerRegistrationDescriptorList IPCServiceWorkerRegistrationDescriptorList;
    typedef ::mozilla::dom::IPCServiceWorkerRegistrationDescriptorListOrCopyableErrorResult IPCServiceWorkerRegistrationDescriptorListOrCopyableErrorResult;
    typedef ::mozilla::dom::IPCServiceWorkerRegistrationDescriptorOrCopyableErrorResult IPCServiceWorkerRegistrationDescriptorOrCopyableErrorResult;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef ::mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::dom::ServiceWorkerUpdateViaCache ServiceWorkerUpdateViaCache;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

public:
    typedef MozPromise<std::tuple<bool, CopyableErrorResult>, ResponseRejectReason, true> UnregisterPromise;
    typedef MozPromise<IPCServiceWorkerRegistrationDescriptorOrCopyableErrorResult, ResponseRejectReason, true> UpdatePromise;
    typedef MozPromise<bool, ResponseRejectReason, true> SetNavigationPreloadEnabledPromise;
    typedef MozPromise<bool, ResponseRejectReason, true> SetNavigationPreloadHeaderPromise;
    typedef MozPromise<mozilla::Maybe<IPCNavigationPreloadState>, ResponseRejectReason, true> GetNavigationPreloadStatePromise;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
    virtual mozilla::ipc::IPCResult
    RecvUpdateState(const IPCServiceWorkerRegistrationDescriptor& aDescriptor) = 0;
    virtual mozilla::ipc::IPCResult
    RecvFireUpdateFound() = 0;
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PServiceWorkerRegistrationChild();

    virtual ~PServiceWorkerRegistrationChild();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    ::base::ProcessId
    OtherPid() const;

    PBackgroundChild*
    Manager() const;

    mozilla::Span<mozilla::ipc::ProtocolId const>
    ManagedProtocolIds() const final;

    UntypedManagedContainer*
    GetManagedActors(mozilla::ipc::ProtocolId aProtocol) final;

    bool
    SendTeardown();

    void
    SendUnregister(
            mozilla::ipc::ResolveCallback<std::tuple<bool, CopyableErrorResult>>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<UnregisterPromise>
    SendUnregister();

    void
    SendUpdate(
            const nsACString& aNewestWorkerScriptUrl,
            mozilla::ipc::ResolveCallback<IPCServiceWorkerRegistrationDescriptorOrCopyableErrorResult>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<UpdatePromise>
    SendUpdate(const nsACString& aNewestWorkerScriptUrl);

    void
    SendSetNavigationPreloadEnabled(
            const bool& aEnabled,
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<SetNavigationPreloadEnabledPromise>
    SendSetNavigationPreloadEnabled(const bool& aEnabled);

    void
    SendSetNavigationPreloadHeader(
            const nsACString& aHeader,
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<SetNavigationPreloadHeaderPromise>
    SendSetNavigationPreloadHeader(const nsACString& aHeader);

    void
    SendGetNavigationPreloadState(
            mozilla::ipc::ResolveCallback<mozilla::Maybe<IPCNavigationPreloadState>>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<GetNavigationPreloadStatePromise>
    SendGetNavigationPreloadState();

    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
    bool mAwaitingManagedEndpointBind = false;

};


} // namespace dom
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::dom::PServiceWorkerRegistrationChild*>
{
    typedef ::mozilla::dom::PServiceWorkerRegistrationChild* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PServiceWorkerRegistrationChild_h
