//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPServiceParent_h
#define PGMPServiceParent_h

#include "mozilla/gmp/PGMPService.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
class nsIFile;

// Headers for things that cannot be forward declared
#include "GMPNativeTypes.h"
#include "GMPSanitizedExports.h"
#include "base/process.h"
#include "gmp-video-codec.h"

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPServiceParent :
    public mozilla::ipc::IToplevelProtocol
{
private:
public:
    static constexpr ::mozilla::ipc::ProtocolId kProtocolId = PGMPServiceMsgStart;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef ::mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef ::mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef ::mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef ::mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    typedef ::cdm::EncryptionScheme EncryptionScheme;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::GMPBufferType GMPBufferType;
    typedef ::mozilla::gmp::GMPLaunchResult GMPLaunchResult;
    typedef ::mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef ::GMPPluginType GMPPluginType;
    typedef ::mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef ::mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::gmp::NodeIdParts NodeIdParts;
    typedef ::mozilla::gmp::NodeIdVariant NodeIdVariant;
    typedef ::mozilla::gmp::PGMPContentChild PGMPContentChild;
    typedef ::mozilla::gmp::PGMPContentParent PGMPContentParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

public:
    typedef std::function<void(GMPLaunchResult&&)> LaunchGMPResolver;
    typedef std::function<void(const nsACString&)> GetGMPNodeIdResolver;

protected:
    virtual mozilla::ipc::IPCResult
    RecvLaunchGMP(
            const NodeIdVariant& nodeIdVariant,
            const nsACString& api,
            nsTArray<nsCString>&& tags,
            nsTArray<ProcessId>&& alreadyBridgedTo,
            LaunchGMPResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetGMPNodeId(
            const nsAString& origin,
            const nsAString& topLevelOrigin,
            const nsAString& gmpName,
            GetGMPNodeIdResolver&& aResolve) = 0;
    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPServiceParent();

    virtual ~PGMPServiceParent();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    ::base::ProcessId
    OtherPid() const;

    mozilla::Span<mozilla::ipc::ProtocolId const>
    ManagedProtocolIds() const final;

    UntypedManagedContainer*
    GetManagedActors(mozilla::ipc::ProtocolId aProtocol) final;

    [[nodiscard]] bool
    SendBeginShutdown();

    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
};


} // namespace gmp
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::gmp::PGMPServiceParent*>
{
    typedef ::mozilla::gmp::PGMPServiceParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PGMPServiceParent_h
