//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPStorageParent_h
#define PGMPStorageParent_h

#include "mozilla/gmp/PGMPStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "GMPSanitizedExports.h"
#include "gmp-errors.h"
#include "gmp-video-codec.h"

namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPStorageParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class ::mozilla::gmp::PGMPParent;
public:
    static constexpr ::mozilla::ipc::ProtocolId kProtocolId = PGMPStorageMsgStart;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef ::mozilla::ipc::ByteBuf ByteBuf;
    typedef ::mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef ::mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef ::mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef ::mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef ::mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    typedef ::cdm::EncryptionScheme EncryptionScheme;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef ::mozilla::ipc::FileDescriptor FileDescriptor;
    typedef ::GMPBufferType GMPBufferType;
    typedef ::GMPErr GMPErr;
    typedef ::mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef ::mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef ::mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef ::mozilla::gmp::NodeIdParts NodeIdParts;
    typedef ::mozilla::gmp::NodeIdVariant NodeIdVariant;
    typedef ::mozilla::gmp::PGMPChild PGMPChild;
    typedef ::mozilla::gmp::PGMPParent PGMPParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef ::mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef ::int16_t int16_t;
    typedef ::int32_t int32_t;
    typedef ::int64_t int64_t;
    typedef ::int8_t int8_t;
    typedef ::intptr_t intptr_t;
    typedef ::nsCString nsCString;
    typedef ::nsString nsString;
    typedef ::nsresult nsresult;
    typedef ::uint16_t uint16_t;
    typedef ::uint32_t uint32_t;
    typedef ::uint64_t uint64_t;
    typedef ::uint8_t uint8_t;
    typedef ::uintptr_t uintptr_t;

protected:
    virtual mozilla::ipc::IPCResult
    RecvOpen(const nsACString& aRecordName) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRead(const nsACString& aRecordName) = 0;
    virtual mozilla::ipc::IPCResult
    RecvWrite(
            const nsACString& aRecordName,
            nsTArray<uint8_t>&& aBytes) = 0;
    virtual mozilla::ipc::IPCResult
    RecvClose(const nsACString& aRecordName) = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPStorageParent();

    virtual ~PGMPStorageParent();

protected:
    void
    ActorAlloc() final;
    void
    ActorDealloc() final;
public:
    ::base::ProcessId
    OtherPid() const;

    PGMPParent*
    Manager() const;

    mozilla::Span<mozilla::ipc::ProtocolId const>
    ManagedProtocolIds() const final;

    UntypedManagedContainer*
    GetManagedActors(mozilla::ipc::ProtocolId aProtocol) final;

    [[nodiscard]] bool
    SendOpenComplete(
            const nsACString& aRecordName,
            const GMPErr& aStatus);

    [[nodiscard]] bool
    SendReadComplete(
            const nsACString& aRecordName,
            const GMPErr& aStatus,
            mozilla::Span<uint8_t const> aBytes);

    [[nodiscard]] bool
    SendWriteComplete(
            const nsACString& aRecordName,
            const GMPErr& aStatus);

    [[nodiscard]] bool
    SendShutdown();

    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
    bool mAwaitingManagedEndpointBind = false;

};


} // namespace gmp
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <::mozilla::gmp::PGMPStorageParent*>
{
    typedef ::mozilla::gmp::PGMPStorageParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static IPC::ReadResult<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef PGMPStorageParent_h
