// -*- mode: Rust -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */


pub enum DynamicLabel { }

pub mod privacy_sanitize {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClearExtra {
        pub cache: Option<bool>,
        pub context: Option<String>,
        pub cookies_and_storage: Option<bool>,
        pub history_form_data_downloads: Option<bool>,
        pub site_settings: Option<bool>,
    }

    impl ExtraKeys for ClearExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cache", "context", "cookies_and_storage", "history_form_data_downloads", "site_settings"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.cache.and_then(|val| map.insert("cache".into(), val.to_string()));
          self.context.and_then(|val| map.insert("context".into(), val.to_string()));
          self.cookies_and_storage.and_then(|val| map.insert("cookies_and_storage".into(), val.to_string()));
          self.history_form_data_downloads.and_then(|val| map.insert("history_form_data_downloads".into(), val.to_string()));
          self.site_settings.and_then(|val| map.insert("site_settings".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.sanitize.clear
    ///
    /// Dispatched when the dialog is accepted (to clear)
    pub static clear: Lazy<EventMetric<ClearExtra>> = Lazy::new(|| {
        EventMetric::new(1.into(), CommonMetricData {
            name: "clear".into(),
            category: "privacy.sanitize".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClearingTimeSpanSelectedExtra {
        pub time_span: Option<String>,
    }

    impl ExtraKeys for ClearingTimeSpanSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["time_span"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.time_span.and_then(|val| map.insert("time_span".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.sanitize.clearing_time_span_selected
    ///
    /// The time span range selected to sanitize
    pub static clearing_time_span_selected: Lazy<EventMetric<ClearingTimeSpanSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(2.into(), CommonMetricData {
            name: "clearing_time_span_selected".into(),
            category: "privacy.sanitize".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct DialogOpenExtra {
        pub context: Option<String>,
    }

    impl ExtraKeys for DialogOpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["context"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.context.and_then(|val| map.insert("context".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.sanitize.dialog_open
    ///
    /// Dispatched when one of the sanitize dialogs opens
    pub static dialog_open: Lazy<EventMetric<DialogOpenExtra>> = Lazy::new(|| {
        EventMetric::new(3.into(), CommonMetricData {
            name: "dialog_open".into(),
            category: "privacy.sanitize".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from privacy.sanitize.load_time
    ///
    /// How much time was spent to open the dialog, including loading data sizes
    pub static load_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(4.into(), CommonMetricData {
            name: "load_time".into(),
            category: "privacy.sanitize".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod browser_backup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.browser_extension_data_size
    ///
    /// The total size of the current profiles storage.local legacy JSON backend in the
    /// browser-extension-data directory, rounded to the nearest 10 kilobytes.
    pub static browser_extension_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(5.into(), CommonMetricData {
            name: "browser_extension_data_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.cookies_size
    ///
    /// The total file size of the cookies.sqlite db located in the current profile
    /// directory, in kilobytes.
    pub static cookies_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(6.into(), CommonMetricData {
            name: "cookies_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.credentials_data_size
    ///
    /// The total size of logins, payment method, and form autofill related files in
    /// the current profile directory, in kilobytes.
    pub static credentials_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(7.into(), CommonMetricData {
            name: "credentials_data_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extension_store_permissions_data_size
    ///
    /// The file size of the current profiles extension-store-permissions/data.safe.bin
    /// file, rounded to the nearest 10 kilobytes.
    pub static extension_store_permissions_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(8.into(), CommonMetricData {
            name: "extension_store_permissions_data_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extensions_json_size
    ///
    /// The total file size of the current profiles extensions metadata files, rounded
    /// to the nearest 10 kilobytes. Files included are:
    ///   - extensions.json
    ///   - extension-settings.json
    ///   - extension-preferences.json
    ///   - addonStartup.json.lz4
    pub static extensions_json_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(9.into(), CommonMetricData {
            name: "extensions_json_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extensions_storage_size
    ///
    /// The total size of all extensions storage directories, rounded to the nearest 10
    /// kilobytes.
    pub static extensions_storage_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(10.into(), CommonMetricData {
            name: "extensions_storage_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extensions_xpi_directory_size
    ///
    /// The total size of the current profiles extensions directory, rounded to the
    /// nearest 10 kilobytes.
    pub static extensions_xpi_directory_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(11.into(), CommonMetricData {
            name: "extensions_xpi_directory_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.favicons_size
    ///
    /// The total file size of the favicons.sqlite db located in the current profile
    /// directory, in kilobytes.
    pub static favicons_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(12.into(), CommonMetricData {
            name: "favicons_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.form_history_size
    ///
    /// The file size of the formhistory.sqlite db located in the current profile
    /// directory, in kilobytes.
    pub static form_history_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(13.into(), CommonMetricData {
            name: "form_history_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.misc_data_size
    ///
    /// The total size of files for telemetry, site storage, media device origin
    /// mapping, chrome privileged IndexedDB databases, and Mozilla Accounts in the
    /// current profile directory, rounded to the nearest tenth kilobyte.
    pub static misc_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(14.into(), CommonMetricData {
            name: "misc_data_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.places_size
    ///
    /// The total file size of the places.sqlite db located in the current profile
    /// directory, in kilobytes.
    pub static places_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(15.into(), CommonMetricData {
            name: "places_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.preferences_size
    ///
    /// The total size of files relating to user preferences and permissions in the
    /// current profile directory, in kilobytes.
    pub static preferences_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(16.into(), CommonMetricData {
            name: "preferences_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.prof_d_disk_space
    ///
    /// The total disk space available on the storage device that the profile directory
    /// is stored on. To reduce fingerprintability, we round to the nearest 10
    /// megabytes and return the result in kilobytes.
    pub static prof_d_disk_space: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(17.into(), CommonMetricData {
            name: "prof_d_disk_space".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.security_data_size
    ///
    /// The total size of files needed for NSS initialization parameters and security
    /// certificate settings in the current profile directory, in kilobytes.
    pub static security_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(18.into(), CommonMetricData {
            name: "security_data_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.session_store_backups_directory_size
    ///
    /// The total size of the session store backups directory, in kilobytes.
    pub static session_store_backups_directory_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(19.into(), CommonMetricData {
            name: "session_store_backups_directory_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.session_store_size
    ///
    /// The size of uncompressed session store json, in kilobytes.
    pub static session_store_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(20.into(), CommonMetricData {
            name: "session_store_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.storage_sync_size
    ///
    /// The file size of the current profiles storage-sync-v2.sqlite db, rounded to the
    /// nearest 10 kilobytes.
    pub static storage_sync_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(21.into(), CommonMetricData {
            name: "storage_sync_size".into(),
            category: "browser.backup".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod background_update {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_update.reasons_to_not_update
    ///
    /// Records which error was causing the background updater to fail. This list
    /// supercedes the `background-update.reason` in `mozapps/update/metrics.yaml`
    pub static reasons_to_not_update: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(22.into(), CommonMetricData {
            name: "reasons_to_not_update".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into(), "metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.time_last_update_scheduled
    ///
    /// Last time the background update was triggered.
    pub static time_last_update_scheduled: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(23.into(), CommonMetricData {
            name: "time_last_update_scheduled".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into(), "metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.automatic_restart_attempted
    ///
    /// True if the background update task successfully attempted an automatic restart.
    pub static automatic_restart_attempted: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(24.into(), CommonMetricData {
            name: "automatic_restart_attempted".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.automatic_restart_success
    ///
    /// True if the background update task successfully restarted after an automatic
    /// restart.
    pub static automatic_restart_success: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(25.into(), CommonMetricData {
            name: "automatic_restart_success".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.client_id
    ///
    /// The legacy Telemetry client ID of this installation's default profile.
    /// The default profile is as determined by the Profile Service, namely
    /// `nsIToolkitProfileService.defaultProfile`.  The majority of users have only one
    /// Firefox installation and only one profile, so the default profile is their
    /// regular browsing profile.
    /// It is possible for a Firefox installation to not have a default profile, but in
    /// such cases the background update task will abort before sending any telemetry;
    /// therefore, the legacy Telemetry client ID should always be present.
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(26.into(), CommonMetricData {
            name: "client_id".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into(), "baseline".into(), "events".into(), "metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.exit_code_exception
    ///
    /// True if the exit code/status of the background update task is 3, which means an
    /// exception was thrown.
    pub static exit_code_exception: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(27.into(), CommonMetricData {
            name: "exit_code_exception".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.exit_code_success
    ///
    /// True if the exit code/status of the background update task is 0, which means
    /// success.
    pub static exit_code_success: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(28.into(), CommonMetricData {
            name: "exit_code_success".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.final_state
    ///
    /// String description of the final state the update state machine reached.
    pub static final_state: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(29.into(), CommonMetricData {
            name: "final_state".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.reasons
    ///
    /// List of reasons that the background update task did not run.
    pub static reasons: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(30.into(), CommonMetricData {
            name: "reasons".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.states
    ///
    /// Ordered list of string descriptions of the states that the update state machine
    /// reached.
    pub static states: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(31.into(), CommonMetricData {
            name: "states".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_current_date
    ///
    /// The `environment.currentDate` of the default profile's serialized targeting
    /// snapshot.
    pub static targeting_env_current_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(32.into(), CommonMetricData {
            name: "targeting_env_current_date".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_firefox_version
    ///
    /// The `environment.firefoxVersion` of the default profile's serialized targeting
    /// snapshot.  At the time of writing, this version is an integer representing the
    /// Firefox major version, e.g., `109`.
    pub static targeting_env_firefox_version: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(33.into(), CommonMetricData {
            name: "targeting_env_firefox_version".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_profile_age
    ///
    /// The `environment.profileAgeCreated` of the default profile's serialized
    /// targeting snapshot.
    pub static targeting_env_profile_age: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(34.into(), CommonMetricData {
            name: "targeting_env_profile_age".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_exception
    ///
    /// True if the default profile had a targeting snapshot serialized to disk, but an
    /// exception was thrown reading it.
    pub static targeting_exception: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(35.into(), CommonMetricData {
            name: "targeting_exception".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_exists
    ///
    /// True if the default profile had a targeting snapshot serialized to disk, and
    /// there was no exception thrown reading it.
    pub static targeting_exists: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(36.into(), CommonMetricData {
            name: "targeting_exists".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_version
    ///
    /// If the default profile had a targeting snapshot serialized to disk, the
    /// `version` of the snapshot.
    /// This version number does not have a physical unit: it's only useful to compare
    /// between versions.
    pub static targeting_version: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(37.into(), CommonMetricData {
            name: "targeting_version".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod browser_launched_to_handle {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SystemNotificationExtra {
        pub action: Option<String>,
        pub name: Option<String>,
    }

    impl ExtraKeys for SystemNotificationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.name.and_then(|val| map.insert("name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.launched_to_handle.system_notification
    ///
    /// Recorded when Firefox launches to complete a native notification popped by a
    /// system (chrome privileged) alert.  Windows-only at the time of writing.
    pub static system_notification: Lazy<EventMetric<SystemNotificationExtra>> = Lazy::new(|| {
        EventMetric::new(38.into(), CommonMetricData {
            name: "system_notification".into(),
            category: "browser.launched_to_handle".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod browser_migration {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.matched_extensions
    ///
    /// Records a list of the Chrome extension IDs that were successfully matched to
    /// Firefox equivalents from the list downloaded from AMO.
    pub static matched_extensions: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(39.into(), CommonMetricData {
            name: "matched_extensions".into(),
            category: "browser.migration".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.unmatched_extensions
    ///
    /// Records a list of the Chrome extension IDs that were unsuccessfully matched to
    /// Firefox equivalents from the list downloaded from AMO.
    pub static unmatched_extensions: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(40.into(), CommonMetricData {
            name: "unmatched_extensions".into(),
            category: "browser.migration".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod messaging_system {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.addon_version
    ///
    /// Used to hold the system addon's version, now is almost certainly an echo of the
    /// app's build id.
    pub static addon_version: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(41.into(), CommonMetricData {
            name: "addon_version".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.browser_session_id
    ///
    /// The Legacy Telemetry browser "session id". Identifies a specific period from
    /// application start to shutdown. See [the "main" ping docs](https://firefox-
    /// source-docs.mozilla.org/toolkit/components/telemetry/data/main-ping.html) for
    /// details.
    pub static browser_session_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(42.into(), CommonMetricData {
            name: "browser_session_id".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.bucket_id
    ///
    /// A name shared between multiple messages that may individually be too targetted.
    /// e.g. a message that gets shown on specific websites or a message asking about
    /// personal information.
    pub static bucket_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(43.into(), CommonMetricData {
            name: "bucket_id".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.client_id
    ///
    /// The client_id according to Telemetry.
    /// Might not always have a value due to policy around specific types of
    /// ping being sent. Value may be the canary client id
    /// `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
    /// in pings near when the data upload pref is disabled (if Telemetry gets
    /// to go first), or between when a client_id has been removed and when it
    /// has been regenerated.
    /// Present only in some circumstances (see
    /// [bug 1484035]https://bugzilla.mozilla.org/show_bug.cgi?id=1484035)).
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(44.into(), CommonMetricData {
            name: "client_id".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event
    ///
    /// The type of event. Any user defined string (e.g. “IMPRESSION”, “CLICK_BUTTON”,
    /// "INDEXEDDB_OPEN_FAILED", “SESSION_END”)
    pub static event: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(45.into(), CommonMetricData {
            name: "event".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_context
    ///
    /// The stringified JSON of `event_context`.
    pub static event_context: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(46.into(), CommonMetricData {
            name: "event_context".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_context_parse_error
    ///
    /// How often we failed to parse event_context as JSON.
    pub static event_context_parse_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            47,
            "messaging_system",
            "event_context_parse_error",
            "messaging-system"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_page
    ///
    /// The event_context's `page`. Almost always "about:welcome".
    pub static event_page: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(48.into(), CommonMetricData {
            name: "event_page".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_reason
    ///
    /// The event_context's `reason`. Likely something like
    /// "welcome-window-closed" or "app-shut-down",.
    pub static event_reason: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(49.into(), CommonMetricData {
            name: "event_reason".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_family
    ///
    /// A string identifier of the message family derived from the message id
    /// (e.g. MR_WELCOME_DEFAULT).
    pub static event_screen_family: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(50.into(), CommonMetricData {
            name: "event_screen_family".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_id
    ///
    /// A string identifier of the message screen id
    /// (e.g. AW_MOBILE_DOWNLOAD).
    pub static event_screen_id: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(51.into(), CommonMetricData {
            name: "event_screen_id".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_index
    ///
    /// A number identifier of the screen index in a sequence of screens
    /// (e.g. 0 for first message).
    pub static event_screen_index: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(52.into(), CommonMetricData {
            name: "event_screen_index".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_initials
    ///
    /// A string identifier of the message screen initials
    /// (e.g. 'EMAG' for EASY_SETUP, MOBILE_DOWNLOADS, AMO, GRATITUDE).
    pub static event_screen_initials: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(53.into(), CommonMetricData {
            name: "event_screen_initials".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_source
    ///
    /// The event_context's `source`. Likely something like "primary_button".
    pub static event_source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(54.into(), CommonMetricData {
            name: "event_source".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.glean_ping_for_ping_failures
    ///
    /// How often something went awry within
    /// `AboutWelcome.submitGleanPingForPing`, preventing ping submission.
    pub static glean_ping_for_ping_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            55,
            "messaging_system",
            "glean_ping_for_ping_failures",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.impression_id
    ///
    /// The unique impression identifier for a specific client.
    pub static impression_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(56.into(), CommonMetricData {
            name: "impression_id".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.invalid_nested_data
    ///
    /// We received a ping with non-scalar data on a field of this name.
    /// If this is existing pre-PingCentre-replacement data, you may need to
    /// augment the logic in
    /// `AboutWelcome.submitGleanPingForPing` like the other `handledKeys`.
    /// If this is for new, post-PingCentre-replacement data, you should
    /// probably prefer a flat structure.
    /// If you're unsure, please ask in
    /// [the #glean channel](https://chat.mozilla.org/#/room/#glean:mozilla.org).
    pub static invalid_nested_data: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(57.into(), CommonMetricData {
            name: "invalid_nested_data".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.locale
    ///
    /// The locale as supplied to the messaging system by
    /// `Services.locale.appLocaleAsBCP47`.
    pub static locale: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(58.into(), CommonMetricData {
            name: "locale".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.message_id
    ///
    /// A string identifier of the message in Activity Stream Router.
    pub static message_id: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(59.into(), CommonMetricData {
            name: "message_id".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.ping_type
    ///
    /// Type of event the ping is capturing. e.g. "cfr", "onboarding"
    pub static ping_type: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(60.into(), CommonMetricData {
            name: "ping_type".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.source
    ///
    /// The source of the interaction described by the other metrics. e.g.
    /// "frecent_links", "newtab", "CFR"
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(61.into(), CommonMetricData {
            name: "source".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.unknown_key_count
    ///
    /// The sum of all unknown keys counted.
    /// Useful for testing.
    /// Can be removed after bug 1600008 is resolved.
    pub static unknown_key_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            62,
            "messaging_system",
            "unknown_key_count",
            "messaging-system"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.unknown_keys
    ///
    /// Ping keys supplied to the messaging system for which
    /// we did not have a corresponding metric mapped to how often they attempted
    /// to be recorded.
    /// You may have forgotten to define an appropriate metric in
    /// `browser/components/newtab/metrics.yaml`.
    pub static unknown_keys: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(63.into(), CommonMetricData {
            name: "unknown_keys".into(),
            category: "messaging_system".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

}
pub mod messaging_system_attribution {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.campaign
    ///
    /// Attribution's campaign, possibly derived from the utm parameter of the
    /// same name.
    pub static campaign: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(64.into(), CommonMetricData {
            name: "campaign".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.content
    ///
    /// Attribution's content, possibly derived from the utm parameter of the
    /// same name.
    pub static content: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(65.into(), CommonMetricData {
            name: "content".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.dlsource
    ///
    /// Mozilla-specific download "source" name. Could be something like
    /// "mozillaci" to identify that the installer came from
    /// `{archive|ftp}.mozilla.org`.
    pub static dlsource: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(66.into(), CommonMetricData {
            name: "dlsource".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.dltoken
    ///
    /// String representation of the dltoken identifying the particular
    /// installer used to install this Firefox.
    /// Likely a UUID, if present.
    pub static dltoken: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(67.into(), CommonMetricData {
            name: "dltoken".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.experiment
    ///
    /// Attribution's experiment key.
    pub static experiment: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(68.into(), CommonMetricData {
            name: "experiment".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.medium
    ///
    /// Attribution's medium, possibly derived from the utm parameter of the same
    /// name.
    pub static medium: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(69.into(), CommonMetricData {
            name: "medium".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.msstoresignedin
    ///
    /// Either the string "true" or the string "false" to indicate whether the
    /// attributed install came from the Microsoft store and, if so, whether the
    /// user was signed in at the time.
    pub static msstoresignedin: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(70.into(), CommonMetricData {
            name: "msstoresignedin".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.source
    ///
    /// Attribution's source, possibly derived from the utm parameter of the same
    /// name.
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(71.into(), CommonMetricData {
            name: "source".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.ua
    ///
    /// Attribution's ua key.
    pub static ua: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(72.into(), CommonMetricData {
            name: "ua".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.unknown_keys
    ///
    /// Attribution keys supplied to the messaging system for which
    /// we did not have a corresponding metric, and the count of how
    /// often that happened.
    /// Either add this key to a list of known attribution keys in
    /// `AboutWelcomeTelemetry` to suppress or define an appropriate metric in
    /// `browser/components/newtab/metrics.yaml` to collect.
    pub static unknown_keys: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(73.into(), CommonMetricData {
            name: "unknown_keys".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.variation
    ///
    /// Attribution's variation key.
    pub static variation: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(74.into(), CommonMetricData {
            name: "variation".into(),
            category: "messaging_system.attribution".into(),
            send_in_pings: vec!["messaging-system".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod newtab {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.blocked_sponsors
    ///
    /// The advertiser names that have been dismissed by the user.
    pub static blocked_sponsors: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(75.into(), CommonMetricData {
            name: "blocked_sponsors".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClosedExtra {
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for ClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.closed
    ///
    /// Recorded when newtab UI is closed by * navigation * closing the tab
    /// Doesn't mean that the newtab was ever visible to a user.
    pub static closed: Lazy<EventMetric<ClosedExtra>> = Lazy::new(|| {
        EventMetric::new(76.into(), CommonMetricData {
            name: "closed".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.homepage_category
    ///
    /// The current setting of the home page. One of ["enabled", "disabled",
    /// "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
    /// media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
    /// `home_url_category`. Sampled once after newtab init.
    pub static homepage_category: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(77.into(), CommonMetricData {
            name: "homepage_category".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.locale
    ///
    /// The application's locale as of when newtab's TelemetryFeed was init. Comes from
    /// `Services.local.appLocaleAsBCP47`. Looks like `en-US`.
    pub static locale: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(78.into(), CommonMetricData {
            name: "locale".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.newtab_category
    ///
    /// The current setting of the newtab page. One of ["enabled", "disabled",
    /// "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
    /// media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
    /// `newtab_url_category`. Sampled once after newtab init.
    pub static newtab_category: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(79.into(), CommonMetricData {
            name: "newtab_category".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenedExtra {
        pub newtab_visit_id: Option<String>,
        pub source: Option<String>,
    }

    impl ExtraKeys for OpenedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.opened
    ///
    /// Recorded when newtab UI is opened via `about:newtab` or `about:home` or
    /// `about:welcome` and has been made visible (see `visibility_event_rcvd_ts` in
    /// [detect-user-session-start.js](https://searchfox.org/mozilla-
    /// central/source/browser/components/newtab/content-src/lib/detect-user-session-
    /// start.js)).
    pub static opened: Lazy<EventMetric<OpenedExtra>> = Lazy::new(|| {
        EventMetric::new(80.into(), CommonMetricData {
            name: "opened".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.sov_allocation
    ///
    /// The partner group assignment for sov
    pub static sov_allocation: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(81.into(), CommonMetricData {
            name: "sov_allocation".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TooltipClickExtra {
        pub feature: Option<String>,
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for TooltipClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["feature", "newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.feature.and_then(|val| map.insert("feature".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.tooltip_click
    ///
    /// Recorded when a feature highlight tooltip is opened.
    pub static tooltip_click: Lazy<EventMetric<TooltipClickExtra>> = Lazy::new(|| {
        EventMetric::new(82.into(), CommonMetricData {
            name: "tooltip_click".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct WallpaperCategoryClickExtra {
        pub newtab_visit_id: Option<String>,
        pub selected_category: Option<String>,
    }

    impl ExtraKeys for WallpaperCategoryClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "selected_category"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.selected_category.and_then(|val| map.insert("selected_category".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_category_click
    ///
    /// Recorded when a user clicks a wallpaper category option
    pub static wallpaper_category_click: Lazy<EventMetric<WallpaperCategoryClickExtra>> = Lazy::new(|| {
        EventMetric::new(83.into(), CommonMetricData {
            name: "wallpaper_category_click".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct WallpaperClickExtra {
        pub had_previous_wallpaper: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub selected_wallpaper: Option<String>,
    }

    impl ExtraKeys for WallpaperClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["had_previous_wallpaper", "newtab_visit_id", "selected_wallpaper"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.had_previous_wallpaper.and_then(|val| map.insert("had_previous_wallpaper".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.selected_wallpaper.and_then(|val| map.insert("selected_wallpaper".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_click
    ///
    /// Recorded when a user clicks on a wallpaper option
    pub static wallpaper_click: Lazy<EventMetric<WallpaperClickExtra>> = Lazy::new(|| {
        EventMetric::new(84.into(), CommonMetricData {
            name: "wallpaper_click".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct WallpaperHighlightCtaClickExtra {
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WallpaperHighlightCtaClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_highlight_cta_click
    ///
    /// Recorded when a user clicks the CTA on the wallpaper feature highlight
    pub static wallpaper_highlight_cta_click: Lazy<EventMetric<WallpaperHighlightCtaClickExtra>> = Lazy::new(|| {
        EventMetric::new(85.into(), CommonMetricData {
            name: "wallpaper_highlight_cta_click".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct WallpaperHighlightDismissedExtra {
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WallpaperHighlightDismissedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_highlight_dismissed
    ///
    /// Recorded when a user dismisses the wallpaper feature highlight
    pub static wallpaper_highlight_dismissed: Lazy<EventMetric<WallpaperHighlightDismissedExtra>> = Lazy::new(|| {
        EventMetric::new(86.into(), CommonMetricData {
            name: "wallpaper_highlight_dismissed".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct WeatherChangeDisplayExtra {
        pub newtab_visit_id: Option<String>,
        pub weather_display_mode: Option<String>,
    }

    impl ExtraKeys for WeatherChangeDisplayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "weather_display_mode"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.weather_display_mode.and_then(|val| map.insert("weather_display_mode".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_change_display
    ///
    /// Recorded when a user changes the weather display.
    pub static weather_change_display: Lazy<EventMetric<WeatherChangeDisplayExtra>> = Lazy::new(|| {
        EventMetric::new(87.into(), CommonMetricData {
            name: "weather_change_display".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_enabled
    ///
    /// Whether the weather widget is enabled on the newtab. Corresponds to the value
    /// of the `browser.newtabpage.activity-stream.showWeather` pref.
    pub static weather_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(88.into(), CommonMetricData {
            name: "weather_enabled".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct WeatherImpressionExtra {
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_impression
    ///
    /// Recorded when the weather widget is viewed
    pub static weather_impression: Lazy<EventMetric<WeatherImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(89.into(), CommonMetricData {
            name: "weather_impression".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct WeatherLoadErrorExtra {
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherLoadErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_load_error
    ///
    /// Recorded when the weather widget is not available
    pub static weather_load_error: Lazy<EventMetric<WeatherLoadErrorExtra>> = Lazy::new(|| {
        EventMetric::new(90.into(), CommonMetricData {
            name: "weather_load_error".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct WeatherLocationSelectedExtra {
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherLocationSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_location_selected
    ///
    /// Recorded when a user selects a location for weather widget
    pub static weather_location_selected: Lazy<EventMetric<WeatherLocationSelectedExtra>> = Lazy::new(|| {
        EventMetric::new(91.into(), CommonMetricData {
            name: "weather_location_selected".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct WeatherOpenProviderUrlExtra {
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherOpenProviderUrlExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_open_provider_url
    ///
    /// Recorded when a user opens a link to the Weather provider website.
    pub static weather_open_provider_url: Lazy<EventMetric<WeatherOpenProviderUrlExtra>> = Lazy::new(|| {
        EventMetric::new(92.into(), CommonMetricData {
            name: "weather_open_provider_url".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod newtab_handoff_preference {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.handoff_preference.enabled
    ///
    /// Records whether the browser.newtabpage.activity-
    /// stream.improvesearch.handoffToAwesomebar preference is enabled or disabled
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(93.into(), CommonMetricData {
            name: "enabled".into(),
            category: "newtab.handoff_preference".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod newtab_search {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.enabled
    ///
    /// Whether the search input is enabled on the newtab. Corresponds to the value of
    /// the `browser.newtabpage.activity-stream.showSearch` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(94.into(), CommonMetricData {
            name: "enabled".into(),
            category: "newtab.search".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct IssuedExtra {
        pub newtab_visit_id: Option<String>,
        pub search_access_point: Option<String>,
        pub telemetry_id: Option<String>,
    }

    impl ExtraKeys for IssuedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.issued
    ///
    /// When Firefox was asked to issue a search from a Search Access Point (SAP) on a
    /// newtab page. Doesn't record searches in Private Browsing Mode unless
    /// `browser.engagement.search_counts.pbm` is set to `true`.
    pub static issued: Lazy<EventMetric<IssuedExtra>> = Lazy::new(|| {
        EventMetric::new(95.into(), CommonMetricData {
            name: "issued".into(),
            category: "newtab.search".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod pocket {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClickExtra {
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
        pub recommendation_id: Option<String>,
        pub tile_id: Option<u32>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_sponsored", "newtab_visit_id", "position", "recommendation_id", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.click
    ///
    /// Recorded when a pocket tile is clicked. Only happens on click. Not on middle-
    /// click. Not on "Open in new Tab"-like options in the context menu.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        EventMetric::new(96.into(), CommonMetricData {
            name: "click".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.enabled
    ///
    /// Whether Pocket is enabled on the newtab. AKA the "Recommended by Pocket"
    /// section. Corresponds to the value of the `browser.newtabpage.activity-
    /// stream.feeds.section.topstories` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(97.into(), CommonMetricData {
            name: "enabled".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.fetch_timestamp
    ///
    /// Timestamp of when the spoc was fetched by the client
    pub static fetch_timestamp: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(98.into(), CommonMetricData {
            name: "fetch_timestamp".into(),
            category: "pocket".into(),
            send_in_pings: vec!["spoc".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
        pub recommendation_id: Option<String>,
        pub tile_id: Option<u32>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_sponsored", "newtab_visit_id", "position", "recommendation_id", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.impression
    ///
    /// Recorded when a pocket tile is visible to the user.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(99.into(), CommonMetricData {
            name: "impression".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.is_signed_in
    ///
    /// Whether the Firefox user is signed in to Pocket. Does not correspond to a pref,
    /// so its value is resampled at newtab's component init and whenever there is a
    /// Discovery Stream user event.
    pub static is_signed_in: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(100.into(), CommonMetricData {
            name: "is_signed_in".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.newtab_creation_timestamp
    ///
    /// Timestamp of when this instance of the newtab was first visible to the user.
    pub static newtab_creation_timestamp: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(101.into(), CommonMetricData {
            name: "newtab_creation_timestamp".into(),
            category: "pocket".into(),
            send_in_pings: vec!["spoc".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SaveExtra {
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
        pub recommendation_id: Option<String>,
        pub tile_id: Option<u32>,
    }

    impl ExtraKeys for SaveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_sponsored", "newtab_visit_id", "position", "recommendation_id", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.save
    ///
    /// Recorded when a user decides to save a pocket tile. Does not mean it ends up
    /// successfully saved. Just that the user clicked on "Save to Pocket" in the
    /// little pocket tile menu.
    pub static save: Lazy<EventMetric<SaveExtra>> = Lazy::new(|| {
        EventMetric::new(102.into(), CommonMetricData {
            name: "save".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.shim
    ///
    /// Opaque partner identifier for a given ad impression or engagement action,
    /// unique per market and region.
    /// Pocket
    /// [proxies requests to ad partners](https://github.com/Pocket/proxy-server/)
    /// and provides them solely with market, region, and action to generate these
    /// shims. Thus, though the contents of this field are obscure, they cannot
    /// identify clients.
    /// At time of writing this information is a comma-separated trio.
    /// The first item is an index into the proxy server's list of acceptable http
    /// endpoints for contacting the ad service. The second item is a
    /// several-hundred-byte base64-encoded JSON-encoded struct with fields for,
    /// amongst other things, market and region. The third is unknown, but appears
    /// to be a signature or checksum.
    /// This shim should not be sent with the client_id.
    pub static shim: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(103.into(), CommonMetricData {
            name: "shim".into(),
            category: "pocket".into(),
            send_in_pings: vec!["spoc".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.sponsored_stories_enabled
    ///
    /// Whether Pocket sponsored stories are enabled on the newtab. Corresponds to the
    /// value of the `browser.newtabpage.activity-stream.showSponsored` pref. Can be
    /// `true` even if pocket.enabled is `false`.
    pub static sponsored_stories_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(104.into(), CommonMetricData {
            name: "sponsored_stories_enabled".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TopicClickExtra {
        pub newtab_visit_id: Option<String>,
        pub topic: Option<String>,
    }

    impl ExtraKeys for TopicClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.topic_click
    ///
    /// Recorded when a pocket "Popular Topic" is clicked. Only happens on click. Not
    /// on middle-click. Not on "Open in new Tab"-like options in the context menu.
    pub static topic_click: Lazy<EventMetric<TopicClickExtra>> = Lazy::new(|| {
        EventMetric::new(105.into(), CommonMetricData {
            name: "topic_click".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod top_sites {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.advertiser
    ///
    /// The name of the advertiser providing the sponsored TopSite.
    pub static advertiser: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(106.into(), CommonMetricData {
            name: "advertiser".into(),
            category: "top_sites".into(),
            send_in_pings: vec!["top-sites".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.context_id
    ///
    /// An identifier to identify users for Contextual Services user interaction pings.
    pub static context_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(107.into(), CommonMetricData {
            name: "context_id".into(),
            category: "top_sites".into(),
            send_in_pings: vec!["top-sites".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.ping_type
    ///
    /// The ping's type. In other situations might be designated by an event's name or
    /// an interaction field. E.g. "topsites-impression", "topsites-click".
    pub static ping_type: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(108.into(), CommonMetricData {
            name: "ping_type".into(),
            category: "top_sites".into(),
            send_in_pings: vec!["top-sites".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.position
    ///
    /// The position (1-based) of the topsites item being interatcted with.
    pub static position: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(109.into(), CommonMetricData {
            name: "position".into(),
            category: "top_sites".into(),
            send_in_pings: vec!["top-sites".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.reporting_url
    ///
    /// The url to report this interaction to.
    pub static reporting_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(110.into(), CommonMetricData {
            name: "reporting_url".into(),
            category: "top_sites".into(),
            send_in_pings: vec!["top-sites".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.source
    ///
    /// The source of the interaction. Always set to "newtab".
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(111.into(), CommonMetricData {
            name: "source".into(),
            category: "top_sites".into(),
            send_in_pings: vec!["top-sites".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.tile_id
    ///
    /// String-encoded number for the tile's sponsored tile id.
    pub static tile_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(112.into(), CommonMetricData {
            name: "tile_id".into(),
            category: "top_sites".into(),
            send_in_pings: vec!["top-sites".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod topsites {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClickExtra {
        pub advertiser_name: Option<String>,
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
        pub tile_id: Option<u32>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "is_sponsored", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.click
    ///
    /// Recorded when a topsite tile is clicked. Only happens on click. Not on middle-
    /// click. Not on "Open in new Tab"-like options in the context menu.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        EventMetric::new(113.into(), CommonMetricData {
            name: "click".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct DismissExtra {
        pub advertiser_name: Option<String>,
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
        pub tile_id: Option<u32>,
    }

    impl ExtraKeys for DismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "is_sponsored", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.dismiss
    ///
    /// Recorded when the "Dismiss" menu item in the three-dots menu of a topsite is
    /// clicked. Corresponds to the receipt of a dispatched `BLOCK_URL` action by
    /// `TelemetryFeed`. Applies to both sponsored and non-sponsored topsites.
    /// `advertiser_name` is only provided for sponsored topsites.
    pub static dismiss: Lazy<EventMetric<DismissExtra>> = Lazy::new(|| {
        EventMetric::new(114.into(), CommonMetricData {
            name: "dismiss".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.enabled
    ///
    /// Whether "topsites" is enabled on the newtab. AKA the "Shortcuts" section.
    /// Corresponds to the value of the `browser.newtabpage.activity-
    /// stream.feeds.topsites` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(115.into(), CommonMetricData {
            name: "enabled".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub advertiser_name: Option<String>,
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
        pub tile_id: Option<u32>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "is_sponsored", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.impression
    ///
    /// Recorded when topsite tiles are loaded.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(116.into(), CommonMetricData {
            name: "impression".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct PrefChangedExtra {
        pub new_value: Option<bool>,
        pub pref_name: Option<String>,
    }

    impl ExtraKeys for PrefChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["new_value", "pref_name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.new_value.and_then(|val| map.insert("new_value".into(), val.to_string()));
          self.pref_name.and_then(|val| map.insert("pref_name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.pref_changed
    ///
    /// Recorded when specific topsites prefs have changed.
    /// The list of possible prefs is presently:
    ///  * browser.newtabpage.activity-stream.feeds.topsites
    ///  * browser.newtabpage.activity-stream.showSponsoredTopSites
    pub static pref_changed: Lazy<EventMetric<PrefChangedExtra>> = Lazy::new(|| {
        EventMetric::new(117.into(), CommonMetricData {
            name: "pref_changed".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.rows
    ///
    /// The number of topsite tile rows configured to be shown on the newtab page.
    /// Corresponds to the value of the `browser.newtabpage.activity-
    /// stream.topSitesRows` pref. This is not the number of rows actually seen by the
    /// user: if the browser window is partially off-screen, or isn't wide enough to
    /// accommodate eight tiles per row, the actual number of rows may be different.
    pub static rows: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(118.into(), CommonMetricData {
            name: "rows".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ShowPrivacyClickExtra {
        pub advertiser_name: Option<String>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
        pub tile_id: Option<u32>,
    }

    impl ExtraKeys for ShowPrivacyClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.show_privacy_click
    ///
    /// Recorded when the "Our Sponsors and Your Privacy" menu item in the three- dots
    /// menu of a sponsored topsite is clicked. Corresponds to the receipt of a
    /// dispatched `ABOUT_SPONSORED_TOP_SITES` action by `TelemetryFeed`.
    pub static show_privacy_click: Lazy<EventMetric<ShowPrivacyClickExtra>> = Lazy::new(|| {
        EventMetric::new(119.into(), CommonMetricData {
            name: "show_privacy_click".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.sponsored_enabled
    ///
    /// Whether sponsored topsites are enabled on the newtab. AKA the "Sponsored
    /// Shortcuts" section. Corresponds to the value of the
    /// `browser.newtabpage.activity-stream.showSponsoredTopSites` pref. Can be `true`
    /// even if topsites.enabled is `false`.
    pub static sponsored_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(120.into(), CommonMetricData {
            name: "sponsored_enabled".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.sponsored_tiles_configured
    ///
    /// The number of topsite tiles configured to be shown on newtab.
    pub static sponsored_tiles_configured: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(121.into(), CommonMetricData {
            name: "sponsored_tiles_configured".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.sponsored_tiles_received
    ///
    /// The stringified JSON of tiles processed for display (array of objects).
    /// Includes tiles not displayed and reason for not displaying. Fields included:
    /// advertiser, provider, display_position, display_fail_reason.
    pub static sponsored_tiles_received: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(122.into(), CommonMetricData {
            name: "sponsored_tiles_received".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod pocket_button {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.event_action
    ///
    /// The action that was taken, like "click" or... actually, it might only ever be
    /// "click".
    pub static event_action: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(123.into(), CommonMetricData {
            name: "event_action".into(),
            category: "pocket.button".into(),
            send_in_pings: vec!["pocket-button".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.event_position
    ///
    /// 0-based index of the item on which the action was performed. Not always
    /// provided.
    pub static event_position: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(124.into(), CommonMetricData {
            name: "event_position".into(),
            category: "pocket.button".into(),
            send_in_pings: vec!["pocket-button".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.event_source
    ///
    /// The source of the taken action, like "save_button", "home_button",
    /// "on_save_recs", or the like.
    pub static event_source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(125.into(), CommonMetricData {
            name: "event_source".into(),
            category: "pocket.button".into(),
            send_in_pings: vec!["pocket-button".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.impression_id
    ///
    /// A UUID representing this profile. This isn't client_id, nor can it be used to
    /// link to a client_id. This also means it should never be sent in a ping with a
    /// client_id.
    pub static impression_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(126.into(), CommonMetricData {
            name: "impression_id".into(),
            category: "pocket.button".into(),
            send_in_pings: vec!["pocket-button".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.model
    ///
    /// A string that identifies the ML model (if any) used to generate on-save
    /// recommendations. Like "doc2vec-incremental-best-article-pubspread".
    pub static model: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(127.into(), CommonMetricData {
            name: "model".into(),
            category: "pocket.button".into(),
            send_in_pings: vec!["pocket-button".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.pocket_logged_in_status
    ///
    /// Whether there was a logged-in Pocket account in the Pocket-Firefox integration
    /// at the point in time this action occurred.
    pub static pocket_logged_in_status: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(128.into(), CommonMetricData {
            name: "pocket_logged_in_status".into(),
            category: "pocket.button".into(),
            send_in_pings: vec!["pocket-button".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.profile_creation_date
    ///
    /// The days since Jan 1, 1970 that the oldest file in the profile dir was
    /// modified. Or created. Or just the day and time of the first thing to ask for
    /// the profile age called in. Or something earlier or later than that.
    /// You may not want to use this.
    pub static profile_creation_date: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(129.into(), CommonMetricData {
            name: "profile_creation_date".into(),
            category: "pocket.button".into(),
            send_in_pings: vec!["pocket-button".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod privacy_ui_fpp_click {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CheckboxExtra {
        pub checked: Option<bool>,
    }

    impl ExtraKeys for CheckboxExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.ui.fpp.click.checkbox
    ///
    /// User interaction by click events on fingerprinting protection checkbox in the
    /// ETP Custom subpanel.
    pub static checkbox: Lazy<EventMetric<CheckboxExtra>> = Lazy::new(|| {
        EventMetric::new(130.into(), CommonMetricData {
            name: "checkbox".into(),
            category: "privacy.ui.fpp.click".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct MenuExtra {
        pub value: Option<String>,
    }

    impl ExtraKeys for MenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.ui.fpp.click.menu
    ///
    /// User interaction by click events on fingerprinting protection menulist in the
    /// ETP Custom subpanel.
    pub static menu: Lazy<EventMetric<MenuExtra>> = Lazy::new(|| {
        EventMetric::new(131.into(), CommonMetricData {
            name: "menu".into(),
            category: "privacy.ui.fpp.click".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod private_browsing_reset_pbm {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ConfirmPanelExtra {
        pub action: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for ConfirmPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from private_browsing.reset_pbm.confirm_panel
    ///
    /// Confirm panel show / hide event.
    pub static confirm_panel: Lazy<EventMetric<ConfirmPanelExtra>> = Lazy::new(|| {
        EventMetric::new(132.into(), CommonMetricData {
            name: "confirm_panel".into(),
            category: "private_browsing.reset_pbm".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ResetActionExtra {
        pub did_confirm: Option<bool>,
    }

    impl ExtraKeys for ResetActionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["did_confirm"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.did_confirm.and_then(|val| map.insert("did_confirm".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from private_browsing.reset_pbm.reset_action
    ///
    /// Dispatched whenever PBM is restarted / reset via the resetPBM feature.
    pub static reset_action: Lazy<EventMetric<ResetActionExtra>> = Lazy::new(|| {
        EventMetric::new(133.into(), CommonMetricData {
            name: "reset_action".into(),
            category: "private_browsing.reset_pbm".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod protocolhandler_mailto {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum HandlerPromptShownLabel {
        EOsDefault = 0,
        EFxDefault = 1,
        __Other__,
    }
    impl From<u16> for HandlerPromptShownLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOsDefault,
                1 => Self::EFxDefault,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HandlerPromptShownLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOsDefault => "os_default",
                Self::EFxDefault => "fx_default",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from protocolhandler.mailto.handler_prompt_shown
    ///
    /// A website was visited, which called registerProtocolHandler for mailto://
    pub static handler_prompt_shown: Lazy<LabeledMetric<LabeledCounterMetric, HandlerPromptShownLabel>> = Lazy::new(|| {
        LabeledMetric::new(134.into(), CommonMetricData {
            name: "handler_prompt_shown".into(),
            category: "protocolhandler.mailto".into(),
            send_in_pings: vec!["active".into(), "metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("fx_default"), ::std::borrow::Cow::from("os_default")]))
    });

    #[repr(u16)]
    pub enum PromptClickedLabel {
        ESetOsDefault = 0,
        ESetOsDefaultError = 1,
        ESetOsDefaultImpossible = 2,
        EDismissOsDefault = 3,
        ESetLocalDefault = 4,
        EDismissLocalDefault = 5,
        __Other__,
    }
    impl From<u16> for PromptClickedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESetOsDefault,
                1 => Self::ESetOsDefaultError,
                2 => Self::ESetOsDefaultImpossible,
                3 => Self::EDismissOsDefault,
                4 => Self::ESetLocalDefault,
                5 => Self::EDismissLocalDefault,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PromptClickedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESetOsDefault => "set_os_default",
                Self::ESetOsDefaultError => "set_os_default_error",
                Self::ESetOsDefaultImpossible => "set_os_default_impossible",
                Self::EDismissOsDefault => "dismiss_os_default",
                Self::ESetLocalDefault => "set_local_default",
                Self::EDismissLocalDefault => "dismiss_local_default",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from protocolhandler.mailto.prompt_clicked
    ///
    /// User clicked on a button to approve setting the current site as default web
    /// mail site. The sum of all counters is the total amount of user interactions and
    /// dismissing the same dialog often could be a sign of a bug.
    pub static prompt_clicked: Lazy<LabeledMetric<LabeledCounterMetric, PromptClickedLabel>> = Lazy::new(|| {
        LabeledMetric::new(135.into(), CommonMetricData {
            name: "prompt_clicked".into(),
            category: "protocolhandler.mailto".into(),
            send_in_pings: vec!["active".into(), "metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("dismiss_local_default"), ::std::borrow::Cow::from("dismiss_os_default"), ::std::borrow::Cow::from("set_local_default"), ::std::borrow::Cow::from("set_os_default"), ::std::borrow::Cow::from("set_os_default_error"), ::std::borrow::Cow::from("set_os_default_impossible")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct VisitExtra {
        pub triggered_externally: Option<bool>,
    }

    impl ExtraKeys for VisitExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["triggered_externally"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.triggered_externally.and_then(|val| map.insert("triggered_externally".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from protocolhandler.mailto.visit
    ///
    /// a URI of type mailto was visited. Furthermore we want to know if from within
    /// the browser.
    pub static visit: Lazy<EventMetric<VisitExtra>> = Lazy::new(|| {
        EventMetric::new(136.into(), CommonMetricData {
            name: "visit".into(),
            category: "protocolhandler.mailto".into(),
            send_in_pings: vec!["active".into(), "events".into(), "metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod newtab_search_ad {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClickExtra {
        pub is_follow_on: Option<bool>,
        pub is_tagged: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub search_access_point: Option<String>,
        pub telemetry_id: Option<String>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_follow_on", "is_tagged", "newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_follow_on.and_then(|val| map.insert("is_follow_on".into(), val.to_string()));
          self.is_tagged.and_then(|val| map.insert("is_tagged".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.ad.click
    ///
    /// Recorded when an ad link is clicked on a Search Engine Result Page (SERP) which
    /// was loaded by a seach that began on a newtab page.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        EventMetric::new(137.into(), CommonMetricData {
            name: "click".into(),
            category: "newtab.search.ad".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub is_follow_on: Option<bool>,
        pub is_tagged: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub search_access_point: Option<String>,
        pub telemetry_id: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_follow_on", "is_tagged", "newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_follow_on.and_then(|val| map.insert("is_follow_on".into(), val.to_string()));
          self.is_tagged.and_then(|val| map.insert("is_tagged".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.ad.impression
    ///
    /// Recorded when a newtab visit resulted in a search that loaded a Search Engine
    /// Result Page (SERP) that contains an ad link. And the SERP is visible.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(138.into(), CommonMetricData {
            name: "impression".into(),
            category: "newtab.search.ad".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod search_with {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from search_with.context_id
    ///
    /// An identifier for Contextual Services user interaction pings. This is used
    /// internally for counting unique users as well as for anti-fraud. It is shared
    /// with other Contextual Services. It is not shared externally.
    pub static context_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(139.into(), CommonMetricData {
            name: "context_id".into(),
            category: "search_with".into(),
            send_in_pings: vec!["search-with".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search_with.reporting_url
    ///
    /// The external url to report this interaction to.
    pub static reporting_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(140.into(), CommonMetricData {
            name: "reporting_url".into(),
            category: "search_with".into(),
            send_in_pings: vec!["search-with".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod serp {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AbandonmentExtra {
        pub impression_id: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for AbandonmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["impression_id", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.abandonment
    ///
    /// Recorded when there is no engagement with the SERP before the tab is closed,
    /// the window is closed, the app is closed, or the tab is navigated away from.
    pub static abandonment: Lazy<EventMetric<AbandonmentExtra>> = Lazy::new(|| {
        EventMetric::new(141.into(), CommonMetricData {
            name: "abandonment".into(),
            category: "serp".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AdImpressionExtra {
        pub ads_hidden: Option<u32>,
        pub ads_loaded: Option<u32>,
        pub ads_visible: Option<u32>,
        pub component: Option<String>,
        pub impression_id: Option<String>,
    }

    impl ExtraKeys for AdImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["ads_hidden", "ads_loaded", "ads_visible", "component", "impression_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.ads_hidden.and_then(|val| map.insert("ads_hidden".into(), val.to_string()));
          self.ads_loaded.and_then(|val| map.insert("ads_loaded".into(), val.to_string()));
          self.ads_visible.and_then(|val| map.insert("ads_visible".into(), val.to_string()));
          self.component.and_then(|val| map.insert("component".into(), val.to_string()));
          self.impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.ad_impression
    ///
    /// Recorded when a user loads a SERP and ads are detected.
    pub static ad_impression: Lazy<EventMetric<AdImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(142.into(), CommonMetricData {
            name: "ad_impression".into(),
            category: "serp".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CategorizationExtra {
        pub app_version: Option<u32>,
        pub channel: Option<String>,
        pub is_shopping_page: Option<bool>,
        pub mappings_version: Option<u32>,
        pub num_ads_clicked: Option<u32>,
        pub num_ads_hidden: Option<u32>,
        pub num_ads_loaded: Option<u32>,
        pub num_ads_visible: Option<u32>,
        pub organic_category: Option<u32>,
        pub organic_num_domains: Option<u32>,
        pub organic_num_inconclusive: Option<u32>,
        pub organic_num_unknown: Option<u32>,
        pub partner_code: Option<String>,
        pub provider: Option<String>,
        pub region: Option<String>,
        pub sponsored_category: Option<u32>,
        pub sponsored_num_domains: Option<u32>,
        pub sponsored_num_inconclusive: Option<u32>,
        pub sponsored_num_unknown: Option<u32>,
        pub tagged: Option<bool>,
    }

    impl ExtraKeys for CategorizationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["app_version", "channel", "is_shopping_page", "mappings_version", "num_ads_clicked", "num_ads_hidden", "num_ads_loaded", "num_ads_visible", "organic_category", "organic_num_domains", "organic_num_inconclusive", "organic_num_unknown", "partner_code", "provider", "region", "sponsored_category", "sponsored_num_domains", "sponsored_num_inconclusive", "sponsored_num_unknown", "tagged"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.app_version.and_then(|val| map.insert("app_version".into(), val.to_string()));
          self.channel.and_then(|val| map.insert("channel".into(), val.to_string()));
          self.is_shopping_page.and_then(|val| map.insert("is_shopping_page".into(), val.to_string()));
          self.mappings_version.and_then(|val| map.insert("mappings_version".into(), val.to_string()));
          self.num_ads_clicked.and_then(|val| map.insert("num_ads_clicked".into(), val.to_string()));
          self.num_ads_hidden.and_then(|val| map.insert("num_ads_hidden".into(), val.to_string()));
          self.num_ads_loaded.and_then(|val| map.insert("num_ads_loaded".into(), val.to_string()));
          self.num_ads_visible.and_then(|val| map.insert("num_ads_visible".into(), val.to_string()));
          self.organic_category.and_then(|val| map.insert("organic_category".into(), val.to_string()));
          self.organic_num_domains.and_then(|val| map.insert("organic_num_domains".into(), val.to_string()));
          self.organic_num_inconclusive.and_then(|val| map.insert("organic_num_inconclusive".into(), val.to_string()));
          self.organic_num_unknown.and_then(|val| map.insert("organic_num_unknown".into(), val.to_string()));
          self.partner_code.and_then(|val| map.insert("partner_code".into(), val.to_string()));
          self.provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.sponsored_category.and_then(|val| map.insert("sponsored_category".into(), val.to_string()));
          self.sponsored_num_domains.and_then(|val| map.insert("sponsored_num_domains".into(), val.to_string()));
          self.sponsored_num_inconclusive.and_then(|val| map.insert("sponsored_num_inconclusive".into(), val.to_string()));
          self.sponsored_num_unknown.and_then(|val| map.insert("sponsored_num_unknown".into(), val.to_string()));
          self.tagged.and_then(|val| map.insert("tagged".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.categorization
    ///
    /// A high-level categorization of a SERP (a best guess as to its topic), using
    /// buckets such as "sports" or "travel".
    pub static categorization: Lazy<EventMetric<CategorizationExtra>> = Lazy::new(|| {
        EventMetric::new(143.into(), CommonMetricData {
            name: "categorization".into(),
            category: "serp".into(),
            send_in_pings: vec!["serp-categorization".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from serp.categorization_duration
    ///
    /// The time it takes to categorize elements on a SERP.
    pub static categorization_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(144.into(), CommonMetricData {
            name: "categorization_duration".into(),
            category: "serp".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EngagementExtra {
        pub action: Option<String>,
        pub impression_id: Option<String>,
        pub target: Option<String>,
    }

    impl ExtraKeys for EngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "impression_id", "target"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.target.and_then(|val| map.insert("target".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.engagement
    ///
    /// Recorded user actions on a SERP.
    pub static engagement: Lazy<EventMetric<EngagementExtra>> = Lazy::new(|| {
        EventMetric::new(145.into(), CommonMetricData {
            name: "engagement".into(),
            category: "serp".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub impression_id: Option<String>,
        pub is_private: Option<bool>,
        pub is_shopping_page: Option<bool>,
        pub is_signed_in: Option<bool>,
        pub partner_code: Option<String>,
        pub provider: Option<String>,
        pub shopping_tab_displayed: Option<bool>,
        pub source: Option<String>,
        pub tagged: Option<bool>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["impression_id", "is_private", "is_shopping_page", "is_signed_in", "partner_code", "provider", "shopping_tab_displayed", "source", "tagged"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.is_private.and_then(|val| map.insert("is_private".into(), val.to_string()));
          self.is_shopping_page.and_then(|val| map.insert("is_shopping_page".into(), val.to_string()));
          self.is_signed_in.and_then(|val| map.insert("is_signed_in".into(), val.to_string()));
          self.partner_code.and_then(|val| map.insert("partner_code".into(), val.to_string()));
          self.provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.shopping_tab_displayed.and_then(|val| map.insert("shopping_tab_displayed".into(), val.to_string()));
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.tagged.and_then(|val| map.insert("tagged".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.impression
    ///
    /// Recorded when a search engine results page (SERP) is shown to a user. The
    /// feature began rolling out to all users with Firefox 115, and was permanently
    /// enabled in Firefox 119.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(146.into(), CommonMetricData {
            name: "impression".into(),
            category: "serp".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod shopping {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AddressBarFeatureCalloutDisplayedExtra {
        pub configuration: Option<String>,
    }

    impl ExtraKeys for AddressBarFeatureCalloutDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["configuration"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.configuration.and_then(|val| map.insert("configuration".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.address_bar_feature_callout_displayed
    ///
    /// The user was shown the feature callout for the Shopping component.
    pub static address_bar_feature_callout_displayed: Lazy<EventMetric<AddressBarFeatureCalloutDisplayedExtra>> = Lazy::new(|| {
        EventMetric::new(147.into(), CommonMetricData {
            name: "address_bar_feature_callout_displayed".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AddressBarIconClickedExtra {
        pub action: Option<String>,
    }

    impl ExtraKeys for AddressBarIconClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.address_bar_icon_clicked
    ///
    /// The Shopping product Address Bar Icon was clicked by the user.
    pub static address_bar_icon_clicked: Lazy<EventMetric<AddressBarIconClickedExtra>> = Lazy::new(|| {
        EventMetric::new(148.into(), CommonMetricData {
            name: "address_bar_icon_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.address_bar_icon_displayed
    ///
    /// The Shopping product Address Bar Icon was displayed to the user.
    pub static address_bar_icon_displayed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(149.into(), CommonMetricData {
            name: "address_bar_icon_displayed".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.ads_exposure
    ///
    /// On a supported product page, the review checker showed analysis, and
    /// the ads exposure pref was enabled, or review checker ads were enabled,
    /// and when we tried to fetch an ad from the ad server, an ad was available.
    /// Does not indicate whether the ad was actually shown.
    pub static ads_exposure: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(150.into(), CommonMetricData {
            name: "ads_exposure".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.product_page_visits
    ///
    /// Counts number of visits to a supported retailer product page
    /// while enrolled in either the control or treatment branches
    /// of the shopping experiment.
    pub static product_page_visits: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            151,
            "shopping",
            "product_page_visits",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_clicked
    ///
    /// An ad shown in the sidebar was clicked.
    pub static surface_ads_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(152.into(), CommonMetricData {
            name: "surface_ads_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_impression
    ///
    /// An ad was shown and visible in the sidebar for 1.5 seconds.
    pub static surface_ads_impression: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(153.into(), CommonMetricData {
            name: "surface_ads_impression".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_placement
    ///
    /// An ad unit was fetched successfully.
    pub static surface_ads_placement: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(154.into(), CommonMetricData {
            name: "surface_ads_placement".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SurfaceAdsSettingToggledExtra {
        pub action: Option<String>,
    }

    impl ExtraKeys for SurfaceAdsSettingToggledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_setting_toggled
    ///
    /// The user clicked the settings toggle to enable or disable ads in the
    /// sidebar settings component.
    pub static surface_ads_setting_toggled: Lazy<EventMetric<SurfaceAdsSettingToggledExtra>> = Lazy::new(|| {
        EventMetric::new(155.into(), CommonMetricData {
            name: "surface_ads_setting_toggled".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_analyze_reviews_none_available_clicked
    ///
    /// The user clicked to analyze reviews in the case the reliability rating
    /// was not available for display in the shopping side bar. This metric
    /// does not contain any information about the product the user is viewing.
    pub static surface_analyze_reviews_none_available_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(156.into(), CommonMetricData {
            name: "surface_analyze_reviews_none_available_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SurfaceAutoOpenSettingToggledExtra {
        pub action: Option<String>,
    }

    impl ExtraKeys for SurfaceAutoOpenSettingToggledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_auto_open_setting_toggled
    ///
    /// The user clicked the settings toggle to enable or disable auto-open in the
    /// sidebar settings component.
    pub static surface_auto_open_setting_toggled: Lazy<EventMetric<SurfaceAutoOpenSettingToggledExtra>> = Lazy::new(|| {
        EventMetric::new(157.into(), CommonMetricData {
            name: "surface_auto_open_setting_toggled".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SurfaceClosedExtra {
        pub source: Option<String>,
    }

    impl ExtraKeys for SurfaceClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_closed
    ///
    /// The user opened the settings menu of the shopping component.
    pub static surface_closed: Lazy<EventMetric<SurfaceClosedExtra>> = Lazy::new(|| {
        EventMetric::new(158.into(), CommonMetricData {
            name: "surface_closed".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SurfaceDisplayedExtra {
        pub side_bar_state: Option<String>,
    }

    impl ExtraKeys for SurfaceDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["side_bar_state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.side_bar_state.and_then(|val| map.insert("side_bar_state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_displayed
    ///
    /// The Shopping product Sidebar was displayed.
    pub static surface_displayed: Lazy<EventMetric<SurfaceDisplayedExtra>> = Lazy::new(|| {
        EventMetric::new(159.into(), CommonMetricData {
            name: "surface_displayed".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_learn_more_clicked
    ///
    /// The user clicked the 'Learn More' link in the Shopping onboarding
    /// experience.
    pub static surface_learn_more_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(160.into(), CommonMetricData {
            name: "surface_learn_more_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_no_ads_available
    ///
    /// On a supported product page, the review checker showed analysis, and
    /// review checker ads were enabled, but when we tried to fetch an ad from
    /// the ad server, no ad was available.
    pub static surface_no_ads_available: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(161.into(), CommonMetricData {
            name: "surface_no_ads_available".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_no_review_reliability_available
    ///
    /// Review reliability was not available for display in the shopping side
    /// bar. This metric does not contain any information about the product
    /// the user is viewing.
    pub static surface_no_review_reliability_available: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(162.into(), CommonMetricData {
            name: "surface_no_review_reliability_available".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_no_thanks_button_clicked
    ///
    /// The user clicks the 'No thanks' button when asked if they want to
    /// disable auto-open behavior.
    pub static surface_no_thanks_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(163.into(), CommonMetricData {
            name: "surface_no_thanks_button_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_not_now_clicked
    ///
    /// The user clicked 'Not Now' to dismiss the dialog.
    pub static surface_not_now_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(164.into(), CommonMetricData {
            name: "surface_not_now_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SurfaceOnboardingDisplayedExtra {
        pub configuration: Option<String>,
    }

    impl ExtraKeys for SurfaceOnboardingDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["configuration"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.configuration.and_then(|val| map.insert("configuration".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_onboarding_displayed
    ///
    /// The Shopping Side bar displayed the onboarding experience.
    pub static surface_onboarding_displayed: Lazy<EventMetric<SurfaceOnboardingDisplayedExtra>> = Lazy::new(|| {
        EventMetric::new(165.into(), CommonMetricData {
            name: "surface_onboarding_displayed".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_opt_in_clicked
    ///
    /// The user clicked the "Yes, try it" element to use the Shopping product's
    /// functionality.
    pub static surface_opt_in_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(166.into(), CommonMetricData {
            name: "surface_opt_in_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_opt_out_button_clicked
    ///
    /// The user clicked the button in the settings panel to turn off the shopping
    /// experience.
    pub static surface_opt_out_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(167.into(), CommonMetricData {
            name: "surface_opt_out_button_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_powered_by_fakespot_link_clicked
    ///
    /// The user clicked the "Fakespot by Mozilla" link in the shopping side
    /// bar.
    pub static surface_powered_by_fakespot_link_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(168.into(), CommonMetricData {
            name: "surface_powered_by_fakespot_link_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_reactivated_button_clicked
    ///
    /// The user clicked the reactivated product button.
    pub static surface_reactivated_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(169.into(), CommonMetricData {
            name: "surface_reactivated_button_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_reanalyze_clicked
    ///
    /// The user clicked to REanalyze reviews in the shopping side bar. This
    /// metric does not contain any information about the product the user is
    /// viewing or any displayed trusted deals.
    pub static surface_reanalyze_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(170.into(), CommonMetricData {
            name: "surface_reanalyze_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SurfaceSettingsExpandClickedExtra {
        pub action: Option<String>,
    }

    impl ExtraKeys for SurfaceSettingsExpandClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_settings_expand_clicked
    ///
    /// The user opened the settings menu of the shopping component.
    pub static surface_settings_expand_clicked: Lazy<EventMetric<SurfaceSettingsExpandClickedExtra>> = Lazy::new(|| {
        EventMetric::new(171.into(), CommonMetricData {
            name: "surface_settings_expand_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SurfaceShowMoreReviewsButtonClickedExtra {
        pub action: Option<String>,
    }

    impl ExtraKeys for SurfaceShowMoreReviewsButtonClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_more_reviews_button_clicked
    ///
    /// The user clicked to expand the recent reviews to see more.
    pub static surface_show_more_reviews_button_clicked: Lazy<EventMetric<SurfaceShowMoreReviewsButtonClickedExtra>> = Lazy::new(|| {
        EventMetric::new(172.into(), CommonMetricData {
            name: "surface_show_more_reviews_button_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_privacy_policy_clicked
    ///
    /// The user clicked to view the Privacy Policy.
    pub static surface_show_privacy_policy_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(173.into(), CommonMetricData {
            name: "surface_show_privacy_policy_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SurfaceShowQualityExplainerClickedExtra {
        pub action: Option<String>,
    }

    impl ExtraKeys for SurfaceShowQualityExplainerClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_quality_explainer_clicked
    ///
    /// The user clicked to see the explanation of Review Quality in the
    /// shopping component.
    pub static surface_show_quality_explainer_clicked: Lazy<EventMetric<SurfaceShowQualityExplainerClickedExtra>> = Lazy::new(|| {
        EventMetric::new(174.into(), CommonMetricData {
            name: "surface_show_quality_explainer_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_quality_explainer_url_clicked
    ///
    /// The user clicked to see the explanation of Review Quality in the
    /// shopping component.
    pub static surface_show_quality_explainer_url_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(175.into(), CommonMetricData {
            name: "surface_show_quality_explainer_url_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_terms_clicked
    ///
    /// The user clicked to view the Terms of Service.
    pub static surface_show_terms_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(176.into(), CommonMetricData {
            name: "surface_show_terms_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_stale_analysis_shown
    ///
    /// The user was shown the dialogue box indicating that analysis of a product
    /// was stale. No information about the product is included.
    pub static surface_stale_analysis_shown: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(177.into(), CommonMetricData {
            name: "surface_stale_analysis_shown".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_yes_keep_closed_button_clicked
    ///
    /// The user clicks the 'Yes, keep closed' button when asked if they want to
    /// disable auto-open behavior.
    pub static surface_yes_keep_closed_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(178.into(), CommonMetricData {
            name: "surface_yes_keep_closed_button_clicked".into(),
            category: "shopping".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod shopping_settings {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.auto_open_user_disabled
    ///
    /// Indicates if the user has manually disabled the auto open sidebar feature.
    /// Set during shopping component init and updated when changed in browser.
    pub static auto_open_user_disabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(179.into(), CommonMetricData {
            name: "auto_open_user_disabled".into(),
            category: "shopping.settings".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.component_opted_out
    ///
    /// Indicates if the user has opted out of using the shopping component.
    /// Set during shopping component init and updated when changed in browser.
    pub static component_opted_out: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(180.into(), CommonMetricData {
            name: "component_opted_out".into(),
            category: "shopping.settings".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.disabled_ads
    ///
    /// Indicates if the user has manually disabled ads. Set during shopping
    /// component init and updated when changed in browser.
    pub static disabled_ads: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(181.into(), CommonMetricData {
            name: "disabled_ads".into(),
            category: "shopping.settings".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.has_onboarded
    ///
    /// Indicates if the user has completed the Shopping product Onboarding
    /// experience. Set during shopping component init and updated when changed
    /// in browser.
    pub static has_onboarded: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(182.into(), CommonMetricData {
            name: "has_onboarded".into(),
            category: "shopping.settings".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.nimbus_disabled_shopping
    ///
    /// Indicates if Nimbus has disabled the use the shopping component.
    pub static nimbus_disabled_shopping: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(183.into(), CommonMetricData {
            name: "nimbus_disabled_shopping".into(),
            category: "shopping.settings".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod quick_suggest {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.advertiser
    ///
    /// The name of the advertiser providing the sponsored TopSite.
    pub static advertiser: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(184.into(), CommonMetricData {
            name: "advertiser".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.block_id
    ///
    /// A unique identifier for the suggestion (a.k.a. a keywords block).
    pub static block_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(185.into(), CommonMetricData {
            name: "block_id".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.context_id
    ///
    /// An identifier to identify users for Contextual Services user interaction pings.
    pub static context_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(186.into(), CommonMetricData {
            name: "context_id".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.iab_category
    ///
    /// The suggestion's category. Either "22 - Shopping" or "5 - Educational".
    pub static iab_category: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(187.into(), CommonMetricData {
            name: "iab_category".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.improve_suggest_experience
    ///
    /// Whether the "Improve Suggest Experience" checkbox is checked.
    pub static improve_suggest_experience: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(188.into(), CommonMetricData {
            name: "improve_suggest_experience".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.is_clicked
    ///
    /// Whether this quicksuggest-impression ping was for an item that was clicked.
    pub static is_clicked: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(189.into(), CommonMetricData {
            name: "is_clicked".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.match_type
    ///
    /// Whether this was a best/top match or not. Either "best-match" or "firefox-
    /// suggest".
    pub static match_type: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(190.into(), CommonMetricData {
            name: "match_type".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.ping_type
    ///
    /// The ping's type. In other situations might be designated by an event's name or
    /// an interaction field. E.g. "quicksuggest-impression", "quicksuggest-block",
    /// "quicksuggest-click".
    pub static ping_type: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(191.into(), CommonMetricData {
            name: "ping_type".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.position
    ///
    /// The position (1-based) of the QuickSuggest item being interatcted with.
    pub static position: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(192.into(), CommonMetricData {
            name: "position".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.reporting_url
    ///
    /// The url to report this interaction to.
    pub static reporting_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(193.into(), CommonMetricData {
            name: "reporting_url".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.request_id
    ///
    /// A request identifier for each API request to [Merino](https://mozilla-
    /// services.github.io/merino/). Only present for suggestions provided by Merino.
    pub static request_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(194.into(), CommonMetricData {
            name: "request_id".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.source
    ///
    /// The source of the interaction. E.g. "urlbar".
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(195.into(), CommonMetricData {
            name: "source".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.suggested_index
    ///
    /// A stringified integer value that is the intended index of the suggestion being
    /// interacted with. If `suggested_index_relative_to_group` is true, the index is
    /// relative to the "Firefox Suggest" group; otherwise the index is relative to the
    /// entire list of suggestions. Non-negative values (starting at 0) are relative to
    /// the start/top of the group/list; negative values are relative to the end/bottom
    /// of the group/list.
    pub static suggested_index: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(196.into(), CommonMetricData {
            name: "suggested_index".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.suggested_index_relative_to_group
    ///
    /// Whether `suggested_index` is relative to the "Firefox Suggest" group. If false,
    /// it is relative to the entire list of suggestions.
    pub static suggested_index_relative_to_group: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(197.into(), CommonMetricData {
            name: "suggested_index_relative_to_group".into(),
            category: "quick_suggest".into(),
            send_in_pings: vec!["quick-suggest".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod urlbar {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AbandonmentExtra {
        pub abandonment_type: Option<String>,
        pub groups: Option<String>,
        pub interaction: Option<String>,
        pub n_chars: Option<u32>,
        pub n_results: Option<u32>,
        pub n_words: Option<u32>,
        pub results: Option<String>,
        pub sap: Option<String>,
        pub search_engine_default_id: Option<String>,
        pub search_mode: Option<String>,
    }

    impl ExtraKeys for AbandonmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["abandonment_type", "groups", "interaction", "n_chars", "n_results", "n_words", "results", "sap", "search_engine_default_id", "search_mode"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.abandonment_type.and_then(|val| map.insert("abandonment_type".into(), val.to_string()));
          self.groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.search_engine_default_id.and_then(|val| map.insert("search_engine_default_id".into(), val.to_string()));
          self.search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.abandonment
    ///
    /// Recorded when the user abandons a search (blurring the urlbar).
    pub static abandonment: Lazy<EventMetric<AbandonmentExtra>> = Lazy::new(|| {
        EventMetric::new(198.into(), CommonMetricData {
            name: "abandonment".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EngagementExtra {
        pub engagement_type: Option<String>,
        pub groups: Option<String>,
        pub interaction: Option<String>,
        pub n_chars: Option<u32>,
        pub n_results: Option<u32>,
        pub n_words: Option<u32>,
        pub provider: Option<String>,
        pub results: Option<String>,
        pub sap: Option<String>,
        pub search_engine_default_id: Option<String>,
        pub search_mode: Option<String>,
        pub selected_position: Option<u32>,
        pub selected_result: Option<String>,
        pub selected_result_subtype: Option<String>,
    }

    impl ExtraKeys for EngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["engagement_type", "groups", "interaction", "n_chars", "n_results", "n_words", "provider", "results", "sap", "search_engine_default_id", "search_mode", "selected_position", "selected_result", "selected_result_subtype"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.engagement_type.and_then(|val| map.insert("engagement_type".into(), val.to_string()));
          self.groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.search_engine_default_id.and_then(|val| map.insert("search_engine_default_id".into(), val.to_string()));
          self.search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          self.selected_position.and_then(|val| map.insert("selected_position".into(), val.to_string()));
          self.selected_result.and_then(|val| map.insert("selected_result".into(), val.to_string()));
          self.selected_result_subtype.and_then(|val| map.insert("selected_result_subtype".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.engagement
    ///
    /// Recorded when the user executes an action on a result.
    pub static engagement: Lazy<EventMetric<EngagementExtra>> = Lazy::new(|| {
        EventMetric::new(199.into(), CommonMetricData {
            name: "engagement".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ExposureExtra {
        pub results: Option<String>,
    }

    impl ExtraKeys for ExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["results"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.results.and_then(|val| map.insert("results".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.exposure
    ///
    /// Recorded when client is exposed to urlbar experiment results.
    pub static exposure: Lazy<EventMetric<ExposureExtra>> = Lazy::new(|| {
        EventMetric::new(200.into(), CommonMetricData {
            name: "exposure".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct PotentialExposureExtra {
        pub keyword: Option<String>,
        pub terminal: Option<bool>,
    }

    impl ExtraKeys for PotentialExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["keyword", "terminal"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.keyword.and_then(|val| map.insert("keyword".into(), val.to_string()));
          self.terminal.and_then(|val| map.insert("terminal".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.potential_exposure
    ///
    /// This event is recorded in the `urlbar-potential-exposure` ping, which is
    /// submitted at the end of urlbar sessions during which the user typed a keyword
    /// defined by the Nimbus variable `potentialExposureKeywords`. A "session" begins
    /// when the user focuses the urlbar and ends with an engagement or abandonment.
    /// The ping will contain one event per unique keyword that is typed during the
    /// session. This ping is not submitted for sessions in private windows.
    pub static potential_exposure: Lazy<EventMetric<PotentialExposureExtra>> = Lazy::new(|| {
        EventMetric::new(201.into(), CommonMetricData {
            name: "potential_exposure".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["urlbar-potential-exposure".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_max_results
    ///
    /// Maximum results to show in the Address Bar. Corresponds to the value of the
    /// `browser.urlbar.maxRichResults` pref.
    pub static pref_max_results: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(202.into(), CommonMetricData {
            name: "pref_max_results".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_data_collection
    ///
    /// Whether the user has opted in to data collection for Firefox Suggest, i.e.,
    /// online suggestions served from Merino. Corresponds to the value of the
    /// `browser.urlbar.quicksuggest.dataCollection.enabled` pref.
    pub static pref_suggest_data_collection: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(203.into(), CommonMetricData {
            name: "pref_suggest_data_collection".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_nonsponsored
    ///
    /// Whether non-sponsored quick suggest results are shown in the urlbar.
    /// Corresponds to the value of the
    /// `browser.urlbar.suggest.quicksuggest.nonsponsored` pref.
    pub static pref_suggest_nonsponsored: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(204.into(), CommonMetricData {
            name: "pref_suggest_nonsponsored".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_sponsored
    ///
    /// Whether sponsored quick suggest results are shown in the urlbar. Corresponds to
    /// the value of the `browser.urlbar.suggest.quicksuggest.sponsored` pref.
    pub static pref_suggest_sponsored: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(205.into(), CommonMetricData {
            name: "pref_suggest_sponsored".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_topsites
    ///
    /// Whether topsite results are enabled in the urlbar. Corresponds to the value of
    /// the `browser.urlbar.suggest.topsites` pref.
    pub static pref_suggest_topsites: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(206.into(), CommonMetricData {
            name: "pref_suggest_topsites".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct QuickSuggestContextualOptInExtra {
        pub interaction: Option<String>,
        pub say_hello: Option<bool>,
        pub top_position: Option<bool>,
    }

    impl ExtraKeys for QuickSuggestContextualOptInExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["interaction", "say_hello", "top_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.say_hello.and_then(|val| map.insert("say_hello".into(), val.to_string()));
          self.top_position.and_then(|val| map.insert("top_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.quick_suggest_contextual_opt_in
    ///
    /// Recorded when the contextual opt-in UI is shown or interacted with.
    pub static quick_suggest_contextual_opt_in: Lazy<EventMetric<QuickSuggestContextualOptInExtra>> = Lazy::new(|| {
        EventMetric::new(207.into(), CommonMetricData {
            name: "quick_suggest_contextual_opt_in".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod browser_engagement {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.active_ticks
    ///
    /// The number of five-second intervals ('ticks') the user was considered
    /// 'active'.
    /// 
    /// 'active' means keyboard or mouse interaction with the application.
    /// It doesn't take into account whether or not the window has focus or is in
    /// the foreground, only if it is receiving these interaction events.
    /// 
    /// Migrated from Telemetry's `browser.engagement.active_ticks`.
    pub static active_ticks: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(208.into(), CommonMetricData {
            name: "active_ticks".into(),
            category: "browser.engagement".into(),
            send_in_pings: vec!["baseline".into(), "metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.profile_count
    ///
    /// Windows only count of the browser profiles on the current system. This
    /// counts profiles that have been used across all Windows user accounts on
    /// machine since this probe was added. The value persists across installs.
    /// A value of 0 is reported if there is an error determining the correct
    /// count. Unset on other platforms.
    pub static profile_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(209.into(), CommonMetricData {
            name: "profile_count".into(),
            category: "browser.engagement".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.uri_count
    ///
    /// The number of total non-unique http(s) URIs visited, including page
    /// reloads, after the session has been restored. URIs on minimized or
    /// background tabs may also be counted. Private browsing uris are included.
    /// 
    /// Migrated from Telemetry's
    /// `browser.engagement.total_uri_count_normal_and_private_mode`.
    pub static uri_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(210.into(), CommonMetricData {
            name: "uri_count".into(),
            category: "browser.engagement".into(),
            send_in_pings: vec!["baseline".into(), "metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod browser_usage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct InteractionExtra {
        pub flow_id: Option<String>,
        pub source: Option<String>,
        pub widget_id: Option<String>,
    }

    impl ExtraKeys for InteractionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "source", "widget_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.widget_id.and_then(|val| map.insert("widget_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.usage.interaction
    ///
    /// The user interacted with something in the Firefox Desktop frontend. Could be
    /// via mouse or keyboard, could be a command or a UI element.
    pub static interaction: Lazy<EventMetric<InteractionExtra>> = Lazy::new(|| {
        EventMetric::new(211.into(), CommonMetricData {
            name: "interaction".into(),
            category: "browser.usage".into(),
            send_in_pings: vec!["prototype-no-code-events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod installation_first_seen {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.admin_user
    ///
    /// Whether the installer is running from an elevated admin user
    pub static admin_user: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(212.into(), CommonMetricData {
            name: "admin_user".into(),
            category: "installation.first_seen".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.default_path
    ///
    /// (optional, present if installer_type is "full") Whether the default path was
    /// used
    pub static default_path: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(213.into(), CommonMetricData {
            name: "default_path".into(),
            category: "installation.first_seen".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.failure_reason
    ///
    /// Only sent if unable to collect firstSeen data. Can have value "NotFoundError"
    /// if file not found or other values depending on the failure reason.
    pub static failure_reason: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(214.into(), CommonMetricData {
            name: "failure_reason".into(),
            category: "installation.first_seen".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.from_msi
    ///
    /// (optional, present if installer_type is "full") Whether this was an MSI install
    pub static from_msi: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(215.into(), CommonMetricData {
            name: "from_msi".into(),
            category: "installation.first_seen".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.install_existed
    ///
    /// Whether there was already an install in this location
    pub static install_existed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(216.into(), CommonMetricData {
            name: "install_existed".into(),
            category: "installation.first_seen".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.installer_type
    ///
    /// The type of installer used to install Firefox. The value is one of "stub",
    /// "full", or "msix"
    pub static installer_type: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(217.into(), CommonMetricData {
            name: "installer_type".into(),
            category: "installation.first_seen".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.other_inst
    ///
    /// Whether there was already any non-MSIX install on this system
    pub static other_inst: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(218.into(), CommonMetricData {
            name: "other_inst".into(),
            category: "installation.first_seen".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.other_msix_inst
    ///
    /// Whether there was already any MSIX install on this system
    pub static other_msix_inst: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(219.into(), CommonMetricData {
            name: "other_msix_inst".into(),
            category: "installation.first_seen".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.profdir_existed
    ///
    /// Whether the top-level profile directory existed
    pub static profdir_existed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(220.into(), CommonMetricData {
            name: "profdir_existed".into(),
            category: "installation.first_seen".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.silent
    ///
    /// (optional, present if installer_type is "full") Whether this was a silent
    /// install
    pub static silent: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(221.into(), CommonMetricData {
            name: "silent".into(),
            category: "installation.first_seen".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.version
    ///
    /// The application version installed by the installer (not necessarily the current
    /// version)
    pub static version: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(222.into(), CommonMetricData {
            name: "version".into(),
            category: "installation.first_seen".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod performance_interaction {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.interaction.tab_switch_composite
    ///
    /// Time between tab selection and first composite of the tab content onto the
    /// screen. (Migrated from the geckoview metric of the same name.)
    pub static tab_switch_composite: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(223.into(), CommonMetricData {
            name: "tab_switch_composite".into(),
            category: "performance.interaction".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.interaction.keypress_present_latency
    ///
    /// Time between receiving a keypress event in the event loop and compositing its
    /// result onto the screen. (Migrated from the geckoview metric of the same name).
    pub static keypress_present_latency: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(224.into(), CommonMetricData {
            name: "keypress_present_latency".into(),
            category: "performance.interaction".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.interaction.mouseup_click_present_latency
    ///
    /// Time between receiving a mouseup which follow by a mouseclick on the event loop
    /// and compositing its result onto the screen. (Migrated from the geckoview metric
    /// of the same name).
    pub static mouseup_click_present_latency: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(225.into(), CommonMetricData {
            name: "mouseup_click_present_latency".into(),
            category: "performance.interaction".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod performance_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.page.total_content_page_load
    ///
    /// Time to load all of a page's resources and render. (Migrated from the geckoview
    /// metric of the same name.)
    pub static total_content_page_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(226.into(), CommonMetricData {
            name: "total_content_page_load".into(),
            category: "performance.page".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.page.non_blank_paint
    ///
    /// The time between navigationStart and the first non-blank paint of a foreground
    /// root content document, in milliseconds. This only records documents that were
    /// in an active docshell throughout the whole time between navigation start and
    /// non-blank paint. The non-blank paint timestamp is taken during display list
    /// building and does not include rasterization or compositing of that paint.
    /// (Migrated from the geckoview metric of the same name.)
    pub static non_blank_paint: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(227.into(), CommonMetricData {
            name: "non_blank_paint".into(),
            category: "performance.page".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod use_counter {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.content_documents_destroyed
    ///
    /// A count of how many content documents were destroyed. Used to turn document use
    /// counters' counts into rates. Excludes documents for which we do not count use
    /// counters (See `Document::ShouldIncludeInTelemetry`).
    pub static content_documents_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            228,
            "use.counter",
            "content_documents_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.dedicated_workers_destroyed
    ///
    /// A count of how many `Dedicated`-kind workers were destroyed. Used to turn
    /// dedicated worker use counters' counts into rates. Excludes chrome workers.
    pub static dedicated_workers_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            229,
            "use.counter",
            "dedicated_workers_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.service_workers_destroyed
    ///
    /// A count of how many `Service`-kind workers were destroyed. Used to turn service
    /// worker use counters' counts into rates. Excludes chrome workers.
    pub static service_workers_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            230,
            "use.counter",
            "service_workers_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.shared_workers_destroyed
    ///
    /// A count of how many `Shared`-kind workers were destroyed. Used to turn shared
    /// worker use counters' counts into rates. Excludes chrome workers.
    pub static shared_workers_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            231,
            "use.counter",
            "shared_workers_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.top_level_content_documents_destroyed
    ///
    /// A count of how many "pages" were destroyed. Used to turn page use counters'
    /// counts into rates. Excludes pages that contain only documents for which we do
    /// not count use counters (See `Document::ShouldIncludeInTelemetry`).
    pub static top_level_content_documents_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            232,
            "use.counter",
            "top_level_content_documents_destroyed",
            "use-counters"
        )
    });

}
pub mod use_counter_css_doc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.alignment_baseline
    ///
    /// Whether a document used the (unknown, counted) CSS property alignment-baseline.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static alignment_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            233,
            "use.counter.css.doc",
            "alignment_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.background_repeat_x
    ///
    /// Whether a document used the (unknown, counted) CSS property background-
    /// repeat-x. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static background_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            234,
            "use.counter.css.doc",
            "background_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.background_repeat_y
    ///
    /// Whether a document used the (unknown, counted) CSS property background-
    /// repeat-y. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static background_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            235,
            "use.counter.css.doc",
            "background_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.baseline_shift
    ///
    /// Whether a document used the (unknown, counted) CSS property baseline-shift.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static baseline_shift: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            236,
            "use.counter.css.doc",
            "baseline_shift",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.buffered_rendering
    ///
    /// Whether a document used the (unknown, counted) CSS property buffered-rendering.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static buffered_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            237,
            "use.counter.css.doc",
            "buffered_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.color_rendering
    ///
    /// Whether a document used the (unknown, counted) CSS property color-rendering.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static color_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            238,
            "use.counter.css.doc",
            "color_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_accent_color
    ///
    /// Whether a document used the CSS property accent-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_accent_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            239,
            "use.counter.css.doc",
            "css_accent_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_align_content
    ///
    /// Whether a document used the CSS property align-content. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            240,
            "use.counter.css.doc",
            "css_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_align_items
    ///
    /// Whether a document used the CSS property align-items. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            241,
            "use.counter.css.doc",
            "css_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_align_self
    ///
    /// Whether a document used the CSS property align-self. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            242,
            "use.counter.css.doc",
            "css_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_all
    ///
    /// Whether a document used the CSS property all. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            243,
            "use.counter.css.doc",
            "css_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_anchor_name
    ///
    /// Whether a document used the CSS property anchor-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_anchor_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            244,
            "use.counter.css.doc",
            "css_anchor_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_anchor_scope
    ///
    /// Whether a document used the CSS property anchor-scope. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_anchor_scope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            245,
            "use.counter.css.doc",
            "css_anchor_scope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation
    ///
    /// Whether a document used the CSS property animation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            246,
            "use.counter.css.doc",
            "css_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_composition
    ///
    /// Whether a document used the CSS property animation-composition. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_composition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            247,
            "use.counter.css.doc",
            "css_animation_composition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_delay
    ///
    /// Whether a document used the CSS property animation-delay. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            248,
            "use.counter.css.doc",
            "css_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_direction
    ///
    /// Whether a document used the CSS property animation-direction. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            249,
            "use.counter.css.doc",
            "css_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_duration
    ///
    /// Whether a document used the CSS property animation-duration. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            250,
            "use.counter.css.doc",
            "css_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_fill_mode
    ///
    /// Whether a document used the CSS property animation-fill-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            251,
            "use.counter.css.doc",
            "css_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_iteration_count
    ///
    /// Whether a document used the CSS property animation-iteration-count. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            252,
            "use.counter.css.doc",
            "css_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_name
    ///
    /// Whether a document used the CSS property animation-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            253,
            "use.counter.css.doc",
            "css_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_play_state
    ///
    /// Whether a document used the CSS property animation-play-state. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            254,
            "use.counter.css.doc",
            "css_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_timeline
    ///
    /// Whether a document used the CSS property animation-timeline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            255,
            "use.counter.css.doc",
            "css_animation_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_timing_function
    ///
    /// Whether a document used the CSS property animation-timing-function. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            256,
            "use.counter.css.doc",
            "css_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_appearance
    ///
    /// Whether a document used the CSS property appearance. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            257,
            "use.counter.css.doc",
            "css_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_aspect_ratio
    ///
    /// Whether a document used the CSS property aspect-ratio. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_aspect_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            258,
            "use.counter.css.doc",
            "css_aspect_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_backdrop_filter
    ///
    /// Whether a document used the CSS property backdrop-filter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_backdrop_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            259,
            "use.counter.css.doc",
            "css_backdrop_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_backface_visibility
    ///
    /// Whether a document used the CSS property backface-visibility. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            260,
            "use.counter.css.doc",
            "css_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background
    ///
    /// Whether a document used the CSS property background. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            261,
            "use.counter.css.doc",
            "css_background",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_attachment
    ///
    /// Whether a document used the CSS property background-attachment. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_attachment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            262,
            "use.counter.css.doc",
            "css_background_attachment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_blend_mode
    ///
    /// Whether a document used the CSS property background-blend-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            263,
            "use.counter.css.doc",
            "css_background_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_clip
    ///
    /// Whether a document used the CSS property background-clip. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            264,
            "use.counter.css.doc",
            "css_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_color
    ///
    /// Whether a document used the CSS property background-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            265,
            "use.counter.css.doc",
            "css_background_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_image
    ///
    /// Whether a document used the CSS property background-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            266,
            "use.counter.css.doc",
            "css_background_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_origin
    ///
    /// Whether a document used the CSS property background-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            267,
            "use.counter.css.doc",
            "css_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_position
    ///
    /// Whether a document used the CSS property background-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            268,
            "use.counter.css.doc",
            "css_background_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_position_x
    ///
    /// Whether a document used the CSS property background-position-x. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            269,
            "use.counter.css.doc",
            "css_background_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_position_y
    ///
    /// Whether a document used the CSS property background-position-y. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            270,
            "use.counter.css.doc",
            "css_background_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_repeat
    ///
    /// Whether a document used the CSS property background-repeat. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            271,
            "use.counter.css.doc",
            "css_background_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_size
    ///
    /// Whether a document used the CSS property background-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            272,
            "use.counter.css.doc",
            "css_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_baseline_source
    ///
    /// Whether a document used the CSS property baseline-source. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_baseline_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            273,
            "use.counter.css.doc",
            "css_baseline_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_block_size
    ///
    /// Whether a document used the CSS property block-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            274,
            "use.counter.css.doc",
            "css_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border
    ///
    /// Whether a document used the CSS property border. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            275,
            "use.counter.css.doc",
            "css_border",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block
    ///
    /// Whether a document used the CSS property border-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            276,
            "use.counter.css.doc",
            "css_border_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_color
    ///
    /// Whether a document used the CSS property border-block-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            277,
            "use.counter.css.doc",
            "css_border_block_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end
    ///
    /// Whether a document used the CSS property border-block-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            278,
            "use.counter.css.doc",
            "css_border_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end_color
    ///
    /// Whether a document used the CSS property border-block-end-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            279,
            "use.counter.css.doc",
            "css_border_block_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end_style
    ///
    /// Whether a document used the CSS property border-block-end-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            280,
            "use.counter.css.doc",
            "css_border_block_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end_width
    ///
    /// Whether a document used the CSS property border-block-end-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            281,
            "use.counter.css.doc",
            "css_border_block_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start
    ///
    /// Whether a document used the CSS property border-block-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            282,
            "use.counter.css.doc",
            "css_border_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start_color
    ///
    /// Whether a document used the CSS property border-block-start-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            283,
            "use.counter.css.doc",
            "css_border_block_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start_style
    ///
    /// Whether a document used the CSS property border-block-start-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            284,
            "use.counter.css.doc",
            "css_border_block_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start_width
    ///
    /// Whether a document used the CSS property border-block-start-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            285,
            "use.counter.css.doc",
            "css_border_block_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_style
    ///
    /// Whether a document used the CSS property border-block-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            286,
            "use.counter.css.doc",
            "css_border_block_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_width
    ///
    /// Whether a document used the CSS property border-block-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            287,
            "use.counter.css.doc",
            "css_border_block_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom
    ///
    /// Whether a document used the CSS property border-bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            288,
            "use.counter.css.doc",
            "css_border_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_color
    ///
    /// Whether a document used the CSS property border-bottom-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            289,
            "use.counter.css.doc",
            "css_border_bottom_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_left_radius
    ///
    /// Whether a document used the CSS property border-bottom-left-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            290,
            "use.counter.css.doc",
            "css_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_right_radius
    ///
    /// Whether a document used the CSS property border-bottom-right-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            291,
            "use.counter.css.doc",
            "css_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_style
    ///
    /// Whether a document used the CSS property border-bottom-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            292,
            "use.counter.css.doc",
            "css_border_bottom_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_width
    ///
    /// Whether a document used the CSS property border-bottom-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            293,
            "use.counter.css.doc",
            "css_border_bottom_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_collapse
    ///
    /// Whether a document used the CSS property border-collapse. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            294,
            "use.counter.css.doc",
            "css_border_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_color
    ///
    /// Whether a document used the CSS property border-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            295,
            "use.counter.css.doc",
            "css_border_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_end_end_radius
    ///
    /// Whether a document used the CSS property border-end-end-radius. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_end_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            296,
            "use.counter.css.doc",
            "css_border_end_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_end_start_radius
    ///
    /// Whether a document used the CSS property border-end-start-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_end_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            297,
            "use.counter.css.doc",
            "css_border_end_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image
    ///
    /// Whether a document used the CSS property border-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            298,
            "use.counter.css.doc",
            "css_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_outset
    ///
    /// Whether a document used the CSS property border-image-outset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            299,
            "use.counter.css.doc",
            "css_border_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_repeat
    ///
    /// Whether a document used the CSS property border-image-repeat. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            300,
            "use.counter.css.doc",
            "css_border_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_slice
    ///
    /// Whether a document used the CSS property border-image-slice. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            301,
            "use.counter.css.doc",
            "css_border_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_source
    ///
    /// Whether a document used the CSS property border-image-source. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            302,
            "use.counter.css.doc",
            "css_border_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_width
    ///
    /// Whether a document used the CSS property border-image-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            303,
            "use.counter.css.doc",
            "css_border_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline
    ///
    /// Whether a document used the CSS property border-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            304,
            "use.counter.css.doc",
            "css_border_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_color
    ///
    /// Whether a document used the CSS property border-inline-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            305,
            "use.counter.css.doc",
            "css_border_inline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end
    ///
    /// Whether a document used the CSS property border-inline-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            306,
            "use.counter.css.doc",
            "css_border_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end_color
    ///
    /// Whether a document used the CSS property border-inline-end-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            307,
            "use.counter.css.doc",
            "css_border_inline_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end_style
    ///
    /// Whether a document used the CSS property border-inline-end-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            308,
            "use.counter.css.doc",
            "css_border_inline_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end_width
    ///
    /// Whether a document used the CSS property border-inline-end-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            309,
            "use.counter.css.doc",
            "css_border_inline_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start
    ///
    /// Whether a document used the CSS property border-inline-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            310,
            "use.counter.css.doc",
            "css_border_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start_color
    ///
    /// Whether a document used the CSS property border-inline-start-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            311,
            "use.counter.css.doc",
            "css_border_inline_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start_style
    ///
    /// Whether a document used the CSS property border-inline-start-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            312,
            "use.counter.css.doc",
            "css_border_inline_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start_width
    ///
    /// Whether a document used the CSS property border-inline-start-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            313,
            "use.counter.css.doc",
            "css_border_inline_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_style
    ///
    /// Whether a document used the CSS property border-inline-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            314,
            "use.counter.css.doc",
            "css_border_inline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_width
    ///
    /// Whether a document used the CSS property border-inline-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            315,
            "use.counter.css.doc",
            "css_border_inline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left
    ///
    /// Whether a document used the CSS property border-left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            316,
            "use.counter.css.doc",
            "css_border_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left_color
    ///
    /// Whether a document used the CSS property border-left-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            317,
            "use.counter.css.doc",
            "css_border_left_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left_style
    ///
    /// Whether a document used the CSS property border-left-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            318,
            "use.counter.css.doc",
            "css_border_left_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left_width
    ///
    /// Whether a document used the CSS property border-left-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            319,
            "use.counter.css.doc",
            "css_border_left_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_radius
    ///
    /// Whether a document used the CSS property border-radius. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            320,
            "use.counter.css.doc",
            "css_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right
    ///
    /// Whether a document used the CSS property border-right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            321,
            "use.counter.css.doc",
            "css_border_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right_color
    ///
    /// Whether a document used the CSS property border-right-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            322,
            "use.counter.css.doc",
            "css_border_right_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right_style
    ///
    /// Whether a document used the CSS property border-right-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            323,
            "use.counter.css.doc",
            "css_border_right_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right_width
    ///
    /// Whether a document used the CSS property border-right-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            324,
            "use.counter.css.doc",
            "css_border_right_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_spacing
    ///
    /// Whether a document used the CSS property border-spacing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            325,
            "use.counter.css.doc",
            "css_border_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_start_end_radius
    ///
    /// Whether a document used the CSS property border-start-end-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_start_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            326,
            "use.counter.css.doc",
            "css_border_start_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_start_start_radius
    ///
    /// Whether a document used the CSS property border-start-start-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_start_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            327,
            "use.counter.css.doc",
            "css_border_start_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_style
    ///
    /// Whether a document used the CSS property border-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            328,
            "use.counter.css.doc",
            "css_border_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top
    ///
    /// Whether a document used the CSS property border-top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            329,
            "use.counter.css.doc",
            "css_border_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_color
    ///
    /// Whether a document used the CSS property border-top-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            330,
            "use.counter.css.doc",
            "css_border_top_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_left_radius
    ///
    /// Whether a document used the CSS property border-top-left-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            331,
            "use.counter.css.doc",
            "css_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_right_radius
    ///
    /// Whether a document used the CSS property border-top-right-radius. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            332,
            "use.counter.css.doc",
            "css_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_style
    ///
    /// Whether a document used the CSS property border-top-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            333,
            "use.counter.css.doc",
            "css_border_top_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_width
    ///
    /// Whether a document used the CSS property border-top-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            334,
            "use.counter.css.doc",
            "css_border_top_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_width
    ///
    /// Whether a document used the CSS property border-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            335,
            "use.counter.css.doc",
            "css_border_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_bottom
    ///
    /// Whether a document used the CSS property bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            336,
            "use.counter.css.doc",
            "css_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_box_decoration_break
    ///
    /// Whether a document used the CSS property box-decoration-break. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            337,
            "use.counter.css.doc",
            "css_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_box_shadow
    ///
    /// Whether a document used the CSS property box-shadow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            338,
            "use.counter.css.doc",
            "css_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_box_sizing
    ///
    /// Whether a document used the CSS property box-sizing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            339,
            "use.counter.css.doc",
            "css_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_break_after
    ///
    /// Whether a document used the CSS property break-after. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            340,
            "use.counter.css.doc",
            "css_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_break_before
    ///
    /// Whether a document used the CSS property break-before. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            341,
            "use.counter.css.doc",
            "css_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_break_inside
    ///
    /// Whether a document used the CSS property break-inside. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            342,
            "use.counter.css.doc",
            "css_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_caption_side
    ///
    /// Whether a document used the CSS property caption-side. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_caption_side: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            343,
            "use.counter.css.doc",
            "css_caption_side",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_caret_color
    ///
    /// Whether a document used the CSS property caret-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_caret_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            344,
            "use.counter.css.doc",
            "css_caret_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clear
    ///
    /// Whether a document used the CSS property clear. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            345,
            "use.counter.css.doc",
            "css_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clip
    ///
    /// Whether a document used the CSS property clip. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            346,
            "use.counter.css.doc",
            "css_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clip_path
    ///
    /// Whether a document used the CSS property clip-path. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            347,
            "use.counter.css.doc",
            "css_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clip_rule
    ///
    /// Whether a document used the CSS property clip-rule. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clip_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            348,
            "use.counter.css.doc",
            "css_clip_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color
    ///
    /// Whether a document used the CSS property color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            349,
            "use.counter.css.doc",
            "css_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_adjust
    ///
    /// Whether a document used the CSS property color-adjust. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            350,
            "use.counter.css.doc",
            "css_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_interpolation
    ///
    /// Whether a document used the CSS property color-interpolation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_interpolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            351,
            "use.counter.css.doc",
            "css_color_interpolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_interpolation_filters
    ///
    /// Whether a document used the CSS property color-interpolation-filters. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_interpolation_filters: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            352,
            "use.counter.css.doc",
            "css_color_interpolation_filters",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_scheme
    ///
    /// Whether a document used the CSS property color-scheme. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_scheme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            353,
            "use.counter.css.doc",
            "css_color_scheme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_count
    ///
    /// Whether a document used the CSS property column-count. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            354,
            "use.counter.css.doc",
            "css_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_fill
    ///
    /// Whether a document used the CSS property column-fill. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            355,
            "use.counter.css.doc",
            "css_column_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_gap
    ///
    /// Whether a document used the CSS property column-gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            356,
            "use.counter.css.doc",
            "css_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule
    ///
    /// Whether a document used the CSS property column-rule. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            357,
            "use.counter.css.doc",
            "css_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule_color
    ///
    /// Whether a document used the CSS property column-rule-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            358,
            "use.counter.css.doc",
            "css_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule_style
    ///
    /// Whether a document used the CSS property column-rule-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            359,
            "use.counter.css.doc",
            "css_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule_width
    ///
    /// Whether a document used the CSS property column-rule-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            360,
            "use.counter.css.doc",
            "css_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_span
    ///
    /// Whether a document used the CSS property column-span. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            361,
            "use.counter.css.doc",
            "css_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_width
    ///
    /// Whether a document used the CSS property column-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            362,
            "use.counter.css.doc",
            "css_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_columns
    ///
    /// Whether a document used the CSS property columns. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            363,
            "use.counter.css.doc",
            "css_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain
    ///
    /// Whether a document used the CSS property contain. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            364,
            "use.counter.css.doc",
            "css_contain",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_block_size
    ///
    /// Whether a document used the CSS property contain-intrinsic-block-size. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            365,
            "use.counter.css.doc",
            "css_contain_intrinsic_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_height
    ///
    /// Whether a document used the CSS property contain-intrinsic-height. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            366,
            "use.counter.css.doc",
            "css_contain_intrinsic_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_inline_size
    ///
    /// Whether a document used the CSS property contain-intrinsic-inline-size. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            367,
            "use.counter.css.doc",
            "css_contain_intrinsic_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_size
    ///
    /// Whether a document used the CSS property contain-intrinsic-size. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            368,
            "use.counter.css.doc",
            "css_contain_intrinsic_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_width
    ///
    /// Whether a document used the CSS property contain-intrinsic-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            369,
            "use.counter.css.doc",
            "css_contain_intrinsic_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_container
    ///
    /// Whether a document used the CSS property container. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_container: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            370,
            "use.counter.css.doc",
            "css_container",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_container_name
    ///
    /// Whether a document used the CSS property container-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_container_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            371,
            "use.counter.css.doc",
            "css_container_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_container_type
    ///
    /// Whether a document used the CSS property container-type. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_container_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            372,
            "use.counter.css.doc",
            "css_container_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_content
    ///
    /// Whether a document used the CSS property content. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            373,
            "use.counter.css.doc",
            "css_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_content_visibility
    ///
    /// Whether a document used the CSS property content-visibility. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_content_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            374,
            "use.counter.css.doc",
            "css_content_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_counter_increment
    ///
    /// Whether a document used the CSS property counter-increment. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_counter_increment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            375,
            "use.counter.css.doc",
            "css_counter_increment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_counter_reset
    ///
    /// Whether a document used the CSS property counter-reset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_counter_reset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            376,
            "use.counter.css.doc",
            "css_counter_reset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_counter_set
    ///
    /// Whether a document used the CSS property counter-set. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_counter_set: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            377,
            "use.counter.css.doc",
            "css_counter_set",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_cursor
    ///
    /// Whether a document used the CSS property cursor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_cursor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            378,
            "use.counter.css.doc",
            "css_cursor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_cx
    ///
    /// Whether a document used the CSS property cx. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_cx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            379,
            "use.counter.css.doc",
            "css_cx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_cy
    ///
    /// Whether a document used the CSS property cy. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_cy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            380,
            "use.counter.css.doc",
            "css_cy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_d
    ///
    /// Whether a document used the CSS property d. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            381,
            "use.counter.css.doc",
            "css_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_direction
    ///
    /// Whether a document used the CSS property direction. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            382,
            "use.counter.css.doc",
            "css_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_display
    ///
    /// Whether a document used the CSS property display. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_display: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            383,
            "use.counter.css.doc",
            "css_display",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_dominant_baseline
    ///
    /// Whether a document used the CSS property dominant-baseline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_dominant_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            384,
            "use.counter.css.doc",
            "css_dominant_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_empty_cells
    ///
    /// Whether a document used the CSS property empty-cells. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_empty_cells: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            385,
            "use.counter.css.doc",
            "css_empty_cells",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_fill
    ///
    /// Whether a document used the CSS property fill. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            386,
            "use.counter.css.doc",
            "css_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_fill_opacity
    ///
    /// Whether a document used the CSS property fill-opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_fill_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            387,
            "use.counter.css.doc",
            "css_fill_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_fill_rule
    ///
    /// Whether a document used the CSS property fill-rule. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_fill_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            388,
            "use.counter.css.doc",
            "css_fill_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_filter
    ///
    /// Whether a document used the CSS property filter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            389,
            "use.counter.css.doc",
            "css_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex
    ///
    /// Whether a document used the CSS property flex. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            390,
            "use.counter.css.doc",
            "css_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_basis
    ///
    /// Whether a document used the CSS property flex-basis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            391,
            "use.counter.css.doc",
            "css_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_direction
    ///
    /// Whether a document used the CSS property flex-direction. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            392,
            "use.counter.css.doc",
            "css_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_flow
    ///
    /// Whether a document used the CSS property flex-flow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            393,
            "use.counter.css.doc",
            "css_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_grow
    ///
    /// Whether a document used the CSS property flex-grow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            394,
            "use.counter.css.doc",
            "css_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_shrink
    ///
    /// Whether a document used the CSS property flex-shrink. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            395,
            "use.counter.css.doc",
            "css_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_wrap
    ///
    /// Whether a document used the CSS property flex-wrap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            396,
            "use.counter.css.doc",
            "css_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_float
    ///
    /// Whether a document used the CSS property float. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_float: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            397,
            "use.counter.css.doc",
            "css_float",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flood_color
    ///
    /// Whether a document used the CSS property flood-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flood_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            398,
            "use.counter.css.doc",
            "css_flood_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flood_opacity
    ///
    /// Whether a document used the CSS property flood-opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flood_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            399,
            "use.counter.css.doc",
            "css_flood_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font
    ///
    /// Whether a document used the CSS property font. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            400,
            "use.counter.css.doc",
            "css_font",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_family
    ///
    /// Whether a document used the CSS property font-family. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_family: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            401,
            "use.counter.css.doc",
            "css_font_family",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_feature_settings
    ///
    /// Whether a document used the CSS property font-feature-settings. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            402,
            "use.counter.css.doc",
            "css_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_kerning
    ///
    /// Whether a document used the CSS property font-kerning. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_kerning: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            403,
            "use.counter.css.doc",
            "css_font_kerning",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_language_override
    ///
    /// Whether a document used the CSS property font-language-override. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            404,
            "use.counter.css.doc",
            "css_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_optical_sizing
    ///
    /// Whether a document used the CSS property font-optical-sizing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_optical_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            405,
            "use.counter.css.doc",
            "css_font_optical_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_palette
    ///
    /// Whether a document used the CSS property font-palette. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_palette: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            406,
            "use.counter.css.doc",
            "css_font_palette",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_size
    ///
    /// Whether a document used the CSS property font-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            407,
            "use.counter.css.doc",
            "css_font_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_size_adjust
    ///
    /// Whether a document used the CSS property font-size-adjust. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            408,
            "use.counter.css.doc",
            "css_font_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_stretch
    ///
    /// Whether a document used the CSS property font-stretch. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_stretch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            409,
            "use.counter.css.doc",
            "css_font_stretch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_style
    ///
    /// Whether a document used the CSS property font-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            410,
            "use.counter.css.doc",
            "css_font_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis
    ///
    /// Whether a document used the CSS property font-synthesis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            411,
            "use.counter.css.doc",
            "css_font_synthesis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_position
    ///
    /// Whether a document used the CSS property font-synthesis-position. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            412,
            "use.counter.css.doc",
            "css_font_synthesis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_small_caps
    ///
    /// Whether a document used the CSS property font-synthesis-small-caps. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_small_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            413,
            "use.counter.css.doc",
            "css_font_synthesis_small_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_style
    ///
    /// Whether a document used the CSS property font-synthesis-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            414,
            "use.counter.css.doc",
            "css_font_synthesis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_weight
    ///
    /// Whether a document used the CSS property font-synthesis-weight. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            415,
            "use.counter.css.doc",
            "css_font_synthesis_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant
    ///
    /// Whether a document used the CSS property font-variant. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            416,
            "use.counter.css.doc",
            "css_font_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_alternates
    ///
    /// Whether a document used the CSS property font-variant-alternates. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_alternates: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            417,
            "use.counter.css.doc",
            "css_font_variant_alternates",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_caps
    ///
    /// Whether a document used the CSS property font-variant-caps. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            418,
            "use.counter.css.doc",
            "css_font_variant_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_east_asian
    ///
    /// Whether a document used the CSS property font-variant-east-asian. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_east_asian: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            419,
            "use.counter.css.doc",
            "css_font_variant_east_asian",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_emoji
    ///
    /// Whether a document used the CSS property font-variant-emoji. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_emoji: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            420,
            "use.counter.css.doc",
            "css_font_variant_emoji",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_ligatures
    ///
    /// Whether a document used the CSS property font-variant-ligatures. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_ligatures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            421,
            "use.counter.css.doc",
            "css_font_variant_ligatures",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_numeric
    ///
    /// Whether a document used the CSS property font-variant-numeric. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_numeric: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            422,
            "use.counter.css.doc",
            "css_font_variant_numeric",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_position
    ///
    /// Whether a document used the CSS property font-variant-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            423,
            "use.counter.css.doc",
            "css_font_variant_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variation_settings
    ///
    /// Whether a document used the CSS property font-variation-settings. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variation_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            424,
            "use.counter.css.doc",
            "css_font_variation_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_weight
    ///
    /// Whether a document used the CSS property font-weight. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            425,
            "use.counter.css.doc",
            "css_font_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_forced_color_adjust
    ///
    /// Whether a document used the CSS property forced-color-adjust. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_forced_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            426,
            "use.counter.css.doc",
            "css_forced_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_gap
    ///
    /// Whether a document used the CSS property gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            427,
            "use.counter.css.doc",
            "css_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid
    ///
    /// Whether a document used the CSS property grid. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            428,
            "use.counter.css.doc",
            "css_grid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_area
    ///
    /// Whether a document used the CSS property grid-area. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            429,
            "use.counter.css.doc",
            "css_grid_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_auto_columns
    ///
    /// Whether a document used the CSS property grid-auto-columns. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            430,
            "use.counter.css.doc",
            "css_grid_auto_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_auto_flow
    ///
    /// Whether a document used the CSS property grid-auto-flow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            431,
            "use.counter.css.doc",
            "css_grid_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_auto_rows
    ///
    /// Whether a document used the CSS property grid-auto-rows. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            432,
            "use.counter.css.doc",
            "css_grid_auto_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column
    ///
    /// Whether a document used the CSS property grid-column. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            433,
            "use.counter.css.doc",
            "css_grid_column",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column_end
    ///
    /// Whether a document used the CSS property grid-column-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            434,
            "use.counter.css.doc",
            "css_grid_column_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column_gap
    ///
    /// Whether a document used the CSS property grid-column-gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            435,
            "use.counter.css.doc",
            "css_grid_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column_start
    ///
    /// Whether a document used the CSS property grid-column-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            436,
            "use.counter.css.doc",
            "css_grid_column_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_gap
    ///
    /// Whether a document used the CSS property grid-gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            437,
            "use.counter.css.doc",
            "css_grid_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row
    ///
    /// Whether a document used the CSS property grid-row. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            438,
            "use.counter.css.doc",
            "css_grid_row",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row_end
    ///
    /// Whether a document used the CSS property grid-row-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            439,
            "use.counter.css.doc",
            "css_grid_row_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row_gap
    ///
    /// Whether a document used the CSS property grid-row-gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            440,
            "use.counter.css.doc",
            "css_grid_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row_start
    ///
    /// Whether a document used the CSS property grid-row-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            441,
            "use.counter.css.doc",
            "css_grid_row_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template
    ///
    /// Whether a document used the CSS property grid-template. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            442,
            "use.counter.css.doc",
            "css_grid_template",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template_areas
    ///
    /// Whether a document used the CSS property grid-template-areas. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_areas: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            443,
            "use.counter.css.doc",
            "css_grid_template_areas",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template_columns
    ///
    /// Whether a document used the CSS property grid-template-columns. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            444,
            "use.counter.css.doc",
            "css_grid_template_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template_rows
    ///
    /// Whether a document used the CSS property grid-template-rows. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            445,
            "use.counter.css.doc",
            "css_grid_template_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_height
    ///
    /// Whether a document used the CSS property height. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            446,
            "use.counter.css.doc",
            "css_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_hyphenate_character
    ///
    /// Whether a document used the CSS property hyphenate-character. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            447,
            "use.counter.css.doc",
            "css_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_hyphens
    ///
    /// Whether a document used the CSS property hyphens. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            448,
            "use.counter.css.doc",
            "css_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_image_orientation
    ///
    /// Whether a document used the CSS property image-orientation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_image_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            449,
            "use.counter.css.doc",
            "css_image_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_image_rendering
    ///
    /// Whether a document used the CSS property image-rendering. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_image_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            450,
            "use.counter.css.doc",
            "css_image_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ime_mode
    ///
    /// Whether a document used the CSS property ime-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ime_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            451,
            "use.counter.css.doc",
            "css_ime_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_initial_letter
    ///
    /// Whether a document used the CSS property initial-letter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_initial_letter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            452,
            "use.counter.css.doc",
            "css_initial_letter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inline_size
    ///
    /// Whether a document used the CSS property inline-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            453,
            "use.counter.css.doc",
            "css_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset
    ///
    /// Whether a document used the CSS property inset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            454,
            "use.counter.css.doc",
            "css_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_area
    ///
    /// Whether a document used the CSS property inset-area. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            455,
            "use.counter.css.doc",
            "css_inset_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_block
    ///
    /// Whether a document used the CSS property inset-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            456,
            "use.counter.css.doc",
            "css_inset_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_block_end
    ///
    /// Whether a document used the CSS property inset-block-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            457,
            "use.counter.css.doc",
            "css_inset_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_block_start
    ///
    /// Whether a document used the CSS property inset-block-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            458,
            "use.counter.css.doc",
            "css_inset_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_inline
    ///
    /// Whether a document used the CSS property inset-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            459,
            "use.counter.css.doc",
            "css_inset_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_inline_end
    ///
    /// Whether a document used the CSS property inset-inline-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            460,
            "use.counter.css.doc",
            "css_inset_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_inline_start
    ///
    /// Whether a document used the CSS property inset-inline-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            461,
            "use.counter.css.doc",
            "css_inset_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_isolation
    ///
    /// Whether a document used the CSS property isolation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_isolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            462,
            "use.counter.css.doc",
            "css_isolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_justify_content
    ///
    /// Whether a document used the CSS property justify-content. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            463,
            "use.counter.css.doc",
            "css_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_justify_items
    ///
    /// Whether a document used the CSS property justify-items. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_justify_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            464,
            "use.counter.css.doc",
            "css_justify_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_justify_self
    ///
    /// Whether a document used the CSS property justify-self. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_justify_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            465,
            "use.counter.css.doc",
            "css_justify_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_left
    ///
    /// Whether a document used the CSS property left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            466,
            "use.counter.css.doc",
            "css_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_letter_spacing
    ///
    /// Whether a document used the CSS property letter-spacing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_letter_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            467,
            "use.counter.css.doc",
            "css_letter_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_lighting_color
    ///
    /// Whether a document used the CSS property lighting-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_lighting_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            468,
            "use.counter.css.doc",
            "css_lighting_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_line_break
    ///
    /// Whether a document used the CSS property line-break. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            469,
            "use.counter.css.doc",
            "css_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_line_height
    ///
    /// Whether a document used the CSS property line-height. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_line_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            470,
            "use.counter.css.doc",
            "css_line_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style
    ///
    /// Whether a document used the CSS property list-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            471,
            "use.counter.css.doc",
            "css_list_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style_image
    ///
    /// Whether a document used the CSS property list-style-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            472,
            "use.counter.css.doc",
            "css_list_style_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style_position
    ///
    /// Whether a document used the CSS property list-style-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            473,
            "use.counter.css.doc",
            "css_list_style_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style_type
    ///
    /// Whether a document used the CSS property list-style-type. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            474,
            "use.counter.css.doc",
            "css_list_style_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin
    ///
    /// Whether a document used the CSS property margin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            475,
            "use.counter.css.doc",
            "css_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_block
    ///
    /// Whether a document used the CSS property margin-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            476,
            "use.counter.css.doc",
            "css_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_block_end
    ///
    /// Whether a document used the CSS property margin-block-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            477,
            "use.counter.css.doc",
            "css_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_block_start
    ///
    /// Whether a document used the CSS property margin-block-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            478,
            "use.counter.css.doc",
            "css_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_bottom
    ///
    /// Whether a document used the CSS property margin-bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            479,
            "use.counter.css.doc",
            "css_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_inline
    ///
    /// Whether a document used the CSS property margin-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            480,
            "use.counter.css.doc",
            "css_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_inline_end
    ///
    /// Whether a document used the CSS property margin-inline-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            481,
            "use.counter.css.doc",
            "css_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_inline_start
    ///
    /// Whether a document used the CSS property margin-inline-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            482,
            "use.counter.css.doc",
            "css_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_left
    ///
    /// Whether a document used the CSS property margin-left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            483,
            "use.counter.css.doc",
            "css_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_right
    ///
    /// Whether a document used the CSS property margin-right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            484,
            "use.counter.css.doc",
            "css_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_top
    ///
    /// Whether a document used the CSS property margin-top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            485,
            "use.counter.css.doc",
            "css_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker
    ///
    /// Whether a document used the CSS property marker. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            486,
            "use.counter.css.doc",
            "css_marker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker_end
    ///
    /// Whether a document used the CSS property marker-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            487,
            "use.counter.css.doc",
            "css_marker_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker_mid
    ///
    /// Whether a document used the CSS property marker-mid. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker_mid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            488,
            "use.counter.css.doc",
            "css_marker_mid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker_start
    ///
    /// Whether a document used the CSS property marker-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            489,
            "use.counter.css.doc",
            "css_marker_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask
    ///
    /// Whether a document used the CSS property mask. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            490,
            "use.counter.css.doc",
            "css_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_clip
    ///
    /// Whether a document used the CSS property mask-clip. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            491,
            "use.counter.css.doc",
            "css_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_composite
    ///
    /// Whether a document used the CSS property mask-composite. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            492,
            "use.counter.css.doc",
            "css_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_image
    ///
    /// Whether a document used the CSS property mask-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            493,
            "use.counter.css.doc",
            "css_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_mode
    ///
    /// Whether a document used the CSS property mask-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            494,
            "use.counter.css.doc",
            "css_mask_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_origin
    ///
    /// Whether a document used the CSS property mask-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            495,
            "use.counter.css.doc",
            "css_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_position
    ///
    /// Whether a document used the CSS property mask-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            496,
            "use.counter.css.doc",
            "css_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_position_x
    ///
    /// Whether a document used the CSS property mask-position-x. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            497,
            "use.counter.css.doc",
            "css_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_position_y
    ///
    /// Whether a document used the CSS property mask-position-y. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            498,
            "use.counter.css.doc",
            "css_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_repeat
    ///
    /// Whether a document used the CSS property mask-repeat. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            499,
            "use.counter.css.doc",
            "css_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_size
    ///
    /// Whether a document used the CSS property mask-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            500,
            "use.counter.css.doc",
            "css_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_type
    ///
    /// Whether a document used the CSS property mask-type. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            501,
            "use.counter.css.doc",
            "css_mask_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_masonry_auto_flow
    ///
    /// Whether a document used the CSS property masonry-auto-flow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_masonry_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            502,
            "use.counter.css.doc",
            "css_masonry_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_math_depth
    ///
    /// Whether a document used the CSS property math-depth. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_math_depth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            503,
            "use.counter.css.doc",
            "css_math_depth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_math_style
    ///
    /// Whether a document used the CSS property math-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_math_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            504,
            "use.counter.css.doc",
            "css_math_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_block_size
    ///
    /// Whether a document used the CSS property max-block-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            505,
            "use.counter.css.doc",
            "css_max_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_height
    ///
    /// Whether a document used the CSS property max-height. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            506,
            "use.counter.css.doc",
            "css_max_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_inline_size
    ///
    /// Whether a document used the CSS property max-inline-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            507,
            "use.counter.css.doc",
            "css_max_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_width
    ///
    /// Whether a document used the CSS property max-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            508,
            "use.counter.css.doc",
            "css_max_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_block_size
    ///
    /// Whether a document used the CSS property min-block-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            509,
            "use.counter.css.doc",
            "css_min_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_height
    ///
    /// Whether a document used the CSS property min-height. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            510,
            "use.counter.css.doc",
            "css_min_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_inline_size
    ///
    /// Whether a document used the CSS property min-inline-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            511,
            "use.counter.css.doc",
            "css_min_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_width
    ///
    /// Whether a document used the CSS property min-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            512,
            "use.counter.css.doc",
            "css_min_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mix_blend_mode
    ///
    /// Whether a document used the CSS property mix-blend-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mix_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            513,
            "use.counter.css.doc",
            "css_mix_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation
    ///
    /// Whether a document used the CSS property -moz-animation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            514,
            "use.counter.css.doc",
            "css_moz_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_delay
    ///
    /// Whether a document used the CSS property -moz-animation-delay. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            515,
            "use.counter.css.doc",
            "css_moz_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_direction
    ///
    /// Whether a document used the CSS property -moz-animation-direction. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            516,
            "use.counter.css.doc",
            "css_moz_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_duration
    ///
    /// Whether a document used the CSS property -moz-animation-duration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            517,
            "use.counter.css.doc",
            "css_moz_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_fill_mode
    ///
    /// Whether a document used the CSS property -moz-animation-fill-mode. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            518,
            "use.counter.css.doc",
            "css_moz_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_iteration_count
    ///
    /// Whether a document used the CSS property -moz-animation-iteration-count.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            519,
            "use.counter.css.doc",
            "css_moz_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_name
    ///
    /// Whether a document used the CSS property -moz-animation-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            520,
            "use.counter.css.doc",
            "css_moz_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_play_state
    ///
    /// Whether a document used the CSS property -moz-animation-play-state. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            521,
            "use.counter.css.doc",
            "css_moz_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_timing_function
    ///
    /// Whether a document used the CSS property -moz-animation-timing-function.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            522,
            "use.counter.css.doc",
            "css_moz_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_appearance
    ///
    /// Whether a document used the CSS property -moz-appearance. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            523,
            "use.counter.css.doc",
            "css_moz_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_backface_visibility
    ///
    /// Whether a document used the CSS property -moz-backface-visibility. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            524,
            "use.counter.css.doc",
            "css_moz_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end
    ///
    /// Whether a document used the CSS property -moz-border-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            525,
            "use.counter.css.doc",
            "css_moz_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end_color
    ///
    /// Whether a document used the CSS property -moz-border-end-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            526,
            "use.counter.css.doc",
            "css_moz_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end_style
    ///
    /// Whether a document used the CSS property -moz-border-end-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            527,
            "use.counter.css.doc",
            "css_moz_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end_width
    ///
    /// Whether a document used the CSS property -moz-border-end-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            528,
            "use.counter.css.doc",
            "css_moz_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_image
    ///
    /// Whether a document used the CSS property -moz-border-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            529,
            "use.counter.css.doc",
            "css_moz_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start
    ///
    /// Whether a document used the CSS property -moz-border-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            530,
            "use.counter.css.doc",
            "css_moz_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start_color
    ///
    /// Whether a document used the CSS property -moz-border-start-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            531,
            "use.counter.css.doc",
            "css_moz_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start_style
    ///
    /// Whether a document used the CSS property -moz-border-start-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            532,
            "use.counter.css.doc",
            "css_moz_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start_width
    ///
    /// Whether a document used the CSS property -moz-border-start-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            533,
            "use.counter.css.doc",
            "css_moz_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_align
    ///
    /// Whether a document used the CSS property -moz-box-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            534,
            "use.counter.css.doc",
            "css_moz_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_collapse
    ///
    /// Whether a document used the CSS property -moz-box-collapse. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            535,
            "use.counter.css.doc",
            "css_moz_box_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_direction
    ///
    /// Whether a document used the CSS property -moz-box-direction. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            536,
            "use.counter.css.doc",
            "css_moz_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_flex
    ///
    /// Whether a document used the CSS property -moz-box-flex. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            537,
            "use.counter.css.doc",
            "css_moz_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_ordinal_group
    ///
    /// Whether a document used the CSS property -moz-box-ordinal-group. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            538,
            "use.counter.css.doc",
            "css_moz_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_orient
    ///
    /// Whether a document used the CSS property -moz-box-orient. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            539,
            "use.counter.css.doc",
            "css_moz_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_pack
    ///
    /// Whether a document used the CSS property -moz-box-pack. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            540,
            "use.counter.css.doc",
            "css_moz_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_sizing
    ///
    /// Whether a document used the CSS property -moz-box-sizing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            541,
            "use.counter.css.doc",
            "css_moz_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_context_properties
    ///
    /// Whether a document used the CSS property -moz-context-properties. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_context_properties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            542,
            "use.counter.css.doc",
            "css_moz_context_properties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_control_character_visibility
    ///
    /// Whether a document used the CSS property -moz-control-character-visibility.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_control_character_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            543,
            "use.counter.css.doc",
            "css_moz_control_character_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_default_appearance
    ///
    /// Whether a document used the CSS property -moz-default-appearance. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_default_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            544,
            "use.counter.css.doc",
            "css_moz_default_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_float_edge
    ///
    /// Whether a document used the CSS property -moz-float-edge. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_float_edge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            545,
            "use.counter.css.doc",
            "css_moz_float_edge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_font_feature_settings
    ///
    /// Whether a document used the CSS property -moz-font-feature-settings. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            546,
            "use.counter.css.doc",
            "css_moz_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_font_language_override
    ///
    /// Whether a document used the CSS property -moz-font-language-override. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            547,
            "use.counter.css.doc",
            "css_moz_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_force_broken_image_icon
    ///
    /// Whether a document used the CSS property -moz-force-broken-image-icon. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_force_broken_image_icon: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            548,
            "use.counter.css.doc",
            "css_moz_force_broken_image_icon",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_hyphens
    ///
    /// Whether a document used the CSS property -moz-hyphens. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            549,
            "use.counter.css.doc",
            "css_moz_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_inert
    ///
    /// Whether a document used the CSS property -moz-inert. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_inert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            550,
            "use.counter.css.doc",
            "css_moz_inert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_margin_end
    ///
    /// Whether a document used the CSS property -moz-margin-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            551,
            "use.counter.css.doc",
            "css_moz_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_margin_start
    ///
    /// Whether a document used the CSS property -moz-margin-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            552,
            "use.counter.css.doc",
            "css_moz_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_math_variant
    ///
    /// Whether a document used the CSS property -moz-math-variant. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            553,
            "use.counter.css.doc",
            "css_moz_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_min_font_size_ratio
    ///
    /// Whether a document used the CSS property -moz-min-font-size-ratio. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_min_font_size_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            554,
            "use.counter.css.doc",
            "css_moz_min_font_size_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_orient
    ///
    /// Whether a document used the CSS property -moz-orient. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            555,
            "use.counter.css.doc",
            "css_moz_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_osx_font_smoothing
    ///
    /// Whether a document used the CSS property -moz-osx-font-smoothing. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_osx_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            556,
            "use.counter.css.doc",
            "css_moz_osx_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_padding_end
    ///
    /// Whether a document used the CSS property -moz-padding-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            557,
            "use.counter.css.doc",
            "css_moz_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_padding_start
    ///
    /// Whether a document used the CSS property -moz-padding-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            558,
            "use.counter.css.doc",
            "css_moz_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_perspective
    ///
    /// Whether a document used the CSS property -moz-perspective. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            559,
            "use.counter.css.doc",
            "css_moz_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_perspective_origin
    ///
    /// Whether a document used the CSS property -moz-perspective-origin. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            560,
            "use.counter.css.doc",
            "css_moz_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_subtree_hidden_only_visually
    ///
    /// Whether a document used the CSS property -moz-subtree-hidden-only-visually.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_subtree_hidden_only_visually: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            561,
            "use.counter.css.doc",
            "css_moz_subtree_hidden_only_visually",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_tab_size
    ///
    /// Whether a document used the CSS property -moz-tab-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            562,
            "use.counter.css.doc",
            "css_moz_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_text_size_adjust
    ///
    /// Whether a document used the CSS property -moz-text-size-adjust. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            563,
            "use.counter.css.doc",
            "css_moz_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_theme
    ///
    /// Whether a document used the CSS property -moz-theme. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_theme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            564,
            "use.counter.css.doc",
            "css_moz_theme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_top_layer
    ///
    /// Whether a document used the CSS property -moz-top-layer. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_top_layer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            565,
            "use.counter.css.doc",
            "css_moz_top_layer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transform
    ///
    /// Whether a document used the CSS property -moz-transform. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            566,
            "use.counter.css.doc",
            "css_moz_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transform_origin
    ///
    /// Whether a document used the CSS property -moz-transform-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            567,
            "use.counter.css.doc",
            "css_moz_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transform_style
    ///
    /// Whether a document used the CSS property -moz-transform-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            568,
            "use.counter.css.doc",
            "css_moz_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition
    ///
    /// Whether a document used the CSS property -moz-transition. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            569,
            "use.counter.css.doc",
            "css_moz_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_delay
    ///
    /// Whether a document used the CSS property -moz-transition-delay. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            570,
            "use.counter.css.doc",
            "css_moz_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_duration
    ///
    /// Whether a document used the CSS property -moz-transition-duration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            571,
            "use.counter.css.doc",
            "css_moz_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_property
    ///
    /// Whether a document used the CSS property -moz-transition-property. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            572,
            "use.counter.css.doc",
            "css_moz_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_timing_function
    ///
    /// Whether a document used the CSS property -moz-transition-timing-function.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            573,
            "use.counter.css.doc",
            "css_moz_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_user_focus
    ///
    /// Whether a document used the CSS property -moz-user-focus. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_focus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            574,
            "use.counter.css.doc",
            "css_moz_user_focus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_user_input
    ///
    /// Whether a document used the CSS property -moz-user-input. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_input: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            575,
            "use.counter.css.doc",
            "css_moz_user_input",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_user_modify
    ///
    /// Whether a document used the CSS property -moz-user-modify. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_modify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            576,
            "use.counter.css.doc",
            "css_moz_user_modify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_user_select
    ///
    /// Whether a document used the CSS property -moz-user-select. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            577,
            "use.counter.css.doc",
            "css_moz_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_dragging
    ///
    /// Whether a document used the CSS property -moz-window-dragging. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_dragging: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            578,
            "use.counter.css.doc",
            "css_moz_window_dragging",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_input_region_margin
    ///
    /// Whether a document used the CSS property -moz-window-input-region-margin.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_window_input_region_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            579,
            "use.counter.css.doc",
            "css_moz_window_input_region_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_opacity
    ///
    /// Whether a document used the CSS property -moz-window-opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            580,
            "use.counter.css.doc",
            "css_moz_window_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_shadow
    ///
    /// Whether a document used the CSS property -moz-window-shadow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            581,
            "use.counter.css.doc",
            "css_moz_window_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_transform
    ///
    /// Whether a document used the CSS property -moz-window-transform. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            582,
            "use.counter.css.doc",
            "css_moz_window_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_transform_origin
    ///
    /// Whether a document used the CSS property -moz-window-transform-origin. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            583,
            "use.counter.css.doc",
            "css_moz_window_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_object_fit
    ///
    /// Whether a document used the CSS property object-fit. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_object_fit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            584,
            "use.counter.css.doc",
            "css_object_fit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_object_position
    ///
    /// Whether a document used the CSS property object-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_object_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            585,
            "use.counter.css.doc",
            "css_object_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset
    ///
    /// Whether a document used the CSS property offset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            586,
            "use.counter.css.doc",
            "css_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_anchor
    ///
    /// Whether a document used the CSS property offset-anchor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            587,
            "use.counter.css.doc",
            "css_offset_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_distance
    ///
    /// Whether a document used the CSS property offset-distance. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_distance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            588,
            "use.counter.css.doc",
            "css_offset_distance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_path
    ///
    /// Whether a document used the CSS property offset-path. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            589,
            "use.counter.css.doc",
            "css_offset_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_position
    ///
    /// Whether a document used the CSS property offset-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            590,
            "use.counter.css.doc",
            "css_offset_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_rotate
    ///
    /// Whether a document used the CSS property offset-rotate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            591,
            "use.counter.css.doc",
            "css_offset_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_opacity
    ///
    /// Whether a document used the CSS property opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            592,
            "use.counter.css.doc",
            "css_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_order
    ///
    /// Whether a document used the CSS property order. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            593,
            "use.counter.css.doc",
            "css_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline
    ///
    /// Whether a document used the CSS property outline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            594,
            "use.counter.css.doc",
            "css_outline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_color
    ///
    /// Whether a document used the CSS property outline-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            595,
            "use.counter.css.doc",
            "css_outline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_offset
    ///
    /// Whether a document used the CSS property outline-offset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            596,
            "use.counter.css.doc",
            "css_outline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_style
    ///
    /// Whether a document used the CSS property outline-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            597,
            "use.counter.css.doc",
            "css_outline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_width
    ///
    /// Whether a document used the CSS property outline-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            598,
            "use.counter.css.doc",
            "css_outline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow
    ///
    /// Whether a document used the CSS property overflow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            599,
            "use.counter.css.doc",
            "css_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_anchor
    ///
    /// Whether a document used the CSS property overflow-anchor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            600,
            "use.counter.css.doc",
            "css_overflow_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_block
    ///
    /// Whether a document used the CSS property overflow-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            601,
            "use.counter.css.doc",
            "css_overflow_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_box
    ///
    /// Whether a document used the CSS property overflow-clip-box. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            602,
            "use.counter.css.doc",
            "css_overflow_clip_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_box_block
    ///
    /// Whether a document used the CSS property overflow-clip-box-block. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            603,
            "use.counter.css.doc",
            "css_overflow_clip_box_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_box_inline
    ///
    /// Whether a document used the CSS property overflow-clip-box-inline. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            604,
            "use.counter.css.doc",
            "css_overflow_clip_box_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_margin
    ///
    /// Whether a document used the CSS property overflow-clip-margin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            605,
            "use.counter.css.doc",
            "css_overflow_clip_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_inline
    ///
    /// Whether a document used the CSS property overflow-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            606,
            "use.counter.css.doc",
            "css_overflow_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_wrap
    ///
    /// Whether a document used the CSS property overflow-wrap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            607,
            "use.counter.css.doc",
            "css_overflow_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_x
    ///
    /// Whether a document used the CSS property overflow-x. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            608,
            "use.counter.css.doc",
            "css_overflow_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_y
    ///
    /// Whether a document used the CSS property overflow-y. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            609,
            "use.counter.css.doc",
            "css_overflow_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior
    ///
    /// Whether a document used the CSS property overscroll-behavior. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            610,
            "use.counter.css.doc",
            "css_overscroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_block
    ///
    /// Whether a document used the CSS property overscroll-behavior-block. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            611,
            "use.counter.css.doc",
            "css_overscroll_behavior_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_inline
    ///
    /// Whether a document used the CSS property overscroll-behavior-inline. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            612,
            "use.counter.css.doc",
            "css_overscroll_behavior_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_x
    ///
    /// Whether a document used the CSS property overscroll-behavior-x. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            613,
            "use.counter.css.doc",
            "css_overscroll_behavior_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_y
    ///
    /// Whether a document used the CSS property overscroll-behavior-y. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            614,
            "use.counter.css.doc",
            "css_overscroll_behavior_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding
    ///
    /// Whether a document used the CSS property padding. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            615,
            "use.counter.css.doc",
            "css_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_block
    ///
    /// Whether a document used the CSS property padding-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            616,
            "use.counter.css.doc",
            "css_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_block_end
    ///
    /// Whether a document used the CSS property padding-block-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            617,
            "use.counter.css.doc",
            "css_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_block_start
    ///
    /// Whether a document used the CSS property padding-block-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            618,
            "use.counter.css.doc",
            "css_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_bottom
    ///
    /// Whether a document used the CSS property padding-bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            619,
            "use.counter.css.doc",
            "css_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_inline
    ///
    /// Whether a document used the CSS property padding-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            620,
            "use.counter.css.doc",
            "css_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_inline_end
    ///
    /// Whether a document used the CSS property padding-inline-end. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            621,
            "use.counter.css.doc",
            "css_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_inline_start
    ///
    /// Whether a document used the CSS property padding-inline-start. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            622,
            "use.counter.css.doc",
            "css_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_left
    ///
    /// Whether a document used the CSS property padding-left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            623,
            "use.counter.css.doc",
            "css_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_right
    ///
    /// Whether a document used the CSS property padding-right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            624,
            "use.counter.css.doc",
            "css_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_top
    ///
    /// Whether a document used the CSS property padding-top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            625,
            "use.counter.css.doc",
            "css_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page
    ///
    /// Whether a document used the CSS property page. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            626,
            "use.counter.css.doc",
            "css_page",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_break_after
    ///
    /// Whether a document used the CSS property page-break-after. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            627,
            "use.counter.css.doc",
            "css_page_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_break_before
    ///
    /// Whether a document used the CSS property page-break-before. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            628,
            "use.counter.css.doc",
            "css_page_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_break_inside
    ///
    /// Whether a document used the CSS property page-break-inside. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            629,
            "use.counter.css.doc",
            "css_page_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_orientation
    ///
    /// Whether a document used the CSS property page-orientation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            630,
            "use.counter.css.doc",
            "css_page_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_paint_order
    ///
    /// Whether a document used the CSS property paint-order. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_paint_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            631,
            "use.counter.css.doc",
            "css_paint_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_perspective
    ///
    /// Whether a document used the CSS property perspective. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            632,
            "use.counter.css.doc",
            "css_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_perspective_origin
    ///
    /// Whether a document used the CSS property perspective-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            633,
            "use.counter.css.doc",
            "css_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_place_content
    ///
    /// Whether a document used the CSS property place-content. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_place_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            634,
            "use.counter.css.doc",
            "css_place_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_place_items
    ///
    /// Whether a document used the CSS property place-items. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_place_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            635,
            "use.counter.css.doc",
            "css_place_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_place_self
    ///
    /// Whether a document used the CSS property place-self. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_place_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            636,
            "use.counter.css.doc",
            "css_place_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_pointer_events
    ///
    /// Whether a document used the CSS property pointer-events. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_pointer_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            637,
            "use.counter.css.doc",
            "css_pointer_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position
    ///
    /// Whether a document used the CSS property position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            638,
            "use.counter.css.doc",
            "css_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_anchor
    ///
    /// Whether a document used the CSS property position-anchor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            639,
            "use.counter.css.doc",
            "css_position_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_try_options
    ///
    /// Whether a document used the CSS property position-try-options. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_try_options: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            640,
            "use.counter.css.doc",
            "css_position_try_options",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_try_order
    ///
    /// Whether a document used the CSS property position-try-order. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_try_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            641,
            "use.counter.css.doc",
            "css_position_try_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_visibility
    ///
    /// Whether a document used the CSS property position-visibility. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            642,
            "use.counter.css.doc",
            "css_position_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_print_color_adjust
    ///
    /// Whether a document used the CSS property print-color-adjust. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            643,
            "use.counter.css.doc",
            "css_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_quotes
    ///
    /// Whether a document used the CSS property quotes. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_quotes: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            644,
            "use.counter.css.doc",
            "css_quotes",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_r
    ///
    /// Whether a document used the CSS property r. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_r: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            645,
            "use.counter.css.doc",
            "css_r",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_resize
    ///
    /// Whether a document used the CSS property resize. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_resize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            646,
            "use.counter.css.doc",
            "css_resize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_right
    ///
    /// Whether a document used the CSS property right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            647,
            "use.counter.css.doc",
            "css_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_rotate
    ///
    /// Whether a document used the CSS property rotate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            648,
            "use.counter.css.doc",
            "css_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_row_gap
    ///
    /// Whether a document used the CSS property row-gap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            649,
            "use.counter.css.doc",
            "css_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ruby_align
    ///
    /// Whether a document used the CSS property ruby-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ruby_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            650,
            "use.counter.css.doc",
            "css_ruby_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ruby_position
    ///
    /// Whether a document used the CSS property ruby-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            651,
            "use.counter.css.doc",
            "css_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_rx
    ///
    /// Whether a document used the CSS property rx. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_rx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            652,
            "use.counter.css.doc",
            "css_rx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ry
    ///
    /// Whether a document used the CSS property ry. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ry: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            653,
            "use.counter.css.doc",
            "css_ry",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scale
    ///
    /// Whether a document used the CSS property scale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            654,
            "use.counter.css.doc",
            "css_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_behavior
    ///
    /// Whether a document used the CSS property scroll-behavior. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            655,
            "use.counter.css.doc",
            "css_scroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin
    ///
    /// Whether a document used the CSS property scroll-margin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            656,
            "use.counter.css.doc",
            "css_scroll_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_block
    ///
    /// Whether a document used the CSS property scroll-margin-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            657,
            "use.counter.css.doc",
            "css_scroll_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_block_end
    ///
    /// Whether a document used the CSS property scroll-margin-block-end. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            658,
            "use.counter.css.doc",
            "css_scroll_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_block_start
    ///
    /// Whether a document used the CSS property scroll-margin-block-start. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            659,
            "use.counter.css.doc",
            "css_scroll_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_bottom
    ///
    /// Whether a document used the CSS property scroll-margin-bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            660,
            "use.counter.css.doc",
            "css_scroll_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_inline
    ///
    /// Whether a document used the CSS property scroll-margin-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            661,
            "use.counter.css.doc",
            "css_scroll_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_inline_end
    ///
    /// Whether a document used the CSS property scroll-margin-inline-end. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            662,
            "use.counter.css.doc",
            "css_scroll_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_inline_start
    ///
    /// Whether a document used the CSS property scroll-margin-inline-start. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            663,
            "use.counter.css.doc",
            "css_scroll_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_left
    ///
    /// Whether a document used the CSS property scroll-margin-left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            664,
            "use.counter.css.doc",
            "css_scroll_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_right
    ///
    /// Whether a document used the CSS property scroll-margin-right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            665,
            "use.counter.css.doc",
            "css_scroll_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_top
    ///
    /// Whether a document used the CSS property scroll-margin-top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            666,
            "use.counter.css.doc",
            "css_scroll_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding
    ///
    /// Whether a document used the CSS property scroll-padding. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            667,
            "use.counter.css.doc",
            "css_scroll_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_block
    ///
    /// Whether a document used the CSS property scroll-padding-block. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            668,
            "use.counter.css.doc",
            "css_scroll_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_block_end
    ///
    /// Whether a document used the CSS property scroll-padding-block-end. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            669,
            "use.counter.css.doc",
            "css_scroll_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_block_start
    ///
    /// Whether a document used the CSS property scroll-padding-block-start. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            670,
            "use.counter.css.doc",
            "css_scroll_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_bottom
    ///
    /// Whether a document used the CSS property scroll-padding-bottom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            671,
            "use.counter.css.doc",
            "css_scroll_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_inline
    ///
    /// Whether a document used the CSS property scroll-padding-inline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            672,
            "use.counter.css.doc",
            "css_scroll_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_inline_end
    ///
    /// Whether a document used the CSS property scroll-padding-inline-end. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            673,
            "use.counter.css.doc",
            "css_scroll_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_inline_start
    ///
    /// Whether a document used the CSS property scroll-padding-inline-start. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            674,
            "use.counter.css.doc",
            "css_scroll_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_left
    ///
    /// Whether a document used the CSS property scroll-padding-left. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            675,
            "use.counter.css.doc",
            "css_scroll_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_right
    ///
    /// Whether a document used the CSS property scroll-padding-right. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            676,
            "use.counter.css.doc",
            "css_scroll_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_top
    ///
    /// Whether a document used the CSS property scroll-padding-top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            677,
            "use.counter.css.doc",
            "css_scroll_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_snap_align
    ///
    /// Whether a document used the CSS property scroll-snap-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            678,
            "use.counter.css.doc",
            "css_scroll_snap_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_snap_stop
    ///
    /// Whether a document used the CSS property scroll-snap-stop. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_stop: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            679,
            "use.counter.css.doc",
            "css_scroll_snap_stop",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_snap_type
    ///
    /// Whether a document used the CSS property scroll-snap-type. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            680,
            "use.counter.css.doc",
            "css_scroll_snap_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_timeline
    ///
    /// Whether a document used the CSS property scroll-timeline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            681,
            "use.counter.css.doc",
            "css_scroll_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_timeline_axis
    ///
    /// Whether a document used the CSS property scroll-timeline-axis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            682,
            "use.counter.css.doc",
            "css_scroll_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_timeline_name
    ///
    /// Whether a document used the CSS property scroll-timeline-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            683,
            "use.counter.css.doc",
            "css_scroll_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scrollbar_color
    ///
    /// Whether a document used the CSS property scrollbar-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            684,
            "use.counter.css.doc",
            "css_scrollbar_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scrollbar_gutter
    ///
    /// Whether a document used the CSS property scrollbar-gutter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_gutter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            685,
            "use.counter.css.doc",
            "css_scrollbar_gutter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scrollbar_width
    ///
    /// Whether a document used the CSS property scrollbar-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            686,
            "use.counter.css.doc",
            "css_scrollbar_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_image_threshold
    ///
    /// Whether a document used the CSS property shape-image-threshold. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            687,
            "use.counter.css.doc",
            "css_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_margin
    ///
    /// Whether a document used the CSS property shape-margin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            688,
            "use.counter.css.doc",
            "css_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_outside
    ///
    /// Whether a document used the CSS property shape-outside. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            689,
            "use.counter.css.doc",
            "css_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_rendering
    ///
    /// Whether a document used the CSS property shape-rendering. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            690,
            "use.counter.css.doc",
            "css_shape_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_size
    ///
    /// Whether a document used the CSS property size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            691,
            "use.counter.css.doc",
            "css_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stop_color
    ///
    /// Whether a document used the CSS property stop-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stop_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            692,
            "use.counter.css.doc",
            "css_stop_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stop_opacity
    ///
    /// Whether a document used the CSS property stop-opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stop_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            693,
            "use.counter.css.doc",
            "css_stop_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke
    ///
    /// Whether a document used the CSS property stroke. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            694,
            "use.counter.css.doc",
            "css_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_dasharray
    ///
    /// Whether a document used the CSS property stroke-dasharray. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dasharray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            695,
            "use.counter.css.doc",
            "css_stroke_dasharray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_dashoffset
    ///
    /// Whether a document used the CSS property stroke-dashoffset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dashoffset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            696,
            "use.counter.css.doc",
            "css_stroke_dashoffset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_linecap
    ///
    /// Whether a document used the CSS property stroke-linecap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linecap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            697,
            "use.counter.css.doc",
            "css_stroke_linecap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_linejoin
    ///
    /// Whether a document used the CSS property stroke-linejoin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linejoin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            698,
            "use.counter.css.doc",
            "css_stroke_linejoin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_miterlimit
    ///
    /// Whether a document used the CSS property stroke-miterlimit. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_miterlimit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            699,
            "use.counter.css.doc",
            "css_stroke_miterlimit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_opacity
    ///
    /// Whether a document used the CSS property stroke-opacity. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            700,
            "use.counter.css.doc",
            "css_stroke_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_width
    ///
    /// Whether a document used the CSS property stroke-width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            701,
            "use.counter.css.doc",
            "css_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_tab_size
    ///
    /// Whether a document used the CSS property tab-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            702,
            "use.counter.css.doc",
            "css_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_table_layout
    ///
    /// Whether a document used the CSS property table-layout. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_table_layout: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            703,
            "use.counter.css.doc",
            "css_table_layout",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_align
    ///
    /// Whether a document used the CSS property text-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            704,
            "use.counter.css.doc",
            "css_text_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_align_last
    ///
    /// Whether a document used the CSS property text-align-last. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_align_last: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            705,
            "use.counter.css.doc",
            "css_text_align_last",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_anchor
    ///
    /// Whether a document used the CSS property text-anchor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            706,
            "use.counter.css.doc",
            "css_text_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_combine_upright
    ///
    /// Whether a document used the CSS property text-combine-upright. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_combine_upright: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            707,
            "use.counter.css.doc",
            "css_text_combine_upright",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration
    ///
    /// Whether a document used the CSS property text-decoration. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            708,
            "use.counter.css.doc",
            "css_text_decoration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_color
    ///
    /// Whether a document used the CSS property text-decoration-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            709,
            "use.counter.css.doc",
            "css_text_decoration_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_line
    ///
    /// Whether a document used the CSS property text-decoration-line. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_line: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            710,
            "use.counter.css.doc",
            "css_text_decoration_line",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_skip_ink
    ///
    /// Whether a document used the CSS property text-decoration-skip-ink. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_skip_ink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            711,
            "use.counter.css.doc",
            "css_text_decoration_skip_ink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_style
    ///
    /// Whether a document used the CSS property text-decoration-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            712,
            "use.counter.css.doc",
            "css_text_decoration_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_thickness
    ///
    /// Whether a document used the CSS property text-decoration-thickness. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_thickness: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            713,
            "use.counter.css.doc",
            "css_text_decoration_thickness",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis
    ///
    /// Whether a document used the CSS property text-emphasis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            714,
            "use.counter.css.doc",
            "css_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis_color
    ///
    /// Whether a document used the CSS property text-emphasis-color. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            715,
            "use.counter.css.doc",
            "css_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis_position
    ///
    /// Whether a document used the CSS property text-emphasis-position. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            716,
            "use.counter.css.doc",
            "css_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis_style
    ///
    /// Whether a document used the CSS property text-emphasis-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            717,
            "use.counter.css.doc",
            "css_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_indent
    ///
    /// Whether a document used the CSS property text-indent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_indent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            718,
            "use.counter.css.doc",
            "css_text_indent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_justify
    ///
    /// Whether a document used the CSS property text-justify. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_justify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            719,
            "use.counter.css.doc",
            "css_text_justify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_orientation
    ///
    /// Whether a document used the CSS property text-orientation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            720,
            "use.counter.css.doc",
            "css_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_overflow
    ///
    /// Whether a document used the CSS property text-overflow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            721,
            "use.counter.css.doc",
            "css_text_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_rendering
    ///
    /// Whether a document used the CSS property text-rendering. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            722,
            "use.counter.css.doc",
            "css_text_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_shadow
    ///
    /// Whether a document used the CSS property text-shadow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            723,
            "use.counter.css.doc",
            "css_text_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_transform
    ///
    /// Whether a document used the CSS property text-transform. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            724,
            "use.counter.css.doc",
            "css_text_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_underline_offset
    ///
    /// Whether a document used the CSS property text-underline-offset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            725,
            "use.counter.css.doc",
            "css_text_underline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_underline_position
    ///
    /// Whether a document used the CSS property text-underline-position. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            726,
            "use.counter.css.doc",
            "css_text_underline_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_wrap
    ///
    /// Whether a document used the CSS property text-wrap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            727,
            "use.counter.css.doc",
            "css_text_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_wrap_mode
    ///
    /// Whether a document used the CSS property text-wrap-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            728,
            "use.counter.css.doc",
            "css_text_wrap_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_wrap_style
    ///
    /// Whether a document used the CSS property text-wrap-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            729,
            "use.counter.css.doc",
            "css_text_wrap_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_top
    ///
    /// Whether a document used the CSS property top. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            730,
            "use.counter.css.doc",
            "css_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_touch_action
    ///
    /// Whether a document used the CSS property touch-action. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_touch_action: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            731,
            "use.counter.css.doc",
            "css_touch_action",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform
    ///
    /// Whether a document used the CSS property transform. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            732,
            "use.counter.css.doc",
            "css_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform_box
    ///
    /// Whether a document used the CSS property transform-box. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            733,
            "use.counter.css.doc",
            "css_transform_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform_origin
    ///
    /// Whether a document used the CSS property transform-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            734,
            "use.counter.css.doc",
            "css_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform_style
    ///
    /// Whether a document used the CSS property transform-style. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            735,
            "use.counter.css.doc",
            "css_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition
    ///
    /// Whether a document used the CSS property transition. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            736,
            "use.counter.css.doc",
            "css_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_behavior
    ///
    /// Whether a document used the CSS property transition-behavior. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            737,
            "use.counter.css.doc",
            "css_transition_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_delay
    ///
    /// Whether a document used the CSS property transition-delay. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            738,
            "use.counter.css.doc",
            "css_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_duration
    ///
    /// Whether a document used the CSS property transition-duration. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            739,
            "use.counter.css.doc",
            "css_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_property
    ///
    /// Whether a document used the CSS property transition-property. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            740,
            "use.counter.css.doc",
            "css_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_timing_function
    ///
    /// Whether a document used the CSS property transition-timing-function. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            741,
            "use.counter.css.doc",
            "css_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_translate
    ///
    /// Whether a document used the CSS property translate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_translate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            742,
            "use.counter.css.doc",
            "css_translate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_unicode_bidi
    ///
    /// Whether a document used the CSS property unicode-bidi. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_unicode_bidi: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            743,
            "use.counter.css.doc",
            "css_unicode_bidi",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_user_select
    ///
    /// Whether a document used the CSS property user-select. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            744,
            "use.counter.css.doc",
            "css_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_vector_effect
    ///
    /// Whether a document used the CSS property vector-effect. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_vector_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            745,
            "use.counter.css.doc",
            "css_vector_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_vertical_align
    ///
    /// Whether a document used the CSS property vertical-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_vertical_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            746,
            "use.counter.css.doc",
            "css_vertical_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline
    ///
    /// Whether a document used the CSS property view-timeline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            747,
            "use.counter.css.doc",
            "css_view_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline_axis
    ///
    /// Whether a document used the CSS property view-timeline-axis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            748,
            "use.counter.css.doc",
            "css_view_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline_inset
    ///
    /// Whether a document used the CSS property view-timeline-inset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            749,
            "use.counter.css.doc",
            "css_view_timeline_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline_name
    ///
    /// Whether a document used the CSS property view-timeline-name. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            750,
            "use.counter.css.doc",
            "css_view_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_visibility
    ///
    /// Whether a document used the CSS property visibility. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            751,
            "use.counter.css.doc",
            "css_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_align_content
    ///
    /// Whether a document used the CSS property -webkit-align-content. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            752,
            "use.counter.css.doc",
            "css_webkit_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_align_items
    ///
    /// Whether a document used the CSS property -webkit-align-items. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            753,
            "use.counter.css.doc",
            "css_webkit_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_align_self
    ///
    /// Whether a document used the CSS property -webkit-align-self. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            754,
            "use.counter.css.doc",
            "css_webkit_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation
    ///
    /// Whether a document used the CSS property -webkit-animation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            755,
            "use.counter.css.doc",
            "css_webkit_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_delay
    ///
    /// Whether a document used the CSS property -webkit-animation-delay. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            756,
            "use.counter.css.doc",
            "css_webkit_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_direction
    ///
    /// Whether a document used the CSS property -webkit-animation-direction. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            757,
            "use.counter.css.doc",
            "css_webkit_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_duration
    ///
    /// Whether a document used the CSS property -webkit-animation-duration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            758,
            "use.counter.css.doc",
            "css_webkit_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_fill_mode
    ///
    /// Whether a document used the CSS property -webkit-animation-fill-mode. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            759,
            "use.counter.css.doc",
            "css_webkit_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_iteration_count
    ///
    /// Whether a document used the CSS property -webkit-animation-iteration-count.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            760,
            "use.counter.css.doc",
            "css_webkit_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_name
    ///
    /// Whether a document used the CSS property -webkit-animation-name. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            761,
            "use.counter.css.doc",
            "css_webkit_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_play_state
    ///
    /// Whether a document used the CSS property -webkit-animation-play-state. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            762,
            "use.counter.css.doc",
            "css_webkit_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_timing_function
    ///
    /// Whether a document used the CSS property -webkit-animation-timing-function.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            763,
            "use.counter.css.doc",
            "css_webkit_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_appearance
    ///
    /// Whether a document used the CSS property -webkit-appearance. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            764,
            "use.counter.css.doc",
            "css_webkit_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_backface_visibility
    ///
    /// Whether a document used the CSS property -webkit-backface-visibility. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            765,
            "use.counter.css.doc",
            "css_webkit_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_background_clip
    ///
    /// Whether a document used the CSS property -webkit-background-clip. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            766,
            "use.counter.css.doc",
            "css_webkit_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_background_origin
    ///
    /// Whether a document used the CSS property -webkit-background-origin. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            767,
            "use.counter.css.doc",
            "css_webkit_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_background_size
    ///
    /// Whether a document used the CSS property -webkit-background-size. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            768,
            "use.counter.css.doc",
            "css_webkit_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_bottom_left_radius
    ///
    /// Whether a document used the CSS property -webkit-border-bottom-left-radius.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            769,
            "use.counter.css.doc",
            "css_webkit_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_bottom_right_radius
    ///
    /// Whether a document used the CSS property -webkit-border-bottom-right-radius.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            770,
            "use.counter.css.doc",
            "css_webkit_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_image
    ///
    /// Whether a document used the CSS property -webkit-border-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            771,
            "use.counter.css.doc",
            "css_webkit_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_radius
    ///
    /// Whether a document used the CSS property -webkit-border-radius. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            772,
            "use.counter.css.doc",
            "css_webkit_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_top_left_radius
    ///
    /// Whether a document used the CSS property -webkit-border-top-left-radius.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            773,
            "use.counter.css.doc",
            "css_webkit_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_top_right_radius
    ///
    /// Whether a document used the CSS property -webkit-border-top-right-radius.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            774,
            "use.counter.css.doc",
            "css_webkit_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_align
    ///
    /// Whether a document used the CSS property -webkit-box-align. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            775,
            "use.counter.css.doc",
            "css_webkit_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_direction
    ///
    /// Whether a document used the CSS property -webkit-box-direction. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            776,
            "use.counter.css.doc",
            "css_webkit_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_flex
    ///
    /// Whether a document used the CSS property -webkit-box-flex. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            777,
            "use.counter.css.doc",
            "css_webkit_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_ordinal_group
    ///
    /// Whether a document used the CSS property -webkit-box-ordinal-group. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            778,
            "use.counter.css.doc",
            "css_webkit_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_orient
    ///
    /// Whether a document used the CSS property -webkit-box-orient. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            779,
            "use.counter.css.doc",
            "css_webkit_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_pack
    ///
    /// Whether a document used the CSS property -webkit-box-pack. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            780,
            "use.counter.css.doc",
            "css_webkit_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_shadow
    ///
    /// Whether a document used the CSS property -webkit-box-shadow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            781,
            "use.counter.css.doc",
            "css_webkit_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_sizing
    ///
    /// Whether a document used the CSS property -webkit-box-sizing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            782,
            "use.counter.css.doc",
            "css_webkit_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_clip_path
    ///
    /// Whether a document used the CSS property -webkit-clip-path. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            783,
            "use.counter.css.doc",
            "css_webkit_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_filter
    ///
    /// Whether a document used the CSS property -webkit-filter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            784,
            "use.counter.css.doc",
            "css_webkit_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex
    ///
    /// Whether a document used the CSS property -webkit-flex. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            785,
            "use.counter.css.doc",
            "css_webkit_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_basis
    ///
    /// Whether a document used the CSS property -webkit-flex-basis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            786,
            "use.counter.css.doc",
            "css_webkit_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_direction
    ///
    /// Whether a document used the CSS property -webkit-flex-direction. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            787,
            "use.counter.css.doc",
            "css_webkit_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_flow
    ///
    /// Whether a document used the CSS property -webkit-flex-flow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            788,
            "use.counter.css.doc",
            "css_webkit_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_grow
    ///
    /// Whether a document used the CSS property -webkit-flex-grow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            789,
            "use.counter.css.doc",
            "css_webkit_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_shrink
    ///
    /// Whether a document used the CSS property -webkit-flex-shrink. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            790,
            "use.counter.css.doc",
            "css_webkit_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_wrap
    ///
    /// Whether a document used the CSS property -webkit-flex-wrap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            791,
            "use.counter.css.doc",
            "css_webkit_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_font_smoothing
    ///
    /// Whether a document used the CSS property -webkit-font-smoothing. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            792,
            "use.counter.css.doc",
            "css_webkit_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_justify_content
    ///
    /// Whether a document used the CSS property -webkit-justify-content. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            793,
            "use.counter.css.doc",
            "css_webkit_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_line_clamp
    ///
    /// Whether a document used the CSS property -webkit-line-clamp. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_line_clamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            794,
            "use.counter.css.doc",
            "css_webkit_line_clamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask
    ///
    /// Whether a document used the CSS property -webkit-mask. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            795,
            "use.counter.css.doc",
            "css_webkit_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_clip
    ///
    /// Whether a document used the CSS property -webkit-mask-clip. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            796,
            "use.counter.css.doc",
            "css_webkit_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_composite
    ///
    /// Whether a document used the CSS property -webkit-mask-composite. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            797,
            "use.counter.css.doc",
            "css_webkit_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_image
    ///
    /// Whether a document used the CSS property -webkit-mask-image. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            798,
            "use.counter.css.doc",
            "css_webkit_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_origin
    ///
    /// Whether a document used the CSS property -webkit-mask-origin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            799,
            "use.counter.css.doc",
            "css_webkit_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_position
    ///
    /// Whether a document used the CSS property -webkit-mask-position. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            800,
            "use.counter.css.doc",
            "css_webkit_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_position_x
    ///
    /// Whether a document used the CSS property -webkit-mask-position-x. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            801,
            "use.counter.css.doc",
            "css_webkit_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_position_y
    ///
    /// Whether a document used the CSS property -webkit-mask-position-y. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            802,
            "use.counter.css.doc",
            "css_webkit_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_repeat
    ///
    /// Whether a document used the CSS property -webkit-mask-repeat. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            803,
            "use.counter.css.doc",
            "css_webkit_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_size
    ///
    /// Whether a document used the CSS property -webkit-mask-size. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            804,
            "use.counter.css.doc",
            "css_webkit_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_order
    ///
    /// Whether a document used the CSS property -webkit-order. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            805,
            "use.counter.css.doc",
            "css_webkit_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_perspective
    ///
    /// Whether a document used the CSS property -webkit-perspective. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            806,
            "use.counter.css.doc",
            "css_webkit_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_perspective_origin
    ///
    /// Whether a document used the CSS property -webkit-perspective-origin. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            807,
            "use.counter.css.doc",
            "css_webkit_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_fill_color
    ///
    /// Whether a document used the CSS property -webkit-text-fill-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_fill_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            808,
            "use.counter.css.doc",
            "css_webkit_text_fill_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_security
    ///
    /// Whether a document used the CSS property -webkit-text-security. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_security: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            809,
            "use.counter.css.doc",
            "css_webkit_text_security",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_size_adjust
    ///
    /// Whether a document used the CSS property -webkit-text-size-adjust. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            810,
            "use.counter.css.doc",
            "css_webkit_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_stroke
    ///
    /// Whether a document used the CSS property -webkit-text-stroke. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            811,
            "use.counter.css.doc",
            "css_webkit_text_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_stroke_color
    ///
    /// Whether a document used the CSS property -webkit-text-stroke-color. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            812,
            "use.counter.css.doc",
            "css_webkit_text_stroke_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_stroke_width
    ///
    /// Whether a document used the CSS property -webkit-text-stroke-width. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            813,
            "use.counter.css.doc",
            "css_webkit_text_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transform
    ///
    /// Whether a document used the CSS property -webkit-transform. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            814,
            "use.counter.css.doc",
            "css_webkit_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transform_origin
    ///
    /// Whether a document used the CSS property -webkit-transform-origin. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            815,
            "use.counter.css.doc",
            "css_webkit_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transform_style
    ///
    /// Whether a document used the CSS property -webkit-transform-style. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            816,
            "use.counter.css.doc",
            "css_webkit_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition
    ///
    /// Whether a document used the CSS property -webkit-transition. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            817,
            "use.counter.css.doc",
            "css_webkit_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_delay
    ///
    /// Whether a document used the CSS property -webkit-transition-delay. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            818,
            "use.counter.css.doc",
            "css_webkit_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_duration
    ///
    /// Whether a document used the CSS property -webkit-transition-duration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            819,
            "use.counter.css.doc",
            "css_webkit_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_property
    ///
    /// Whether a document used the CSS property -webkit-transition-property. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            820,
            "use.counter.css.doc",
            "css_webkit_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_timing_function
    ///
    /// Whether a document used the CSS property -webkit-transition-timing-function.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            821,
            "use.counter.css.doc",
            "css_webkit_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_user_select
    ///
    /// Whether a document used the CSS property -webkit-user-select. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            822,
            "use.counter.css.doc",
            "css_webkit_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_white_space
    ///
    /// Whether a document used the CSS property white-space. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_white_space: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            823,
            "use.counter.css.doc",
            "css_white_space",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_white_space_collapse
    ///
    /// Whether a document used the CSS property white-space-collapse. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_white_space_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            824,
            "use.counter.css.doc",
            "css_white_space_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_width
    ///
    /// Whether a document used the CSS property width. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            825,
            "use.counter.css.doc",
            "css_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_will_change
    ///
    /// Whether a document used the CSS property will-change. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_will_change: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            826,
            "use.counter.css.doc",
            "css_will_change",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_word_break
    ///
    /// Whether a document used the CSS property word-break. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_word_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            827,
            "use.counter.css.doc",
            "css_word_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_word_spacing
    ///
    /// Whether a document used the CSS property word-spacing. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_word_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            828,
            "use.counter.css.doc",
            "css_word_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_word_wrap
    ///
    /// Whether a document used the CSS property word-wrap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_word_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            829,
            "use.counter.css.doc",
            "css_word_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_writing_mode
    ///
    /// Whether a document used the CSS property writing-mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            830,
            "use.counter.css.doc",
            "css_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x
    ///
    /// Whether a document used the CSS property x. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            831,
            "use.counter.css.doc",
            "css_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x_lang
    ///
    /// Whether a document used the CSS property -x-lang. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x_lang: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            832,
            "use.counter.css.doc",
            "css_x_lang",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x_span
    ///
    /// Whether a document used the CSS property -x-span. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            833,
            "use.counter.css.doc",
            "css_x_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x_text_scale
    ///
    /// Whether a document used the CSS property -x-text-scale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x_text_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            834,
            "use.counter.css.doc",
            "css_x_text_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_y
    ///
    /// Whether a document used the CSS property y. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            835,
            "use.counter.css.doc",
            "css_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_z_index
    ///
    /// Whether a document used the CSS property z-index. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_z_index: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            836,
            "use.counter.css.doc",
            "css_z_index",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_zoom
    ///
    /// Whether a document used the CSS property zoom. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            837,
            "use.counter.css.doc",
            "css_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.max_zoom
    ///
    /// Whether a document used the (unknown, counted) CSS property max-zoom. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static max_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            838,
            "use.counter.css.doc",
            "max_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.min_zoom
    ///
    /// Whether a document used the (unknown, counted) CSS property min-zoom. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static min_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            839,
            "use.counter.css.doc",
            "min_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.orientation
    ///
    /// Whether a document used the (unknown, counted) CSS property orientation.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            840,
            "use.counter.css.doc",
            "orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.orphans
    ///
    /// Whether a document used the (unknown, counted) CSS property orphans. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static orphans: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            841,
            "use.counter.css.doc",
            "orphans",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.speak
    ///
    /// Whether a document used the (unknown, counted) CSS property speak. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static speak: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            842,
            "use.counter.css.doc",
            "speak",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.text_size_adjust
    ///
    /// Whether a document used the (unknown, counted) CSS property text-size-adjust.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            843,
            "use.counter.css.doc",
            "text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.user_zoom
    ///
    /// Whether a document used the (unknown, counted) CSS property user-zoom. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static user_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            844,
            "use.counter.css.doc",
            "user_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_app_region
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-app-region.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_app_region: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            845,
            "use.counter.css.doc",
            "webkit_app_region",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// after. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            846,
            "use.counter.css.doc",
            "webkit_border_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// after-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            847,
            "use.counter.css.doc",
            "webkit_border_after_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// after-style. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            848,
            "use.counter.css.doc",
            "webkit_border_after_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// after-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            849,
            "use.counter.css.doc",
            "webkit_border_after_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// before. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            850,
            "use.counter.css.doc",
            "webkit_border_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// before-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            851,
            "use.counter.css.doc",
            "webkit_border_before_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// before-style. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            852,
            "use.counter.css.doc",
            "webkit_border_before_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// before-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            853,
            "use.counter.css.doc",
            "webkit_border_before_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            854,
            "use.counter.css.doc",
            "webkit_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end-
    /// color. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            855,
            "use.counter.css.doc",
            "webkit_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end-
    /// style. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            856,
            "use.counter.css.doc",
            "webkit_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end-
    /// width. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            857,
            "use.counter.css.doc",
            "webkit_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_horizontal_spacing
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// horizontal-spacing. Compare against `use.counter.content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_border_horizontal_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            858,
            "use.counter.css.doc",
            "webkit_border_horizontal_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// start. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            859,
            "use.counter.css.doc",
            "webkit_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// start-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            860,
            "use.counter.css.doc",
            "webkit_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// start-style. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            861,
            "use.counter.css.doc",
            "webkit_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// start-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            862,
            "use.counter.css.doc",
            "webkit_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_vertical_spacing
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-
    /// vertical-spacing. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_vertical_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            863,
            "use.counter.css.doc",
            "webkit_border_vertical_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_box_decoration_break
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-box-
    /// decoration-break. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            864,
            "use.counter.css.doc",
            "webkit_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_box_reflect
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-box-
    /// reflect. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_box_reflect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            865,
            "use.counter.css.doc",
            "webkit_box_reflect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_break_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// break-after. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            866,
            "use.counter.css.doc",
            "webkit_column_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_break_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// break-before. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            867,
            "use.counter.css.doc",
            "webkit_column_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_break_inside
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// break-inside. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            868,
            "use.counter.css.doc",
            "webkit_column_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_count
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// count. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            869,
            "use.counter.css.doc",
            "webkit_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_gap
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-gap.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            870,
            "use.counter.css.doc",
            "webkit_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// rule. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            871,
            "use.counter.css.doc",
            "webkit_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// rule-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            872,
            "use.counter.css.doc",
            "webkit_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// rule-style. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            873,
            "use.counter.css.doc",
            "webkit_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// rule-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            874,
            "use.counter.css.doc",
            "webkit_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_span
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// span. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            875,
            "use.counter.css.doc",
            "webkit_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-
    /// width. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            876,
            "use.counter.css.doc",
            "webkit_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_columns
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-columns.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            877,
            "use.counter.css.doc",
            "webkit_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_font_feature_settings
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-font-
    /// feature-settings. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            878,
            "use.counter.css.doc",
            "webkit_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_font_size_delta
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-font-size-
    /// delta. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_font_size_delta: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            879,
            "use.counter.css.doc",
            "webkit_font_size_delta",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_highlight
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-highlight.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_highlight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            880,
            "use.counter.css.doc",
            "webkit_highlight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_hyphenate_character
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-hyphenate-
    /// character. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            881,
            "use.counter.css.doc",
            "webkit_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_line_break
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-line-break.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            882,
            "use.counter.css.doc",
            "webkit_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_locale
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-locale.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            883,
            "use.counter.css.doc",
            "webkit_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_logical_height
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-logical-
    /// height. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            884,
            "use.counter.css.doc",
            "webkit_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_logical_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-logical-
    /// width. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            885,
            "use.counter.css.doc",
            "webkit_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// after. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_margin_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            886,
            "use.counter.css.doc",
            "webkit_margin_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_after_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// after-collapse. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_after_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            887,
            "use.counter.css.doc",
            "webkit_margin_after_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// before. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_margin_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            888,
            "use.counter.css.doc",
            "webkit_margin_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_before_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// before-collapse. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_before_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            889,
            "use.counter.css.doc",
            "webkit_margin_before_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_bottom_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// bottom-collapse. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_bottom_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            890,
            "use.counter.css.doc",
            "webkit_margin_bottom_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// collapse. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            891,
            "use.counter.css.doc",
            "webkit_margin_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_end
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-end.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            892,
            "use.counter.css.doc",
            "webkit_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_start
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-
    /// start. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            893,
            "use.counter.css.doc",
            "webkit_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_top_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-top-
    /// collapse. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_top_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            894,
            "use.counter.css.doc",
            "webkit_margin_top_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_mask_box_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            895,
            "use.counter.css.doc",
            "webkit_mask_box_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_outset
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image-outset. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            896,
            "use.counter.css.doc",
            "webkit_mask_box_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_repeat
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image-repeat. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            897,
            "use.counter.css.doc",
            "webkit_mask_box_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_slice
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image-slice. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            898,
            "use.counter.css.doc",
            "webkit_mask_box_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_source
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image-source. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            899,
            "use.counter.css.doc",
            "webkit_mask_box_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-
    /// image-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            900,
            "use.counter.css.doc",
            "webkit_mask_box_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_repeat_x
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-
    /// repeat-x. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            901,
            "use.counter.css.doc",
            "webkit_mask_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_repeat_y
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-
    /// repeat-y. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            902,
            "use.counter.css.doc",
            "webkit_mask_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_max_logical_height
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-max-
    /// logical-height. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_max_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            903,
            "use.counter.css.doc",
            "webkit_max_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_max_logical_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-max-
    /// logical-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_max_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            904,
            "use.counter.css.doc",
            "webkit_max_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_min_logical_height
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-min-
    /// logical-height. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_min_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            905,
            "use.counter.css.doc",
            "webkit_min_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_min_logical_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-min-
    /// logical-width. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_min_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            906,
            "use.counter.css.doc",
            "webkit_min_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_opacity
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-opacity.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            907,
            "use.counter.css.doc",
            "webkit_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-
    /// after. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_padding_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            908,
            "use.counter.css.doc",
            "webkit_padding_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-
    /// before. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_padding_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            909,
            "use.counter.css.doc",
            "webkit_padding_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_end
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-
    /// end. Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            910,
            "use.counter.css.doc",
            "webkit_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_start
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-
    /// start. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            911,
            "use.counter.css.doc",
            "webkit_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_perspective_origin_x
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-
    /// perspective-origin-x. Compare against `use.counter.content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_perspective_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            912,
            "use.counter.css.doc",
            "webkit_perspective_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_perspective_origin_y
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-
    /// perspective-origin-y. Compare against `use.counter.content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_perspective_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            913,
            "use.counter.css.doc",
            "webkit_perspective_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_print_color_adjust
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-print-
    /// color-adjust. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            914,
            "use.counter.css.doc",
            "webkit_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_rtl_ordering
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-rtl-
    /// ordering. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_rtl_ordering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            915,
            "use.counter.css.doc",
            "webkit_rtl_ordering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_ruby_position
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-ruby-
    /// position. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            916,
            "use.counter.css.doc",
            "webkit_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_shape_image_threshold
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-shape-
    /// image-threshold. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            917,
            "use.counter.css.doc",
            "webkit_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_shape_margin
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-shape-
    /// margin. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            918,
            "use.counter.css.doc",
            "webkit_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_shape_outside
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-shape-
    /// outside. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            919,
            "use.counter.css.doc",
            "webkit_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_tap_highlight_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-tap-
    /// highlight-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_tap_highlight_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            920,
            "use.counter.css.doc",
            "webkit_tap_highlight_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_combine
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// combine. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_text_combine: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            921,
            "use.counter.css.doc",
            "webkit_text_combine",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_decorations_in_effect
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// decorations-in-effect. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_text_decorations_in_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            922,
            "use.counter.css.doc",
            "webkit_text_decorations_in_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// emphasis. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            923,
            "use.counter.css.doc",
            "webkit_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// emphasis-color. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            924,
            "use.counter.css.doc",
            "webkit_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis_position
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// emphasis-position. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            925,
            "use.counter.css.doc",
            "webkit_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// emphasis-style. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            926,
            "use.counter.css.doc",
            "webkit_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_orientation
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-
    /// orientation. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            927,
            "use.counter.css.doc",
            "webkit_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_transform_origin_x
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-transform-
    /// origin-x. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_transform_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            928,
            "use.counter.css.doc",
            "webkit_transform_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_transform_origin_y
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-transform-
    /// origin-y. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_transform_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            929,
            "use.counter.css.doc",
            "webkit_transform_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_transform_origin_z
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-transform-
    /// origin-z. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_transform_origin_z: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            930,
            "use.counter.css.doc",
            "webkit_transform_origin_z",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_user_drag
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-user-drag.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_user_drag: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            931,
            "use.counter.css.doc",
            "webkit_user_drag",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_user_modify
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-user-
    /// modify. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_user_modify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            932,
            "use.counter.css.doc",
            "webkit_user_modify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_writing_mode
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-writing-
    /// mode. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static webkit_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            933,
            "use.counter.css.doc",
            "webkit_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.widows
    ///
    /// Whether a document used the (unknown, counted) CSS property widows. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static widows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            934,
            "use.counter.css.doc",
            "widows",
            "use-counters"
        )
    });

}
pub mod use_counter_css_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.alignment_baseline
    ///
    /// Whether a page used the (unknown, counted) CSS property alignment-baseline.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static alignment_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            935,
            "use.counter.css.page",
            "alignment_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.background_repeat_x
    ///
    /// Whether a page used the (unknown, counted) CSS property background-repeat-x.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static background_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            936,
            "use.counter.css.page",
            "background_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.background_repeat_y
    ///
    /// Whether a page used the (unknown, counted) CSS property background-repeat-y.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static background_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            937,
            "use.counter.css.page",
            "background_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.baseline_shift
    ///
    /// Whether a page used the (unknown, counted) CSS property baseline-shift. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static baseline_shift: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            938,
            "use.counter.css.page",
            "baseline_shift",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.buffered_rendering
    ///
    /// Whether a page used the (unknown, counted) CSS property buffered-rendering.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static buffered_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            939,
            "use.counter.css.page",
            "buffered_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.color_rendering
    ///
    /// Whether a page used the (unknown, counted) CSS property color-rendering.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static color_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            940,
            "use.counter.css.page",
            "color_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_accent_color
    ///
    /// Whether a page used the CSS property accent-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_accent_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            941,
            "use.counter.css.page",
            "css_accent_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_align_content
    ///
    /// Whether a page used the CSS property align-content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            942,
            "use.counter.css.page",
            "css_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_align_items
    ///
    /// Whether a page used the CSS property align-items. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            943,
            "use.counter.css.page",
            "css_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_align_self
    ///
    /// Whether a page used the CSS property align-self. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            944,
            "use.counter.css.page",
            "css_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_all
    ///
    /// Whether a page used the CSS property all. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            945,
            "use.counter.css.page",
            "css_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_anchor_name
    ///
    /// Whether a page used the CSS property anchor-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_anchor_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            946,
            "use.counter.css.page",
            "css_anchor_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_anchor_scope
    ///
    /// Whether a page used the CSS property anchor-scope. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_anchor_scope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            947,
            "use.counter.css.page",
            "css_anchor_scope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation
    ///
    /// Whether a page used the CSS property animation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            948,
            "use.counter.css.page",
            "css_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_composition
    ///
    /// Whether a page used the CSS property animation-composition. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_composition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            949,
            "use.counter.css.page",
            "css_animation_composition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_delay
    ///
    /// Whether a page used the CSS property animation-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            950,
            "use.counter.css.page",
            "css_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_direction
    ///
    /// Whether a page used the CSS property animation-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            951,
            "use.counter.css.page",
            "css_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_duration
    ///
    /// Whether a page used the CSS property animation-duration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            952,
            "use.counter.css.page",
            "css_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_fill_mode
    ///
    /// Whether a page used the CSS property animation-fill-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            953,
            "use.counter.css.page",
            "css_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_iteration_count
    ///
    /// Whether a page used the CSS property animation-iteration-count. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            954,
            "use.counter.css.page",
            "css_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_name
    ///
    /// Whether a page used the CSS property animation-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            955,
            "use.counter.css.page",
            "css_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_play_state
    ///
    /// Whether a page used the CSS property animation-play-state. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            956,
            "use.counter.css.page",
            "css_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_timeline
    ///
    /// Whether a page used the CSS property animation-timeline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            957,
            "use.counter.css.page",
            "css_animation_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_timing_function
    ///
    /// Whether a page used the CSS property animation-timing-function. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            958,
            "use.counter.css.page",
            "css_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_appearance
    ///
    /// Whether a page used the CSS property appearance. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            959,
            "use.counter.css.page",
            "css_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_aspect_ratio
    ///
    /// Whether a page used the CSS property aspect-ratio. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_aspect_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            960,
            "use.counter.css.page",
            "css_aspect_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_backdrop_filter
    ///
    /// Whether a page used the CSS property backdrop-filter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_backdrop_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            961,
            "use.counter.css.page",
            "css_backdrop_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_backface_visibility
    ///
    /// Whether a page used the CSS property backface-visibility. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            962,
            "use.counter.css.page",
            "css_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background
    ///
    /// Whether a page used the CSS property background. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            963,
            "use.counter.css.page",
            "css_background",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_attachment
    ///
    /// Whether a page used the CSS property background-attachment. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_attachment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            964,
            "use.counter.css.page",
            "css_background_attachment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_blend_mode
    ///
    /// Whether a page used the CSS property background-blend-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            965,
            "use.counter.css.page",
            "css_background_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_clip
    ///
    /// Whether a page used the CSS property background-clip. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            966,
            "use.counter.css.page",
            "css_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_color
    ///
    /// Whether a page used the CSS property background-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            967,
            "use.counter.css.page",
            "css_background_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_image
    ///
    /// Whether a page used the CSS property background-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            968,
            "use.counter.css.page",
            "css_background_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_origin
    ///
    /// Whether a page used the CSS property background-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            969,
            "use.counter.css.page",
            "css_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_position
    ///
    /// Whether a page used the CSS property background-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            970,
            "use.counter.css.page",
            "css_background_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_position_x
    ///
    /// Whether a page used the CSS property background-position-x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            971,
            "use.counter.css.page",
            "css_background_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_position_y
    ///
    /// Whether a page used the CSS property background-position-y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            972,
            "use.counter.css.page",
            "css_background_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_repeat
    ///
    /// Whether a page used the CSS property background-repeat. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            973,
            "use.counter.css.page",
            "css_background_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_size
    ///
    /// Whether a page used the CSS property background-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            974,
            "use.counter.css.page",
            "css_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_baseline_source
    ///
    /// Whether a page used the CSS property baseline-source. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_baseline_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            975,
            "use.counter.css.page",
            "css_baseline_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_block_size
    ///
    /// Whether a page used the CSS property block-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            976,
            "use.counter.css.page",
            "css_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border
    ///
    /// Whether a page used the CSS property border. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            977,
            "use.counter.css.page",
            "css_border",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block
    ///
    /// Whether a page used the CSS property border-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            978,
            "use.counter.css.page",
            "css_border_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_color
    ///
    /// Whether a page used the CSS property border-block-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            979,
            "use.counter.css.page",
            "css_border_block_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end
    ///
    /// Whether a page used the CSS property border-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            980,
            "use.counter.css.page",
            "css_border_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end_color
    ///
    /// Whether a page used the CSS property border-block-end-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            981,
            "use.counter.css.page",
            "css_border_block_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end_style
    ///
    /// Whether a page used the CSS property border-block-end-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            982,
            "use.counter.css.page",
            "css_border_block_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end_width
    ///
    /// Whether a page used the CSS property border-block-end-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            983,
            "use.counter.css.page",
            "css_border_block_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start
    ///
    /// Whether a page used the CSS property border-block-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            984,
            "use.counter.css.page",
            "css_border_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start_color
    ///
    /// Whether a page used the CSS property border-block-start-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            985,
            "use.counter.css.page",
            "css_border_block_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start_style
    ///
    /// Whether a page used the CSS property border-block-start-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            986,
            "use.counter.css.page",
            "css_border_block_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start_width
    ///
    /// Whether a page used the CSS property border-block-start-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            987,
            "use.counter.css.page",
            "css_border_block_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_style
    ///
    /// Whether a page used the CSS property border-block-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            988,
            "use.counter.css.page",
            "css_border_block_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_width
    ///
    /// Whether a page used the CSS property border-block-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            989,
            "use.counter.css.page",
            "css_border_block_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom
    ///
    /// Whether a page used the CSS property border-bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            990,
            "use.counter.css.page",
            "css_border_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_color
    ///
    /// Whether a page used the CSS property border-bottom-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            991,
            "use.counter.css.page",
            "css_border_bottom_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_left_radius
    ///
    /// Whether a page used the CSS property border-bottom-left-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            992,
            "use.counter.css.page",
            "css_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_right_radius
    ///
    /// Whether a page used the CSS property border-bottom-right-radius. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            993,
            "use.counter.css.page",
            "css_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_style
    ///
    /// Whether a page used the CSS property border-bottom-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            994,
            "use.counter.css.page",
            "css_border_bottom_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_width
    ///
    /// Whether a page used the CSS property border-bottom-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            995,
            "use.counter.css.page",
            "css_border_bottom_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_collapse
    ///
    /// Whether a page used the CSS property border-collapse. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            996,
            "use.counter.css.page",
            "css_border_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_color
    ///
    /// Whether a page used the CSS property border-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            997,
            "use.counter.css.page",
            "css_border_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_end_end_radius
    ///
    /// Whether a page used the CSS property border-end-end-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_end_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            998,
            "use.counter.css.page",
            "css_border_end_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_end_start_radius
    ///
    /// Whether a page used the CSS property border-end-start-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_end_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            999,
            "use.counter.css.page",
            "css_border_end_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image
    ///
    /// Whether a page used the CSS property border-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1000,
            "use.counter.css.page",
            "css_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_outset
    ///
    /// Whether a page used the CSS property border-image-outset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1001,
            "use.counter.css.page",
            "css_border_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_repeat
    ///
    /// Whether a page used the CSS property border-image-repeat. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1002,
            "use.counter.css.page",
            "css_border_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_slice
    ///
    /// Whether a page used the CSS property border-image-slice. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1003,
            "use.counter.css.page",
            "css_border_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_source
    ///
    /// Whether a page used the CSS property border-image-source. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1004,
            "use.counter.css.page",
            "css_border_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_width
    ///
    /// Whether a page used the CSS property border-image-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1005,
            "use.counter.css.page",
            "css_border_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline
    ///
    /// Whether a page used the CSS property border-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1006,
            "use.counter.css.page",
            "css_border_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_color
    ///
    /// Whether a page used the CSS property border-inline-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1007,
            "use.counter.css.page",
            "css_border_inline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end
    ///
    /// Whether a page used the CSS property border-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1008,
            "use.counter.css.page",
            "css_border_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end_color
    ///
    /// Whether a page used the CSS property border-inline-end-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1009,
            "use.counter.css.page",
            "css_border_inline_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end_style
    ///
    /// Whether a page used the CSS property border-inline-end-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1010,
            "use.counter.css.page",
            "css_border_inline_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end_width
    ///
    /// Whether a page used the CSS property border-inline-end-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1011,
            "use.counter.css.page",
            "css_border_inline_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start
    ///
    /// Whether a page used the CSS property border-inline-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1012,
            "use.counter.css.page",
            "css_border_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start_color
    ///
    /// Whether a page used the CSS property border-inline-start-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1013,
            "use.counter.css.page",
            "css_border_inline_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start_style
    ///
    /// Whether a page used the CSS property border-inline-start-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1014,
            "use.counter.css.page",
            "css_border_inline_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start_width
    ///
    /// Whether a page used the CSS property border-inline-start-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1015,
            "use.counter.css.page",
            "css_border_inline_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_style
    ///
    /// Whether a page used the CSS property border-inline-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1016,
            "use.counter.css.page",
            "css_border_inline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_width
    ///
    /// Whether a page used the CSS property border-inline-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1017,
            "use.counter.css.page",
            "css_border_inline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left
    ///
    /// Whether a page used the CSS property border-left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1018,
            "use.counter.css.page",
            "css_border_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left_color
    ///
    /// Whether a page used the CSS property border-left-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1019,
            "use.counter.css.page",
            "css_border_left_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left_style
    ///
    /// Whether a page used the CSS property border-left-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1020,
            "use.counter.css.page",
            "css_border_left_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left_width
    ///
    /// Whether a page used the CSS property border-left-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1021,
            "use.counter.css.page",
            "css_border_left_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_radius
    ///
    /// Whether a page used the CSS property border-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1022,
            "use.counter.css.page",
            "css_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right
    ///
    /// Whether a page used the CSS property border-right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1023,
            "use.counter.css.page",
            "css_border_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right_color
    ///
    /// Whether a page used the CSS property border-right-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1024,
            "use.counter.css.page",
            "css_border_right_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right_style
    ///
    /// Whether a page used the CSS property border-right-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1025,
            "use.counter.css.page",
            "css_border_right_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right_width
    ///
    /// Whether a page used the CSS property border-right-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1026,
            "use.counter.css.page",
            "css_border_right_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_spacing
    ///
    /// Whether a page used the CSS property border-spacing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1027,
            "use.counter.css.page",
            "css_border_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_start_end_radius
    ///
    /// Whether a page used the CSS property border-start-end-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_start_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1028,
            "use.counter.css.page",
            "css_border_start_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_start_start_radius
    ///
    /// Whether a page used the CSS property border-start-start-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_start_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1029,
            "use.counter.css.page",
            "css_border_start_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_style
    ///
    /// Whether a page used the CSS property border-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1030,
            "use.counter.css.page",
            "css_border_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top
    ///
    /// Whether a page used the CSS property border-top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1031,
            "use.counter.css.page",
            "css_border_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_color
    ///
    /// Whether a page used the CSS property border-top-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1032,
            "use.counter.css.page",
            "css_border_top_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_left_radius
    ///
    /// Whether a page used the CSS property border-top-left-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1033,
            "use.counter.css.page",
            "css_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_right_radius
    ///
    /// Whether a page used the CSS property border-top-right-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1034,
            "use.counter.css.page",
            "css_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_style
    ///
    /// Whether a page used the CSS property border-top-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1035,
            "use.counter.css.page",
            "css_border_top_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_width
    ///
    /// Whether a page used the CSS property border-top-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1036,
            "use.counter.css.page",
            "css_border_top_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_width
    ///
    /// Whether a page used the CSS property border-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1037,
            "use.counter.css.page",
            "css_border_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_bottom
    ///
    /// Whether a page used the CSS property bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1038,
            "use.counter.css.page",
            "css_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_box_decoration_break
    ///
    /// Whether a page used the CSS property box-decoration-break. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1039,
            "use.counter.css.page",
            "css_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_box_shadow
    ///
    /// Whether a page used the CSS property box-shadow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1040,
            "use.counter.css.page",
            "css_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_box_sizing
    ///
    /// Whether a page used the CSS property box-sizing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1041,
            "use.counter.css.page",
            "css_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_break_after
    ///
    /// Whether a page used the CSS property break-after. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1042,
            "use.counter.css.page",
            "css_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_break_before
    ///
    /// Whether a page used the CSS property break-before. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1043,
            "use.counter.css.page",
            "css_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_break_inside
    ///
    /// Whether a page used the CSS property break-inside. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1044,
            "use.counter.css.page",
            "css_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_caption_side
    ///
    /// Whether a page used the CSS property caption-side. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_caption_side: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1045,
            "use.counter.css.page",
            "css_caption_side",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_caret_color
    ///
    /// Whether a page used the CSS property caret-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_caret_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1046,
            "use.counter.css.page",
            "css_caret_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clear
    ///
    /// Whether a page used the CSS property clear. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1047,
            "use.counter.css.page",
            "css_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clip
    ///
    /// Whether a page used the CSS property clip. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1048,
            "use.counter.css.page",
            "css_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clip_path
    ///
    /// Whether a page used the CSS property clip-path. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1049,
            "use.counter.css.page",
            "css_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clip_rule
    ///
    /// Whether a page used the CSS property clip-rule. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clip_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1050,
            "use.counter.css.page",
            "css_clip_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color
    ///
    /// Whether a page used the CSS property color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1051,
            "use.counter.css.page",
            "css_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_adjust
    ///
    /// Whether a page used the CSS property color-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1052,
            "use.counter.css.page",
            "css_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_interpolation
    ///
    /// Whether a page used the CSS property color-interpolation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color_interpolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1053,
            "use.counter.css.page",
            "css_color_interpolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_interpolation_filters
    ///
    /// Whether a page used the CSS property color-interpolation-filters. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_color_interpolation_filters: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1054,
            "use.counter.css.page",
            "css_color_interpolation_filters",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_scheme
    ///
    /// Whether a page used the CSS property color-scheme. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color_scheme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1055,
            "use.counter.css.page",
            "css_color_scheme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_count
    ///
    /// Whether a page used the CSS property column-count. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1056,
            "use.counter.css.page",
            "css_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_fill
    ///
    /// Whether a page used the CSS property column-fill. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1057,
            "use.counter.css.page",
            "css_column_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_gap
    ///
    /// Whether a page used the CSS property column-gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1058,
            "use.counter.css.page",
            "css_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule
    ///
    /// Whether a page used the CSS property column-rule. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1059,
            "use.counter.css.page",
            "css_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule_color
    ///
    /// Whether a page used the CSS property column-rule-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1060,
            "use.counter.css.page",
            "css_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule_style
    ///
    /// Whether a page used the CSS property column-rule-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1061,
            "use.counter.css.page",
            "css_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule_width
    ///
    /// Whether a page used the CSS property column-rule-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1062,
            "use.counter.css.page",
            "css_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_span
    ///
    /// Whether a page used the CSS property column-span. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1063,
            "use.counter.css.page",
            "css_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_width
    ///
    /// Whether a page used the CSS property column-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1064,
            "use.counter.css.page",
            "css_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_columns
    ///
    /// Whether a page used the CSS property columns. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1065,
            "use.counter.css.page",
            "css_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain
    ///
    /// Whether a page used the CSS property contain. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1066,
            "use.counter.css.page",
            "css_contain",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_block_size
    ///
    /// Whether a page used the CSS property contain-intrinsic-block-size. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_contain_intrinsic_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1067,
            "use.counter.css.page",
            "css_contain_intrinsic_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_height
    ///
    /// Whether a page used the CSS property contain-intrinsic-height. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1068,
            "use.counter.css.page",
            "css_contain_intrinsic_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_inline_size
    ///
    /// Whether a page used the CSS property contain-intrinsic-inline-size. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_contain_intrinsic_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1069,
            "use.counter.css.page",
            "css_contain_intrinsic_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_size
    ///
    /// Whether a page used the CSS property contain-intrinsic-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1070,
            "use.counter.css.page",
            "css_contain_intrinsic_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_width
    ///
    /// Whether a page used the CSS property contain-intrinsic-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1071,
            "use.counter.css.page",
            "css_contain_intrinsic_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_container
    ///
    /// Whether a page used the CSS property container. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_container: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1072,
            "use.counter.css.page",
            "css_container",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_container_name
    ///
    /// Whether a page used the CSS property container-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_container_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1073,
            "use.counter.css.page",
            "css_container_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_container_type
    ///
    /// Whether a page used the CSS property container-type. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_container_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1074,
            "use.counter.css.page",
            "css_container_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_content
    ///
    /// Whether a page used the CSS property content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1075,
            "use.counter.css.page",
            "css_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_content_visibility
    ///
    /// Whether a page used the CSS property content-visibility. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_content_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1076,
            "use.counter.css.page",
            "css_content_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_counter_increment
    ///
    /// Whether a page used the CSS property counter-increment. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_counter_increment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1077,
            "use.counter.css.page",
            "css_counter_increment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_counter_reset
    ///
    /// Whether a page used the CSS property counter-reset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_counter_reset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1078,
            "use.counter.css.page",
            "css_counter_reset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_counter_set
    ///
    /// Whether a page used the CSS property counter-set. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_counter_set: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1079,
            "use.counter.css.page",
            "css_counter_set",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_cursor
    ///
    /// Whether a page used the CSS property cursor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_cursor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1080,
            "use.counter.css.page",
            "css_cursor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_cx
    ///
    /// Whether a page used the CSS property cx. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_cx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1081,
            "use.counter.css.page",
            "css_cx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_cy
    ///
    /// Whether a page used the CSS property cy. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_cy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1082,
            "use.counter.css.page",
            "css_cy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_d
    ///
    /// Whether a page used the CSS property d. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1083,
            "use.counter.css.page",
            "css_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_direction
    ///
    /// Whether a page used the CSS property direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1084,
            "use.counter.css.page",
            "css_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_display
    ///
    /// Whether a page used the CSS property display. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_display: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1085,
            "use.counter.css.page",
            "css_display",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_dominant_baseline
    ///
    /// Whether a page used the CSS property dominant-baseline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_dominant_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1086,
            "use.counter.css.page",
            "css_dominant_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_empty_cells
    ///
    /// Whether a page used the CSS property empty-cells. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_empty_cells: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1087,
            "use.counter.css.page",
            "css_empty_cells",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_fill
    ///
    /// Whether a page used the CSS property fill. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1088,
            "use.counter.css.page",
            "css_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_fill_opacity
    ///
    /// Whether a page used the CSS property fill-opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_fill_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1089,
            "use.counter.css.page",
            "css_fill_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_fill_rule
    ///
    /// Whether a page used the CSS property fill-rule. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_fill_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1090,
            "use.counter.css.page",
            "css_fill_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_filter
    ///
    /// Whether a page used the CSS property filter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1091,
            "use.counter.css.page",
            "css_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex
    ///
    /// Whether a page used the CSS property flex. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1092,
            "use.counter.css.page",
            "css_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_basis
    ///
    /// Whether a page used the CSS property flex-basis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1093,
            "use.counter.css.page",
            "css_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_direction
    ///
    /// Whether a page used the CSS property flex-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1094,
            "use.counter.css.page",
            "css_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_flow
    ///
    /// Whether a page used the CSS property flex-flow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1095,
            "use.counter.css.page",
            "css_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_grow
    ///
    /// Whether a page used the CSS property flex-grow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1096,
            "use.counter.css.page",
            "css_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_shrink
    ///
    /// Whether a page used the CSS property flex-shrink. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1097,
            "use.counter.css.page",
            "css_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_wrap
    ///
    /// Whether a page used the CSS property flex-wrap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1098,
            "use.counter.css.page",
            "css_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_float
    ///
    /// Whether a page used the CSS property float. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_float: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1099,
            "use.counter.css.page",
            "css_float",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flood_color
    ///
    /// Whether a page used the CSS property flood-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flood_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1100,
            "use.counter.css.page",
            "css_flood_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flood_opacity
    ///
    /// Whether a page used the CSS property flood-opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flood_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1101,
            "use.counter.css.page",
            "css_flood_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font
    ///
    /// Whether a page used the CSS property font. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1102,
            "use.counter.css.page",
            "css_font",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_family
    ///
    /// Whether a page used the CSS property font-family. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_family: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1103,
            "use.counter.css.page",
            "css_font_family",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_feature_settings
    ///
    /// Whether a page used the CSS property font-feature-settings. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1104,
            "use.counter.css.page",
            "css_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_kerning
    ///
    /// Whether a page used the CSS property font-kerning. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_kerning: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1105,
            "use.counter.css.page",
            "css_font_kerning",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_language_override
    ///
    /// Whether a page used the CSS property font-language-override. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1106,
            "use.counter.css.page",
            "css_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_optical_sizing
    ///
    /// Whether a page used the CSS property font-optical-sizing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_optical_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1107,
            "use.counter.css.page",
            "css_font_optical_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_palette
    ///
    /// Whether a page used the CSS property font-palette. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_palette: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1108,
            "use.counter.css.page",
            "css_font_palette",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_size
    ///
    /// Whether a page used the CSS property font-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1109,
            "use.counter.css.page",
            "css_font_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_size_adjust
    ///
    /// Whether a page used the CSS property font-size-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1110,
            "use.counter.css.page",
            "css_font_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_stretch
    ///
    /// Whether a page used the CSS property font-stretch. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_stretch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1111,
            "use.counter.css.page",
            "css_font_stretch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_style
    ///
    /// Whether a page used the CSS property font-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1112,
            "use.counter.css.page",
            "css_font_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis
    ///
    /// Whether a page used the CSS property font-synthesis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1113,
            "use.counter.css.page",
            "css_font_synthesis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_position
    ///
    /// Whether a page used the CSS property font-synthesis-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1114,
            "use.counter.css.page",
            "css_font_synthesis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_small_caps
    ///
    /// Whether a page used the CSS property font-synthesis-small-caps. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_small_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1115,
            "use.counter.css.page",
            "css_font_synthesis_small_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_style
    ///
    /// Whether a page used the CSS property font-synthesis-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1116,
            "use.counter.css.page",
            "css_font_synthesis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_weight
    ///
    /// Whether a page used the CSS property font-synthesis-weight. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1117,
            "use.counter.css.page",
            "css_font_synthesis_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant
    ///
    /// Whether a page used the CSS property font-variant. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1118,
            "use.counter.css.page",
            "css_font_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_alternates
    ///
    /// Whether a page used the CSS property font-variant-alternates. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_alternates: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1119,
            "use.counter.css.page",
            "css_font_variant_alternates",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_caps
    ///
    /// Whether a page used the CSS property font-variant-caps. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1120,
            "use.counter.css.page",
            "css_font_variant_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_east_asian
    ///
    /// Whether a page used the CSS property font-variant-east-asian. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_east_asian: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1121,
            "use.counter.css.page",
            "css_font_variant_east_asian",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_emoji
    ///
    /// Whether a page used the CSS property font-variant-emoji. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_emoji: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1122,
            "use.counter.css.page",
            "css_font_variant_emoji",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_ligatures
    ///
    /// Whether a page used the CSS property font-variant-ligatures. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_ligatures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1123,
            "use.counter.css.page",
            "css_font_variant_ligatures",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_numeric
    ///
    /// Whether a page used the CSS property font-variant-numeric. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_numeric: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1124,
            "use.counter.css.page",
            "css_font_variant_numeric",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_position
    ///
    /// Whether a page used the CSS property font-variant-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1125,
            "use.counter.css.page",
            "css_font_variant_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variation_settings
    ///
    /// Whether a page used the CSS property font-variation-settings. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variation_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1126,
            "use.counter.css.page",
            "css_font_variation_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_weight
    ///
    /// Whether a page used the CSS property font-weight. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1127,
            "use.counter.css.page",
            "css_font_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_forced_color_adjust
    ///
    /// Whether a page used the CSS property forced-color-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_forced_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1128,
            "use.counter.css.page",
            "css_forced_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_gap
    ///
    /// Whether a page used the CSS property gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1129,
            "use.counter.css.page",
            "css_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid
    ///
    /// Whether a page used the CSS property grid. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1130,
            "use.counter.css.page",
            "css_grid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_area
    ///
    /// Whether a page used the CSS property grid-area. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1131,
            "use.counter.css.page",
            "css_grid_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_auto_columns
    ///
    /// Whether a page used the CSS property grid-auto-columns. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1132,
            "use.counter.css.page",
            "css_grid_auto_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_auto_flow
    ///
    /// Whether a page used the CSS property grid-auto-flow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1133,
            "use.counter.css.page",
            "css_grid_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_auto_rows
    ///
    /// Whether a page used the CSS property grid-auto-rows. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1134,
            "use.counter.css.page",
            "css_grid_auto_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column
    ///
    /// Whether a page used the CSS property grid-column. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1135,
            "use.counter.css.page",
            "css_grid_column",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column_end
    ///
    /// Whether a page used the CSS property grid-column-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1136,
            "use.counter.css.page",
            "css_grid_column_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column_gap
    ///
    /// Whether a page used the CSS property grid-column-gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1137,
            "use.counter.css.page",
            "css_grid_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column_start
    ///
    /// Whether a page used the CSS property grid-column-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1138,
            "use.counter.css.page",
            "css_grid_column_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_gap
    ///
    /// Whether a page used the CSS property grid-gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1139,
            "use.counter.css.page",
            "css_grid_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row
    ///
    /// Whether a page used the CSS property grid-row. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1140,
            "use.counter.css.page",
            "css_grid_row",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row_end
    ///
    /// Whether a page used the CSS property grid-row-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1141,
            "use.counter.css.page",
            "css_grid_row_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row_gap
    ///
    /// Whether a page used the CSS property grid-row-gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1142,
            "use.counter.css.page",
            "css_grid_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row_start
    ///
    /// Whether a page used the CSS property grid-row-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1143,
            "use.counter.css.page",
            "css_grid_row_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template
    ///
    /// Whether a page used the CSS property grid-template. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1144,
            "use.counter.css.page",
            "css_grid_template",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template_areas
    ///
    /// Whether a page used the CSS property grid-template-areas. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_areas: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1145,
            "use.counter.css.page",
            "css_grid_template_areas",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template_columns
    ///
    /// Whether a page used the CSS property grid-template-columns. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1146,
            "use.counter.css.page",
            "css_grid_template_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template_rows
    ///
    /// Whether a page used the CSS property grid-template-rows. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1147,
            "use.counter.css.page",
            "css_grid_template_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_height
    ///
    /// Whether a page used the CSS property height. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1148,
            "use.counter.css.page",
            "css_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_hyphenate_character
    ///
    /// Whether a page used the CSS property hyphenate-character. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1149,
            "use.counter.css.page",
            "css_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_hyphens
    ///
    /// Whether a page used the CSS property hyphens. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1150,
            "use.counter.css.page",
            "css_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_image_orientation
    ///
    /// Whether a page used the CSS property image-orientation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_image_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1151,
            "use.counter.css.page",
            "css_image_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_image_rendering
    ///
    /// Whether a page used the CSS property image-rendering. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_image_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1152,
            "use.counter.css.page",
            "css_image_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ime_mode
    ///
    /// Whether a page used the CSS property ime-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ime_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1153,
            "use.counter.css.page",
            "css_ime_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_initial_letter
    ///
    /// Whether a page used the CSS property initial-letter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_initial_letter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1154,
            "use.counter.css.page",
            "css_initial_letter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inline_size
    ///
    /// Whether a page used the CSS property inline-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1155,
            "use.counter.css.page",
            "css_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset
    ///
    /// Whether a page used the CSS property inset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1156,
            "use.counter.css.page",
            "css_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_area
    ///
    /// Whether a page used the CSS property inset-area. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1157,
            "use.counter.css.page",
            "css_inset_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_block
    ///
    /// Whether a page used the CSS property inset-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1158,
            "use.counter.css.page",
            "css_inset_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_block_end
    ///
    /// Whether a page used the CSS property inset-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1159,
            "use.counter.css.page",
            "css_inset_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_block_start
    ///
    /// Whether a page used the CSS property inset-block-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1160,
            "use.counter.css.page",
            "css_inset_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_inline
    ///
    /// Whether a page used the CSS property inset-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1161,
            "use.counter.css.page",
            "css_inset_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_inline_end
    ///
    /// Whether a page used the CSS property inset-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1162,
            "use.counter.css.page",
            "css_inset_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_inline_start
    ///
    /// Whether a page used the CSS property inset-inline-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1163,
            "use.counter.css.page",
            "css_inset_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_isolation
    ///
    /// Whether a page used the CSS property isolation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_isolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1164,
            "use.counter.css.page",
            "css_isolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_justify_content
    ///
    /// Whether a page used the CSS property justify-content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1165,
            "use.counter.css.page",
            "css_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_justify_items
    ///
    /// Whether a page used the CSS property justify-items. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_justify_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1166,
            "use.counter.css.page",
            "css_justify_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_justify_self
    ///
    /// Whether a page used the CSS property justify-self. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_justify_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1167,
            "use.counter.css.page",
            "css_justify_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_left
    ///
    /// Whether a page used the CSS property left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1168,
            "use.counter.css.page",
            "css_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_letter_spacing
    ///
    /// Whether a page used the CSS property letter-spacing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_letter_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1169,
            "use.counter.css.page",
            "css_letter_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_lighting_color
    ///
    /// Whether a page used the CSS property lighting-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_lighting_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1170,
            "use.counter.css.page",
            "css_lighting_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_line_break
    ///
    /// Whether a page used the CSS property line-break. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1171,
            "use.counter.css.page",
            "css_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_line_height
    ///
    /// Whether a page used the CSS property line-height. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_line_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1172,
            "use.counter.css.page",
            "css_line_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style
    ///
    /// Whether a page used the CSS property list-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1173,
            "use.counter.css.page",
            "css_list_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style_image
    ///
    /// Whether a page used the CSS property list-style-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1174,
            "use.counter.css.page",
            "css_list_style_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style_position
    ///
    /// Whether a page used the CSS property list-style-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1175,
            "use.counter.css.page",
            "css_list_style_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style_type
    ///
    /// Whether a page used the CSS property list-style-type. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1176,
            "use.counter.css.page",
            "css_list_style_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin
    ///
    /// Whether a page used the CSS property margin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1177,
            "use.counter.css.page",
            "css_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_block
    ///
    /// Whether a page used the CSS property margin-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1178,
            "use.counter.css.page",
            "css_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_block_end
    ///
    /// Whether a page used the CSS property margin-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1179,
            "use.counter.css.page",
            "css_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_block_start
    ///
    /// Whether a page used the CSS property margin-block-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1180,
            "use.counter.css.page",
            "css_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_bottom
    ///
    /// Whether a page used the CSS property margin-bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1181,
            "use.counter.css.page",
            "css_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_inline
    ///
    /// Whether a page used the CSS property margin-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1182,
            "use.counter.css.page",
            "css_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_inline_end
    ///
    /// Whether a page used the CSS property margin-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1183,
            "use.counter.css.page",
            "css_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_inline_start
    ///
    /// Whether a page used the CSS property margin-inline-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1184,
            "use.counter.css.page",
            "css_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_left
    ///
    /// Whether a page used the CSS property margin-left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1185,
            "use.counter.css.page",
            "css_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_right
    ///
    /// Whether a page used the CSS property margin-right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1186,
            "use.counter.css.page",
            "css_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_top
    ///
    /// Whether a page used the CSS property margin-top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1187,
            "use.counter.css.page",
            "css_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker
    ///
    /// Whether a page used the CSS property marker. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1188,
            "use.counter.css.page",
            "css_marker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker_end
    ///
    /// Whether a page used the CSS property marker-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1189,
            "use.counter.css.page",
            "css_marker_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker_mid
    ///
    /// Whether a page used the CSS property marker-mid. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker_mid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1190,
            "use.counter.css.page",
            "css_marker_mid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker_start
    ///
    /// Whether a page used the CSS property marker-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1191,
            "use.counter.css.page",
            "css_marker_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask
    ///
    /// Whether a page used the CSS property mask. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1192,
            "use.counter.css.page",
            "css_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_clip
    ///
    /// Whether a page used the CSS property mask-clip. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1193,
            "use.counter.css.page",
            "css_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_composite
    ///
    /// Whether a page used the CSS property mask-composite. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1194,
            "use.counter.css.page",
            "css_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_image
    ///
    /// Whether a page used the CSS property mask-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1195,
            "use.counter.css.page",
            "css_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_mode
    ///
    /// Whether a page used the CSS property mask-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1196,
            "use.counter.css.page",
            "css_mask_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_origin
    ///
    /// Whether a page used the CSS property mask-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1197,
            "use.counter.css.page",
            "css_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_position
    ///
    /// Whether a page used the CSS property mask-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1198,
            "use.counter.css.page",
            "css_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_position_x
    ///
    /// Whether a page used the CSS property mask-position-x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1199,
            "use.counter.css.page",
            "css_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_position_y
    ///
    /// Whether a page used the CSS property mask-position-y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1200,
            "use.counter.css.page",
            "css_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_repeat
    ///
    /// Whether a page used the CSS property mask-repeat. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1201,
            "use.counter.css.page",
            "css_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_size
    ///
    /// Whether a page used the CSS property mask-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1202,
            "use.counter.css.page",
            "css_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_type
    ///
    /// Whether a page used the CSS property mask-type. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1203,
            "use.counter.css.page",
            "css_mask_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_masonry_auto_flow
    ///
    /// Whether a page used the CSS property masonry-auto-flow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_masonry_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1204,
            "use.counter.css.page",
            "css_masonry_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_math_depth
    ///
    /// Whether a page used the CSS property math-depth. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_math_depth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1205,
            "use.counter.css.page",
            "css_math_depth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_math_style
    ///
    /// Whether a page used the CSS property math-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_math_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1206,
            "use.counter.css.page",
            "css_math_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_block_size
    ///
    /// Whether a page used the CSS property max-block-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1207,
            "use.counter.css.page",
            "css_max_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_height
    ///
    /// Whether a page used the CSS property max-height. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1208,
            "use.counter.css.page",
            "css_max_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_inline_size
    ///
    /// Whether a page used the CSS property max-inline-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1209,
            "use.counter.css.page",
            "css_max_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_width
    ///
    /// Whether a page used the CSS property max-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1210,
            "use.counter.css.page",
            "css_max_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_block_size
    ///
    /// Whether a page used the CSS property min-block-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1211,
            "use.counter.css.page",
            "css_min_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_height
    ///
    /// Whether a page used the CSS property min-height. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1212,
            "use.counter.css.page",
            "css_min_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_inline_size
    ///
    /// Whether a page used the CSS property min-inline-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1213,
            "use.counter.css.page",
            "css_min_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_width
    ///
    /// Whether a page used the CSS property min-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1214,
            "use.counter.css.page",
            "css_min_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mix_blend_mode
    ///
    /// Whether a page used the CSS property mix-blend-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mix_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1215,
            "use.counter.css.page",
            "css_mix_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation
    ///
    /// Whether a page used the CSS property -moz-animation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1216,
            "use.counter.css.page",
            "css_moz_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_delay
    ///
    /// Whether a page used the CSS property -moz-animation-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1217,
            "use.counter.css.page",
            "css_moz_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_direction
    ///
    /// Whether a page used the CSS property -moz-animation-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1218,
            "use.counter.css.page",
            "css_moz_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_duration
    ///
    /// Whether a page used the CSS property -moz-animation-duration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1219,
            "use.counter.css.page",
            "css_moz_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_fill_mode
    ///
    /// Whether a page used the CSS property -moz-animation-fill-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1220,
            "use.counter.css.page",
            "css_moz_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_iteration_count
    ///
    /// Whether a page used the CSS property -moz-animation-iteration-count. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1221,
            "use.counter.css.page",
            "css_moz_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_name
    ///
    /// Whether a page used the CSS property -moz-animation-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1222,
            "use.counter.css.page",
            "css_moz_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_play_state
    ///
    /// Whether a page used the CSS property -moz-animation-play-state. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1223,
            "use.counter.css.page",
            "css_moz_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_timing_function
    ///
    /// Whether a page used the CSS property -moz-animation-timing-function. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1224,
            "use.counter.css.page",
            "css_moz_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_appearance
    ///
    /// Whether a page used the CSS property -moz-appearance. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1225,
            "use.counter.css.page",
            "css_moz_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_backface_visibility
    ///
    /// Whether a page used the CSS property -moz-backface-visibility. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1226,
            "use.counter.css.page",
            "css_moz_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end
    ///
    /// Whether a page used the CSS property -moz-border-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1227,
            "use.counter.css.page",
            "css_moz_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end_color
    ///
    /// Whether a page used the CSS property -moz-border-end-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1228,
            "use.counter.css.page",
            "css_moz_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end_style
    ///
    /// Whether a page used the CSS property -moz-border-end-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1229,
            "use.counter.css.page",
            "css_moz_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end_width
    ///
    /// Whether a page used the CSS property -moz-border-end-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1230,
            "use.counter.css.page",
            "css_moz_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_image
    ///
    /// Whether a page used the CSS property -moz-border-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1231,
            "use.counter.css.page",
            "css_moz_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start
    ///
    /// Whether a page used the CSS property -moz-border-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1232,
            "use.counter.css.page",
            "css_moz_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start_color
    ///
    /// Whether a page used the CSS property -moz-border-start-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1233,
            "use.counter.css.page",
            "css_moz_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start_style
    ///
    /// Whether a page used the CSS property -moz-border-start-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1234,
            "use.counter.css.page",
            "css_moz_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start_width
    ///
    /// Whether a page used the CSS property -moz-border-start-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1235,
            "use.counter.css.page",
            "css_moz_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_align
    ///
    /// Whether a page used the CSS property -moz-box-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1236,
            "use.counter.css.page",
            "css_moz_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_collapse
    ///
    /// Whether a page used the CSS property -moz-box-collapse. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1237,
            "use.counter.css.page",
            "css_moz_box_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_direction
    ///
    /// Whether a page used the CSS property -moz-box-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1238,
            "use.counter.css.page",
            "css_moz_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_flex
    ///
    /// Whether a page used the CSS property -moz-box-flex. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1239,
            "use.counter.css.page",
            "css_moz_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_ordinal_group
    ///
    /// Whether a page used the CSS property -moz-box-ordinal-group. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1240,
            "use.counter.css.page",
            "css_moz_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_orient
    ///
    /// Whether a page used the CSS property -moz-box-orient. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1241,
            "use.counter.css.page",
            "css_moz_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_pack
    ///
    /// Whether a page used the CSS property -moz-box-pack. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1242,
            "use.counter.css.page",
            "css_moz_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_sizing
    ///
    /// Whether a page used the CSS property -moz-box-sizing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1243,
            "use.counter.css.page",
            "css_moz_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_context_properties
    ///
    /// Whether a page used the CSS property -moz-context-properties. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_context_properties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1244,
            "use.counter.css.page",
            "css_moz_context_properties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_control_character_visibility
    ///
    /// Whether a page used the CSS property -moz-control-character-visibility. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_control_character_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1245,
            "use.counter.css.page",
            "css_moz_control_character_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_default_appearance
    ///
    /// Whether a page used the CSS property -moz-default-appearance. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_default_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1246,
            "use.counter.css.page",
            "css_moz_default_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_float_edge
    ///
    /// Whether a page used the CSS property -moz-float-edge. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_float_edge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1247,
            "use.counter.css.page",
            "css_moz_float_edge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_font_feature_settings
    ///
    /// Whether a page used the CSS property -moz-font-feature-settings. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1248,
            "use.counter.css.page",
            "css_moz_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_font_language_override
    ///
    /// Whether a page used the CSS property -moz-font-language-override. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1249,
            "use.counter.css.page",
            "css_moz_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_force_broken_image_icon
    ///
    /// Whether a page used the CSS property -moz-force-broken-image-icon. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_force_broken_image_icon: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1250,
            "use.counter.css.page",
            "css_moz_force_broken_image_icon",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_hyphens
    ///
    /// Whether a page used the CSS property -moz-hyphens. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1251,
            "use.counter.css.page",
            "css_moz_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_inert
    ///
    /// Whether a page used the CSS property -moz-inert. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_inert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1252,
            "use.counter.css.page",
            "css_moz_inert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_margin_end
    ///
    /// Whether a page used the CSS property -moz-margin-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1253,
            "use.counter.css.page",
            "css_moz_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_margin_start
    ///
    /// Whether a page used the CSS property -moz-margin-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1254,
            "use.counter.css.page",
            "css_moz_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_math_variant
    ///
    /// Whether a page used the CSS property -moz-math-variant. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1255,
            "use.counter.css.page",
            "css_moz_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_min_font_size_ratio
    ///
    /// Whether a page used the CSS property -moz-min-font-size-ratio. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_min_font_size_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1256,
            "use.counter.css.page",
            "css_moz_min_font_size_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_orient
    ///
    /// Whether a page used the CSS property -moz-orient. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1257,
            "use.counter.css.page",
            "css_moz_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_osx_font_smoothing
    ///
    /// Whether a page used the CSS property -moz-osx-font-smoothing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_osx_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1258,
            "use.counter.css.page",
            "css_moz_osx_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_padding_end
    ///
    /// Whether a page used the CSS property -moz-padding-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1259,
            "use.counter.css.page",
            "css_moz_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_padding_start
    ///
    /// Whether a page used the CSS property -moz-padding-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1260,
            "use.counter.css.page",
            "css_moz_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_perspective
    ///
    /// Whether a page used the CSS property -moz-perspective. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1261,
            "use.counter.css.page",
            "css_moz_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_perspective_origin
    ///
    /// Whether a page used the CSS property -moz-perspective-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1262,
            "use.counter.css.page",
            "css_moz_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_subtree_hidden_only_visually
    ///
    /// Whether a page used the CSS property -moz-subtree-hidden-only-visually. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_subtree_hidden_only_visually: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1263,
            "use.counter.css.page",
            "css_moz_subtree_hidden_only_visually",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_tab_size
    ///
    /// Whether a page used the CSS property -moz-tab-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1264,
            "use.counter.css.page",
            "css_moz_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_text_size_adjust
    ///
    /// Whether a page used the CSS property -moz-text-size-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1265,
            "use.counter.css.page",
            "css_moz_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_theme
    ///
    /// Whether a page used the CSS property -moz-theme. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_theme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1266,
            "use.counter.css.page",
            "css_moz_theme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_top_layer
    ///
    /// Whether a page used the CSS property -moz-top-layer. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_top_layer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1267,
            "use.counter.css.page",
            "css_moz_top_layer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transform
    ///
    /// Whether a page used the CSS property -moz-transform. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1268,
            "use.counter.css.page",
            "css_moz_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transform_origin
    ///
    /// Whether a page used the CSS property -moz-transform-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1269,
            "use.counter.css.page",
            "css_moz_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transform_style
    ///
    /// Whether a page used the CSS property -moz-transform-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1270,
            "use.counter.css.page",
            "css_moz_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition
    ///
    /// Whether a page used the CSS property -moz-transition. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1271,
            "use.counter.css.page",
            "css_moz_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_delay
    ///
    /// Whether a page used the CSS property -moz-transition-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1272,
            "use.counter.css.page",
            "css_moz_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_duration
    ///
    /// Whether a page used the CSS property -moz-transition-duration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1273,
            "use.counter.css.page",
            "css_moz_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_property
    ///
    /// Whether a page used the CSS property -moz-transition-property. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1274,
            "use.counter.css.page",
            "css_moz_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_timing_function
    ///
    /// Whether a page used the CSS property -moz-transition-timing-function. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1275,
            "use.counter.css.page",
            "css_moz_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_user_focus
    ///
    /// Whether a page used the CSS property -moz-user-focus. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_focus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1276,
            "use.counter.css.page",
            "css_moz_user_focus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_user_input
    ///
    /// Whether a page used the CSS property -moz-user-input. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_input: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1277,
            "use.counter.css.page",
            "css_moz_user_input",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_user_modify
    ///
    /// Whether a page used the CSS property -moz-user-modify. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_modify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1278,
            "use.counter.css.page",
            "css_moz_user_modify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_user_select
    ///
    /// Whether a page used the CSS property -moz-user-select. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1279,
            "use.counter.css.page",
            "css_moz_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_dragging
    ///
    /// Whether a page used the CSS property -moz-window-dragging. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_dragging: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1280,
            "use.counter.css.page",
            "css_moz_window_dragging",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_input_region_margin
    ///
    /// Whether a page used the CSS property -moz-window-input-region-margin. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_window_input_region_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1281,
            "use.counter.css.page",
            "css_moz_window_input_region_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_opacity
    ///
    /// Whether a page used the CSS property -moz-window-opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1282,
            "use.counter.css.page",
            "css_moz_window_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_shadow
    ///
    /// Whether a page used the CSS property -moz-window-shadow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1283,
            "use.counter.css.page",
            "css_moz_window_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_transform
    ///
    /// Whether a page used the CSS property -moz-window-transform. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1284,
            "use.counter.css.page",
            "css_moz_window_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_transform_origin
    ///
    /// Whether a page used the CSS property -moz-window-transform-origin. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_moz_window_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1285,
            "use.counter.css.page",
            "css_moz_window_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_object_fit
    ///
    /// Whether a page used the CSS property object-fit. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_object_fit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1286,
            "use.counter.css.page",
            "css_object_fit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_object_position
    ///
    /// Whether a page used the CSS property object-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_object_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1287,
            "use.counter.css.page",
            "css_object_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset
    ///
    /// Whether a page used the CSS property offset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1288,
            "use.counter.css.page",
            "css_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_anchor
    ///
    /// Whether a page used the CSS property offset-anchor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1289,
            "use.counter.css.page",
            "css_offset_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_distance
    ///
    /// Whether a page used the CSS property offset-distance. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_distance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1290,
            "use.counter.css.page",
            "css_offset_distance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_path
    ///
    /// Whether a page used the CSS property offset-path. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1291,
            "use.counter.css.page",
            "css_offset_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_position
    ///
    /// Whether a page used the CSS property offset-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1292,
            "use.counter.css.page",
            "css_offset_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_rotate
    ///
    /// Whether a page used the CSS property offset-rotate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1293,
            "use.counter.css.page",
            "css_offset_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_opacity
    ///
    /// Whether a page used the CSS property opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1294,
            "use.counter.css.page",
            "css_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_order
    ///
    /// Whether a page used the CSS property order. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1295,
            "use.counter.css.page",
            "css_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline
    ///
    /// Whether a page used the CSS property outline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1296,
            "use.counter.css.page",
            "css_outline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_color
    ///
    /// Whether a page used the CSS property outline-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1297,
            "use.counter.css.page",
            "css_outline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_offset
    ///
    /// Whether a page used the CSS property outline-offset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1298,
            "use.counter.css.page",
            "css_outline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_style
    ///
    /// Whether a page used the CSS property outline-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1299,
            "use.counter.css.page",
            "css_outline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_width
    ///
    /// Whether a page used the CSS property outline-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1300,
            "use.counter.css.page",
            "css_outline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow
    ///
    /// Whether a page used the CSS property overflow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1301,
            "use.counter.css.page",
            "css_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_anchor
    ///
    /// Whether a page used the CSS property overflow-anchor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1302,
            "use.counter.css.page",
            "css_overflow_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_block
    ///
    /// Whether a page used the CSS property overflow-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1303,
            "use.counter.css.page",
            "css_overflow_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_box
    ///
    /// Whether a page used the CSS property overflow-clip-box. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1304,
            "use.counter.css.page",
            "css_overflow_clip_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_box_block
    ///
    /// Whether a page used the CSS property overflow-clip-box-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1305,
            "use.counter.css.page",
            "css_overflow_clip_box_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_box_inline
    ///
    /// Whether a page used the CSS property overflow-clip-box-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1306,
            "use.counter.css.page",
            "css_overflow_clip_box_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_margin
    ///
    /// Whether a page used the CSS property overflow-clip-margin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1307,
            "use.counter.css.page",
            "css_overflow_clip_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_inline
    ///
    /// Whether a page used the CSS property overflow-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1308,
            "use.counter.css.page",
            "css_overflow_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_wrap
    ///
    /// Whether a page used the CSS property overflow-wrap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1309,
            "use.counter.css.page",
            "css_overflow_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_x
    ///
    /// Whether a page used the CSS property overflow-x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1310,
            "use.counter.css.page",
            "css_overflow_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_y
    ///
    /// Whether a page used the CSS property overflow-y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1311,
            "use.counter.css.page",
            "css_overflow_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior
    ///
    /// Whether a page used the CSS property overscroll-behavior. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1312,
            "use.counter.css.page",
            "css_overscroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_block
    ///
    /// Whether a page used the CSS property overscroll-behavior-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1313,
            "use.counter.css.page",
            "css_overscroll_behavior_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_inline
    ///
    /// Whether a page used the CSS property overscroll-behavior-inline. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_overscroll_behavior_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1314,
            "use.counter.css.page",
            "css_overscroll_behavior_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_x
    ///
    /// Whether a page used the CSS property overscroll-behavior-x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1315,
            "use.counter.css.page",
            "css_overscroll_behavior_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_y
    ///
    /// Whether a page used the CSS property overscroll-behavior-y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1316,
            "use.counter.css.page",
            "css_overscroll_behavior_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding
    ///
    /// Whether a page used the CSS property padding. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1317,
            "use.counter.css.page",
            "css_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_block
    ///
    /// Whether a page used the CSS property padding-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1318,
            "use.counter.css.page",
            "css_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_block_end
    ///
    /// Whether a page used the CSS property padding-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1319,
            "use.counter.css.page",
            "css_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_block_start
    ///
    /// Whether a page used the CSS property padding-block-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1320,
            "use.counter.css.page",
            "css_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_bottom
    ///
    /// Whether a page used the CSS property padding-bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1321,
            "use.counter.css.page",
            "css_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_inline
    ///
    /// Whether a page used the CSS property padding-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1322,
            "use.counter.css.page",
            "css_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_inline_end
    ///
    /// Whether a page used the CSS property padding-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1323,
            "use.counter.css.page",
            "css_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_inline_start
    ///
    /// Whether a page used the CSS property padding-inline-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1324,
            "use.counter.css.page",
            "css_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_left
    ///
    /// Whether a page used the CSS property padding-left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1325,
            "use.counter.css.page",
            "css_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_right
    ///
    /// Whether a page used the CSS property padding-right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1326,
            "use.counter.css.page",
            "css_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_top
    ///
    /// Whether a page used the CSS property padding-top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1327,
            "use.counter.css.page",
            "css_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page
    ///
    /// Whether a page used the CSS property page. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1328,
            "use.counter.css.page",
            "css_page",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_break_after
    ///
    /// Whether a page used the CSS property page-break-after. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1329,
            "use.counter.css.page",
            "css_page_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_break_before
    ///
    /// Whether a page used the CSS property page-break-before. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1330,
            "use.counter.css.page",
            "css_page_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_break_inside
    ///
    /// Whether a page used the CSS property page-break-inside. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1331,
            "use.counter.css.page",
            "css_page_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_orientation
    ///
    /// Whether a page used the CSS property page-orientation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1332,
            "use.counter.css.page",
            "css_page_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_paint_order
    ///
    /// Whether a page used the CSS property paint-order. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_paint_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1333,
            "use.counter.css.page",
            "css_paint_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_perspective
    ///
    /// Whether a page used the CSS property perspective. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1334,
            "use.counter.css.page",
            "css_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_perspective_origin
    ///
    /// Whether a page used the CSS property perspective-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1335,
            "use.counter.css.page",
            "css_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_place_content
    ///
    /// Whether a page used the CSS property place-content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_place_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1336,
            "use.counter.css.page",
            "css_place_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_place_items
    ///
    /// Whether a page used the CSS property place-items. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_place_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1337,
            "use.counter.css.page",
            "css_place_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_place_self
    ///
    /// Whether a page used the CSS property place-self. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_place_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1338,
            "use.counter.css.page",
            "css_place_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_pointer_events
    ///
    /// Whether a page used the CSS property pointer-events. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_pointer_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1339,
            "use.counter.css.page",
            "css_pointer_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position
    ///
    /// Whether a page used the CSS property position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1340,
            "use.counter.css.page",
            "css_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_anchor
    ///
    /// Whether a page used the CSS property position-anchor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1341,
            "use.counter.css.page",
            "css_position_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_try_options
    ///
    /// Whether a page used the CSS property position-try-options. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_try_options: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1342,
            "use.counter.css.page",
            "css_position_try_options",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_try_order
    ///
    /// Whether a page used the CSS property position-try-order. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_try_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1343,
            "use.counter.css.page",
            "css_position_try_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_visibility
    ///
    /// Whether a page used the CSS property position-visibility. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1344,
            "use.counter.css.page",
            "css_position_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_print_color_adjust
    ///
    /// Whether a page used the CSS property print-color-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1345,
            "use.counter.css.page",
            "css_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_quotes
    ///
    /// Whether a page used the CSS property quotes. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_quotes: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1346,
            "use.counter.css.page",
            "css_quotes",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_r
    ///
    /// Whether a page used the CSS property r. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_r: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1347,
            "use.counter.css.page",
            "css_r",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_resize
    ///
    /// Whether a page used the CSS property resize. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_resize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1348,
            "use.counter.css.page",
            "css_resize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_right
    ///
    /// Whether a page used the CSS property right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1349,
            "use.counter.css.page",
            "css_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_rotate
    ///
    /// Whether a page used the CSS property rotate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1350,
            "use.counter.css.page",
            "css_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_row_gap
    ///
    /// Whether a page used the CSS property row-gap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1351,
            "use.counter.css.page",
            "css_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ruby_align
    ///
    /// Whether a page used the CSS property ruby-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ruby_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1352,
            "use.counter.css.page",
            "css_ruby_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ruby_position
    ///
    /// Whether a page used the CSS property ruby-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1353,
            "use.counter.css.page",
            "css_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_rx
    ///
    /// Whether a page used the CSS property rx. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_rx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1354,
            "use.counter.css.page",
            "css_rx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ry
    ///
    /// Whether a page used the CSS property ry. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ry: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1355,
            "use.counter.css.page",
            "css_ry",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scale
    ///
    /// Whether a page used the CSS property scale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1356,
            "use.counter.css.page",
            "css_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_behavior
    ///
    /// Whether a page used the CSS property scroll-behavior. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1357,
            "use.counter.css.page",
            "css_scroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin
    ///
    /// Whether a page used the CSS property scroll-margin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1358,
            "use.counter.css.page",
            "css_scroll_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_block
    ///
    /// Whether a page used the CSS property scroll-margin-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1359,
            "use.counter.css.page",
            "css_scroll_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_block_end
    ///
    /// Whether a page used the CSS property scroll-margin-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1360,
            "use.counter.css.page",
            "css_scroll_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_block_start
    ///
    /// Whether a page used the CSS property scroll-margin-block-start. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1361,
            "use.counter.css.page",
            "css_scroll_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_bottom
    ///
    /// Whether a page used the CSS property scroll-margin-bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1362,
            "use.counter.css.page",
            "css_scroll_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_inline
    ///
    /// Whether a page used the CSS property scroll-margin-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1363,
            "use.counter.css.page",
            "css_scroll_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_inline_end
    ///
    /// Whether a page used the CSS property scroll-margin-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1364,
            "use.counter.css.page",
            "css_scroll_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_inline_start
    ///
    /// Whether a page used the CSS property scroll-margin-inline-start. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_scroll_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1365,
            "use.counter.css.page",
            "css_scroll_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_left
    ///
    /// Whether a page used the CSS property scroll-margin-left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1366,
            "use.counter.css.page",
            "css_scroll_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_right
    ///
    /// Whether a page used the CSS property scroll-margin-right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1367,
            "use.counter.css.page",
            "css_scroll_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_top
    ///
    /// Whether a page used the CSS property scroll-margin-top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1368,
            "use.counter.css.page",
            "css_scroll_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding
    ///
    /// Whether a page used the CSS property scroll-padding. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1369,
            "use.counter.css.page",
            "css_scroll_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_block
    ///
    /// Whether a page used the CSS property scroll-padding-block. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1370,
            "use.counter.css.page",
            "css_scroll_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_block_end
    ///
    /// Whether a page used the CSS property scroll-padding-block-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1371,
            "use.counter.css.page",
            "css_scroll_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_block_start
    ///
    /// Whether a page used the CSS property scroll-padding-block-start. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_scroll_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1372,
            "use.counter.css.page",
            "css_scroll_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_bottom
    ///
    /// Whether a page used the CSS property scroll-padding-bottom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1373,
            "use.counter.css.page",
            "css_scroll_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_inline
    ///
    /// Whether a page used the CSS property scroll-padding-inline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1374,
            "use.counter.css.page",
            "css_scroll_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_inline_end
    ///
    /// Whether a page used the CSS property scroll-padding-inline-end. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1375,
            "use.counter.css.page",
            "css_scroll_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_inline_start
    ///
    /// Whether a page used the CSS property scroll-padding-inline-start. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_scroll_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1376,
            "use.counter.css.page",
            "css_scroll_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_left
    ///
    /// Whether a page used the CSS property scroll-padding-left. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1377,
            "use.counter.css.page",
            "css_scroll_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_right
    ///
    /// Whether a page used the CSS property scroll-padding-right. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1378,
            "use.counter.css.page",
            "css_scroll_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_top
    ///
    /// Whether a page used the CSS property scroll-padding-top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1379,
            "use.counter.css.page",
            "css_scroll_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_snap_align
    ///
    /// Whether a page used the CSS property scroll-snap-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1380,
            "use.counter.css.page",
            "css_scroll_snap_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_snap_stop
    ///
    /// Whether a page used the CSS property scroll-snap-stop. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_stop: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1381,
            "use.counter.css.page",
            "css_scroll_snap_stop",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_snap_type
    ///
    /// Whether a page used the CSS property scroll-snap-type. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1382,
            "use.counter.css.page",
            "css_scroll_snap_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_timeline
    ///
    /// Whether a page used the CSS property scroll-timeline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1383,
            "use.counter.css.page",
            "css_scroll_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_timeline_axis
    ///
    /// Whether a page used the CSS property scroll-timeline-axis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1384,
            "use.counter.css.page",
            "css_scroll_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_timeline_name
    ///
    /// Whether a page used the CSS property scroll-timeline-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1385,
            "use.counter.css.page",
            "css_scroll_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scrollbar_color
    ///
    /// Whether a page used the CSS property scrollbar-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1386,
            "use.counter.css.page",
            "css_scrollbar_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scrollbar_gutter
    ///
    /// Whether a page used the CSS property scrollbar-gutter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_gutter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1387,
            "use.counter.css.page",
            "css_scrollbar_gutter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scrollbar_width
    ///
    /// Whether a page used the CSS property scrollbar-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1388,
            "use.counter.css.page",
            "css_scrollbar_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_image_threshold
    ///
    /// Whether a page used the CSS property shape-image-threshold. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1389,
            "use.counter.css.page",
            "css_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_margin
    ///
    /// Whether a page used the CSS property shape-margin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1390,
            "use.counter.css.page",
            "css_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_outside
    ///
    /// Whether a page used the CSS property shape-outside. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1391,
            "use.counter.css.page",
            "css_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_rendering
    ///
    /// Whether a page used the CSS property shape-rendering. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1392,
            "use.counter.css.page",
            "css_shape_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_size
    ///
    /// Whether a page used the CSS property size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1393,
            "use.counter.css.page",
            "css_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stop_color
    ///
    /// Whether a page used the CSS property stop-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stop_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1394,
            "use.counter.css.page",
            "css_stop_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stop_opacity
    ///
    /// Whether a page used the CSS property stop-opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stop_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1395,
            "use.counter.css.page",
            "css_stop_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke
    ///
    /// Whether a page used the CSS property stroke. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1396,
            "use.counter.css.page",
            "css_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_dasharray
    ///
    /// Whether a page used the CSS property stroke-dasharray. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dasharray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1397,
            "use.counter.css.page",
            "css_stroke_dasharray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_dashoffset
    ///
    /// Whether a page used the CSS property stroke-dashoffset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dashoffset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1398,
            "use.counter.css.page",
            "css_stroke_dashoffset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_linecap
    ///
    /// Whether a page used the CSS property stroke-linecap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linecap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1399,
            "use.counter.css.page",
            "css_stroke_linecap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_linejoin
    ///
    /// Whether a page used the CSS property stroke-linejoin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linejoin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1400,
            "use.counter.css.page",
            "css_stroke_linejoin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_miterlimit
    ///
    /// Whether a page used the CSS property stroke-miterlimit. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_miterlimit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1401,
            "use.counter.css.page",
            "css_stroke_miterlimit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_opacity
    ///
    /// Whether a page used the CSS property stroke-opacity. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1402,
            "use.counter.css.page",
            "css_stroke_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_width
    ///
    /// Whether a page used the CSS property stroke-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1403,
            "use.counter.css.page",
            "css_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_tab_size
    ///
    /// Whether a page used the CSS property tab-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1404,
            "use.counter.css.page",
            "css_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_table_layout
    ///
    /// Whether a page used the CSS property table-layout. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_table_layout: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1405,
            "use.counter.css.page",
            "css_table_layout",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_align
    ///
    /// Whether a page used the CSS property text-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1406,
            "use.counter.css.page",
            "css_text_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_align_last
    ///
    /// Whether a page used the CSS property text-align-last. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_align_last: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1407,
            "use.counter.css.page",
            "css_text_align_last",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_anchor
    ///
    /// Whether a page used the CSS property text-anchor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1408,
            "use.counter.css.page",
            "css_text_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_combine_upright
    ///
    /// Whether a page used the CSS property text-combine-upright. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_combine_upright: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1409,
            "use.counter.css.page",
            "css_text_combine_upright",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration
    ///
    /// Whether a page used the CSS property text-decoration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1410,
            "use.counter.css.page",
            "css_text_decoration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_color
    ///
    /// Whether a page used the CSS property text-decoration-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1411,
            "use.counter.css.page",
            "css_text_decoration_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_line
    ///
    /// Whether a page used the CSS property text-decoration-line. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_line: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1412,
            "use.counter.css.page",
            "css_text_decoration_line",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_skip_ink
    ///
    /// Whether a page used the CSS property text-decoration-skip-ink. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_skip_ink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1413,
            "use.counter.css.page",
            "css_text_decoration_skip_ink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_style
    ///
    /// Whether a page used the CSS property text-decoration-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1414,
            "use.counter.css.page",
            "css_text_decoration_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_thickness
    ///
    /// Whether a page used the CSS property text-decoration-thickness. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_thickness: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1415,
            "use.counter.css.page",
            "css_text_decoration_thickness",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis
    ///
    /// Whether a page used the CSS property text-emphasis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1416,
            "use.counter.css.page",
            "css_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis_color
    ///
    /// Whether a page used the CSS property text-emphasis-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1417,
            "use.counter.css.page",
            "css_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis_position
    ///
    /// Whether a page used the CSS property text-emphasis-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1418,
            "use.counter.css.page",
            "css_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis_style
    ///
    /// Whether a page used the CSS property text-emphasis-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1419,
            "use.counter.css.page",
            "css_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_indent
    ///
    /// Whether a page used the CSS property text-indent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_indent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1420,
            "use.counter.css.page",
            "css_text_indent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_justify
    ///
    /// Whether a page used the CSS property text-justify. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_justify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1421,
            "use.counter.css.page",
            "css_text_justify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_orientation
    ///
    /// Whether a page used the CSS property text-orientation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1422,
            "use.counter.css.page",
            "css_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_overflow
    ///
    /// Whether a page used the CSS property text-overflow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1423,
            "use.counter.css.page",
            "css_text_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_rendering
    ///
    /// Whether a page used the CSS property text-rendering. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1424,
            "use.counter.css.page",
            "css_text_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_shadow
    ///
    /// Whether a page used the CSS property text-shadow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1425,
            "use.counter.css.page",
            "css_text_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_transform
    ///
    /// Whether a page used the CSS property text-transform. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1426,
            "use.counter.css.page",
            "css_text_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_underline_offset
    ///
    /// Whether a page used the CSS property text-underline-offset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1427,
            "use.counter.css.page",
            "css_text_underline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_underline_position
    ///
    /// Whether a page used the CSS property text-underline-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1428,
            "use.counter.css.page",
            "css_text_underline_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_wrap
    ///
    /// Whether a page used the CSS property text-wrap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1429,
            "use.counter.css.page",
            "css_text_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_wrap_mode
    ///
    /// Whether a page used the CSS property text-wrap-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1430,
            "use.counter.css.page",
            "css_text_wrap_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_wrap_style
    ///
    /// Whether a page used the CSS property text-wrap-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1431,
            "use.counter.css.page",
            "css_text_wrap_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_top
    ///
    /// Whether a page used the CSS property top. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1432,
            "use.counter.css.page",
            "css_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_touch_action
    ///
    /// Whether a page used the CSS property touch-action. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_touch_action: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1433,
            "use.counter.css.page",
            "css_touch_action",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform
    ///
    /// Whether a page used the CSS property transform. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1434,
            "use.counter.css.page",
            "css_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform_box
    ///
    /// Whether a page used the CSS property transform-box. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1435,
            "use.counter.css.page",
            "css_transform_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform_origin
    ///
    /// Whether a page used the CSS property transform-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1436,
            "use.counter.css.page",
            "css_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform_style
    ///
    /// Whether a page used the CSS property transform-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1437,
            "use.counter.css.page",
            "css_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition
    ///
    /// Whether a page used the CSS property transition. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1438,
            "use.counter.css.page",
            "css_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_behavior
    ///
    /// Whether a page used the CSS property transition-behavior. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1439,
            "use.counter.css.page",
            "css_transition_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_delay
    ///
    /// Whether a page used the CSS property transition-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1440,
            "use.counter.css.page",
            "css_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_duration
    ///
    /// Whether a page used the CSS property transition-duration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1441,
            "use.counter.css.page",
            "css_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_property
    ///
    /// Whether a page used the CSS property transition-property. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1442,
            "use.counter.css.page",
            "css_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_timing_function
    ///
    /// Whether a page used the CSS property transition-timing-function. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1443,
            "use.counter.css.page",
            "css_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_translate
    ///
    /// Whether a page used the CSS property translate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_translate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1444,
            "use.counter.css.page",
            "css_translate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_unicode_bidi
    ///
    /// Whether a page used the CSS property unicode-bidi. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_unicode_bidi: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1445,
            "use.counter.css.page",
            "css_unicode_bidi",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_user_select
    ///
    /// Whether a page used the CSS property user-select. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1446,
            "use.counter.css.page",
            "css_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_vector_effect
    ///
    /// Whether a page used the CSS property vector-effect. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_vector_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1447,
            "use.counter.css.page",
            "css_vector_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_vertical_align
    ///
    /// Whether a page used the CSS property vertical-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_vertical_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1448,
            "use.counter.css.page",
            "css_vertical_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline
    ///
    /// Whether a page used the CSS property view-timeline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1449,
            "use.counter.css.page",
            "css_view_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline_axis
    ///
    /// Whether a page used the CSS property view-timeline-axis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1450,
            "use.counter.css.page",
            "css_view_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline_inset
    ///
    /// Whether a page used the CSS property view-timeline-inset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1451,
            "use.counter.css.page",
            "css_view_timeline_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline_name
    ///
    /// Whether a page used the CSS property view-timeline-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1452,
            "use.counter.css.page",
            "css_view_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_visibility
    ///
    /// Whether a page used the CSS property visibility. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1453,
            "use.counter.css.page",
            "css_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_align_content
    ///
    /// Whether a page used the CSS property -webkit-align-content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1454,
            "use.counter.css.page",
            "css_webkit_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_align_items
    ///
    /// Whether a page used the CSS property -webkit-align-items. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1455,
            "use.counter.css.page",
            "css_webkit_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_align_self
    ///
    /// Whether a page used the CSS property -webkit-align-self. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1456,
            "use.counter.css.page",
            "css_webkit_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation
    ///
    /// Whether a page used the CSS property -webkit-animation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1457,
            "use.counter.css.page",
            "css_webkit_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_delay
    ///
    /// Whether a page used the CSS property -webkit-animation-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1458,
            "use.counter.css.page",
            "css_webkit_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_direction
    ///
    /// Whether a page used the CSS property -webkit-animation-direction. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1459,
            "use.counter.css.page",
            "css_webkit_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_duration
    ///
    /// Whether a page used the CSS property -webkit-animation-duration. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1460,
            "use.counter.css.page",
            "css_webkit_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_fill_mode
    ///
    /// Whether a page used the CSS property -webkit-animation-fill-mode. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1461,
            "use.counter.css.page",
            "css_webkit_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_iteration_count
    ///
    /// Whether a page used the CSS property -webkit-animation-iteration-count. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1462,
            "use.counter.css.page",
            "css_webkit_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_name
    ///
    /// Whether a page used the CSS property -webkit-animation-name. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1463,
            "use.counter.css.page",
            "css_webkit_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_play_state
    ///
    /// Whether a page used the CSS property -webkit-animation-play-state. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1464,
            "use.counter.css.page",
            "css_webkit_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_timing_function
    ///
    /// Whether a page used the CSS property -webkit-animation-timing-function. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1465,
            "use.counter.css.page",
            "css_webkit_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_appearance
    ///
    /// Whether a page used the CSS property -webkit-appearance. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1466,
            "use.counter.css.page",
            "css_webkit_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_backface_visibility
    ///
    /// Whether a page used the CSS property -webkit-backface-visibility. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1467,
            "use.counter.css.page",
            "css_webkit_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_background_clip
    ///
    /// Whether a page used the CSS property -webkit-background-clip. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1468,
            "use.counter.css.page",
            "css_webkit_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_background_origin
    ///
    /// Whether a page used the CSS property -webkit-background-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1469,
            "use.counter.css.page",
            "css_webkit_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_background_size
    ///
    /// Whether a page used the CSS property -webkit-background-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1470,
            "use.counter.css.page",
            "css_webkit_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_bottom_left_radius
    ///
    /// Whether a page used the CSS property -webkit-border-bottom-left-radius. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1471,
            "use.counter.css.page",
            "css_webkit_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_bottom_right_radius
    ///
    /// Whether a page used the CSS property -webkit-border-bottom-right-radius.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static css_webkit_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1472,
            "use.counter.css.page",
            "css_webkit_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_image
    ///
    /// Whether a page used the CSS property -webkit-border-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1473,
            "use.counter.css.page",
            "css_webkit_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_radius
    ///
    /// Whether a page used the CSS property -webkit-border-radius. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1474,
            "use.counter.css.page",
            "css_webkit_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_top_left_radius
    ///
    /// Whether a page used the CSS property -webkit-border-top-left-radius. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1475,
            "use.counter.css.page",
            "css_webkit_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_top_right_radius
    ///
    /// Whether a page used the CSS property -webkit-border-top-right-radius. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1476,
            "use.counter.css.page",
            "css_webkit_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_align
    ///
    /// Whether a page used the CSS property -webkit-box-align. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1477,
            "use.counter.css.page",
            "css_webkit_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_direction
    ///
    /// Whether a page used the CSS property -webkit-box-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1478,
            "use.counter.css.page",
            "css_webkit_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_flex
    ///
    /// Whether a page used the CSS property -webkit-box-flex. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1479,
            "use.counter.css.page",
            "css_webkit_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_ordinal_group
    ///
    /// Whether a page used the CSS property -webkit-box-ordinal-group. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1480,
            "use.counter.css.page",
            "css_webkit_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_orient
    ///
    /// Whether a page used the CSS property -webkit-box-orient. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1481,
            "use.counter.css.page",
            "css_webkit_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_pack
    ///
    /// Whether a page used the CSS property -webkit-box-pack. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1482,
            "use.counter.css.page",
            "css_webkit_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_shadow
    ///
    /// Whether a page used the CSS property -webkit-box-shadow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1483,
            "use.counter.css.page",
            "css_webkit_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_sizing
    ///
    /// Whether a page used the CSS property -webkit-box-sizing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1484,
            "use.counter.css.page",
            "css_webkit_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_clip_path
    ///
    /// Whether a page used the CSS property -webkit-clip-path. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1485,
            "use.counter.css.page",
            "css_webkit_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_filter
    ///
    /// Whether a page used the CSS property -webkit-filter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1486,
            "use.counter.css.page",
            "css_webkit_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex
    ///
    /// Whether a page used the CSS property -webkit-flex. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1487,
            "use.counter.css.page",
            "css_webkit_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_basis
    ///
    /// Whether a page used the CSS property -webkit-flex-basis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1488,
            "use.counter.css.page",
            "css_webkit_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_direction
    ///
    /// Whether a page used the CSS property -webkit-flex-direction. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1489,
            "use.counter.css.page",
            "css_webkit_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_flow
    ///
    /// Whether a page used the CSS property -webkit-flex-flow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1490,
            "use.counter.css.page",
            "css_webkit_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_grow
    ///
    /// Whether a page used the CSS property -webkit-flex-grow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1491,
            "use.counter.css.page",
            "css_webkit_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_shrink
    ///
    /// Whether a page used the CSS property -webkit-flex-shrink. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1492,
            "use.counter.css.page",
            "css_webkit_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_wrap
    ///
    /// Whether a page used the CSS property -webkit-flex-wrap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1493,
            "use.counter.css.page",
            "css_webkit_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_font_smoothing
    ///
    /// Whether a page used the CSS property -webkit-font-smoothing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1494,
            "use.counter.css.page",
            "css_webkit_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_justify_content
    ///
    /// Whether a page used the CSS property -webkit-justify-content. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1495,
            "use.counter.css.page",
            "css_webkit_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_line_clamp
    ///
    /// Whether a page used the CSS property -webkit-line-clamp. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_line_clamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1496,
            "use.counter.css.page",
            "css_webkit_line_clamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask
    ///
    /// Whether a page used the CSS property -webkit-mask. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1497,
            "use.counter.css.page",
            "css_webkit_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_clip
    ///
    /// Whether a page used the CSS property -webkit-mask-clip. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1498,
            "use.counter.css.page",
            "css_webkit_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_composite
    ///
    /// Whether a page used the CSS property -webkit-mask-composite. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1499,
            "use.counter.css.page",
            "css_webkit_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_image
    ///
    /// Whether a page used the CSS property -webkit-mask-image. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1500,
            "use.counter.css.page",
            "css_webkit_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_origin
    ///
    /// Whether a page used the CSS property -webkit-mask-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1501,
            "use.counter.css.page",
            "css_webkit_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_position
    ///
    /// Whether a page used the CSS property -webkit-mask-position. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1502,
            "use.counter.css.page",
            "css_webkit_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_position_x
    ///
    /// Whether a page used the CSS property -webkit-mask-position-x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1503,
            "use.counter.css.page",
            "css_webkit_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_position_y
    ///
    /// Whether a page used the CSS property -webkit-mask-position-y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1504,
            "use.counter.css.page",
            "css_webkit_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_repeat
    ///
    /// Whether a page used the CSS property -webkit-mask-repeat. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1505,
            "use.counter.css.page",
            "css_webkit_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_size
    ///
    /// Whether a page used the CSS property -webkit-mask-size. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1506,
            "use.counter.css.page",
            "css_webkit_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_order
    ///
    /// Whether a page used the CSS property -webkit-order. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1507,
            "use.counter.css.page",
            "css_webkit_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_perspective
    ///
    /// Whether a page used the CSS property -webkit-perspective. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1508,
            "use.counter.css.page",
            "css_webkit_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_perspective_origin
    ///
    /// Whether a page used the CSS property -webkit-perspective-origin. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1509,
            "use.counter.css.page",
            "css_webkit_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_fill_color
    ///
    /// Whether a page used the CSS property -webkit-text-fill-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_fill_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1510,
            "use.counter.css.page",
            "css_webkit_text_fill_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_security
    ///
    /// Whether a page used the CSS property -webkit-text-security. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_security: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1511,
            "use.counter.css.page",
            "css_webkit_text_security",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_size_adjust
    ///
    /// Whether a page used the CSS property -webkit-text-size-adjust. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1512,
            "use.counter.css.page",
            "css_webkit_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_stroke
    ///
    /// Whether a page used the CSS property -webkit-text-stroke. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1513,
            "use.counter.css.page",
            "css_webkit_text_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_stroke_color
    ///
    /// Whether a page used the CSS property -webkit-text-stroke-color. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1514,
            "use.counter.css.page",
            "css_webkit_text_stroke_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_stroke_width
    ///
    /// Whether a page used the CSS property -webkit-text-stroke-width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1515,
            "use.counter.css.page",
            "css_webkit_text_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transform
    ///
    /// Whether a page used the CSS property -webkit-transform. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1516,
            "use.counter.css.page",
            "css_webkit_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transform_origin
    ///
    /// Whether a page used the CSS property -webkit-transform-origin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1517,
            "use.counter.css.page",
            "css_webkit_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transform_style
    ///
    /// Whether a page used the CSS property -webkit-transform-style. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1518,
            "use.counter.css.page",
            "css_webkit_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition
    ///
    /// Whether a page used the CSS property -webkit-transition. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1519,
            "use.counter.css.page",
            "css_webkit_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_delay
    ///
    /// Whether a page used the CSS property -webkit-transition-delay. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1520,
            "use.counter.css.page",
            "css_webkit_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_duration
    ///
    /// Whether a page used the CSS property -webkit-transition-duration. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1521,
            "use.counter.css.page",
            "css_webkit_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_property
    ///
    /// Whether a page used the CSS property -webkit-transition-property. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static css_webkit_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1522,
            "use.counter.css.page",
            "css_webkit_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_timing_function
    ///
    /// Whether a page used the CSS property -webkit-transition-timing-function.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static css_webkit_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1523,
            "use.counter.css.page",
            "css_webkit_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_user_select
    ///
    /// Whether a page used the CSS property -webkit-user-select. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1524,
            "use.counter.css.page",
            "css_webkit_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_white_space
    ///
    /// Whether a page used the CSS property white-space. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_white_space: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1525,
            "use.counter.css.page",
            "css_white_space",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_white_space_collapse
    ///
    /// Whether a page used the CSS property white-space-collapse. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_white_space_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1526,
            "use.counter.css.page",
            "css_white_space_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_width
    ///
    /// Whether a page used the CSS property width. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1527,
            "use.counter.css.page",
            "css_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_will_change
    ///
    /// Whether a page used the CSS property will-change. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_will_change: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1528,
            "use.counter.css.page",
            "css_will_change",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_word_break
    ///
    /// Whether a page used the CSS property word-break. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_word_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1529,
            "use.counter.css.page",
            "css_word_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_word_spacing
    ///
    /// Whether a page used the CSS property word-spacing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_word_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1530,
            "use.counter.css.page",
            "css_word_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_word_wrap
    ///
    /// Whether a page used the CSS property word-wrap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_word_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1531,
            "use.counter.css.page",
            "css_word_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_writing_mode
    ///
    /// Whether a page used the CSS property writing-mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1532,
            "use.counter.css.page",
            "css_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x
    ///
    /// Whether a page used the CSS property x. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1533,
            "use.counter.css.page",
            "css_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x_lang
    ///
    /// Whether a page used the CSS property -x-lang. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x_lang: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1534,
            "use.counter.css.page",
            "css_x_lang",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x_span
    ///
    /// Whether a page used the CSS property -x-span. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1535,
            "use.counter.css.page",
            "css_x_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x_text_scale
    ///
    /// Whether a page used the CSS property -x-text-scale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x_text_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1536,
            "use.counter.css.page",
            "css_x_text_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_y
    ///
    /// Whether a page used the CSS property y. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1537,
            "use.counter.css.page",
            "css_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_z_index
    ///
    /// Whether a page used the CSS property z-index. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_z_index: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1538,
            "use.counter.css.page",
            "css_z_index",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_zoom
    ///
    /// Whether a page used the CSS property zoom. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1539,
            "use.counter.css.page",
            "css_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.max_zoom
    ///
    /// Whether a page used the (unknown, counted) CSS property max-zoom. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static max_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1540,
            "use.counter.css.page",
            "max_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.min_zoom
    ///
    /// Whether a page used the (unknown, counted) CSS property min-zoom. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static min_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1541,
            "use.counter.css.page",
            "min_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.orientation
    ///
    /// Whether a page used the (unknown, counted) CSS property orientation. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1542,
            "use.counter.css.page",
            "orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.orphans
    ///
    /// Whether a page used the (unknown, counted) CSS property orphans. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static orphans: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1543,
            "use.counter.css.page",
            "orphans",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.speak
    ///
    /// Whether a page used the (unknown, counted) CSS property speak. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static speak: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1544,
            "use.counter.css.page",
            "speak",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.text_size_adjust
    ///
    /// Whether a page used the (unknown, counted) CSS property text-size-adjust.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1545,
            "use.counter.css.page",
            "text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.user_zoom
    ///
    /// Whether a page used the (unknown, counted) CSS property user-zoom. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static user_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1546,
            "use.counter.css.page",
            "user_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_app_region
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-app-region.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_app_region: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1547,
            "use.counter.css.page",
            "webkit_app_region",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1548,
            "use.counter.css.page",
            "webkit_border_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1549,
            "use.counter.css.page",
            "webkit_border_after_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1550,
            "use.counter.css.page",
            "webkit_border_after_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_after_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1551,
            "use.counter.css.page",
            "webkit_border_after_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1552,
            "use.counter.css.page",
            "webkit_border_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1553,
            "use.counter.css.page",
            "webkit_border_before_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1554,
            "use.counter.css.page",
            "webkit_border_before_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_before_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1555,
            "use.counter.css.page",
            "webkit_border_before_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1556,
            "use.counter.css.page",
            "webkit_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1557,
            "use.counter.css.page",
            "webkit_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1558,
            "use.counter.css.page",
            "webkit_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1559,
            "use.counter.css.page",
            "webkit_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_horizontal_spacing
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-
    /// horizontal-spacing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_horizontal_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1560,
            "use.counter.css.page",
            "webkit_border_horizontal_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1561,
            "use.counter.css.page",
            "webkit_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1562,
            "use.counter.css.page",
            "webkit_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1563,
            "use.counter.css.page",
            "webkit_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1564,
            "use.counter.css.page",
            "webkit_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_vertical_spacing
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-
    /// vertical-spacing. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_vertical_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1565,
            "use.counter.css.page",
            "webkit_border_vertical_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_box_decoration_break
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-box-decoration-
    /// break. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1566,
            "use.counter.css.page",
            "webkit_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_box_reflect
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-box-reflect.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_box_reflect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1567,
            "use.counter.css.page",
            "webkit_box_reflect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_break_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-break-
    /// after. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1568,
            "use.counter.css.page",
            "webkit_column_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_break_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-break-
    /// before. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1569,
            "use.counter.css.page",
            "webkit_column_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_break_inside
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-break-
    /// inside. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1570,
            "use.counter.css.page",
            "webkit_column_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_count
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-count.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1571,
            "use.counter.css.page",
            "webkit_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_gap
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-gap.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1572,
            "use.counter.css.page",
            "webkit_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1573,
            "use.counter.css.page",
            "webkit_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1574,
            "use.counter.css.page",
            "webkit_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1575,
            "use.counter.css.page",
            "webkit_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1576,
            "use.counter.css.page",
            "webkit_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_span
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-span.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1577,
            "use.counter.css.page",
            "webkit_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-width.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1578,
            "use.counter.css.page",
            "webkit_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_columns
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-columns.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1579,
            "use.counter.css.page",
            "webkit_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_font_feature_settings
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-font-feature-
    /// settings. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1580,
            "use.counter.css.page",
            "webkit_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_font_size_delta
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-font-size-
    /// delta. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_font_size_delta: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1581,
            "use.counter.css.page",
            "webkit_font_size_delta",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_highlight
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-highlight.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_highlight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1582,
            "use.counter.css.page",
            "webkit_highlight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_hyphenate_character
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-hyphenate-
    /// character. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1583,
            "use.counter.css.page",
            "webkit_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_line_break
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-line-break.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1584,
            "use.counter.css.page",
            "webkit_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_locale
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-locale. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static webkit_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1585,
            "use.counter.css.page",
            "webkit_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_logical_height
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-logical-height.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1586,
            "use.counter.css.page",
            "webkit_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_logical_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-logical-width.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1587,
            "use.counter.css.page",
            "webkit_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-after.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1588,
            "use.counter.css.page",
            "webkit_margin_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_after_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-after-
    /// collapse. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_margin_after_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1589,
            "use.counter.css.page",
            "webkit_margin_after_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-before.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1590,
            "use.counter.css.page",
            "webkit_margin_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_before_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-before-
    /// collapse. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_margin_before_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1591,
            "use.counter.css.page",
            "webkit_margin_before_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_bottom_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-bottom-
    /// collapse. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_margin_bottom_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1592,
            "use.counter.css.page",
            "webkit_margin_bottom_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-
    /// collapse. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_margin_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1593,
            "use.counter.css.page",
            "webkit_margin_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_end
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-end.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1594,
            "use.counter.css.page",
            "webkit_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_start
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-start.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1595,
            "use.counter.css.page",
            "webkit_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_top_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-top-
    /// collapse. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_margin_top_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1596,
            "use.counter.css.page",
            "webkit_margin_top_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1597,
            "use.counter.css.page",
            "webkit_mask_box_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_outset
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
    /// outset. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1598,
            "use.counter.css.page",
            "webkit_mask_box_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_repeat
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
    /// repeat. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1599,
            "use.counter.css.page",
            "webkit_mask_box_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_slice
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
    /// slice. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1600,
            "use.counter.css.page",
            "webkit_mask_box_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_source
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
    /// source. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1601,
            "use.counter.css.page",
            "webkit_mask_box_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_box_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1602,
            "use.counter.css.page",
            "webkit_mask_box_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_repeat_x
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-repeat-x.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1603,
            "use.counter.css.page",
            "webkit_mask_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_repeat_y
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-repeat-y.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_mask_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1604,
            "use.counter.css.page",
            "webkit_mask_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_max_logical_height
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-max-logical-
    /// height. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_max_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1605,
            "use.counter.css.page",
            "webkit_max_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_max_logical_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-max-logical-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_max_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1606,
            "use.counter.css.page",
            "webkit_max_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_min_logical_height
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-min-logical-
    /// height. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_min_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1607,
            "use.counter.css.page",
            "webkit_min_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_min_logical_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-min-logical-
    /// width. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_min_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1608,
            "use.counter.css.page",
            "webkit_min_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_opacity
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-opacity.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1609,
            "use.counter.css.page",
            "webkit_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-after.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_padding_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1610,
            "use.counter.css.page",
            "webkit_padding_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-before.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_padding_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1611,
            "use.counter.css.page",
            "webkit_padding_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_end
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-end.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1612,
            "use.counter.css.page",
            "webkit_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_start
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-start.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1613,
            "use.counter.css.page",
            "webkit_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_perspective_origin_x
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-perspective-
    /// origin-x. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_perspective_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1614,
            "use.counter.css.page",
            "webkit_perspective_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_perspective_origin_y
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-perspective-
    /// origin-y. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_perspective_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1615,
            "use.counter.css.page",
            "webkit_perspective_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_print_color_adjust
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-print-color-
    /// adjust. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1616,
            "use.counter.css.page",
            "webkit_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_rtl_ordering
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-rtl-ordering.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_rtl_ordering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1617,
            "use.counter.css.page",
            "webkit_rtl_ordering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_ruby_position
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-ruby-position.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1618,
            "use.counter.css.page",
            "webkit_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_shape_image_threshold
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-shape-image-
    /// threshold. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1619,
            "use.counter.css.page",
            "webkit_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_shape_margin
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-shape-margin.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1620,
            "use.counter.css.page",
            "webkit_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_shape_outside
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-shape-outside.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1621,
            "use.counter.css.page",
            "webkit_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_tap_highlight_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-tap-highlight-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_tap_highlight_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1622,
            "use.counter.css.page",
            "webkit_tap_highlight_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_combine
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-combine.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_combine: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1623,
            "use.counter.css.page",
            "webkit_text_combine",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_decorations_in_effect
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-
    /// decorations-in-effect. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_text_decorations_in_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1624,
            "use.counter.css.page",
            "webkit_text_decorations_in_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1625,
            "use.counter.css.page",
            "webkit_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
    /// color. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1626,
            "use.counter.css.page",
            "webkit_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis_position
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
    /// position. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1627,
            "use.counter.css.page",
            "webkit_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-
    /// style. Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1628,
            "use.counter.css.page",
            "webkit_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_orientation
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-
    /// orientation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1629,
            "use.counter.css.page",
            "webkit_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_transform_origin_x
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-transform-
    /// origin-x. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_transform_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1630,
            "use.counter.css.page",
            "webkit_transform_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_transform_origin_y
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-transform-
    /// origin-y. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_transform_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1631,
            "use.counter.css.page",
            "webkit_transform_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_transform_origin_z
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-transform-
    /// origin-z. Compare against `use.counter.top_level_content_documents_destroyed`
    /// to calculate the rate.
    pub static webkit_transform_origin_z: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1632,
            "use.counter.css.page",
            "webkit_transform_origin_z",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_user_drag
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-user-drag.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_user_drag: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1633,
            "use.counter.css.page",
            "webkit_user_drag",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_user_modify
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-user-modify.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_user_modify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1634,
            "use.counter.css.page",
            "webkit_user_modify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_writing_mode
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-writing-mode.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static webkit_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1635,
            "use.counter.css.page",
            "webkit_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.widows
    ///
    /// Whether a page used the (unknown, counted) CSS property widows. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static widows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1636,
            "use.counter.css.page",
            "widows",
            "use-counters"
        )
    });

}
pub mod use_counter_deprecated_ops_doc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.ambient_light_event
    ///
    /// Whether a document used AmbientLightEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static ambient_light_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1637,
            "use.counter.deprecated_ops.doc",
            "ambient_light_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.app_cache
    ///
    /// Whether a document used AppCache. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static app_cache: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1638,
            "use.counter.deprecated_ops.doc",
            "app_cache",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.components
    ///
    /// Whether a document used Components. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static components: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1639,
            "use.counter.deprecated_ops.doc",
            "components",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.create_image_bitmap_canvas_rendering_context2_d
    ///
    /// Whether a document used CreateImageBitmapCanvasRenderingContext2D. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static create_image_bitmap_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1640,
            "use.counter.deprecated_ops.doc",
            "create_image_bitmap_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.deprecated_testing_attribute
    ///
    /// Whether a document used DeprecatedTestingAttribute. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_attribute: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1641,
            "use.counter.deprecated_ops.doc",
            "deprecated_testing_attribute",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.deprecated_testing_interface
    ///
    /// Whether a document used DeprecatedTestingInterface. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_interface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1642,
            "use.counter.deprecated_ops.doc",
            "deprecated_testing_interface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.deprecated_testing_method
    ///
    /// Whether a document used DeprecatedTestingMethod. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_method: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1643,
            "use.counter.deprecated_ops.doc",
            "deprecated_testing_method",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.document_release_capture
    ///
    /// Whether a document used DocumentReleaseCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1644,
            "use.counter.deprecated_ops.doc",
            "document_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domattr_modified
    ///
    /// Whether a document used DOMAttrModified. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domattr_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1645,
            "use.counter.deprecated_ops.doc",
            "domattr_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domcharacter_data_modified
    ///
    /// Whether a document used DOMCharacterDataModified. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domcharacter_data_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1646,
            "use.counter.deprecated_ops.doc",
            "domcharacter_data_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_inserted
    ///
    /// Whether a document used DOMNodeInserted. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1647,
            "use.counter.deprecated_ops.doc",
            "domnode_inserted",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_inserted_into_document
    ///
    /// Whether a document used DOMNodeInsertedIntoDocument. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted_into_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1648,
            "use.counter.deprecated_ops.doc",
            "domnode_inserted_into_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_removed
    ///
    /// Whether a document used DOMNodeRemoved. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_removed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1649,
            "use.counter.deprecated_ops.doc",
            "domnode_removed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_removed_from_document
    ///
    /// Whether a document used DOMNodeRemovedFromDocument. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_removed_from_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1650,
            "use.counter.deprecated_ops.doc",
            "domnode_removed_from_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domquad_bounds_attr
    ///
    /// Whether a document used DOMQuadBoundsAttr. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domquad_bounds_attr: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1651,
            "use.counter.deprecated_ops.doc",
            "domquad_bounds_attr",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domsubtree_modified
    ///
    /// Whether a document used DOMSubtreeModified. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domsubtree_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1652,
            "use.counter.deprecated_ops.doc",
            "domsubtree_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.draw_window_canvas_rendering_context2_d
    ///
    /// Whether a document used DrawWindowCanvasRenderingContext2D. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static draw_window_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1653,
            "use.counter.deprecated_ops.doc",
            "draw_window_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.element_release_capture
    ///
    /// Whether a document used ElementReleaseCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1654,
            "use.counter.deprecated_ops.doc",
            "element_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.element_set_capture
    ///
    /// Whether a document used ElementSetCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_set_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1655,
            "use.counter.deprecated_ops.doc",
            "element_set_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.external__add_search_provider
    ///
    /// Whether a document used External_AddSearchProvider. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static external__add_search_provider: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1656,
            "use.counter.deprecated_ops.doc",
            "external__add_search_provider",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.form_submission_untrusted_event
    ///
    /// Whether a document used FormSubmissionUntrustedEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static form_submission_untrusted_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1657,
            "use.counter.deprecated_ops.doc",
            "form_submission_untrusted_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.idbobject_store_create_index_locale
    ///
    /// Whether a document used IDBObjectStoreCreateIndexLocale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static idbobject_store_create_index_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1658,
            "use.counter.deprecated_ops.doc",
            "idbobject_store_create_index_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.idbopen_dboptions__storage_type
    ///
    /// Whether a document used IDBOpenDBOptions_StorageType. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static idbopen_dboptions__storage_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1659,
            "use.counter.deprecated_ops.doc",
            "idbopen_dboptions__storage_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.image_bitmap_rendering_context__transfer_image_bitmap
    ///
    /// Whether a document used ImageBitmapRenderingContext_TransferImageBitmap.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static image_bitmap_rendering_context__transfer_image_bitmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1660,
            "use.counter.deprecated_ops.doc",
            "image_bitmap_rendering_context__transfer_image_bitmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.import_xulinto_content
    ///
    /// Whether a document used ImportXULIntoContent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static import_xulinto_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1661,
            "use.counter.deprecated_ops.doc",
            "import_xulinto_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.init_mouse_event
    ///
    /// Whether a document used InitMouseEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static init_mouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1662,
            "use.counter.deprecated_ops.doc",
            "init_mouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.init_nsmouse_event
    ///
    /// Whether a document used InitNSMouseEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static init_nsmouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1663,
            "use.counter.deprecated_ops.doc",
            "init_nsmouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.install_trigger_deprecated
    ///
    /// Whether a document used InstallTriggerDeprecated. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static install_trigger_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1664,
            "use.counter.deprecated_ops.doc",
            "install_trigger_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.install_trigger_install_deprecated
    ///
    /// Whether a document used InstallTriggerInstallDeprecated. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static install_trigger_install_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1665,
            "use.counter.deprecated_ops.doc",
            "install_trigger_install_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.lenient_setter
    ///
    /// Whether a document used LenientSetter. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static lenient_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1666,
            "use.counter.deprecated_ops.doc",
            "lenient_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.lenient_this
    ///
    /// Whether a document used LenientThis. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static lenient_this: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1667,
            "use.counter.deprecated_ops.doc",
            "lenient_this",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.math_ml__deprecated_math_space_value2
    ///
    /// Whether a document used MathML_DeprecatedMathSpaceValue2. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_space_value2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1668,
            "use.counter.deprecated_ops.doc",
            "math_ml__deprecated_math_space_value2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.math_ml__deprecated_math_variant
    ///
    /// Whether a document used MathML_DeprecatedMathVariant. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1669,
            "use.counter.deprecated_ops.doc",
            "math_ml__deprecated_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.math_ml__deprecated_stixgeneral_operator_stretching
    ///
    /// Whether a document used MathML_DeprecatedStixgeneralOperatorStretching. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_stixgeneral_operator_stretching: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1670,
            "use.counter.deprecated_ops.doc",
            "math_ml__deprecated_stixgeneral_operator_stretching",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.motion_event
    ///
    /// Whether a document used MotionEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static motion_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1671,
            "use.counter.deprecated_ops.doc",
            "motion_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.mouse_event__moz_pressure
    ///
    /// Whether a document used MouseEvent_MozPressure. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mouse_event__moz_pressure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1672,
            "use.counter.deprecated_ops.doc",
            "mouse_event__moz_pressure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.moz_input_source
    ///
    /// Whether a document used MozInputSource. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static moz_input_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1673,
            "use.counter.deprecated_ops.doc",
            "moz_input_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.moz_request_full_screen_deprecated_prefix
    ///
    /// Whether a document used MozRequestFullScreenDeprecatedPrefix. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static moz_request_full_screen_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1674,
            "use.counter.deprecated_ops.doc",
            "moz_request_full_screen_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.mozfullscreenchange_deprecated_prefix
    ///
    /// Whether a document used MozfullscreenchangeDeprecatedPrefix. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenchange_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1675,
            "use.counter.deprecated_ops.doc",
            "mozfullscreenchange_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.mozfullscreenerror_deprecated_prefix
    ///
    /// Whether a document used MozfullscreenerrorDeprecatedPrefix. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenerror_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1676,
            "use.counter.deprecated_ops.doc",
            "mozfullscreenerror_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.navigator_get_user_media
    ///
    /// Whether a document used NavigatorGetUserMedia. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_get_user_media: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1677,
            "use.counter.deprecated_ops.doc",
            "navigator_get_user_media",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.node_iterator_detach
    ///
    /// Whether a document used NodeIteratorDetach. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static node_iterator_detach: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1678,
            "use.counter.deprecated_ops.doc",
            "node_iterator_detach",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.offscreen_canvas_to_blob
    ///
    /// Whether a document used OffscreenCanvasToBlob. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static offscreen_canvas_to_blob: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1679,
            "use.counter.deprecated_ops.doc",
            "offscreen_canvas_to_blob",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.orientation_event
    ///
    /// Whether a document used OrientationEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static orientation_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1680,
            "use.counter.deprecated_ops.doc",
            "orientation_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.proximity_event
    ///
    /// Whether a document used ProximityEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static proximity_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1681,
            "use.counter.deprecated_ops.doc",
            "proximity_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.rtcpeer_connection_get_streams
    ///
    /// Whether a document used RTCPeerConnectionGetStreams. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static rtcpeer_connection_get_streams: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1682,
            "use.counter.deprecated_ops.doc",
            "rtcpeer_connection_get_streams",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.size_to_content
    ///
    /// Whether a document used SizeToContent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static size_to_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1683,
            "use.counter.deprecated_ops.doc",
            "size_to_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.svgdeselect_all
    ///
    /// Whether a document used SVGDeselectAll. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgdeselect_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1684,
            "use.counter.deprecated_ops.doc",
            "svgdeselect_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.svgfarthest_viewport_element
    ///
    /// Whether a document used SVGFarthestViewportElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgfarthest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1685,
            "use.counter.deprecated_ops.doc",
            "svgfarthest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.svgnearest_viewport_element
    ///
    /// Whether a document used SVGNearestViewportElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgnearest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1686,
            "use.counter.deprecated_ops.doc",
            "svgnearest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.sync_xmlhttp_request_deprecated
    ///
    /// Whether a document used SyncXMLHttpRequestDeprecated. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static sync_xmlhttp_request_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1687,
            "use.counter.deprecated_ops.doc",
            "sync_xmlhttp_request_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.use_of_capture_events
    ///
    /// Whether a document used UseOfCaptureEvents. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static use_of_capture_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1688,
            "use.counter.deprecated_ops.doc",
            "use_of_capture_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.use_of_release_events
    ///
    /// Whether a document used UseOfReleaseEvents. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static use_of_release_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1689,
            "use.counter.deprecated_ops.doc",
            "use_of_release_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.webrtc_deprecated_prefix
    ///
    /// Whether a document used WebrtcDeprecatedPrefix. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webrtc_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1690,
            "use.counter.deprecated_ops.doc",
            "webrtc_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.window__cc_ontrollers
    ///
    /// Whether a document used Window_Cc_ontrollers. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window__cc_ontrollers: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1691,
            "use.counter.deprecated_ops.doc",
            "window__cc_ontrollers",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.window_content_untrusted
    ///
    /// Whether a document used WindowContentUntrusted. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_content_untrusted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1692,
            "use.counter.deprecated_ops.doc",
            "window_content_untrusted",
            "use-counters"
        )
    });

}
pub mod use_counter_deprecated_ops_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.ambient_light_event
    ///
    /// Whether a page used AmbientLightEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static ambient_light_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1693,
            "use.counter.deprecated_ops.page",
            "ambient_light_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.app_cache
    ///
    /// Whether a page used AppCache. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static app_cache: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1694,
            "use.counter.deprecated_ops.page",
            "app_cache",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.components
    ///
    /// Whether a page used Components. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static components: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1695,
            "use.counter.deprecated_ops.page",
            "components",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.create_image_bitmap_canvas_rendering_context2_d
    ///
    /// Whether a page used CreateImageBitmapCanvasRenderingContext2D. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static create_image_bitmap_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1696,
            "use.counter.deprecated_ops.page",
            "create_image_bitmap_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.deprecated_testing_attribute
    ///
    /// Whether a page used DeprecatedTestingAttribute. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_attribute: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1697,
            "use.counter.deprecated_ops.page",
            "deprecated_testing_attribute",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.deprecated_testing_interface
    ///
    /// Whether a page used DeprecatedTestingInterface. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_interface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1698,
            "use.counter.deprecated_ops.page",
            "deprecated_testing_interface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.deprecated_testing_method
    ///
    /// Whether a page used DeprecatedTestingMethod. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_method: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1699,
            "use.counter.deprecated_ops.page",
            "deprecated_testing_method",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.document_release_capture
    ///
    /// Whether a page used DocumentReleaseCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1700,
            "use.counter.deprecated_ops.page",
            "document_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domattr_modified
    ///
    /// Whether a page used DOMAttrModified. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domattr_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1701,
            "use.counter.deprecated_ops.page",
            "domattr_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domcharacter_data_modified
    ///
    /// Whether a page used DOMCharacterDataModified. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domcharacter_data_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1702,
            "use.counter.deprecated_ops.page",
            "domcharacter_data_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_inserted
    ///
    /// Whether a page used DOMNodeInserted. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1703,
            "use.counter.deprecated_ops.page",
            "domnode_inserted",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_inserted_into_document
    ///
    /// Whether a page used DOMNodeInsertedIntoDocument. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted_into_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1704,
            "use.counter.deprecated_ops.page",
            "domnode_inserted_into_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_removed
    ///
    /// Whether a page used DOMNodeRemoved. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_removed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1705,
            "use.counter.deprecated_ops.page",
            "domnode_removed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_removed_from_document
    ///
    /// Whether a page used DOMNodeRemovedFromDocument. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_removed_from_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1706,
            "use.counter.deprecated_ops.page",
            "domnode_removed_from_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domquad_bounds_attr
    ///
    /// Whether a page used DOMQuadBoundsAttr. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domquad_bounds_attr: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1707,
            "use.counter.deprecated_ops.page",
            "domquad_bounds_attr",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domsubtree_modified
    ///
    /// Whether a page used DOMSubtreeModified. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domsubtree_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1708,
            "use.counter.deprecated_ops.page",
            "domsubtree_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.draw_window_canvas_rendering_context2_d
    ///
    /// Whether a page used DrawWindowCanvasRenderingContext2D. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static draw_window_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1709,
            "use.counter.deprecated_ops.page",
            "draw_window_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.element_release_capture
    ///
    /// Whether a page used ElementReleaseCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1710,
            "use.counter.deprecated_ops.page",
            "element_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.element_set_capture
    ///
    /// Whether a page used ElementSetCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_set_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1711,
            "use.counter.deprecated_ops.page",
            "element_set_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.external__add_search_provider
    ///
    /// Whether a page used External_AddSearchProvider. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static external__add_search_provider: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1712,
            "use.counter.deprecated_ops.page",
            "external__add_search_provider",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.form_submission_untrusted_event
    ///
    /// Whether a page used FormSubmissionUntrustedEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static form_submission_untrusted_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1713,
            "use.counter.deprecated_ops.page",
            "form_submission_untrusted_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.idbobject_store_create_index_locale
    ///
    /// Whether a page used IDBObjectStoreCreateIndexLocale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static idbobject_store_create_index_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1714,
            "use.counter.deprecated_ops.page",
            "idbobject_store_create_index_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.idbopen_dboptions__storage_type
    ///
    /// Whether a page used IDBOpenDBOptions_StorageType. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static idbopen_dboptions__storage_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1715,
            "use.counter.deprecated_ops.page",
            "idbopen_dboptions__storage_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.image_bitmap_rendering_context__transfer_image_bitmap
    ///
    /// Whether a page used ImageBitmapRenderingContext_TransferImageBitmap. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static image_bitmap_rendering_context__transfer_image_bitmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1716,
            "use.counter.deprecated_ops.page",
            "image_bitmap_rendering_context__transfer_image_bitmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.import_xulinto_content
    ///
    /// Whether a page used ImportXULIntoContent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static import_xulinto_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1717,
            "use.counter.deprecated_ops.page",
            "import_xulinto_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.init_mouse_event
    ///
    /// Whether a page used InitMouseEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static init_mouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1718,
            "use.counter.deprecated_ops.page",
            "init_mouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.init_nsmouse_event
    ///
    /// Whether a page used InitNSMouseEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static init_nsmouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1719,
            "use.counter.deprecated_ops.page",
            "init_nsmouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.install_trigger_deprecated
    ///
    /// Whether a page used InstallTriggerDeprecated. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static install_trigger_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1720,
            "use.counter.deprecated_ops.page",
            "install_trigger_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.install_trigger_install_deprecated
    ///
    /// Whether a page used InstallTriggerInstallDeprecated. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static install_trigger_install_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1721,
            "use.counter.deprecated_ops.page",
            "install_trigger_install_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.lenient_setter
    ///
    /// Whether a page used LenientSetter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static lenient_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1722,
            "use.counter.deprecated_ops.page",
            "lenient_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.lenient_this
    ///
    /// Whether a page used LenientThis. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static lenient_this: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1723,
            "use.counter.deprecated_ops.page",
            "lenient_this",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.math_ml__deprecated_math_space_value2
    ///
    /// Whether a page used MathML_DeprecatedMathSpaceValue2. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_space_value2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1724,
            "use.counter.deprecated_ops.page",
            "math_ml__deprecated_math_space_value2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.math_ml__deprecated_math_variant
    ///
    /// Whether a page used MathML_DeprecatedMathVariant. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1725,
            "use.counter.deprecated_ops.page",
            "math_ml__deprecated_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.math_ml__deprecated_stixgeneral_operator_stretching
    ///
    /// Whether a page used MathML_DeprecatedStixgeneralOperatorStretching. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static math_ml__deprecated_stixgeneral_operator_stretching: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1726,
            "use.counter.deprecated_ops.page",
            "math_ml__deprecated_stixgeneral_operator_stretching",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.motion_event
    ///
    /// Whether a page used MotionEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static motion_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1727,
            "use.counter.deprecated_ops.page",
            "motion_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.mouse_event__moz_pressure
    ///
    /// Whether a page used MouseEvent_MozPressure. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mouse_event__moz_pressure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1728,
            "use.counter.deprecated_ops.page",
            "mouse_event__moz_pressure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.moz_input_source
    ///
    /// Whether a page used MozInputSource. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static moz_input_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1729,
            "use.counter.deprecated_ops.page",
            "moz_input_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.moz_request_full_screen_deprecated_prefix
    ///
    /// Whether a page used MozRequestFullScreenDeprecatedPrefix. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static moz_request_full_screen_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1730,
            "use.counter.deprecated_ops.page",
            "moz_request_full_screen_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.mozfullscreenchange_deprecated_prefix
    ///
    /// Whether a page used MozfullscreenchangeDeprecatedPrefix. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenchange_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1731,
            "use.counter.deprecated_ops.page",
            "mozfullscreenchange_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.mozfullscreenerror_deprecated_prefix
    ///
    /// Whether a page used MozfullscreenerrorDeprecatedPrefix. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenerror_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1732,
            "use.counter.deprecated_ops.page",
            "mozfullscreenerror_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.navigator_get_user_media
    ///
    /// Whether a page used NavigatorGetUserMedia. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_get_user_media: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1733,
            "use.counter.deprecated_ops.page",
            "navigator_get_user_media",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.node_iterator_detach
    ///
    /// Whether a page used NodeIteratorDetach. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static node_iterator_detach: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1734,
            "use.counter.deprecated_ops.page",
            "node_iterator_detach",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.offscreen_canvas_to_blob
    ///
    /// Whether a page used OffscreenCanvasToBlob. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static offscreen_canvas_to_blob: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1735,
            "use.counter.deprecated_ops.page",
            "offscreen_canvas_to_blob",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.orientation_event
    ///
    /// Whether a page used OrientationEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static orientation_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1736,
            "use.counter.deprecated_ops.page",
            "orientation_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.proximity_event
    ///
    /// Whether a page used ProximityEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static proximity_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1737,
            "use.counter.deprecated_ops.page",
            "proximity_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.rtcpeer_connection_get_streams
    ///
    /// Whether a page used RTCPeerConnectionGetStreams. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static rtcpeer_connection_get_streams: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1738,
            "use.counter.deprecated_ops.page",
            "rtcpeer_connection_get_streams",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.size_to_content
    ///
    /// Whether a page used SizeToContent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static size_to_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1739,
            "use.counter.deprecated_ops.page",
            "size_to_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.svgdeselect_all
    ///
    /// Whether a page used SVGDeselectAll. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgdeselect_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1740,
            "use.counter.deprecated_ops.page",
            "svgdeselect_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.svgfarthest_viewport_element
    ///
    /// Whether a page used SVGFarthestViewportElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgfarthest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1741,
            "use.counter.deprecated_ops.page",
            "svgfarthest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.svgnearest_viewport_element
    ///
    /// Whether a page used SVGNearestViewportElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgnearest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1742,
            "use.counter.deprecated_ops.page",
            "svgnearest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.sync_xmlhttp_request_deprecated
    ///
    /// Whether a page used SyncXMLHttpRequestDeprecated. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static sync_xmlhttp_request_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1743,
            "use.counter.deprecated_ops.page",
            "sync_xmlhttp_request_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.use_of_capture_events
    ///
    /// Whether a page used UseOfCaptureEvents. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static use_of_capture_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1744,
            "use.counter.deprecated_ops.page",
            "use_of_capture_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.use_of_release_events
    ///
    /// Whether a page used UseOfReleaseEvents. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static use_of_release_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1745,
            "use.counter.deprecated_ops.page",
            "use_of_release_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.webrtc_deprecated_prefix
    ///
    /// Whether a page used WebrtcDeprecatedPrefix. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webrtc_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1746,
            "use.counter.deprecated_ops.page",
            "webrtc_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.window__cc_ontrollers
    ///
    /// Whether a page used Window_Cc_ontrollers. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window__cc_ontrollers: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1747,
            "use.counter.deprecated_ops.page",
            "window__cc_ontrollers",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.window_content_untrusted
    ///
    /// Whether a page used WindowContentUntrusted. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_content_untrusted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1748,
            "use.counter.deprecated_ops.page",
            "window_content_untrusted",
            "use-counters"
        )
    });

}
pub mod use_counter_doc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.clipboard_read
    ///
    /// Whether a document called called Clipboard.read. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static clipboard_read: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1749,
            "use.counter.doc",
            "clipboard_read",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.clipboard_readtext
    ///
    /// Whether a document called called Clipboard.readText. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static clipboard_readtext: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1750,
            "use.counter.doc",
            "clipboard_readtext",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.clipboard_write
    ///
    /// Whether a document called called Clipboard.write. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static clipboard_write: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1751,
            "use.counter.doc",
            "clipboard_write",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_assert
    ///
    /// Whether a document called called console.assert. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1752,
            "use.counter.doc",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_clear
    ///
    /// Whether a document called called console.clear. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1753,
            "use.counter.doc",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_count
    ///
    /// Whether a document called called console.count. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1754,
            "use.counter.doc",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_countreset
    ///
    /// Whether a document called called console.countReset. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1755,
            "use.counter.doc",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_debug
    ///
    /// Whether a document called called console.debug. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1756,
            "use.counter.doc",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_dir
    ///
    /// Whether a document called called console.dir. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1757,
            "use.counter.doc",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_dirxml
    ///
    /// Whether a document called called console.dirxml. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1758,
            "use.counter.doc",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_error
    ///
    /// Whether a document called called console.error. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1759,
            "use.counter.doc",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_exception
    ///
    /// Whether a document called called console.exception. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1760,
            "use.counter.doc",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_group
    ///
    /// Whether a document called called console.group. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1761,
            "use.counter.doc",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_groupcollapsed
    ///
    /// Whether a document called called console.groupCollapsed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1762,
            "use.counter.doc",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_groupend
    ///
    /// Whether a document called called console.groupEnd. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1763,
            "use.counter.doc",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_info
    ///
    /// Whether a document called called console.info. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1764,
            "use.counter.doc",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_log
    ///
    /// Whether a document called called console.log. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1765,
            "use.counter.doc",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_profile
    ///
    /// Whether a document called called console.profile. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1766,
            "use.counter.doc",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_profileend
    ///
    /// Whether a document called called console.profileEnd. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1767,
            "use.counter.doc",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_table
    ///
    /// Whether a document called called console.table. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1768,
            "use.counter.doc",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_time
    ///
    /// Whether a document called called console.time. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1769,
            "use.counter.doc",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_timeend
    ///
    /// Whether a document called called console.timeEnd. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1770,
            "use.counter.doc",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_timelog
    ///
    /// Whether a document called called console.timeLog. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1771,
            "use.counter.doc",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_timestamp
    ///
    /// Whether a document called called console.timeStamp. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1772,
            "use.counter.doc",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_trace
    ///
    /// Whether a document called called console.trace. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1773,
            "use.counter.doc",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_warn
    ///
    /// Whether a document called called console.warn. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1774,
            "use.counter.doc",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.customelementregistry_define
    ///
    /// Whether a document called called CustomElementRegistry.define. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static customelementregistry_define: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1775,
            "use.counter.doc",
            "customelementregistry_define",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.customized_builtin
    ///
    /// Whether a document registers a customized built-in element. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static customized_builtin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1776,
            "use.counter.doc",
            "customized_builtin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_addelement
    ///
    /// Whether a document called called DataTransfer.addElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_addelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1777,
            "use.counter.doc",
            "datatransfer_addelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozcleardataat
    ///
    /// Whether a document called called DataTransfer.mozClearDataAt. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcleardataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1778,
            "use.counter.doc",
            "datatransfer_mozcleardataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozcursor_getter
    ///
    /// Whether a document got DataTransfer.mozCursor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1779,
            "use.counter.doc",
            "datatransfer_mozcursor_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozcursor_setter
    ///
    /// Whether a document set DataTransfer.mozCursor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1780,
            "use.counter.doc",
            "datatransfer_mozcursor_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozgetdataat
    ///
    /// Whether a document called called DataTransfer.mozGetDataAt. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozgetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1781,
            "use.counter.doc",
            "datatransfer_mozgetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozitemcount_getter
    ///
    /// Whether a document got DataTransfer.mozItemCount. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1782,
            "use.counter.doc",
            "datatransfer_mozitemcount_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozitemcount_setter
    ///
    /// Whether a document set DataTransfer.mozItemCount. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1783,
            "use.counter.doc",
            "datatransfer_mozitemcount_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozsetdataat
    ///
    /// Whether a document called called DataTransfer.mozSetDataAt. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1784,
            "use.counter.doc",
            "datatransfer_mozsetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozsourcenode_getter
    ///
    /// Whether a document got DataTransfer.mozSourceNode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1785,
            "use.counter.doc",
            "datatransfer_mozsourcenode_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozsourcenode_setter
    ///
    /// Whether a document set DataTransfer.mozSourceNode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1786,
            "use.counter.doc",
            "datatransfer_mozsourcenode_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_moztypesat
    ///
    /// Whether a document called called DataTransfer.mozTypesAt. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_moztypesat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1787,
            "use.counter.doc",
            "datatransfer_moztypesat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozusercancelled_getter
    ///
    /// Whether a document got DataTransfer.mozUserCancelled. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1788,
            "use.counter.doc",
            "datatransfer_mozusercancelled_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozusercancelled_setter
    ///
    /// Whether a document set DataTransfer.mozUserCancelled. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1789,
            "use.counter.doc",
            "datatransfer_mozusercancelled_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransferitem_webkitgetasentry
    ///
    /// Whether a document called called DataTransferItem.webkitGetAsEntry. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransferitem_webkitgetasentry: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1790,
            "use.counter.doc",
            "datatransferitem_webkitgetasentry",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_caretrangefrompoint
    ///
    /// Whether a document called called Document.caretRangeFromPoint. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_caretrangefrompoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1791,
            "use.counter.doc",
            "document_caretrangefrompoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_exec_command_content_read_only
    ///
    /// Whether a document calls execCommand with contentReadOnly. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_exec_command_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1792,
            "use.counter.doc",
            "document_exec_command_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_exitpictureinpicture
    ///
    /// Whether a document called called Document.exitPictureInPicture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_exitpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1793,
            "use.counter.doc",
            "document_exitpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_featurepolicy
    ///
    /// Whether a document called called Document.featurePolicy. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_featurepolicy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1794,
            "use.counter.doc",
            "document_featurepolicy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_mozsetimageelement
    ///
    /// Whether a document called called Document.mozSetImageElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_mozsetimageelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1795,
            "use.counter.doc",
            "document_mozsetimageelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onbeforecopy
    ///
    /// Whether a document called called Document.onbeforecopy. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onbeforecopy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1796,
            "use.counter.doc",
            "document_onbeforecopy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onbeforecut
    ///
    /// Whether a document called called Document.onbeforecut. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onbeforecut: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1797,
            "use.counter.doc",
            "document_onbeforecut",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onbeforepaste
    ///
    /// Whether a document called called Document.onbeforepaste. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onbeforepaste: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1798,
            "use.counter.doc",
            "document_onbeforepaste",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_oncancel
    ///
    /// Whether a document called called Document.oncancel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1799,
            "use.counter.doc",
            "document_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onfreeze
    ///
    /// Whether a document called called Document.onfreeze. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onfreeze: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1800,
            "use.counter.doc",
            "document_onfreeze",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onmousewheel
    ///
    /// Whether a document called called Document.onmousewheel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1801,
            "use.counter.doc",
            "document_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onresume
    ///
    /// Whether a document called called Document.onresume. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onresume: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1802,
            "use.counter.doc",
            "document_onresume",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onsearch
    ///
    /// Whether a document called called Document.onsearch. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1803,
            "use.counter.doc",
            "document_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onwebkitfullscreenchange
    ///
    /// Whether a document called called Document.onwebkitfullscreenchange. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onwebkitfullscreenchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1804,
            "use.counter.doc",
            "document_onwebkitfullscreenchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_onwebkitfullscreenerror
    ///
    /// Whether a document called called Document.onwebkitfullscreenerror. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_onwebkitfullscreenerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1805,
            "use.counter.doc",
            "document_onwebkitfullscreenerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_open
    ///
    /// Whether a document calls document.open in a way that creates a new Window
    /// object. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static document_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1806,
            "use.counter.doc",
            "document_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_pictureinpictureelement
    ///
    /// Whether a document called called Document.pictureInPictureElement. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_pictureinpictureelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1807,
            "use.counter.doc",
            "document_pictureinpictureelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_pictureinpictureenabled
    ///
    /// Whether a document called called Document.pictureInPictureEnabled. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_pictureinpictureenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1808,
            "use.counter.doc",
            "document_pictureinpictureenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_state_or_value_content_read_only
    ///
    /// Whether a document calls queryCommandState or queryCommandValue with
    /// contentReadOnly. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static document_query_command_state_or_value_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1809,
            "use.counter.doc",
            "document_query_command_state_or_value_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_state_or_value_insert_br_on_return
    ///
    /// Whether a document calls queryCommandState or queryCommandValue with
    /// insertBrOnReturn. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static document_query_command_state_or_value_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1810,
            "use.counter.doc",
            "document_query_command_state_or_value_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_supported_or_enabled_content_read_only
    ///
    /// Whether a document calls queryCommandSupported or queryCommandEnabled with
    /// contentReadOnly. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static document_query_command_supported_or_enabled_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1811,
            "use.counter.doc",
            "document_query_command_supported_or_enabled_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_supported_or_enabled_insert_br_on_return
    ///
    /// Whether a document calls queryCommandSupported or queryCommandEnabled with
    /// insertBrOnReturn. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static document_query_command_supported_or_enabled_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1812,
            "use.counter.doc",
            "document_query_command_supported_or_enabled_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_registerelement
    ///
    /// Whether a document called called Document.registerElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_registerelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1813,
            "use.counter.doc",
            "document_registerelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_wasdiscarded
    ///
    /// Whether a document called called Document.wasDiscarded. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_wasdiscarded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1814,
            "use.counter.doc",
            "document_wasdiscarded",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitcancelfullscreen
    ///
    /// Whether a document called called Document.webkitCancelFullScreen. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitcancelfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1815,
            "use.counter.doc",
            "document_webkitcancelfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitcurrentfullscreenelement
    ///
    /// Whether a document called called Document.webkitCurrentFullScreenElement.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static document_webkitcurrentfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1816,
            "use.counter.doc",
            "document_webkitcurrentfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitexitfullscreen
    ///
    /// Whether a document called called Document.webkitExitFullscreen. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitexitfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1817,
            "use.counter.doc",
            "document_webkitexitfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitfullscreenelement
    ///
    /// Whether a document called called Document.webkitFullscreenElement. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1818,
            "use.counter.doc",
            "document_webkitfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitfullscreenenabled
    ///
    /// Whether a document called called Document.webkitFullscreenEnabled. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitfullscreenenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1819,
            "use.counter.doc",
            "document_webkitfullscreenenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkithidden
    ///
    /// Whether a document called called Document.webkitHidden. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkithidden: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1820,
            "use.counter.doc",
            "document_webkithidden",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitisfullscreen
    ///
    /// Whether a document called called Document.webkitIsFullScreen. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitisfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1821,
            "use.counter.doc",
            "document_webkitisfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_webkitvisibilitystate
    ///
    /// Whether a document called called Document.webkitVisibilityState. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_webkitvisibilitystate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1822,
            "use.counter.doc",
            "document_webkitvisibilitystate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_xmlencoding
    ///
    /// Whether a document called called Document.xmlEncoding. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_xmlencoding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1823,
            "use.counter.doc",
            "document_xmlencoding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_xmlstandalone
    ///
    /// Whether a document called called Document.xmlStandalone. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_xmlstandalone: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1824,
            "use.counter.doc",
            "document_xmlstandalone",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_xmlversion
    ///
    /// Whether a document called called Document.xmlVersion. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_xmlversion: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1825,
            "use.counter.doc",
            "document_xmlversion",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.domparser_parsefromstring
    ///
    /// Whether a document called called DOMParser.parseFromString. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domparser_parsefromstring: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1826,
            "use.counter.doc",
            "domparser_parsefromstring",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_attachshadow
    ///
    /// Whether a document called called Element.attachShadow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_attachshadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1827,
            "use.counter.doc",
            "element_attachshadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_computedstylemap
    ///
    /// Whether a document called called Element.computedStyleMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_computedstylemap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1828,
            "use.counter.doc",
            "element_computedstylemap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_onmousewheel
    ///
    /// Whether a document called called Element.onmousewheel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1829,
            "use.counter.doc",
            "element_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_releasecapture
    ///
    /// Whether a document called called Element.releaseCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_releasecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1830,
            "use.counter.doc",
            "element_releasecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_releasepointercapture
    ///
    /// Whether a document called called Element.releasePointerCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_releasepointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1831,
            "use.counter.doc",
            "element_releasepointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_scrollintoviewifneeded
    ///
    /// Whether a document called called Element.scrollIntoViewIfNeeded. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_scrollintoviewifneeded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1832,
            "use.counter.doc",
            "element_scrollintoviewifneeded",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_setcapture
    ///
    /// Whether a document called called Element.setCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_setcapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1833,
            "use.counter.doc",
            "element_setcapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_sethtml
    ///
    /// Whether a document called called Element.setHTML. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_sethtml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1834,
            "use.counter.doc",
            "element_sethtml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_setpointercapture
    ///
    /// Whether a document called called Element.setPointerCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_setpointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1835,
            "use.counter.doc",
            "element_setpointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.enumerate_devices_insec
    ///
    /// Whether a document calls MediaDevices.enumerateDevices from an insecure
    /// context. Compare against `use.counter.content_documents_destroyed` to calculate
    /// the rate.
    pub static enumerate_devices_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1836,
            "use.counter.doc",
            "enumerate_devices_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.enumerate_devices_unfocused
    ///
    /// Whether a document calls MediaDevices.enumerateDevices from a unfocused
    /// document. Compare against `use.counter.content_documents_destroyed` to
    /// calculate the rate.
    pub static enumerate_devices_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1837,
            "use.counter.doc",
            "enumerate_devices_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_blend
    ///
    /// Whether a document uses the feBlend SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_blend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1838,
            "use.counter.doc",
            "fe_blend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_color_matrix
    ///
    /// Whether a document uses the feColorMatrix SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_color_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1839,
            "use.counter.doc",
            "fe_color_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_component_transfer
    ///
    /// Whether a document uses the feComponentTransfer SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_component_transfer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1840,
            "use.counter.doc",
            "fe_component_transfer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_composite
    ///
    /// Whether a document uses the feComposite SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1841,
            "use.counter.doc",
            "fe_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_convolve_matrix
    ///
    /// Whether a document uses the feConvolveMatrix SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_convolve_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1842,
            "use.counter.doc",
            "fe_convolve_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_diffuse_lighting
    ///
    /// Whether a document uses the feDiffuseLighting SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_diffuse_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1843,
            "use.counter.doc",
            "fe_diffuse_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_displacement_map
    ///
    /// Whether a document uses the feDisplacementMap SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_displacement_map: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1844,
            "use.counter.doc",
            "fe_displacement_map",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_flood
    ///
    /// Whether a document uses the feFlood SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_flood: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1845,
            "use.counter.doc",
            "fe_flood",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_gaussian_blur
    ///
    /// Whether a document uses the feGaussianBlur SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_gaussian_blur: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1846,
            "use.counter.doc",
            "fe_gaussian_blur",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_image
    ///
    /// Whether a document uses the feImage SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1847,
            "use.counter.doc",
            "fe_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_merge
    ///
    /// Whether a document uses the feMerge SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_merge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1848,
            "use.counter.doc",
            "fe_merge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_morphology
    ///
    /// Whether a document uses the feMorphology SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_morphology: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1849,
            "use.counter.doc",
            "fe_morphology",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_offset
    ///
    /// Whether a document uses the feOffset SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1850,
            "use.counter.doc",
            "fe_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_specular_lighting
    ///
    /// Whether a document uses the feSpecularLighting SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_specular_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1851,
            "use.counter.doc",
            "fe_specular_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_tile
    ///
    /// Whether a document uses the feTile SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_tile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1852,
            "use.counter.doc",
            "fe_tile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_turbulence
    ///
    /// Whether a document uses the feTurbulence SVG filter.. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_turbulence: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1853,
            "use.counter.doc",
            "fe_turbulence",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.filtered_cross_origin_iframe
    ///
    /// Whether a document cross-origin <iframe> within a CSS/SVG filter. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static filtered_cross_origin_iframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1854,
            "use.counter.doc",
            "filtered_cross_origin_iframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.get_user_media_insec
    ///
    /// Whether a document calls MediaDevices.getUserMedia from an insecure context.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static get_user_media_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1855,
            "use.counter.doc",
            "get_user_media_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.get_user_media_unfocused
    ///
    /// Whether a document calls MediaDevices.getUserMedia from an unfocused document.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static get_user_media_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1856,
            "use.counter.doc",
            "get_user_media_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlbuttonelement_popovertargetaction
    ///
    /// Whether a document called called HTMLButtonElement.popoverTargetAction. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlbuttonelement_popovertargetaction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1857,
            "use.counter.doc",
            "htmlbuttonelement_popovertargetaction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlbuttonelement_popovertargetelement
    ///
    /// Whether a document called called HTMLButtonElement.popoverTargetElement.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlbuttonelement_popovertargetelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1858,
            "use.counter.doc",
            "htmlbuttonelement_popovertargetelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldialogelement_show
    ///
    /// Whether a document called called HTMLDialogElement.show. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldialogelement_show: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1859,
            "use.counter.doc",
            "htmldialogelement_show",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_named_getter_hit
    ///
    /// Whether a document calls to the named getter on HTMLDocument that find
    /// something via the name lookup. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_named_getter_hit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1860,
            "use.counter.doc",
            "htmldocument_named_getter_hit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlelement_attributestylemap
    ///
    /// Whether a document called called HTMLElement.attributeStyleMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlelement_attributestylemap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1861,
            "use.counter.doc",
            "htmlelement_attributestylemap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlelement_hidepopover
    ///
    /// Whether a document called called HTMLElement.hidePopover. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlelement_hidepopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1862,
            "use.counter.doc",
            "htmlelement_hidepopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlelement_popover
    ///
    /// Whether a document called called HTMLElement.popover. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlelement_popover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1863,
            "use.counter.doc",
            "htmlelement_popover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlelement_showpopover
    ///
    /// Whether a document called called HTMLElement.showPopover. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlelement_showpopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1864,
            "use.counter.doc",
            "htmlelement_showpopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlelement_togglepopover
    ///
    /// Whether a document called called HTMLElement.togglePopover. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlelement_togglepopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1865,
            "use.counter.doc",
            "htmlelement_togglepopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmliframeelement_loading
    ///
    /// Whether a document called called HTMLIFrameElement.loading. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmliframeelement_loading: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1866,
            "use.counter.doc",
            "htmliframeelement_loading",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_capture
    ///
    /// Whether a document called called HTMLInputElement.capture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1867,
            "use.counter.doc",
            "htmlinputelement_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_incremental
    ///
    /// Whether a document called called HTMLInputElement.incremental. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_incremental: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1868,
            "use.counter.doc",
            "htmlinputelement_incremental",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_onsearch
    ///
    /// Whether a document called called HTMLInputElement.onsearch. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1869,
            "use.counter.doc",
            "htmlinputelement_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_popovertargetaction
    ///
    /// Whether a document called called HTMLInputElement.popoverTargetAction. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_popovertargetaction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1870,
            "use.counter.doc",
            "htmlinputelement_popovertargetaction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_popovertargetelement
    ///
    /// Whether a document called called HTMLInputElement.popoverTargetElement. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_popovertargetelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1871,
            "use.counter.doc",
            "htmlinputelement_popovertargetelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_webkitdirectory
    ///
    /// Whether a document called called HTMLInputElement.webkitdirectory. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_webkitdirectory: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1872,
            "use.counter.doc",
            "htmlinputelement_webkitdirectory",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlinputelement_webkitentries
    ///
    /// Whether a document called called HTMLInputElement.webkitEntries. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_webkitentries: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1873,
            "use.counter.doc",
            "htmlinputelement_webkitentries",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlmediaelement_disableremoteplayback
    ///
    /// Whether a document called called HTMLMediaElement.disableRemotePlayback.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlmediaelement_disableremoteplayback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1874,
            "use.counter.doc",
            "htmlmediaelement_disableremoteplayback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlmediaelement_remote
    ///
    /// Whether a document called called HTMLMediaElement.remote. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlmediaelement_remote: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1875,
            "use.counter.doc",
            "htmlmediaelement_remote",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_cancelvideoframecallback
    ///
    /// Whether a document called called HTMLVideoElement.cancelVideoFrameCallback.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_cancelvideoframecallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1876,
            "use.counter.doc",
            "htmlvideoelement_cancelvideoframecallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_disablepictureinpicture
    ///
    /// Whether a document called called HTMLVideoElement.disablePictureInPicture.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_disablepictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1877,
            "use.counter.doc",
            "htmlvideoelement_disablepictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_onenterpictureinpicture
    ///
    /// Whether a document called called HTMLVideoElement.onenterpictureinpicture.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_onenterpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1878,
            "use.counter.doc",
            "htmlvideoelement_onenterpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_onleavepictureinpicture
    ///
    /// Whether a document called called HTMLVideoElement.onleavepictureinpicture.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_onleavepictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1879,
            "use.counter.doc",
            "htmlvideoelement_onleavepictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_playsinline
    ///
    /// Whether a document called called HTMLVideoElement.playsInline. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmlvideoelement_playsinline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1880,
            "use.counter.doc",
            "htmlvideoelement_playsinline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_requestpictureinpicture
    ///
    /// Whether a document called called HTMLVideoElement.requestPictureInPicture.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_requestpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1881,
            "use.counter.doc",
            "htmlvideoelement_requestpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmlvideoelement_requestvideoframecallback
    ///
    /// Whether a document called called HTMLVideoElement.requestVideoFrameCallback.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_requestvideoframecallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1882,
            "use.counter.doc",
            "htmlvideoelement_requestvideoframecallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.imagedata_colorspace
    ///
    /// Whether a document called called ImageData.colorSpace. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static imagedata_colorspace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1883,
            "use.counter.doc",
            "imagedata_colorspace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_asmjs
    ///
    /// Whether a document uses asm.js. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_asmjs: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1884,
            "use.counter.doc",
            "js_asmjs",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_subclassing_array_type_2
    ///
    /// Whether a document Array is Type II subclassed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_array_type_2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1885,
            "use.counter.doc",
            "js_subclassing_array_type_2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_subclassing_array_type_3
    ///
    /// Whether a document Array is Type III subclassed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_array_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1886,
            "use.counter.doc",
            "js_subclassing_array_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_subclassing_arraybuffer_type_3
    ///
    /// Whether a document ArrayBuffer is Type III subclassed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_arraybuffer_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1887,
            "use.counter.doc",
            "js_subclassing_arraybuffer_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_subclassing_promise_type_2
    ///
    /// Whether a document Promise is Type II subclassed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_promise_type_2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1888,
            "use.counter.doc",
            "js_subclassing_promise_type_2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_subclassing_promise_type_3
    ///
    /// Whether a document Promise is Type III subclassed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_promise_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1889,
            "use.counter.doc",
            "js_subclassing_promise_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_subclassing_regexp_type_3
    ///
    /// Whether a document RegExp is Type III subclassed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_regexp_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1890,
            "use.counter.doc",
            "js_subclassing_regexp_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_subclassing_regexp_type_4
    ///
    /// Whether a document RegExp is Type IV subclassed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_regexp_type_4: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1891,
            "use.counter.doc",
            "js_subclassing_regexp_type_4",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_subclassing_sharedarraybuffer_type_3
    ///
    /// Whether a document SharedArrayBuffer is Type III subclassed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_sharedarraybuffer_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1892,
            "use.counter.doc",
            "js_subclassing_sharedarraybuffer_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_subclassing_typedarray_type_2
    ///
    /// Whether a document TypedArray is Type II subclassed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_typedarray_type_2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1893,
            "use.counter.doc",
            "js_subclassing_typedarray_type_2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_subclassing_typedarray_type_3
    ///
    /// Whether a document TypedArray is Type III subclassed. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_typedarray_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1894,
            "use.counter.doc",
            "js_subclassing_typedarray_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_wasm
    ///
    /// Whether a document uses WebAssembly. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_wasm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1895,
            "use.counter.doc",
            "js_wasm",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_wasm_legacy_exceptions
    ///
    /// Whether a document uses WebAssembly legacy exception-handling. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_wasm_legacy_exceptions: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1896,
            "use.counter.doc",
            "js_wasm_legacy_exceptions",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.location_ancestororigins
    ///
    /// Whether a document called called Location.ancestorOrigins. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static location_ancestororigins: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1897,
            "use.counter.doc",
            "location_ancestororigins",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mediadevices_enumeratedevices
    ///
    /// Whether a document called called MediaDevices.enumerateDevices. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mediadevices_enumeratedevices: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1898,
            "use.counter.doc",
            "mediadevices_enumeratedevices",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mediadevices_getdisplaymedia
    ///
    /// Whether a document called called MediaDevices.getDisplayMedia. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getdisplaymedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1899,
            "use.counter.doc",
            "mediadevices_getdisplaymedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mediadevices_getusermedia
    ///
    /// Whether a document called called MediaDevices.getUserMedia. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1900,
            "use.counter.doc",
            "mediadevices_getusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_audio_failure
    ///
    /// Whether a document includes a mixed content audio element that does not load..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1901,
            "use.counter.doc",
            "mixed_content_not_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_audio_success
    ///
    /// Whether a document includes a mixed content audio element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1902,
            "use.counter.doc",
            "mixed_content_not_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_image_failure
    ///
    /// Whether a document includes a mixed content img element that does not load..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1903,
            "use.counter.doc",
            "mixed_content_not_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_image_success
    ///
    /// Whether a document includes a mixed content img element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1904,
            "use.counter.doc",
            "mixed_content_not_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_video_failure
    ///
    /// Whether a document includes a mixed content video element that does not laod..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1905,
            "use.counter.doc",
            "mixed_content_not_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_video_success
    ///
    /// Whether a document includes a mixed content video element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1906,
            "use.counter.doc",
            "mixed_content_not_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_audio_failure
    ///
    /// Whether a document includes a mixed content audio element that does not load..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1907,
            "use.counter.doc",
            "mixed_content_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_audio_success
    ///
    /// Whether a document includes a mixed content audio element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1908,
            "use.counter.doc",
            "mixed_content_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_image_failure
    ///
    /// Whether a document includes a mixed content img element that does not load..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1909,
            "use.counter.doc",
            "mixed_content_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_image_success
    ///
    /// Whether a document includes a mixed content img element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1910,
            "use.counter.doc",
            "mixed_content_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_video_failure
    ///
    /// Whether a document includes a mixed content video element that does not laod..
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1911,
            "use.counter.doc",
            "mixed_content_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_video_success
    ///
    /// Whether a document includes a mixed content video element that loads.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1912,
            "use.counter.doc",
            "mixed_content_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.moz_get_user_media_insec
    ///
    /// Whether a document calls Navigator.mozGetUserMedia from an insecure context.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static moz_get_user_media_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1913,
            "use.counter.doc",
            "moz_get_user_media_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_canshare
    ///
    /// Whether a document called called Navigator.canShare. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_canshare: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1914,
            "use.counter.doc",
            "navigator_canshare",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_clearappbadge
    ///
    /// Whether a document called called Navigator.clearAppBadge. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_clearappbadge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1915,
            "use.counter.doc",
            "navigator_clearappbadge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_mozgetusermedia
    ///
    /// Whether a document called called Navigator.mozGetUserMedia. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_mozgetusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1916,
            "use.counter.doc",
            "navigator_mozgetusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_setappbadge
    ///
    /// Whether a document called called Navigator.setAppBadge. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_setappbadge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1917,
            "use.counter.doc",
            "navigator_setappbadge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_share
    ///
    /// Whether a document called called Navigator.share. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_share: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1918,
            "use.counter.doc",
            "navigator_share",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_useractivation
    ///
    /// Whether a document called called Navigator.userActivation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_useractivation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1919,
            "use.counter.doc",
            "navigator_useractivation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_wakelock
    ///
    /// Whether a document called called Navigator.wakeLock. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_wakelock: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1920,
            "use.counter.doc",
            "navigator_wakelock",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.ondommousescroll
    ///
    /// Whether a document sets DOMMouseScroll event listener. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static ondommousescroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1921,
            "use.counter.doc",
            "ondommousescroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.onmozmousepixelscroll
    ///
    /// Whether a document sets MozMousePixelScroll event listener. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static onmozmousepixelscroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1922,
            "use.counter.doc",
            "onmozmousepixelscroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.onoverflow
    ///
    /// Whether a document sets an element onoverflow event listener. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static onoverflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1923,
            "use.counter.doc",
            "onoverflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.onunderflow
    ///
    /// Whether a document sets an element onunderflow event listener. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static onunderflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1924,
            "use.counter.doc",
            "onunderflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.percentage_stroke_width_in_svg
    ///
    /// Whether a document whether percentage stroke-width is used in SVG elements
    /// (excluding <text>). Compare against `use.counter.content_documents_destroyed`
    /// to calculate the rate.
    pub static percentage_stroke_width_in_svg: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1925,
            "use.counter.doc",
            "percentage_stroke_width_in_svg",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.percentage_stroke_width_in_svgtext
    ///
    /// Whether a document whether percentage stroke-width is used in SVG <text>.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static percentage_stroke_width_in_svgtext: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1926,
            "use.counter.doc",
            "percentage_stroke_width_in_svgtext",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_delete
    ///
    /// Whether a document calls caches.delete in Private Browsing Mode. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1927,
            "use.counter.doc",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_has
    ///
    /// Whether a document calls caches.has in Private Browsing Mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1928,
            "use.counter.doc",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_keys
    ///
    /// Whether a document calls caches.keys in Private Browsing Mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1929,
            "use.counter.doc",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_match
    ///
    /// Whether a document calls caches.match in Private Browsing Mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1930,
            "use.counter.doc",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_open
    ///
    /// Whether a document calls caches.open in Private Browsing Mode. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1931,
            "use.counter.doc",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_idbfactory_delete_database
    ///
    /// Whether a document calls indexedDB.deleteDatabase in Private Browsing Mode.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1932,
            "use.counter.doc",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_idbfactory_open
    ///
    /// Whether a document calls indexedDB.open in Private Browsing Mode. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1933,
            "use.counter.doc",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_navigator_service_worker
    ///
    /// Whether a document accesses navigator.serviceWorker in Private Browsing Mode.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static private_browsing_navigator_service_worker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1934,
            "use.counter.doc",
            "private_browsing_navigator_service_worker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.pushmanager_subscribe
    ///
    /// Whether a document called called PushManager.subscribe. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1935,
            "use.counter.doc",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.pushsubscription_unsubscribe
    ///
    /// Whether a document called called PushSubscription.unsubscribe. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1936,
            "use.counter.doc",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.range_createcontextualfragment
    ///
    /// Whether a document called called Range.createContextualFragment. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static range_createcontextualfragment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1937,
            "use.counter.doc",
            "range_createcontextualfragment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.sanitizer_constructor
    ///
    /// Whether a document called called Sanitizer.constructor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static sanitizer_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1938,
            "use.counter.doc",
            "sanitizer_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.sanitizer_sanitize
    ///
    /// Whether a document called called Sanitizer.sanitize. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static sanitizer_sanitize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1939,
            "use.counter.doc",
            "sanitizer_sanitize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.scheduler_posttask
    ///
    /// Whether a document called called Scheduler.postTask. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1940,
            "use.counter.doc",
            "scheduler_posttask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.shadowroot_pictureinpictureelement
    ///
    /// Whether a document called called ShadowRoot.pictureInPictureElement. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static shadowroot_pictureinpictureelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1941,
            "use.counter.doc",
            "shadowroot_pictureinpictureelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.svgsvgelement_currentscale_getter
    ///
    /// Whether a document got SVGSVGElement.currentScale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1942,
            "use.counter.doc",
            "svgsvgelement_currentscale_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.svgsvgelement_currentscale_setter
    ///
    /// Whether a document set SVGSVGElement.currentScale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1943,
            "use.counter.doc",
            "svgsvgelement_currentscale_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.svgsvgelement_getelementbyid
    ///
    /// Whether a document called called SVGSVGElement.getElementById. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_getelementbyid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1944,
            "use.counter.doc",
            "svgsvgelement_getelementbyid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_absoluteorientationsensor
    ///
    /// Whether a document called called Window.AbsoluteOrientationSensor. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_absoluteorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1945,
            "use.counter.doc",
            "window_absoluteorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_accelerometer
    ///
    /// Whether a document called called Window.Accelerometer. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_accelerometer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1946,
            "use.counter.doc",
            "window_accelerometer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_backgroundfetchmanager
    ///
    /// Whether a document called called Window.BackgroundFetchManager. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1947,
            "use.counter.doc",
            "window_backgroundfetchmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_backgroundfetchrecord
    ///
    /// Whether a document called called Window.BackgroundFetchRecord. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchrecord: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1948,
            "use.counter.doc",
            "window_backgroundfetchrecord",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_backgroundfetchregistration
    ///
    /// Whether a document called called Window.BackgroundFetchRegistration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchregistration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1949,
            "use.counter.doc",
            "window_backgroundfetchregistration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_beforeinstallpromptevent
    ///
    /// Whether a document called called Window.BeforeInstallPromptEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_beforeinstallpromptevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1950,
            "use.counter.doc",
            "window_beforeinstallpromptevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetooth
    ///
    /// Whether a document called called Window.Bluetooth. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetooth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1951,
            "use.counter.doc",
            "window_bluetooth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothcharacteristicproperties
    ///
    /// Whether a document called called Window.BluetoothCharacteristicProperties.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_bluetoothcharacteristicproperties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1952,
            "use.counter.doc",
            "window_bluetoothcharacteristicproperties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothdevice
    ///
    /// Whether a document called called Window.BluetoothDevice. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1953,
            "use.counter.doc",
            "window_bluetoothdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattcharacteristic
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTCharacteristic.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_bluetoothremotegattcharacteristic: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1954,
            "use.counter.doc",
            "window_bluetoothremotegattcharacteristic",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattdescriptor
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTDescriptor. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattdescriptor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1955,
            "use.counter.doc",
            "window_bluetoothremotegattdescriptor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattserver
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTServer. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1956,
            "use.counter.doc",
            "window_bluetoothremotegattserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattservice
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTService. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattservice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1957,
            "use.counter.doc",
            "window_bluetoothremotegattservice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothuuid
    ///
    /// Whether a document called called Window.BluetoothUUID. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothuuid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1958,
            "use.counter.doc",
            "window_bluetoothuuid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_canvascapturemediastreamtrack
    ///
    /// Whether a document called called Window.CanvasCaptureMediaStreamTrack. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_canvascapturemediastreamtrack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1959,
            "use.counter.doc",
            "window_canvascapturemediastreamtrack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_chrome
    ///
    /// Whether a document called called Window.chrome. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_chrome: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1960,
            "use.counter.doc",
            "window_chrome",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_clipboarditem
    ///
    /// Whether a document called called Window.ClipboardItem. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_clipboarditem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1961,
            "use.counter.doc",
            "window_clipboarditem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssimagevalue
    ///
    /// Whether a document called called Window.CSSImageValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssimagevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1962,
            "use.counter.doc",
            "window_cssimagevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csskeywordvalue
    ///
    /// Whether a document called called Window.CSSKeywordValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csskeywordvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1963,
            "use.counter.doc",
            "window_csskeywordvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathclamp
    ///
    /// Whether a document called called Window.CSSMathClamp. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathclamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1964,
            "use.counter.doc",
            "window_cssmathclamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathinvert
    ///
    /// Whether a document called called Window.CSSMathInvert. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathinvert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1965,
            "use.counter.doc",
            "window_cssmathinvert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathmax
    ///
    /// Whether a document called called Window.CSSMathMax. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmax: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1966,
            "use.counter.doc",
            "window_cssmathmax",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathmin
    ///
    /// Whether a document called called Window.CSSMathMin. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1967,
            "use.counter.doc",
            "window_cssmathmin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathnegate
    ///
    /// Whether a document called called Window.CSSMathNegate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathnegate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1968,
            "use.counter.doc",
            "window_cssmathnegate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathproduct
    ///
    /// Whether a document called called Window.CSSMathProduct. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathproduct: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1969,
            "use.counter.doc",
            "window_cssmathproduct",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathsum
    ///
    /// Whether a document called called Window.CSSMathSum. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathsum: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1970,
            "use.counter.doc",
            "window_cssmathsum",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathvalue
    ///
    /// Whether a document called called Window.CSSMathValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1971,
            "use.counter.doc",
            "window_cssmathvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmatrixcomponent
    ///
    /// Whether a document called called Window.CSSMatrixComponent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmatrixcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1972,
            "use.counter.doc",
            "window_cssmatrixcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssnumericarray
    ///
    /// Whether a document called called Window.CSSNumericArray. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericarray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1973,
            "use.counter.doc",
            "window_cssnumericarray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssnumericvalue
    ///
    /// Whether a document called called Window.CSSNumericValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1974,
            "use.counter.doc",
            "window_cssnumericvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssperspective
    ///
    /// Whether a document called called Window.CSSPerspective. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssperspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1975,
            "use.counter.doc",
            "window_cssperspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csspositionvalue
    ///
    /// Whether a document called called Window.CSSPositionValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csspositionvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1976,
            "use.counter.doc",
            "window_csspositionvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csspropertyrule
    ///
    /// Whether a document called called Window.CSSPropertyRule. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csspropertyrule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1977,
            "use.counter.doc",
            "window_csspropertyrule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssrotate
    ///
    /// Whether a document called called Window.CSSRotate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssrotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1978,
            "use.counter.doc",
            "window_cssrotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssscale
    ///
    /// Whether a document called called Window.CSSScale. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssscale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1979,
            "use.counter.doc",
            "window_cssscale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssskew
    ///
    /// Whether a document called called Window.CSSSkew. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssskew: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1980,
            "use.counter.doc",
            "window_cssskew",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssskewx
    ///
    /// Whether a document called called Window.CSSSkewX. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssskewx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1981,
            "use.counter.doc",
            "window_cssskewx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssskewy
    ///
    /// Whether a document called called Window.CSSSkewY. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssskewy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1982,
            "use.counter.doc",
            "window_cssskewy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssstylevalue
    ///
    /// Whether a document called called Window.CSSStyleValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssstylevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1983,
            "use.counter.doc",
            "window_cssstylevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csstransformcomponent
    ///
    /// Whether a document called called Window.CSSTransformComponent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csstransformcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1984,
            "use.counter.doc",
            "window_csstransformcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csstransformvalue
    ///
    /// Whether a document called called Window.CSSTransformValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csstransformvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1985,
            "use.counter.doc",
            "window_csstransformvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csstranslate
    ///
    /// Whether a document called called Window.CSSTranslate. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csstranslate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1986,
            "use.counter.doc",
            "window_csstranslate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssunitvalue
    ///
    /// Whether a document called called Window.CSSUnitValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssunitvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1987,
            "use.counter.doc",
            "window_cssunitvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssunparsedvalue
    ///
    /// Whether a document called called Window.CSSUnparsedValue. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssunparsedvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1988,
            "use.counter.doc",
            "window_cssunparsedvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssvariablereferencevalue
    ///
    /// Whether a document called called Window.CSSVariableReferenceValue. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssvariablereferencevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1989,
            "use.counter.doc",
            "window_cssvariablereferencevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_defaultstatus
    ///
    /// Whether a document called called Window.defaultStatus. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_defaultstatus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1990,
            "use.counter.doc",
            "window_defaultstatus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_devicemotioneventacceleration
    ///
    /// Whether a document called called Window.DeviceMotionEventAcceleration. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_devicemotioneventacceleration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1991,
            "use.counter.doc",
            "window_devicemotioneventacceleration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_devicemotioneventrotationrate
    ///
    /// Whether a document called called Window.DeviceMotionEventRotationRate. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_devicemotioneventrotationrate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1992,
            "use.counter.doc",
            "window_devicemotioneventrotationrate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_domerror
    ///
    /// Whether a document called called Window.DOMError. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_domerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1993,
            "use.counter.doc",
            "window_domerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_encodedvideochunk
    ///
    /// Whether a document called called Window.EncodedVideoChunk. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_encodedvideochunk: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1994,
            "use.counter.doc",
            "window_encodedvideochunk",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_enterpictureinpictureevent
    ///
    /// Whether a document called called Window.EnterPictureInPictureEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_enterpictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1995,
            "use.counter.doc",
            "window_enterpictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_external
    ///
    /// Whether a document called called Window.External. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1996,
            "use.counter.doc",
            "window_external",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_federatedcredential
    ///
    /// Whether a document called called Window.FederatedCredential. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_federatedcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1997,
            "use.counter.doc",
            "window_federatedcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_gyroscope
    ///
    /// Whether a document called called Window.Gyroscope. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_gyroscope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1998,
            "use.counter.doc",
            "window_gyroscope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_htmlcontentelement
    ///
    /// Whether a document called called Window.HTMLContentElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_htmlcontentelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1999,
            "use.counter.doc",
            "window_htmlcontentelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_htmlshadowelement
    ///
    /// Whether a document called called Window.HTMLShadowElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_htmlshadowelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2000,
            "use.counter.doc",
            "window_htmlshadowelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_imagecapture
    ///
    /// Whether a document called called Window.ImageCapture. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_imagecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2001,
            "use.counter.doc",
            "window_imagecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_inputdevicecapabilities
    ///
    /// Whether a document called called Window.InputDeviceCapabilities. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_inputdevicecapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2002,
            "use.counter.doc",
            "window_inputdevicecapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_inputdeviceinfo
    ///
    /// Whether a document called called Window.InputDeviceInfo. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_inputdeviceinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2003,
            "use.counter.doc",
            "window_inputdeviceinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_keyboard
    ///
    /// Whether a document called called Window.Keyboard. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_keyboard: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2004,
            "use.counter.doc",
            "window_keyboard",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_keyboardlayoutmap
    ///
    /// Whether a document called called Window.KeyboardLayoutMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_keyboardlayoutmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2005,
            "use.counter.doc",
            "window_keyboardlayoutmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_linearaccelerationsensor
    ///
    /// Whether a document called called Window.LinearAccelerationSensor. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_linearaccelerationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2006,
            "use.counter.doc",
            "window_linearaccelerationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_mediasettingsrange
    ///
    /// Whether a document called called Window.MediaSettingsRange. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_mediasettingsrange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2007,
            "use.counter.doc",
            "window_mediasettingsrange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiaccess
    ///
    /// Whether a document called called Window.MIDIAccess. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiaccess: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2008,
            "use.counter.doc",
            "window_midiaccess",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiconnectionevent
    ///
    /// Whether a document called called Window.MIDIConnectionEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2009,
            "use.counter.doc",
            "window_midiconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiinput
    ///
    /// Whether a document called called Window.MIDIInput. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiinput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2010,
            "use.counter.doc",
            "window_midiinput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiinputmap
    ///
    /// Whether a document called called Window.MIDIInputMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiinputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2011,
            "use.counter.doc",
            "window_midiinputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midimessageevent
    ///
    /// Whether a document called called Window.MIDIMessageEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midimessageevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2012,
            "use.counter.doc",
            "window_midimessageevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midioutput
    ///
    /// Whether a document called called Window.MIDIOutput. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midioutput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2013,
            "use.counter.doc",
            "window_midioutput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midioutputmap
    ///
    /// Whether a document called called Window.MIDIOutputMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midioutputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2014,
            "use.counter.doc",
            "window_midioutputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiport
    ///
    /// Whether a document called called Window.MIDIPort. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2015,
            "use.counter.doc",
            "window_midiport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_networkinformation
    ///
    /// Whether a document called called Window.NetworkInformation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_networkinformation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2016,
            "use.counter.doc",
            "window_networkinformation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_offscreenbuffering
    ///
    /// Whether a document called called Window.offscreenBuffering. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_offscreenbuffering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2017,
            "use.counter.doc",
            "window_offscreenbuffering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onbeforeinstallprompt
    ///
    /// Whether a document called called Window.onbeforeinstallprompt. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onbeforeinstallprompt: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2018,
            "use.counter.doc",
            "window_onbeforeinstallprompt",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_oncancel
    ///
    /// Whether a document called called Window.oncancel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2019,
            "use.counter.doc",
            "window_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onmousewheel
    ///
    /// Whether a document called called Window.onmousewheel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2020,
            "use.counter.doc",
            "window_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onorientationchange
    ///
    /// Whether a document called called Window.onorientationchange. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onorientationchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2021,
            "use.counter.doc",
            "window_onorientationchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onsearch
    ///
    /// Whether a document called called Window.onsearch. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2022,
            "use.counter.doc",
            "window_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onselectionchange
    ///
    /// Whether a document called called Window.onselectionchange. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onselectionchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2023,
            "use.counter.doc",
            "window_onselectionchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_open_empty_url
    ///
    /// Whether a document calls window.open with an empty url argument. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_open_empty_url: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2024,
            "use.counter.doc",
            "window_open_empty_url",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_opendatabase
    ///
    /// Whether a document called called Window.openDatabase. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_opendatabase: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2025,
            "use.counter.doc",
            "window_opendatabase",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_orientation
    ///
    /// Whether a document called called Window.orientation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2026,
            "use.counter.doc",
            "window_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_orientationsensor
    ///
    /// Whether a document called called Window.OrientationSensor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_orientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2027,
            "use.counter.doc",
            "window_orientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_overconstrainederror
    ///
    /// Whether a document called called Window.OverconstrainedError. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_overconstrainederror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2028,
            "use.counter.doc",
            "window_overconstrainederror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_passwordcredential
    ///
    /// Whether a document called called Window.PasswordCredential. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_passwordcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2029,
            "use.counter.doc",
            "window_passwordcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentaddress
    ///
    /// Whether a document called called Window.PaymentAddress. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentaddress: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2030,
            "use.counter.doc",
            "window_paymentaddress",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentinstruments
    ///
    /// Whether a document called called Window.PaymentInstruments. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentinstruments: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2031,
            "use.counter.doc",
            "window_paymentinstruments",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentmanager
    ///
    /// Whether a document called called Window.PaymentManager. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2032,
            "use.counter.doc",
            "window_paymentmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentmethodchangeevent
    ///
    /// Whether a document called called Window.PaymentMethodChangeEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentmethodchangeevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2033,
            "use.counter.doc",
            "window_paymentmethodchangeevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentrequest
    ///
    /// Whether a document called called Window.PaymentRequest. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2034,
            "use.counter.doc",
            "window_paymentrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentrequestupdateevent
    ///
    /// Whether a document called called Window.PaymentRequestUpdateEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequestupdateevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2035,
            "use.counter.doc",
            "window_paymentrequestupdateevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentresponse
    ///
    /// Whether a document called called Window.PaymentResponse. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentresponse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2036,
            "use.counter.doc",
            "window_paymentresponse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_performancelongtasktiming
    ///
    /// Whether a document called called Window.PerformanceLongTaskTiming. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_performancelongtasktiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2037,
            "use.counter.doc",
            "window_performancelongtasktiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_photocapabilities
    ///
    /// Whether a document called called Window.PhotoCapabilities. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_photocapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2038,
            "use.counter.doc",
            "window_photocapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_pictureinpictureevent
    ///
    /// Whether a document called called Window.PictureInPictureEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2039,
            "use.counter.doc",
            "window_pictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_pictureinpicturewindow
    ///
    /// Whether a document called called Window.PictureInPictureWindow. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpicturewindow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2040,
            "use.counter.doc",
            "window_pictureinpicturewindow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentation
    ///
    /// Whether a document called called Window.Presentation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2041,
            "use.counter.doc",
            "window_presentation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationavailability
    ///
    /// Whether a document called called Window.PresentationAvailability. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationavailability: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2042,
            "use.counter.doc",
            "window_presentationavailability",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnection
    ///
    /// Whether a document called called Window.PresentationConnection. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2043,
            "use.counter.doc",
            "window_presentationconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnectionavailableevent
    ///
    /// Whether a document called called Window.PresentationConnectionAvailableEvent.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_presentationconnectionavailableevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2044,
            "use.counter.doc",
            "window_presentationconnectionavailableevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnectioncloseevent
    ///
    /// Whether a document called called Window.PresentationConnectionCloseEvent.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_presentationconnectioncloseevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2045,
            "use.counter.doc",
            "window_presentationconnectioncloseevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnectionlist
    ///
    /// Whether a document called called Window.PresentationConnectionList. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnectionlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2046,
            "use.counter.doc",
            "window_presentationconnectionlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationreceiver
    ///
    /// Whether a document called called Window.PresentationReceiver. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationreceiver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2047,
            "use.counter.doc",
            "window_presentationreceiver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationrequest
    ///
    /// Whether a document called called Window.PresentationRequest. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2048,
            "use.counter.doc",
            "window_presentationrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_relativeorientationsensor
    ///
    /// Whether a document called called Window.RelativeOrientationSensor. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_relativeorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2049,
            "use.counter.doc",
            "window_relativeorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_remoteplayback
    ///
    /// Whether a document called called Window.RemotePlayback. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_remoteplayback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2050,
            "use.counter.doc",
            "window_remoteplayback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_report
    ///
    /// Whether a document called called Window.Report. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_report: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2051,
            "use.counter.doc",
            "window_report",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_reportbody
    ///
    /// Whether a document called called Window.ReportBody. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_reportbody: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2052,
            "use.counter.doc",
            "window_reportbody",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_reportingobserver
    ///
    /// Whether a document called called Window.ReportingObserver. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_reportingobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2053,
            "use.counter.doc",
            "window_reportingobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcerror
    ///
    /// Whether a document called called Window.RTCError. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2054,
            "use.counter.doc",
            "window_rtcerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcerrorevent
    ///
    /// Whether a document called called Window.RTCErrorEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2055,
            "use.counter.doc",
            "window_rtcerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcicetransport
    ///
    /// Whether a document called called Window.RTCIceTransport. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcicetransport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2056,
            "use.counter.doc",
            "window_rtcicetransport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcpeerconnectioniceerrorevent
    ///
    /// Whether a document called called Window.RTCPeerConnectionIceErrorEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcpeerconnectioniceerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2057,
            "use.counter.doc",
            "window_rtcpeerconnectioniceerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sensor
    ///
    /// Whether a document called called Window.Sensor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2058,
            "use.counter.doc",
            "window_sensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sensorerrorevent
    ///
    /// Whether a document called called Window.SensorErrorEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sensorerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2059,
            "use.counter.doc",
            "window_sensorerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sidebar_getter
    ///
    /// Whether a document got Window.sidebar. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2060,
            "use.counter.doc",
            "window_sidebar_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sidebar_setter
    ///
    /// Whether a document set Window.sidebar. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2061,
            "use.counter.doc",
            "window_sidebar_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_speechrecognitionalternative
    ///
    /// Whether a document called called Window.SpeechRecognitionAlternative. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionalternative: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2062,
            "use.counter.doc",
            "window_speechrecognitionalternative",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_speechrecognitionresult
    ///
    /// Whether a document called called Window.SpeechRecognitionResult. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2063,
            "use.counter.doc",
            "window_speechrecognitionresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_speechrecognitionresultlist
    ///
    /// Whether a document called called Window.SpeechRecognitionResultList. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionresultlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2064,
            "use.counter.doc",
            "window_speechrecognitionresultlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_stylemedia
    ///
    /// Whether a document called called Window.styleMedia. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_stylemedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2065,
            "use.counter.doc",
            "window_stylemedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_stylepropertymap
    ///
    /// Whether a document called called Window.StylePropertyMap. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2066,
            "use.counter.doc",
            "window_stylepropertymap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_stylepropertymapreadonly
    ///
    /// Whether a document called called Window.StylePropertyMapReadOnly. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymapreadonly: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2067,
            "use.counter.doc",
            "window_stylepropertymapreadonly",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_svgdiscardelement
    ///
    /// Whether a document called called Window.SVGDiscardElement. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_svgdiscardelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2068,
            "use.counter.doc",
            "window_svgdiscardelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_syncmanager
    ///
    /// Whether a document called called Window.SyncManager. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_syncmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2069,
            "use.counter.doc",
            "window_syncmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_taskattributiontiming
    ///
    /// Whether a document called called Window.TaskAttributionTiming. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_taskattributiontiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2070,
            "use.counter.doc",
            "window_taskattributiontiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_textevent
    ///
    /// Whether a document called called Window.TextEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_textevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2071,
            "use.counter.doc",
            "window_textevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_touch
    ///
    /// Whether a document called called Window.Touch. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_touch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2072,
            "use.counter.doc",
            "window_touch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_touchevent
    ///
    /// Whether a document called called Window.TouchEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_touchevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2073,
            "use.counter.doc",
            "window_touchevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_touchlist
    ///
    /// Whether a document called called Window.TouchList. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_touchlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2074,
            "use.counter.doc",
            "window_touchlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usb
    ///
    /// Whether a document called called Window.USB. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usb: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2075,
            "use.counter.doc",
            "window_usb",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbalternateinterface
    ///
    /// Whether a document called called Window.USBAlternateInterface. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbalternateinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2076,
            "use.counter.doc",
            "window_usbalternateinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbconfiguration
    ///
    /// Whether a document called called Window.USBConfiguration. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbconfiguration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2077,
            "use.counter.doc",
            "window_usbconfiguration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbconnectionevent
    ///
    /// Whether a document called called Window.USBConnectionEvent. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2078,
            "use.counter.doc",
            "window_usbconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbdevice
    ///
    /// Whether a document called called Window.USBDevice. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2079,
            "use.counter.doc",
            "window_usbdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbendpoint
    ///
    /// Whether a document called called Window.USBEndpoint. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbendpoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2080,
            "use.counter.doc",
            "window_usbendpoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbinterface
    ///
    /// Whether a document called called Window.USBInterface. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2081,
            "use.counter.doc",
            "window_usbinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbintransferresult
    ///
    /// Whether a document called called Window.USBInTransferResult. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2082,
            "use.counter.doc",
            "window_usbintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousintransferpacket
    ///
    /// Whether a document called called Window.USBIsochronousInTransferPacket. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousintransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2083,
            "use.counter.doc",
            "window_usbisochronousintransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousintransferresult
    ///
    /// Whether a document called called Window.USBIsochronousInTransferResult. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2084,
            "use.counter.doc",
            "window_usbisochronousintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousouttransferpacket
    ///
    /// Whether a document called called Window.USBIsochronousOutTransferPacket.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousouttransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2085,
            "use.counter.doc",
            "window_usbisochronousouttransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousouttransferresult
    ///
    /// Whether a document called called Window.USBIsochronousOutTransferResult.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2086,
            "use.counter.doc",
            "window_usbisochronousouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbouttransferresult
    ///
    /// Whether a document called called Window.USBOutTransferResult. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2087,
            "use.counter.doc",
            "window_usbouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_useractivation
    ///
    /// Whether a document called called Window.UserActivation. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_useractivation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2088,
            "use.counter.doc",
            "window_useractivation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videocolorspace
    ///
    /// Whether a document called called Window.VideoColorSpace. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videocolorspace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2089,
            "use.counter.doc",
            "window_videocolorspace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videodecoder
    ///
    /// Whether a document called called Window.VideoDecoder. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videodecoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2090,
            "use.counter.doc",
            "window_videodecoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videoencoder
    ///
    /// Whether a document called called Window.VideoEncoder. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videoencoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2091,
            "use.counter.doc",
            "window_videoencoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videoframe
    ///
    /// Whether a document called called Window.VideoFrame. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videoframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2092,
            "use.counter.doc",
            "window_videoframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_wakelock
    ///
    /// Whether a document called called Window.WakeLock. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_wakelock: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2093,
            "use.counter.doc",
            "window_wakelock",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_wakelocksentinel
    ///
    /// Whether a document called called Window.WakeLockSentinel. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_wakelocksentinel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2094,
            "use.counter.doc",
            "window_wakelocksentinel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitcancelanimationframe
    ///
    /// Whether a document called called Window.webkitCancelAnimationFrame. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitcancelanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2095,
            "use.counter.doc",
            "window_webkitcancelanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitmediastream
    ///
    /// Whether a document called called Window.webkitMediaStream. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitmediastream: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2096,
            "use.counter.doc",
            "window_webkitmediastream",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitmutationobserver
    ///
    /// Whether a document called called Window.WebKitMutationObserver. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitmutationobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2097,
            "use.counter.doc",
            "window_webkitmutationobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitrequestanimationframe
    ///
    /// Whether a document called called Window.webkitRequestAnimationFrame. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitrequestanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2098,
            "use.counter.doc",
            "window_webkitrequestanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitrequestfilesystem
    ///
    /// Whether a document called called Window.webkitRequestFileSystem. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitrequestfilesystem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2099,
            "use.counter.doc",
            "window_webkitrequestfilesystem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitresolvelocalfilesystemurl
    ///
    /// Whether a document called called Window.webkitResolveLocalFileSystemURL.
    /// Compare against `use.counter.content_documents_destroyed` to calculate the
    /// rate.
    pub static window_webkitresolvelocalfilesystemurl: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2100,
            "use.counter.doc",
            "window_webkitresolvelocalfilesystemurl",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitrtcpeerconnection
    ///
    /// Whether a document called called Window.webkitRTCPeerConnection. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitrtcpeerconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2101,
            "use.counter.doc",
            "window_webkitrtcpeerconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechgrammar
    ///
    /// Whether a document called called Window.webkitSpeechGrammar. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammar: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2102,
            "use.counter.doc",
            "window_webkitspeechgrammar",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechgrammarlist
    ///
    /// Whether a document called called Window.webkitSpeechGrammarList. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammarlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2103,
            "use.counter.doc",
            "window_webkitspeechgrammarlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechrecognition
    ///
    /// Whether a document called called Window.webkitSpeechRecognition. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2104,
            "use.counter.doc",
            "window_webkitspeechrecognition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechrecognitionerror
    ///
    /// Whether a document called called Window.webkitSpeechRecognitionError. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognitionerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2105,
            "use.counter.doc",
            "window_webkitspeechrecognitionerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechrecognitionevent
    ///
    /// Whether a document called called Window.webkitSpeechRecognitionEvent. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognitionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2106,
            "use.counter.doc",
            "window_webkitspeechrecognitionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitstorageinfo
    ///
    /// Whether a document called called Window.webkitStorageInfo. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitstorageinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2107,
            "use.counter.doc",
            "window_webkitstorageinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.workernavigator_permissions
    ///
    /// Whether a document called called WorkerNavigator.permissions. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static workernavigator_permissions: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2108,
            "use.counter.doc",
            "workernavigator_permissions",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.wr_filter_fallback
    ///
    /// Whether a document triggers the blob fallback for an SVG filter.. Compare
    /// against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static wr_filter_fallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2109,
            "use.counter.doc",
            "wr_filter_fallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.xslstylesheet
    ///
    /// Whether a document uses an XSL Stylesheet. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static xslstylesheet: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2110,
            "use.counter.doc",
            "xslstylesheet",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.xsltprocessor_constructor
    ///
    /// Whether a document called called XSLTProcessor.constructor. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static xsltprocessor_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2111,
            "use.counter.doc",
            "xsltprocessor_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.you_tube_flash_embed
    ///
    /// Whether a document in <object> or <embed>. Compare against
    /// `use.counter.content_documents_destroyed` to calculate the rate.
    pub static you_tube_flash_embed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2112,
            "use.counter.doc",
            "you_tube_flash_embed",
            "use-counters"
        )
    });

}
pub mod use_counter_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.clipboard_read
    ///
    /// Whether a page called called Clipboard.read. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static clipboard_read: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2113,
            "use.counter.page",
            "clipboard_read",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.clipboard_readtext
    ///
    /// Whether a page called called Clipboard.readText. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static clipboard_readtext: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2114,
            "use.counter.page",
            "clipboard_readtext",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.clipboard_write
    ///
    /// Whether a page called called Clipboard.write. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static clipboard_write: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2115,
            "use.counter.page",
            "clipboard_write",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_assert
    ///
    /// Whether a page called called console.assert. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2116,
            "use.counter.page",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_clear
    ///
    /// Whether a page called called console.clear. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2117,
            "use.counter.page",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_count
    ///
    /// Whether a page called called console.count. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2118,
            "use.counter.page",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_countreset
    ///
    /// Whether a page called called console.countReset. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2119,
            "use.counter.page",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_debug
    ///
    /// Whether a page called called console.debug. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2120,
            "use.counter.page",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_dir
    ///
    /// Whether a page called called console.dir. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2121,
            "use.counter.page",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_dirxml
    ///
    /// Whether a page called called console.dirxml. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2122,
            "use.counter.page",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_error
    ///
    /// Whether a page called called console.error. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2123,
            "use.counter.page",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_exception
    ///
    /// Whether a page called called console.exception. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2124,
            "use.counter.page",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_group
    ///
    /// Whether a page called called console.group. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2125,
            "use.counter.page",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_groupcollapsed
    ///
    /// Whether a page called called console.groupCollapsed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2126,
            "use.counter.page",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_groupend
    ///
    /// Whether a page called called console.groupEnd. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2127,
            "use.counter.page",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_info
    ///
    /// Whether a page called called console.info. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2128,
            "use.counter.page",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_log
    ///
    /// Whether a page called called console.log. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2129,
            "use.counter.page",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_profile
    ///
    /// Whether a page called called console.profile. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2130,
            "use.counter.page",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_profileend
    ///
    /// Whether a page called called console.profileEnd. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2131,
            "use.counter.page",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_table
    ///
    /// Whether a page called called console.table. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2132,
            "use.counter.page",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_time
    ///
    /// Whether a page called called console.time. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2133,
            "use.counter.page",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_timeend
    ///
    /// Whether a page called called console.timeEnd. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2134,
            "use.counter.page",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_timelog
    ///
    /// Whether a page called called console.timeLog. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2135,
            "use.counter.page",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_timestamp
    ///
    /// Whether a page called called console.timeStamp. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2136,
            "use.counter.page",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_trace
    ///
    /// Whether a page called called console.trace. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2137,
            "use.counter.page",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_warn
    ///
    /// Whether a page called called console.warn. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2138,
            "use.counter.page",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.customelementregistry_define
    ///
    /// Whether a page called called CustomElementRegistry.define. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static customelementregistry_define: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2139,
            "use.counter.page",
            "customelementregistry_define",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.customized_builtin
    ///
    /// Whether a page registers a customized built-in element. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static customized_builtin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2140,
            "use.counter.page",
            "customized_builtin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_addelement
    ///
    /// Whether a page called called DataTransfer.addElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_addelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2141,
            "use.counter.page",
            "datatransfer_addelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozcleardataat
    ///
    /// Whether a page called called DataTransfer.mozClearDataAt. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcleardataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2142,
            "use.counter.page",
            "datatransfer_mozcleardataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozcursor_getter
    ///
    /// Whether a page got DataTransfer.mozCursor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2143,
            "use.counter.page",
            "datatransfer_mozcursor_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozcursor_setter
    ///
    /// Whether a page set DataTransfer.mozCursor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2144,
            "use.counter.page",
            "datatransfer_mozcursor_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozgetdataat
    ///
    /// Whether a page called called DataTransfer.mozGetDataAt. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozgetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2145,
            "use.counter.page",
            "datatransfer_mozgetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozitemcount_getter
    ///
    /// Whether a page got DataTransfer.mozItemCount. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2146,
            "use.counter.page",
            "datatransfer_mozitemcount_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozitemcount_setter
    ///
    /// Whether a page set DataTransfer.mozItemCount. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2147,
            "use.counter.page",
            "datatransfer_mozitemcount_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozsetdataat
    ///
    /// Whether a page called called DataTransfer.mozSetDataAt. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2148,
            "use.counter.page",
            "datatransfer_mozsetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozsourcenode_getter
    ///
    /// Whether a page got DataTransfer.mozSourceNode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2149,
            "use.counter.page",
            "datatransfer_mozsourcenode_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozsourcenode_setter
    ///
    /// Whether a page set DataTransfer.mozSourceNode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2150,
            "use.counter.page",
            "datatransfer_mozsourcenode_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_moztypesat
    ///
    /// Whether a page called called DataTransfer.mozTypesAt. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_moztypesat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2151,
            "use.counter.page",
            "datatransfer_moztypesat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozusercancelled_getter
    ///
    /// Whether a page got DataTransfer.mozUserCancelled. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2152,
            "use.counter.page",
            "datatransfer_mozusercancelled_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozusercancelled_setter
    ///
    /// Whether a page set DataTransfer.mozUserCancelled. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2153,
            "use.counter.page",
            "datatransfer_mozusercancelled_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransferitem_webkitgetasentry
    ///
    /// Whether a page called called DataTransferItem.webkitGetAsEntry. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransferitem_webkitgetasentry: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2154,
            "use.counter.page",
            "datatransferitem_webkitgetasentry",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_caretrangefrompoint
    ///
    /// Whether a page called called Document.caretRangeFromPoint. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_caretrangefrompoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2155,
            "use.counter.page",
            "document_caretrangefrompoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_exec_command_content_read_only
    ///
    /// Whether a page calls execCommand with contentReadOnly. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_exec_command_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2156,
            "use.counter.page",
            "document_exec_command_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_exitpictureinpicture
    ///
    /// Whether a page called called Document.exitPictureInPicture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_exitpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2157,
            "use.counter.page",
            "document_exitpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_featurepolicy
    ///
    /// Whether a page called called Document.featurePolicy. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_featurepolicy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2158,
            "use.counter.page",
            "document_featurepolicy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_mozsetimageelement
    ///
    /// Whether a page called called Document.mozSetImageElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_mozsetimageelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2159,
            "use.counter.page",
            "document_mozsetimageelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onbeforecopy
    ///
    /// Whether a page called called Document.onbeforecopy. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onbeforecopy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2160,
            "use.counter.page",
            "document_onbeforecopy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onbeforecut
    ///
    /// Whether a page called called Document.onbeforecut. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onbeforecut: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2161,
            "use.counter.page",
            "document_onbeforecut",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onbeforepaste
    ///
    /// Whether a page called called Document.onbeforepaste. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onbeforepaste: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2162,
            "use.counter.page",
            "document_onbeforepaste",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_oncancel
    ///
    /// Whether a page called called Document.oncancel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2163,
            "use.counter.page",
            "document_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onfreeze
    ///
    /// Whether a page called called Document.onfreeze. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onfreeze: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2164,
            "use.counter.page",
            "document_onfreeze",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onmousewheel
    ///
    /// Whether a page called called Document.onmousewheel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2165,
            "use.counter.page",
            "document_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onresume
    ///
    /// Whether a page called called Document.onresume. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onresume: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2166,
            "use.counter.page",
            "document_onresume",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onsearch
    ///
    /// Whether a page called called Document.onsearch. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2167,
            "use.counter.page",
            "document_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onwebkitfullscreenchange
    ///
    /// Whether a page called called Document.onwebkitfullscreenchange. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onwebkitfullscreenchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2168,
            "use.counter.page",
            "document_onwebkitfullscreenchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_onwebkitfullscreenerror
    ///
    /// Whether a page called called Document.onwebkitfullscreenerror. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_onwebkitfullscreenerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2169,
            "use.counter.page",
            "document_onwebkitfullscreenerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_open
    ///
    /// Whether a page calls document.open in a way that creates a new Window object.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static document_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2170,
            "use.counter.page",
            "document_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_pictureinpictureelement
    ///
    /// Whether a page called called Document.pictureInPictureElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_pictureinpictureelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2171,
            "use.counter.page",
            "document_pictureinpictureelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_pictureinpictureenabled
    ///
    /// Whether a page called called Document.pictureInPictureEnabled. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_pictureinpictureenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2172,
            "use.counter.page",
            "document_pictureinpictureenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_state_or_value_content_read_only
    ///
    /// Whether a page calls queryCommandState or queryCommandValue with
    /// contentReadOnly. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_state_or_value_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2173,
            "use.counter.page",
            "document_query_command_state_or_value_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_state_or_value_insert_br_on_return
    ///
    /// Whether a page calls queryCommandState or queryCommandValue with
    /// insertBrOnReturn. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_state_or_value_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2174,
            "use.counter.page",
            "document_query_command_state_or_value_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_supported_or_enabled_content_read_only
    ///
    /// Whether a page calls queryCommandSupported or queryCommandEnabled with
    /// contentReadOnly. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_supported_or_enabled_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2175,
            "use.counter.page",
            "document_query_command_supported_or_enabled_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_supported_or_enabled_insert_br_on_return
    ///
    /// Whether a page calls queryCommandSupported or queryCommandEnabled with
    /// insertBrOnReturn. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_supported_or_enabled_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2176,
            "use.counter.page",
            "document_query_command_supported_or_enabled_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_registerelement
    ///
    /// Whether a page called called Document.registerElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_registerelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2177,
            "use.counter.page",
            "document_registerelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_wasdiscarded
    ///
    /// Whether a page called called Document.wasDiscarded. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_wasdiscarded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2178,
            "use.counter.page",
            "document_wasdiscarded",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitcancelfullscreen
    ///
    /// Whether a page called called Document.webkitCancelFullScreen. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitcancelfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2179,
            "use.counter.page",
            "document_webkitcancelfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitcurrentfullscreenelement
    ///
    /// Whether a page called called Document.webkitCurrentFullScreenElement. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static document_webkitcurrentfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2180,
            "use.counter.page",
            "document_webkitcurrentfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitexitfullscreen
    ///
    /// Whether a page called called Document.webkitExitFullscreen. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitexitfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2181,
            "use.counter.page",
            "document_webkitexitfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitfullscreenelement
    ///
    /// Whether a page called called Document.webkitFullscreenElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2182,
            "use.counter.page",
            "document_webkitfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitfullscreenenabled
    ///
    /// Whether a page called called Document.webkitFullscreenEnabled. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitfullscreenenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2183,
            "use.counter.page",
            "document_webkitfullscreenenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkithidden
    ///
    /// Whether a page called called Document.webkitHidden. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkithidden: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2184,
            "use.counter.page",
            "document_webkithidden",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitisfullscreen
    ///
    /// Whether a page called called Document.webkitIsFullScreen. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitisfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2185,
            "use.counter.page",
            "document_webkitisfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_webkitvisibilitystate
    ///
    /// Whether a page called called Document.webkitVisibilityState. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_webkitvisibilitystate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2186,
            "use.counter.page",
            "document_webkitvisibilitystate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_xmlencoding
    ///
    /// Whether a page called called Document.xmlEncoding. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_xmlencoding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2187,
            "use.counter.page",
            "document_xmlencoding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_xmlstandalone
    ///
    /// Whether a page called called Document.xmlStandalone. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_xmlstandalone: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2188,
            "use.counter.page",
            "document_xmlstandalone",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_xmlversion
    ///
    /// Whether a page called called Document.xmlVersion. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_xmlversion: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2189,
            "use.counter.page",
            "document_xmlversion",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.domparser_parsefromstring
    ///
    /// Whether a page called called DOMParser.parseFromString. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domparser_parsefromstring: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2190,
            "use.counter.page",
            "domparser_parsefromstring",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_attachshadow
    ///
    /// Whether a page called called Element.attachShadow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_attachshadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2191,
            "use.counter.page",
            "element_attachshadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_computedstylemap
    ///
    /// Whether a page called called Element.computedStyleMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_computedstylemap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2192,
            "use.counter.page",
            "element_computedstylemap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_onmousewheel
    ///
    /// Whether a page called called Element.onmousewheel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2193,
            "use.counter.page",
            "element_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_releasecapture
    ///
    /// Whether a page called called Element.releaseCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_releasecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2194,
            "use.counter.page",
            "element_releasecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_releasepointercapture
    ///
    /// Whether a page called called Element.releasePointerCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_releasepointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2195,
            "use.counter.page",
            "element_releasepointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_scrollintoviewifneeded
    ///
    /// Whether a page called called Element.scrollIntoViewIfNeeded. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_scrollintoviewifneeded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2196,
            "use.counter.page",
            "element_scrollintoviewifneeded",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_setcapture
    ///
    /// Whether a page called called Element.setCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_setcapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2197,
            "use.counter.page",
            "element_setcapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_sethtml
    ///
    /// Whether a page called called Element.setHTML. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_sethtml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2198,
            "use.counter.page",
            "element_sethtml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_setpointercapture
    ///
    /// Whether a page called called Element.setPointerCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_setpointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2199,
            "use.counter.page",
            "element_setpointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.enumerate_devices_insec
    ///
    /// Whether a page calls MediaDevices.enumerateDevices from an insecure context.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static enumerate_devices_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2200,
            "use.counter.page",
            "enumerate_devices_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.enumerate_devices_unfocused
    ///
    /// Whether a page calls MediaDevices.enumerateDevices from a unfocused document.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static enumerate_devices_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2201,
            "use.counter.page",
            "enumerate_devices_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_blend
    ///
    /// Whether a page uses the feBlend SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_blend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2202,
            "use.counter.page",
            "fe_blend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_color_matrix
    ///
    /// Whether a page uses the feColorMatrix SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_color_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2203,
            "use.counter.page",
            "fe_color_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_component_transfer
    ///
    /// Whether a page uses the feComponentTransfer SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_component_transfer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2204,
            "use.counter.page",
            "fe_component_transfer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_composite
    ///
    /// Whether a page uses the feComposite SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2205,
            "use.counter.page",
            "fe_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_convolve_matrix
    ///
    /// Whether a page uses the feConvolveMatrix SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_convolve_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2206,
            "use.counter.page",
            "fe_convolve_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_diffuse_lighting
    ///
    /// Whether a page uses the feDiffuseLighting SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_diffuse_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2207,
            "use.counter.page",
            "fe_diffuse_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_displacement_map
    ///
    /// Whether a page uses the feDisplacementMap SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_displacement_map: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2208,
            "use.counter.page",
            "fe_displacement_map",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_flood
    ///
    /// Whether a page uses the feFlood SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_flood: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2209,
            "use.counter.page",
            "fe_flood",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_gaussian_blur
    ///
    /// Whether a page uses the feGaussianBlur SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_gaussian_blur: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2210,
            "use.counter.page",
            "fe_gaussian_blur",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_image
    ///
    /// Whether a page uses the feImage SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2211,
            "use.counter.page",
            "fe_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_merge
    ///
    /// Whether a page uses the feMerge SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_merge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2212,
            "use.counter.page",
            "fe_merge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_morphology
    ///
    /// Whether a page uses the feMorphology SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_morphology: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2213,
            "use.counter.page",
            "fe_morphology",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_offset
    ///
    /// Whether a page uses the feOffset SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2214,
            "use.counter.page",
            "fe_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_specular_lighting
    ///
    /// Whether a page uses the feSpecularLighting SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_specular_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2215,
            "use.counter.page",
            "fe_specular_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_tile
    ///
    /// Whether a page uses the feTile SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_tile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2216,
            "use.counter.page",
            "fe_tile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_turbulence
    ///
    /// Whether a page uses the feTurbulence SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_turbulence: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2217,
            "use.counter.page",
            "fe_turbulence",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.filtered_cross_origin_iframe
    ///
    /// Whether a page cross-origin <iframe> within a CSS/SVG filter. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static filtered_cross_origin_iframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2218,
            "use.counter.page",
            "filtered_cross_origin_iframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.get_user_media_insec
    ///
    /// Whether a page calls MediaDevices.getUserMedia from an insecure context.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static get_user_media_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2219,
            "use.counter.page",
            "get_user_media_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.get_user_media_unfocused
    ///
    /// Whether a page calls MediaDevices.getUserMedia from an unfocused document.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static get_user_media_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2220,
            "use.counter.page",
            "get_user_media_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlbuttonelement_popovertargetaction
    ///
    /// Whether a page called called HTMLButtonElement.popoverTargetAction. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlbuttonelement_popovertargetaction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2221,
            "use.counter.page",
            "htmlbuttonelement_popovertargetaction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlbuttonelement_popovertargetelement
    ///
    /// Whether a page called called HTMLButtonElement.popoverTargetElement. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlbuttonelement_popovertargetelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2222,
            "use.counter.page",
            "htmlbuttonelement_popovertargetelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldialogelement_show
    ///
    /// Whether a page called called HTMLDialogElement.show. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldialogelement_show: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2223,
            "use.counter.page",
            "htmldialogelement_show",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_named_getter_hit
    ///
    /// Whether a page calls to the named getter on HTMLDocument that find something
    /// via the name lookup. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_named_getter_hit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2224,
            "use.counter.page",
            "htmldocument_named_getter_hit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlelement_attributestylemap
    ///
    /// Whether a page called called HTMLElement.attributeStyleMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlelement_attributestylemap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2225,
            "use.counter.page",
            "htmlelement_attributestylemap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlelement_hidepopover
    ///
    /// Whether a page called called HTMLElement.hidePopover. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlelement_hidepopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2226,
            "use.counter.page",
            "htmlelement_hidepopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlelement_popover
    ///
    /// Whether a page called called HTMLElement.popover. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlelement_popover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2227,
            "use.counter.page",
            "htmlelement_popover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlelement_showpopover
    ///
    /// Whether a page called called HTMLElement.showPopover. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlelement_showpopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2228,
            "use.counter.page",
            "htmlelement_showpopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlelement_togglepopover
    ///
    /// Whether a page called called HTMLElement.togglePopover. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlelement_togglepopover: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2229,
            "use.counter.page",
            "htmlelement_togglepopover",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmliframeelement_loading
    ///
    /// Whether a page called called HTMLIFrameElement.loading. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmliframeelement_loading: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2230,
            "use.counter.page",
            "htmliframeelement_loading",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_capture
    ///
    /// Whether a page called called HTMLInputElement.capture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2231,
            "use.counter.page",
            "htmlinputelement_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_incremental
    ///
    /// Whether a page called called HTMLInputElement.incremental. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_incremental: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2232,
            "use.counter.page",
            "htmlinputelement_incremental",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_onsearch
    ///
    /// Whether a page called called HTMLInputElement.onsearch. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2233,
            "use.counter.page",
            "htmlinputelement_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_popovertargetaction
    ///
    /// Whether a page called called HTMLInputElement.popoverTargetAction. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlinputelement_popovertargetaction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2234,
            "use.counter.page",
            "htmlinputelement_popovertargetaction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_popovertargetelement
    ///
    /// Whether a page called called HTMLInputElement.popoverTargetElement. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlinputelement_popovertargetelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2235,
            "use.counter.page",
            "htmlinputelement_popovertargetelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_webkitdirectory
    ///
    /// Whether a page called called HTMLInputElement.webkitdirectory. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_webkitdirectory: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2236,
            "use.counter.page",
            "htmlinputelement_webkitdirectory",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlinputelement_webkitentries
    ///
    /// Whether a page called called HTMLInputElement.webkitEntries. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlinputelement_webkitentries: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2237,
            "use.counter.page",
            "htmlinputelement_webkitentries",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlmediaelement_disableremoteplayback
    ///
    /// Whether a page called called HTMLMediaElement.disableRemotePlayback. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlmediaelement_disableremoteplayback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2238,
            "use.counter.page",
            "htmlmediaelement_disableremoteplayback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlmediaelement_remote
    ///
    /// Whether a page called called HTMLMediaElement.remote. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlmediaelement_remote: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2239,
            "use.counter.page",
            "htmlmediaelement_remote",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_cancelvideoframecallback
    ///
    /// Whether a page called called HTMLVideoElement.cancelVideoFrameCallback. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_cancelvideoframecallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2240,
            "use.counter.page",
            "htmlvideoelement_cancelvideoframecallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_disablepictureinpicture
    ///
    /// Whether a page called called HTMLVideoElement.disablePictureInPicture. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_disablepictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2241,
            "use.counter.page",
            "htmlvideoelement_disablepictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_onenterpictureinpicture
    ///
    /// Whether a page called called HTMLVideoElement.onenterpictureinpicture. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_onenterpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2242,
            "use.counter.page",
            "htmlvideoelement_onenterpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_onleavepictureinpicture
    ///
    /// Whether a page called called HTMLVideoElement.onleavepictureinpicture. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_onleavepictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2243,
            "use.counter.page",
            "htmlvideoelement_onleavepictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_playsinline
    ///
    /// Whether a page called called HTMLVideoElement.playsInline. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmlvideoelement_playsinline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2244,
            "use.counter.page",
            "htmlvideoelement_playsinline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_requestpictureinpicture
    ///
    /// Whether a page called called HTMLVideoElement.requestPictureInPicture. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static htmlvideoelement_requestpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2245,
            "use.counter.page",
            "htmlvideoelement_requestpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmlvideoelement_requestvideoframecallback
    ///
    /// Whether a page called called HTMLVideoElement.requestVideoFrameCallback.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static htmlvideoelement_requestvideoframecallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2246,
            "use.counter.page",
            "htmlvideoelement_requestvideoframecallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.imagedata_colorspace
    ///
    /// Whether a page called called ImageData.colorSpace. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static imagedata_colorspace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2247,
            "use.counter.page",
            "imagedata_colorspace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_asmjs
    ///
    /// Whether a page uses asm.js. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_asmjs: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2248,
            "use.counter.page",
            "js_asmjs",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_subclassing_array_type_2
    ///
    /// Whether a page Array is Type II subclassed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_array_type_2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2249,
            "use.counter.page",
            "js_subclassing_array_type_2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_subclassing_array_type_3
    ///
    /// Whether a page Array is Type III subclassed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_array_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2250,
            "use.counter.page",
            "js_subclassing_array_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_subclassing_arraybuffer_type_3
    ///
    /// Whether a page ArrayBuffer is Type III subclassed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_arraybuffer_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2251,
            "use.counter.page",
            "js_subclassing_arraybuffer_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_subclassing_promise_type_2
    ///
    /// Whether a page Promise is Type II subclassed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_promise_type_2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2252,
            "use.counter.page",
            "js_subclassing_promise_type_2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_subclassing_promise_type_3
    ///
    /// Whether a page Promise is Type III subclassed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_promise_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2253,
            "use.counter.page",
            "js_subclassing_promise_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_subclassing_regexp_type_3
    ///
    /// Whether a page RegExp is Type III subclassed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_regexp_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2254,
            "use.counter.page",
            "js_subclassing_regexp_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_subclassing_regexp_type_4
    ///
    /// Whether a page RegExp is Type IV subclassed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_regexp_type_4: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2255,
            "use.counter.page",
            "js_subclassing_regexp_type_4",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_subclassing_sharedarraybuffer_type_3
    ///
    /// Whether a page SharedArrayBuffer is Type III subclassed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_sharedarraybuffer_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2256,
            "use.counter.page",
            "js_subclassing_sharedarraybuffer_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_subclassing_typedarray_type_2
    ///
    /// Whether a page TypedArray is Type II subclassed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_typedarray_type_2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2257,
            "use.counter.page",
            "js_subclassing_typedarray_type_2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_subclassing_typedarray_type_3
    ///
    /// Whether a page TypedArray is Type III subclassed. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_subclassing_typedarray_type_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2258,
            "use.counter.page",
            "js_subclassing_typedarray_type_3",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_wasm
    ///
    /// Whether a page uses WebAssembly. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_wasm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2259,
            "use.counter.page",
            "js_wasm",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_wasm_legacy_exceptions
    ///
    /// Whether a page uses WebAssembly legacy exception-handling. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_wasm_legacy_exceptions: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2260,
            "use.counter.page",
            "js_wasm_legacy_exceptions",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.location_ancestororigins
    ///
    /// Whether a page called called Location.ancestorOrigins. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static location_ancestororigins: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2261,
            "use.counter.page",
            "location_ancestororigins",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mediadevices_enumeratedevices
    ///
    /// Whether a page called called MediaDevices.enumerateDevices. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mediadevices_enumeratedevices: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2262,
            "use.counter.page",
            "mediadevices_enumeratedevices",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mediadevices_getdisplaymedia
    ///
    /// Whether a page called called MediaDevices.getDisplayMedia. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getdisplaymedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2263,
            "use.counter.page",
            "mediadevices_getdisplaymedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mediadevices_getusermedia
    ///
    /// Whether a page called called MediaDevices.getUserMedia. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2264,
            "use.counter.page",
            "mediadevices_getusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_audio_failure
    ///
    /// Whether a page includes a mixed content audio element that does not load..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_not_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2265,
            "use.counter.page",
            "mixed_content_not_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_audio_success
    ///
    /// Whether a page includes a mixed content audio element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2266,
            "use.counter.page",
            "mixed_content_not_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_image_failure
    ///
    /// Whether a page includes a mixed content img element that does not load..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_not_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2267,
            "use.counter.page",
            "mixed_content_not_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_image_success
    ///
    /// Whether a page includes a mixed content img element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2268,
            "use.counter.page",
            "mixed_content_not_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_video_failure
    ///
    /// Whether a page includes a mixed content video element that does not laod..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_not_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2269,
            "use.counter.page",
            "mixed_content_not_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_video_success
    ///
    /// Whether a page includes a mixed content video element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_not_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2270,
            "use.counter.page",
            "mixed_content_not_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_audio_failure
    ///
    /// Whether a page includes a mixed content audio element that does not load..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2271,
            "use.counter.page",
            "mixed_content_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_audio_success
    ///
    /// Whether a page includes a mixed content audio element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2272,
            "use.counter.page",
            "mixed_content_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_image_failure
    ///
    /// Whether a page includes a mixed content img element that does not load..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2273,
            "use.counter.page",
            "mixed_content_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_image_success
    ///
    /// Whether a page includes a mixed content img element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2274,
            "use.counter.page",
            "mixed_content_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_video_failure
    ///
    /// Whether a page includes a mixed content video element that does not laod..
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static mixed_content_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2275,
            "use.counter.page",
            "mixed_content_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_video_success
    ///
    /// Whether a page includes a mixed content video element that loads.. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static mixed_content_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2276,
            "use.counter.page",
            "mixed_content_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.moz_get_user_media_insec
    ///
    /// Whether a page calls Navigator.mozGetUserMedia from an insecure context.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static moz_get_user_media_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2277,
            "use.counter.page",
            "moz_get_user_media_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_canshare
    ///
    /// Whether a page called called Navigator.canShare. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_canshare: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2278,
            "use.counter.page",
            "navigator_canshare",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_clearappbadge
    ///
    /// Whether a page called called Navigator.clearAppBadge. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_clearappbadge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2279,
            "use.counter.page",
            "navigator_clearappbadge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_mozgetusermedia
    ///
    /// Whether a page called called Navigator.mozGetUserMedia. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_mozgetusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2280,
            "use.counter.page",
            "navigator_mozgetusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_setappbadge
    ///
    /// Whether a page called called Navigator.setAppBadge. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_setappbadge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2281,
            "use.counter.page",
            "navigator_setappbadge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_share
    ///
    /// Whether a page called called Navigator.share. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_share: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2282,
            "use.counter.page",
            "navigator_share",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_useractivation
    ///
    /// Whether a page called called Navigator.userActivation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_useractivation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2283,
            "use.counter.page",
            "navigator_useractivation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_wakelock
    ///
    /// Whether a page called called Navigator.wakeLock. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_wakelock: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2284,
            "use.counter.page",
            "navigator_wakelock",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.ondommousescroll
    ///
    /// Whether a page sets DOMMouseScroll event listener. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static ondommousescroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2285,
            "use.counter.page",
            "ondommousescroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.onmozmousepixelscroll
    ///
    /// Whether a page sets MozMousePixelScroll event listener. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static onmozmousepixelscroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2286,
            "use.counter.page",
            "onmozmousepixelscroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.onoverflow
    ///
    /// Whether a page sets an element onoverflow event listener. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static onoverflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2287,
            "use.counter.page",
            "onoverflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.onunderflow
    ///
    /// Whether a page sets an element onunderflow event listener. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static onunderflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2288,
            "use.counter.page",
            "onunderflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.percentage_stroke_width_in_svg
    ///
    /// Whether a page whether percentage stroke-width is used in SVG elements
    /// (excluding <text>). Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static percentage_stroke_width_in_svg: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2289,
            "use.counter.page",
            "percentage_stroke_width_in_svg",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.percentage_stroke_width_in_svgtext
    ///
    /// Whether a page whether percentage stroke-width is used in SVG <text>. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static percentage_stroke_width_in_svgtext: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2290,
            "use.counter.page",
            "percentage_stroke_width_in_svgtext",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_delete
    ///
    /// Whether a page calls caches.delete in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2291,
            "use.counter.page",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_has
    ///
    /// Whether a page calls caches.has in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2292,
            "use.counter.page",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_keys
    ///
    /// Whether a page calls caches.keys in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2293,
            "use.counter.page",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_match
    ///
    /// Whether a page calls caches.match in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2294,
            "use.counter.page",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_open
    ///
    /// Whether a page calls caches.open in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2295,
            "use.counter.page",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_idbfactory_delete_database
    ///
    /// Whether a page calls indexedDB.deleteDatabase in Private Browsing Mode. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2296,
            "use.counter.page",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_idbfactory_open
    ///
    /// Whether a page calls indexedDB.open in Private Browsing Mode. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2297,
            "use.counter.page",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_navigator_service_worker
    ///
    /// Whether a page accesses navigator.serviceWorker in Private Browsing Mode.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static private_browsing_navigator_service_worker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2298,
            "use.counter.page",
            "private_browsing_navigator_service_worker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.pushmanager_subscribe
    ///
    /// Whether a page called called PushManager.subscribe. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2299,
            "use.counter.page",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.pushsubscription_unsubscribe
    ///
    /// Whether a page called called PushSubscription.unsubscribe. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2300,
            "use.counter.page",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.range_createcontextualfragment
    ///
    /// Whether a page called called Range.createContextualFragment. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static range_createcontextualfragment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2301,
            "use.counter.page",
            "range_createcontextualfragment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.sanitizer_constructor
    ///
    /// Whether a page called called Sanitizer.constructor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static sanitizer_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2302,
            "use.counter.page",
            "sanitizer_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.sanitizer_sanitize
    ///
    /// Whether a page called called Sanitizer.sanitize. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static sanitizer_sanitize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2303,
            "use.counter.page",
            "sanitizer_sanitize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.scheduler_posttask
    ///
    /// Whether a page called called Scheduler.postTask. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2304,
            "use.counter.page",
            "scheduler_posttask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.shadowroot_pictureinpictureelement
    ///
    /// Whether a page called called ShadowRoot.pictureInPictureElement. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static shadowroot_pictureinpictureelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2305,
            "use.counter.page",
            "shadowroot_pictureinpictureelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.svgsvgelement_currentscale_getter
    ///
    /// Whether a page got SVGSVGElement.currentScale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2306,
            "use.counter.page",
            "svgsvgelement_currentscale_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.svgsvgelement_currentscale_setter
    ///
    /// Whether a page set SVGSVGElement.currentScale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2307,
            "use.counter.page",
            "svgsvgelement_currentscale_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.svgsvgelement_getelementbyid
    ///
    /// Whether a page called called SVGSVGElement.getElementById. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_getelementbyid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2308,
            "use.counter.page",
            "svgsvgelement_getelementbyid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_absoluteorientationsensor
    ///
    /// Whether a page called called Window.AbsoluteOrientationSensor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_absoluteorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2309,
            "use.counter.page",
            "window_absoluteorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_accelerometer
    ///
    /// Whether a page called called Window.Accelerometer. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_accelerometer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2310,
            "use.counter.page",
            "window_accelerometer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_backgroundfetchmanager
    ///
    /// Whether a page called called Window.BackgroundFetchManager. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2311,
            "use.counter.page",
            "window_backgroundfetchmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_backgroundfetchrecord
    ///
    /// Whether a page called called Window.BackgroundFetchRecord. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchrecord: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2312,
            "use.counter.page",
            "window_backgroundfetchrecord",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_backgroundfetchregistration
    ///
    /// Whether a page called called Window.BackgroundFetchRegistration. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_backgroundfetchregistration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2313,
            "use.counter.page",
            "window_backgroundfetchregistration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_beforeinstallpromptevent
    ///
    /// Whether a page called called Window.BeforeInstallPromptEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_beforeinstallpromptevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2314,
            "use.counter.page",
            "window_beforeinstallpromptevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetooth
    ///
    /// Whether a page called called Window.Bluetooth. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetooth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2315,
            "use.counter.page",
            "window_bluetooth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothcharacteristicproperties
    ///
    /// Whether a page called called Window.BluetoothCharacteristicProperties. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_bluetoothcharacteristicproperties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2316,
            "use.counter.page",
            "window_bluetoothcharacteristicproperties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothdevice
    ///
    /// Whether a page called called Window.BluetoothDevice. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2317,
            "use.counter.page",
            "window_bluetoothdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattcharacteristic
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTCharacteristic. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_bluetoothremotegattcharacteristic: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2318,
            "use.counter.page",
            "window_bluetoothremotegattcharacteristic",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattdescriptor
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTDescriptor. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_bluetoothremotegattdescriptor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2319,
            "use.counter.page",
            "window_bluetoothremotegattdescriptor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattserver
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTServer. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2320,
            "use.counter.page",
            "window_bluetoothremotegattserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattservice
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTService. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattservice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2321,
            "use.counter.page",
            "window_bluetoothremotegattservice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothuuid
    ///
    /// Whether a page called called Window.BluetoothUUID. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothuuid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2322,
            "use.counter.page",
            "window_bluetoothuuid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_canvascapturemediastreamtrack
    ///
    /// Whether a page called called Window.CanvasCaptureMediaStreamTrack. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_canvascapturemediastreamtrack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2323,
            "use.counter.page",
            "window_canvascapturemediastreamtrack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_chrome
    ///
    /// Whether a page called called Window.chrome. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_chrome: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2324,
            "use.counter.page",
            "window_chrome",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_clipboarditem
    ///
    /// Whether a page called called Window.ClipboardItem. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_clipboarditem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2325,
            "use.counter.page",
            "window_clipboarditem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssimagevalue
    ///
    /// Whether a page called called Window.CSSImageValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssimagevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2326,
            "use.counter.page",
            "window_cssimagevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csskeywordvalue
    ///
    /// Whether a page called called Window.CSSKeywordValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csskeywordvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2327,
            "use.counter.page",
            "window_csskeywordvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathclamp
    ///
    /// Whether a page called called Window.CSSMathClamp. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathclamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2328,
            "use.counter.page",
            "window_cssmathclamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathinvert
    ///
    /// Whether a page called called Window.CSSMathInvert. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathinvert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2329,
            "use.counter.page",
            "window_cssmathinvert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathmax
    ///
    /// Whether a page called called Window.CSSMathMax. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmax: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2330,
            "use.counter.page",
            "window_cssmathmax",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathmin
    ///
    /// Whether a page called called Window.CSSMathMin. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2331,
            "use.counter.page",
            "window_cssmathmin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathnegate
    ///
    /// Whether a page called called Window.CSSMathNegate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathnegate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2332,
            "use.counter.page",
            "window_cssmathnegate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathproduct
    ///
    /// Whether a page called called Window.CSSMathProduct. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathproduct: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2333,
            "use.counter.page",
            "window_cssmathproduct",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathsum
    ///
    /// Whether a page called called Window.CSSMathSum. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathsum: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2334,
            "use.counter.page",
            "window_cssmathsum",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathvalue
    ///
    /// Whether a page called called Window.CSSMathValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2335,
            "use.counter.page",
            "window_cssmathvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmatrixcomponent
    ///
    /// Whether a page called called Window.CSSMatrixComponent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmatrixcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2336,
            "use.counter.page",
            "window_cssmatrixcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssnumericarray
    ///
    /// Whether a page called called Window.CSSNumericArray. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericarray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2337,
            "use.counter.page",
            "window_cssnumericarray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssnumericvalue
    ///
    /// Whether a page called called Window.CSSNumericValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2338,
            "use.counter.page",
            "window_cssnumericvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssperspective
    ///
    /// Whether a page called called Window.CSSPerspective. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssperspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2339,
            "use.counter.page",
            "window_cssperspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csspositionvalue
    ///
    /// Whether a page called called Window.CSSPositionValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csspositionvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2340,
            "use.counter.page",
            "window_csspositionvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csspropertyrule
    ///
    /// Whether a page called called Window.CSSPropertyRule. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csspropertyrule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2341,
            "use.counter.page",
            "window_csspropertyrule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssrotate
    ///
    /// Whether a page called called Window.CSSRotate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssrotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2342,
            "use.counter.page",
            "window_cssrotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssscale
    ///
    /// Whether a page called called Window.CSSScale. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssscale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2343,
            "use.counter.page",
            "window_cssscale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssskew
    ///
    /// Whether a page called called Window.CSSSkew. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssskew: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2344,
            "use.counter.page",
            "window_cssskew",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssskewx
    ///
    /// Whether a page called called Window.CSSSkewX. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssskewx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2345,
            "use.counter.page",
            "window_cssskewx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssskewy
    ///
    /// Whether a page called called Window.CSSSkewY. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssskewy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2346,
            "use.counter.page",
            "window_cssskewy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssstylevalue
    ///
    /// Whether a page called called Window.CSSStyleValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssstylevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2347,
            "use.counter.page",
            "window_cssstylevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csstransformcomponent
    ///
    /// Whether a page called called Window.CSSTransformComponent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csstransformcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2348,
            "use.counter.page",
            "window_csstransformcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csstransformvalue
    ///
    /// Whether a page called called Window.CSSTransformValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csstransformvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2349,
            "use.counter.page",
            "window_csstransformvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csstranslate
    ///
    /// Whether a page called called Window.CSSTranslate. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csstranslate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2350,
            "use.counter.page",
            "window_csstranslate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssunitvalue
    ///
    /// Whether a page called called Window.CSSUnitValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssunitvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2351,
            "use.counter.page",
            "window_cssunitvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssunparsedvalue
    ///
    /// Whether a page called called Window.CSSUnparsedValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssunparsedvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2352,
            "use.counter.page",
            "window_cssunparsedvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssvariablereferencevalue
    ///
    /// Whether a page called called Window.CSSVariableReferenceValue. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssvariablereferencevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2353,
            "use.counter.page",
            "window_cssvariablereferencevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_defaultstatus
    ///
    /// Whether a page called called Window.defaultStatus. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_defaultstatus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2354,
            "use.counter.page",
            "window_defaultstatus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_devicemotioneventacceleration
    ///
    /// Whether a page called called Window.DeviceMotionEventAcceleration. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_devicemotioneventacceleration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2355,
            "use.counter.page",
            "window_devicemotioneventacceleration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_devicemotioneventrotationrate
    ///
    /// Whether a page called called Window.DeviceMotionEventRotationRate. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_devicemotioneventrotationrate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2356,
            "use.counter.page",
            "window_devicemotioneventrotationrate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_domerror
    ///
    /// Whether a page called called Window.DOMError. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_domerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2357,
            "use.counter.page",
            "window_domerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_encodedvideochunk
    ///
    /// Whether a page called called Window.EncodedVideoChunk. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_encodedvideochunk: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2358,
            "use.counter.page",
            "window_encodedvideochunk",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_enterpictureinpictureevent
    ///
    /// Whether a page called called Window.EnterPictureInPictureEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_enterpictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2359,
            "use.counter.page",
            "window_enterpictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_external
    ///
    /// Whether a page called called Window.External. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2360,
            "use.counter.page",
            "window_external",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_federatedcredential
    ///
    /// Whether a page called called Window.FederatedCredential. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_federatedcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2361,
            "use.counter.page",
            "window_federatedcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_gyroscope
    ///
    /// Whether a page called called Window.Gyroscope. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_gyroscope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2362,
            "use.counter.page",
            "window_gyroscope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_htmlcontentelement
    ///
    /// Whether a page called called Window.HTMLContentElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_htmlcontentelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2363,
            "use.counter.page",
            "window_htmlcontentelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_htmlshadowelement
    ///
    /// Whether a page called called Window.HTMLShadowElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_htmlshadowelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2364,
            "use.counter.page",
            "window_htmlshadowelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_imagecapture
    ///
    /// Whether a page called called Window.ImageCapture. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_imagecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2365,
            "use.counter.page",
            "window_imagecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_inputdevicecapabilities
    ///
    /// Whether a page called called Window.InputDeviceCapabilities. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_inputdevicecapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2366,
            "use.counter.page",
            "window_inputdevicecapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_inputdeviceinfo
    ///
    /// Whether a page called called Window.InputDeviceInfo. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_inputdeviceinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2367,
            "use.counter.page",
            "window_inputdeviceinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_keyboard
    ///
    /// Whether a page called called Window.Keyboard. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_keyboard: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2368,
            "use.counter.page",
            "window_keyboard",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_keyboardlayoutmap
    ///
    /// Whether a page called called Window.KeyboardLayoutMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_keyboardlayoutmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2369,
            "use.counter.page",
            "window_keyboardlayoutmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_linearaccelerationsensor
    ///
    /// Whether a page called called Window.LinearAccelerationSensor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_linearaccelerationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2370,
            "use.counter.page",
            "window_linearaccelerationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_mediasettingsrange
    ///
    /// Whether a page called called Window.MediaSettingsRange. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_mediasettingsrange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2371,
            "use.counter.page",
            "window_mediasettingsrange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiaccess
    ///
    /// Whether a page called called Window.MIDIAccess. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiaccess: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2372,
            "use.counter.page",
            "window_midiaccess",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiconnectionevent
    ///
    /// Whether a page called called Window.MIDIConnectionEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2373,
            "use.counter.page",
            "window_midiconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiinput
    ///
    /// Whether a page called called Window.MIDIInput. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiinput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2374,
            "use.counter.page",
            "window_midiinput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiinputmap
    ///
    /// Whether a page called called Window.MIDIInputMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiinputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2375,
            "use.counter.page",
            "window_midiinputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midimessageevent
    ///
    /// Whether a page called called Window.MIDIMessageEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midimessageevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2376,
            "use.counter.page",
            "window_midimessageevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midioutput
    ///
    /// Whether a page called called Window.MIDIOutput. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midioutput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2377,
            "use.counter.page",
            "window_midioutput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midioutputmap
    ///
    /// Whether a page called called Window.MIDIOutputMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midioutputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2378,
            "use.counter.page",
            "window_midioutputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiport
    ///
    /// Whether a page called called Window.MIDIPort. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2379,
            "use.counter.page",
            "window_midiport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_networkinformation
    ///
    /// Whether a page called called Window.NetworkInformation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_networkinformation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2380,
            "use.counter.page",
            "window_networkinformation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_offscreenbuffering
    ///
    /// Whether a page called called Window.offscreenBuffering. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_offscreenbuffering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2381,
            "use.counter.page",
            "window_offscreenbuffering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onbeforeinstallprompt
    ///
    /// Whether a page called called Window.onbeforeinstallprompt. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onbeforeinstallprompt: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2382,
            "use.counter.page",
            "window_onbeforeinstallprompt",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_oncancel
    ///
    /// Whether a page called called Window.oncancel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2383,
            "use.counter.page",
            "window_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onmousewheel
    ///
    /// Whether a page called called Window.onmousewheel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2384,
            "use.counter.page",
            "window_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onorientationchange
    ///
    /// Whether a page called called Window.onorientationchange. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onorientationchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2385,
            "use.counter.page",
            "window_onorientationchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onsearch
    ///
    /// Whether a page called called Window.onsearch. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2386,
            "use.counter.page",
            "window_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onselectionchange
    ///
    /// Whether a page called called Window.onselectionchange. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onselectionchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2387,
            "use.counter.page",
            "window_onselectionchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_open_empty_url
    ///
    /// Whether a page calls window.open with an empty url argument. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_open_empty_url: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2388,
            "use.counter.page",
            "window_open_empty_url",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_opendatabase
    ///
    /// Whether a page called called Window.openDatabase. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_opendatabase: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2389,
            "use.counter.page",
            "window_opendatabase",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_orientation
    ///
    /// Whether a page called called Window.orientation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2390,
            "use.counter.page",
            "window_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_orientationsensor
    ///
    /// Whether a page called called Window.OrientationSensor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_orientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2391,
            "use.counter.page",
            "window_orientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_overconstrainederror
    ///
    /// Whether a page called called Window.OverconstrainedError. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_overconstrainederror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2392,
            "use.counter.page",
            "window_overconstrainederror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_passwordcredential
    ///
    /// Whether a page called called Window.PasswordCredential. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_passwordcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2393,
            "use.counter.page",
            "window_passwordcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentaddress
    ///
    /// Whether a page called called Window.PaymentAddress. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentaddress: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2394,
            "use.counter.page",
            "window_paymentaddress",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentinstruments
    ///
    /// Whether a page called called Window.PaymentInstruments. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentinstruments: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2395,
            "use.counter.page",
            "window_paymentinstruments",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentmanager
    ///
    /// Whether a page called called Window.PaymentManager. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2396,
            "use.counter.page",
            "window_paymentmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentmethodchangeevent
    ///
    /// Whether a page called called Window.PaymentMethodChangeEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentmethodchangeevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2397,
            "use.counter.page",
            "window_paymentmethodchangeevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentrequest
    ///
    /// Whether a page called called Window.PaymentRequest. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2398,
            "use.counter.page",
            "window_paymentrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentrequestupdateevent
    ///
    /// Whether a page called called Window.PaymentRequestUpdateEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequestupdateevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2399,
            "use.counter.page",
            "window_paymentrequestupdateevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentresponse
    ///
    /// Whether a page called called Window.PaymentResponse. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentresponse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2400,
            "use.counter.page",
            "window_paymentresponse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_performancelongtasktiming
    ///
    /// Whether a page called called Window.PerformanceLongTaskTiming. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_performancelongtasktiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2401,
            "use.counter.page",
            "window_performancelongtasktiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_photocapabilities
    ///
    /// Whether a page called called Window.PhotoCapabilities. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_photocapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2402,
            "use.counter.page",
            "window_photocapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_pictureinpictureevent
    ///
    /// Whether a page called called Window.PictureInPictureEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2403,
            "use.counter.page",
            "window_pictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_pictureinpicturewindow
    ///
    /// Whether a page called called Window.PictureInPictureWindow. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpicturewindow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2404,
            "use.counter.page",
            "window_pictureinpicturewindow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentation
    ///
    /// Whether a page called called Window.Presentation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2405,
            "use.counter.page",
            "window_presentation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationavailability
    ///
    /// Whether a page called called Window.PresentationAvailability. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationavailability: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2406,
            "use.counter.page",
            "window_presentationavailability",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnection
    ///
    /// Whether a page called called Window.PresentationConnection. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2407,
            "use.counter.page",
            "window_presentationconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnectionavailableevent
    ///
    /// Whether a page called called Window.PresentationConnectionAvailableEvent.
    /// Compare against `use.counter.top_level_content_documents_destroyed` to
    /// calculate the rate.
    pub static window_presentationconnectionavailableevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2408,
            "use.counter.page",
            "window_presentationconnectionavailableevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnectioncloseevent
    ///
    /// Whether a page called called Window.PresentationConnectionCloseEvent. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_presentationconnectioncloseevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2409,
            "use.counter.page",
            "window_presentationconnectioncloseevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnectionlist
    ///
    /// Whether a page called called Window.PresentationConnectionList. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnectionlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2410,
            "use.counter.page",
            "window_presentationconnectionlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationreceiver
    ///
    /// Whether a page called called Window.PresentationReceiver. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationreceiver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2411,
            "use.counter.page",
            "window_presentationreceiver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationrequest
    ///
    /// Whether a page called called Window.PresentationRequest. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2412,
            "use.counter.page",
            "window_presentationrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_relativeorientationsensor
    ///
    /// Whether a page called called Window.RelativeOrientationSensor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_relativeorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2413,
            "use.counter.page",
            "window_relativeorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_remoteplayback
    ///
    /// Whether a page called called Window.RemotePlayback. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_remoteplayback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2414,
            "use.counter.page",
            "window_remoteplayback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_report
    ///
    /// Whether a page called called Window.Report. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_report: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2415,
            "use.counter.page",
            "window_report",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_reportbody
    ///
    /// Whether a page called called Window.ReportBody. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_reportbody: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2416,
            "use.counter.page",
            "window_reportbody",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_reportingobserver
    ///
    /// Whether a page called called Window.ReportingObserver. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_reportingobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2417,
            "use.counter.page",
            "window_reportingobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcerror
    ///
    /// Whether a page called called Window.RTCError. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_rtcerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2418,
            "use.counter.page",
            "window_rtcerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcerrorevent
    ///
    /// Whether a page called called Window.RTCErrorEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_rtcerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2419,
            "use.counter.page",
            "window_rtcerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcicetransport
    ///
    /// Whether a page called called Window.RTCIceTransport. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_rtcicetransport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2420,
            "use.counter.page",
            "window_rtcicetransport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcpeerconnectioniceerrorevent
    ///
    /// Whether a page called called Window.RTCPeerConnectionIceErrorEvent. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_rtcpeerconnectioniceerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2421,
            "use.counter.page",
            "window_rtcpeerconnectioniceerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sensor
    ///
    /// Whether a page called called Window.Sensor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2422,
            "use.counter.page",
            "window_sensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sensorerrorevent
    ///
    /// Whether a page called called Window.SensorErrorEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sensorerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2423,
            "use.counter.page",
            "window_sensorerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sidebar_getter
    ///
    /// Whether a page got Window.sidebar. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2424,
            "use.counter.page",
            "window_sidebar_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sidebar_setter
    ///
    /// Whether a page set Window.sidebar. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2425,
            "use.counter.page",
            "window_sidebar_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_speechrecognitionalternative
    ///
    /// Whether a page called called Window.SpeechRecognitionAlternative. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_speechrecognitionalternative: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2426,
            "use.counter.page",
            "window_speechrecognitionalternative",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_speechrecognitionresult
    ///
    /// Whether a page called called Window.SpeechRecognitionResult. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2427,
            "use.counter.page",
            "window_speechrecognitionresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_speechrecognitionresultlist
    ///
    /// Whether a page called called Window.SpeechRecognitionResultList. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_speechrecognitionresultlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2428,
            "use.counter.page",
            "window_speechrecognitionresultlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_stylemedia
    ///
    /// Whether a page called called Window.styleMedia. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_stylemedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2429,
            "use.counter.page",
            "window_stylemedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_stylepropertymap
    ///
    /// Whether a page called called Window.StylePropertyMap. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2430,
            "use.counter.page",
            "window_stylepropertymap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_stylepropertymapreadonly
    ///
    /// Whether a page called called Window.StylePropertyMapReadOnly. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymapreadonly: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2431,
            "use.counter.page",
            "window_stylepropertymapreadonly",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_svgdiscardelement
    ///
    /// Whether a page called called Window.SVGDiscardElement. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_svgdiscardelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2432,
            "use.counter.page",
            "window_svgdiscardelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_syncmanager
    ///
    /// Whether a page called called Window.SyncManager. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_syncmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2433,
            "use.counter.page",
            "window_syncmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_taskattributiontiming
    ///
    /// Whether a page called called Window.TaskAttributionTiming. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_taskattributiontiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2434,
            "use.counter.page",
            "window_taskattributiontiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_textevent
    ///
    /// Whether a page called called Window.TextEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_textevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2435,
            "use.counter.page",
            "window_textevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_touch
    ///
    /// Whether a page called called Window.Touch. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_touch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2436,
            "use.counter.page",
            "window_touch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_touchevent
    ///
    /// Whether a page called called Window.TouchEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_touchevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2437,
            "use.counter.page",
            "window_touchevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_touchlist
    ///
    /// Whether a page called called Window.TouchList. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_touchlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2438,
            "use.counter.page",
            "window_touchlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usb
    ///
    /// Whether a page called called Window.USB. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usb: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2439,
            "use.counter.page",
            "window_usb",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbalternateinterface
    ///
    /// Whether a page called called Window.USBAlternateInterface. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbalternateinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2440,
            "use.counter.page",
            "window_usbalternateinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbconfiguration
    ///
    /// Whether a page called called Window.USBConfiguration. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbconfiguration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2441,
            "use.counter.page",
            "window_usbconfiguration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbconnectionevent
    ///
    /// Whether a page called called Window.USBConnectionEvent. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2442,
            "use.counter.page",
            "window_usbconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbdevice
    ///
    /// Whether a page called called Window.USBDevice. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2443,
            "use.counter.page",
            "window_usbdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbendpoint
    ///
    /// Whether a page called called Window.USBEndpoint. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbendpoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2444,
            "use.counter.page",
            "window_usbendpoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbinterface
    ///
    /// Whether a page called called Window.USBInterface. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2445,
            "use.counter.page",
            "window_usbinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbintransferresult
    ///
    /// Whether a page called called Window.USBInTransferResult. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2446,
            "use.counter.page",
            "window_usbintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousintransferpacket
    ///
    /// Whether a page called called Window.USBIsochronousInTransferPacket. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousintransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2447,
            "use.counter.page",
            "window_usbisochronousintransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousintransferresult
    ///
    /// Whether a page called called Window.USBIsochronousInTransferResult. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2448,
            "use.counter.page",
            "window_usbisochronousintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousouttransferpacket
    ///
    /// Whether a page called called Window.USBIsochronousOutTransferPacket. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousouttransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2449,
            "use.counter.page",
            "window_usbisochronousouttransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousouttransferresult
    ///
    /// Whether a page called called Window.USBIsochronousOutTransferResult. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_usbisochronousouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2450,
            "use.counter.page",
            "window_usbisochronousouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbouttransferresult
    ///
    /// Whether a page called called Window.USBOutTransferResult. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2451,
            "use.counter.page",
            "window_usbouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_useractivation
    ///
    /// Whether a page called called Window.UserActivation. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_useractivation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2452,
            "use.counter.page",
            "window_useractivation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videocolorspace
    ///
    /// Whether a page called called Window.VideoColorSpace. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videocolorspace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2453,
            "use.counter.page",
            "window_videocolorspace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videodecoder
    ///
    /// Whether a page called called Window.VideoDecoder. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videodecoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2454,
            "use.counter.page",
            "window_videodecoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videoencoder
    ///
    /// Whether a page called called Window.VideoEncoder. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videoencoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2455,
            "use.counter.page",
            "window_videoencoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videoframe
    ///
    /// Whether a page called called Window.VideoFrame. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videoframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2456,
            "use.counter.page",
            "window_videoframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_wakelock
    ///
    /// Whether a page called called Window.WakeLock. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_wakelock: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2457,
            "use.counter.page",
            "window_wakelock",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_wakelocksentinel
    ///
    /// Whether a page called called Window.WakeLockSentinel. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_wakelocksentinel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2458,
            "use.counter.page",
            "window_wakelocksentinel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitcancelanimationframe
    ///
    /// Whether a page called called Window.webkitCancelAnimationFrame. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitcancelanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2459,
            "use.counter.page",
            "window_webkitcancelanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitmediastream
    ///
    /// Whether a page called called Window.webkitMediaStream. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitmediastream: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2460,
            "use.counter.page",
            "window_webkitmediastream",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitmutationobserver
    ///
    /// Whether a page called called Window.WebKitMutationObserver. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitmutationobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2461,
            "use.counter.page",
            "window_webkitmutationobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitrequestanimationframe
    ///
    /// Whether a page called called Window.webkitRequestAnimationFrame. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_webkitrequestanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2462,
            "use.counter.page",
            "window_webkitrequestanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitrequestfilesystem
    ///
    /// Whether a page called called Window.webkitRequestFileSystem. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitrequestfilesystem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2463,
            "use.counter.page",
            "window_webkitrequestfilesystem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitresolvelocalfilesystemurl
    ///
    /// Whether a page called called Window.webkitResolveLocalFileSystemURL. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_webkitresolvelocalfilesystemurl: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2464,
            "use.counter.page",
            "window_webkitresolvelocalfilesystemurl",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitrtcpeerconnection
    ///
    /// Whether a page called called Window.webkitRTCPeerConnection. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitrtcpeerconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2465,
            "use.counter.page",
            "window_webkitrtcpeerconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechgrammar
    ///
    /// Whether a page called called Window.webkitSpeechGrammar. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammar: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2466,
            "use.counter.page",
            "window_webkitspeechgrammar",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechgrammarlist
    ///
    /// Whether a page called called Window.webkitSpeechGrammarList. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammarlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2467,
            "use.counter.page",
            "window_webkitspeechgrammarlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechrecognition
    ///
    /// Whether a page called called Window.webkitSpeechRecognition. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2468,
            "use.counter.page",
            "window_webkitspeechrecognition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechrecognitionerror
    ///
    /// Whether a page called called Window.webkitSpeechRecognitionError. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_webkitspeechrecognitionerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2469,
            "use.counter.page",
            "window_webkitspeechrecognitionerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechrecognitionevent
    ///
    /// Whether a page called called Window.webkitSpeechRecognitionEvent. Compare
    /// against `use.counter.top_level_content_documents_destroyed` to calculate the
    /// rate.
    pub static window_webkitspeechrecognitionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2470,
            "use.counter.page",
            "window_webkitspeechrecognitionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitstorageinfo
    ///
    /// Whether a page called called Window.webkitStorageInfo. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitstorageinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2471,
            "use.counter.page",
            "window_webkitstorageinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.workernavigator_permissions
    ///
    /// Whether a page called called WorkerNavigator.permissions. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static workernavigator_permissions: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2472,
            "use.counter.page",
            "workernavigator_permissions",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.wr_filter_fallback
    ///
    /// Whether a page triggers the blob fallback for an SVG filter.. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static wr_filter_fallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2473,
            "use.counter.page",
            "wr_filter_fallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.xslstylesheet
    ///
    /// Whether a page uses an XSL Stylesheet. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static xslstylesheet: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2474,
            "use.counter.page",
            "xslstylesheet",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.xsltprocessor_constructor
    ///
    /// Whether a page called called XSLTProcessor.constructor. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static xsltprocessor_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2475,
            "use.counter.page",
            "xsltprocessor_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.you_tube_flash_embed
    ///
    /// Whether a page in <object> or <embed>. Compare against
    /// `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static you_tube_flash_embed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2476,
            "use.counter.page",
            "you_tube_flash_embed",
            "use-counters"
        )
    });

}
pub mod use_counter_worker_dedicated {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_assert
    ///
    /// Whether a dedicated worker called called console.assert. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2477,
            "use.counter.worker.dedicated",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_clear
    ///
    /// Whether a dedicated worker called called console.clear. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2478,
            "use.counter.worker.dedicated",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_count
    ///
    /// Whether a dedicated worker called called console.count. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2479,
            "use.counter.worker.dedicated",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_countreset
    ///
    /// Whether a dedicated worker called called console.countReset. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2480,
            "use.counter.worker.dedicated",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_debug
    ///
    /// Whether a dedicated worker called called console.debug. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2481,
            "use.counter.worker.dedicated",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_dir
    ///
    /// Whether a dedicated worker called called console.dir. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2482,
            "use.counter.worker.dedicated",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_dirxml
    ///
    /// Whether a dedicated worker called called console.dirxml. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2483,
            "use.counter.worker.dedicated",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_error
    ///
    /// Whether a dedicated worker called called console.error. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2484,
            "use.counter.worker.dedicated",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_exception
    ///
    /// Whether a dedicated worker called called console.exception. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2485,
            "use.counter.worker.dedicated",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_group
    ///
    /// Whether a dedicated worker called called console.group. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2486,
            "use.counter.worker.dedicated",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_groupcollapsed
    ///
    /// Whether a dedicated worker called called console.groupCollapsed. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2487,
            "use.counter.worker.dedicated",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_groupend
    ///
    /// Whether a dedicated worker called called console.groupEnd. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2488,
            "use.counter.worker.dedicated",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_info
    ///
    /// Whether a dedicated worker called called console.info. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2489,
            "use.counter.worker.dedicated",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_log
    ///
    /// Whether a dedicated worker called called console.log. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2490,
            "use.counter.worker.dedicated",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_profile
    ///
    /// Whether a dedicated worker called called console.profile. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2491,
            "use.counter.worker.dedicated",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_profileend
    ///
    /// Whether a dedicated worker called called console.profileEnd. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2492,
            "use.counter.worker.dedicated",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_table
    ///
    /// Whether a dedicated worker called called console.table. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2493,
            "use.counter.worker.dedicated",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_time
    ///
    /// Whether a dedicated worker called called console.time. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2494,
            "use.counter.worker.dedicated",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_timeend
    ///
    /// Whether a dedicated worker called called console.timeEnd. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2495,
            "use.counter.worker.dedicated",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_timelog
    ///
    /// Whether a dedicated worker called called console.timeLog. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2496,
            "use.counter.worker.dedicated",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_timestamp
    ///
    /// Whether a dedicated worker called called console.timeStamp. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2497,
            "use.counter.worker.dedicated",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_trace
    ///
    /// Whether a dedicated worker called called console.trace. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2498,
            "use.counter.worker.dedicated",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_warn
    ///
    /// Whether a dedicated worker called called console.warn. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2499,
            "use.counter.worker.dedicated",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_delete
    ///
    /// Whether a dedicated worker calls caches.delete in Private Browsing Mode.
    /// Compare against `use.counter.dedicated_workers_destroyed` to calculate the
    /// rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2500,
            "use.counter.worker.dedicated",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_has
    ///
    /// Whether a dedicated worker calls caches.has in Private Browsing Mode. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2501,
            "use.counter.worker.dedicated",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_keys
    ///
    /// Whether a dedicated worker calls caches.keys in Private Browsing Mode. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2502,
            "use.counter.worker.dedicated",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_match
    ///
    /// Whether a dedicated worker calls caches.match in Private Browsing Mode. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2503,
            "use.counter.worker.dedicated",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_open
    ///
    /// Whether a dedicated worker calls caches.open in Private Browsing Mode. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2504,
            "use.counter.worker.dedicated",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_idbfactory_delete_database
    ///
    /// Whether a dedicated worker calls indexedDB.deleteDatabase in Private Browsing
    /// Mode. Compare against `use.counter.dedicated_workers_destroyed` to calculate
    /// the rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2505,
            "use.counter.worker.dedicated",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_idbfactory_open
    ///
    /// Whether a dedicated worker calls indexedDB.open in Private Browsing Mode.
    /// Compare against `use.counter.dedicated_workers_destroyed` to calculate the
    /// rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2506,
            "use.counter.worker.dedicated",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.pushmanager_subscribe
    ///
    /// Whether a dedicated worker called called PushManager.subscribe. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2507,
            "use.counter.worker.dedicated",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.pushsubscription_unsubscribe
    ///
    /// Whether a dedicated worker called called PushSubscription.unsubscribe. Compare
    /// against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2508,
            "use.counter.worker.dedicated",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.scheduler_posttask
    ///
    /// Whether a dedicated worker called called Scheduler.postTask. Compare against
    /// `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2509,
            "use.counter.worker.dedicated",
            "scheduler_posttask",
            "use-counters"
        )
    });

}
pub mod use_counter_worker_service {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_assert
    ///
    /// Whether a service worker called called console.assert. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2510,
            "use.counter.worker.service",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_clear
    ///
    /// Whether a service worker called called console.clear. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2511,
            "use.counter.worker.service",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_count
    ///
    /// Whether a service worker called called console.count. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2512,
            "use.counter.worker.service",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_countreset
    ///
    /// Whether a service worker called called console.countReset. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2513,
            "use.counter.worker.service",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_debug
    ///
    /// Whether a service worker called called console.debug. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2514,
            "use.counter.worker.service",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_dir
    ///
    /// Whether a service worker called called console.dir. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2515,
            "use.counter.worker.service",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_dirxml
    ///
    /// Whether a service worker called called console.dirxml. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2516,
            "use.counter.worker.service",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_error
    ///
    /// Whether a service worker called called console.error. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2517,
            "use.counter.worker.service",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_exception
    ///
    /// Whether a service worker called called console.exception. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2518,
            "use.counter.worker.service",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_group
    ///
    /// Whether a service worker called called console.group. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2519,
            "use.counter.worker.service",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_groupcollapsed
    ///
    /// Whether a service worker called called console.groupCollapsed. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2520,
            "use.counter.worker.service",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_groupend
    ///
    /// Whether a service worker called called console.groupEnd. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2521,
            "use.counter.worker.service",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_info
    ///
    /// Whether a service worker called called console.info. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2522,
            "use.counter.worker.service",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_log
    ///
    /// Whether a service worker called called console.log. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2523,
            "use.counter.worker.service",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_profile
    ///
    /// Whether a service worker called called console.profile. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2524,
            "use.counter.worker.service",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_profileend
    ///
    /// Whether a service worker called called console.profileEnd. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2525,
            "use.counter.worker.service",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_table
    ///
    /// Whether a service worker called called console.table. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2526,
            "use.counter.worker.service",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_time
    ///
    /// Whether a service worker called called console.time. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2527,
            "use.counter.worker.service",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_timeend
    ///
    /// Whether a service worker called called console.timeEnd. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2528,
            "use.counter.worker.service",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_timelog
    ///
    /// Whether a service worker called called console.timeLog. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2529,
            "use.counter.worker.service",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_timestamp
    ///
    /// Whether a service worker called called console.timeStamp. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2530,
            "use.counter.worker.service",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_trace
    ///
    /// Whether a service worker called called console.trace. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2531,
            "use.counter.worker.service",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_warn
    ///
    /// Whether a service worker called called console.warn. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2532,
            "use.counter.worker.service",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_delete
    ///
    /// Whether a service worker calls caches.delete in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2533,
            "use.counter.worker.service",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_has
    ///
    /// Whether a service worker calls caches.has in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2534,
            "use.counter.worker.service",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_keys
    ///
    /// Whether a service worker calls caches.keys in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2535,
            "use.counter.worker.service",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_match
    ///
    /// Whether a service worker calls caches.match in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2536,
            "use.counter.worker.service",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_open
    ///
    /// Whether a service worker calls caches.open in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2537,
            "use.counter.worker.service",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_idbfactory_delete_database
    ///
    /// Whether a service worker calls indexedDB.deleteDatabase in Private Browsing
    /// Mode. Compare against `use.counter.service_workers_destroyed` to calculate the
    /// rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2538,
            "use.counter.worker.service",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_idbfactory_open
    ///
    /// Whether a service worker calls indexedDB.open in Private Browsing Mode. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2539,
            "use.counter.worker.service",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.pushmanager_subscribe
    ///
    /// Whether a service worker called called PushManager.subscribe. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2540,
            "use.counter.worker.service",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.pushsubscription_unsubscribe
    ///
    /// Whether a service worker called called PushSubscription.unsubscribe. Compare
    /// against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2541,
            "use.counter.worker.service",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.scheduler_posttask
    ///
    /// Whether a service worker called called Scheduler.postTask. Compare against
    /// `use.counter.service_workers_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2542,
            "use.counter.worker.service",
            "scheduler_posttask",
            "use-counters"
        )
    });

}
pub mod use_counter_worker_shared {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_assert
    ///
    /// Whether a shared worker called called console.assert. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2543,
            "use.counter.worker.shared",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_clear
    ///
    /// Whether a shared worker called called console.clear. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2544,
            "use.counter.worker.shared",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_count
    ///
    /// Whether a shared worker called called console.count. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2545,
            "use.counter.worker.shared",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_countreset
    ///
    /// Whether a shared worker called called console.countReset. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2546,
            "use.counter.worker.shared",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_debug
    ///
    /// Whether a shared worker called called console.debug. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2547,
            "use.counter.worker.shared",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_dir
    ///
    /// Whether a shared worker called called console.dir. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2548,
            "use.counter.worker.shared",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_dirxml
    ///
    /// Whether a shared worker called called console.dirxml. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2549,
            "use.counter.worker.shared",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_error
    ///
    /// Whether a shared worker called called console.error. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2550,
            "use.counter.worker.shared",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_exception
    ///
    /// Whether a shared worker called called console.exception. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2551,
            "use.counter.worker.shared",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_group
    ///
    /// Whether a shared worker called called console.group. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2552,
            "use.counter.worker.shared",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_groupcollapsed
    ///
    /// Whether a shared worker called called console.groupCollapsed. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2553,
            "use.counter.worker.shared",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_groupend
    ///
    /// Whether a shared worker called called console.groupEnd. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2554,
            "use.counter.worker.shared",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_info
    ///
    /// Whether a shared worker called called console.info. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2555,
            "use.counter.worker.shared",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_log
    ///
    /// Whether a shared worker called called console.log. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2556,
            "use.counter.worker.shared",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_profile
    ///
    /// Whether a shared worker called called console.profile. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2557,
            "use.counter.worker.shared",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_profileend
    ///
    /// Whether a shared worker called called console.profileEnd. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2558,
            "use.counter.worker.shared",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_table
    ///
    /// Whether a shared worker called called console.table. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2559,
            "use.counter.worker.shared",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_time
    ///
    /// Whether a shared worker called called console.time. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2560,
            "use.counter.worker.shared",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_timeend
    ///
    /// Whether a shared worker called called console.timeEnd. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2561,
            "use.counter.worker.shared",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_timelog
    ///
    /// Whether a shared worker called called console.timeLog. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2562,
            "use.counter.worker.shared",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_timestamp
    ///
    /// Whether a shared worker called called console.timeStamp. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2563,
            "use.counter.worker.shared",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_trace
    ///
    /// Whether a shared worker called called console.trace. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2564,
            "use.counter.worker.shared",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_warn
    ///
    /// Whether a shared worker called called console.warn. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2565,
            "use.counter.worker.shared",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_delete
    ///
    /// Whether a shared worker calls caches.delete in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2566,
            "use.counter.worker.shared",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_has
    ///
    /// Whether a shared worker calls caches.has in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2567,
            "use.counter.worker.shared",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_keys
    ///
    /// Whether a shared worker calls caches.keys in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2568,
            "use.counter.worker.shared",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_match
    ///
    /// Whether a shared worker calls caches.match in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2569,
            "use.counter.worker.shared",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_open
    ///
    /// Whether a shared worker calls caches.open in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2570,
            "use.counter.worker.shared",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_idbfactory_delete_database
    ///
    /// Whether a shared worker calls indexedDB.deleteDatabase in Private Browsing
    /// Mode. Compare against `use.counter.shared_workers_destroyed` to calculate the
    /// rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2571,
            "use.counter.worker.shared",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_idbfactory_open
    ///
    /// Whether a shared worker calls indexedDB.open in Private Browsing Mode. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2572,
            "use.counter.worker.shared",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.pushmanager_subscribe
    ///
    /// Whether a shared worker called called PushManager.subscribe. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2573,
            "use.counter.worker.shared",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.pushsubscription_unsubscribe
    ///
    /// Whether a shared worker called called PushSubscription.unsubscribe. Compare
    /// against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2574,
            "use.counter.worker.shared",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.scheduler_posttask
    ///
    /// Whether a shared worker called called Scheduler.postTask. Compare against
    /// `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2575,
            "use.counter.worker.shared",
            "scheduler_posttask",
            "use-counters"
        )
    });

}
pub mod geolocation {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from geolocation.accuracy
    ///
    /// Accuracy returned by the Geolocation API
    pub static accuracy: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2576.into(), CommonMetricData {
            name: "accuracy".into(),
            category: "geolocation".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 66355200, 50, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum FallbackLabel {
        ENone = 0,
        EOnError = 1,
        EOnTimeout = 2,
        __Other__,
    }
    impl From<u16> for FallbackLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::EOnError,
                2 => Self::EOnTimeout,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FallbackLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "none",
                Self::EOnError => "on_error",
                Self::EOnTimeout => "on_timeout",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from geolocation.fallback
    ///
    /// Whether the default provider falled back to NetworkGeolocationProvider.
    pub static fallback: Lazy<LabeledMetric<LabeledCounterMetric, FallbackLabel>> = Lazy::new(|| {
        LabeledMetric::new(2577.into(), CommonMetricData {
            name: "fallback".into(),
            category: "geolocation".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("none"), ::std::borrow::Cow::from("on_error"), ::std::borrow::Cow::from("on_timeout")]))
    });

    #[repr(u16)]
    pub enum LinuxProviderLabel {
        ENone = 0,
        EPortal = 1,
        EGeoclue = 2,
        EGpsd = 3,
        __Other__,
    }
    impl From<u16> for LinuxProviderLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::EPortal,
                2 => Self::EGeoclue,
                3 => Self::EGpsd,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LinuxProviderLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "none",
                Self::EPortal => "portal",
                Self::EGeoclue => "geoclue",
                Self::EGpsd => "gpsd",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from geolocation.linux_provider
    ///
    /// Which system provider are we using on Linux
    pub static linux_provider: Lazy<LabeledMetric<LabeledBooleanMetric, LinuxProviderLabel>> = Lazy::new(|| {
        LabeledMetric::new(2578.into(), CommonMetricData {
            name: "linux_provider".into(),
            category: "geolocation".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("geoclue"), ::std::borrow::Cow::from("gpsd"), ::std::borrow::Cow::from("none"), ::std::borrow::Cow::from("portal")]))
    });

    #[repr(u16)]
    pub enum RequestResultLabel {
        ESuccess = 0,
        EPermissionDenied = 1,
        EPositionUnavailable = 2,
        ETimeout = 3,
        __Other__,
    }
    impl From<u16> for RequestResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EPermissionDenied,
                2 => Self::EPositionUnavailable,
                3 => Self::ETimeout,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RequestResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EPermissionDenied => "permission_denied",
                Self::EPositionUnavailable => "position_unavailable",
                Self::ETimeout => "timeout",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from geolocation.request_result
    ///
    /// The result for each geolocation request. Success label will only happen once
    /// for each request, even if it's a watch request.
    pub static request_result: Lazy<LabeledMetric<LabeledCounterMetric, RequestResultLabel>> = Lazy::new(|| {
        LabeledMetric::new(2579.into(), CommonMetricData {
            name: "request_result".into(),
            category: "geolocation".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("permission_denied"), ::std::borrow::Cow::from("position_unavailable"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("timeout")]))
    });

}
pub mod mediadrm {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EmePlaybackExtra {
        pub key_system: Option<String>,
        pub played_time: Option<u32>,
        pub resolution: Option<String>,
        pub video_codec: Option<String>,
    }

    impl ExtraKeys for EmePlaybackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["key_system", "played_time", "resolution", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.played_time.and_then(|val| map.insert("played_time".into(), val.to_string()));
          self.resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mediadrm.eme_playback
    ///
    /// Record the EME play time with the video codec and resolutions.
    pub static eme_playback: Lazy<EventMetric<EmePlaybackExtra>> = Lazy::new(|| {
        EventMetric::new(2580.into(), CommonMetricData {
            name: "eme_playback".into(),
            category: "mediadrm".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod hls {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from hls.canplay_requested
    ///
    /// Record when a page requests canPlayType for a HLS media type.
    pub static canplay_requested: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2581,
            "hls",
            "canplay_requested",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from hls.canplay_supported
    ///
    /// Record when a canPlayType request supports HLS.
    pub static canplay_supported: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2582,
            "hls",
            "canplay_supported",
            "metrics"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct MediaLoadExtra {
        pub media_extension: Option<String>,
    }

    impl ExtraKeys for MediaLoadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["media_extension"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.media_extension.and_then(|val| map.insert("media_extension".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from hls.media_load
    ///
    /// Record the information about the HLS playback on Android using ExoPlayer. The
    /// value of this event contains the media format.
    pub static media_load: Lazy<EventMetric<MediaLoadExtra>> = Lazy::new(|| {
        EventMetric::new(2583.into(), CommonMetricData {
            name: "media_load".into(),
            category: "hls".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod gmp {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum UpdateXmlFetchResultLabel {
        ECertPinSuccess = 0,
        ECertPinNetRequestError = 1,
        ECertPinNetTimeout = 2,
        ECertPinAbort = 3,
        ECertPinMissingData = 4,
        ECertPinFailed = 5,
        ECertPinInvalid = 6,
        ECertPinXmlParseError = 7,
        ECertPinUnknownError = 8,
        EContentSigSuccess = 9,
        EContentSigNetRequestError = 10,
        EContentSigNetTimeout = 11,
        EContentSigAbort = 12,
        EContentSigMissingData = 13,
        EContentSigFailed = 14,
        EContentSigInvalid = 15,
        EContentSigXmlParseError = 16,
        EContentSigUnknownError = 17,
        __Other__,
    }
    impl From<u16> for UpdateXmlFetchResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECertPinSuccess,
                1 => Self::ECertPinNetRequestError,
                2 => Self::ECertPinNetTimeout,
                3 => Self::ECertPinAbort,
                4 => Self::ECertPinMissingData,
                5 => Self::ECertPinFailed,
                6 => Self::ECertPinInvalid,
                7 => Self::ECertPinXmlParseError,
                8 => Self::ECertPinUnknownError,
                9 => Self::EContentSigSuccess,
                10 => Self::EContentSigNetRequestError,
                11 => Self::EContentSigNetTimeout,
                12 => Self::EContentSigAbort,
                13 => Self::EContentSigMissingData,
                14 => Self::EContentSigFailed,
                15 => Self::EContentSigInvalid,
                16 => Self::EContentSigXmlParseError,
                17 => Self::EContentSigUnknownError,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for UpdateXmlFetchResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECertPinSuccess => "cert_pin_success",
                Self::ECertPinNetRequestError => "cert_pin_net_request_error",
                Self::ECertPinNetTimeout => "cert_pin_net_timeout",
                Self::ECertPinAbort => "cert_pin_abort",
                Self::ECertPinMissingData => "cert_pin_missing_data",
                Self::ECertPinFailed => "cert_pin_failed",
                Self::ECertPinInvalid => "cert_pin_invalid",
                Self::ECertPinXmlParseError => "cert_pin_xml_parse_error",
                Self::ECertPinUnknownError => "cert_pin_unknown_error",
                Self::EContentSigSuccess => "content_sig_success",
                Self::EContentSigNetRequestError => "content_sig_net_request_error",
                Self::EContentSigNetTimeout => "content_sig_net_timeout",
                Self::EContentSigAbort => "content_sig_abort",
                Self::EContentSigMissingData => "content_sig_missing_data",
                Self::EContentSigFailed => "content_sig_failed",
                Self::EContentSigInvalid => "content_sig_invalid",
                Self::EContentSigXmlParseError => "content_sig_xml_parse_error",
                Self::EContentSigUnknownError => "content_sig_unknown_error",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gmp.update_xml_fetch_result
    ///
    /// The result of Gecko fetching an update.xml from Balrog. This captures 3
    /// different data points: success or failure of the request, if cert pinning or
    /// content signatures were used to verify the result, and the reason for failure,
    /// if the request failed.
    pub static update_xml_fetch_result: Lazy<LabeledMetric<LabeledCounterMetric, UpdateXmlFetchResultLabel>> = Lazy::new(|| {
        LabeledMetric::new(2584.into(), CommonMetricData {
            name: "update_xml_fetch_result".into(),
            category: "gmp".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("cert_pin_abort"), ::std::borrow::Cow::from("cert_pin_failed"), ::std::borrow::Cow::from("cert_pin_invalid"), ::std::borrow::Cow::from("cert_pin_missing_data"), ::std::borrow::Cow::from("cert_pin_net_request_error"), ::std::borrow::Cow::from("cert_pin_net_timeout"), ::std::borrow::Cow::from("cert_pin_success"), ::std::borrow::Cow::from("cert_pin_unknown_error"), ::std::borrow::Cow::from("cert_pin_xml_parse_error"), ::std::borrow::Cow::from("content_sig_abort"), ::std::borrow::Cow::from("content_sig_failed"), ::std::borrow::Cow::from("content_sig_invalid"), ::std::borrow::Cow::from("content_sig_missing_data"), ::std::borrow::Cow::from("content_sig_net_request_error"), ::std::borrow::Cow::from("content_sig_net_timeout"), ::std::borrow::Cow::from("content_sig_success"), ::std::borrow::Cow::from("content_sig_unknown_error"), ::std::borrow::Cow::from("content_sig_xml_parse_error")]))
    });

}
pub mod media_audio {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum BackendLabel {
        EUnknown = 0,
        EAudiounit = 1,
        EAudiounitRust = 2,
        EAaudio = 3,
        EOpensl = 4,
        EWasapi = 5,
        EWinmm = 6,
        EAlsa = 7,
        EJack = 8,
        EOss = 9,
        EPulse = 10,
        EPulseRust = 11,
        ESndio = 12,
        ESunaudio = 13,
        __Other__,
    }
    impl From<u16> for BackendLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUnknown,
                1 => Self::EAudiounit,
                2 => Self::EAudiounitRust,
                3 => Self::EAaudio,
                4 => Self::EOpensl,
                5 => Self::EWasapi,
                6 => Self::EWinmm,
                7 => Self::EAlsa,
                8 => Self::EJack,
                9 => Self::EOss,
                10 => Self::EPulse,
                11 => Self::EPulseRust,
                12 => Self::ESndio,
                13 => Self::ESunaudio,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BackendLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUnknown => "unknown",
                Self::EAudiounit => "audiounit",
                Self::EAudiounitRust => "audiounit-rust",
                Self::EAaudio => "aaudio",
                Self::EOpensl => "opensl",
                Self::EWasapi => "wasapi",
                Self::EWinmm => "winmm",
                Self::EAlsa => "alsa",
                Self::EJack => "jack",
                Self::EOss => "oss",
                Self::EPulse => "pulse",
                Self::EPulseRust => "pulse-rust",
                Self::ESndio => "sndio",
                Self::ESunaudio => "sunaudio",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.audio.backend
    ///
    /// The operating system audio backend (Migrated from the geckoview metric of the
    /// same name).
    pub static backend: Lazy<LabeledMetric<LabeledCounterMetric, BackendLabel>> = Lazy::new(|| {
        LabeledMetric::new(2585.into(), CommonMetricData {
            name: "backend".into(),
            category: "media.audio".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("aaudio"), ::std::borrow::Cow::from("alsa"), ::std::borrow::Cow::from("audiounit"), ::std::borrow::Cow::from("audiounit-rust"), ::std::borrow::Cow::from("jack"), ::std::borrow::Cow::from("opensl"), ::std::borrow::Cow::from("oss"), ::std::borrow::Cow::from("pulse"), ::std::borrow::Cow::from("pulse-rust"), ::std::borrow::Cow::from("sndio"), ::std::borrow::Cow::from("sunaudio"), ::std::borrow::Cow::from("unknown"), ::std::borrow::Cow::from("wasapi"), ::std::borrow::Cow::from("winmm")]))
    });

    #[repr(u16)]
    pub enum InitFailureLabel {
        EFirst = 0,
        EOther = 1,
        __Other__,
    }
    impl From<u16> for InitFailureLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFirst,
                1 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for InitFailureLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFirst => "first",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.audio.init_failure
    ///
    /// Failure occurs when initializing the audio stream. (Migrated from the geckoview
    /// metric of the same name).
    pub static init_failure: Lazy<LabeledMetric<LabeledCounterMetric, InitFailureLabel>> = Lazy::new(|| {
        LabeledMetric::new(2586.into(), CommonMetricData {
            name: "init_failure".into(),
            category: "media.audio".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("first"), ::std::borrow::Cow::from("other")]))
    });

}
pub mod media_playback {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum DeviceHardwareDecoderSupportLabel {
        EH264 = 0,
        EVp8 = 1,
        EVp9 = 2,
        EAv1 = 3,
        EHevc = 4,
        __Other__,
    }
    impl From<u16> for DeviceHardwareDecoderSupportLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EH264,
                1 => Self::EVp8,
                2 => Self::EVp9,
                3 => Self::EAv1,
                4 => Self::EHevc,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DeviceHardwareDecoderSupportLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EH264 => "h264",
                Self::EVp8 => "vp8",
                Self::EVp9 => "vp9",
                Self::EAv1 => "av1",
                Self::EHevc => "hevc",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.playback.device_hardware_decoder_support
    ///
    /// The results of hardware decoder support for different video codecs. True means
    /// that codec can be decoded by hardware on user's device.
    pub static device_hardware_decoder_support: Lazy<LabeledMetric<LabeledBooleanMetric, DeviceHardwareDecoderSupportLabel>> = Lazy::new(|| {
        LabeledMetric::new(2587.into(), CommonMetricData {
            name: "device_hardware_decoder_support".into(),
            category: "media.playback".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("av1"), ::std::borrow::Cow::from("h264"), ::std::borrow::Cow::from("hevc"), ::std::borrow::Cow::from("vp8"), ::std::borrow::Cow::from("vp9")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct FirstFrameLoadedExtra {
        pub buffering_time: Option<u32>,
        pub first_frame_loaded_time: Option<u32>,
        pub hls_decoder: Option<bool>,
        pub is_hardware_decoding: Option<bool>,
        pub key_system: Option<String>,
        pub metadata_loaded_time: Option<u32>,
        pub playback_type: Option<String>,
        pub resolution: Option<String>,
        pub total_waiting_data_time: Option<u32>,
        pub video_codec: Option<String>,
    }

    impl ExtraKeys for FirstFrameLoadedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["buffering_time", "first_frame_loaded_time", "hls_decoder", "is_hardware_decoding", "key_system", "metadata_loaded_time", "playback_type", "resolution", "total_waiting_data_time", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.buffering_time.and_then(|val| map.insert("buffering_time".into(), val.to_string()));
          self.first_frame_loaded_time.and_then(|val| map.insert("first_frame_loaded_time".into(), val.to_string()));
          self.hls_decoder.and_then(|val| map.insert("hls_decoder".into(), val.to_string()));
          self.is_hardware_decoding.and_then(|val| map.insert("is_hardware_decoding".into(), val.to_string()));
          self.key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.metadata_loaded_time.and_then(|val| map.insert("metadata_loaded_time".into(), val.to_string()));
          self.playback_type.and_then(|val| map.insert("playback_type".into(), val.to_string()));
          self.resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.total_waiting_data_time.and_then(|val| map.insert("total_waiting_data_time".into(), val.to_string()));
          self.video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.playback.first_frame_loaded
    ///
    /// The time that the media pipeline takes to load the first video frame.
    pub static first_frame_loaded: Lazy<EventMetric<FirstFrameLoadedExtra>> = Lazy::new(|| {
        EventMetric::new(2588.into(), CommonMetricData {
            name: "first_frame_loaded".into(),
            category: "media.playback".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.playback.not_supported_video_per_mime_type
    ///
    /// Count the amount of times where video playback is failed to start due to the
    /// mime type is not supported by Firefox. The result is accumulated per mime type,
    /// eg. video/hevc.
    pub static not_supported_video_per_mime_type: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2589.into(), CommonMetricData {
            name: "not_supported_video_per_mime_type".into(),
            category: "media.playback".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

}
pub mod mfcdm {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EmePlaybackExtra {
        pub dropped_frames: Option<u32>,
        pub key_system: Option<String>,
        pub played_time: Option<u32>,
        pub rendered_frames: Option<u32>,
        pub resolution: Option<String>,
        pub video_codec: Option<String>,
    }

    impl ExtraKeys for EmePlaybackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["dropped_frames", "key_system", "played_time", "rendered_frames", "resolution", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.dropped_frames.and_then(|val| map.insert("dropped_frames".into(), val.to_string()));
          self.key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.played_time.and_then(|val| map.insert("played_time".into(), val.to_string()));
          self.rendered_frames.and_then(|val| map.insert("rendered_frames".into(), val.to_string()));
          self.resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mfcdm.eme_playback
    ///
    /// Record the information about the EME playback when using the media engine. The
    /// value of this event is the key system name.
    pub static eme_playback: Lazy<EventMetric<EmePlaybackExtra>> = Lazy::new(|| {
        EventMetric::new(2590.into(), CommonMetricData {
            name: "eme_playback".into(),
            category: "mfcdm".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ErrorExtra {
        pub audio_codec: Option<String>,
        pub current_state: Option<String>,
        pub error_name: Option<String>,
        pub key_system: Option<String>,
        pub resolution: Option<String>,
        pub video_codec: Option<String>,
    }

    impl ExtraKeys for ErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["audio_codec", "current_state", "error_name", "key_system", "resolution", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.audio_codec.and_then(|val| map.insert("audio_codec".into(), val.to_string()));
          self.current_state.and_then(|val| map.insert("current_state".into(), val.to_string()));
          self.error_name.and_then(|val| map.insert("error_name".into(), val.to_string()));
          self.key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mfcdm.error
    ///
    /// Record the error or crash happened while using the media engine playback. The
    /// value of this event is the name of error. This probe covers both EME and non-
    /// EME playback.
    pub static error: Lazy<EventMetric<ErrorExtra>> = Lazy::new(|| {
        EventMetric::new(2591.into(), CommonMetricData {
            name: "error".into(),
            category: "mfcdm".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod codec_stats {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.audio_preferred_codec
    ///
    /// Counts the preferred audio codec being signaled to us to identify preferred
    /// audio codec.
    pub static audio_preferred_codec: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2592.into(), CommonMetricData {
            name: "audio_preferred_codec".into(),
            category: "codec.stats".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.other_fec_signaled
    ///
    /// Count how many other fec options are being offered.
    pub static other_fec_signaled: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2593.into(), CommonMetricData {
            name: "other_fec_signaled".into(),
            category: "codec.stats".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[repr(u16)]
    pub enum UlpfecNegotiatedLabel {
        ENegotiated = 0,
        ENotNegotiated = 1,
        __Other__,
    }
    impl From<u16> for UlpfecNegotiatedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENegotiated,
                1 => Self::ENotNegotiated,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for UlpfecNegotiatedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENegotiated => "negotiated",
                Self::ENotNegotiated => "not_negotiated",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.ulpfec_negotiated
    ///
    /// Counts the number of times that ulpfec is negotiated or not negotiated on the
    /// first negotiation for each video transceiver.
    pub static ulpfec_negotiated: Lazy<LabeledMetric<LabeledCounterMetric, UlpfecNegotiatedLabel>> = Lazy::new(|| {
        LabeledMetric::new(2594.into(), CommonMetricData {
            name: "ulpfec_negotiated".into(),
            category: "codec.stats".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("negotiated"), ::std::borrow::Cow::from("not_negotiated")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.video_preferred_codec
    ///
    /// Counts the preferred video codec being signaled to us to identify preferred
    /// video codec.
    pub static video_preferred_codec: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2595.into(), CommonMetricData {
            name: "video_preferred_codec".into(),
            category: "codec.stats".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

}
pub mod rtcrtpsender {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.count
    ///
    /// The number of RTCRtpSenders created.
    pub static count: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(2596.into(), CommonMetricData {
            name: "count".into(),
            category: "rtcrtpsender".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "used_sendencodings".into(), category: "rtcrtpsender".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_length_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_no_getparameters".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_no_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_other".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_rid_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_stale_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.count_setparameters_compat
    ///
    /// The number of RTCRtpSenders created that use the compatibility mode for
    /// setParameters.
    pub static count_setparameters_compat: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(2597.into(), CommonMetricData {
            name: "count_setparameters_compat".into(),
            category: "rtcrtpsender".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "fail_no_encodings".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_length_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_no_getparameters".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_no_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.used_sendencodings
    ///
    /// The proportion of RTCRtpSenders that were created by an addTransceivers call
    /// that was passed a sendEncodings.
    pub static used_sendencodings: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2598.into(), CommonMetricData {
            name: "used_sendencodings".into(),
            category: "rtcrtpsender".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod rtcrtpsender_setparameters {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.blame_length_changed
    ///
    /// The number of RTCRtpSenders that have warned at least once about a
    /// `setParameters` call that attempted to change the number of encodings, broken
    /// down by the eTLD+1 of the site. Collected only on EARLY_BETA_OR_EARLIER.
    pub static blame_length_changed: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2599.into(), CommonMetricData {
            name: "blame_length_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.blame_no_getparameters
    ///
    /// The number of RTCRtpSenders that have warned at least once about a
    /// `setParameters` call because `[[LastReturnedParameters]]` was not set, broken
    /// down by the eTLD+1 of the site. (ie; there was not a recent enough call to
    /// `getParameters`) Collected only on EARLY_BETA_OR_EARLIER.
    pub static blame_no_getparameters: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2600.into(), CommonMetricData {
            name: "blame_no_getparameters".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.blame_no_transactionid
    ///
    /// The number of RTCRtpSenders that have warned at least once about a
    /// `setParameters` call that did not set the transactionId field, broken down by
    /// the eTLD+1 of the site. Collected only on EARLY_BETA_OR_EARLIER.
    pub static blame_no_transactionid: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2601.into(), CommonMetricData {
            name: "blame_no_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_length_changed
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that attempted to change the number of encodings.
    pub static fail_length_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2602.into(), CommonMetricData {
            name: "fail_length_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_encodings
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have thrown an error at least once about a setParameters call that had no
    /// encodings (we do not measure this against the general population of
    /// RTCRtpSenders, since without the compat mode this failure is never observed,
    /// because it fails the length change check).
    pub static fail_no_encodings: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2603.into(), CommonMetricData {
            name: "fail_no_encodings".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_getparameters
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call because [[LastReturnedParameters]] was not set. (ie; there
    /// was not a recent enough call to getParameters)
    pub static fail_no_getparameters: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2604.into(), CommonMetricData {
            name: "fail_no_getparameters".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_transactionid
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that did not set the transactionId field.
    pub static fail_no_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2605.into(), CommonMetricData {
            name: "fail_no_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_other
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that had no encodings.
    pub static fail_other: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2606.into(), CommonMetricData {
            name: "fail_other".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_rid_changed
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that attempted to change the rid on an encoding (note that
    /// we only check this if the encoding count did not change, see
    /// fail_length_changed).
    pub static fail_rid_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2607.into(), CommonMetricData {
            name: "fail_rid_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_stale_transactionid
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that used a stale transaction id.
    pub static fail_stale_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2608.into(), CommonMetricData {
            name: "fail_stale_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_length_changed
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that attempted to
    /// change the number of encodings.
    pub static warn_length_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2609.into(), CommonMetricData {
            name: "warn_length_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_no_getparameters
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call because
    /// [[LastReturnedParameters]] was not set.  (ie; there was not a recent enough
    /// call to getParameters)
    pub static warn_no_getparameters: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2610.into(), CommonMetricData {
            name: "warn_no_getparameters".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_no_transactionid
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that did not set the
    /// transactionId field.
    pub static warn_no_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2611.into(), CommonMetricData {
            name: "warn_no_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod webrtcdtls {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.cipher
    ///
    /// The CipherSuite used for each webrtc DTLS connection, as a string
    /// representation of the CipherSuite's ID in 4 hex digits (eg;
    /// TLS_DHE_RSA_WITH_AES_128_CBC_SHA would be "0x0033")
    pub static cipher: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2612.into(), CommonMetricData {
            name: "cipher".into(),
            category: "webrtcdtls".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.client_handshake_result
    ///
    /// The result of each webrtc client DTLS handshake as a string containing either
    /// the name of the error code (eg; SSL_ERROR_BAD_CERTIFICATE), SUCCESS for
    /// successful handshakes, ALPN_FAILURE when ALPN negotiation fails, or
    /// CERT_FAILURE when cert validation fails.
    pub static client_handshake_result: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2613.into(), CommonMetricData {
            name: "client_handshake_result".into(),
            category: "webrtcdtls".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.protocol_version
    ///
    /// The version of DTLS used for each webrtc connection. Can be 1.0, 1.2, or 1.3
    /// (there is no 1.1 version of DTLS)
    pub static protocol_version: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2614.into(), CommonMetricData {
            name: "protocol_version".into(),
            category: "webrtcdtls".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.server_handshake_result
    ///
    /// The result of each webrtc server DTLS handshake, as the name of the error code
    /// (eg; SSL_ERROR_BAD_CERTIFICATE), the empty string for successful handshakes,
    /// ALPN_FAILURE when ALPN negotiation fails, or CERT_FAILURE when cert validation
    /// fails.
    pub static server_handshake_result: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2615.into(), CommonMetricData {
            name: "server_handshake_result".into(),
            category: "webrtcdtls".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.srtp_cipher
    ///
    /// The SRTPProtectionProfile (see RFC 5764) used for each webrtc SRTP connection,
    /// as a string representation of the SRTPProtectionProfile's ID in 4 hex digits
    /// (eg; SRTP_AES128_CM_HMAC_SHA1_80 would be "0x0001")
    pub static srtp_cipher: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2616.into(), CommonMetricData {
            name: "srtp_cipher".into(),
            category: "webrtcdtls".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

}
pub mod javascript_pageload {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.baseline_compile_time
    ///
    /// Time spent during page load baseline compiling Javascript in ms. (Migrated from
    /// the geckoview metric of the same name.)
    pub static baseline_compile_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2617.into(), CommonMetricData {
            name: "baseline_compile_time".into(),
            category: "javascript.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.delazification_time
    ///
    /// Time spent during page load delazifying Javascript in ms. (Migrated from the
    /// geckoview metric of the same name.)
    pub static delazification_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2618.into(), CommonMetricData {
            name: "delazification_time".into(),
            category: "javascript.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.execution_time
    ///
    /// Time spent during page load executing Javascript in ms. (Migrated from the
    /// geckoview metric of the same name.)
    pub static execution_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2619.into(), CommonMetricData {
            name: "execution_time".into(),
            category: "javascript.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.gc_time
    ///
    /// Time spent during page load in the GC in ms. (Migrated from the geckoview
    /// metric of the same name.)
    pub static gc_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2620.into(), CommonMetricData {
            name: "gc_time".into(),
            category: "javascript.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.parse_time
    ///
    /// Time spent during page load syntax parsing JS scripts on the main thread in ms.
    /// (Migrated from the geckoview metric of the same name.)
    pub static parse_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2621.into(), CommonMetricData {
            name: "parse_time".into(),
            category: "javascript.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.protect_time
    ///
    /// Time spent during page load protecting JIT executable memory. (Migrated from
    /// the geckoview metric of the same name.)
    pub static protect_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2622.into(), CommonMetricData {
            name: "protect_time".into(),
            category: "javascript.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.xdr_encode_time
    ///
    /// Time spent during page load XDR encoding Javascript in ms. (Migrated from the
    /// geckoview metric of the same name.)
    pub static xdr_encode_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2623.into(), CommonMetricData {
            name: "xdr_encode_time".into(),
            category: "javascript.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod perf {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from perf.largest_contentful_paint
    ///
    /// Time from navigation start to largest contentful paint.
    pub static largest_contentful_paint: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2624.into(), CommonMetricData {
            name: "largest_contentful_paint".into(),
            category: "perf".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from perf.largest_contentful_paint_from_response_start
    ///
    /// Time from response start to largest contentful paint.
    pub static largest_contentful_paint_from_response_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2625.into(), CommonMetricData {
            name: "largest_contentful_paint_from_response_start".into(),
            category: "perf".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct PageLoadExtra {
        pub dns_lookup_time: Option<u32>,
        pub fcp_time: Option<u32>,
        pub http_ver: Option<u32>,
        pub js_exec_time: Option<u32>,
        pub lcp_time: Option<u32>,
        pub load_time: Option<u32>,
        pub load_type: Option<String>,
        pub redirect_count: Option<u32>,
        pub redirect_time: Option<u32>,
        pub response_time: Option<u32>,
        pub same_origin_nav: Option<bool>,
        pub trr_domain: Option<String>,
        pub using_webdriver: Option<bool>,
    }

    impl ExtraKeys for PageLoadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["dns_lookup_time", "fcp_time", "http_ver", "js_exec_time", "lcp_time", "load_time", "load_type", "redirect_count", "redirect_time", "response_time", "same_origin_nav", "trr_domain", "using_webdriver"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.dns_lookup_time.and_then(|val| map.insert("dns_lookup_time".into(), val.to_string()));
          self.fcp_time.and_then(|val| map.insert("fcp_time".into(), val.to_string()));
          self.http_ver.and_then(|val| map.insert("http_ver".into(), val.to_string()));
          self.js_exec_time.and_then(|val| map.insert("js_exec_time".into(), val.to_string()));
          self.lcp_time.and_then(|val| map.insert("lcp_time".into(), val.to_string()));
          self.load_time.and_then(|val| map.insert("load_time".into(), val.to_string()));
          self.load_type.and_then(|val| map.insert("load_type".into(), val.to_string()));
          self.redirect_count.and_then(|val| map.insert("redirect_count".into(), val.to_string()));
          self.redirect_time.and_then(|val| map.insert("redirect_time".into(), val.to_string()));
          self.response_time.and_then(|val| map.insert("response_time".into(), val.to_string()));
          self.same_origin_nav.and_then(|val| map.insert("same_origin_nav".into(), val.to_string()));
          self.trr_domain.and_then(|val| map.insert("trr_domain".into(), val.to_string()));
          self.using_webdriver.and_then(|val| map.insert("using_webdriver".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from perf.page_load
    ///
    /// Recorded when a top level content document has been loaded.
    pub static page_load: Lazy<EventMetric<PageLoadExtra>> = Lazy::new(|| {
        EventMetric::new(2626.into(), CommonMetricData {
            name: "page_load".into(),
            category: "perf".into(),
            send_in_pings: vec!["pageload".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod performance_pageload {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.fcp
    ///
    /// The time between navigationStart and the first contentful paint of a foreground
    /// http or https root content document, in milliseconds. The contentful paint
    /// timestamp is taken during display list building and does not include
    /// rasterization or compositing of that paint. (Migrated from the geckoview metric
    /// of the same name).
    pub static fcp: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2627.into(), CommonMetricData {
            name: "fcp".into(),
            category: "performance.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.fcp_responsestart
    ///
    /// The time between responseStart and the first contentful paint of a foreground
    /// http or https root content document, in milliseconds. The contentful paint
    /// timestamp is taken during display list building and does not include
    /// rasterization or compositing of that paint. (Migrated from the geckoview metric
    /// of the same name).
    pub static fcp_responsestart: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2628.into(), CommonMetricData {
            name: "fcp_responsestart".into(),
            category: "performance.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.load_time
    ///
    /// Time in milliseconds from navigationStart to loadEventStart for the foreground
    /// http or https root content document. (Migrated from the geckoview metric of the
    /// same name).
    pub static load_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2629.into(), CommonMetricData {
            name: "load_time".into(),
            category: "performance.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.load_time_responsestart
    ///
    /// Time in milliseconds from responseStart to loadEventStart for the foreground
    /// http or https root content document. (Migrated from the geckoview metric of the
    /// same name).
    pub static load_time_responsestart: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2630.into(), CommonMetricData {
            name: "load_time_responsestart".into(),
            category: "performance.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.async_sheet_load
    ///
    /// Time spent in milliseconds since a style sheet started loading async until it
    /// finished.
    pub static async_sheet_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2631.into(), CommonMetricData {
            name: "async_sheet_load".into(),
            category: "performance.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.req_anim_frame_callback
    ///
    /// Time spent in milliseconds calling all request animation frame callbacks for a
    /// document before it has reached readystate complete. (Migrated from the
    /// geckoview metric of the same name.)
    pub static req_anim_frame_callback: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2632.into(), CommonMetricData {
            name: "req_anim_frame_callback".into(),
            category: "performance.pageload".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod performance_time {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_complete
    ///
    /// Time from navigationStart to domComplete as per the W3C Performance Timing API.
    /// (Migrated from the geckoview metric of the same name.)
    pub static dom_complete: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2633.into(), CommonMetricData {
            name: "dom_complete".into(),
            category: "performance.time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_content_loaded_end
    ///
    /// Time from navigationStart to domContentLoadedEventEnd as per the W3C
    /// Performance Timing API. (Migrated from the geckoview metric of the same name.)
    pub static dom_content_loaded_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2634.into(), CommonMetricData {
            name: "dom_content_loaded_end".into(),
            category: "performance.time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_content_loaded_start
    ///
    /// Time from navigationStart to domContentLoadedEventStart as per the W3C
    /// Performance Timing API. (Migrated from the geckoview metric of the same name.)
    pub static dom_content_loaded_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2635.into(), CommonMetricData {
            name: "dom_content_loaded_start".into(),
            category: "performance.time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_interactive
    ///
    /// Time from navigationStart to domInteractive as per the W3C Performance Timing
    /// API. (Migrated from the geckoview metric of the same name.)
    pub static dom_interactive: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2636.into(), CommonMetricData {
            name: "dom_interactive".into(),
            category: "performance.time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.load_event_end
    ///
    /// Time from navigationStart to loadEventEnd as per the W3C Performance Timing
    /// API. (Migrated from the geckoview metric of the same name.)
    pub static load_event_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2637.into(), CommonMetricData {
            name: "load_event_end".into(),
            category: "performance.time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.load_event_start
    ///
    /// Time from navigationStart to loadEventStart as per the W3C Performance Timing
    /// API. (Migrated from the geckoview metric of the same name.)
    pub static load_event_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2638.into(), CommonMetricData {
            name: "load_event_start".into(),
            category: "performance.time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.response_start
    ///
    /// Time from navigationStart to responseStart as per the W3C Performance Timing
    /// API. (Migrated from the geckoview metric of the same name.)
    pub static response_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2639.into(), CommonMetricData {
            name: "response_start".into(),
            category: "performance.time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod private_attribution {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum DatabaseLabel {
        EReset = 0,
        __Other__,
    }
    impl From<u16> for DatabaseLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EReset,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DatabaseLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EReset => "reset",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from private_attribution.database
    ///
    /// The metrics for the attribution data stores
    pub static database: Lazy<LabeledMetric<LabeledCounterMetric, DatabaseLabel>> = Lazy::new(|| {
        LabeledMetric::new(2640.into(), CommonMetricData {
            name: "database".into(),
            category: "private_attribution".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("reset")]))
    });

    #[repr(u16)]
    pub enum MeasureConversionLabel {
        ESuccess = 0,
        EError = 1,
        ELastView = 2,
        ELastClick = 3,
        ELastImpression = 4,
        __Other__,
    }
    impl From<u16> for MeasureConversionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EError,
                2 => Self::ELastView,
                3 => Self::ELastClick,
                4 => Self::ELastImpression,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MeasureConversionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EError => "error",
                Self::ELastView => "last_view",
                Self::ELastClick => "last_click",
                Self::ELastImpression => "last_impression",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from private_attribution.measure_conversion
    ///
    /// The count of outcomes for the measureConversion API
    pub static measure_conversion: Lazy<LabeledMetric<LabeledCounterMetric, MeasureConversionLabel>> = Lazy::new(|| {
        LabeledMetric::new(2641.into(), CommonMetricData {
            name: "measure_conversion".into(),
            category: "private_attribution".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("error"), ::std::borrow::Cow::from("last_click"), ::std::borrow::Cow::from("last_impression"), ::std::borrow::Cow::from("last_view"), ::std::borrow::Cow::from("success")]))
    });

    #[repr(u16)]
    pub enum SaveImpressionLabel {
        ESuccess = 0,
        EError = 1,
        ELastView = 2,
        ELastClick = 3,
        ELastImpression = 4,
        __Other__,
    }
    impl From<u16> for SaveImpressionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EError,
                2 => Self::ELastView,
                3 => Self::ELastClick,
                4 => Self::ELastImpression,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SaveImpressionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EError => "error",
                Self::ELastView => "last_view",
                Self::ELastClick => "last_click",
                Self::ELastImpression => "last_impression",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from private_attribution.save_impression
    ///
    /// The count of outcomes for the saveImpression API
    pub static save_impression: Lazy<LabeledMetric<LabeledCounterMetric, SaveImpressionLabel>> = Lazy::new(|| {
        LabeledMetric::new(2642.into(), CommonMetricData {
            name: "save_impression".into(),
            category: "private_attribution".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("error"), ::std::borrow::Cow::from("last_click"), ::std::borrow::Cow::from("last_impression"), ::std::borrow::Cow::from("last_view"), ::std::borrow::Cow::from("success")]))
    });

}
pub mod httpsfirst {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgrade_time
    ///
    /// If a HTTPS-First (`dom.security.https_first` enabled) upgrade isn't successful,
    /// measures the timespan between the navigation start and the downgrade.
    pub static downgrade_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2643.into(), CommonMetricData {
            name: "downgrade_time".into(),
            category: "httpsfirst".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgrade_time_schemeless
    ///
    /// If a schemeless HTTPS-First (`dom.security.https_first` disabled, but load
    /// marked as schemeless) upgrade isn't successful, measures the timespan between
    /// the navigation start and the downgrade.
    pub static downgrade_time_schemeless: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2644.into(), CommonMetricData {
            name: "downgrade_time_schemeless".into(),
            category: "httpsfirst".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded
    ///
    /// How many regular HTTPS-First (`dom.security.https_first` enabled) upgrades fail
    /// and get downgraded again.
    pub static downgraded: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(2645.into(), CommonMetricData {
            name: "downgraded".into(),
            category: "httpsfirst".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "downgraded_on_timer".into(), category: "httpsfirst".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded_on_timer
    ///
    /// How many HTTPS-First (`dom.security.https_first` enabled) upgrades get
    /// downgraded again because the HTTP request fired after 3s received a answer
    /// faster than the HTTPS request.
    pub static downgraded_on_timer: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2646.into(), CommonMetricData {
            name: "downgraded_on_timer".into(),
            category: "httpsfirst".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded_on_timer_schemeless
    ///
    /// How many of schemeless HTTPS-First (`dom.security.https_first` disabled, but
    /// load marked as schemeless) upgrades get downgraded again because the HTTP
    /// request fired after 3s received a answer faster than the HTTPS request
    pub static downgraded_on_timer_schemeless: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2647.into(), CommonMetricData {
            name: "downgraded_on_timer_schemeless".into(),
            category: "httpsfirst".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded_schemeless
    ///
    /// How many schemeless HTTPS-First (`dom.security.https_first` disabled, but load
    /// marked as schemeless) upgrades fail and get downgraded again.
    pub static downgraded_schemeless: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(2648.into(), CommonMetricData {
            name: "downgraded_schemeless".into(),
            category: "httpsfirst".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "downgraded_on_timer_schemeless".into(), category: "httpsfirst".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.upgraded
    ///
    /// Counts how often a load is successfully upgraded to HTTPS because of HTTPS-
    /// First (`dom.security.https_first` enabled). This does not include loads that
    /// get downgraded again.
    pub static upgraded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2649,
            "httpsfirst",
            "upgraded",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.upgraded_schemeless
    ///
    /// Counts how often a load is successfully upgraded to HTTPS because of schemeless
    /// HTTPS-First (`dom.security.https_first` disabled, but load marked as
    /// schemeless). This does not include loads that get downgraded again.
    pub static upgraded_schemeless: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2650,
            "httpsfirst",
            "upgraded_schemeless",
            "metrics"
        )
    });

}
pub mod webauthn_create {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum AuthenticatorAttachmentLabel {
        ECrossPlatform = 0,
        EPlatform = 1,
        EUnknown = 2,
        __Other__,
    }
    impl From<u16> for AuthenticatorAttachmentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrossPlatform,
                1 => Self::EPlatform,
                2 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AuthenticatorAttachmentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrossPlatform => "cross-platform",
                Self::EPlatform => "platform",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.authenticator_attachment
    ///
    /// The number of successfully created credentials by authenticator attachment
    /// modality.
    pub static authenticator_attachment: Lazy<LabeledMetric<LabeledCounterMetric, AuthenticatorAttachmentLabel>> = Lazy::new(|| {
        LabeledMetric::new(2651.into(), CommonMetricData {
            name: "authenticator_attachment".into(),
            category: "webauthn_create".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("cross-platform"), ::std::borrow::Cow::from("platform"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.failure
    ///
    /// The total number of failed calls to navigator.credentials.create.
    pub static failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2652,
            "webauthn_create",
            "failure",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.passkey
    ///
    /// The number of client-side discoverable credentials (passkeys) created.
    pub static passkey: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2653,
            "webauthn_create",
            "passkey",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.success
    ///
    /// The total number of successful calls to navigator.credentials.create.
    pub static success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2654,
            "webauthn_create",
            "success",
            "metrics"
        )
    });

}
pub mod webauthn_get {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum AuthenticatorAttachmentLabel {
        ECrossPlatform = 0,
        EPlatform = 1,
        EUnknown = 2,
        __Other__,
    }
    impl From<u16> for AuthenticatorAttachmentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrossPlatform,
                1 => Self::EPlatform,
                2 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AuthenticatorAttachmentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrossPlatform => "cross-platform",
                Self::EPlatform => "platform",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webauthn_get.authenticator_attachment
    ///
    /// The number of successfully asserted credentials by authenticator attachment
    /// modality.
    pub static authenticator_attachment: Lazy<LabeledMetric<LabeledCounterMetric, AuthenticatorAttachmentLabel>> = Lazy::new(|| {
        LabeledMetric::new(2655.into(), CommonMetricData {
            name: "authenticator_attachment".into(),
            category: "webauthn_get".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("cross-platform"), ::std::borrow::Cow::from("platform"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_get.failure
    ///
    /// The total number of failed calls to navigator.credentials.get.
    pub static failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2656,
            "webauthn_get",
            "failure",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_get.success
    ///
    /// The total number of successful calls to navigator.credentials.get.
    pub static success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2657,
            "webauthn_get",
            "success",
            "metrics"
        )
    });

}
pub mod gfx {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.composite_time
    ///
    /// The time taken to composite a frame. On non-webrender this is the time taken in
    /// `CompositorBridgeParent::CompositeToTarget()`. On webrender, this is the time
    /// taken from the start of `WebRenderBridgeParent::CompositeToTarget()`, until the
    /// render thread has rendered the frame (in `RenderThread::HandleFrameOneDoc()`).
    /// (Migrated from the geckoview metric of the same name).
    pub static composite_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2658.into(), CommonMetricData {
            name: "composite_time".into(),
            category: "gfx".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.scroll_present_latency
    ///
    /// Time between receiving a scroll event on the event loop and compositing its
    /// result onto the screen (ms). (Migrated from the geckoview metric of the same
    /// name).
    pub static scroll_present_latency: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2659.into(), CommonMetricData {
            name: "scroll_present_latency".into(),
            category: "gfx".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod gfx_adapter_primary {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.description
    ///
    /// Long form description of the Graphics adapter (Migrated from the geckoview
    /// metric of the same name).
    pub static description: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2660.into(), CommonMetricData {
            name: "description".into(),
            category: "gfx.adapter.primary".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.device_id
    ///
    /// Graphics adapter device identification (Migrated from the geckoview metric of
    /// the same name).
    pub static device_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2661.into(), CommonMetricData {
            name: "device_id".into(),
            category: "gfx.adapter.primary".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_date
    ///
    /// Graphics adapter driver date (Migrated from the geckoview metric of the same
    /// name).
    pub static driver_date: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2662.into(), CommonMetricData {
            name: "driver_date".into(),
            category: "gfx.adapter.primary".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_files
    ///
    /// List of graphics adapter driver files (Migrated from the geckoview metric of
    /// the same name).
    pub static driver_files: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2663.into(), CommonMetricData {
            name: "driver_files".into(),
            category: "gfx.adapter.primary".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_vendor
    ///
    /// Graphics adapter driver vendor identification (Migrated from the geckoview
    /// metric of the same name).
    pub static driver_vendor: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2664.into(), CommonMetricData {
            name: "driver_vendor".into(),
            category: "gfx.adapter.primary".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_version
    ///
    /// Graphics adapter driver version (Migrated from the geckoview metric of the same
    /// name).
    pub static driver_version: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2665.into(), CommonMetricData {
            name: "driver_version".into(),
            category: "gfx.adapter.primary".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.ram
    ///
    /// Graphics adapter dedicated memory (Migrated from the geckoview metric of the
    /// same name).
    pub static ram: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2666.into(), CommonMetricData {
            name: "ram".into(),
            category: "gfx.adapter.primary".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.subsystem_id
    ///
    /// Graphics adapter subsystem identification (Migrated from the geckoview metric
    /// of the same name).
    pub static subsystem_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2667.into(), CommonMetricData {
            name: "subsystem_id".into(),
            category: "gfx.adapter.primary".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.vendor_id
    ///
    /// Graphics adapter vendor identification (Migrated from the geckoview metric of
    /// the same name).
    pub static vendor_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2668.into(), CommonMetricData {
            name: "vendor_id".into(),
            category: "gfx.adapter.primary".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod gfx_checkerboard {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.duration
    ///
    /// The duration of a checkerboard event. Checkerboarding is when painting has not
    /// kept up with asynchronous panning and zooming so the compositor has to display
    /// a "checkerboard pattern" (or in practice, the background color) rather than the
    /// actual page content. (Migrated from the geckoview metric of the same name).
    pub static duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2669.into(), CommonMetricData {
            name: "duration".into(),
            category: "gfx.checkerboard".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.peak_pixel_count
    ///
    /// The peak number of CSS pixels that checkerboarded during a checkerboard event.
    /// The minimum value of the largest histogram bucket is the size of a 4k display
    /// with maximum APZ zooming. (Migrated from the geckoview metric of the same
    /// name).
    pub static peak_pixel_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2670.into(), CommonMetricData {
            name: "peak_pixel_count".into(),
            category: "gfx.checkerboard".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 66355200, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.potential_duration
    ///
    /// The total amount of time that we could reasonably be checkerboarding. This is
    /// the union of two possibly-intersecting sets of time periods: The first set is
    /// that in which checkerboarding was actually happening, since by definition it
    /// could potentially be happening. The second set is that in which the APZC is
    /// actively transforming content in the compositor, since it could potentially
    /// transform it so as to display checkerboarding to the user. Combined with other
    /// information, this allows us to meaningfully say how frequently users actually
    /// enncounters checkerboarding. (Migrated from the geckoview metric of the same
    /// name).
    pub static potential_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2671.into(), CommonMetricData {
            name: "potential_duration".into(),
            category: "gfx.checkerboard".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.severity
    ///
    /// An opaque measurement of the severity of a checkerboard event. This doesn't
    /// have units, it's just useful for comparing two checkerboard events to see which
    /// one is worse, for some implementation-specific definition of "worse". The
    /// larger the value, the worse the checkerboarding. (Migrated from the geckoview
    /// metric of the same name).
    pub static severity: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2672.into(), CommonMetricData {
            name: "severity".into(),
            category: "gfx.checkerboard".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 1073741824, 50, HistogramType::Exponential)
    });

}
pub mod gfx_content {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.full_paint_time
    ///
    /// Time spent in the full paint pipeline for content until it's ready for
    /// composition. For non-webrender this includes `paint_time`, plus rasterization
    /// if OMTP is enabled. For webrender, this includes `paint_time`, plus scene
    /// building time. (Migrated from the geckoview metric of the same name).
    pub static full_paint_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2673.into(), CommonMetricData {
            name: "full_paint_time".into(),
            category: "gfx.content".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.paint_time
    ///
    /// Time spent in the main-thread paint pipeline for content. For non-webrender,
    /// this includes display list building, layer building, and when OMTP is disabled,
    /// rasterization. For webrender, this includes display list building, and
    /// webrender display list building. (Migrated from the geckoview metric of the
    /// same name).
    pub static paint_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2674.into(), CommonMetricData {
            name: "paint_time".into(),
            category: "gfx.content".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod gfx_content_frame_time {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.from_paint
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in
    /// the content process until that frame is presented in the compositor. (Migrated
    /// from the geckoview metric of the same name).
    pub static from_paint: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2675.into(), CommonMetricData {
            name: "from_paint".into(),
            category: "gfx.content.frame_time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 5000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.from_vsync
    ///
    /// The time, in percentage of a vsync interval, spent from the vsync that started
    /// a paint in the content process until that frame is presented in the compositor.
    /// (Migrated from the geckoview metric of the same name).
    pub static from_vsync: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2676.into(), CommonMetricData {
            name: "from_vsync".into(),
            category: "gfx.content.frame_time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 8, 792, 100, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ReasonLabel {
        EOnTime = 0,
        ENoVsync = 1,
        EMissedComposite = 2,
        ESlowComposite = 3,
        EMissedCompositeMid = 4,
        EMissedCompositeLong = 5,
        EMissedCompositeLow = 6,
        ENoVsyncNoId = 7,
        __Other__,
    }
    impl From<u16> for ReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOnTime,
                1 => Self::ENoVsync,
                2 => Self::EMissedComposite,
                3 => Self::ESlowComposite,
                4 => Self::EMissedCompositeMid,
                5 => Self::EMissedCompositeLong,
                6 => Self::EMissedCompositeLow,
                7 => Self::ENoVsyncNoId,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOnTime => "on_time",
                Self::ENoVsync => "no_vsync",
                Self::EMissedComposite => "missed_composite",
                Self::ESlowComposite => "slow_composite",
                Self::EMissedCompositeMid => "missed_composite_mid",
                Self::EMissedCompositeLong => "missed_composite_long",
                Self::EMissedCompositeLow => "missed_composite_low",
                Self::ENoVsyncNoId => "no_vsync_no_id",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.reason
    ///
    /// The reason that `gfx.content.frame_time.from_paint` recorded a slow (>200ms)
    /// result, if any. (Migrated from the geckoview metric of the same name).
    pub static reason: Lazy<LabeledMetric<LabeledCounterMetric, ReasonLabel>> = Lazy::new(|| {
        LabeledMetric::new(2677.into(), CommonMetricData {
            name: "reason".into(),
            category: "gfx.content.frame_time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("missed_composite"), ::std::borrow::Cow::from("missed_composite_long"), ::std::borrow::Cow::from("missed_composite_low"), ::std::borrow::Cow::from("missed_composite_mid"), ::std::borrow::Cow::from("no_vsync"), ::std::borrow::Cow::from("no_vsync_no_id"), ::std::borrow::Cow::from("on_time"), ::std::borrow::Cow::from("slow_composite")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.with_svg
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in
    /// the content process until that frame is presented in the compositor, for frames
    /// that contained an SVG to be drawn by webrender. (Migrated from the geckoview
    /// metric of the same name).
    pub static with_svg: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2678.into(), CommonMetricData {
            name: "with_svg".into(),
            category: "gfx.content.frame_time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 5000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.without_resource_upload
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in
    /// the content process until that frame is presented in the compositor by
    /// webrender, excluding time spent uploading resources. (Migrated from the
    /// geckoview metric of the same name).
    pub static without_resource_upload: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2679.into(), CommonMetricData {
            name: "without_resource_upload".into(),
            category: "gfx.content.frame_time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 5000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.without_upload
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in
    /// the content process until that frame is presented in the compositor by
    /// webrender, excluding time spent uploading any content. (Migrated from the
    /// geckoview metric of the same name).
    pub static without_upload: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2680.into(), CommonMetricData {
            name: "without_upload".into(),
            category: "gfx.content.frame_time".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 5000, 50, HistogramType::Exponential)
    });

}
pub mod gfx_display {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.display.count
    ///
    /// Amount of displays connected to the device (Migrated from the geckoview metric
    /// of the same name).
    pub static count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2681.into(), CommonMetricData {
            name: "count".into(),
            category: "gfx.display".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.display.primary_height
    ///
    /// Height of the primary display, takes device rotation into account. (Migrated
    /// from the geckoview metric of the same name).
    pub static primary_height: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2682.into(), CommonMetricData {
            name: "primary_height".into(),
            category: "gfx.display".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.display.primary_width
    ///
    /// Width of the primary display, takes device rotation into account. (Migrated
    /// from the geckoview metric of the same name).
    pub static primary_width: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2683.into(), CommonMetricData {
            name: "primary_width".into(),
            category: "gfx.display".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod gfx_feature {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.feature.webrender
    ///
    /// Whether webrender is enabled or disabled, and why. (Migrated from the geckoview
    /// metric of the same name).
    pub static webrender: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2684.into(), CommonMetricData {
            name: "webrender".into(),
            category: "gfx.feature".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod gfx_status {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.status.compositor
    ///
    /// Name of the graphics compositor in use. Possible values are "opengl, d3d11,
    /// client, webrender or basic" (Migrated from the geckoview metric of the same
    /// name).
    pub static compositor: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2685.into(), CommonMetricData {
            name: "compositor".into(),
            category: "gfx.status".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.status.headless
    ///
    /// Boolean indicated whether graphics is running in headless (no display) mode
    /// (Migrated from the geckoview metric of the same name).
    pub static headless: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2686.into(), CommonMetricData {
            name: "headless".into(),
            category: "gfx.status".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.status.last_compositor_gecko_version
    ///
    /// The gecko version at the last time a compositor was initialized, and therefore
    /// when gfx_status_compositor was last updated. Due to gfx_status_compositor's
    /// user lifetime we see lots of unexpected values for the current gecko version.
    /// We believe this is because the user has not opened a tab since they were
    /// updated to a version where webrender should be enabled on their device. This
    /// can be used to verify that theory. (Migrated from the geckoview metric of the
    /// same name).
    pub static last_compositor_gecko_version: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2687.into(), CommonMetricData {
            name: "last_compositor_gecko_version".into(),
            category: "gfx.status".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod gpu_process {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum CrashFallbacksLabel {
        ENone = 0,
        EDecodingDisabled = 1,
        EDisabled = 2,
        __Other__,
    }
    impl From<u16> for CrashFallbacksLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::EDecodingDisabled,
                2 => Self::EDisabled,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CrashFallbacksLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "none",
                Self::EDecodingDisabled => "decoding_disabled",
                Self::EDisabled => "disabled",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.crash_fallbacks
    ///
    /// How often we use different fallbacks when the GPU process crashes
    pub static crash_fallbacks: Lazy<LabeledMetric<LabeledCounterMetric, CrashFallbacksLabel>> = Lazy::new(|| {
        LabeledMetric::new(2688.into(), CommonMetricData {
            name: "crash_fallbacks".into(),
            category: "gpu_process".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("decoding_disabled"), ::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("none")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.feature_status
    ///
    /// Current status of the GPU process feature
    pub static feature_status: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2689.into(), CommonMetricData {
            name: "feature_status".into(),
            category: "gpu_process".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.total_launch_attempts
    ///
    /// The number of total GPU process launch attempts.
    pub static total_launch_attempts: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2690.into(), CommonMetricData {
            name: "total_launch_attempts".into(),
            category: "gpu_process".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.unstable_launch_attempts
    ///
    /// The number of consecutive unstable launch attempts.
    pub static unstable_launch_attempts: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2691.into(), CommonMetricData {
            name: "unstable_launch_attempts".into(),
            category: "gpu_process".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod paint {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from paint.build_displaylist_time
    ///
    /// The time to build a Gecko display list.
    pub static build_displaylist_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2692.into(), CommonMetricData {
            name: "build_displaylist_time".into(),
            category: "paint".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

}
pub mod wr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from wr.framebuild_time
    ///
    /// The time to rasterize glyphs for consumption by WebRender.
    pub static framebuild_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2693.into(), CommonMetricData {
            name: "framebuild_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.gpu_wait_time
    ///
    /// The time spent waiting for the GPU to complete previously issued drawing
    /// commands.
    pub static gpu_wait_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2694.into(), CommonMetricData {
            name: "gpu_wait_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.rasterize_blobs_time
    ///
    /// The time to rasterize blobs for consumption by WebRender.
    pub static rasterize_blobs_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2695.into(), CommonMetricData {
            name: "rasterize_blobs_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.rasterize_glyphs_time
    ///
    /// The time to rasterize glyphs for consumption by WebRender.
    pub static rasterize_glyphs_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2696.into(), CommonMetricData {
            name: "rasterize_glyphs_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.renderer_time
    ///
    /// WebRender renderer time.
    pub static renderer_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2697.into(), CommonMetricData {
            name: "renderer_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.renderer_time_no_sc
    ///
    /// WebRender renderer time excluding frames in which shader compilation took
    /// place.
    pub static renderer_time_no_sc: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2698.into(), CommonMetricData {
            name: "renderer_time_no_sc".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.scenebuild_time
    ///
    /// WebRender scene build time.
    pub static scenebuild_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2699.into(), CommonMetricData {
            name: "scenebuild_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.sceneswap_time
    ///
    /// WebRender scene swap time.
    pub static sceneswap_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2700.into(), CommonMetricData {
            name: "sceneswap_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.texture_cache_update_time
    ///
    /// Time taken by WebRender to update the texture cache.
    pub static texture_cache_update_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2701.into(), CommonMetricData {
            name: "texture_cache_update_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.time_to_frame_build
    ///
    /// Time elapsed between the construction of a transaction and the associated frame
    /// build beginning.
    pub static time_to_frame_build: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2702.into(), CommonMetricData {
            name: "time_to_frame_build".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.time_to_render_start
    ///
    /// Time elapsed between the construction of a frame and the start of rendering.
    pub static time_to_render_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2703.into(), CommonMetricData {
            name: "time_to_render_start".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

}
pub mod avif {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum A1lxLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for A1lxLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for A1lxLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.a1lx
    ///
    /// AV1LayeredImageIndexingProperty (a1lx). (Migrated from the geckoview metric of
    /// the same name).
    pub static a1lx: Lazy<LabeledMetric<LabeledCounterMetric, A1lxLabel>> = Lazy::new(|| {
        LabeledMetric::new(2704.into(), CommonMetricData {
            name: "a1lx".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum A1opLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for A1opLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for A1opLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.a1op
    ///
    /// AVIF OperatingPointSelectorProperty (a1op). (Migrated from the geckoview metric
    /// of the same name).
    pub static a1op: Lazy<LabeledMetric<LabeledCounterMetric, A1opLabel>> = Lazy::new(|| {
        LabeledMetric::new(2705.into(), CommonMetricData {
            name: "a1op".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum AlphaLabel {
        EAbsent = 0,
        EPresent = 1,
        __Other__,
    }
    impl From<u16> for AlphaLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAbsent,
                1 => Self::EPresent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AlphaLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAbsent => "absent",
                Self::EPresent => "present",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.alpha
    ///
    /// AVIF alpha plane. (Migrated from the geckoview metric of the same name).
    pub static alpha: Lazy<LabeledMetric<LabeledCounterMetric, AlphaLabel>> = Lazy::new(|| {
        LabeledMetric::new(2706.into(), CommonMetricData {
            name: "alpha".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum AomDecodeErrorLabel {
        EError = 0,
        EMemError = 1,
        EAbiMismatch = 2,
        EIncapable = 3,
        EUnsupBitstream = 4,
        EUnsupFeature = 5,
        ECorruptFrame = 6,
        EInvalidParam = 7,
        __Other__,
    }
    impl From<u16> for AomDecodeErrorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EError,
                1 => Self::EMemError,
                2 => Self::EAbiMismatch,
                3 => Self::EIncapable,
                4 => Self::EUnsupBitstream,
                5 => Self::EUnsupFeature,
                6 => Self::ECorruptFrame,
                7 => Self::EInvalidParam,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AomDecodeErrorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EError => "error",
                Self::EMemError => "mem_error",
                Self::EAbiMismatch => "abi_mismatch",
                Self::EIncapable => "incapable",
                Self::EUnsupBitstream => "unsup_bitstream",
                Self::EUnsupFeature => "unsup_feature",
                Self::ECorruptFrame => "corrupt_frame",
                Self::EInvalidParam => "invalid_param",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.aom_decode_error
    ///
    /// Image-decode Error from AOM decoder (Migrated from the geckoview metric of the
    /// same name).
    pub static aom_decode_error: Lazy<LabeledMetric<LabeledCounterMetric, AomDecodeErrorLabel>> = Lazy::new(|| {
        LabeledMetric::new(2707.into(), CommonMetricData {
            name: "aom_decode_error".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("abi_mismatch"), ::std::borrow::Cow::from("corrupt_frame"), ::std::borrow::Cow::from("error"), ::std::borrow::Cow::from("incapable"), ::std::borrow::Cow::from("invalid_param"), ::std::borrow::Cow::from("mem_error"), ::std::borrow::Cow::from("unsup_bitstream"), ::std::borrow::Cow::from("unsup_feature")]))
    });

    #[repr(u16)]
    pub enum BitDepthLabel {
        EColor8 = 0,
        EColor10 = 1,
        EColor12 = 2,
        EColor16 = 3,
        EUnknown = 4,
        __Other__,
    }
    impl From<u16> for BitDepthLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EColor8,
                1 => Self::EColor10,
                2 => Self::EColor12,
                3 => Self::EColor16,
                4 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BitDepthLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EColor8 => "color_8",
                Self::EColor10 => "color_10",
                Self::EColor12 => "color_12",
                Self::EColor16 => "color_16",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.bit_depth
    ///
    /// Bits per pixel of AVIF image. (Migrated from the geckoview metric of the same
    /// name).
    pub static bit_depth: Lazy<LabeledMetric<LabeledCounterMetric, BitDepthLabel>> = Lazy::new(|| {
        LabeledMetric::new(2708.into(), CommonMetricData {
            name: "bit_depth".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("color_10"), ::std::borrow::Cow::from("color_12"), ::std::borrow::Cow::from("color_16"), ::std::borrow::Cow::from("color_8"), ::std::borrow::Cow::from("unknown")]))
    });

    #[repr(u16)]
    pub enum CicpCpLabel {
        EReserved = 0,
        EBt709 = 1,
        EUnspecified = 2,
        EReserved3 = 3,
        EBt470m = 4,
        EBt470bg = 5,
        EBt601 = 6,
        ESmpte240 = 7,
        EGenericFilm = 8,
        EBt2020 = 9,
        EXyz = 10,
        ESmpte431 = 11,
        ESmpte432 = 12,
        EReserved13 = 13,
        EReserved14 = 14,
        EReserved15 = 15,
        EReserved16 = 16,
        EReserved17 = 17,
        EReserved18 = 18,
        EReserved19 = 19,
        EReserved20 = 20,
        EReserved21 = 21,
        EEbu3213 = 22,
        EReservedRest = 23,
        __Other__,
    }
    impl From<u16> for CicpCpLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EReserved,
                1 => Self::EBt709,
                2 => Self::EUnspecified,
                3 => Self::EReserved3,
                4 => Self::EBt470m,
                5 => Self::EBt470bg,
                6 => Self::EBt601,
                7 => Self::ESmpte240,
                8 => Self::EGenericFilm,
                9 => Self::EBt2020,
                10 => Self::EXyz,
                11 => Self::ESmpte431,
                12 => Self::ESmpte432,
                13 => Self::EReserved13,
                14 => Self::EReserved14,
                15 => Self::EReserved15,
                16 => Self::EReserved16,
                17 => Self::EReserved17,
                18 => Self::EReserved18,
                19 => Self::EReserved19,
                20 => Self::EReserved20,
                21 => Self::EReserved21,
                22 => Self::EEbu3213,
                23 => Self::EReservedRest,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CicpCpLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EReserved => "reserved",
                Self::EBt709 => "bt709",
                Self::EUnspecified => "unspecified",
                Self::EReserved3 => "reserved_3",
                Self::EBt470m => "bt470m",
                Self::EBt470bg => "bt470bg",
                Self::EBt601 => "bt601",
                Self::ESmpte240 => "smpte240",
                Self::EGenericFilm => "generic_film",
                Self::EBt2020 => "bt2020",
                Self::EXyz => "xyz",
                Self::ESmpte431 => "smpte431",
                Self::ESmpte432 => "smpte432",
                Self::EReserved13 => "reserved_13",
                Self::EReserved14 => "reserved_14",
                Self::EReserved15 => "reserved_15",
                Self::EReserved16 => "reserved_16",
                Self::EReserved17 => "reserved_17",
                Self::EReserved18 => "reserved_18",
                Self::EReserved19 => "reserved_19",
                Self::EReserved20 => "reserved_20",
                Self::EReserved21 => "reserved_21",
                Self::EEbu3213 => "ebu3213",
                Self::EReservedRest => "reserved_rest",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.cicp_cp
    ///
    /// AVIF CICP colour primaries. (Migrated from the geckoview metric of the same
    /// name).
    pub static cicp_cp: Lazy<LabeledMetric<LabeledCounterMetric, CicpCpLabel>> = Lazy::new(|| {
        LabeledMetric::new(2709.into(), CommonMetricData {
            name: "cicp_cp".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("bt2020"), ::std::borrow::Cow::from("bt470bg"), ::std::borrow::Cow::from("bt470m"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("ebu3213"), ::std::borrow::Cow::from("generic_film"), ::std::borrow::Cow::from("reserved"), ::std::borrow::Cow::from("reserved_13"), ::std::borrow::Cow::from("reserved_14"), ::std::borrow::Cow::from("reserved_15"), ::std::borrow::Cow::from("reserved_16"), ::std::borrow::Cow::from("reserved_17"), ::std::borrow::Cow::from("reserved_18"), ::std::borrow::Cow::from("reserved_19"), ::std::borrow::Cow::from("reserved_20"), ::std::borrow::Cow::from("reserved_21"), ::std::borrow::Cow::from("reserved_3"), ::std::borrow::Cow::from("reserved_rest"), ::std::borrow::Cow::from("smpte240"), ::std::borrow::Cow::from("smpte431"), ::std::borrow::Cow::from("smpte432"), ::std::borrow::Cow::from("unspecified"), ::std::borrow::Cow::from("xyz")]))
    });

    #[repr(u16)]
    pub enum CicpMcLabel {
        EIdentity = 0,
        EBt709 = 1,
        EUnspecified = 2,
        EReserved = 3,
        EFcc = 4,
        EBt470bg = 5,
        EBt601 = 6,
        ESmpte240 = 7,
        EYcgco = 8,
        EBt2020Ncl = 9,
        EBt2020Cl = 10,
        ESmpte2085 = 11,
        EChromatNcl = 12,
        EChromatCl = 13,
        EIctcp = 14,
        EReservedRest = 15,
        __Other__,
    }
    impl From<u16> for CicpMcLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EIdentity,
                1 => Self::EBt709,
                2 => Self::EUnspecified,
                3 => Self::EReserved,
                4 => Self::EFcc,
                5 => Self::EBt470bg,
                6 => Self::EBt601,
                7 => Self::ESmpte240,
                8 => Self::EYcgco,
                9 => Self::EBt2020Ncl,
                10 => Self::EBt2020Cl,
                11 => Self::ESmpte2085,
                12 => Self::EChromatNcl,
                13 => Self::EChromatCl,
                14 => Self::EIctcp,
                15 => Self::EReservedRest,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CicpMcLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EIdentity => "identity",
                Self::EBt709 => "bt709",
                Self::EUnspecified => "unspecified",
                Self::EReserved => "reserved",
                Self::EFcc => "fcc",
                Self::EBt470bg => "bt470bg",
                Self::EBt601 => "bt601",
                Self::ESmpte240 => "smpte240",
                Self::EYcgco => "ycgco",
                Self::EBt2020Ncl => "bt2020_ncl",
                Self::EBt2020Cl => "bt2020_cl",
                Self::ESmpte2085 => "smpte2085",
                Self::EChromatNcl => "chromat_ncl",
                Self::EChromatCl => "chromat_cl",
                Self::EIctcp => "ictcp",
                Self::EReservedRest => "reserved_rest",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.cicp_mc
    ///
    /// AVIF CICP transfer characteristics. (Migrated from the geckoview metric of the
    /// same name).
    pub static cicp_mc: Lazy<LabeledMetric<LabeledCounterMetric, CicpMcLabel>> = Lazy::new(|| {
        LabeledMetric::new(2710.into(), CommonMetricData {
            name: "cicp_mc".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("bt2020_cl"), ::std::borrow::Cow::from("bt2020_ncl"), ::std::borrow::Cow::from("bt470bg"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("chromat_cl"), ::std::borrow::Cow::from("chromat_ncl"), ::std::borrow::Cow::from("fcc"), ::std::borrow::Cow::from("ictcp"), ::std::borrow::Cow::from("identity"), ::std::borrow::Cow::from("reserved"), ::std::borrow::Cow::from("reserved_rest"), ::std::borrow::Cow::from("smpte2085"), ::std::borrow::Cow::from("smpte240"), ::std::borrow::Cow::from("unspecified"), ::std::borrow::Cow::from("ycgco")]))
    });

    #[repr(u16)]
    pub enum CicpTcLabel {
        EReserved = 0,
        EBt709 = 1,
        EUnspecified = 2,
        EReserved3 = 3,
        EBt470m = 4,
        EBt470bg = 5,
        EBt601 = 6,
        ESmpte240 = 7,
        ELinear = 8,
        ELog100 = 9,
        ELog100Sqrt10 = 10,
        EIec61966 = 11,
        EBt1361 = 12,
        ESrgb = 13,
        EBt202010bit = 14,
        EBt202012bit = 15,
        ESmpte2084 = 16,
        ESmpte428 = 17,
        EHlg = 18,
        EReservedRest = 19,
        __Other__,
    }
    impl From<u16> for CicpTcLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EReserved,
                1 => Self::EBt709,
                2 => Self::EUnspecified,
                3 => Self::EReserved3,
                4 => Self::EBt470m,
                5 => Self::EBt470bg,
                6 => Self::EBt601,
                7 => Self::ESmpte240,
                8 => Self::ELinear,
                9 => Self::ELog100,
                10 => Self::ELog100Sqrt10,
                11 => Self::EIec61966,
                12 => Self::EBt1361,
                13 => Self::ESrgb,
                14 => Self::EBt202010bit,
                15 => Self::EBt202012bit,
                16 => Self::ESmpte2084,
                17 => Self::ESmpte428,
                18 => Self::EHlg,
                19 => Self::EReservedRest,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CicpTcLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EReserved => "reserved",
                Self::EBt709 => "bt709",
                Self::EUnspecified => "unspecified",
                Self::EReserved3 => "reserved_3",
                Self::EBt470m => "bt470m",
                Self::EBt470bg => "bt470bg",
                Self::EBt601 => "bt601",
                Self::ESmpte240 => "smpte240",
                Self::ELinear => "linear",
                Self::ELog100 => "log_100",
                Self::ELog100Sqrt10 => "log_100_sqrt10",
                Self::EIec61966 => "iec61966",
                Self::EBt1361 => "bt_1361",
                Self::ESrgb => "srgb",
                Self::EBt202010bit => "bt2020_10bit",
                Self::EBt202012bit => "bt2020_12bit",
                Self::ESmpte2084 => "smpte2084",
                Self::ESmpte428 => "smpte428",
                Self::EHlg => "hlg",
                Self::EReservedRest => "reserved_rest",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.cicp_tc
    ///
    /// AVIF CICP transfer characteristics. (Migrated from the geckoview metric of the
    /// same name).
    pub static cicp_tc: Lazy<LabeledMetric<LabeledCounterMetric, CicpTcLabel>> = Lazy::new(|| {
        LabeledMetric::new(2711.into(), CommonMetricData {
            name: "cicp_tc".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("bt2020_10bit"), ::std::borrow::Cow::from("bt2020_12bit"), ::std::borrow::Cow::from("bt470bg"), ::std::borrow::Cow::from("bt470m"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("bt_1361"), ::std::borrow::Cow::from("hlg"), ::std::borrow::Cow::from("iec61966"), ::std::borrow::Cow::from("linear"), ::std::borrow::Cow::from("log_100"), ::std::borrow::Cow::from("log_100_sqrt10"), ::std::borrow::Cow::from("reserved"), ::std::borrow::Cow::from("reserved_3"), ::std::borrow::Cow::from("reserved_rest"), ::std::borrow::Cow::from("smpte2084"), ::std::borrow::Cow::from("smpte240"), ::std::borrow::Cow::from("smpte428"), ::std::borrow::Cow::from("srgb"), ::std::borrow::Cow::from("unspecified")]))
    });

    #[repr(u16)]
    pub enum ClapLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for ClapLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ClapLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.clap
    ///
    /// AVIF CleanApertureBox (clap). (Migrated from the geckoview metric of the same
    /// name).
    pub static clap: Lazy<LabeledMetric<LabeledCounterMetric, ClapLabel>> = Lazy::new(|| {
        LabeledMetric::new(2712.into(), CommonMetricData {
            name: "clap".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum ColrLabel {
        ENclx = 0,
        EIcc = 1,
        EAbsent = 2,
        EBoth = 3,
        __Other__,
    }
    impl From<u16> for ColrLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENclx,
                1 => Self::EIcc,
                2 => Self::EAbsent,
                3 => Self::EBoth,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ColrLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENclx => "nclx",
                Self::EIcc => "icc",
                Self::EAbsent => "absent",
                Self::EBoth => "both",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.colr
    ///
    /// AVIF colour information type. (Migrated from the geckoview metric of the same
    /// name).
    pub static colr: Lazy<LabeledMetric<LabeledCounterMetric, ColrLabel>> = Lazy::new(|| {
        LabeledMetric::new(2713.into(), CommonMetricData {
            name: "colr".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("both"), ::std::borrow::Cow::from("icc"), ::std::borrow::Cow::from("nclx")]))
    });

    #[repr(u16)]
    pub enum DecodeResultLabel {
        ESuccess = 0,
        EParseError = 1,
        ENoPrimaryItem = 2,
        EDecodeError = 3,
        ESizeOverflow = 4,
        EOutOfMemory = 5,
        EPipeInitError = 6,
        EWriteBufferError = 7,
        EAlphaYSzMismatch = 8,
        EAlphaYBpcMismatch = 9,
        EIspeMismatch = 10,
        ERenderSizeMismatch = 11,
        EFrameSizeChanged = 12,
        EInvalidCicp = 13,
        EInvalidParseStatus = 14,
        EMissingBrand = 15,
        EFtypNotFirst = 16,
        ENoImage = 17,
        EMultipleMoov = 18,
        ENoMoov = 19,
        ELselNoEssential = 20,
        EA1opNoEssential = 21,
        EA1lxEssential = 22,
        ETxformNoEssential = 23,
        EImageItemType = 24,
        EItemTypeMissing = 25,
        EConstructionMethod = 26,
        EItemLocNotFound = 27,
        ENoItemDataBox = 28,
        ENoSamples = 29,
        EUncategorized = 30,
        __Other__,
    }
    impl From<u16> for DecodeResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EParseError,
                2 => Self::ENoPrimaryItem,
                3 => Self::EDecodeError,
                4 => Self::ESizeOverflow,
                5 => Self::EOutOfMemory,
                6 => Self::EPipeInitError,
                7 => Self::EWriteBufferError,
                8 => Self::EAlphaYSzMismatch,
                9 => Self::EAlphaYBpcMismatch,
                10 => Self::EIspeMismatch,
                11 => Self::ERenderSizeMismatch,
                12 => Self::EFrameSizeChanged,
                13 => Self::EInvalidCicp,
                14 => Self::EInvalidParseStatus,
                15 => Self::EMissingBrand,
                16 => Self::EFtypNotFirst,
                17 => Self::ENoImage,
                18 => Self::EMultipleMoov,
                19 => Self::ENoMoov,
                20 => Self::ELselNoEssential,
                21 => Self::EA1opNoEssential,
                22 => Self::EA1lxEssential,
                23 => Self::ETxformNoEssential,
                24 => Self::EImageItemType,
                25 => Self::EItemTypeMissing,
                26 => Self::EConstructionMethod,
                27 => Self::EItemLocNotFound,
                28 => Self::ENoItemDataBox,
                29 => Self::ENoSamples,
                30 => Self::EUncategorized,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DecodeResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EParseError => "parse_error",
                Self::ENoPrimaryItem => "no_primary_item",
                Self::EDecodeError => "decode_error",
                Self::ESizeOverflow => "size_overflow",
                Self::EOutOfMemory => "out_of_memory",
                Self::EPipeInitError => "pipe_init_error",
                Self::EWriteBufferError => "write_buffer_error",
                Self::EAlphaYSzMismatch => "alpha_y_sz_mismatch",
                Self::EAlphaYBpcMismatch => "alpha_y_bpc_mismatch",
                Self::EIspeMismatch => "ispe_mismatch",
                Self::ERenderSizeMismatch => "render_size_mismatch",
                Self::EFrameSizeChanged => "frame_size_changed",
                Self::EInvalidCicp => "invalid_cicp",
                Self::EInvalidParseStatus => "invalid_parse_status",
                Self::EMissingBrand => "missing_brand",
                Self::EFtypNotFirst => "ftyp_not_first",
                Self::ENoImage => "no_image",
                Self::EMultipleMoov => "multiple_moov",
                Self::ENoMoov => "no_moov",
                Self::ELselNoEssential => "lsel_no_essential",
                Self::EA1opNoEssential => "a1op_no_essential",
                Self::EA1lxEssential => "a1lx_essential",
                Self::ETxformNoEssential => "txform_no_essential",
                Self::EImageItemType => "image_item_type",
                Self::EItemTypeMissing => "item_type_missing",
                Self::EConstructionMethod => "construction_method",
                Self::EItemLocNotFound => "item_loc_not_found",
                Self::ENoItemDataBox => "no_item_data_box",
                Self::ENoSamples => "no_samples",
                Self::EUncategorized => "uncategorized",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.decode_result
    ///
    /// Decode result of AVIF image. (Migrated from the geckoview metric of the same
    /// name).
    pub static decode_result: Lazy<LabeledMetric<LabeledCounterMetric, DecodeResultLabel>> = Lazy::new(|| {
        LabeledMetric::new(2714.into(), CommonMetricData {
            name: "decode_result".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("a1lx_essential"), ::std::borrow::Cow::from("a1op_no_essential"), ::std::borrow::Cow::from("alpha_y_bpc_mismatch"), ::std::borrow::Cow::from("alpha_y_sz_mismatch"), ::std::borrow::Cow::from("construction_method"), ::std::borrow::Cow::from("decode_error"), ::std::borrow::Cow::from("frame_size_changed"), ::std::borrow::Cow::from("ftyp_not_first"), ::std::borrow::Cow::from("image_item_type"), ::std::borrow::Cow::from("invalid_cicp"), ::std::borrow::Cow::from("invalid_parse_status"), ::std::borrow::Cow::from("ispe_mismatch"), ::std::borrow::Cow::from("item_loc_not_found"), ::std::borrow::Cow::from("item_type_missing"), ::std::borrow::Cow::from("lsel_no_essential"), ::std::borrow::Cow::from("missing_brand"), ::std::borrow::Cow::from("multiple_moov"), ::std::borrow::Cow::from("no_image"), ::std::borrow::Cow::from("no_item_data_box"), ::std::borrow::Cow::from("no_moov"), ::std::borrow::Cow::from("no_primary_item"), ::std::borrow::Cow::from("no_samples"), ::std::borrow::Cow::from("out_of_memory"), ::std::borrow::Cow::from("parse_error"), ::std::borrow::Cow::from("pipe_init_error"), ::std::borrow::Cow::from("render_size_mismatch"), ::std::borrow::Cow::from("size_overflow"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("txform_no_essential"), ::std::borrow::Cow::from("uncategorized"), ::std::borrow::Cow::from("write_buffer_error")]))
    });

    #[repr(u16)]
    pub enum DecoderLabel {
        EDav1d = 0,
        EAom = 1,
        __Other__,
    }
    impl From<u16> for DecoderLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDav1d,
                1 => Self::EAom,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DecoderLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDav1d => "dav1d",
                Self::EAom => "aom",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.decoder
    ///
    /// Decoder of AVIF image. (Migrated from the geckoview metric of the same name).
    pub static decoder: Lazy<LabeledMetric<LabeledCounterMetric, DecoderLabel>> = Lazy::new(|| {
        LabeledMetric::new(2715.into(), CommonMetricData {
            name: "decoder".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("aom"), ::std::borrow::Cow::from("dav1d")]))
    });

    #[repr(u16)]
    pub enum GridLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for GridLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GridLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.grid
    ///
    /// AVIF AVIF grid-based image. (Migrated from the geckoview metric of the same
    /// name).
    pub static grid: Lazy<LabeledMetric<LabeledCounterMetric, GridLabel>> = Lazy::new(|| {
        LabeledMetric::new(2716.into(), CommonMetricData {
            name: "grid".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum IproLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for IproLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IproLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.ipro
    ///
    /// AVIF ItemProtectionBox (ipro). (Migrated from the geckoview metric of the same
    /// name).
    pub static ipro: Lazy<LabeledMetric<LabeledCounterMetric, IproLabel>> = Lazy::new(|| {
        LabeledMetric::new(2717.into(), CommonMetricData {
            name: "ipro".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum IspeLabel {
        EValid = 0,
        EAbsent = 1,
        EBitstreamMismatch = 2,
        __Other__,
    }
    impl From<u16> for IspeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EValid,
                1 => Self::EAbsent,
                2 => Self::EBitstreamMismatch,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IspeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EValid => "valid",
                Self::EAbsent => "absent",
                Self::EBitstreamMismatch => "bitstream_mismatch",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.ispe
    ///
    /// AVIF spatial extents (image size). (Migrated from the geckoview metric of the
    /// same name).
    pub static ispe: Lazy<LabeledMetric<LabeledCounterMetric, IspeLabel>> = Lazy::new(|| {
        LabeledMetric::new(2718.into(), CommonMetricData {
            name: "ispe".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("bitstream_mismatch"), ::std::borrow::Cow::from("valid")]))
    });

    #[repr(u16)]
    pub enum LselLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for LselLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LselLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.lsel
    ///
    /// AVIF LayerSelectorProperty (lsel). (Migrated from the geckoview metric of the
    /// same name).
    pub static lsel: Lazy<LabeledMetric<LabeledCounterMetric, LselLabel>> = Lazy::new(|| {
        LabeledMetric::new(2719.into(), CommonMetricData {
            name: "lsel".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum PaspLabel {
        EAbsent = 0,
        ESquare = 1,
        ENonsquare = 2,
        EInvalid = 3,
        __Other__,
    }
    impl From<u16> for PaspLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAbsent,
                1 => Self::ESquare,
                2 => Self::ENonsquare,
                3 => Self::EInvalid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PaspLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAbsent => "absent",
                Self::ESquare => "square",
                Self::ENonsquare => "nonsquare",
                Self::EInvalid => "invalid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.pasp
    ///
    /// AVIF pixel aspect ratio. (Migrated from the geckoview metric of the same name).
    pub static pasp: Lazy<LabeledMetric<LabeledCounterMetric, PaspLabel>> = Lazy::new(|| {
        LabeledMetric::new(2720.into(), CommonMetricData {
            name: "pasp".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("nonsquare"), ::std::borrow::Cow::from("square")]))
    });

    #[repr(u16)]
    pub enum PixiLabel {
        EValid = 0,
        EAbsent = 1,
        EBitstreamMismatch = 2,
        __Other__,
    }
    impl From<u16> for PixiLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EValid,
                1 => Self::EAbsent,
                2 => Self::EBitstreamMismatch,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PixiLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EValid => "valid",
                Self::EAbsent => "absent",
                Self::EBitstreamMismatch => "bitstream_mismatch",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.pixi
    ///
    /// AVIF pixel information (bits per channel). (Migrated from the geckoview metric
    /// of the same name).
    pub static pixi: Lazy<LabeledMetric<LabeledCounterMetric, PixiLabel>> = Lazy::new(|| {
        LabeledMetric::new(2721.into(), CommonMetricData {
            name: "pixi".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("bitstream_mismatch"), ::std::borrow::Cow::from("valid")]))
    });

    #[repr(u16)]
    pub enum YuvColorSpaceLabel {
        EBt601 = 0,
        EBt709 = 1,
        EBt2020 = 2,
        EIdentity = 3,
        EUnknown = 4,
        __Other__,
    }
    impl From<u16> for YuvColorSpaceLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBt601,
                1 => Self::EBt709,
                2 => Self::EBt2020,
                3 => Self::EIdentity,
                4 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for YuvColorSpaceLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBt601 => "bt601",
                Self::EBt709 => "bt709",
                Self::EBt2020 => "bt2020",
                Self::EIdentity => "identity",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.yuv_color_space
    ///
    /// YUV color space of AVIF image. (Migrated from the geckoview metric of the same
    /// name).
    pub static yuv_color_space: Lazy<LabeledMetric<LabeledCounterMetric, YuvColorSpaceLabel>> = Lazy::new(|| {
        LabeledMetric::new(2722.into(), CommonMetricData {
            name: "yuv_color_space".into(),
            category: "avif".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("bt2020"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("identity"), ::std::borrow::Cow::from("unknown")]))
    });

}
pub mod javascript_gc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.compact_time
    ///
    /// The time spent in the compact phase. (Migrated from the geckoview metric of the
    /// same name.)
    pub static compact_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2723.into(), CommonMetricData {
            name: "compact_time".into(),
            category: "javascript.gc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.mark_roots_time
    ///
    /// The time spent marking GC roots. (Migrated from the geckoview metric of the
    /// same name.)
    pub static mark_roots_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2724.into(), CommonMetricData {
            name: "mark_roots_time".into(),
            category: "javascript.gc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.mark_time
    ///
    /// The time spent in the mark phase. (Migrated from the geckoview metric of the
    /// same name.)
    pub static mark_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2725.into(), CommonMetricData {
            name: "mark_time".into(),
            category: "javascript.gc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.minor_time
    ///
    /// The time taked by a minor (nursery) collection. (Migrated from the geckoview
    /// metric of the same name.)
    pub static minor_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2726.into(), CommonMetricData {
            name: "minor_time".into(),
            category: "javascript.gc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.prepare_time
    ///
    /// The time spent in the preparation phase. (Migrated from the geckoview metric of
    /// the same name.)
    pub static prepare_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2727.into(), CommonMetricData {
            name: "prepare_time".into(),
            category: "javascript.gc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.slice_time
    ///
    /// The time spent running a GC slice. (Migrated from the geckoview metric of the
    /// same name.)
    pub static slice_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2728.into(), CommonMetricData {
            name: "slice_time".into(),
            category: "javascript.gc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.sweep_time
    ///
    /// The time spent in the sweep phase. (Migrated from the geckoview metric of the
    /// same name.)
    pub static sweep_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2729.into(), CommonMetricData {
            name: "sweep_time".into(),
            category: "javascript.gc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.total_time
    ///
    /// The total time taken by a major collection. (Migrated from the geckoview metric
    /// of the same name.)
    pub static total_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2730.into(), CommonMetricData {
            name: "total_time".into(),
            category: "javascript.gc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod performance_clone_deserialize {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.clone.deserialize.items
    ///
    /// Size of deserialized data, in items
    pub static items: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2731.into(), CommonMetricData {
            name: "items".into(),
            category: "performance.clone.deserialize".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 2147483646, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.clone.deserialize.size
    ///
    /// Size of deserialized data, in bytes
    pub static size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(2732.into(), CommonMetricData {
            name: "size".into(),
            category: "performance.clone.deserialize".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.clone.deserialize.time
    ///
    /// Time spent deserializing structured data
    pub static time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2733.into(), CommonMetricData {
            name: "time".into(),
            category: "performance.clone.deserialize".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

}
pub mod performance_responsiveness {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.responsiveness.req_anim_frame_callback
    ///
    /// Time spent in milliseconds calling all request animation frame callbacks for a
    /// document after it has reached readystate complete. (Migrated from the geckoview
    /// metric of the same name.)
    pub static req_anim_frame_callback: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2734.into(), CommonMetricData {
            name: "req_anim_frame_callback".into(),
            category: "performance.responsiveness".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod geckoview {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.content_process_lifetime
    ///
    /// The uptime of content processes. (Migrated from the geckoview metric of the
    /// same name).
    pub static content_process_lifetime: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2735.into(), CommonMetricData {
            name: "content_process_lifetime".into(),
            category: "geckoview".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.document_site_origins
    ///
    /// When a document is loaded, report the number of [site
    /// origins](https://searchfox.org/ mozilla-central/rev/
    /// 3300072e993ae05d50d5c63d815260367eaf9179/ caps/nsIPrincipal.idl#264) of the
    /// entire browser if it has been at least 5 minutes since last time we collect
    /// this data. (Migrated from the geckoview metric of the same name).
    pub static document_site_origins: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2736.into(), CommonMetricData {
            name: "document_site_origins".into(),
            category: "geckoview".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 100, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.page_load_progress_time
    ///
    /// Time between page load progress starts (0) and completion (100). (Migrated from
    /// the geckoview metric of the same name).
    pub static page_load_progress_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2737.into(), CommonMetricData {
            name: "page_load_progress_time".into(),
            category: "geckoview".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.page_load_time
    ///
    /// The time taken to load a page. This includes all static contents, no dynamic
    /// content. Loading of about: pages is not counted. Back back navigation
    /// (sometimes via BFCache) is included which is a source of bimodality due to the
    /// <50ms load times. (Migrated from the geckoview metric of the same name).
    pub static page_load_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2738.into(), CommonMetricData {
            name: "page_load_time".into(),
            category: "geckoview".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.page_reload_time
    ///
    /// Time taken to reload a page. This includes all static contents, no dynamic
    /// content. Loading of about: pages is not counted. (Migrated from the geckoview
    /// metric of the same name).
    pub static page_reload_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2739.into(), CommonMetricData {
            name: "page_reload_time".into(),
            category: "geckoview".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.per_document_site_origins
    ///
    /// When a document is unloaded, report the highest number of [site
    /// origins](https://searchfox.org/ mozilla-central/rev/
    /// 3300072e993ae05d50d5c63d815260367eaf9179/ caps/nsIPrincipal.idl#264) loaded
    /// simultaneously in that document. (Migrated from the geckoview metric of the
    /// same name).
    pub static per_document_site_origins: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2740.into(), CommonMetricData {
            name: "per_document_site_origins".into(),
            category: "geckoview".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 100, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.startup_runtime
    ///
    /// The time taken to initialize GeckoRuntime. (Migrated from the geckoview metric
    /// of the same name).
    pub static startup_runtime: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2741.into(), CommonMetricData {
            name: "startup_runtime".into(),
            category: "geckoview".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod networking {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_access_fixup_diff
    ///
    /// If we fix up a cookie lastAccessed timestamp that is in the future this metric
    /// records the number of seconds that timestamp was off from NOW.
    pub static cookie_access_fixup_diff: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2742.into(), CommonMetricData {
            name: "cookie_access_fixup_diff".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 315360000000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_part_by_key
    ///
    /// A distribution of the partitioned cookies in storage belonging to a particular
    /// cookie key (host + origin attributes)
    pub static cookie_count_part_by_key: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2743.into(), CommonMetricData {
            name: "cookie_count_part_by_key".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 220, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_partitioned
    ///
    /// Reports the number of partitioned cookies in storage
    pub static cookie_count_partitioned: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2744.into(), CommonMetricData {
            name: "cookie_count_partitioned".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 4000, 22, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_total
    ///
    /// Reports the total number of cookies in storage
    pub static cookie_count_total: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2745.into(), CommonMetricData {
            name: "cookie_count_total".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 4000, 22, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_unpart_by_key
    ///
    /// A distribution of the unpartitioned cookies in storage belonging to a
    /// particular cookie key (host + origin attributes)
    pub static cookie_count_unpart_by_key: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2746.into(), CommonMetricData {
            name: "cookie_count_unpart_by_key".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 220, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_unpartitioned
    ///
    /// Reports the number of unpartitioned cookies in storage
    pub static cookie_count_unpartitioned: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2747.into(), CommonMetricData {
            name: "cookie_count_unpartitioned".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 4000, 22, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_creation_fixup_diff
    ///
    /// If we fix up a cookie creation timestamp that is in the future this metric
    /// records the number of seconds that timestamp was off from NOW.
    pub static cookie_creation_fixup_diff: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2748.into(), CommonMetricData {
            name: "cookie_creation_fixup_diff".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 315360000000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_purge_entry_max
    ///
    /// A distribution of the number of cookies purged for a single host + OA entry as
    /// a result of exceeding the maximum threshold for the given host + OA (single
    /// purge)
    pub static cookie_purge_entry_max: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2749.into(), CommonMetricData {
            name: "cookie_purge_entry_max".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 220, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_purge_max
    ///
    /// A distribution of the number of cookies purged across all host + OAs as a
    /// result of exceeding the cookie maximum threshold (single purge)
    pub static cookie_purge_max: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2750.into(), CommonMetricData {
            name: "cookie_purge_max".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 4000, 22, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum CookieTimestampFixedCountLabel {
        ECreationtime = 0,
        ELastaccessed = 1,
        __Other__,
    }
    impl From<u16> for CookieTimestampFixedCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECreationtime,
                1 => Self::ELastaccessed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CookieTimestampFixedCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECreationtime => "creationTime",
                Self::ELastaccessed => "lastAccessed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_timestamp_fixed_count
    ///
    /// Counts the number of times a cookie's invalid timestamp was fixed when reading
    /// it from the DB.
    pub static cookie_timestamp_fixed_count: Lazy<LabeledMetric<LabeledCounterMetric, CookieTimestampFixedCountLabel>> = Lazy::new(|| {
        LabeledMetric::new(2751.into(), CommonMetricData {
            name: "cookie_timestamp_fixed_count".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("creationTime"), ::std::borrow::Cow::from("lastAccessed")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_failed_lookup_time
    ///
    /// Time for an unsuccessful DNS OS resolution (msec) | Migrated from Firefox
    /// Telemetry's `DNS_FAILED_LOOKUP_TIME`.
    pub static dns_failed_lookup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2752.into(), CommonMetricData {
            name: "dns_failed_lookup_time".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_lookup_time
    ///
    /// Time for a successful DNS resolution (msec) | Migrated from Firefox Telemetry's
    /// `DNS_LOOKUP_TIME`.
    pub static dns_lookup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2753.into(), CommonMetricData {
            name: "dns_lookup_time".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum DnsNativeCountLabel {
        ERegular = 0,
        EPrivate = 1,
        EHttpsRegular = 2,
        EHttpsPrivate = 3,
        __Other__,
    }
    impl From<u16> for DnsNativeCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERegular,
                1 => Self::EPrivate,
                2 => Self::EHttpsRegular,
                3 => Self::EHttpsPrivate,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DnsNativeCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERegular => "regular",
                Self::EPrivate => "private",
                Self::EHttpsRegular => "https_regular",
                Self::EHttpsPrivate => "https_private",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_native_count
    ///
    /// The count of calls to the native DNS APIs
    pub static dns_native_count: Lazy<LabeledMetric<LabeledCounterMetric, DnsNativeCountLabel>> = Lazy::new(|| {
        LabeledMetric::new(2754.into(), CommonMetricData {
            name: "dns_native_count".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("https_private"), ::std::borrow::Cow::from("https_regular"), ::std::borrow::Cow::from("private"), ::std::borrow::Cow::from("regular")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_native_https_call_time
    ///
    /// Time spent in the call to the native OS DNS resolution.
    pub static dns_native_https_call_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2755.into(), CommonMetricData {
            name: "dns_native_https_call_time".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_renewal_time
    ///
    /// Time for a renewed DNS OS resolution (msec) | Migrated from Firefox Telemetry's
    /// `DNS_RENEWAL_TIME`.
    pub static dns_renewal_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2756.into(), CommonMetricData {
            name: "dns_renewal_time".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_renewal_time_for_ttl
    ///
    /// Time for a DNS OS resolution (msec) used to get TTL | Migrated from Firefox
    /// Telemetry's `DNS_RENEWAL_TIME_FOR_TTL`.
    pub static dns_renewal_time_for_ttl: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2757.into(), CommonMetricData {
            name: "dns_renewal_time_for_ttl".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_download_throughput
    ///
    /// The download throughput for  http/1.0, http/1.1 requests larger than 10MB.
    /// Measured in megabits per second, Mbps.
    pub static http_1_download_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2758.into(), CommonMetricData {
            name: "http_1_download_throughput".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput
    ///
    /// The upload throughput for http/1.0, http/1.1 requests larger than 10MB.
    /// Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2759.into(), CommonMetricData {
            name: "http_1_upload_throughput".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput_100
    ///
    /// The upload throughput for http/1.0, http/1.1 request size larger than 100MB.
    /// Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2760.into(), CommonMetricData {
            name: "http_1_upload_throughput_100".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput_10_50
    ///
    /// The upload throughput for http/1.0, http/1.1 request size between 10MB and
    /// 50MB. Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2761.into(), CommonMetricData {
            name: "http_1_upload_throughput_10_50".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput_50_100
    ///
    /// The upload throughput for http/1.0, http/1.1 request size between 50MB and
    /// 100MB. Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2762.into(), CommonMetricData {
            name: "http_1_upload_throughput_50_100".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_download_throughput
    ///
    /// The download throughput for http/2 requests larger than 10MB. Measured in
    /// megabits per second, Mbps.
    pub static http_2_download_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2763.into(), CommonMetricData {
            name: "http_2_download_throughput".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput
    ///
    /// The upload throughput for http/2 requests larger than 10MB. Measured in
    /// megabits per second, Mbps.
    pub static http_2_upload_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2764.into(), CommonMetricData {
            name: "http_2_upload_throughput".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput_100
    ///
    /// The upload throughput for http/2 request size larger than 100MB. Measured in
    /// megabits per second, Mbps.
    pub static http_2_upload_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2765.into(), CommonMetricData {
            name: "http_2_upload_throughput_100".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput_10_50
    ///
    /// The upload throughput for http/2 request size between 10MB and 50MB. Measured
    /// in megabits per second, Mbps.
    pub static http_2_upload_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2766.into(), CommonMetricData {
            name: "http_2_upload_throughput_10_50".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput_50_100
    ///
    /// The upload throughput for http/2 request size between 50MB and 100MB. Measured
    /// in megabits per second, Mbps.
    pub static http_2_upload_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2767.into(), CommonMetricData {
            name: "http_2_upload_throughput_50_100".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_download_throughput
    ///
    /// The download throughput for http/3 requests larger than 10MB. Measured in
    /// megabits per second, Mbps.
    pub static http_3_download_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2768.into(), CommonMetricData {
            name: "http_3_download_throughput".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput
    ///
    /// The upload throughput for http/3 requests larger than 10MB. Measured in
    /// megabits per second, Mbps.
    pub static http_3_upload_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2769.into(), CommonMetricData {
            name: "http_3_upload_throughput".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput_100
    ///
    /// The upload throughput for http/3 request size larger than 100MB. Measured in
    /// megabits per second, Mbps.
    pub static http_3_upload_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2770.into(), CommonMetricData {
            name: "http_3_upload_throughput_100".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput_10_50
    ///
    /// The upload throughput for http/3 request size between 10MB and 50MB. Measured
    /// in megabits per second, Mbps.
    pub static http_3_upload_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2771.into(), CommonMetricData {
            name: "http_3_upload_throughput_10_50".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput_50_100
    ///
    /// The upload throughput for http/3 request size between 50MB and 100MB. Measured
    /// in megabits per second, Mbps.
    pub static http_3_upload_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2772.into(), CommonMetricData {
            name: "http_3_upload_throughput_50_100".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 5000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum HttpChannelOnstartSuccessHttpsRrLabel {
        ESuccess = 0,
        EFailure = 1,
        ESuccessEchUsed = 2,
        EFailureEchUsed = 3,
        __Other__,
    }
    impl From<u16> for HttpChannelOnstartSuccessHttpsRrLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                2 => Self::ESuccessEchUsed,
                3 => Self::EFailureEchUsed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelOnstartSuccessHttpsRrLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::ESuccessEchUsed => "success_ech_used",
                Self::EFailureEchUsed => "failure_ech_used",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_onstart_success_https_rr
    ///
    /// Successfully started HTTP channels when HTTPS RR is used
    pub static http_channel_onstart_success_https_rr: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelOnstartSuccessHttpsRrLabel>> = Lazy::new(|| {
        LabeledMetric::new(2773.into(), CommonMetricData {
            name: "http_channel_onstart_success_https_rr".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("failure_ech_used"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("success_ech_used")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_page_open_to_first_sent
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable
    /// for page loads without HTTPS RR
    pub static http_channel_page_open_to_first_sent: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2774.into(), CommonMetricData {
            name: "http_channel_page_open_to_first_sent".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_page_open_to_first_sent_https_rr
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable
    /// for page loads with HTTPS RR
    pub static http_channel_page_open_to_first_sent_https_rr: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2775.into(), CommonMetricData {
            name: "http_channel_page_open_to_first_sent_https_rr".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_sub_open_to_first_sent
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable
    /// for sub-resource loads without HTTPS RR
    pub static http_channel_sub_open_to_first_sent: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2776.into(), CommonMetricData {
            name: "http_channel_sub_open_to_first_sent".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_sub_open_to_first_sent_https_rr
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable
    /// for sub-resource loads with HTTPS RR
    pub static http_channel_sub_open_to_first_sent_https_rr: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2777.into(), CommonMetricData {
            name: "http_channel_sub_open_to_first_sent_https_rr".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_cssloader_ondatafinished_to_onstop_delay
    ///
    /// The time between processing OnDataFinished and processing OnStopRequest for
    /// CSSLoader in the content process
    pub static http_content_cssloader_ondatafinished_to_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2778.into(), CommonMetricData {
            name: "http_content_cssloader_ondatafinished_to_onstop_delay".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_html5parser_ondatafinished_to_onstop_delay
    ///
    /// The time between processing OnDataFinished and processing OnStopRequest (if
    /// OnDataFinished comes first)
    pub static http_content_html5parser_ondatafinished_to_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2779.into(), CommonMetricData {
            name: "http_content_html5parser_ondatafinished_to_onstop_delay".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_ondatafinished_delay
    ///
    /// The time between dispatching OnDataFinished from the socket thread and
    /// processing it.
    pub static http_content_ondatafinished_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2780.into(), CommonMetricData {
            name: "http_content_ondatafinished_delay".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_ondatafinished_to_onstop_delay
    ///
    /// The time between processing OnDataFinished and processing OnStopRequest (if
    /// OnDataFinished comes first)
    pub static http_content_ondatafinished_to_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2781.into(), CommonMetricData {
            name: "http_content_ondatafinished_to_onstop_delay".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_onstart_delay
    ///
    /// The time between dispatching OnStartRequest from the socket thread and
    /// processing it on the main thread (content process).
    pub static http_content_onstart_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2782.into(), CommonMetricData {
            name: "http_content_onstart_delay".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_onstop_delay
    ///
    /// The time between dispatching OnStopRequest from the socket thread and
    /// processing it on the main thread (content process).
    pub static http_content_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2783.into(), CommonMetricData {
            name: "http_content_onstop_delay".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_onstart_suspend_total_time
    ///
    /// Time in milliseconds that http channel spent suspended between AsyncOpen and
    /// OnStartRequest.
    pub static http_onstart_suspend_total_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2784.into(), CommonMetricData {
            name: "http_onstart_suspend_total_time".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum HttpResponseVersionLabel {
        EUnknown = 0,
        EHttp1 = 1,
        EHttp2 = 2,
        EHttp3 = 3,
        __Other__,
    }
    impl From<u16> for HttpResponseVersionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUnknown,
                1 => Self::EHttp1,
                2 => Self::EHttp2,
                3 => Self::EHttp3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpResponseVersionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUnknown => "unknown",
                Self::EHttp1 => "http_1",
                Self::EHttp2 => "http_2",
                Self::EHttp3 => "http_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_response_version
    ///
    /// HTTP protocol version used on response from nsHttp.h
    pub static http_response_version: Lazy<LabeledMetric<LabeledCounterMetric, HttpResponseVersionLabel>> = Lazy::new(|| {
        LabeledMetric::new(2785.into(), CommonMetricData {
            name: "http_response_version".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("http_1"), ::std::borrow::Cow::from("http_2"), ::std::borrow::Cow::from("http_3"), ::std::borrow::Cow::from("unknown")]))
    });

    #[repr(u16)]
    pub enum HttpsRrPresentedLabel {
        EPresented = 0,
        EPresentedWithHttp3 = 1,
        ENone = 2,
        __Other__,
    }
    impl From<u16> for HttpsRrPresentedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresented,
                1 => Self::EPresentedWithHttp3,
                2 => Self::ENone,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpsRrPresentedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresented => "presented",
                Self::EPresentedWithHttp3 => "presented_with_http3",
                Self::ENone => "none",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.https_rr_presented
    ///
    /// HTTPS RR is presented or not
    pub static https_rr_presented: Lazy<LabeledMetric<LabeledCounterMetric, HttpsRrPresentedLabel>> = Lazy::new(|| {
        LabeledMetric::new(2786.into(), CommonMetricData {
            name: "https_rr_presented".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("none"), ::std::borrow::Cow::from("presented"), ::std::borrow::Cow::from("presented_with_http3")]))
    });

    #[repr(u16)]
    pub enum HttpsUpgradeWithHttpsRrLabel {
        EHttpsRr = 0,
        EOthers = 1,
        __Other__,
    }
    impl From<u16> for HttpsUpgradeWithHttpsRrLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHttpsRr,
                1 => Self::EOthers,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpsUpgradeWithHttpsRrLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHttpsRr => "https_rr",
                Self::EOthers => "others",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.https_upgrade_with_https_rr
    ///
    /// Whether an HTTP request gets upgraded to HTTPS because of HTTPS RR
    pub static https_upgrade_with_https_rr: Lazy<LabeledMetric<LabeledCounterMetric, HttpsUpgradeWithHttpsRrLabel>> = Lazy::new(|| {
        LabeledMetric::new(2787.into(), CommonMetricData {
            name: "https_upgrade_with_https_rr".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("https_rr"), ::std::borrow::Cow::from("others")]))
    });

    #[repr(u16)]
    pub enum ProxyInfoTypeLabel {
        EHttp = 0,
        EHttps = 1,
        ESocks4 = 2,
        ESocks4a = 3,
        ESocks5 = 4,
        ESocks5h = 5,
        EDirect = 6,
        EUnknown = 7,
        __Other__,
    }
    impl From<u16> for ProxyInfoTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHttp,
                1 => Self::EHttps,
                2 => Self::ESocks4,
                3 => Self::ESocks4a,
                4 => Self::ESocks5,
                5 => Self::ESocks5h,
                6 => Self::EDirect,
                7 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ProxyInfoTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHttp => "http",
                Self::EHttps => "https",
                Self::ESocks4 => "socks4",
                Self::ESocks4a => "socks4a",
                Self::ESocks5 => "socks5",
                Self::ESocks5h => "socks5h",
                Self::EDirect => "direct",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.proxy_info_type
    ///
    /// The proxies configurations created in the browser session (SOCKSv4, SOCKSv5,
    /// HTTP, HTTPS)
    pub static proxy_info_type: Lazy<LabeledMetric<LabeledCounterMetric, ProxyInfoTypeLabel>> = Lazy::new(|| {
        LabeledMetric::new(2788.into(), CommonMetricData {
            name: "proxy_info_type".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("direct"), ::std::borrow::Cow::from("http"), ::std::borrow::Cow::from("https"), ::std::borrow::Cow::from("socks4"), ::std::borrow::Cow::from("socks4a"), ::std::borrow::Cow::from("socks5"), ::std::borrow::Cow::from("socks5h"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.residual_cache_folder_count
    ///
    /// Counts how often we find a cache folder that wasn't purged at shutdown by a
    /// background task process.
    pub static residual_cache_folder_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2789,
            "networking",
            "residual_cache_folder_count",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum ResidualCacheFolderRemovalLabel {
        ESuccess = 0,
        EFailure = 1,
        __Other__,
    }
    impl From<u16> for ResidualCacheFolderRemovalLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResidualCacheFolderRemovalLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.residual_cache_folder_removal
    ///
    /// Counts how often succeed/fail in removing cache folder that wasn't purged at
    /// shutdown
    pub static residual_cache_folder_removal: Lazy<LabeledMetric<LabeledCounterMetric, ResidualCacheFolderRemovalLabel>> = Lazy::new(|| {
        LabeledMetric::new(2790.into(), CommonMetricData {
            name: "residual_cache_folder_removal".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie
    ///
    /// This counts the number of times we set a cookie. Introduced as a denomenator
    /// for measuring CHIPS adoption.
    pub static set_cookie: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(2791.into(), CommonMetricData {
            name: "set_cookie".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "set_cookie_foreign".into(), category: "networking".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "set_cookie_foreign_partitioned".into(), category: "networking".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "set_cookie_partitioned".into(), category: "networking".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie_foreign
    ///
    /// This counts the number of times we set a cookie from a foreign (not same-site)
    /// context. Introduced as a denomenator for measuring CHIPS adoption.
    pub static set_cookie_foreign: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2792.into(), CommonMetricData {
            name: "set_cookie_foreign".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie_foreign_partitioned
    ///
    /// This counts the number of times we set a cookie that has the Partitioned
    /// attribute in a foreign (not same-site) context. This tracks the adoption of
    /// CHIPS.
    pub static set_cookie_foreign_partitioned: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2793.into(), CommonMetricData {
            name: "set_cookie_foreign_partitioned".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie_partitioned
    ///
    /// This counts the number of times we set a cookie that has the Partitioned
    /// attribute. This tracks the adoption of CHIPS.
    pub static set_cookie_partitioned: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2794.into(), CommonMetricData {
            name: "set_cookie_partitioned".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum SpeculativeConnectOutcomeLabel {
        ESuccessful = 0,
        EAbortedSocketLimit = 1,
        EAbortedSocketFail = 2,
        EAbortedHttpsNotEnabled = 3,
        __Other__,
    }
    impl From<u16> for SpeculativeConnectOutcomeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccessful,
                1 => Self::EAbortedSocketLimit,
                2 => Self::EAbortedSocketFail,
                3 => Self::EAbortedHttpsNotEnabled,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SpeculativeConnectOutcomeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccessful => "successful",
                Self::EAbortedSocketLimit => "aborted_socket_limit",
                Self::EAbortedSocketFail => "aborted_socket_fail",
                Self::EAbortedHttpsNotEnabled => "aborted_https_not_enabled",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.speculative_connect_outcome
    ///
    /// Counts the occurrence of each outcome of a speculative connection
    pub static speculative_connect_outcome: Lazy<LabeledMetric<LabeledCounterMetric, SpeculativeConnectOutcomeLabel>> = Lazy::new(|| {
        LabeledMetric::new(2795.into(), CommonMetricData {
            name: "speculative_connect_outcome".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("aborted_https_not_enabled"), ::std::borrow::Cow::from("aborted_socket_fail"), ::std::borrow::Cow::from("aborted_socket_limit"), ::std::borrow::Cow::from("successful")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.transaction_wait_time
    ///
    /// Time from submission to dispatch of transaction without HTTPS RR (ms)
    pub static transaction_wait_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2796.into(), CommonMetricData {
            name: "transaction_wait_time".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.transaction_wait_time_https_rr
    ///
    /// Time from submission to dispatch of transaction when HTTPS RR is used (ms)
    pub static transaction_wait_time_https_rr: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2797.into(), CommonMetricData {
            name: "transaction_wait_time_https_rr".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum TrrRequestCountLabel {
        ERegular = 0,
        EPrivate = 1,
        __Other__,
    }
    impl From<u16> for TrrRequestCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERegular,
                1 => Self::EPrivate,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrRequestCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERegular => "regular",
                Self::EPrivate => "private",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_request_count
    ///
    /// The count of successful TRR requests keyed by regular/private browsing
    pub static trr_request_count: Lazy<LabeledMetric<LabeledCounterMetric, TrrRequestCountLabel>> = Lazy::new(|| {
        LabeledMetric::new(2798.into(), CommonMetricData {
            name: "trr_request_count".into(),
            category: "networking".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("private"), ::std::borrow::Cow::from("regular")]))
    });

}
pub mod netwerk {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum EarlyHintsLabel {
        EStylesheet = 0,
        EFonts = 1,
        EScripts = 2,
        EFetch = 3,
        EImage = 4,
        EOther = 5,
        __Other__,
    }
    impl From<u16> for EarlyHintsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EStylesheet,
                1 => Self::EFonts,
                2 => Self::EScripts,
                3 => Self::EFetch,
                4 => Self::EImage,
                5 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EarlyHintsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EStylesheet => "stylesheet",
                Self::EFonts => "fonts",
                Self::EScripts => "scripts",
                Self::EFetch => "fetch",
                Self::EImage => "image",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from netwerk.early_hints
    ///
    /// Counts the different type of resources that are sent for early hints.
    pub static early_hints: Lazy<LabeledMetric<LabeledCounterMetric, EarlyHintsLabel>> = Lazy::new(|| {
        LabeledMetric::new(2799.into(), CommonMetricData {
            name: "early_hints".into(),
            category: "netwerk".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("fetch"), ::std::borrow::Cow::from("fonts"), ::std::borrow::Cow::from("image"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("scripts"), ::std::borrow::Cow::from("stylesheet")]))
    });

    #[repr(u16)]
    pub enum EhLinkTypeLabel {
        EDnsPrefetch = 0,
        EIcon = 1,
        EModulepreload = 2,
        EPreconnect = 3,
        EPrefetch = 4,
        EPreload = 5,
        EPrerender = 6,
        EStylesheet = 7,
        EOther = 8,
        __Other__,
    }
    impl From<u16> for EhLinkTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDnsPrefetch,
                1 => Self::EIcon,
                2 => Self::EModulepreload,
                3 => Self::EPreconnect,
                4 => Self::EPrefetch,
                5 => Self::EPreload,
                6 => Self::EPrerender,
                7 => Self::EStylesheet,
                8 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EhLinkTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDnsPrefetch => "dns-prefetch",
                Self::EIcon => "icon",
                Self::EModulepreload => "modulepreload",
                Self::EPreconnect => "preconnect",
                Self::EPrefetch => "prefetch",
                Self::EPreload => "preload",
                Self::EPrerender => "prerender",
                Self::EStylesheet => "stylesheet",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from netwerk.eh_link_type
    ///
    /// Counts different type of link headers that are sent in early hint
    pub static eh_link_type: Lazy<LabeledMetric<LabeledCounterMetric, EhLinkTypeLabel>> = Lazy::new(|| {
        LabeledMetric::new(2800.into(), CommonMetricData {
            name: "eh_link_type".into(),
            category: "netwerk".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("dns-prefetch"), ::std::borrow::Cow::from("icon"), ::std::borrow::Cow::from("modulepreload"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("preconnect"), ::std::borrow::Cow::from("prefetch"), ::std::borrow::Cow::from("preload"), ::std::borrow::Cow::from("prerender"), ::std::borrow::Cow::from("stylesheet")]))
    });

}
pub mod network {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from network.cache_hit_time
    ///
    /// Time to open existing cache entry file. (Migrated from the geckoview metric of
    /// the same name).
    pub static cache_hit_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2801.into(), CommonMetricData {
            name: "cache_hit_time".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum CorsAuthorizationHeaderLabel {
        EAllowed = 0,
        EDisallowed = 1,
        ECoveredByWildcard = 2,
        __Other__,
    }
    impl From<u16> for CorsAuthorizationHeaderLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAllowed,
                1 => Self::EDisallowed,
                2 => Self::ECoveredByWildcard,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CorsAuthorizationHeaderLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAllowed => "allowed",
                Self::EDisallowed => "disallowed",
                Self::ECoveredByWildcard => "covered_by_wildcard",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.cors_authorization_header
    ///
    /// Count how many times we see `Authorization` header in `Access-Control-Request-
    /// Headers` header and the possible outcomes.
    pub static cors_authorization_header: Lazy<LabeledMetric<LabeledCounterMetric, CorsAuthorizationHeaderLabel>> = Lazy::new(|| {
        LabeledMetric::new(2802.into(), CommonMetricData {
            name: "cors_authorization_header".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("allowed"), ::std::borrow::Cow::from("covered_by_wildcard"), ::std::borrow::Cow::from("disallowed")]))
    });

    #[repr(u16)]
    pub enum DataSizePbPerTypeLabel {
        ETextHtml = 0,
        ETextCss = 1,
        ETextJson = 2,
        ETextPlain = 3,
        ETextJavascript = 4,
        ETextOther = 5,
        EAudio = 6,
        EVideo = 7,
        EMultipart = 8,
        EIcon = 9,
        EImage = 10,
        EOcsp = 11,
        EXpinstall = 12,
        EWasm = 13,
        EPdf = 14,
        EOctetStream = 15,
        EProxy = 16,
        ECompressed = 17,
        EX509 = 18,
        EApplicationOther = 19,
        __Other__,
    }
    impl From<u16> for DataSizePbPerTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ETextHtml,
                1 => Self::ETextCss,
                2 => Self::ETextJson,
                3 => Self::ETextPlain,
                4 => Self::ETextJavascript,
                5 => Self::ETextOther,
                6 => Self::EAudio,
                7 => Self::EVideo,
                8 => Self::EMultipart,
                9 => Self::EIcon,
                10 => Self::EImage,
                11 => Self::EOcsp,
                12 => Self::EXpinstall,
                13 => Self::EWasm,
                14 => Self::EPdf,
                15 => Self::EOctetStream,
                16 => Self::EProxy,
                17 => Self::ECompressed,
                18 => Self::EX509,
                19 => Self::EApplicationOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DataSizePbPerTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ETextHtml => "text_html",
                Self::ETextCss => "text_css",
                Self::ETextJson => "text_json",
                Self::ETextPlain => "text_plain",
                Self::ETextJavascript => "text_javascript",
                Self::ETextOther => "text_other",
                Self::EAudio => "audio",
                Self::EVideo => "video",
                Self::EMultipart => "multipart",
                Self::EIcon => "icon",
                Self::EImage => "image",
                Self::EOcsp => "ocsp",
                Self::EXpinstall => "xpinstall",
                Self::EWasm => "wasm",
                Self::EPdf => "pdf",
                Self::EOctetStream => "octet_stream",
                Self::EProxy => "proxy",
                Self::ECompressed => "compressed",
                Self::EX509 => "x509",
                Self::EApplicationOther => "application_other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.data_size_pb_per_type
    ///
    /// Number of KB we transferred keyed by "contentType"
    pub static data_size_pb_per_type: Lazy<LabeledMetric<LabeledCounterMetric, DataSizePbPerTypeLabel>> = Lazy::new(|| {
        LabeledMetric::new(2803.into(), CommonMetricData {
            name: "data_size_pb_per_type".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("application_other"), ::std::borrow::Cow::from("audio"), ::std::borrow::Cow::from("compressed"), ::std::borrow::Cow::from("icon"), ::std::borrow::Cow::from("image"), ::std::borrow::Cow::from("multipart"), ::std::borrow::Cow::from("ocsp"), ::std::borrow::Cow::from("octet_stream"), ::std::borrow::Cow::from("pdf"), ::std::borrow::Cow::from("proxy"), ::std::borrow::Cow::from("text_css"), ::std::borrow::Cow::from("text_html"), ::std::borrow::Cow::from("text_javascript"), ::std::borrow::Cow::from("text_json"), ::std::borrow::Cow::from("text_other"), ::std::borrow::Cow::from("text_plain"), ::std::borrow::Cow::from("video"), ::std::borrow::Cow::from("wasm"), ::std::borrow::Cow::from("x509"), ::std::borrow::Cow::from("xpinstall")]))
    });

    #[repr(u16)]
    pub enum DataSizePerTypeLabel {
        ETextHtml = 0,
        ETextCss = 1,
        ETextJson = 2,
        ETextPlain = 3,
        ETextJavascript = 4,
        ETextOther = 5,
        EAudio = 6,
        EVideo = 7,
        EMultipart = 8,
        EIcon = 9,
        EImage = 10,
        EOcsp = 11,
        EXpinstall = 12,
        EWasm = 13,
        EPdf = 14,
        EOctetStream = 15,
        EProxy = 16,
        ECompressed = 17,
        EX509 = 18,
        EApplicationOther = 19,
        __Other__,
    }
    impl From<u16> for DataSizePerTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ETextHtml,
                1 => Self::ETextCss,
                2 => Self::ETextJson,
                3 => Self::ETextPlain,
                4 => Self::ETextJavascript,
                5 => Self::ETextOther,
                6 => Self::EAudio,
                7 => Self::EVideo,
                8 => Self::EMultipart,
                9 => Self::EIcon,
                10 => Self::EImage,
                11 => Self::EOcsp,
                12 => Self::EXpinstall,
                13 => Self::EWasm,
                14 => Self::EPdf,
                15 => Self::EOctetStream,
                16 => Self::EProxy,
                17 => Self::ECompressed,
                18 => Self::EX509,
                19 => Self::EApplicationOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DataSizePerTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ETextHtml => "text_html",
                Self::ETextCss => "text_css",
                Self::ETextJson => "text_json",
                Self::ETextPlain => "text_plain",
                Self::ETextJavascript => "text_javascript",
                Self::ETextOther => "text_other",
                Self::EAudio => "audio",
                Self::EVideo => "video",
                Self::EMultipart => "multipart",
                Self::EIcon => "icon",
                Self::EImage => "image",
                Self::EOcsp => "ocsp",
                Self::EXpinstall => "xpinstall",
                Self::EWasm => "wasm",
                Self::EPdf => "pdf",
                Self::EOctetStream => "octet_stream",
                Self::EProxy => "proxy",
                Self::ECompressed => "compressed",
                Self::EX509 => "x509",
                Self::EApplicationOther => "application_other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.data_size_per_type
    ///
    /// Number of KB we transferred keyed by "contentType"
    pub static data_size_per_type: Lazy<LabeledMetric<LabeledCounterMetric, DataSizePerTypeLabel>> = Lazy::new(|| {
        LabeledMetric::new(2804.into(), CommonMetricData {
            name: "data_size_per_type".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("application_other"), ::std::borrow::Cow::from("audio"), ::std::borrow::Cow::from("compressed"), ::std::borrow::Cow::from("icon"), ::std::borrow::Cow::from("image"), ::std::borrow::Cow::from("multipart"), ::std::borrow::Cow::from("ocsp"), ::std::borrow::Cow::from("octet_stream"), ::std::borrow::Cow::from("pdf"), ::std::borrow::Cow::from("proxy"), ::std::borrow::Cow::from("text_css"), ::std::borrow::Cow::from("text_html"), ::std::borrow::Cow::from("text_javascript"), ::std::borrow::Cow::from("text_json"), ::std::borrow::Cow::from("text_other"), ::std::borrow::Cow::from("text_plain"), ::std::borrow::Cow::from("video"), ::std::borrow::Cow::from("wasm"), ::std::borrow::Cow::from("x509"), ::std::borrow::Cow::from("xpinstall")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.dns_end
    ///
    /// In the HTTP page channel, time from the DNS request being issued to the
    /// response. Corresponds to Legacy histogram HTTP_PAGE_DNS_LOOKUP_TIME in Desktop.
    /// (Migrated from the geckoview metric of the same name).
    pub static dns_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2805.into(), CommonMetricData {
            name: "dns_end".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.dns_start
    ///
    /// In the HTTP page channel, time from connection open to the DNS request being
    /// issued. Corresponds to Legacy histogram HTTP_PAGE_DNS_ISSUE_TIME in Desktop.
    /// (Migrated from the geckoview metric of the same name).
    pub static dns_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2806.into(), CommonMetricData {
            name: "dns_start".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.first_from_cache
    ///
    /// In the HTTP page channel, time from connection open to cache read start.
    /// Corresponds to Legacy histogram HTTP_PAGE_OPEN_TO_FIRST_FROM_CACHE_V2 in
    /// Desktop.
    pub static first_from_cache: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2807.into(), CommonMetricData {
            name: "first_from_cache".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.font_download_end
    ///
    /// Time after navigationStart that all webfont downloads are completed. (Migrated
    /// from the geckoview metric of the same name).
    pub static font_download_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2808.into(), CommonMetricData {
            name: "font_download_end".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.tcp_connection
    ///
    /// In the HTTP page channel, time from the TCP SYN packet is received to the
    /// connection is established and ready for HTTP. Corresponds to Legacy histogram
    /// HTTP_PAGE_TCP_CONNECTION_2 in Desktop (Migrated from the geckoview metric of
    /// the same name).
    pub static tcp_connection: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2809.into(), CommonMetricData {
            name: "tcp_connection".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.tls_handshake
    ///
    /// In the HTTP page channel, time from after the TCP SYN packet is received to the
    /// secure connection is established and ready for HTTP. Corresponds to Legacy
    /// histogram HTTP_PAGE_TLS_HANDSHAKE in Desktop. (Migrated from the geckoview
    /// metric of the same name).
    pub static tls_handshake: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2810.into(), CommonMetricData {
            name: "tls_handshake".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod cert_verifier {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_verifier.cert_trust_evaluation_time
    ///
    /// Measures how long we take to evaluate the trust status of a certificate.
    pub static cert_trust_evaluation_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2811.into(), CommonMetricData {
            name: "cert_trust_evaluation_time".into(),
            category: "cert_verifier".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[repr(u16)]
    pub enum CrliteStatusLabel {
        ENoFilter = 0,
        ENotCovered = 1,
        ENotEnrolled = 2,
        ENotRevoked = 3,
        ERevokedInFilter = 4,
        ERevokedInStash = 5,
        __Other__,
    }
    impl From<u16> for CrliteStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENoFilter,
                1 => Self::ENotCovered,
                2 => Self::ENotEnrolled,
                3 => Self::ENotRevoked,
                4 => Self::ERevokedInFilter,
                5 => Self::ERevokedInStash,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CrliteStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENoFilter => "no_filter",
                Self::ENotCovered => "not_covered",
                Self::ENotEnrolled => "not_enrolled",
                Self::ENotRevoked => "not_revoked",
                Self::ERevokedInFilter => "revoked_in_filter",
                Self::ERevokedInStash => "revoked_in_stash",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_verifier.crlite_status
    ///
    /// Counts the number of times different CRLite statuses were returned.
    pub static crlite_status: Lazy<LabeledMetric<LabeledCounterMetric, CrliteStatusLabel>> = Lazy::new(|| {
        LabeledMetric::new(2812.into(), CommonMetricData {
            name: "crlite_status".into(),
            category: "cert_verifier".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("no_filter"), ::std::borrow::Cow::from("not_covered"), ::std::borrow::Cow::from("not_enrolled"), ::std::borrow::Cow::from("not_revoked"), ::std::borrow::Cow::from("revoked_in_filter"), ::std::borrow::Cow::from("revoked_in_stash")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_verifier.trust_obj_count
    ///
    /// The total number of trust objects in cert9.db
    pub static trust_obj_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2813.into(), CommonMetricData {
            name: "trust_obj_count".into(),
            category: "cert_verifier".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod cert_compression {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_compression.brotli_saved_bytes
    ///
    /// The difference between the length of encoded certificate vs the actual
    /// certificate.
    pub static brotli_saved_bytes: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2814.into(), CommonMetricData {
            name: "brotli_saved_bytes".into(),
            category: "cert_compression".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 65536, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum FailuresLabel {
        EZlib = 0,
        EBrotli = 1,
        __Other__,
    }
    impl From<u16> for FailuresLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EZlib,
                1 => Self::EBrotli,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FailuresLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EZlib => "zlib",
                Self::EBrotli => "brotli",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_compression.failures
    ///
    /// The number of times each certificate compression algorithm returned an error.
    pub static failures: Lazy<LabeledMetric<LabeledCounterMetric, FailuresLabel>> = Lazy::new(|| {
        LabeledMetric::new(2815.into(), CommonMetricData {
            name: "failures".into(),
            category: "cert_compression".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("brotli"), ::std::borrow::Cow::from("zlib")]))
    });

    #[repr(u16)]
    pub enum UsedLabel {
        EZlib = 0,
        EBrotli = 1,
        __Other__,
    }
    impl From<u16> for UsedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EZlib,
                1 => Self::EBrotli,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for UsedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EZlib => "zlib",
                Self::EBrotli => "brotli",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_compression.used
    ///
    /// The number of times each certificate compression algorithm was used.
    pub static used: Lazy<LabeledMetric<LabeledCounterMetric, UsedLabel>> = Lazy::new(|| {
        LabeledMetric::new(2816.into(), CommonMetricData {
            name: "used".into(),
            category: "cert_compression".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("brotli"), ::std::borrow::Cow::from("zlib")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_compression.zlib_saved_bytes
    ///
    /// The difference between the length of encoded certificate vs the actual
    /// certificate.
    pub static zlib_saved_bytes: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2817.into(), CommonMetricData {
            name: "zlib_saved_bytes".into(),
            category: "cert_compression".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 65536, 100, HistogramType::Exponential)
    });

}
pub mod data_storage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from data_storage.alternate_services
    ///
    /// The number of entries stored in the AlternateServices nsIDataStorage
    pub static alternate_services: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2818.into(), CommonMetricData {
            name: "alternate_services".into(),
            category: "data_storage".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from data_storage.client_auth_remember_list
    ///
    /// The number of entries stored in the ClientAuthRememberList nsIDataStorage
    pub static client_auth_remember_list: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2819.into(), CommonMetricData {
            name: "client_auth_remember_list".into(),
            category: "data_storage".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from data_storage.site_security_service_state
    ///
    /// The number of entries stored in the SiteSecurityServiceState nsIDataStorage
    pub static site_security_service_state: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2820.into(), CommonMetricData {
            name: "site_security_service_state".into(),
            category: "data_storage".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod tls {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from tls.certificate_verifications
    ///
    /// The total number of successful TLS server certificate verifications.
    pub static certificate_verifications: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(2821.into(), CommonMetricData {
            name: "certificate_verifications".into(),
            category: "tls".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "built_in_roots_module".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "nss_cert_db".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "preloaded_intermediates".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "third_party_certificates".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "tls_handshake".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[repr(u16)]
    pub enum XyberIntoleranceReasonLabel {
        EPrConnectResetError = 0,
        EPrEndOfFileError = 1,
        ESslErrorBadHandshakeHashValue = 2,
        ESslErrorBadMacAlert = 3,
        ESslErrorBadMacRead = 4,
        ESslErrorDecodeErrorAlert = 5,
        ESslErrorHandshakeFailed = 6,
        ESslErrorHandshakeFailureAlert = 7,
        ESslErrorHandshakeUnexpectedAlert = 8,
        ESslErrorIllegalParameterAlert = 9,
        ESslErrorInternalErrorAlert = 10,
        ESslErrorKeyExchangeFailure = 11,
        ESslErrorNoCypherOverlap = 12,
        ESslErrorProtocolVersionAlert = 13,
        ESslErrorRxUnexpectedRecordType = 14,
        ESslErrorRxMalformedHybridKeyShare = 15,
        ESslErrorUnsupportedVersion = 16,
        __Other__,
    }
    impl From<u16> for XyberIntoleranceReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPrConnectResetError,
                1 => Self::EPrEndOfFileError,
                2 => Self::ESslErrorBadHandshakeHashValue,
                3 => Self::ESslErrorBadMacAlert,
                4 => Self::ESslErrorBadMacRead,
                5 => Self::ESslErrorDecodeErrorAlert,
                6 => Self::ESslErrorHandshakeFailed,
                7 => Self::ESslErrorHandshakeFailureAlert,
                8 => Self::ESslErrorHandshakeUnexpectedAlert,
                9 => Self::ESslErrorIllegalParameterAlert,
                10 => Self::ESslErrorInternalErrorAlert,
                11 => Self::ESslErrorKeyExchangeFailure,
                12 => Self::ESslErrorNoCypherOverlap,
                13 => Self::ESslErrorProtocolVersionAlert,
                14 => Self::ESslErrorRxUnexpectedRecordType,
                15 => Self::ESslErrorRxMalformedHybridKeyShare,
                16 => Self::ESslErrorUnsupportedVersion,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for XyberIntoleranceReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPrConnectResetError => "PR_CONNECT_RESET_ERROR",
                Self::EPrEndOfFileError => "PR_END_OF_FILE_ERROR",
                Self::ESslErrorBadHandshakeHashValue => "SSL_ERROR_BAD_HANDSHAKE_HASH_VALUE",
                Self::ESslErrorBadMacAlert => "SSL_ERROR_BAD_MAC_ALERT",
                Self::ESslErrorBadMacRead => "SSL_ERROR_BAD_MAC_READ",
                Self::ESslErrorDecodeErrorAlert => "SSL_ERROR_DECODE_ERROR_ALERT",
                Self::ESslErrorHandshakeFailed => "SSL_ERROR_HANDSHAKE_FAILED",
                Self::ESslErrorHandshakeFailureAlert => "SSL_ERROR_HANDSHAKE_FAILURE_ALERT",
                Self::ESslErrorHandshakeUnexpectedAlert => "SSL_ERROR_HANDSHAKE_UNEXPECTED_ALERT",
                Self::ESslErrorIllegalParameterAlert => "SSL_ERROR_ILLEGAL_PARAMETER_ALERT",
                Self::ESslErrorInternalErrorAlert => "SSL_ERROR_INTERNAL_ERROR_ALERT",
                Self::ESslErrorKeyExchangeFailure => "SSL_ERROR_KEY_EXCHANGE_FAILURE",
                Self::ESslErrorNoCypherOverlap => "SSL_ERROR_NO_CYPHER_OVERLAP",
                Self::ESslErrorProtocolVersionAlert => "SSL_ERROR_PROTOCOL_VERSION_ALERT",
                Self::ESslErrorRxUnexpectedRecordType => "SSL_ERROR_RX_UNEXPECTED_RECORD_TYPE",
                Self::ESslErrorRxMalformedHybridKeyShare => "SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE",
                Self::ESslErrorUnsupportedVersion => "SSL_ERROR_UNSUPPORTED_VERSION",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tls.xyber_intolerance_reason
    ///
    /// The error that was returned from a failed TLS 1.3 handshake in which the client
    /// sent a Xyber key share (see tlsIntoleranceTelemetryBucket() in
    /// nsNSSIOLayer.cpp).
    pub static xyber_intolerance_reason: Lazy<LabeledMetric<LabeledCounterMetric, XyberIntoleranceReasonLabel>> = Lazy::new(|| {
        LabeledMetric::new(2822.into(), CommonMetricData {
            name: "xyber_intolerance_reason".into(),
            category: "tls".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("PR_CONNECT_RESET_ERROR"), ::std::borrow::Cow::from("PR_END_OF_FILE_ERROR"), ::std::borrow::Cow::from("SSL_ERROR_BAD_HANDSHAKE_HASH_VALUE"), ::std::borrow::Cow::from("SSL_ERROR_BAD_MAC_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_BAD_MAC_READ"), ::std::borrow::Cow::from("SSL_ERROR_DECODE_ERROR_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_HANDSHAKE_FAILED"), ::std::borrow::Cow::from("SSL_ERROR_HANDSHAKE_FAILURE_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_HANDSHAKE_UNEXPECTED_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_ILLEGAL_PARAMETER_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_INTERNAL_ERROR_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_KEY_EXCHANGE_FAILURE"), ::std::borrow::Cow::from("SSL_ERROR_NO_CYPHER_OVERLAP"), ::std::borrow::Cow::from("SSL_ERROR_PROTOCOL_VERSION_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE"), ::std::borrow::Cow::from("SSL_ERROR_RX_UNEXPECTED_RECORD_TYPE"), ::std::borrow::Cow::from("SSL_ERROR_UNSUPPORTED_VERSION")]))
    });

}
pub mod verification_used_cert_from {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.built_in_roots_module
    ///
    /// How many successfully-built certificate chains used a certificate from the
    /// built-in roots module.
    pub static built_in_roots_module: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2823.into(), CommonMetricData {
            name: "built_in_roots_module".into(),
            category: "verification_used_cert_from".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.nss_cert_db
    ///
    /// How many successfully-built certificate chains used a certificate from the NSS
    /// cert DB.
    pub static nss_cert_db: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2824.into(), CommonMetricData {
            name: "nss_cert_db".into(),
            category: "verification_used_cert_from".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.preloaded_intermediates
    ///
    /// How many successfully-built certificate chains used a certificate from
    /// preloaded intermediates.
    pub static preloaded_intermediates: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2825.into(), CommonMetricData {
            name: "preloaded_intermediates".into(),
            category: "verification_used_cert_from".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.third_party_certificates
    ///
    /// How many successfully-built certificate chains used a third-party certificate
    /// from the OS.
    pub static third_party_certificates: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2826.into(), CommonMetricData {
            name: "third_party_certificates".into(),
            category: "verification_used_cert_from".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.tls_handshake
    ///
    /// How many successfully-built certificate chains used a certificate from the TLS
    /// handshake.
    pub static tls_handshake: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(2827.into(), CommonMetricData {
            name: "tls_handshake".into(),
            category: "verification_used_cert_from".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod bounce_tracking_protection {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.enabled_at_startup
    ///
    /// Keeps track of whether the feature is enabled at startup.
    pub static enabled_at_startup: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2828.into(), CommonMetricData {
            name: "enabled_at_startup".into(),
            category: "bounce.tracking.protection".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.enabled_dry_run_mode_at_startup
    ///
    /// Keeps track of whether the feature is enabled and running in dry-run mode at
    /// startup.
    pub static enabled_dry_run_mode_at_startup: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2829.into(), CommonMetricData {
            name: "enabled_dry_run_mode_at_startup".into(),
            category: "bounce.tracking.protection".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum PurgeCountLabel {
        ESuccess = 0,
        EFailure = 1,
        EDry = 2,
        __Other__,
    }
    impl From<u16> for PurgeCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                2 => Self::EDry,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PurgeCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::EDry => "dry",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.purge_count
    ///
    /// Counts how often we purge trackers. Giving a high level overview about the
    /// effectivness of bounce tracking protection. Allows determining error rate with
    /// failure/success label. When in dry mode, we count the purges that would have
    /// happened under the dry label.
    pub static purge_count: Lazy<LabeledMetric<LabeledCounterMetric, PurgeCountLabel>> = Lazy::new(|| {
        LabeledMetric::new(2830.into(), CommonMetricData {
            name: "purge_count".into(),
            category: "bounce.tracking.protection".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("dry"), ::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.purge_count_classified_tracker
    ///
    /// Counts sites purged from BTP that are classified as trackers as part of the
    /// following lists: [emailtracking-protection, fingerprinting-protection,
    /// socialtracking-protection, tracking-protection]
    pub static purge_count_classified_tracker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2831,
            "bounce.tracking.protection",
            "purge_count_classified_tracker",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.purge_duration
    ///
    /// For every purge that is scheduled, we call the ClearDataService to purge
    /// persistent storage for each detected bounce tracker. This may do some blocking
    /// work on main thread and dispatch some cleanups to other threads. Collect
    /// telemetry on how long it takes to clear in the wild to determine whether we
    /// need to improve performance here.
    pub static purge_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2832.into(), CommonMetricData {
            name: "purge_duration".into(),
            category: "bounce.tracking.protection".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

}
pub mod background_tasks_rmdir_base {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2833.into(), CommonMetricData {
            name: "elapsed_ms".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(2834.into(), CommonMetricData {
            name: "metric_base".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2835.into(), CommonMetricData {
            name: "removal_count".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2836.into(), CommonMetricData {
            name: "retry_count".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2837.into(), CommonMetricData {
            name: "succeeded".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2838.into(), CommonMetricData {
            name: "suffix_ever_failed".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2839.into(), CommonMetricData {
            name: "suffix_removal_count".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2840.into(), CommonMetricData {
            name: "was_first".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod background_tasks_rmdir_http_cache {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2841.into(), CommonMetricData {
            name: "elapsed_ms".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(2842.into(), CommonMetricData {
            name: "metric_base".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2843.into(), CommonMetricData {
            name: "removal_count".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2844.into(), CommonMetricData {
            name: "retry_count".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2845.into(), CommonMetricData {
            name: "succeeded".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2846.into(), CommonMetricData {
            name: "suffix_ever_failed".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2847.into(), CommonMetricData {
            name: "suffix_removal_count".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2848.into(), CommonMetricData {
            name: "was_first".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod background_tasks_rmdir_quota {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2849.into(), CommonMetricData {
            name: "elapsed_ms".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(2850.into(), CommonMetricData {
            name: "metric_base".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2851.into(), CommonMetricData {
            name: "removal_count".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2852.into(), CommonMetricData {
            name: "retry_count".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2853.into(), CommonMetricData {
            name: "succeeded".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2854.into(), CommonMetricData {
            name: "suffix_ever_failed".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2855.into(), CommonMetricData {
            name: "suffix_removal_count".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2856.into(), CommonMetricData {
            name: "was_first".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["background-tasks".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod relevancy_classify {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from relevancy.classify.duration
    ///
    /// Record the duration (in ms) of a successful classification.
    pub static duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2857.into(), CommonMetricData {
            name: "duration".into(),
            category: "relevancy.classify".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct FailExtra {
        pub reason: Option<String>,
    }

    impl ExtraKeys for FailExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relevancy.classify.fail
    ///
    /// Record an event of a failed / aborted user interest classification.
    pub static fail: Lazy<EventMetric<FailExtra>> = Lazy::new(|| {
        EventMetric::new(2858.into(), CommonMetricData {
            name: "fail".into(),
            category: "relevancy.classify".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SucceedExtra {
        pub input_classified_size: Option<u32>,
        pub input_inconclusive_size: Option<u32>,
        pub input_size: Option<u32>,
        pub interest_top_1_hits: Option<u32>,
        pub interest_top_2_hits: Option<u32>,
        pub interest_top_3_hits: Option<u32>,
        pub output_interest_size: Option<u32>,
    }

    impl ExtraKeys for SucceedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["input_classified_size", "input_inconclusive_size", "input_size", "interest_top_1_hits", "interest_top_2_hits", "interest_top_3_hits", "output_interest_size"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.input_classified_size.and_then(|val| map.insert("input_classified_size".into(), val.to_string()));
          self.input_inconclusive_size.and_then(|val| map.insert("input_inconclusive_size".into(), val.to_string()));
          self.input_size.and_then(|val| map.insert("input_size".into(), val.to_string()));
          self.interest_top_1_hits.and_then(|val| map.insert("interest_top_1_hits".into(), val.to_string()));
          self.interest_top_2_hits.and_then(|val| map.insert("interest_top_2_hits".into(), val.to_string()));
          self.interest_top_3_hits.and_then(|val| map.insert("interest_top_3_hits".into(), val.to_string()));
          self.output_interest_size.and_then(|val| map.insert("output_interest_size".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relevancy.classify.succeed
    ///
    /// Record an event of a successful user interest classification.
    pub static succeed: Lazy<EventMetric<SucceedExtra>> = Lazy::new(|| {
        EventMetric::new(2859.into(), CommonMetricData {
            name: "succeed".into(),
            category: "relevancy.classify".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod cookie_banners {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.cookie_injection_fail
    ///
    /// Counts how often the cookie banner is still shown even if we have injected
    /// cookies.
    pub static cookie_injection_fail: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2860,
            "cookie.banners",
            "cookie_injection_fail",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.google_gdpr_choice_cookie
    ///
    /// Records the GDPR choice on Google Search based on the "SOCS" cookie of the
    /// Google Search domains. The value could be "Accept", "Reject" or "Custom". We
    /// use the label to record different choices on different Google domains. We only
    /// collect this if the default search engine is Google.
    pub static google_gdpr_choice_cookie: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2861.into(), CommonMetricData {
            name: "google_gdpr_choice_cookie".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct GoogleGdprChoiceCookieEventExtra {
        pub choice: Option<String>,
        pub region: Option<String>,
        pub search_domain: Option<String>,
    }

    impl ExtraKeys for GoogleGdprChoiceCookieEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["choice", "region", "search_domain"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.choice.and_then(|val| map.insert("choice".into(), val.to_string()));
          self.region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.search_domain.and_then(|val| map.insert("search_domain".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.google_gdpr_choice_cookie_event
    ///
    /// Recorded whenever a GDPR choice is made on a Google Search page. We assess the
    /// "SOCS" cookie to know the GDPR choice.
    pub static google_gdpr_choice_cookie_event: Lazy<EventMetric<GoogleGdprChoiceCookieEventExtra>> = Lazy::new(|| {
        EventMetric::new(2862.into(), CommonMetricData {
            name: "google_gdpr_choice_cookie_event".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct GoogleGdprChoiceCookieEventPbmExtra {
        pub choice: Option<String>,
    }

    impl ExtraKeys for GoogleGdprChoiceCookieEventPbmExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["choice"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.choice.and_then(|val| map.insert("choice".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.google_gdpr_choice_cookie_event_pbm
    ///
    /// Recorded whenever a GDPR choice is made on a Google Search page on private
    /// browsing windows. We assess the "SOCS" cookie to know the GDPR choice.
    pub static google_gdpr_choice_cookie_event_pbm: Lazy<EventMetric<GoogleGdprChoiceCookieEventPbmExtra>> = Lazy::new(|| {
        EventMetric::new(2863.into(), CommonMetricData {
            name: "google_gdpr_choice_cookie_event_pbm".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum NormalWindowServiceModeLabel {
        EDisabled = 0,
        EReject = 1,
        ERejectOrAccept = 2,
        EInvalid = 3,
        __Other__,
    }
    impl From<u16> for NormalWindowServiceModeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDisabled,
                1 => Self::EReject,
                2 => Self::ERejectOrAccept,
                3 => Self::EInvalid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NormalWindowServiceModeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDisabled => "disabled",
                Self::EReject => "reject",
                Self::ERejectOrAccept => "reject_or_accept",
                Self::EInvalid => "invalid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.normal_window_service_mode
    ///
    /// The pref value of the cookie banner service mode for normal windows.
    pub static normal_window_service_mode: Lazy<LabeledMetric<LabeledBooleanMetric, NormalWindowServiceModeLabel>> = Lazy::new(|| {
        LabeledMetric::new(2864.into(), CommonMetricData {
            name: "normal_window_service_mode".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("reject"), ::std::borrow::Cow::from("reject_or_accept")]))
    });

    #[repr(u16)]
    pub enum PrivateWindowServiceModeLabel {
        EDisabled = 0,
        EReject = 1,
        ERejectOrAccept = 2,
        EInvalid = 3,
        __Other__,
    }
    impl From<u16> for PrivateWindowServiceModeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDisabled,
                1 => Self::EReject,
                2 => Self::ERejectOrAccept,
                3 => Self::EInvalid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PrivateWindowServiceModeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDisabled => "disabled",
                Self::EReject => "reject",
                Self::ERejectOrAccept => "reject_or_accept",
                Self::EInvalid => "invalid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.private_window_service_mode
    ///
    /// The pref value of the cookie banner service mode for private windows.
    pub static private_window_service_mode: Lazy<LabeledMetric<LabeledBooleanMetric, PrivateWindowServiceModeLabel>> = Lazy::new(|| {
        LabeledMetric::new(2865.into(), CommonMetricData {
            name: "private_window_service_mode".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("reject"), ::std::borrow::Cow::from("reject_or_accept")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ReloadExtra {
        pub has_click_rule: Option<bool>,
        pub has_cookie_rule: Option<bool>,
        pub no_rule: Option<bool>,
    }

    impl ExtraKeys for ReloadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_click_rule", "has_cookie_rule", "no_rule"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.has_click_rule.and_then(|val| map.insert("has_click_rule".into(), val.to_string()));
          self.has_cookie_rule.and_then(|val| map.insert("has_cookie_rule".into(), val.to_string()));
          self.no_rule.and_then(|val| map.insert("no_rule".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.reload
    ///
    /// Recorded when the top-level page is reloaded. We use this event metric to know
    /// whether or not the reloading domain has cookie banner rule.
    pub static reload: Lazy<EventMetric<ReloadExtra>> = Lazy::new(|| {
        EventMetric::new(2866.into(), CommonMetricData {
            name: "reload".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum RuleLookupByDomainLabel {
        ETopHit = 0,
        ETopHitOptIn = 1,
        ETopHitOptOut = 2,
        ETopMiss = 3,
        EIframeHit = 4,
        EIframeHitOptIn = 5,
        EIframeHitOptOut = 6,
        EIframeMiss = 7,
        ETopCookieHit = 8,
        ETopCookieHitOptIn = 9,
        ETopCookieHitOptOut = 10,
        ETopCookieMiss = 11,
        EIframeCookieHit = 12,
        EIframeCookieHitOptIn = 13,
        EIframeCookieHitOptOut = 14,
        EIframeCookieMiss = 15,
        ETopClickHit = 16,
        ETopClickHitOptIn = 17,
        ETopClickHitOptOut = 18,
        ETopClickMiss = 19,
        EIframeClickHit = 20,
        EIframeClickHitOptIn = 21,
        EIframeClickHitOptOut = 22,
        EIframeClickMiss = 23,
        __Other__,
    }
    impl From<u16> for RuleLookupByDomainLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ETopHit,
                1 => Self::ETopHitOptIn,
                2 => Self::ETopHitOptOut,
                3 => Self::ETopMiss,
                4 => Self::EIframeHit,
                5 => Self::EIframeHitOptIn,
                6 => Self::EIframeHitOptOut,
                7 => Self::EIframeMiss,
                8 => Self::ETopCookieHit,
                9 => Self::ETopCookieHitOptIn,
                10 => Self::ETopCookieHitOptOut,
                11 => Self::ETopCookieMiss,
                12 => Self::EIframeCookieHit,
                13 => Self::EIframeCookieHitOptIn,
                14 => Self::EIframeCookieHitOptOut,
                15 => Self::EIframeCookieMiss,
                16 => Self::ETopClickHit,
                17 => Self::ETopClickHitOptIn,
                18 => Self::ETopClickHitOptOut,
                19 => Self::ETopClickMiss,
                20 => Self::EIframeClickHit,
                21 => Self::EIframeClickHitOptIn,
                22 => Self::EIframeClickHitOptOut,
                23 => Self::EIframeClickMiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RuleLookupByDomainLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ETopHit => "top_hit",
                Self::ETopHitOptIn => "top_hit_opt_in",
                Self::ETopHitOptOut => "top_hit_opt_out",
                Self::ETopMiss => "top_miss",
                Self::EIframeHit => "iframe_hit",
                Self::EIframeHitOptIn => "iframe_hit_opt_in",
                Self::EIframeHitOptOut => "iframe_hit_opt_out",
                Self::EIframeMiss => "iframe_miss",
                Self::ETopCookieHit => "top_cookie_hit",
                Self::ETopCookieHitOptIn => "top_cookie_hit_opt_in",
                Self::ETopCookieHitOptOut => "top_cookie_hit_opt_out",
                Self::ETopCookieMiss => "top_cookie_miss",
                Self::EIframeCookieHit => "iframe_cookie_hit",
                Self::EIframeCookieHitOptIn => "iframe_cookie_hit_opt_in",
                Self::EIframeCookieHitOptOut => "iframe_cookie_hit_opt_out",
                Self::EIframeCookieMiss => "iframe_cookie_miss",
                Self::ETopClickHit => "top_click_hit",
                Self::ETopClickHitOptIn => "top_click_hit_opt_in",
                Self::ETopClickHitOptOut => "top_click_hit_opt_out",
                Self::ETopClickMiss => "top_click_miss",
                Self::EIframeClickHit => "iframe_click_hit",
                Self::EIframeClickHitOptIn => "iframe_click_hit_opt_in",
                Self::EIframeClickHitOptOut => "iframe_click_hit_opt_out",
                Self::EIframeClickMiss => "iframe_click_miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.rule_lookup_by_domain
    ///
    /// Counts the number of hit/miss of cookie banner rule lookups for domain. We
    /// collect three types of counters, including counters for overall rule lookup,
    /// counters for cookie rule lookup and counters for click rule lookup. We also
    /// divide the counter by top-level loads and iframe loads. For each domain, we
    /// will only collect once.
    pub static rule_lookup_by_domain: Lazy<LabeledMetric<LabeledCounterMetric, RuleLookupByDomainLabel>> = Lazy::new(|| {
        LabeledMetric::new(2867.into(), CommonMetricData {
            name: "rule_lookup_by_domain".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("iframe_click_hit"), ::std::borrow::Cow::from("iframe_click_hit_opt_in"), ::std::borrow::Cow::from("iframe_click_hit_opt_out"), ::std::borrow::Cow::from("iframe_click_miss"), ::std::borrow::Cow::from("iframe_cookie_hit"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_in"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_out"), ::std::borrow::Cow::from("iframe_cookie_miss"), ::std::borrow::Cow::from("iframe_hit"), ::std::borrow::Cow::from("iframe_hit_opt_in"), ::std::borrow::Cow::from("iframe_hit_opt_out"), ::std::borrow::Cow::from("iframe_miss"), ::std::borrow::Cow::from("top_click_hit"), ::std::borrow::Cow::from("top_click_hit_opt_in"), ::std::borrow::Cow::from("top_click_hit_opt_out"), ::std::borrow::Cow::from("top_click_miss"), ::std::borrow::Cow::from("top_cookie_hit"), ::std::borrow::Cow::from("top_cookie_hit_opt_in"), ::std::borrow::Cow::from("top_cookie_hit_opt_out"), ::std::borrow::Cow::from("top_cookie_miss"), ::std::borrow::Cow::from("top_hit"), ::std::borrow::Cow::from("top_hit_opt_in"), ::std::borrow::Cow::from("top_hit_opt_out"), ::std::borrow::Cow::from("top_miss")]))
    });

    #[repr(u16)]
    pub enum RuleLookupByLoadLabel {
        ETopHit = 0,
        ETopHitOptIn = 1,
        ETopHitOptOut = 2,
        ETopMiss = 3,
        EIframeHit = 4,
        EIframeHitOptIn = 5,
        EIframeHitOptOut = 6,
        EIframeMiss = 7,
        ETopCookieHit = 8,
        ETopCookieHitOptIn = 9,
        ETopCookieHitOptOut = 10,
        ETopCookieMiss = 11,
        EIframeCookieHit = 12,
        EIframeCookieHitOptIn = 13,
        EIframeCookieHitOptOut = 14,
        EIframeCookieMiss = 15,
        ETopClickHit = 16,
        ETopClickHitOptIn = 17,
        ETopClickHitOptOut = 18,
        ETopClickMiss = 19,
        EIframeClickHit = 20,
        EIframeClickHitOptIn = 21,
        EIframeClickHitOptOut = 22,
        EIframeClickMiss = 23,
        __Other__,
    }
    impl From<u16> for RuleLookupByLoadLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ETopHit,
                1 => Self::ETopHitOptIn,
                2 => Self::ETopHitOptOut,
                3 => Self::ETopMiss,
                4 => Self::EIframeHit,
                5 => Self::EIframeHitOptIn,
                6 => Self::EIframeHitOptOut,
                7 => Self::EIframeMiss,
                8 => Self::ETopCookieHit,
                9 => Self::ETopCookieHitOptIn,
                10 => Self::ETopCookieHitOptOut,
                11 => Self::ETopCookieMiss,
                12 => Self::EIframeCookieHit,
                13 => Self::EIframeCookieHitOptIn,
                14 => Self::EIframeCookieHitOptOut,
                15 => Self::EIframeCookieMiss,
                16 => Self::ETopClickHit,
                17 => Self::ETopClickHitOptIn,
                18 => Self::ETopClickHitOptOut,
                19 => Self::ETopClickMiss,
                20 => Self::EIframeClickHit,
                21 => Self::EIframeClickHitOptIn,
                22 => Self::EIframeClickHitOptOut,
                23 => Self::EIframeClickMiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RuleLookupByLoadLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ETopHit => "top_hit",
                Self::ETopHitOptIn => "top_hit_opt_in",
                Self::ETopHitOptOut => "top_hit_opt_out",
                Self::ETopMiss => "top_miss",
                Self::EIframeHit => "iframe_hit",
                Self::EIframeHitOptIn => "iframe_hit_opt_in",
                Self::EIframeHitOptOut => "iframe_hit_opt_out",
                Self::EIframeMiss => "iframe_miss",
                Self::ETopCookieHit => "top_cookie_hit",
                Self::ETopCookieHitOptIn => "top_cookie_hit_opt_in",
                Self::ETopCookieHitOptOut => "top_cookie_hit_opt_out",
                Self::ETopCookieMiss => "top_cookie_miss",
                Self::EIframeCookieHit => "iframe_cookie_hit",
                Self::EIframeCookieHitOptIn => "iframe_cookie_hit_opt_in",
                Self::EIframeCookieHitOptOut => "iframe_cookie_hit_opt_out",
                Self::EIframeCookieMiss => "iframe_cookie_miss",
                Self::ETopClickHit => "top_click_hit",
                Self::ETopClickHitOptIn => "top_click_hit_opt_in",
                Self::ETopClickHitOptOut => "top_click_hit_opt_out",
                Self::ETopClickMiss => "top_click_miss",
                Self::EIframeClickHit => "iframe_click_hit",
                Self::EIframeClickHitOptIn => "iframe_click_hit_opt_in",
                Self::EIframeClickHitOptOut => "iframe_click_hit_opt_out",
                Self::EIframeClickMiss => "iframe_click_miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.rule_lookup_by_load
    ///
    /// Counts the number of hit/miss of cookie banner rule lookups for every load. We
    /// collect three types of counters, including counters for overall rule lookup,
    /// counters for cookie rule lookup and counters for click rule lookup. We also
    /// divide the counter by top-level loads and iframe loads.
    pub static rule_lookup_by_load: Lazy<LabeledMetric<LabeledCounterMetric, RuleLookupByLoadLabel>> = Lazy::new(|| {
        LabeledMetric::new(2868.into(), CommonMetricData {
            name: "rule_lookup_by_load".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("iframe_click_hit"), ::std::borrow::Cow::from("iframe_click_hit_opt_in"), ::std::borrow::Cow::from("iframe_click_hit_opt_out"), ::std::borrow::Cow::from("iframe_click_miss"), ::std::borrow::Cow::from("iframe_cookie_hit"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_in"), ::std::borrow::Cow::from("iframe_cookie_hit_opt_out"), ::std::borrow::Cow::from("iframe_cookie_miss"), ::std::borrow::Cow::from("iframe_hit"), ::std::borrow::Cow::from("iframe_hit_opt_in"), ::std::borrow::Cow::from("iframe_hit_opt_out"), ::std::borrow::Cow::from("iframe_miss"), ::std::borrow::Cow::from("top_click_hit"), ::std::borrow::Cow::from("top_click_hit_opt_in"), ::std::borrow::Cow::from("top_click_hit_opt_out"), ::std::borrow::Cow::from("top_click_miss"), ::std::borrow::Cow::from("top_cookie_hit"), ::std::borrow::Cow::from("top_cookie_hit_opt_in"), ::std::borrow::Cow::from("top_cookie_hit_opt_out"), ::std::borrow::Cow::from("top_cookie_miss"), ::std::borrow::Cow::from("top_hit"), ::std::borrow::Cow::from("top_hit_opt_in"), ::std::borrow::Cow::from("top_hit_opt_out"), ::std::borrow::Cow::from("top_miss")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.service_detect_only
    ///
    /// Tracks the value of the cookiebanners.service.detectOnly pref.
    pub static service_detect_only: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2869.into(), CommonMetricData {
            name: "service_detect_only".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod cookie_banners_click {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.query_selector_run_count_per_window_frame
    ///
    /// How often a query selector is run during the lifetime of a sub-frame content
    /// window.
    pub static query_selector_run_count_per_window_frame: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2870.into(), CommonMetricData {
            name: "query_selector_run_count_per_window_frame".into(),
            category: "cookie.banners.click".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 2500, 20, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.query_selector_run_count_per_window_top_level
    ///
    /// How often a query selector is run during the lifetime of a top-level content
    /// window.
    pub static query_selector_run_count_per_window_top_level: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2871.into(), CommonMetricData {
            name: "query_selector_run_count_per_window_top_level".into(),
            category: "cookie.banners.click".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 2500, 20, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.query_selector_run_duration_per_window_frame
    ///
    /// Total time spent (in microseconds) on running querySelector for the lifetime of
    /// a sub-frame content window.
    pub static query_selector_run_duration_per_window_frame: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2872.into(), CommonMetricData {
            name: "query_selector_run_duration_per_window_frame".into(),
            category: "cookie.banners.click".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 30000000, 8, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.query_selector_run_duration_per_window_top_level
    ///
    /// Total time spent (in microseconds) on running querySelector for the lifetime of
    /// a top-level content window.
    pub static query_selector_run_duration_per_window_top_level: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2873.into(), CommonMetricData {
            name: "query_selector_run_duration_per_window_top_level".into(),
            category: "cookie.banners.click".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 30000000, 8, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum ResultLabel {
        ESuccess = 0,
        ESuccessCookieInjected = 1,
        ESuccessDomContentLoaded = 2,
        ESuccessMutationPreLoad = 3,
        ESuccessMutationPostLoad = 4,
        EFail = 5,
        EFailBannerNotFound = 6,
        EFailBannerNotVisible = 7,
        EFailButtonNotFound = 8,
        EFailNoRuleForMode = 9,
        EFailActorDestroyed = 10,
        __Other__,
    }
    impl From<u16> for ResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::ESuccessCookieInjected,
                2 => Self::ESuccessDomContentLoaded,
                3 => Self::ESuccessMutationPreLoad,
                4 => Self::ESuccessMutationPostLoad,
                5 => Self::EFail,
                6 => Self::EFailBannerNotFound,
                7 => Self::EFailBannerNotVisible,
                8 => Self::EFailButtonNotFound,
                9 => Self::EFailNoRuleForMode,
                10 => Self::EFailActorDestroyed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::ESuccessCookieInjected => "success_cookie_injected",
                Self::ESuccessDomContentLoaded => "success_dom_content_loaded",
                Self::ESuccessMutationPreLoad => "success_mutation_pre_load",
                Self::ESuccessMutationPostLoad => "success_mutation_post_load",
                Self::EFail => "fail",
                Self::EFailBannerNotFound => "fail_banner_not_found",
                Self::EFailBannerNotVisible => "fail_banner_not_visible",
                Self::EFailButtonNotFound => "fail_button_not_found",
                Self::EFailNoRuleForMode => "fail_no_rule_for_mode",
                Self::EFailActorDestroyed => "fail_actor_destroyed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.result
    ///
    /// Given a matching cookie banner rule, how often do we handle or fail to handle
    /// cookie banners, labelled by reason. The 'success' and 'fail' counters count the
    /// total numbers independently of the reason counters. Counters are incremented
    /// after the content window has been destroyed. This metric additionally reports
    /// cookie injections after which we didn't see a banner as
    /// "success_cookie_injected".
    pub static result: Lazy<LabeledMetric<LabeledCounterMetric, ResultLabel>> = Lazy::new(|| {
        LabeledMetric::new(2874.into(), CommonMetricData {
            name: "result".into(),
            category: "cookie.banners.click".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("fail"), ::std::borrow::Cow::from("fail_actor_destroyed"), ::std::borrow::Cow::from("fail_banner_not_found"), ::std::borrow::Cow::from("fail_banner_not_visible"), ::std::borrow::Cow::from("fail_button_not_found"), ::std::borrow::Cow::from("fail_no_rule_for_mode"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("success_cookie_injected"), ::std::borrow::Cow::from("success_dom_content_loaded"), ::std::borrow::Cow::from("success_mutation_post_load"), ::std::borrow::Cow::from("success_mutation_pre_load")]))
    });

}
pub mod cookie_banners_cmp {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.cmp.detected_cmp
    ///
    /// Counts how often a specific cmp has been detected by our cookie banner
    /// handling.
    pub static detected_cmp: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2875.into(), CommonMetricData {
            name: "detected_cmp".into(),
            category: "cookie.banners.cmp".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.cmp.ratio_handled_by_cmp_rule
    ///
    /// The proportion of cookie banners handled by CMP rules within the total number
    /// of cases handled, including those handled by site-specific rules.
    pub static ratio_handled_by_cmp_rule: Lazy<RateMetric> = Lazy::new(|| {
        RateMetric::new(2876.into(), CommonMetricData {
            name: "ratio_handled_by_cmp_rule".into(),
            category: "cookie.banners.cmp".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum ResultLabel {
        ESuccess = 0,
        ESuccessDomContentLoaded = 1,
        ESuccessMutationPreLoad = 2,
        ESuccessMutationPostLoad = 3,
        EFail = 4,
        EFailBannerNotFound = 5,
        EFailBannerNotVisible = 6,
        EFailButtonNotFound = 7,
        EFailNoRuleForMode = 8,
        EFailActorDestroyed = 9,
        __Other__,
    }
    impl From<u16> for ResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::ESuccessDomContentLoaded,
                2 => Self::ESuccessMutationPreLoad,
                3 => Self::ESuccessMutationPostLoad,
                4 => Self::EFail,
                5 => Self::EFailBannerNotFound,
                6 => Self::EFailBannerNotVisible,
                7 => Self::EFailButtonNotFound,
                8 => Self::EFailNoRuleForMode,
                9 => Self::EFailActorDestroyed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::ESuccessDomContentLoaded => "success_dom_content_loaded",
                Self::ESuccessMutationPreLoad => "success_mutation_pre_load",
                Self::ESuccessMutationPostLoad => "success_mutation_post_load",
                Self::EFail => "fail",
                Self::EFailBannerNotFound => "fail_banner_not_found",
                Self::EFailBannerNotVisible => "fail_banner_not_visible",
                Self::EFailButtonNotFound => "fail_button_not_found",
                Self::EFailNoRuleForMode => "fail_no_rule_for_mode",
                Self::EFailActorDestroyed => "fail_actor_destroyed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.cmp.result
    ///
    /// Given a matching CMP rule, how often do we handle or fail to handle cookie
    /// banners, labelled by reason. The 'success' and 'fail' counters count the total
    /// numbers independently of the reason counters. Counters are incremented after
    /// the content window has been destroyed.
    pub static result: Lazy<LabeledMetric<LabeledCounterMetric, ResultLabel>> = Lazy::new(|| {
        LabeledMetric::new(2877.into(), CommonMetricData {
            name: "result".into(),
            category: "cookie.banners.cmp".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("fail"), ::std::borrow::Cow::from("fail_actor_destroyed"), ::std::borrow::Cow::from("fail_banner_not_found"), ::std::borrow::Cow::from("fail_banner_not_visible"), ::std::borrow::Cow::from("fail_button_not_found"), ::std::borrow::Cow::from("fail_no_rule_for_mode"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("success_dom_content_loaded"), ::std::borrow::Cow::from("success_mutation_post_load"), ::std::borrow::Cow::from("success_mutation_pre_load")]))
    });

}
pub mod crash {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from crash.app_build
    ///
    /// The build id of the application. This may differ from `client_info` because a
    /// main process crash may be reported later by a different (e.g. updated) client.
    pub static app_build: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2878.into(), CommonMetricData {
            name: "app_build".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.app_channel
    ///
    /// The release channel of the application. This may differ from `client_info`
    /// because a main process crash may be reported later by a different (e.g.
    /// updated) client.
    pub static app_channel: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2879.into(), CommonMetricData {
            name: "app_channel".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.app_display_version
    ///
    /// The version of the application. This may differ from `client_info` because a
    /// main process crash may be reported later by a different (e.g. updated) client.
    pub static app_display_version: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2880.into(), CommonMetricData {
            name: "app_display_version".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct AsyncShutdownTimeoutObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub phase: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub conditions: Option<String>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub broken_add_blockers: AsyncShutdownTimeoutObjectItemBrokenAddBlockers,
    }

            pub type AsyncShutdownTimeoutObjectItemBrokenAddBlockers = Vec<AsyncShutdownTimeoutObjectItemBrokenAddBlockersItem>;

    pub type AsyncShutdownTimeoutObjectItemBrokenAddBlockersItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from crash.async_shutdown_timeout
    ///
    /// Present when a shutdown blocker failed to respond within a reasonable amount of
    /// time.
    pub static async_shutdown_timeout: Lazy<ObjectMetric<AsyncShutdownTimeoutObject>> = Lazy::new(|| {
        ObjectMetric::new(2881.into(), CommonMetricData {
            name: "async_shutdown_timeout".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.background_task_name
    ///
    /// The name of the background task if launched as one.
    pub static background_task_name: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2882.into(), CommonMetricData {
            name: "background_task_name".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.event_loop_nesting_level
    ///
    /// Indicates the nesting level of the event loop.
    pub static event_loop_nesting_level: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2883.into(), CommonMetricData {
            name: "event_loop_nesting_level".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.font_name
    ///
    /// The font family name that is being loaded when the crash occurred.
    pub static font_name: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2884.into(), CommonMetricData {
            name: "font_name".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.gpu_process_launch
    ///
    /// The number of times that the GPU process was launched.
    pub static gpu_process_launch: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2885.into(), CommonMetricData {
            name: "gpu_process_launch".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.ipc_channel_error
    ///
    /// The error reason for an ipc-based content crash.
    pub static ipc_channel_error: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2886.into(), CommonMetricData {
            name: "ipc_channel_error".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.is_garbage_collecting
    ///
    /// Indicates that the crash occurred while the garbage collector was running.
    pub static is_garbage_collecting: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2887.into(), CommonMetricData {
            name: "is_garbage_collecting".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.main_thread_runnable_name
    ///
    /// Name of the currently executing `nsIRunnable` on the main thread. Nightly-only.
    pub static main_thread_runnable_name: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2888.into(), CommonMetricData {
            name: "main_thread_runnable_name".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.minidump_sha256_hash
    ///
    /// The SHA256 hash of the associated minidump file, if any.
    pub static minidump_sha256_hash: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2889.into(), CommonMetricData {
            name: "minidump_sha256_hash".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.moz_crash_reason
    ///
    /// Contains the string passed to `MOZ_CRASH()`.
    pub static moz_crash_reason: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2890.into(), CommonMetricData {
            name: "moz_crash_reason".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.process_type
    ///
    /// The type of process that experienced a crash. See the full list of options
    /// [here](https://firefox-source-
    /// docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#process-
    /// types).
    pub static process_type: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2891.into(), CommonMetricData {
            name: "process_type".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.profiler_child_shutdown_phase
    ///
    /// The shutdown phase of the profiler.
    pub static profiler_child_shutdown_phase: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2892.into(), CommonMetricData {
            name: "profiler_child_shutdown_phase".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

        pub type QuotaManagerShutdownTimeoutObject = Vec<QuotaManagerShutdownTimeoutObjectItem>;

    pub type QuotaManagerShutdownTimeoutObjectItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from crash.quota_manager_shutdown_timeout
    ///
    /// Contains a list of shutdown steps and status of the quota manager clients.
    pub static quota_manager_shutdown_timeout: Lazy<ObjectMetric<QuotaManagerShutdownTimeoutObject>> = Lazy::new(|| {
        ObjectMetric::new(2893.into(), CommonMetricData {
            name: "quota_manager_shutdown_timeout".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.remote_type
    ///
    /// The type of the content process. See the full list of options
    /// [here](https://firefox-source-
    /// docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#remote-
    /// process-types).
    pub static remote_type: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2894.into(), CommonMetricData {
            name: "remote_type".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.shutdown_progress
    ///
    /// The shutdown phase in which the crash occurred.
    pub static shutdown_progress: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2895.into(), CommonMetricData {
            name: "shutdown_progress".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub error: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_type: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_thread: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub main_module: Option<i64>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub modules: StackTracesObjectItemModules,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub threads: StackTracesObjectItemThreads,
    }

            pub type StackTracesObjectItemModules = Vec<StackTracesObjectItemModulesItem>;

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectItemModulesItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub base_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub end_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub code_id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub debug_file: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub debug_id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub filename: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub version: Option<String>,
    }

            pub type StackTracesObjectItemThreads = Vec<StackTracesObjectItemThreadsItem>;

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectItemThreadsItem {
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub frames: StackTracesObjectItemThreadsItemItemFrames,
    }

            pub type StackTracesObjectItemThreadsItemItemFrames = Vec<StackTracesObjectItemThreadsItemItemFramesItem>;

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectItemThreadsItemItemFramesItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub module_index: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub ip: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub trust: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from crash.stack_traces
    ///
    /// Stack trace and module information of the crashing process.
    pub static stack_traces: Lazy<ObjectMetric<StackTracesObject>> = Lazy::new(|| {
        ObjectMetric::new(2896.into(), CommonMetricData {
            name: "stack_traces".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.startup
    ///
    /// If true, the crash occurred during process startup.
    pub static startup: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2897.into(), CommonMetricData {
            name: "startup".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.time
    ///
    /// The time at which the crash occurred.
    pub static time: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(2898.into(), CommonMetricData {
            name: "time".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod crash_windows {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from crash.windows.error_reporting
    ///
    /// Indicates if the crash was intercepted by the Windows Error Reporting runtime
    /// exception module.
    pub static error_reporting: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2899.into(), CommonMetricData {
            name: "error_reporting".into(),
            category: "crash.windows".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.windows.file_dialog_error_code
    ///
    /// The HRESULT returned from a Win32 system call leading to termination of the
    /// file-dialog utility process. MozCrashReason is expected to provide context for
    /// the value.
    pub static file_dialog_error_code: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2900.into(), CommonMetricData {
            name: "file_dialog_error_code".into(),
            category: "crash.windows".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod crash_submission {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.collector_errors
    ///
    /// 
    pub static collector_errors: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2901.into(), CommonMetricData {
            name: "collector_errors".into(),
            category: "crash_submission".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.failure
    ///
    /// 
    pub static failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2902,
            "crash_submission",
            "failure",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.pending
    ///
    /// 
    pub static pending: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2903,
            "crash_submission",
            "pending",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.success
    ///
    /// 
    pub static success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2904,
            "crash_submission",
            "success",
            "metrics"
        )
    });

}
pub mod dll_blocklist {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from dll_blocklist.init_failed
    ///
    /// Indicates whether initialization of the DLL blocklist failed.
    pub static init_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2905.into(), CommonMetricData {
            name: "init_failed".into(),
            category: "dll_blocklist".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from dll_blocklist.list
    ///
    /// A list of blocked DLLs.
    pub static list: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(2906.into(), CommonMetricData {
            name: "list".into(),
            category: "dll_blocklist".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from dll_blocklist.user32_loaded_before
    ///
    /// Indicates whether `user32.dll` was loaded before the DLL blocklist was
    /// initialized.
    pub static user32_loaded_before: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2907.into(), CommonMetricData {
            name: "user32_loaded_before".into(),
            category: "dll_blocklist".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod environment {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from environment.experimental_features
    ///
    /// Specifies the enabled experimental features from
    /// about:preferences#experimental.
    pub static experimental_features: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(2908.into(), CommonMetricData {
            name: "experimental_features".into(),
            category: "environment".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from environment.headless_mode
    ///
    /// Whether the app was invoked in headless mode via `--headless` or
    /// `--backgroundtask`.
    pub static headless_mode: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2909.into(), CommonMetricData {
            name: "headless_mode".into(),
            category: "environment".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from environment.uptime
    ///
    /// The start time of the application.
    pub static uptime: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(2910.into(), CommonMetricData {
            name: "uptime".into(),
            category: "environment".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod memory {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_commit
    ///
    /// Available commit size.
    pub static available_commit: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2911.into(), CommonMetricData {
            name: "available_commit".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_physical
    ///
    /// Available physical memory.
    pub static available_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2912.into(), CommonMetricData {
            name: "available_physical".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_swap
    ///
    /// Available swap memory.
    pub static available_swap: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2913.into(), CommonMetricData {
            name: "available_swap".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_virtual
    ///
    /// Available virtual memory.
    pub static available_virtual: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2914.into(), CommonMetricData {
            name: "available_virtual".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.low_physical
    ///
    /// The number of times the available memory tracker has detected that free
    /// physical memory is running low.
    pub static low_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2915.into(), CommonMetricData {
            name: "low_physical".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.oom_allocation_size
    ///
    /// The size of the allocation that caused on OOM crash.
    pub static oom_allocation_size: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2916.into(), CommonMetricData {
            name: "oom_allocation_size".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.purgeable_physical
    ///
    /// The amount of memory that can be deallocated by the OS in case of memory
    /// pressure.
    pub static purgeable_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2917.into(), CommonMetricData {
            name: "purgeable_physical".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.system_use_percentage
    ///
    /// The percentage of memory in use.
    pub static system_use_percentage: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2918.into(), CommonMetricData {
            name: "system_use_percentage".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.texture
    ///
    /// The amount of memory used in textures.
    pub static texture: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2919.into(), CommonMetricData {
            name: "texture".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.total_page_file
    ///
    /// The total page file size.
    pub static total_page_file: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2920.into(), CommonMetricData {
            name: "total_page_file".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.total_physical
    ///
    /// The total physical memory.
    pub static total_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2921.into(), CommonMetricData {
            name: "total_physical".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.total_virtual
    ///
    /// The total virtual memory.
    pub static total_virtual: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2922.into(), CommonMetricData {
            name: "total_virtual".into(),
            category: "memory".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod windows {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from windows.package_family_name
    ///
    /// The Package Family Name of Firefox, if installed through an MSIX package.
    pub static package_family_name: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2923.into(), CommonMetricData {
            name: "package_family_name".into(),
            category: "windows".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod extensions {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ProcessEventLabel {
        ECrashedBg = 0,
        ECrashedFg = 1,
        ECreatedBg = 2,
        ECreatedFg = 3,
        ECrashedOverThresholdBg = 4,
        ECrashedOverThresholdFg = 5,
        __Other__,
    }
    impl From<u16> for ProcessEventLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrashedBg,
                1 => Self::ECrashedFg,
                2 => Self::ECreatedBg,
                3 => Self::ECreatedFg,
                4 => Self::ECrashedOverThresholdBg,
                5 => Self::ECrashedOverThresholdFg,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ProcessEventLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrashedBg => "crashed_bg",
                Self::ECrashedFg => "crashed_fg",
                Self::ECreatedBg => "created_bg",
                Self::ECreatedFg => "created_fg",
                Self::ECrashedOverThresholdBg => "crashed_over_threshold_bg",
                Self::ECrashedOverThresholdFg => "crashed_over_threshold_fg",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.process_event
    ///
    /// Counters for how many times the extension process has crashed or been created.
    /// The labels with "_fg" / "_bg" suffixes are only recorded in Android builds,
    /// while the "created" and "crashed" labels are recorded on both Desktop and
    /// Android
    /// builds.
    pub static process_event: Lazy<LabeledMetric<LabeledCounterMetric, ProcessEventLabel>> = Lazy::new(|| {
        LabeledMetric::new(2924.into(), CommonMetricData {
            name: "process_event".into(),
            category: "extensions".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("crashed_bg"), ::std::borrow::Cow::from("crashed_fg"), ::std::borrow::Cow::from("crashed_over_threshold_bg"), ::std::borrow::Cow::from("crashed_over_threshold_fg"), ::std::borrow::Cow::from("created_bg"), ::std::borrow::Cow::from("created_fg")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.startup_cache_load_time
    ///
    /// Time to load and deserialize the extensions startupCache data.
    pub static startup_cache_load_time: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(2925.into(), CommonMetricData {
            name: "startup_cache_load_time".into(),
            category: "extensions".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.startup_cache_read_errors
    ///
    /// The number of times an unexpected error has been raised while reading
    /// the extensions StartupCache file.
    pub static startup_cache_read_errors: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2926.into(), CommonMetricData {
            name: "startup_cache_read_errors".into(),
            category: "extensions".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.startup_cache_write_bytelength
    ///
    /// The amount of bytes written to the extensions StartupCache file.
    pub static startup_cache_write_bytelength: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2927.into(), CommonMetricData {
            name: "startup_cache_write_bytelength".into(),
            category: "extensions".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.use_remote_policy
    ///
    /// Corresponds to the value of `WebExtensionPolicy.useRemoteWebExtensions`.
    pub static use_remote_policy: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2928.into(), CommonMetricData {
            name: "use_remote_policy".into(),
            category: "extensions".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.use_remote_pref
    ///
    /// Corresponds to the value of `extensions.webextensions.remote` pref.
    pub static use_remote_pref: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2929.into(), CommonMetricData {
            name: "use_remote_pref".into(),
            category: "extensions".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod extensions_apis_dnr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.evaluate_rules_count_max
    ///
    /// Max amount of DNR rules being evaluated.
    pub static evaluate_rules_count_max: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2930.into(), CommonMetricData {
            name: "evaluate_rules_count_max".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.evaluate_rules_time
    ///
    /// Amount of time it takes to evaluate DNR rules for one network request.
    pub static evaluate_rules_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2931.into(), CommonMetricData {
            name: "evaluate_rules_time".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum StartupCacheEntriesLabel {
        EHit = 0,
        EMiss = 1,
        __Other__,
    }
    impl From<u16> for StartupCacheEntriesLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHit,
                1 => Self::EMiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StartupCacheEntriesLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHit => "hit",
                Self::EMiss => "miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_entries
    ///
    /// Counters for startup cache data hits or misses on initializating
    /// DNR rules for extensions loaded on application startup.
    pub static startup_cache_entries: Lazy<LabeledMetric<LabeledCounterMetric, StartupCacheEntriesLabel>> = Lazy::new(|| {
        LabeledMetric::new(2932.into(), CommonMetricData {
            name: "startup_cache_entries".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("hit"), ::std::borrow::Cow::from("miss")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_read_size
    ///
    /// Amount of data read from the DNR startup cache file.
    pub static startup_cache_read_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(2933.into(), CommonMetricData {
            name: "startup_cache_read_size".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_read_time
    ///
    /// Amount of time it takes to read data into the DNR startup cache file.
    pub static startup_cache_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2934.into(), CommonMetricData {
            name: "startup_cache_read_time".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_write_size
    ///
    /// Amount of data written to the DNR startup cache file.
    pub static startup_cache_write_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(2935.into(), CommonMetricData {
            name: "startup_cache_write_size".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_write_time
    ///
    /// Amount of time it takes to write data into the DNR startup cache file.
    pub static startup_cache_write_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2936.into(), CommonMetricData {
            name: "startup_cache_write_time".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.validate_rules_time
    ///
    /// Amount of time it takes to validate DNR rules of individual ruleset
    /// when dynamic or static rulesets have been loaded from disk.
    pub static validate_rules_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2937.into(), CommonMetricData {
            name: "validate_rules_time".into(),
            category: "extensions.apis.dnr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod extensions_counters {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum BrowserActionPreloadResultLabel {
        EPopupshown = 0,
        EClearafterhover = 1,
        EClearaftermousedown = 2,
        __Other__,
    }
    impl From<u16> for BrowserActionPreloadResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPopupshown,
                1 => Self::EClearafterhover,
                2 => Self::EClearaftermousedown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BrowserActionPreloadResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPopupshown => "popupShown",
                Self::EClearafterhover => "clearAfterHover",
                Self::EClearaftermousedown => "clearAfterMousedown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.counters.browser_action_preload_result
    ///
    /// Number of times an event page hit the idle timeout and results in one of the
    /// labels.
    pub static browser_action_preload_result: Lazy<LabeledMetric<LabeledCounterMetric, BrowserActionPreloadResultLabel>> = Lazy::new(|| {
        LabeledMetric::new(2938.into(), CommonMetricData {
            name: "browser_action_preload_result".into(),
            category: "extensions.counters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("clearAfterHover"), ::std::borrow::Cow::from("clearAfterMousedown"), ::std::borrow::Cow::from("popupShown")]))
    });

    #[repr(u16)]
    pub enum EventPageIdleResultLabel {
        ESuspend = 0,
        EResetOther = 1,
        EResetEvent = 2,
        EResetListeners = 3,
        EResetNativeapp = 4,
        EResetStreamfilter = 5,
        EResetParentapicall = 6,
        EPermissionsRequest = 7,
        ELaunchwebauthflow = 8,
        __Other__,
    }
    impl From<u16> for EventPageIdleResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuspend,
                1 => Self::EResetOther,
                2 => Self::EResetEvent,
                3 => Self::EResetListeners,
                4 => Self::EResetNativeapp,
                5 => Self::EResetStreamfilter,
                6 => Self::EResetParentapicall,
                7 => Self::EPermissionsRequest,
                8 => Self::ELaunchwebauthflow,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EventPageIdleResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuspend => "suspend",
                Self::EResetOther => "reset_other",
                Self::EResetEvent => "reset_event",
                Self::EResetListeners => "reset_listeners",
                Self::EResetNativeapp => "reset_nativeapp",
                Self::EResetStreamfilter => "reset_streamfilter",
                Self::EResetParentapicall => "reset_parentapicall",
                Self::EPermissionsRequest => "permissions_request",
                Self::ELaunchwebauthflow => "launchWebAuthFlow",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.counters.event_page_idle_result
    ///
    /// Number of times an event page hit the idle timeout and results in one of the
    /// labels.
    pub static event_page_idle_result: Lazy<LabeledMetric<LabeledCounterMetric, EventPageIdleResultLabel>> = Lazy::new(|| {
        LabeledMetric::new(2939.into(), CommonMetricData {
            name: "event_page_idle_result".into(),
            category: "extensions.counters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("launchWebAuthFlow"), ::std::borrow::Cow::from("permissions_request"), ::std::borrow::Cow::from("reset_event"), ::std::borrow::Cow::from("reset_listeners"), ::std::borrow::Cow::from("reset_nativeapp"), ::std::borrow::Cow::from("reset_other"), ::std::borrow::Cow::from("reset_parentapicall"), ::std::borrow::Cow::from("reset_streamfilter"), ::std::borrow::Cow::from("suspend")]))
    });

}
pub mod extensions_data {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct MigrateResultExtra {
        pub addon_id: Option<String>,
        pub backend: Option<String>,
        pub data_migrated: Option<String>,
        pub error_name: Option<String>,
        pub has_jsonfile: Option<String>,
        pub has_olddata: Option<String>,
    }

    impl ExtraKeys for MigrateResultExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "backend", "data_migrated", "error_name", "has_jsonfile", "has_olddata"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.backend.and_then(|val| map.insert("backend".into(), val.to_string()));
          self.data_migrated.and_then(|val| map.insert("data_migrated".into(), val.to_string()));
          self.error_name.and_then(|val| map.insert("error_name".into(), val.to_string()));
          self.has_jsonfile.and_then(|val| map.insert("has_jsonfile".into(), val.to_string()));
          self.has_olddata.and_then(|val| map.insert("has_olddata".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.data.migrate_result
    ///
    /// These events are sent when an extension is migrating its data to the new
    /// IndexedDB backend.
    pub static migrate_result: Lazy<EventMetric<MigrateResultExtra>> = Lazy::new(|| {
        EventMetric::new(2940.into(), CommonMetricData {
            name: "migrate_result".into(),
            category: "extensions.data".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct StorageLocalErrorExtra {
        pub addon_id: Option<String>,
        pub error_name: Option<String>,
        pub method: Option<String>,
    }

    impl ExtraKeys for StorageLocalErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "error_name", "method"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.error_name.and_then(|val| map.insert("error_name".into(), val.to_string()));
          self.method.and_then(|val| map.insert("method".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.data.storage_local_error
    ///
    /// These events are collected when an extension triggers an unexpected error
    /// while running a storage.local API call (e.g. because of some underlying
    /// QuotaManager and/or IndexedDB error).
    pub static storage_local_error: Lazy<EventMetric<StorageLocalErrorExtra>> = Lazy::new(|| {
        EventMetric::new(2941.into(), CommonMetricData {
            name: "storage_local_error".into(),
            category: "extensions.data".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod extensions_quarantined_domains {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from extensions.quarantined_domains.listhash
    ///
    /// SHA1 cryptographic hash of the quarantined domains string pref.
    pub static listhash: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2942.into(), CommonMetricData {
            name: "listhash".into(),
            category: "extensions.quarantined_domains".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.quarantined_domains.listsize
    ///
    /// Number of domains listed in the quarantined domains list pref for the client
    /// during this session.
    pub static listsize: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2943.into(), CommonMetricData {
            name: "listsize".into(),
            category: "extensions.quarantined_domains".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.quarantined_domains.remotehash
    ///
    /// SHA1 cryptographic hash of the quarantined domains string pref as it was set
    /// based on the value got synced from the RemoteSettings collection.
    /// AMRemoteSettings will be re-processing the entries on the next application
    /// startup and so this metric lifetime can be set to application and expect it to
    /// be always set to the value got from the RemoteSettings collection.
    pub static remotehash: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2944.into(), CommonMetricData {
            name: "remotehash".into(),
            category: "extensions.quarantined_domains".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod extensions_timing {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.background_page_load
    ///
    /// Amount of time it takes to load a WebExtensions background page, from when the
    /// build function is called to when the page has finished processing the onload
    /// event.
    pub static background_page_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2945.into(), CommonMetricData {
            name: "background_page_load".into(),
            category: "extensions.timing".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.browser_action_popup_open
    ///
    /// Amount of time it takes for a BrowserAction popup to open.
    pub static browser_action_popup_open: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2946.into(), CommonMetricData {
            name: "browser_action_popup_open".into(),
            category: "extensions.timing".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.content_script_injection
    ///
    /// Amount of time it takes for content scripts from a WebExtension to be injected
    /// into a window.
    pub static content_script_injection: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2947.into(), CommonMetricData {
            name: "content_script_injection".into(),
            category: "extensions.timing".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.event_page_running_time
    ///
    /// Amount of time (keyed by addon id) that an event page has been running before
    /// being suspended,
    /// or the entire addon shutdown.
    pub static event_page_running_time: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2948.into(), CommonMetricData {
            name: "event_page_running_time".into(),
            category: "extensions.timing".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 60000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.extension_startup
    ///
    /// Amount of time it takes for a WebExtension to start up, from when the
    /// startup function is called to when the startup promise resolves.
    pub static extension_startup: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2949.into(), CommonMetricData {
            name: "extension_startup".into(),
            category: "extensions.timing".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.page_action_popup_open
    ///
    /// Amount of time it takes for a PageAction popup to open.
    pub static page_action_popup_open: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2950.into(), CommonMetricData {
            name: "page_action_popup_open".into(),
            category: "extensions.timing".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.storage_local_get_idb
    ///
    /// Amount of time it takes to perform a get via storage.local using the IndexedDB
    /// backend.
    pub static storage_local_get_idb: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2951.into(), CommonMetricData {
            name: "storage_local_get_idb".into(),
            category: "extensions.timing".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.storage_local_set_idb
    ///
    /// Amount of time it takes to perform a set via storage.local using the Indexed
    /// backend.
    pub static storage_local_set_idb: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2952.into(), CommonMetricData {
            name: "storage_local_set_idb".into(),
            category: "extensions.timing".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod formautofill {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum FormSubmissionHeuristicLabel {
        EFormSubmitEvent = 0,
        EFormRemovalAfterFetch = 1,
        EPageNavigation = 2,
        EIframePagehide = 3,
        __Other__,
    }
    impl From<u16> for FormSubmissionHeuristicLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFormSubmitEvent,
                1 => Self::EFormRemovalAfterFetch,
                2 => Self::EPageNavigation,
                3 => Self::EIframePagehide,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FormSubmissionHeuristicLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFormSubmitEvent => "form-submit-event",
                Self::EFormRemovalAfterFetch => "form-removal-after-fetch",
                Self::EPageNavigation => "page-navigation",
                Self::EIframePagehide => "iframe-pagehide",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.form_submission_heuristic
    ///
    /// The heuristic that detected the form submission.
    pub static form_submission_heuristic: Lazy<LabeledMetric<LabeledCounterMetric, FormSubmissionHeuristicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2953.into(), CommonMetricData {
            name: "form_submission_heuristic".into(),
            category: "formautofill".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("form-removal-after-fetch"), ::std::borrow::Cow::from("form-submit-event"), ::std::borrow::Cow::from("iframe-pagehide"), ::std::borrow::Cow::from("page-navigation")]))
    });

}
pub mod formautofill_creditcards {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.autofill_profiles_count
    ///
    /// Count at store time how many credit card autofill profiles the user has.
    pub static autofill_profiles_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2954.into(), CommonMetricData {
            name: "autofill_profiles_count".into(),
            category: "formautofill.creditcards".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct FormClearedExtra {
        pub field_name: Option<String>,
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for FormClearedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["field_name", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_cleared
    ///
    /// Recorded when a credit card form is cleared . The flow id indicates an
    /// interaction session with the a form and is shared across cc_form events. The
    /// field_name is used to record the field that triggers this event
    pub static form_cleared: Lazy<EventMetric<FormClearedExtra>> = Lazy::new(|| {
        EventMetric::new(2955.into(), CommonMetricData {
            name: "form_cleared".into(),
            category: "formautofill.creditcards".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct FormDetectedExtra {
        pub cc_exp: Option<String>,
        pub cc_exp_month: Option<String>,
        pub cc_exp_year: Option<String>,
        pub cc_name: Option<String>,
        pub cc_number: Option<String>,
        pub cc_number_multi_parts: Option<u32>,
        pub cc_type: Option<String>,
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for FormDetectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_number_multi_parts", "cc_type", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.cc_number_multi_parts.and_then(|val| map.insert("cc_number_multi_parts".into(), val.to_string()));
          self.cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_detected
    ///
    /// Recorded when a form is recognized as a credit card form. The possible value of
    /// cc_* are "autocomplete", "undetected", "regexp" or an integer between 0-100:
    ///   - When the value is "autocomplete", the field is identified via autocomplete
    /// attribute
    ///   - When the value is "undetected", the field is not detected in the form
    ///   - When the value is "regexp", then the field is identified by regexp-based
    /// heuristic
    ///   - When the value is an integer greater than 0, the value indicates the
    /// confidence value from fathom (normalized to 0-100)
    /// The flow id points to an interaction session with a credit card form and is
    /// shared across cc_form events .
    pub static form_detected: Lazy<EventMetric<FormDetectedExtra>> = Lazy::new(|| {
        EventMetric::new(2956.into(), CommonMetricData {
            name: "form_detected".into(),
            category: "formautofill.creditcards".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct FormFilledExtra {
        pub cc_exp: Option<String>,
        pub cc_exp_month: Option<String>,
        pub cc_exp_year: Option<String>,
        pub cc_name: Option<String>,
        pub cc_number: Option<String>,
        pub cc_type: Option<String>,
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for FormFilledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_filled
    ///
    /// Recorded when a credit card form is autofilled. The flow id indicates an
    /// interaction session with the a form and is shared across cc_form events. The
    /// possible value of cc_* are `filled`, `not_filled`, `user_filled` or
    /// `unavailable`
    pub static form_filled: Lazy<EventMetric<FormFilledExtra>> = Lazy::new(|| {
        EventMetric::new(2957.into(), CommonMetricData {
            name: "form_filled".into(),
            category: "formautofill.creditcards".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct FormFilledModifiedExtra {
        pub field_name: Option<String>,
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for FormFilledModifiedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["field_name", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_filled_modified
    ///
    /// Recorded when a field in a credit card form is autofilled and then modified by
    /// the user. The flow id indicates an interaction session with the a form and is
    /// shared across cc_form events. The field_name is used to record the field that
    /// triggers this event.
    pub static form_filled_modified: Lazy<EventMetric<FormFilledModifiedExtra>> = Lazy::new(|| {
        EventMetric::new(2958.into(), CommonMetricData {
            name: "form_filled_modified".into(),
            category: "formautofill.creditcards".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct FormPopupShownExtra {
        pub field_name: Option<String>,
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for FormPopupShownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["field_name", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_popup_shown
    ///
    /// Recorded when autofill popup is shown for a credit card form. The flow id
    /// indicates an interaction session with the a form and is shared across cc_form
    /// events. The field_name is used to record the field that triggers this event.
    pub static form_popup_shown: Lazy<EventMetric<FormPopupShownExtra>> = Lazy::new(|| {
        EventMetric::new(2959.into(), CommonMetricData {
            name: "form_popup_shown".into(),
            category: "formautofill.creditcards".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct FormSubmittedExtra {
        pub cc_exp: Option<String>,
        pub cc_exp_month: Option<String>,
        pub cc_exp_year: Option<String>,
        pub cc_name: Option<String>,
        pub cc_number: Option<String>,
        pub cc_type: Option<String>,
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for FormSubmittedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.form_submitted
    ///
    /// Recorded when a credit card form is submitted. The flow id indicates an
    /// interaction session with the a form and is shared across cc_form events. The
    /// possible value of cc_* are `autofilled`, `user_filled` or `unavailable`
    pub static form_submitted: Lazy<EventMetric<FormSubmittedExtra>> = Lazy::new(|| {
        EventMetric::new(2960.into(), CommonMetricData {
            name: "form_submitted".into(),
            category: "formautofill.creditcards".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod fog {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from fog.failed_idle_registration
    ///
    /// True if we failed to register with the idle service. Absent otherwise.
    /// Means IPC probably isn't working well.
    /// Child-process data will likely be absent, or incomplete.
    pub static failed_idle_registration: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2961.into(), CommonMetricData {
            name: "failed_idle_registration".into(),
            category: "fog".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.initialization
    ///
    /// Time the FOG initialization takes.
    pub static initialization: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(2962.into(), CommonMetricData {
            name: "initialization".into(),
            category: "fog".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.inits_during_shutdown
    ///
    /// Counts the number of times init had to be called during shutdown.
    /// Should never have a value for any session long enough to grow idle.
    pub static inits_during_shutdown: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2963,
            "fog",
            "inits_during_shutdown",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.max_pings_per_minute
    ///
    /// Value of the configurable rate limit, in pings per minute, for Glean pings as
    /// set at init.
    pub static max_pings_per_minute: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2964.into(), CommonMetricData {
            name: "max_pings_per_minute".into(),
            category: "fog".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod fog_ipc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.buffer_sizes
    ///
    /// The number and size of the IPC buffers being received over FOG IPC.
    pub static buffer_sizes: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(2965.into(), CommonMetricData {
            name: "buffer_sizes".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.flush_durations
    ///
    /// The length of time between asking the child processes for their
    /// IPC buffers and all of them being received by the parent.
    pub static flush_durations: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2966.into(), CommonMetricData {
            name: "flush_durations".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.flush_failures
    ///
    /// The number of times we failed to flush all non-parent-process data,
    /// throwing even partial results into the trash.
    /// If this number is high, we might consider writing custom `MozPromise`-
    /// handling code instead of using `MozPromise::All`.
    pub static flush_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2967,
            "fog.ipc",
            "flush_failures",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.replay_failures
    ///
    /// The number of times the ipc buffer failed to be replayed in the
    /// parent process.
    pub static replay_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2968,
            "fog.ipc",
            "replay_failures",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.shutdown_registration_failures
    ///
    /// The number of times we tried to register shutdown flush routines for
    /// content child processes, and failed (probably because there was no main
    /// thread).
    /// As a result there may be data loss from content child processes.
    /// Large or rising number of clients experiencing this indicates we should
    /// perhaps refactor content child shutdown in FOG to try harder to register
    /// flush operations.
    /// Will likely be obsoleted by bug 1641989.
    pub static shutdown_registration_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2969,
            "fog.ipc",
            "shutdown_registration_failures",
            "metrics"
        )
    });

}
pub mod test_only {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.bad_code
    ///
    /// Number of times we encountered bad code.
    /// This is a test-only metric.
    pub static bad_code: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(2970.into(), CommonMetricData {
            name: "bad_code".into(),
            category: "test_only".into(),
            send_in_pings: vec!["ride-along-ping".into(), "test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

        pub type BalloonsObject = Vec<BalloonsObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct BalloonsObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub colour: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub diameter: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub CamelCasedParameter: Option<i64>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from test_only.balloons
    ///
    /// A collection of balloons
    pub static balloons: Lazy<ObjectMetric<BalloonsObject>> = Lazy::new(|| {
        ObjectMetric::new(2971.into(), CommonMetricData {
            name: "balloons".into(),
            category: "test_only".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.can_we_flag_it
    ///
    /// Test metric for a boolean.
    /// This is a test-only metric.
    pub static can_we_flag_it: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2972.into(), CommonMetricData {
            name: "can_we_flag_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.can_we_time_it
    ///
    /// Test metric for a timespan.
    /// This is a test-only metric.
    pub static can_we_time_it: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(2973.into(), CommonMetricData {
            name: "can_we_time_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.cheesy_string
    ///
    /// Only the cheesiest of strings.
    /// This is a test-only metric.
    pub static cheesy_string: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(2974.into(), CommonMetricData {
            name: "cheesy_string".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.cheesy_string_list
    ///
    /// Only the cheesiest of strings. In list form!
    /// This is a test-only metric.
    pub static cheesy_string_list: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(2975.into(), CommonMetricData {
            name: "cheesy_string_list".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct CrashStackObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub status: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub main_module: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_info: Option<CrashStackObjectItemCrashInfoObject>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub modules: CrashStackObjectItemModules,
    }

            #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct CrashStackObjectItemCrashInfoObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub typ: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crashing_thread: Option<i64>,
    }

            pub type CrashStackObjectItemModules = Vec<CrashStackObjectItemModulesItem>;

        #[derive(Debug, Hash, Eq, PartialEq, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct CrashStackObjectItemModulesItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub base_addr: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub end_addr: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from test_only.crash_stack
    ///
    /// A not-real crash stack
    pub static crash_stack: Lazy<ObjectMetric<CrashStackObject>> = Lazy::new(|| {
        ObjectMetric::new(2976.into(), CommonMetricData {
            name: "crash_stack".into(),
            category: "test_only".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.do_you_remember
    ///
    /// They say it's the second thing to go.
    /// This is a test-only metric.
    pub static do_you_remember: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(2977.into(), CommonMetricData {
            name: "do_you_remember".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Megabyte)
    });

    #[repr(u16)]
    pub enum MabelsBalloonLabelsLabel {
        ECelebratory = 0,
        ECelebratoryAndSnarky = 1,
        __Other__,
    }
    impl From<u16> for MabelsBalloonLabelsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECelebratory,
                1 => Self::ECelebratoryAndSnarky,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsBalloonLabelsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECelebratory => "celebratory",
                Self::ECelebratoryAndSnarky => "celebratory_and_snarky",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_balloon_labels
    ///
    /// How does Mabel label her balloons?
    /// This is a test-only metric.
    pub static mabels_balloon_labels: Lazy<LabeledMetric<LabeledStringMetric, MabelsBalloonLabelsLabel>> = Lazy::new(|| {
        LabeledMetric::new(2978.into(), CommonMetricData {
            name: "mabels_balloon_labels".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("celebratory"), ::std::borrow::Cow::from("celebratory_and_snarky")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_balloon_strings
    ///
    /// What do the labeled Mabel's liked balloons' strings say?
    /// This is a test-only metric.
    pub static mabels_balloon_strings: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2979.into(), CommonMetricData {
            name: "mabels_balloon_strings".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_bathroom_counters
    ///
    /// Counts Mabels labeled by their bathroom counters.
    /// This is a test-only metric.
    pub static mabels_bathroom_counters: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2980.into(), CommonMetricData {
            name: "mabels_bathroom_counters".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_kitchen_counters
    ///
    /// Counts Mabels labeled by their kitchen counters.
    /// This is a test-only metric.
    pub static mabels_kitchen_counters: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2981.into(), CommonMetricData {
            name: "mabels_kitchen_counters".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_label_maker
    ///
    /// Mabel just got a label maker and wants to party like it's
    /// 1999.
    /// This is a test-only metric.
    pub static mabels_label_maker: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2982.into(), CommonMetricData {
            name: "mabels_label_maker".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[repr(u16)]
    pub enum MabelsLabeledCountersLabel {
        ENextToTheFridge = 0,
        EClean = 1,
        E1stCounter = 2,
        __Other__,
    }
    impl From<u16> for MabelsLabeledCountersLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENextToTheFridge,
                1 => Self::EClean,
                2 => Self::E1stCounter,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsLabeledCountersLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENextToTheFridge => "next_to_the_fridge",
                Self::EClean => "clean",
                Self::E1stCounter => "1st_counter",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_labeled_counters
    ///
    /// Counts Mabels labeled by their kitchen counters.
    /// Now with static labels.
    /// This is a test-only metric.
    pub static mabels_labeled_counters: Lazy<LabeledMetric<LabeledCounterMetric, MabelsLabeledCountersLabel>> = Lazy::new(|| {
        LabeledMetric::new(2983.into(), CommonMetricData {
            name: "mabels_labeled_counters".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("1st_counter"), ::std::borrow::Cow::from("clean"), ::std::borrow::Cow::from("next_to_the_fridge")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_like_balloons
    ///
    /// Does the labeled Mabel like balloons?
    /// This is a test-only metric.
    pub static mabels_like_balloons: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2984.into(), CommonMetricData {
            name: "mabels_like_balloons".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[repr(u16)]
    pub enum MabelsLikeLabeledBalloonsLabel {
        EWater = 0,
        EBirthdayParty = 1,
        __Other__,
    }
    impl From<u16> for MabelsLikeLabeledBalloonsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EWater,
                1 => Self::EBirthdayParty,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsLikeLabeledBalloonsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EWater => "water",
                Self::EBirthdayParty => "birthday_party",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_like_labeled_balloons
    ///
    /// Does the labeled Mabel like balloons?
    /// This is a test-only metric.
    pub static mabels_like_labeled_balloons: Lazy<LabeledMetric<LabeledBooleanMetric, MabelsLikeLabeledBalloonsLabel>> = Lazy::new(|| {
        LabeledMetric::new(2985.into(), CommonMetricData {
            name: "mabels_like_labeled_balloons".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("birthday_party"), ::std::borrow::Cow::from("water")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.meaning_of_life
    ///
    /// Measures the one true answer to the Ultimate Question of Life,
    /// the Universe, and Everything.
    /// Approximately.
    /// This is a test-only metric.
    pub static meaning_of_life: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(2986.into(), CommonMetricData {
            name: "meaning_of_life".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirror_time
    ///
    /// Mirrored metric for a timespan.
    /// This is a test-only metric.
    pub static mirror_time: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(2987.into(), CommonMetricData {
            name: "mirror_time".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirror_time_nanos
    ///
    /// Mirrored metric for a timespan.
    /// This is a test-only metric.
    pub static mirror_time_nanos: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(2988.into(), CommonMetricData {
            name: "mirror_time_nanos".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirrors_for_labeled_bools
    ///
    /// Mirrored metric.
    /// This is a test-only metric.
    pub static mirrors_for_labeled_bools: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2989.into(), CommonMetricData {
            name: "mirrors_for_labeled_bools".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.one_ping_one_bool
    ///
    /// One bool for one ping only.
    /// This is a test-only metric.
    pub static one_ping_one_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2990.into(), CommonMetricData {
            name: "one_ping_one_bool".into(),
            category: "test_only".into(),
            send_in_pings: vec!["one-ping-only".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_a_date
    ///
    /// ...To be writing FOG code. This is a test-only metric.
    pub static what_a_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(2991.into(), CommonMetricData {
            name: "what_a_date".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_id_it
    ///
    /// Just a UUID.
    /// This is a test-only metric.
    pub static what_id_it: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(2992.into(), CommonMetricData {
            name: "what_id_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_time_is_it
    ///
    /// Adheres to at least two of the top ten fallacies programmers believe
    /// about time.
    /// This is a test-only metric.
    pub static what_time_is_it: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(2993.into(), CommonMetricData {
            name: "what_time_is_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

}
pub mod test_only_ipc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_bool
    ///
    /// This is a test-only metric.
    /// Just flagging things.
    pub static a_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(2994.into(), CommonMetricData {
            name: "a_bool".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_counter
    ///
    /// This is a test-only metric.
    /// Just counting things.
    pub static a_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2995,
            "test_only.ipc",
            "a_counter",
            "store1"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_custom_dist
    ///
    /// This is a test-only metric.
    /// Just measuring samples.
    pub static a_custom_dist: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(2996.into(), CommonMetricData {
            name: "a_custom_dist".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 2147483646, 10, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_date
    ///
    /// This is a test-only metric.
    /// Just putting things on the calendar.
    pub static a_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(2997.into(), CommonMetricData {
            name: "a_date".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_labeled_counter
    ///
    /// This is a test-only metric.
    /// Just counting labeled things.
    pub static a_labeled_counter: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(2998.into(), CommonMetricData {
            name: "a_labeled_counter".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_memory_dist
    ///
    /// This is a test-only metric.
    /// Just measuring memory.
    pub static a_memory_dist: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(2999.into(), CommonMetricData {
            name: "a_memory_dist".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_quantity
    ///
    /// This is a test-only metric.
    /// Just quantifying things.
    pub static a_quantity: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3000.into(), CommonMetricData {
            name: "a_quantity".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string
    ///
    /// This is a test-only metric.
    /// Just setting some strings.
    pub static a_string: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3001.into(), CommonMetricData {
            name: "a_string".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string_list
    ///
    /// This is a test-only metric.
    /// Just appending some strings.
    pub static a_string_list: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(3002.into(), CommonMetricData {
            name: "a_string_list".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_text
    ///
    /// This is a test-only metric.
    /// For holding Text data.
    pub static a_text: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3003.into(), CommonMetricData {
            name: "a_text".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_timing_dist
    ///
    /// This is a test-only metric.
    /// Just measuring time.
    pub static a_timing_dist: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(3004.into(), CommonMetricData {
            name: "a_timing_dist".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_url
    ///
    /// This is a test-only metric.
    /// Just setting some Urls.
    pub static a_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(3005.into(), CommonMetricData {
            name: "a_url".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_uuid
    ///
    /// This is a test-only metric.
    /// Just recording some unique identifiers.
    pub static a_uuid: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(3006.into(), CommonMetricData {
            name: "a_uuid".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AnEventExtra {
        pub extra1: Option<String>,
        pub extra2: Option<String>,
        pub value: Option<String>,
    }

    impl ExtraKeys for AnEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          self.value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_event
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    pub static an_event: Lazy<EventMetric<AnEventExtra>> = Lazy::new(|| {
        EventMetric::new(3007.into(), CommonMetricData {
            name: "an_event".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_external_denominator
    ///
    /// This is a test-only metric.
    /// A denominator not from around here.
    pub static an_external_denominator: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(3008.into(), CommonMetricData {
            name: "an_external_denominator".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "rate_with_external_denominator".into(), category: "test_only.ipc".into(), send_in_pings: vec!["store1".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.another_labeled_counter
    ///
    /// This is a test-only metric.
    /// Just another metric counting labeled things.
    pub static another_labeled_counter: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        LabeledMetric::new(3009.into(), CommonMetricData {
            name: "another_labeled_counter".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EventWithExtraExtra {
        pub extra1: Option<String>,
        pub extra2: Option<u32>,
        pub extra3_longer_name: Option<bool>,
    }

    impl ExtraKeys for EventWithExtraExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2", "extra3_longer_name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          self.extra3_longer_name.and_then(|val| map.insert("extra3_longer_name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.event_with_extra
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    pub static event_with_extra: Lazy<EventMetric<EventWithExtraExtra>> = Lazy::new(|| {
        EventMetric::new(3010.into(), CommonMetricData {
            name: "event_with_extra".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.irate
    ///
    /// This is a test-only metric.
    /// A rate that isn't happy about it.
    pub static irate: Lazy<RateMetric> = Lazy::new(|| {
        RateMetric::new(3011.into(), CommonMetricData {
            name: "irate".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.no_extra_event
    ///
    /// This is a test-only metric.
    /// Just recording some events without the extra fuss.
    pub static no_extra_event: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3012.into(), CommonMetricData {
            name: "no_extra_event".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.rate_with_external_denominator
    ///
    /// This is a test-only metric.
    /// A rate with a denominator that is Out There.
    pub static rate_with_external_denominator: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(3013.into(), CommonMetricData {
            name: "rate_with_external_denominator".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod test_only_jog {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.jog.a_counter
    ///
    /// This is a test-only metric.
    /// Just counting things.
    /// Tied closely to test_jog_name_collision.
    pub static a_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3014,
            "test_only.jog",
            "a_counter",
            "store1"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AnEventExtra {
        pub extra1: Option<String>,
        pub extra2: Option<String>,
    }

    impl ExtraKeys for AnEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.jog.an_event
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    /// Tied closely to test_jog_name_collision.
    pub static an_event: Lazy<EventMetric<AnEventExtra>> = Lazy::new(|| {
        EventMetric::new(3015.into(), CommonMetricData {
            name: "an_event".into(),
            category: "test_only.jog".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod nimbus_events {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnrollFailedExtra {
        pub branch: Option<String>,
        pub experiment: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for EnrollFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enroll_failed
    ///
    /// Recorded when an enrollment fails, including the reason for the failure.
    pub static enroll_failed: Lazy<EventMetric<EnrollFailedExtra>> = Lazy::new(|| {
        EventMetric::new(3016.into(), CommonMetricData {
            name: "enroll_failed".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnrollmentExtra {
        pub branch: Option<String>,
        pub experiment: Option<String>,
        pub experiment_type: Option<String>,
    }

    impl ExtraKeys for EnrollmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "experiment_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.experiment_type.and_then(|val| map.insert("experiment_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enrollment
    ///
    /// Recorded when a user has met the conditions and is first bucketed into an
    /// experiment (i.e. targeting matched and they were randomized into a bucket and
    /// branch of the experiment). Expected a maximum of once per experiment per user.
    pub static enrollment: Lazy<EventMetric<EnrollmentExtra>> = Lazy::new(|| {
        EventMetric::new(3017.into(), CommonMetricData {
            name: "enrollment".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnrollmentStatusExtra {
        pub branch: Option<String>,
        pub conflict_slug: Option<String>,
        pub error_string: Option<String>,
        pub reason: Option<String>,
        pub slug: Option<String>,
        pub status: Option<String>,
    }

    impl ExtraKeys for EnrollmentStatusExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "conflict_slug", "error_string", "reason", "slug", "status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.conflict_slug.and_then(|val| map.insert("conflict_slug".into(), val.to_string()));
          self.error_string.and_then(|val| map.insert("error_string".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.slug.and_then(|val| map.insert("slug".into(), val.to_string()));
          self.status.and_then(|val| map.insert("status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enrollment_status
    ///
    /// Recorded for each enrollment status each time the SDK completes application of
    /// pending experiments.
    pub static enrollment_status: Lazy<EventMetric<EnrollmentStatusExtra>> = Lazy::new(|| {
        EventMetric::new(3018.into(), CommonMetricData {
            name: "enrollment_status".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: true,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ExposureExtra {
        pub branch: Option<String>,
        pub experiment: Option<String>,
        pub feature_id: Option<String>,
    }

    impl ExtraKeys for ExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "feature_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.feature_id.and_then(|val| map.insert("feature_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.exposure
    ///
    /// Recorded when a user actually observes an experimental treatment, or would have
    /// observed an experimental treatment if they had been in a branch that would have
    /// shown one.
    pub static exposure: Lazy<EventMetric<ExposureExtra>> = Lazy::new(|| {
        EventMetric::new(3019.into(), CommonMetricData {
            name: "exposure".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.is_ready
    ///
    /// An event sent when Nimbus is ready — sent upon completion of each update of the
    /// recipes.
    pub static is_ready: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3020.into(), CommonMetricData {
            name: "is_ready".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct UnenrollFailedExtra {
        pub experiment: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.unenroll_failed
    ///
    /// Recorded when an unenrollment fails, including the reason for the failure.
    pub static unenroll_failed: Lazy<EventMetric<UnenrollFailedExtra>> = Lazy::new(|| {
        EventMetric::new(3021.into(), CommonMetricData {
            name: "unenroll_failed".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct UnenrollmentExtra {
        pub branch: Option<String>,
        pub changed_pref: Option<String>,
        pub conflicting_slug: Option<String>,
        pub experiment: Option<String>,
        pub pref_name: Option<String>,
        pub pref_type: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for UnenrollmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "changed_pref", "conflicting_slug", "experiment", "pref_name", "pref_type", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.changed_pref.and_then(|val| map.insert("changed_pref".into(), val.to_string()));
          self.conflicting_slug.and_then(|val| map.insert("conflicting_slug".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.pref_name.and_then(|val| map.insert("pref_name".into(), val.to_string()));
          self.pref_type.and_then(|val| map.insert("pref_type".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.unenrollment
    ///
    /// Recorded when either telemetry is disabled, or the experiment has run for its
    /// designed duration (i.e. it is no longer present in the Nimbus Remote Settings
    /// collection)
    pub static unenrollment: Lazy<EventMetric<UnenrollmentExtra>> = Lazy::new(|| {
        EventMetric::new(3022.into(), CommonMetricData {
            name: "unenrollment".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ValidationFailedExtra {
        pub branch: Option<String>,
        pub experiment: Option<String>,
        pub feature: Option<String>,
        pub l10n_ids: Option<String>,
        pub locale: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for ValidationFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "feature", "l10n_ids", "locale", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.feature.and_then(|val| map.insert("feature".into(), val.to_string()));
          self.l10n_ids.and_then(|val| map.insert("l10n_ids".into(), val.to_string()));
          self.locale.and_then(|val| map.insert("locale".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.validation_failed
    ///
    /// This records when validation of a recipe fails.
    pub static validation_failed: Lazy<EventMetric<ValidationFailedExtra>> = Lazy::new(|| {
        EventMetric::new(3023.into(), CommonMetricData {
            name: "validation_failed".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod pwmgr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum FormAutofillResultLabel {
        EFilled = 0,
        ENoPasswordField = 1,
        EPasswordDisabledReadonly = 2,
        ENoLoginsFit = 3,
        ENoSavedLogins = 4,
        EExistingPassword = 5,
        EExistingUsername = 6,
        EMultipleLogins = 7,
        ENoAutofillForms = 8,
        EAutocompleteOff = 9,
        EInsecure = 10,
        EPasswordAutocompleteNewPassword = 11,
        ETypeNoLongerPassword = 12,
        EFormInCrossoriginSubframe = 13,
        EFilledUsernameOnlyForm = 14,
        __Other__,
    }
    impl From<u16> for FormAutofillResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFilled,
                1 => Self::ENoPasswordField,
                2 => Self::EPasswordDisabledReadonly,
                3 => Self::ENoLoginsFit,
                4 => Self::ENoSavedLogins,
                5 => Self::EExistingPassword,
                6 => Self::EExistingUsername,
                7 => Self::EMultipleLogins,
                8 => Self::ENoAutofillForms,
                9 => Self::EAutocompleteOff,
                10 => Self::EInsecure,
                11 => Self::EPasswordAutocompleteNewPassword,
                12 => Self::ETypeNoLongerPassword,
                13 => Self::EFormInCrossoriginSubframe,
                14 => Self::EFilledUsernameOnlyForm,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FormAutofillResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFilled => "filled",
                Self::ENoPasswordField => "no_password_field",
                Self::EPasswordDisabledReadonly => "password_disabled_readonly",
                Self::ENoLoginsFit => "no_logins_fit",
                Self::ENoSavedLogins => "no_saved_logins",
                Self::EExistingPassword => "existing_password",
                Self::EExistingUsername => "existing_username",
                Self::EMultipleLogins => "multiple_logins",
                Self::ENoAutofillForms => "no_autofill_forms",
                Self::EAutocompleteOff => "autocomplete_off",
                Self::EInsecure => "insecure",
                Self::EPasswordAutocompleteNewPassword => "password_autocomplete_new_password",
                Self::ETypeNoLongerPassword => "type_no_longer_password",
                Self::EFormInCrossoriginSubframe => "form_in_crossorigin_subframe",
                Self::EFilledUsernameOnlyForm => "filled_username_only_form",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.form_autofill_result
    ///
    /// The result of auto-filling a login form.
    pub static form_autofill_result: Lazy<LabeledMetric<LabeledCounterMetric, FormAutofillResultLabel>> = Lazy::new(|| {
        LabeledMetric::new(3024.into(), CommonMetricData {
            name: "form_autofill_result".into(),
            category: "pwmgr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("autocomplete_off"), ::std::borrow::Cow::from("existing_password"), ::std::borrow::Cow::from("existing_username"), ::std::borrow::Cow::from("filled"), ::std::borrow::Cow::from("filled_username_only_form"), ::std::borrow::Cow::from("form_in_crossorigin_subframe"), ::std::borrow::Cow::from("insecure"), ::std::borrow::Cow::from("multiple_logins"), ::std::borrow::Cow::from("no_autofill_forms"), ::std::borrow::Cow::from("no_logins_fit"), ::std::borrow::Cow::from("no_password_field"), ::std::borrow::Cow::from("no_saved_logins"), ::std::borrow::Cow::from("password_autocomplete_new_password"), ::std::borrow::Cow::from("password_disabled_readonly"), ::std::borrow::Cow::from("type_no_longer_password")]))
    });

}
pub mod pdfjs {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ButtonsLabel {
        EPresentationMode = 0,
        EPresentationModeKeyboard = 1,
        EViewBookmark = 2,
        EFirstPage = 3,
        ELastPage = 4,
        EPageRotateCw = 5,
        EPageRotateCcw = 6,
        ECursorSelectTool = 7,
        ECursorHandTool = 8,
        EScrollPage = 9,
        EScrollVertical = 10,
        EScrollHorizontal = 11,
        EScrollWrapped = 12,
        ESpreadNone = 13,
        ESpreadOdd = 14,
        ESpreadEven = 15,
        EDocumentProperties = 16,
        __Other__,
    }
    impl From<u16> for ButtonsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresentationMode,
                1 => Self::EPresentationModeKeyboard,
                2 => Self::EViewBookmark,
                3 => Self::EFirstPage,
                4 => Self::ELastPage,
                5 => Self::EPageRotateCw,
                6 => Self::EPageRotateCcw,
                7 => Self::ECursorSelectTool,
                8 => Self::ECursorHandTool,
                9 => Self::EScrollPage,
                10 => Self::EScrollVertical,
                11 => Self::EScrollHorizontal,
                12 => Self::EScrollWrapped,
                13 => Self::ESpreadNone,
                14 => Self::ESpreadOdd,
                15 => Self::ESpreadEven,
                16 => Self::EDocumentProperties,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ButtonsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresentationMode => "presentation_mode",
                Self::EPresentationModeKeyboard => "presentation_mode_keyboard",
                Self::EViewBookmark => "view_bookmark",
                Self::EFirstPage => "first_page",
                Self::ELastPage => "last_page",
                Self::EPageRotateCw => "page_rotate_cw",
                Self::EPageRotateCcw => "page_rotate_ccw",
                Self::ECursorSelectTool => "cursor_select_tool",
                Self::ECursorHandTool => "cursor_hand_tool",
                Self::EScrollPage => "scroll_page",
                Self::EScrollVertical => "scroll_vertical",
                Self::EScrollHorizontal => "scroll_horizontal",
                Self::EScrollWrapped => "scroll_wrapped",
                Self::ESpreadNone => "spread_none",
                Self::ESpreadOdd => "spread_odd",
                Self::ESpreadEven => "spread_even",
                Self::EDocumentProperties => "document_properties",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.buttons
    ///
    /// Counts the number of times some actions are executed in the PDF viewer.
    pub static buttons: Lazy<LabeledMetric<LabeledCounterMetric, ButtonsLabel>> = Lazy::new(|| {
        LabeledMetric::new(3025.into(), CommonMetricData {
            name: "buttons".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("cursor_hand_tool"), ::std::borrow::Cow::from("cursor_select_tool"), ::std::borrow::Cow::from("document_properties"), ::std::borrow::Cow::from("first_page"), ::std::borrow::Cow::from("last_page"), ::std::borrow::Cow::from("page_rotate_ccw"), ::std::borrow::Cow::from("page_rotate_cw"), ::std::borrow::Cow::from("presentation_mode"), ::std::borrow::Cow::from("presentation_mode_keyboard"), ::std::borrow::Cow::from("scroll_horizontal"), ::std::borrow::Cow::from("scroll_page"), ::std::borrow::Cow::from("scroll_vertical"), ::std::borrow::Cow::from("scroll_wrapped"), ::std::borrow::Cow::from("spread_even"), ::std::borrow::Cow::from("spread_none"), ::std::borrow::Cow::from("spread_odd"), ::std::borrow::Cow::from("view_bookmark")]))
    });

    #[repr(u16)]
    pub enum EditingLabel {
        EInk = 0,
        EFreetext = 1,
        EStamp = 2,
        ESave = 3,
        EPrint = 4,
        __Other__,
    }
    impl From<u16> for EditingLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EInk,
                1 => Self::EFreetext,
                2 => Self::EStamp,
                3 => Self::ESave,
                4 => Self::EPrint,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EditingLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EInk => "ink",
                Self::EFreetext => "freetext",
                Self::EStamp => "stamp",
                Self::ESave => "save",
                Self::EPrint => "print",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing
    ///
    /// Counts the number of times some PDF editing features are used.
    pub static editing: Lazy<LabeledMetric<LabeledCounterMetric, EditingLabel>> = Lazy::new(|| {
        LabeledMetric::new(3026.into(), CommonMetricData {
            name: "editing".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("freetext"), ::std::borrow::Cow::from("ink"), ::std::borrow::Cow::from("print"), ::std::borrow::Cow::from("save"), ::std::borrow::Cow::from("stamp")]))
    });

    #[repr(u16)]
    pub enum GeckoviewLabel {
        EDownloadTapped = 0,
        EOpenInAppTapped = 1,
        EOpenInAppJustOnce = 2,
        EOpenInAppAlways = 3,
        EDownloadFailed = 4,
        EDownloadSucceeded = 5,
        ESaveAsPdfTapped = 6,
        __Other__,
    }
    impl From<u16> for GeckoviewLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDownloadTapped,
                1 => Self::EOpenInAppTapped,
                2 => Self::EOpenInAppJustOnce,
                3 => Self::EOpenInAppAlways,
                4 => Self::EDownloadFailed,
                5 => Self::EDownloadSucceeded,
                6 => Self::ESaveAsPdfTapped,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GeckoviewLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDownloadTapped => "download_tapped",
                Self::EOpenInAppTapped => "open_in_app_tapped",
                Self::EOpenInAppJustOnce => "open_in_app_just_once",
                Self::EOpenInAppAlways => "open_in_app_always",
                Self::EDownloadFailed => "download_failed",
                Self::EDownloadSucceeded => "download_succeeded",
                Self::ESaveAsPdfTapped => "save_as_pdf_tapped",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.geckoview
    ///
    /// Counts the number of times some actions are executed in the PDF viewer.
    pub static geckoview: Lazy<LabeledMetric<LabeledCounterMetric, GeckoviewLabel>> = Lazy::new(|| {
        LabeledMetric::new(3027.into(), CommonMetricData {
            name: "geckoview".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("download_failed"), ::std::borrow::Cow::from("download_succeeded"), ::std::borrow::Cow::from("download_tapped"), ::std::borrow::Cow::from("open_in_app_always"), ::std::borrow::Cow::from("open_in_app_just_once"), ::std::borrow::Cow::from("open_in_app_tapped"), ::std::borrow::Cow::from("save_as_pdf_tapped")]))
    });

    #[repr(u16)]
    pub enum StampLabel {
        EInsertedImage = 0,
        EAltTextSave = 1,
        EAltTextCancel = 2,
        EAltTextTooltip = 3,
        EAltTextEdit = 4,
        EAltTextDescription = 5,
        EAltTextDecorative = 6,
        EAltTextKeyboard = 7,
        __Other__,
    }
    impl From<u16> for StampLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EInsertedImage,
                1 => Self::EAltTextSave,
                2 => Self::EAltTextCancel,
                3 => Self::EAltTextTooltip,
                4 => Self::EAltTextEdit,
                5 => Self::EAltTextDescription,
                6 => Self::EAltTextDecorative,
                7 => Self::EAltTextKeyboard,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StampLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EInsertedImage => "inserted_image",
                Self::EAltTextSave => "alt_text_save",
                Self::EAltTextCancel => "alt_text_cancel",
                Self::EAltTextTooltip => "alt_text_tooltip",
                Self::EAltTextEdit => "alt_text_edit",
                Self::EAltTextDescription => "alt_text_description",
                Self::EAltTextDecorative => "alt_text_decorative",
                Self::EAltTextKeyboard => "alt_text_keyboard",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.stamp
    ///
    /// Counts the number of times some PDF editing features are used.
    pub static stamp: Lazy<LabeledMetric<LabeledCounterMetric, StampLabel>> = Lazy::new(|| {
        LabeledMetric::new(3028.into(), CommonMetricData {
            name: "stamp".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("alt_text_cancel"), ::std::borrow::Cow::from("alt_text_decorative"), ::std::borrow::Cow::from("alt_text_description"), ::std::borrow::Cow::from("alt_text_edit"), ::std::borrow::Cow::from("alt_text_keyboard"), ::std::borrow::Cow::from("alt_text_save"), ::std::borrow::Cow::from("alt_text_tooltip"), ::std::borrow::Cow::from("inserted_image")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.time_to_view
    ///
    /// Time spent to display first page in PDF Viewer (ms).
    pub static time_to_view: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(3029.into(), CommonMetricData {
            name: "time_to_view".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 10000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.used
    ///
    /// How many times PDF Viewer was used.
    pub static used: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3030,
            "pdfjs",
            "used",
            "metrics"
        )
    });

}
pub mod pdfjs_editing_highlight {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ColorLabel {
        EYellow = 0,
        EGreen = 1,
        EBlue = 2,
        EPink = 3,
        ERed = 4,
        __Other__,
    }
    impl From<u16> for ColorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EYellow,
                1 => Self::EGreen,
                2 => Self::EBlue,
                3 => Self::EPink,
                4 => Self::ERed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ColorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EYellow => "yellow",
                Self::EGreen => "green",
                Self::EBlue => "blue",
                Self::EPink => "pink",
                Self::ERed => "red",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.color
    ///
    /// Counts the number of times a given color is used to highlight.
    pub static color: Lazy<LabeledMetric<LabeledCounterMetric, ColorLabel>> = Lazy::new(|| {
        LabeledMetric::new(3031.into(), CommonMetricData {
            name: "color".into(),
            category: "pdfjs.editing.highlight".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("blue"), ::std::borrow::Cow::from("green"), ::std::borrow::Cow::from("pink"), ::std::borrow::Cow::from("red"), ::std::borrow::Cow::from("yellow")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.color_changed
    ///
    /// Counts the number of times the user changes the color of a highlight.
    pub static color_changed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3032,
            "pdfjs.editing.highlight",
            "color_changed",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.deleted
    ///
    /// Counts the number of times the user deletes highlights.
    pub static deleted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3033,
            "pdfjs.editing.highlight",
            "deleted",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.edited
    ///
    /// Counts the number of times the user edits highlights.
    pub static edited: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3034,
            "pdfjs.editing.highlight",
            "edited",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum KindLabel {
        EFreeHighlight = 0,
        EHighlight = 1,
        __Other__,
    }
    impl From<u16> for KindLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFreeHighlight,
                1 => Self::EHighlight,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for KindLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFreeHighlight => "free_highlight",
                Self::EHighlight => "highlight",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.kind
    ///
    /// Counts the number of times a given kind is used to highlight.
    pub static kind: Lazy<LabeledMetric<LabeledCounterMetric, KindLabel>> = Lazy::new(|| {
        LabeledMetric::new(3035.into(), CommonMetricData {
            name: "kind".into(),
            category: "pdfjs.editing.highlight".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("free_highlight"), ::std::borrow::Cow::from("highlight")]))
    });

    #[repr(u16)]
    pub enum MethodLabel {
        EContextMenu = 0,
        EMainToolbar = 1,
        EFloatingButton = 2,
        __Other__,
    }
    impl From<u16> for MethodLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EContextMenu,
                1 => Self::EMainToolbar,
                2 => Self::EFloatingButton,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MethodLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EContextMenu => "context_menu",
                Self::EMainToolbar => "main_toolbar",
                Self::EFloatingButton => "floating_button",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.method
    ///
    /// Counts the number of times a given method is used to highlight.
    pub static method: Lazy<LabeledMetric<LabeledCounterMetric, MethodLabel>> = Lazy::new(|| {
        LabeledMetric::new(3036.into(), CommonMetricData {
            name: "method".into(),
            category: "pdfjs.editing.highlight".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("context_menu"), ::std::borrow::Cow::from("floating_button"), ::std::borrow::Cow::from("main_toolbar")]))
    });

    #[repr(u16)]
    pub enum NumberOfColorsLabel {
        EOne = 0,
        ETwo = 1,
        EThree = 2,
        EFour = 3,
        EFive = 4,
        __Other__,
    }
    impl From<u16> for NumberOfColorsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOne,
                1 => Self::ETwo,
                2 => Self::EThree,
                3 => Self::EFour,
                4 => Self::EFive,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NumberOfColorsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOne => "one",
                Self::ETwo => "two",
                Self::EThree => "three",
                Self::EFour => "four",
                Self::EFive => "five",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.number_of_colors
    ///
    /// Counts the number of different colors used to highlight.
    pub static number_of_colors: Lazy<LabeledMetric<LabeledCounterMetric, NumberOfColorsLabel>> = Lazy::new(|| {
        LabeledMetric::new(3037.into(), CommonMetricData {
            name: "number_of_colors".into(),
            category: "pdfjs.editing.highlight".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("five"), ::std::borrow::Cow::from("four"), ::std::borrow::Cow::from("one"), ::std::borrow::Cow::from("three"), ::std::borrow::Cow::from("two")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.print
    ///
    /// Counts the number of times the user prints a PDF with highlights.
    pub static print: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3038,
            "pdfjs.editing.highlight",
            "print",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.save
    ///
    /// Counts the number of times the user saves a PDF with highlights.
    pub static save: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3039,
            "pdfjs.editing.highlight",
            "save",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.thickness
    ///
    /// The thickness used to draw a free highlight.
    pub static thickness: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(3040.into(), CommonMetricData {
            name: "thickness".into(),
            category: "pdfjs.editing.highlight".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 8, 24, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.thickness_changed
    ///
    /// Counts the number of times the user changes the thickness of a free highlight.
    pub static thickness_changed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3041,
            "pdfjs.editing.highlight",
            "thickness_changed",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.toggle_visibility
    ///
    /// Counts the number of times the user toggles the visibility of highlights.
    pub static toggle_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3042,
            "pdfjs.editing.highlight",
            "toggle_visibility",
            "metrics"
        )
    });

}
pub mod power {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_bogus_values
    ///
    /// Impossibly large CPU time values that were discarded.
    pub static cpu_time_bogus_values: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3043,
            "power",
            "cpu_time_bogus_values",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum CpuTimePerProcessTypeMsLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for CpuTimePerProcessTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CpuTimePerProcessTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_per_process_type_ms
    ///
    /// CPU time used by each process type in ms.
    pub static cpu_time_per_process_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, CpuTimePerProcessTypeMsLabel>> = Lazy::new(|| {
        LabeledMetric::new(3044.into(), CommonMetricData {
            name: "cpu_time_per_process_type_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

    #[repr(u16)]
    pub enum CpuTimePerTrackerTypeMsLabel {
        EAd = 0,
        EAnalytics = 1,
        ECryptomining = 2,
        EFingerprinting = 3,
        ESocial = 4,
        EUnknown = 5,
        __Other__,
    }
    impl From<u16> for CpuTimePerTrackerTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAd,
                1 => Self::EAnalytics,
                2 => Self::ECryptomining,
                3 => Self::EFingerprinting,
                4 => Self::ESocial,
                5 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CpuTimePerTrackerTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAd => "ad",
                Self::EAnalytics => "analytics",
                Self::ECryptomining => "cryptomining",
                Self::EFingerprinting => "fingerprinting",
                Self::ESocial => "social",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_per_tracker_type_ms
    ///
    /// CPU time used by content processes used only for tracking resources, labeled by
    /// the category of the tracker.
    pub static cpu_time_per_tracker_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, CpuTimePerTrackerTypeMsLabel>> = Lazy::new(|| {
        LabeledMetric::new(3045.into(), CommonMetricData {
            name: "cpu_time_per_tracker_type_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("ad"), ::std::borrow::Cow::from("analytics"), ::std::borrow::Cow::from("cryptomining"), ::std::borrow::Cow::from("fingerprinting"), ::std::borrow::Cow::from("social"), ::std::borrow::Cow::from("unknown")]))
    });

    #[repr(u16)]
    pub enum EnergyPerProcessTypeLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for EnergyPerProcessTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EnergyPerProcessTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.energy_per_process_type
    ///
    /// How much energy (in µWh) has been used, broken down by process type. Only
    /// available on Apple Silicon.
    pub static energy_per_process_type: Lazy<LabeledMetric<LabeledCounterMetric, EnergyPerProcessTypeLabel>> = Lazy::new(|| {
        LabeledMetric::new(3046.into(), CommonMetricData {
            name: "energy_per_process_type".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.gpu_time_bogus_values
    ///
    /// Impossibly large GPU time values that were discarded.
    pub static gpu_time_bogus_values: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3047,
            "power",
            "gpu_time_bogus_values",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum GpuTimePerProcessTypeMsLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for GpuTimePerProcessTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuTimePerProcessTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.gpu_time_per_process_type_ms
    ///
    /// GPU time used by each process type in ms.
    pub static gpu_time_per_process_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, GpuTimePerProcessTypeMsLabel>> = Lazy::new(|| {
        LabeledMetric::new(3048.into(), CommonMetricData {
            name: "gpu_time_per_process_type_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_cpu_time_ms
    ///
    /// Total CPU time used by all processes in ms.
    pub static total_cpu_time_ms: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3049,
            "power",
            "total_cpu_time_ms",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_gpu_time_ms
    ///
    /// Total GPU time used by all processes in ms.
    pub static total_gpu_time_ms: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3050,
            "power",
            "total_gpu_time_ms",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_thread_wakeups
    ///
    /// How many times threads woke up and could have woken up a CPU core.
    pub static total_thread_wakeups: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3051,
            "power",
            "total_thread_wakeups",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum WakeupsPerProcessTypeLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for WakeupsPerProcessTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for WakeupsPerProcessTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_process_type
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by process type.
    pub static wakeups_per_process_type: Lazy<LabeledMetric<LabeledCounterMetric, WakeupsPerProcessTypeLabel>> = Lazy::new(|| {
        LabeledMetric::new(3052.into(), CommonMetricData {
            name: "wakeups_per_process_type".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

}
pub mod power_battery {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from power.battery.percentage_when_user_active
    ///
    /// Records how many percent of battery was available for each period of user
    /// activity.
    pub static percentage_when_user_active: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(3053.into(), CommonMetricData {
            name: "percentage_when_user_active".into(),
            category: "power.battery".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 100, 100, HistogramType::Linear)
    });

}
pub mod power_cpu_ms_per_thread {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ContentBackgroundLabel {
        EAsynclogger = 0,
        EAudioipc = 1,
        EAudioipcCallbackRpc = 2,
        EAudioipcClientCallback = 3,
        EAudioipcClientRpc = 4,
        EAudioipcDevicecollectionRpc = 5,
        EAudioipcServerCallback = 6,
        EAudioipcServerRpc = 7,
        EBackgroundthreadpool = 8,
        EBgiothreadpool = 9,
        EBgreadurls = 10,
        EBhmgrMonitor = 11,
        EBhmgrProcessor = 12,
        ECamerasIpc = 13,
        ECapturethread = 14,
        EClassifierUpdate = 15,
        EComMta = 16,
        ECompositor = 17,
        ECookie = 18,
        ECubeboperation = 19,
        EDatachannelIo = 20,
        EDnsResolver = 21,
        EDomWorker = 22,
        EDomcachethread = 23,
        EExtensionprotocolhandler = 24,
        EFontLoader = 25,
        EFontenumthread = 26,
        EFsBroker = 27,
        EGeckomain = 28,
        EGmpthread = 29,
        EGraphrunner = 30,
        EHtml5Parser = 31,
        EImagebridgechld = 32,
        EImageio = 33,
        EIndexeddb = 34,
        EInitfontlist = 35,
        EInotifyeventthread = 36,
        EIpcIOChild = 37,
        EIpcIOParent = 38,
        EIpcLaunch = 39,
        EIpdlBackground = 40,
        EJsWatchdog = 41,
        EJumpList = 42,
        ELibwebrtcmodulethread = 43,
        ELinkMonitor = 44,
        ELsThread = 45,
        EMediacache = 46,
        EMediadecoderstatemachine = 47,
        EMediapdecoder = 48,
        EMediasupervisor = 49,
        EMediatimer = 50,
        EMediatrackgrph = 51,
        EMemorypoller = 52,
        EMozstorage = 53,
        EMtransport = 54,
        ENetlinkMonitor = 55,
        EPacerthread = 56,
        EPermission = 57,
        EPlayeventsound = 58,
        EProcesshangmon = 59,
        EProfilerchild = 60,
        EProxyresolution = 61,
        EQuotamanagerIo = 62,
        ERegisterfonts = 63,
        ERemotebackbuffer = 64,
        ERemotelzystream = 65,
        ERemvidchild = 66,
        ERenderer = 67,
        ESandboxreporter = 68,
        ESavescripts = 69,
        ESocketThread = 70,
        ESoftwarevsyncthread = 71,
        ESslCert = 72,
        EStartupcache = 73,
        EStreamtrans = 74,
        EStylethread = 75,
        ESwcomposite = 76,
        ETaskcontroller = 77,
        ETimer = 78,
        EToastbgthread = 79,
        ETrrBackground = 80,
        EUntrustedModules = 81,
        EUrlClassifier = 82,
        EVideocapture = 83,
        EVsynciothread = 84,
        EWebrtccallthread = 85,
        EWebrtcworker = 86,
        EWincompositor = 87,
        EWindowsvsyncthread = 88,
        EWinwindowocclusioncalc = 89,
        EWorkerLauncher = 90,
        EWrrenderbackend = 91,
        EWrscenebuilder = 92,
        EWrscenebuilderlp = 93,
        EWrworker = 94,
        EWrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ContentBackgroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAsynclogger,
                1 => Self::EAudioipc,
                2 => Self::EAudioipcCallbackRpc,
                3 => Self::EAudioipcClientCallback,
                4 => Self::EAudioipcClientRpc,
                5 => Self::EAudioipcDevicecollectionRpc,
                6 => Self::EAudioipcServerCallback,
                7 => Self::EAudioipcServerRpc,
                8 => Self::EBackgroundthreadpool,
                9 => Self::EBgiothreadpool,
                10 => Self::EBgreadurls,
                11 => Self::EBhmgrMonitor,
                12 => Self::EBhmgrProcessor,
                13 => Self::ECamerasIpc,
                14 => Self::ECapturethread,
                15 => Self::EClassifierUpdate,
                16 => Self::EComMta,
                17 => Self::ECompositor,
                18 => Self::ECookie,
                19 => Self::ECubeboperation,
                20 => Self::EDatachannelIo,
                21 => Self::EDnsResolver,
                22 => Self::EDomWorker,
                23 => Self::EDomcachethread,
                24 => Self::EExtensionprotocolhandler,
                25 => Self::EFontLoader,
                26 => Self::EFontenumthread,
                27 => Self::EFsBroker,
                28 => Self::EGeckomain,
                29 => Self::EGmpthread,
                30 => Self::EGraphrunner,
                31 => Self::EHtml5Parser,
                32 => Self::EImagebridgechld,
                33 => Self::EImageio,
                34 => Self::EIndexeddb,
                35 => Self::EInitfontlist,
                36 => Self::EInotifyeventthread,
                37 => Self::EIpcIOChild,
                38 => Self::EIpcIOParent,
                39 => Self::EIpcLaunch,
                40 => Self::EIpdlBackground,
                41 => Self::EJsWatchdog,
                42 => Self::EJumpList,
                43 => Self::ELibwebrtcmodulethread,
                44 => Self::ELinkMonitor,
                45 => Self::ELsThread,
                46 => Self::EMediacache,
                47 => Self::EMediadecoderstatemachine,
                48 => Self::EMediapdecoder,
                49 => Self::EMediasupervisor,
                50 => Self::EMediatimer,
                51 => Self::EMediatrackgrph,
                52 => Self::EMemorypoller,
                53 => Self::EMozstorage,
                54 => Self::EMtransport,
                55 => Self::ENetlinkMonitor,
                56 => Self::EPacerthread,
                57 => Self::EPermission,
                58 => Self::EPlayeventsound,
                59 => Self::EProcesshangmon,
                60 => Self::EProfilerchild,
                61 => Self::EProxyresolution,
                62 => Self::EQuotamanagerIo,
                63 => Self::ERegisterfonts,
                64 => Self::ERemotebackbuffer,
                65 => Self::ERemotelzystream,
                66 => Self::ERemvidchild,
                67 => Self::ERenderer,
                68 => Self::ESandboxreporter,
                69 => Self::ESavescripts,
                70 => Self::ESocketThread,
                71 => Self::ESoftwarevsyncthread,
                72 => Self::ESslCert,
                73 => Self::EStartupcache,
                74 => Self::EStreamtrans,
                75 => Self::EStylethread,
                76 => Self::ESwcomposite,
                77 => Self::ETaskcontroller,
                78 => Self::ETimer,
                79 => Self::EToastbgthread,
                80 => Self::ETrrBackground,
                81 => Self::EUntrustedModules,
                82 => Self::EUrlClassifier,
                83 => Self::EVideocapture,
                84 => Self::EVsynciothread,
                85 => Self::EWebrtccallthread,
                86 => Self::EWebrtcworker,
                87 => Self::EWincompositor,
                88 => Self::EWindowsvsyncthread,
                89 => Self::EWinwindowocclusioncalc,
                90 => Self::EWorkerLauncher,
                91 => Self::EWrrenderbackend,
                92 => Self::EWrscenebuilder,
                93 => Self::EWrscenebuilderlp,
                94 => Self::EWrworker,
                95 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentBackgroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.content_background
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static content_background: Lazy<LabeledMetric<LabeledCounterMetric, ContentBackgroundLabel>> = Lazy::new(|| {
        LabeledMetric::new(3054.into(), CommonMetricData {
            name: "content_background".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ContentForegroundLabel {
        EAsynclogger = 0,
        EAudioipc = 1,
        EAudioipcCallbackRpc = 2,
        EAudioipcClientCallback = 3,
        EAudioipcClientRpc = 4,
        EAudioipcDevicecollectionRpc = 5,
        EAudioipcServerCallback = 6,
        EAudioipcServerRpc = 7,
        EBackgroundthreadpool = 8,
        EBgiothreadpool = 9,
        EBgreadurls = 10,
        EBhmgrMonitor = 11,
        EBhmgrProcessor = 12,
        ECamerasIpc = 13,
        ECapturethread = 14,
        EClassifierUpdate = 15,
        EComMta = 16,
        ECompositor = 17,
        ECookie = 18,
        ECubeboperation = 19,
        EDatachannelIo = 20,
        EDnsResolver = 21,
        EDomWorker = 22,
        EDomcachethread = 23,
        EExtensionprotocolhandler = 24,
        EFontLoader = 25,
        EFontenumthread = 26,
        EFsBroker = 27,
        EGeckomain = 28,
        EGmpthread = 29,
        EGraphrunner = 30,
        EHtml5Parser = 31,
        EImagebridgechld = 32,
        EImageio = 33,
        EIndexeddb = 34,
        EInitfontlist = 35,
        EInotifyeventthread = 36,
        EIpcIOChild = 37,
        EIpcIOParent = 38,
        EIpcLaunch = 39,
        EIpdlBackground = 40,
        EJsWatchdog = 41,
        EJumpList = 42,
        ELibwebrtcmodulethread = 43,
        ELinkMonitor = 44,
        ELsThread = 45,
        EMediacache = 46,
        EMediadecoderstatemachine = 47,
        EMediapdecoder = 48,
        EMediasupervisor = 49,
        EMediatimer = 50,
        EMediatrackgrph = 51,
        EMemorypoller = 52,
        EMozstorage = 53,
        EMtransport = 54,
        ENetlinkMonitor = 55,
        EPacerthread = 56,
        EPermission = 57,
        EPlayeventsound = 58,
        EProcesshangmon = 59,
        EProfilerchild = 60,
        EProxyresolution = 61,
        EQuotamanagerIo = 62,
        ERegisterfonts = 63,
        ERemotebackbuffer = 64,
        ERemotelzystream = 65,
        ERemvidchild = 66,
        ERenderer = 67,
        ESandboxreporter = 68,
        ESavescripts = 69,
        ESocketThread = 70,
        ESoftwarevsyncthread = 71,
        ESslCert = 72,
        EStartupcache = 73,
        EStreamtrans = 74,
        EStylethread = 75,
        ESwcomposite = 76,
        ETaskcontroller = 77,
        ETimer = 78,
        EToastbgthread = 79,
        ETrrBackground = 80,
        EUntrustedModules = 81,
        EUrlClassifier = 82,
        EVideocapture = 83,
        EVsynciothread = 84,
        EWebrtccallthread = 85,
        EWebrtcworker = 86,
        EWincompositor = 87,
        EWindowsvsyncthread = 88,
        EWinwindowocclusioncalc = 89,
        EWorkerLauncher = 90,
        EWrrenderbackend = 91,
        EWrscenebuilder = 92,
        EWrscenebuilderlp = 93,
        EWrworker = 94,
        EWrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ContentForegroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAsynclogger,
                1 => Self::EAudioipc,
                2 => Self::EAudioipcCallbackRpc,
                3 => Self::EAudioipcClientCallback,
                4 => Self::EAudioipcClientRpc,
                5 => Self::EAudioipcDevicecollectionRpc,
                6 => Self::EAudioipcServerCallback,
                7 => Self::EAudioipcServerRpc,
                8 => Self::EBackgroundthreadpool,
                9 => Self::EBgiothreadpool,
                10 => Self::EBgreadurls,
                11 => Self::EBhmgrMonitor,
                12 => Self::EBhmgrProcessor,
                13 => Self::ECamerasIpc,
                14 => Self::ECapturethread,
                15 => Self::EClassifierUpdate,
                16 => Self::EComMta,
                17 => Self::ECompositor,
                18 => Self::ECookie,
                19 => Self::ECubeboperation,
                20 => Self::EDatachannelIo,
                21 => Self::EDnsResolver,
                22 => Self::EDomWorker,
                23 => Self::EDomcachethread,
                24 => Self::EExtensionprotocolhandler,
                25 => Self::EFontLoader,
                26 => Self::EFontenumthread,
                27 => Self::EFsBroker,
                28 => Self::EGeckomain,
                29 => Self::EGmpthread,
                30 => Self::EGraphrunner,
                31 => Self::EHtml5Parser,
                32 => Self::EImagebridgechld,
                33 => Self::EImageio,
                34 => Self::EIndexeddb,
                35 => Self::EInitfontlist,
                36 => Self::EInotifyeventthread,
                37 => Self::EIpcIOChild,
                38 => Self::EIpcIOParent,
                39 => Self::EIpcLaunch,
                40 => Self::EIpdlBackground,
                41 => Self::EJsWatchdog,
                42 => Self::EJumpList,
                43 => Self::ELibwebrtcmodulethread,
                44 => Self::ELinkMonitor,
                45 => Self::ELsThread,
                46 => Self::EMediacache,
                47 => Self::EMediadecoderstatemachine,
                48 => Self::EMediapdecoder,
                49 => Self::EMediasupervisor,
                50 => Self::EMediatimer,
                51 => Self::EMediatrackgrph,
                52 => Self::EMemorypoller,
                53 => Self::EMozstorage,
                54 => Self::EMtransport,
                55 => Self::ENetlinkMonitor,
                56 => Self::EPacerthread,
                57 => Self::EPermission,
                58 => Self::EPlayeventsound,
                59 => Self::EProcesshangmon,
                60 => Self::EProfilerchild,
                61 => Self::EProxyresolution,
                62 => Self::EQuotamanagerIo,
                63 => Self::ERegisterfonts,
                64 => Self::ERemotebackbuffer,
                65 => Self::ERemotelzystream,
                66 => Self::ERemvidchild,
                67 => Self::ERenderer,
                68 => Self::ESandboxreporter,
                69 => Self::ESavescripts,
                70 => Self::ESocketThread,
                71 => Self::ESoftwarevsyncthread,
                72 => Self::ESslCert,
                73 => Self::EStartupcache,
                74 => Self::EStreamtrans,
                75 => Self::EStylethread,
                76 => Self::ESwcomposite,
                77 => Self::ETaskcontroller,
                78 => Self::ETimer,
                79 => Self::EToastbgthread,
                80 => Self::ETrrBackground,
                81 => Self::EUntrustedModules,
                82 => Self::EUrlClassifier,
                83 => Self::EVideocapture,
                84 => Self::EVsynciothread,
                85 => Self::EWebrtccallthread,
                86 => Self::EWebrtcworker,
                87 => Self::EWincompositor,
                88 => Self::EWindowsvsyncthread,
                89 => Self::EWinwindowocclusioncalc,
                90 => Self::EWorkerLauncher,
                91 => Self::EWrrenderbackend,
                92 => Self::EWrscenebuilder,
                93 => Self::EWrscenebuilderlp,
                94 => Self::EWrworker,
                95 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentForegroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.content_foreground
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static content_foreground: Lazy<LabeledMetric<LabeledCounterMetric, ContentForegroundLabel>> = Lazy::new(|| {
        LabeledMetric::new(3055.into(), CommonMetricData {
            name: "content_foreground".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum GpuProcessLabel {
        EAsynclogger = 0,
        EAudioipc = 1,
        EAudioipcCallbackRpc = 2,
        EAudioipcClientCallback = 3,
        EAudioipcClientRpc = 4,
        EAudioipcDevicecollectionRpc = 5,
        EAudioipcServerCallback = 6,
        EAudioipcServerRpc = 7,
        EBackgroundthreadpool = 8,
        EBgiothreadpool = 9,
        EBgreadurls = 10,
        EBhmgrMonitor = 11,
        EBhmgrProcessor = 12,
        ECamerasIpc = 13,
        ECapturethread = 14,
        EClassifierUpdate = 15,
        EComMta = 16,
        ECompositor = 17,
        ECookie = 18,
        ECubeboperation = 19,
        EDatachannelIo = 20,
        EDnsResolver = 21,
        EDomWorker = 22,
        EDomcachethread = 23,
        EExtensionprotocolhandler = 24,
        EFontLoader = 25,
        EFontenumthread = 26,
        EFsBroker = 27,
        EGeckomain = 28,
        EGmpthread = 29,
        EGraphrunner = 30,
        EHtml5Parser = 31,
        EImagebridgechld = 32,
        EImageio = 33,
        EIndexeddb = 34,
        EInitfontlist = 35,
        EInotifyeventthread = 36,
        EIpcIOChild = 37,
        EIpcIOParent = 38,
        EIpcLaunch = 39,
        EIpdlBackground = 40,
        EJsWatchdog = 41,
        EJumpList = 42,
        ELibwebrtcmodulethread = 43,
        ELinkMonitor = 44,
        ELsThread = 45,
        EMediacache = 46,
        EMediadecoderstatemachine = 47,
        EMediapdecoder = 48,
        EMediasupervisor = 49,
        EMediatimer = 50,
        EMediatrackgrph = 51,
        EMemorypoller = 52,
        EMozstorage = 53,
        EMtransport = 54,
        ENetlinkMonitor = 55,
        EPacerthread = 56,
        EPermission = 57,
        EPlayeventsound = 58,
        EProcesshangmon = 59,
        EProfilerchild = 60,
        EProxyresolution = 61,
        EQuotamanagerIo = 62,
        ERegisterfonts = 63,
        ERemotebackbuffer = 64,
        ERemotelzystream = 65,
        ERemvidchild = 66,
        ERenderer = 67,
        ESandboxreporter = 68,
        ESavescripts = 69,
        ESocketThread = 70,
        ESoftwarevsyncthread = 71,
        ESslCert = 72,
        EStartupcache = 73,
        EStreamtrans = 74,
        EStylethread = 75,
        ESwcomposite = 76,
        ETaskcontroller = 77,
        ETimer = 78,
        EToastbgthread = 79,
        ETrrBackground = 80,
        EUntrustedModules = 81,
        EUrlClassifier = 82,
        EVideocapture = 83,
        EVsynciothread = 84,
        EWebrtccallthread = 85,
        EWebrtcworker = 86,
        EWincompositor = 87,
        EWindowsvsyncthread = 88,
        EWinwindowocclusioncalc = 89,
        EWorkerLauncher = 90,
        EWrrenderbackend = 91,
        EWrscenebuilder = 92,
        EWrscenebuilderlp = 93,
        EWrworker = 94,
        EWrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for GpuProcessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAsynclogger,
                1 => Self::EAudioipc,
                2 => Self::EAudioipcCallbackRpc,
                3 => Self::EAudioipcClientCallback,
                4 => Self::EAudioipcClientRpc,
                5 => Self::EAudioipcDevicecollectionRpc,
                6 => Self::EAudioipcServerCallback,
                7 => Self::EAudioipcServerRpc,
                8 => Self::EBackgroundthreadpool,
                9 => Self::EBgiothreadpool,
                10 => Self::EBgreadurls,
                11 => Self::EBhmgrMonitor,
                12 => Self::EBhmgrProcessor,
                13 => Self::ECamerasIpc,
                14 => Self::ECapturethread,
                15 => Self::EClassifierUpdate,
                16 => Self::EComMta,
                17 => Self::ECompositor,
                18 => Self::ECookie,
                19 => Self::ECubeboperation,
                20 => Self::EDatachannelIo,
                21 => Self::EDnsResolver,
                22 => Self::EDomWorker,
                23 => Self::EDomcachethread,
                24 => Self::EExtensionprotocolhandler,
                25 => Self::EFontLoader,
                26 => Self::EFontenumthread,
                27 => Self::EFsBroker,
                28 => Self::EGeckomain,
                29 => Self::EGmpthread,
                30 => Self::EGraphrunner,
                31 => Self::EHtml5Parser,
                32 => Self::EImagebridgechld,
                33 => Self::EImageio,
                34 => Self::EIndexeddb,
                35 => Self::EInitfontlist,
                36 => Self::EInotifyeventthread,
                37 => Self::EIpcIOChild,
                38 => Self::EIpcIOParent,
                39 => Self::EIpcLaunch,
                40 => Self::EIpdlBackground,
                41 => Self::EJsWatchdog,
                42 => Self::EJumpList,
                43 => Self::ELibwebrtcmodulethread,
                44 => Self::ELinkMonitor,
                45 => Self::ELsThread,
                46 => Self::EMediacache,
                47 => Self::EMediadecoderstatemachine,
                48 => Self::EMediapdecoder,
                49 => Self::EMediasupervisor,
                50 => Self::EMediatimer,
                51 => Self::EMediatrackgrph,
                52 => Self::EMemorypoller,
                53 => Self::EMozstorage,
                54 => Self::EMtransport,
                55 => Self::ENetlinkMonitor,
                56 => Self::EPacerthread,
                57 => Self::EPermission,
                58 => Self::EPlayeventsound,
                59 => Self::EProcesshangmon,
                60 => Self::EProfilerchild,
                61 => Self::EProxyresolution,
                62 => Self::EQuotamanagerIo,
                63 => Self::ERegisterfonts,
                64 => Self::ERemotebackbuffer,
                65 => Self::ERemotelzystream,
                66 => Self::ERemvidchild,
                67 => Self::ERenderer,
                68 => Self::ESandboxreporter,
                69 => Self::ESavescripts,
                70 => Self::ESocketThread,
                71 => Self::ESoftwarevsyncthread,
                72 => Self::ESslCert,
                73 => Self::EStartupcache,
                74 => Self::EStreamtrans,
                75 => Self::EStylethread,
                76 => Self::ESwcomposite,
                77 => Self::ETaskcontroller,
                78 => Self::ETimer,
                79 => Self::EToastbgthread,
                80 => Self::ETrrBackground,
                81 => Self::EUntrustedModules,
                82 => Self::EUrlClassifier,
                83 => Self::EVideocapture,
                84 => Self::EVsynciothread,
                85 => Self::EWebrtccallthread,
                86 => Self::EWebrtcworker,
                87 => Self::EWincompositor,
                88 => Self::EWindowsvsyncthread,
                89 => Self::EWinwindowocclusioncalc,
                90 => Self::EWorkerLauncher,
                91 => Self::EWrrenderbackend,
                92 => Self::EWrscenebuilder,
                93 => Self::EWrscenebuilderlp,
                94 => Self::EWrworker,
                95 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuProcessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.gpu_process
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static gpu_process: Lazy<LabeledMetric<LabeledCounterMetric, GpuProcessLabel>> = Lazy::new(|| {
        LabeledMetric::new(3056.into(), CommonMetricData {
            name: "gpu_process".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentActiveLabel {
        EAsynclogger = 0,
        EAudioipc = 1,
        EAudioipcCallbackRpc = 2,
        EAudioipcClientCallback = 3,
        EAudioipcClientRpc = 4,
        EAudioipcDevicecollectionRpc = 5,
        EAudioipcServerCallback = 6,
        EAudioipcServerRpc = 7,
        EBackgroundthreadpool = 8,
        EBgiothreadpool = 9,
        EBgreadurls = 10,
        EBhmgrMonitor = 11,
        EBhmgrProcessor = 12,
        ECamerasIpc = 13,
        ECapturethread = 14,
        EClassifierUpdate = 15,
        EComMta = 16,
        ECompositor = 17,
        ECookie = 18,
        ECubeboperation = 19,
        EDatachannelIo = 20,
        EDnsResolver = 21,
        EDomWorker = 22,
        EDomcachethread = 23,
        EExtensionprotocolhandler = 24,
        EFontLoader = 25,
        EFontenumthread = 26,
        EFsBroker = 27,
        EGeckomain = 28,
        EGmpthread = 29,
        EGraphrunner = 30,
        EHtml5Parser = 31,
        EImagebridgechld = 32,
        EImageio = 33,
        EIndexeddb = 34,
        EInitfontlist = 35,
        EInotifyeventthread = 36,
        EIpcIOChild = 37,
        EIpcIOParent = 38,
        EIpcLaunch = 39,
        EIpdlBackground = 40,
        EJsWatchdog = 41,
        EJumpList = 42,
        ELibwebrtcmodulethread = 43,
        ELinkMonitor = 44,
        ELsThread = 45,
        EMediacache = 46,
        EMediadecoderstatemachine = 47,
        EMediapdecoder = 48,
        EMediasupervisor = 49,
        EMediatimer = 50,
        EMediatrackgrph = 51,
        EMemorypoller = 52,
        EMozstorage = 53,
        EMtransport = 54,
        ENetlinkMonitor = 55,
        EPacerthread = 56,
        EPermission = 57,
        EPlayeventsound = 58,
        EProcesshangmon = 59,
        EProfilerchild = 60,
        EProxyresolution = 61,
        EQuotamanagerIo = 62,
        ERegisterfonts = 63,
        ERemotebackbuffer = 64,
        ERemotelzystream = 65,
        ERemvidchild = 66,
        ERenderer = 67,
        ESandboxreporter = 68,
        ESavescripts = 69,
        ESocketThread = 70,
        ESoftwarevsyncthread = 71,
        ESslCert = 72,
        EStartupcache = 73,
        EStreamtrans = 74,
        EStylethread = 75,
        ESwcomposite = 76,
        ETaskcontroller = 77,
        ETimer = 78,
        EToastbgthread = 79,
        ETrrBackground = 80,
        EUntrustedModules = 81,
        EUrlClassifier = 82,
        EVideocapture = 83,
        EVsynciothread = 84,
        EWebrtccallthread = 85,
        EWebrtcworker = 86,
        EWincompositor = 87,
        EWindowsvsyncthread = 88,
        EWinwindowocclusioncalc = 89,
        EWorkerLauncher = 90,
        EWrrenderbackend = 91,
        EWrscenebuilder = 92,
        EWrscenebuilderlp = 93,
        EWrworker = 94,
        EWrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ParentActiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAsynclogger,
                1 => Self::EAudioipc,
                2 => Self::EAudioipcCallbackRpc,
                3 => Self::EAudioipcClientCallback,
                4 => Self::EAudioipcClientRpc,
                5 => Self::EAudioipcDevicecollectionRpc,
                6 => Self::EAudioipcServerCallback,
                7 => Self::EAudioipcServerRpc,
                8 => Self::EBackgroundthreadpool,
                9 => Self::EBgiothreadpool,
                10 => Self::EBgreadurls,
                11 => Self::EBhmgrMonitor,
                12 => Self::EBhmgrProcessor,
                13 => Self::ECamerasIpc,
                14 => Self::ECapturethread,
                15 => Self::EClassifierUpdate,
                16 => Self::EComMta,
                17 => Self::ECompositor,
                18 => Self::ECookie,
                19 => Self::ECubeboperation,
                20 => Self::EDatachannelIo,
                21 => Self::EDnsResolver,
                22 => Self::EDomWorker,
                23 => Self::EDomcachethread,
                24 => Self::EExtensionprotocolhandler,
                25 => Self::EFontLoader,
                26 => Self::EFontenumthread,
                27 => Self::EFsBroker,
                28 => Self::EGeckomain,
                29 => Self::EGmpthread,
                30 => Self::EGraphrunner,
                31 => Self::EHtml5Parser,
                32 => Self::EImagebridgechld,
                33 => Self::EImageio,
                34 => Self::EIndexeddb,
                35 => Self::EInitfontlist,
                36 => Self::EInotifyeventthread,
                37 => Self::EIpcIOChild,
                38 => Self::EIpcIOParent,
                39 => Self::EIpcLaunch,
                40 => Self::EIpdlBackground,
                41 => Self::EJsWatchdog,
                42 => Self::EJumpList,
                43 => Self::ELibwebrtcmodulethread,
                44 => Self::ELinkMonitor,
                45 => Self::ELsThread,
                46 => Self::EMediacache,
                47 => Self::EMediadecoderstatemachine,
                48 => Self::EMediapdecoder,
                49 => Self::EMediasupervisor,
                50 => Self::EMediatimer,
                51 => Self::EMediatrackgrph,
                52 => Self::EMemorypoller,
                53 => Self::EMozstorage,
                54 => Self::EMtransport,
                55 => Self::ENetlinkMonitor,
                56 => Self::EPacerthread,
                57 => Self::EPermission,
                58 => Self::EPlayeventsound,
                59 => Self::EProcesshangmon,
                60 => Self::EProfilerchild,
                61 => Self::EProxyresolution,
                62 => Self::EQuotamanagerIo,
                63 => Self::ERegisterfonts,
                64 => Self::ERemotebackbuffer,
                65 => Self::ERemotelzystream,
                66 => Self::ERemvidchild,
                67 => Self::ERenderer,
                68 => Self::ESandboxreporter,
                69 => Self::ESavescripts,
                70 => Self::ESocketThread,
                71 => Self::ESoftwarevsyncthread,
                72 => Self::ESslCert,
                73 => Self::EStartupcache,
                74 => Self::EStreamtrans,
                75 => Self::EStylethread,
                76 => Self::ESwcomposite,
                77 => Self::ETaskcontroller,
                78 => Self::ETimer,
                79 => Self::EToastbgthread,
                80 => Self::ETrrBackground,
                81 => Self::EUntrustedModules,
                82 => Self::EUrlClassifier,
                83 => Self::EVideocapture,
                84 => Self::EVsynciothread,
                85 => Self::EWebrtccallthread,
                86 => Self::EWebrtcworker,
                87 => Self::EWincompositor,
                88 => Self::EWindowsvsyncthread,
                89 => Self::EWinwindowocclusioncalc,
                90 => Self::EWorkerLauncher,
                91 => Self::EWrrenderbackend,
                92 => Self::EWrscenebuilder,
                93 => Self::EWrscenebuilderlp,
                94 => Self::EWrworker,
                95 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentActiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.parent_active
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static parent_active: Lazy<LabeledMetric<LabeledCounterMetric, ParentActiveLabel>> = Lazy::new(|| {
        LabeledMetric::new(3057.into(), CommonMetricData {
            name: "parent_active".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentInactiveLabel {
        EAsynclogger = 0,
        EAudioipc = 1,
        EAudioipcCallbackRpc = 2,
        EAudioipcClientCallback = 3,
        EAudioipcClientRpc = 4,
        EAudioipcDevicecollectionRpc = 5,
        EAudioipcServerCallback = 6,
        EAudioipcServerRpc = 7,
        EBackgroundthreadpool = 8,
        EBgiothreadpool = 9,
        EBgreadurls = 10,
        EBhmgrMonitor = 11,
        EBhmgrProcessor = 12,
        ECamerasIpc = 13,
        ECapturethread = 14,
        EClassifierUpdate = 15,
        EComMta = 16,
        ECompositor = 17,
        ECookie = 18,
        ECubeboperation = 19,
        EDatachannelIo = 20,
        EDnsResolver = 21,
        EDomWorker = 22,
        EDomcachethread = 23,
        EExtensionprotocolhandler = 24,
        EFontLoader = 25,
        EFontenumthread = 26,
        EFsBroker = 27,
        EGeckomain = 28,
        EGmpthread = 29,
        EGraphrunner = 30,
        EHtml5Parser = 31,
        EImagebridgechld = 32,
        EImageio = 33,
        EIndexeddb = 34,
        EInitfontlist = 35,
        EInotifyeventthread = 36,
        EIpcIOChild = 37,
        EIpcIOParent = 38,
        EIpcLaunch = 39,
        EIpdlBackground = 40,
        EJsWatchdog = 41,
        EJumpList = 42,
        ELibwebrtcmodulethread = 43,
        ELinkMonitor = 44,
        ELsThread = 45,
        EMediacache = 46,
        EMediadecoderstatemachine = 47,
        EMediapdecoder = 48,
        EMediasupervisor = 49,
        EMediatimer = 50,
        EMediatrackgrph = 51,
        EMemorypoller = 52,
        EMozstorage = 53,
        EMtransport = 54,
        ENetlinkMonitor = 55,
        EPacerthread = 56,
        EPermission = 57,
        EPlayeventsound = 58,
        EProcesshangmon = 59,
        EProfilerchild = 60,
        EProxyresolution = 61,
        EQuotamanagerIo = 62,
        ERegisterfonts = 63,
        ERemotebackbuffer = 64,
        ERemotelzystream = 65,
        ERemvidchild = 66,
        ERenderer = 67,
        ESandboxreporter = 68,
        ESavescripts = 69,
        ESocketThread = 70,
        ESoftwarevsyncthread = 71,
        ESslCert = 72,
        EStartupcache = 73,
        EStreamtrans = 74,
        EStylethread = 75,
        ESwcomposite = 76,
        ETaskcontroller = 77,
        ETimer = 78,
        EToastbgthread = 79,
        ETrrBackground = 80,
        EUntrustedModules = 81,
        EUrlClassifier = 82,
        EVideocapture = 83,
        EVsynciothread = 84,
        EWebrtccallthread = 85,
        EWebrtcworker = 86,
        EWincompositor = 87,
        EWindowsvsyncthread = 88,
        EWinwindowocclusioncalc = 89,
        EWorkerLauncher = 90,
        EWrrenderbackend = 91,
        EWrscenebuilder = 92,
        EWrscenebuilderlp = 93,
        EWrworker = 94,
        EWrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ParentInactiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAsynclogger,
                1 => Self::EAudioipc,
                2 => Self::EAudioipcCallbackRpc,
                3 => Self::EAudioipcClientCallback,
                4 => Self::EAudioipcClientRpc,
                5 => Self::EAudioipcDevicecollectionRpc,
                6 => Self::EAudioipcServerCallback,
                7 => Self::EAudioipcServerRpc,
                8 => Self::EBackgroundthreadpool,
                9 => Self::EBgiothreadpool,
                10 => Self::EBgreadurls,
                11 => Self::EBhmgrMonitor,
                12 => Self::EBhmgrProcessor,
                13 => Self::ECamerasIpc,
                14 => Self::ECapturethread,
                15 => Self::EClassifierUpdate,
                16 => Self::EComMta,
                17 => Self::ECompositor,
                18 => Self::ECookie,
                19 => Self::ECubeboperation,
                20 => Self::EDatachannelIo,
                21 => Self::EDnsResolver,
                22 => Self::EDomWorker,
                23 => Self::EDomcachethread,
                24 => Self::EExtensionprotocolhandler,
                25 => Self::EFontLoader,
                26 => Self::EFontenumthread,
                27 => Self::EFsBroker,
                28 => Self::EGeckomain,
                29 => Self::EGmpthread,
                30 => Self::EGraphrunner,
                31 => Self::EHtml5Parser,
                32 => Self::EImagebridgechld,
                33 => Self::EImageio,
                34 => Self::EIndexeddb,
                35 => Self::EInitfontlist,
                36 => Self::EInotifyeventthread,
                37 => Self::EIpcIOChild,
                38 => Self::EIpcIOParent,
                39 => Self::EIpcLaunch,
                40 => Self::EIpdlBackground,
                41 => Self::EJsWatchdog,
                42 => Self::EJumpList,
                43 => Self::ELibwebrtcmodulethread,
                44 => Self::ELinkMonitor,
                45 => Self::ELsThread,
                46 => Self::EMediacache,
                47 => Self::EMediadecoderstatemachine,
                48 => Self::EMediapdecoder,
                49 => Self::EMediasupervisor,
                50 => Self::EMediatimer,
                51 => Self::EMediatrackgrph,
                52 => Self::EMemorypoller,
                53 => Self::EMozstorage,
                54 => Self::EMtransport,
                55 => Self::ENetlinkMonitor,
                56 => Self::EPacerthread,
                57 => Self::EPermission,
                58 => Self::EPlayeventsound,
                59 => Self::EProcesshangmon,
                60 => Self::EProfilerchild,
                61 => Self::EProxyresolution,
                62 => Self::EQuotamanagerIo,
                63 => Self::ERegisterfonts,
                64 => Self::ERemotebackbuffer,
                65 => Self::ERemotelzystream,
                66 => Self::ERemvidchild,
                67 => Self::ERenderer,
                68 => Self::ESandboxreporter,
                69 => Self::ESavescripts,
                70 => Self::ESocketThread,
                71 => Self::ESoftwarevsyncthread,
                72 => Self::ESslCert,
                73 => Self::EStartupcache,
                74 => Self::EStreamtrans,
                75 => Self::EStylethread,
                76 => Self::ESwcomposite,
                77 => Self::ETaskcontroller,
                78 => Self::ETimer,
                79 => Self::EToastbgthread,
                80 => Self::ETrrBackground,
                81 => Self::EUntrustedModules,
                82 => Self::EUrlClassifier,
                83 => Self::EVideocapture,
                84 => Self::EVsynciothread,
                85 => Self::EWebrtccallthread,
                86 => Self::EWebrtcworker,
                87 => Self::EWincompositor,
                88 => Self::EWindowsvsyncthread,
                89 => Self::EWinwindowocclusioncalc,
                90 => Self::EWorkerLauncher,
                91 => Self::EWrrenderbackend,
                92 => Self::EWrscenebuilder,
                93 => Self::EWrscenebuilderlp,
                94 => Self::EWrworker,
                95 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentInactiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.parent_inactive
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static parent_inactive: Lazy<LabeledMetric<LabeledCounterMetric, ParentInactiveLabel>> = Lazy::new(|| {
        LabeledMetric::new(3058.into(), CommonMetricData {
            name: "parent_inactive".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

}
pub mod power_wakeups_per_thread {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ContentBackgroundLabel {
        EAsynclogger = 0,
        EAudioipc = 1,
        EAudioipcCallbackRpc = 2,
        EAudioipcClientCallback = 3,
        EAudioipcClientRpc = 4,
        EAudioipcDevicecollectionRpc = 5,
        EAudioipcServerCallback = 6,
        EAudioipcServerRpc = 7,
        EBackgroundthreadpool = 8,
        EBgiothreadpool = 9,
        EBgreadurls = 10,
        EBhmgrMonitor = 11,
        EBhmgrProcessor = 12,
        ECamerasIpc = 13,
        ECapturethread = 14,
        EClassifierUpdate = 15,
        EComMta = 16,
        ECompositor = 17,
        ECookie = 18,
        ECubeboperation = 19,
        EDatachannelIo = 20,
        EDnsResolver = 21,
        EDomWorker = 22,
        EDomcachethread = 23,
        EExtensionprotocolhandler = 24,
        EFontLoader = 25,
        EFontenumthread = 26,
        EFsBroker = 27,
        EGeckomain = 28,
        EGmpthread = 29,
        EGraphrunner = 30,
        EHtml5Parser = 31,
        EImagebridgechld = 32,
        EImageio = 33,
        EIndexeddb = 34,
        EInitfontlist = 35,
        EInotifyeventthread = 36,
        EIpcIOChild = 37,
        EIpcIOParent = 38,
        EIpcLaunch = 39,
        EIpdlBackground = 40,
        EJsWatchdog = 41,
        EJumpList = 42,
        ELibwebrtcmodulethread = 43,
        ELinkMonitor = 44,
        ELsThread = 45,
        EMediacache = 46,
        EMediadecoderstatemachine = 47,
        EMediapdecoder = 48,
        EMediasupervisor = 49,
        EMediatimer = 50,
        EMediatrackgrph = 51,
        EMemorypoller = 52,
        EMozstorage = 53,
        EMtransport = 54,
        ENetlinkMonitor = 55,
        EPacerthread = 56,
        EPermission = 57,
        EPlayeventsound = 58,
        EProcesshangmon = 59,
        EProfilerchild = 60,
        EProxyresolution = 61,
        EQuotamanagerIo = 62,
        ERegisterfonts = 63,
        ERemotebackbuffer = 64,
        ERemotelzystream = 65,
        ERemvidchild = 66,
        ERenderer = 67,
        ESandboxreporter = 68,
        ESavescripts = 69,
        ESocketThread = 70,
        ESoftwarevsyncthread = 71,
        ESslCert = 72,
        EStartupcache = 73,
        EStreamtrans = 74,
        EStylethread = 75,
        ESwcomposite = 76,
        ETaskcontroller = 77,
        ETimer = 78,
        EToastbgthread = 79,
        ETrrBackground = 80,
        EUntrustedModules = 81,
        EUrlClassifier = 82,
        EVideocapture = 83,
        EVsynciothread = 84,
        EWebrtccallthread = 85,
        EWebrtcworker = 86,
        EWincompositor = 87,
        EWindowsvsyncthread = 88,
        EWinwindowocclusioncalc = 89,
        EWorkerLauncher = 90,
        EWrrenderbackend = 91,
        EWrscenebuilder = 92,
        EWrscenebuilderlp = 93,
        EWrworker = 94,
        EWrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ContentBackgroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAsynclogger,
                1 => Self::EAudioipc,
                2 => Self::EAudioipcCallbackRpc,
                3 => Self::EAudioipcClientCallback,
                4 => Self::EAudioipcClientRpc,
                5 => Self::EAudioipcDevicecollectionRpc,
                6 => Self::EAudioipcServerCallback,
                7 => Self::EAudioipcServerRpc,
                8 => Self::EBackgroundthreadpool,
                9 => Self::EBgiothreadpool,
                10 => Self::EBgreadurls,
                11 => Self::EBhmgrMonitor,
                12 => Self::EBhmgrProcessor,
                13 => Self::ECamerasIpc,
                14 => Self::ECapturethread,
                15 => Self::EClassifierUpdate,
                16 => Self::EComMta,
                17 => Self::ECompositor,
                18 => Self::ECookie,
                19 => Self::ECubeboperation,
                20 => Self::EDatachannelIo,
                21 => Self::EDnsResolver,
                22 => Self::EDomWorker,
                23 => Self::EDomcachethread,
                24 => Self::EExtensionprotocolhandler,
                25 => Self::EFontLoader,
                26 => Self::EFontenumthread,
                27 => Self::EFsBroker,
                28 => Self::EGeckomain,
                29 => Self::EGmpthread,
                30 => Self::EGraphrunner,
                31 => Self::EHtml5Parser,
                32 => Self::EImagebridgechld,
                33 => Self::EImageio,
                34 => Self::EIndexeddb,
                35 => Self::EInitfontlist,
                36 => Self::EInotifyeventthread,
                37 => Self::EIpcIOChild,
                38 => Self::EIpcIOParent,
                39 => Self::EIpcLaunch,
                40 => Self::EIpdlBackground,
                41 => Self::EJsWatchdog,
                42 => Self::EJumpList,
                43 => Self::ELibwebrtcmodulethread,
                44 => Self::ELinkMonitor,
                45 => Self::ELsThread,
                46 => Self::EMediacache,
                47 => Self::EMediadecoderstatemachine,
                48 => Self::EMediapdecoder,
                49 => Self::EMediasupervisor,
                50 => Self::EMediatimer,
                51 => Self::EMediatrackgrph,
                52 => Self::EMemorypoller,
                53 => Self::EMozstorage,
                54 => Self::EMtransport,
                55 => Self::ENetlinkMonitor,
                56 => Self::EPacerthread,
                57 => Self::EPermission,
                58 => Self::EPlayeventsound,
                59 => Self::EProcesshangmon,
                60 => Self::EProfilerchild,
                61 => Self::EProxyresolution,
                62 => Self::EQuotamanagerIo,
                63 => Self::ERegisterfonts,
                64 => Self::ERemotebackbuffer,
                65 => Self::ERemotelzystream,
                66 => Self::ERemvidchild,
                67 => Self::ERenderer,
                68 => Self::ESandboxreporter,
                69 => Self::ESavescripts,
                70 => Self::ESocketThread,
                71 => Self::ESoftwarevsyncthread,
                72 => Self::ESslCert,
                73 => Self::EStartupcache,
                74 => Self::EStreamtrans,
                75 => Self::EStylethread,
                76 => Self::ESwcomposite,
                77 => Self::ETaskcontroller,
                78 => Self::ETimer,
                79 => Self::EToastbgthread,
                80 => Self::ETrrBackground,
                81 => Self::EUntrustedModules,
                82 => Self::EUrlClassifier,
                83 => Self::EVideocapture,
                84 => Self::EVsynciothread,
                85 => Self::EWebrtccallthread,
                86 => Self::EWebrtcworker,
                87 => Self::EWincompositor,
                88 => Self::EWindowsvsyncthread,
                89 => Self::EWinwindowocclusioncalc,
                90 => Self::EWorkerLauncher,
                91 => Self::EWrrenderbackend,
                92 => Self::EWrscenebuilder,
                93 => Self::EWrscenebuilderlp,
                94 => Self::EWrworker,
                95 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentBackgroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.content_background
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static content_background: Lazy<LabeledMetric<LabeledCounterMetric, ContentBackgroundLabel>> = Lazy::new(|| {
        LabeledMetric::new(3059.into(), CommonMetricData {
            name: "content_background".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ContentForegroundLabel {
        EAsynclogger = 0,
        EAudioipc = 1,
        EAudioipcCallbackRpc = 2,
        EAudioipcClientCallback = 3,
        EAudioipcClientRpc = 4,
        EAudioipcDevicecollectionRpc = 5,
        EAudioipcServerCallback = 6,
        EAudioipcServerRpc = 7,
        EBackgroundthreadpool = 8,
        EBgiothreadpool = 9,
        EBgreadurls = 10,
        EBhmgrMonitor = 11,
        EBhmgrProcessor = 12,
        ECamerasIpc = 13,
        ECapturethread = 14,
        EClassifierUpdate = 15,
        EComMta = 16,
        ECompositor = 17,
        ECookie = 18,
        ECubeboperation = 19,
        EDatachannelIo = 20,
        EDnsResolver = 21,
        EDomWorker = 22,
        EDomcachethread = 23,
        EExtensionprotocolhandler = 24,
        EFontLoader = 25,
        EFontenumthread = 26,
        EFsBroker = 27,
        EGeckomain = 28,
        EGmpthread = 29,
        EGraphrunner = 30,
        EHtml5Parser = 31,
        EImagebridgechld = 32,
        EImageio = 33,
        EIndexeddb = 34,
        EInitfontlist = 35,
        EInotifyeventthread = 36,
        EIpcIOChild = 37,
        EIpcIOParent = 38,
        EIpcLaunch = 39,
        EIpdlBackground = 40,
        EJsWatchdog = 41,
        EJumpList = 42,
        ELibwebrtcmodulethread = 43,
        ELinkMonitor = 44,
        ELsThread = 45,
        EMediacache = 46,
        EMediadecoderstatemachine = 47,
        EMediapdecoder = 48,
        EMediasupervisor = 49,
        EMediatimer = 50,
        EMediatrackgrph = 51,
        EMemorypoller = 52,
        EMozstorage = 53,
        EMtransport = 54,
        ENetlinkMonitor = 55,
        EPacerthread = 56,
        EPermission = 57,
        EPlayeventsound = 58,
        EProcesshangmon = 59,
        EProfilerchild = 60,
        EProxyresolution = 61,
        EQuotamanagerIo = 62,
        ERegisterfonts = 63,
        ERemotebackbuffer = 64,
        ERemotelzystream = 65,
        ERemvidchild = 66,
        ERenderer = 67,
        ESandboxreporter = 68,
        ESavescripts = 69,
        ESocketThread = 70,
        ESoftwarevsyncthread = 71,
        ESslCert = 72,
        EStartupcache = 73,
        EStreamtrans = 74,
        EStylethread = 75,
        ESwcomposite = 76,
        ETaskcontroller = 77,
        ETimer = 78,
        EToastbgthread = 79,
        ETrrBackground = 80,
        EUntrustedModules = 81,
        EUrlClassifier = 82,
        EVideocapture = 83,
        EVsynciothread = 84,
        EWebrtccallthread = 85,
        EWebrtcworker = 86,
        EWincompositor = 87,
        EWindowsvsyncthread = 88,
        EWinwindowocclusioncalc = 89,
        EWorkerLauncher = 90,
        EWrrenderbackend = 91,
        EWrscenebuilder = 92,
        EWrscenebuilderlp = 93,
        EWrworker = 94,
        EWrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ContentForegroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAsynclogger,
                1 => Self::EAudioipc,
                2 => Self::EAudioipcCallbackRpc,
                3 => Self::EAudioipcClientCallback,
                4 => Self::EAudioipcClientRpc,
                5 => Self::EAudioipcDevicecollectionRpc,
                6 => Self::EAudioipcServerCallback,
                7 => Self::EAudioipcServerRpc,
                8 => Self::EBackgroundthreadpool,
                9 => Self::EBgiothreadpool,
                10 => Self::EBgreadurls,
                11 => Self::EBhmgrMonitor,
                12 => Self::EBhmgrProcessor,
                13 => Self::ECamerasIpc,
                14 => Self::ECapturethread,
                15 => Self::EClassifierUpdate,
                16 => Self::EComMta,
                17 => Self::ECompositor,
                18 => Self::ECookie,
                19 => Self::ECubeboperation,
                20 => Self::EDatachannelIo,
                21 => Self::EDnsResolver,
                22 => Self::EDomWorker,
                23 => Self::EDomcachethread,
                24 => Self::EExtensionprotocolhandler,
                25 => Self::EFontLoader,
                26 => Self::EFontenumthread,
                27 => Self::EFsBroker,
                28 => Self::EGeckomain,
                29 => Self::EGmpthread,
                30 => Self::EGraphrunner,
                31 => Self::EHtml5Parser,
                32 => Self::EImagebridgechld,
                33 => Self::EImageio,
                34 => Self::EIndexeddb,
                35 => Self::EInitfontlist,
                36 => Self::EInotifyeventthread,
                37 => Self::EIpcIOChild,
                38 => Self::EIpcIOParent,
                39 => Self::EIpcLaunch,
                40 => Self::EIpdlBackground,
                41 => Self::EJsWatchdog,
                42 => Self::EJumpList,
                43 => Self::ELibwebrtcmodulethread,
                44 => Self::ELinkMonitor,
                45 => Self::ELsThread,
                46 => Self::EMediacache,
                47 => Self::EMediadecoderstatemachine,
                48 => Self::EMediapdecoder,
                49 => Self::EMediasupervisor,
                50 => Self::EMediatimer,
                51 => Self::EMediatrackgrph,
                52 => Self::EMemorypoller,
                53 => Self::EMozstorage,
                54 => Self::EMtransport,
                55 => Self::ENetlinkMonitor,
                56 => Self::EPacerthread,
                57 => Self::EPermission,
                58 => Self::EPlayeventsound,
                59 => Self::EProcesshangmon,
                60 => Self::EProfilerchild,
                61 => Self::EProxyresolution,
                62 => Self::EQuotamanagerIo,
                63 => Self::ERegisterfonts,
                64 => Self::ERemotebackbuffer,
                65 => Self::ERemotelzystream,
                66 => Self::ERemvidchild,
                67 => Self::ERenderer,
                68 => Self::ESandboxreporter,
                69 => Self::ESavescripts,
                70 => Self::ESocketThread,
                71 => Self::ESoftwarevsyncthread,
                72 => Self::ESslCert,
                73 => Self::EStartupcache,
                74 => Self::EStreamtrans,
                75 => Self::EStylethread,
                76 => Self::ESwcomposite,
                77 => Self::ETaskcontroller,
                78 => Self::ETimer,
                79 => Self::EToastbgthread,
                80 => Self::ETrrBackground,
                81 => Self::EUntrustedModules,
                82 => Self::EUrlClassifier,
                83 => Self::EVideocapture,
                84 => Self::EVsynciothread,
                85 => Self::EWebrtccallthread,
                86 => Self::EWebrtcworker,
                87 => Self::EWincompositor,
                88 => Self::EWindowsvsyncthread,
                89 => Self::EWinwindowocclusioncalc,
                90 => Self::EWorkerLauncher,
                91 => Self::EWrrenderbackend,
                92 => Self::EWrscenebuilder,
                93 => Self::EWrscenebuilderlp,
                94 => Self::EWrworker,
                95 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentForegroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.content_foreground
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static content_foreground: Lazy<LabeledMetric<LabeledCounterMetric, ContentForegroundLabel>> = Lazy::new(|| {
        LabeledMetric::new(3060.into(), CommonMetricData {
            name: "content_foreground".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum GpuProcessLabel {
        EAsynclogger = 0,
        EAudioipc = 1,
        EAudioipcCallbackRpc = 2,
        EAudioipcClientCallback = 3,
        EAudioipcClientRpc = 4,
        EAudioipcDevicecollectionRpc = 5,
        EAudioipcServerCallback = 6,
        EAudioipcServerRpc = 7,
        EBackgroundthreadpool = 8,
        EBgiothreadpool = 9,
        EBgreadurls = 10,
        EBhmgrMonitor = 11,
        EBhmgrProcessor = 12,
        ECamerasIpc = 13,
        ECapturethread = 14,
        EClassifierUpdate = 15,
        EComMta = 16,
        ECompositor = 17,
        ECookie = 18,
        ECubeboperation = 19,
        EDatachannelIo = 20,
        EDnsResolver = 21,
        EDomWorker = 22,
        EDomcachethread = 23,
        EExtensionprotocolhandler = 24,
        EFontLoader = 25,
        EFontenumthread = 26,
        EFsBroker = 27,
        EGeckomain = 28,
        EGmpthread = 29,
        EGraphrunner = 30,
        EHtml5Parser = 31,
        EImagebridgechld = 32,
        EImageio = 33,
        EIndexeddb = 34,
        EInitfontlist = 35,
        EInotifyeventthread = 36,
        EIpcIOChild = 37,
        EIpcIOParent = 38,
        EIpcLaunch = 39,
        EIpdlBackground = 40,
        EJsWatchdog = 41,
        EJumpList = 42,
        ELibwebrtcmodulethread = 43,
        ELinkMonitor = 44,
        ELsThread = 45,
        EMediacache = 46,
        EMediadecoderstatemachine = 47,
        EMediapdecoder = 48,
        EMediasupervisor = 49,
        EMediatimer = 50,
        EMediatrackgrph = 51,
        EMemorypoller = 52,
        EMozstorage = 53,
        EMtransport = 54,
        ENetlinkMonitor = 55,
        EPacerthread = 56,
        EPermission = 57,
        EPlayeventsound = 58,
        EProcesshangmon = 59,
        EProfilerchild = 60,
        EProxyresolution = 61,
        EQuotamanagerIo = 62,
        ERegisterfonts = 63,
        ERemotebackbuffer = 64,
        ERemotelzystream = 65,
        ERemvidchild = 66,
        ERenderer = 67,
        ESandboxreporter = 68,
        ESavescripts = 69,
        ESocketThread = 70,
        ESoftwarevsyncthread = 71,
        ESslCert = 72,
        EStartupcache = 73,
        EStreamtrans = 74,
        EStylethread = 75,
        ESwcomposite = 76,
        ETaskcontroller = 77,
        ETimer = 78,
        EToastbgthread = 79,
        ETrrBackground = 80,
        EUntrustedModules = 81,
        EUrlClassifier = 82,
        EVideocapture = 83,
        EVsynciothread = 84,
        EWebrtccallthread = 85,
        EWebrtcworker = 86,
        EWincompositor = 87,
        EWindowsvsyncthread = 88,
        EWinwindowocclusioncalc = 89,
        EWorkerLauncher = 90,
        EWrrenderbackend = 91,
        EWrscenebuilder = 92,
        EWrscenebuilderlp = 93,
        EWrworker = 94,
        EWrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for GpuProcessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAsynclogger,
                1 => Self::EAudioipc,
                2 => Self::EAudioipcCallbackRpc,
                3 => Self::EAudioipcClientCallback,
                4 => Self::EAudioipcClientRpc,
                5 => Self::EAudioipcDevicecollectionRpc,
                6 => Self::EAudioipcServerCallback,
                7 => Self::EAudioipcServerRpc,
                8 => Self::EBackgroundthreadpool,
                9 => Self::EBgiothreadpool,
                10 => Self::EBgreadurls,
                11 => Self::EBhmgrMonitor,
                12 => Self::EBhmgrProcessor,
                13 => Self::ECamerasIpc,
                14 => Self::ECapturethread,
                15 => Self::EClassifierUpdate,
                16 => Self::EComMta,
                17 => Self::ECompositor,
                18 => Self::ECookie,
                19 => Self::ECubeboperation,
                20 => Self::EDatachannelIo,
                21 => Self::EDnsResolver,
                22 => Self::EDomWorker,
                23 => Self::EDomcachethread,
                24 => Self::EExtensionprotocolhandler,
                25 => Self::EFontLoader,
                26 => Self::EFontenumthread,
                27 => Self::EFsBroker,
                28 => Self::EGeckomain,
                29 => Self::EGmpthread,
                30 => Self::EGraphrunner,
                31 => Self::EHtml5Parser,
                32 => Self::EImagebridgechld,
                33 => Self::EImageio,
                34 => Self::EIndexeddb,
                35 => Self::EInitfontlist,
                36 => Self::EInotifyeventthread,
                37 => Self::EIpcIOChild,
                38 => Self::EIpcIOParent,
                39 => Self::EIpcLaunch,
                40 => Self::EIpdlBackground,
                41 => Self::EJsWatchdog,
                42 => Self::EJumpList,
                43 => Self::ELibwebrtcmodulethread,
                44 => Self::ELinkMonitor,
                45 => Self::ELsThread,
                46 => Self::EMediacache,
                47 => Self::EMediadecoderstatemachine,
                48 => Self::EMediapdecoder,
                49 => Self::EMediasupervisor,
                50 => Self::EMediatimer,
                51 => Self::EMediatrackgrph,
                52 => Self::EMemorypoller,
                53 => Self::EMozstorage,
                54 => Self::EMtransport,
                55 => Self::ENetlinkMonitor,
                56 => Self::EPacerthread,
                57 => Self::EPermission,
                58 => Self::EPlayeventsound,
                59 => Self::EProcesshangmon,
                60 => Self::EProfilerchild,
                61 => Self::EProxyresolution,
                62 => Self::EQuotamanagerIo,
                63 => Self::ERegisterfonts,
                64 => Self::ERemotebackbuffer,
                65 => Self::ERemotelzystream,
                66 => Self::ERemvidchild,
                67 => Self::ERenderer,
                68 => Self::ESandboxreporter,
                69 => Self::ESavescripts,
                70 => Self::ESocketThread,
                71 => Self::ESoftwarevsyncthread,
                72 => Self::ESslCert,
                73 => Self::EStartupcache,
                74 => Self::EStreamtrans,
                75 => Self::EStylethread,
                76 => Self::ESwcomposite,
                77 => Self::ETaskcontroller,
                78 => Self::ETimer,
                79 => Self::EToastbgthread,
                80 => Self::ETrrBackground,
                81 => Self::EUntrustedModules,
                82 => Self::EUrlClassifier,
                83 => Self::EVideocapture,
                84 => Self::EVsynciothread,
                85 => Self::EWebrtccallthread,
                86 => Self::EWebrtcworker,
                87 => Self::EWincompositor,
                88 => Self::EWindowsvsyncthread,
                89 => Self::EWinwindowocclusioncalc,
                90 => Self::EWorkerLauncher,
                91 => Self::EWrrenderbackend,
                92 => Self::EWrscenebuilder,
                93 => Self::EWrscenebuilderlp,
                94 => Self::EWrworker,
                95 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuProcessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.gpu_process
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static gpu_process: Lazy<LabeledMetric<LabeledCounterMetric, GpuProcessLabel>> = Lazy::new(|| {
        LabeledMetric::new(3061.into(), CommonMetricData {
            name: "gpu_process".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentActiveLabel {
        EAsynclogger = 0,
        EAudioipc = 1,
        EAudioipcCallbackRpc = 2,
        EAudioipcClientCallback = 3,
        EAudioipcClientRpc = 4,
        EAudioipcDevicecollectionRpc = 5,
        EAudioipcServerCallback = 6,
        EAudioipcServerRpc = 7,
        EBackgroundthreadpool = 8,
        EBgiothreadpool = 9,
        EBgreadurls = 10,
        EBhmgrMonitor = 11,
        EBhmgrProcessor = 12,
        ECamerasIpc = 13,
        ECapturethread = 14,
        EClassifierUpdate = 15,
        EComMta = 16,
        ECompositor = 17,
        ECookie = 18,
        ECubeboperation = 19,
        EDatachannelIo = 20,
        EDnsResolver = 21,
        EDomWorker = 22,
        EDomcachethread = 23,
        EExtensionprotocolhandler = 24,
        EFontLoader = 25,
        EFontenumthread = 26,
        EFsBroker = 27,
        EGeckomain = 28,
        EGmpthread = 29,
        EGraphrunner = 30,
        EHtml5Parser = 31,
        EImagebridgechld = 32,
        EImageio = 33,
        EIndexeddb = 34,
        EInitfontlist = 35,
        EInotifyeventthread = 36,
        EIpcIOChild = 37,
        EIpcIOParent = 38,
        EIpcLaunch = 39,
        EIpdlBackground = 40,
        EJsWatchdog = 41,
        EJumpList = 42,
        ELibwebrtcmodulethread = 43,
        ELinkMonitor = 44,
        ELsThread = 45,
        EMediacache = 46,
        EMediadecoderstatemachine = 47,
        EMediapdecoder = 48,
        EMediasupervisor = 49,
        EMediatimer = 50,
        EMediatrackgrph = 51,
        EMemorypoller = 52,
        EMozstorage = 53,
        EMtransport = 54,
        ENetlinkMonitor = 55,
        EPacerthread = 56,
        EPermission = 57,
        EPlayeventsound = 58,
        EProcesshangmon = 59,
        EProfilerchild = 60,
        EProxyresolution = 61,
        EQuotamanagerIo = 62,
        ERegisterfonts = 63,
        ERemotebackbuffer = 64,
        ERemotelzystream = 65,
        ERemvidchild = 66,
        ERenderer = 67,
        ESandboxreporter = 68,
        ESavescripts = 69,
        ESocketThread = 70,
        ESoftwarevsyncthread = 71,
        ESslCert = 72,
        EStartupcache = 73,
        EStreamtrans = 74,
        EStylethread = 75,
        ESwcomposite = 76,
        ETaskcontroller = 77,
        ETimer = 78,
        EToastbgthread = 79,
        ETrrBackground = 80,
        EUntrustedModules = 81,
        EUrlClassifier = 82,
        EVideocapture = 83,
        EVsynciothread = 84,
        EWebrtccallthread = 85,
        EWebrtcworker = 86,
        EWincompositor = 87,
        EWindowsvsyncthread = 88,
        EWinwindowocclusioncalc = 89,
        EWorkerLauncher = 90,
        EWrrenderbackend = 91,
        EWrscenebuilder = 92,
        EWrscenebuilderlp = 93,
        EWrworker = 94,
        EWrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ParentActiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAsynclogger,
                1 => Self::EAudioipc,
                2 => Self::EAudioipcCallbackRpc,
                3 => Self::EAudioipcClientCallback,
                4 => Self::EAudioipcClientRpc,
                5 => Self::EAudioipcDevicecollectionRpc,
                6 => Self::EAudioipcServerCallback,
                7 => Self::EAudioipcServerRpc,
                8 => Self::EBackgroundthreadpool,
                9 => Self::EBgiothreadpool,
                10 => Self::EBgreadurls,
                11 => Self::EBhmgrMonitor,
                12 => Self::EBhmgrProcessor,
                13 => Self::ECamerasIpc,
                14 => Self::ECapturethread,
                15 => Self::EClassifierUpdate,
                16 => Self::EComMta,
                17 => Self::ECompositor,
                18 => Self::ECookie,
                19 => Self::ECubeboperation,
                20 => Self::EDatachannelIo,
                21 => Self::EDnsResolver,
                22 => Self::EDomWorker,
                23 => Self::EDomcachethread,
                24 => Self::EExtensionprotocolhandler,
                25 => Self::EFontLoader,
                26 => Self::EFontenumthread,
                27 => Self::EFsBroker,
                28 => Self::EGeckomain,
                29 => Self::EGmpthread,
                30 => Self::EGraphrunner,
                31 => Self::EHtml5Parser,
                32 => Self::EImagebridgechld,
                33 => Self::EImageio,
                34 => Self::EIndexeddb,
                35 => Self::EInitfontlist,
                36 => Self::EInotifyeventthread,
                37 => Self::EIpcIOChild,
                38 => Self::EIpcIOParent,
                39 => Self::EIpcLaunch,
                40 => Self::EIpdlBackground,
                41 => Self::EJsWatchdog,
                42 => Self::EJumpList,
                43 => Self::ELibwebrtcmodulethread,
                44 => Self::ELinkMonitor,
                45 => Self::ELsThread,
                46 => Self::EMediacache,
                47 => Self::EMediadecoderstatemachine,
                48 => Self::EMediapdecoder,
                49 => Self::EMediasupervisor,
                50 => Self::EMediatimer,
                51 => Self::EMediatrackgrph,
                52 => Self::EMemorypoller,
                53 => Self::EMozstorage,
                54 => Self::EMtransport,
                55 => Self::ENetlinkMonitor,
                56 => Self::EPacerthread,
                57 => Self::EPermission,
                58 => Self::EPlayeventsound,
                59 => Self::EProcesshangmon,
                60 => Self::EProfilerchild,
                61 => Self::EProxyresolution,
                62 => Self::EQuotamanagerIo,
                63 => Self::ERegisterfonts,
                64 => Self::ERemotebackbuffer,
                65 => Self::ERemotelzystream,
                66 => Self::ERemvidchild,
                67 => Self::ERenderer,
                68 => Self::ESandboxreporter,
                69 => Self::ESavescripts,
                70 => Self::ESocketThread,
                71 => Self::ESoftwarevsyncthread,
                72 => Self::ESslCert,
                73 => Self::EStartupcache,
                74 => Self::EStreamtrans,
                75 => Self::EStylethread,
                76 => Self::ESwcomposite,
                77 => Self::ETaskcontroller,
                78 => Self::ETimer,
                79 => Self::EToastbgthread,
                80 => Self::ETrrBackground,
                81 => Self::EUntrustedModules,
                82 => Self::EUrlClassifier,
                83 => Self::EVideocapture,
                84 => Self::EVsynciothread,
                85 => Self::EWebrtccallthread,
                86 => Self::EWebrtcworker,
                87 => Self::EWincompositor,
                88 => Self::EWindowsvsyncthread,
                89 => Self::EWinwindowocclusioncalc,
                90 => Self::EWorkerLauncher,
                91 => Self::EWrrenderbackend,
                92 => Self::EWrscenebuilder,
                93 => Self::EWrscenebuilderlp,
                94 => Self::EWrworker,
                95 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentActiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.parent_active
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static parent_active: Lazy<LabeledMetric<LabeledCounterMetric, ParentActiveLabel>> = Lazy::new(|| {
        LabeledMetric::new(3062.into(), CommonMetricData {
            name: "parent_active".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentInactiveLabel {
        EAsynclogger = 0,
        EAudioipc = 1,
        EAudioipcCallbackRpc = 2,
        EAudioipcClientCallback = 3,
        EAudioipcClientRpc = 4,
        EAudioipcDevicecollectionRpc = 5,
        EAudioipcServerCallback = 6,
        EAudioipcServerRpc = 7,
        EBackgroundthreadpool = 8,
        EBgiothreadpool = 9,
        EBgreadurls = 10,
        EBhmgrMonitor = 11,
        EBhmgrProcessor = 12,
        ECamerasIpc = 13,
        ECapturethread = 14,
        EClassifierUpdate = 15,
        EComMta = 16,
        ECompositor = 17,
        ECookie = 18,
        ECubeboperation = 19,
        EDatachannelIo = 20,
        EDnsResolver = 21,
        EDomWorker = 22,
        EDomcachethread = 23,
        EExtensionprotocolhandler = 24,
        EFontLoader = 25,
        EFontenumthread = 26,
        EFsBroker = 27,
        EGeckomain = 28,
        EGmpthread = 29,
        EGraphrunner = 30,
        EHtml5Parser = 31,
        EImagebridgechld = 32,
        EImageio = 33,
        EIndexeddb = 34,
        EInitfontlist = 35,
        EInotifyeventthread = 36,
        EIpcIOChild = 37,
        EIpcIOParent = 38,
        EIpcLaunch = 39,
        EIpdlBackground = 40,
        EJsWatchdog = 41,
        EJumpList = 42,
        ELibwebrtcmodulethread = 43,
        ELinkMonitor = 44,
        ELsThread = 45,
        EMediacache = 46,
        EMediadecoderstatemachine = 47,
        EMediapdecoder = 48,
        EMediasupervisor = 49,
        EMediatimer = 50,
        EMediatrackgrph = 51,
        EMemorypoller = 52,
        EMozstorage = 53,
        EMtransport = 54,
        ENetlinkMonitor = 55,
        EPacerthread = 56,
        EPermission = 57,
        EPlayeventsound = 58,
        EProcesshangmon = 59,
        EProfilerchild = 60,
        EProxyresolution = 61,
        EQuotamanagerIo = 62,
        ERegisterfonts = 63,
        ERemotebackbuffer = 64,
        ERemotelzystream = 65,
        ERemvidchild = 66,
        ERenderer = 67,
        ESandboxreporter = 68,
        ESavescripts = 69,
        ESocketThread = 70,
        ESoftwarevsyncthread = 71,
        ESslCert = 72,
        EStartupcache = 73,
        EStreamtrans = 74,
        EStylethread = 75,
        ESwcomposite = 76,
        ETaskcontroller = 77,
        ETimer = 78,
        EToastbgthread = 79,
        ETrrBackground = 80,
        EUntrustedModules = 81,
        EUrlClassifier = 82,
        EVideocapture = 83,
        EVsynciothread = 84,
        EWebrtccallthread = 85,
        EWebrtcworker = 86,
        EWincompositor = 87,
        EWindowsvsyncthread = 88,
        EWinwindowocclusioncalc = 89,
        EWorkerLauncher = 90,
        EWrrenderbackend = 91,
        EWrscenebuilder = 92,
        EWrscenebuilderlp = 93,
        EWrworker = 94,
        EWrworkerlp = 95,
        __Other__,
    }
    impl From<u16> for ParentInactiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAsynclogger,
                1 => Self::EAudioipc,
                2 => Self::EAudioipcCallbackRpc,
                3 => Self::EAudioipcClientCallback,
                4 => Self::EAudioipcClientRpc,
                5 => Self::EAudioipcDevicecollectionRpc,
                6 => Self::EAudioipcServerCallback,
                7 => Self::EAudioipcServerRpc,
                8 => Self::EBackgroundthreadpool,
                9 => Self::EBgiothreadpool,
                10 => Self::EBgreadurls,
                11 => Self::EBhmgrMonitor,
                12 => Self::EBhmgrProcessor,
                13 => Self::ECamerasIpc,
                14 => Self::ECapturethread,
                15 => Self::EClassifierUpdate,
                16 => Self::EComMta,
                17 => Self::ECompositor,
                18 => Self::ECookie,
                19 => Self::ECubeboperation,
                20 => Self::EDatachannelIo,
                21 => Self::EDnsResolver,
                22 => Self::EDomWorker,
                23 => Self::EDomcachethread,
                24 => Self::EExtensionprotocolhandler,
                25 => Self::EFontLoader,
                26 => Self::EFontenumthread,
                27 => Self::EFsBroker,
                28 => Self::EGeckomain,
                29 => Self::EGmpthread,
                30 => Self::EGraphrunner,
                31 => Self::EHtml5Parser,
                32 => Self::EImagebridgechld,
                33 => Self::EImageio,
                34 => Self::EIndexeddb,
                35 => Self::EInitfontlist,
                36 => Self::EInotifyeventthread,
                37 => Self::EIpcIOChild,
                38 => Self::EIpcIOParent,
                39 => Self::EIpcLaunch,
                40 => Self::EIpdlBackground,
                41 => Self::EJsWatchdog,
                42 => Self::EJumpList,
                43 => Self::ELibwebrtcmodulethread,
                44 => Self::ELinkMonitor,
                45 => Self::ELsThread,
                46 => Self::EMediacache,
                47 => Self::EMediadecoderstatemachine,
                48 => Self::EMediapdecoder,
                49 => Self::EMediasupervisor,
                50 => Self::EMediatimer,
                51 => Self::EMediatrackgrph,
                52 => Self::EMemorypoller,
                53 => Self::EMozstorage,
                54 => Self::EMtransport,
                55 => Self::ENetlinkMonitor,
                56 => Self::EPacerthread,
                57 => Self::EPermission,
                58 => Self::EPlayeventsound,
                59 => Self::EProcesshangmon,
                60 => Self::EProfilerchild,
                61 => Self::EProxyresolution,
                62 => Self::EQuotamanagerIo,
                63 => Self::ERegisterfonts,
                64 => Self::ERemotebackbuffer,
                65 => Self::ERemotelzystream,
                66 => Self::ERemvidchild,
                67 => Self::ERenderer,
                68 => Self::ESandboxreporter,
                69 => Self::ESavescripts,
                70 => Self::ESocketThread,
                71 => Self::ESoftwarevsyncthread,
                72 => Self::ESslCert,
                73 => Self::EStartupcache,
                74 => Self::EStreamtrans,
                75 => Self::EStylethread,
                76 => Self::ESwcomposite,
                77 => Self::ETaskcontroller,
                78 => Self::ETimer,
                79 => Self::EToastbgthread,
                80 => Self::ETrrBackground,
                81 => Self::EUntrustedModules,
                82 => Self::EUrlClassifier,
                83 => Self::EVideocapture,
                84 => Self::EVsynciothread,
                85 => Self::EWebrtccallthread,
                86 => Self::EWebrtcworker,
                87 => Self::EWincompositor,
                88 => Self::EWindowsvsyncthread,
                89 => Self::EWinwindowocclusioncalc,
                90 => Self::EWorkerLauncher,
                91 => Self::EWrrenderbackend,
                92 => Self::EWrscenebuilder,
                93 => Self::EWrscenebuilderlp,
                94 => Self::EWrworker,
                95 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentInactiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.parent_inactive
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static parent_inactive: Lazy<LabeledMetric<LabeledCounterMetric, ParentInactiveLabel>> = Lazy::new(|| {
        LabeledMetric::new(3063.into(), CommonMetricData {
            name: "parent_inactive".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

}
pub mod broken_site_report {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.breakage_category
    ///
    /// An optional select-box choice (options may eventually change)
    pub static breakage_category: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3064.into(), CommonMetricData {
            name: "breakage_category".into(),
            category: "broken_site_report".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.description
    ///
    /// An optional description of the site issue the user is experiencing. May contain
    /// PII.
    pub static description: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3065.into(), CommonMetricData {
            name: "description".into(),
            category: "broken_site_report".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.url
    ///
    /// The URL of the site being reported. May contain PII.
    pub static url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(3066.into(), CommonMetricData {
            name: "url".into(),
            category: "broken_site_report".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod broken_site_report_browser_info_app {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.app.default_locales
    ///
    /// Locale strings, ie `["en-US", "en"]`
    pub static default_locales: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(3067.into(), CommonMetricData {
            name: "default_locales".into(),
            category: "broken_site_report.browser_info.app".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.app.default_useragent_string
    ///
    /// The default user-agent string of the browser
    pub static default_useragent_string: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3068.into(), CommonMetricData {
            name: "default_useragent_string".into(),
            category: "broken_site_report.browser_info.app".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.app.fission_enabled
    ///
    /// Whether Fission is enabled
    pub static fission_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3069.into(), CommonMetricData {
            name: "fission_enabled".into(),
            category: "broken_site_report.browser_info.app".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod broken_site_report_browser_info_graphics {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.device_pixel_ratio
    ///
    /// A decimal number
    pub static device_pixel_ratio: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3070.into(), CommonMetricData {
            name: "device_pixel_ratio".into(),
            category: "broken_site_report.browser_info.graphics".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.devices_json
    ///
    /// JSON array of objects with `vendorID` and `deviceID`. For instance,
    /// `[{"vendorID":"0x000", "deviceID":"0x001"}]`
    pub static devices_json: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3071.into(), CommonMetricData {
            name: "devices_json".into(),
            category: "broken_site_report.browser_info.graphics".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.drivers_json
    ///
    /// JSON array of objects with `renderer` and `version`. For instance,
    /// `[{"renderer":"demo", "version":"0.2"}]`
    pub static drivers_json: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3072.into(), CommonMetricData {
            name: "drivers_json".into(),
            category: "broken_site_report.browser_info.graphics".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.features_json
    ///
    /// JSON object. For instance,
    /// `{"WEBRENDER":"available","WEBRENDER_PARTIAL":"disabled (User disabled via
    /// pref)"}`
    pub static features_json: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3073.into(), CommonMetricData {
            name: "features_json".into(),
            category: "broken_site_report.browser_info.graphics".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.has_touch_screen
    ///
    /// Whether a touch screen was detected
    pub static has_touch_screen: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3074.into(), CommonMetricData {
            name: "has_touch_screen".into(),
            category: "broken_site_report.browser_info.graphics".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.monitors_json
    ///
    /// JSON array of objects with `screenWidth`, 'screenHeight`, and `scale`. For
    /// instance, `[{"screenWidth":3584,"screenHeight":2240,"scale":2}]`
    pub static monitors_json: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3075.into(), CommonMetricData {
            name: "monitors_json".into(),
            category: "broken_site_report.browser_info.graphics".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod broken_site_report_browser_info_prefs {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.cookie_behavior
    ///
    /// Value of `network.cookie.cookieBehavior`
    pub static cookie_behavior: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3076.into(), CommonMetricData {
            name: "cookie_behavior".into(),
            category: "broken_site_report.browser_info.prefs".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.forced_accelerated_layers
    ///
    /// Value of `layers.acceleration_force.enabled`
    pub static forced_accelerated_layers: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3077.into(), CommonMetricData {
            name: "forced_accelerated_layers".into(),
            category: "broken_site_report.browser_info.prefs".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.global_privacy_control_enabled
    ///
    /// Value of `privacy.globalprivacycontrol.enabled`
    pub static global_privacy_control_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3078.into(), CommonMetricData {
            name: "global_privacy_control_enabled".into(),
            category: "broken_site_report.browser_info.prefs".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.installtrigger_enabled
    ///
    /// Value of `extensions.InstallTrigger.enabled`
    pub static installtrigger_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3079.into(), CommonMetricData {
            name: "installtrigger_enabled".into(),
            category: "broken_site_report.browser_info.prefs".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.opaque_response_blocking
    ///
    /// Value of `browser.opaqueResponseBlocking`
    pub static opaque_response_blocking: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3080.into(), CommonMetricData {
            name: "opaque_response_blocking".into(),
            category: "broken_site_report.browser_info.prefs".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.resist_fingerprinting_enabled
    ///
    /// Value of `privacy.resistFingerprinting`
    pub static resist_fingerprinting_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3081.into(), CommonMetricData {
            name: "resist_fingerprinting_enabled".into(),
            category: "broken_site_report.browser_info.prefs".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.software_webrender
    ///
    /// Value of `gfx.webrender.software`
    pub static software_webrender: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3082.into(), CommonMetricData {
            name: "software_webrender".into(),
            category: "broken_site_report.browser_info.prefs".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod broken_site_report_browser_info_security {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.security.antispyware
    ///
    /// Which antispyware software was reported on this system.
    pub static antispyware: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(3083.into(), CommonMetricData {
            name: "antispyware".into(),
            category: "broken_site_report.browser_info.security".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.security.antivirus
    ///
    /// Which antivirus software was reported on this system.
    pub static antivirus: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(3084.into(), CommonMetricData {
            name: "antivirus".into(),
            category: "broken_site_report.browser_info.security".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.security.firewall
    ///
    /// Which firewall software was reported on this system.
    pub static firewall: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(3085.into(), CommonMetricData {
            name: "firewall".into(),
            category: "broken_site_report.browser_info.security".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod broken_site_report_browser_info_system {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.system.is_tablet
    ///
    /// Whether the device is a tablet
    pub static is_tablet: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3086.into(), CommonMetricData {
            name: "is_tablet".into(),
            category: "broken_site_report.browser_info.system".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.system.memory
    ///
    /// How many mb of RAM is reported for the system
    pub static memory: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3087.into(), CommonMetricData {
            name: "memory".into(),
            category: "broken_site_report.browser_info.system".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod broken_site_report_tab_info {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.languages
    ///
    /// The languages the site actually sees (may be overridden)
    pub static languages: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(3088.into(), CommonMetricData {
            name: "languages".into(),
            category: "broken_site_report.tab_info".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.useragent_string
    ///
    /// The userAgent the site actually sees (may be overridden)
    pub static useragent_string: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3089.into(), CommonMetricData {
            name: "useragent_string".into(),
            category: "broken_site_report.tab_info".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod broken_site_report_tab_info_antitracking {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.block_list
    ///
    /// Currently either `basic` or `strict`, may change in the future.
    pub static block_list: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3090.into(), CommonMetricData {
            name: "block_list".into(),
            category: "broken_site_report.tab_info.antitracking".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.has_mixed_active_content_blocked
    ///
    /// Whether the reported tab has any blocked mixed active content
    pub static has_mixed_active_content_blocked: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3091.into(), CommonMetricData {
            name: "has_mixed_active_content_blocked".into(),
            category: "broken_site_report.tab_info.antitracking".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.has_mixed_display_content_blocked
    ///
    /// Whether the reported tab has any blocked mixed display content
    pub static has_mixed_display_content_blocked: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3092.into(), CommonMetricData {
            name: "has_mixed_display_content_blocked".into(),
            category: "broken_site_report.tab_info.antitracking".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.has_tracking_content_blocked
    ///
    /// Whether the reported tab has any blocked tracking content
    pub static has_tracking_content_blocked: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3093.into(), CommonMetricData {
            name: "has_tracking_content_blocked".into(),
            category: "broken_site_report.tab_info.antitracking".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.is_private_browsing
    ///
    /// Whether the tab the user was on when reporting is in private browsing mode
    pub static is_private_browsing: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3094.into(), CommonMetricData {
            name: "is_private_browsing".into(),
            category: "broken_site_report.tab_info.antitracking".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod broken_site_report_tab_info_frameworks {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.frameworks.fastclick
    ///
    /// Whether the FastClick web library was detected on the original tab.
    pub static fastclick: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3095.into(), CommonMetricData {
            name: "fastclick".into(),
            category: "broken_site_report.tab_info.frameworks".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.frameworks.marfeel
    ///
    /// Whether the Marfeel web framework was detected on the original tab.
    pub static marfeel: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3096.into(), CommonMetricData {
            name: "marfeel".into(),
            category: "broken_site_report.tab_info.frameworks".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.frameworks.mobify
    ///
    /// Whether the Mobify web framework was detected on the original tab.
    pub static mobify: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3097.into(), CommonMetricData {
            name: "mobify".into(),
            category: "broken_site_report.tab_info.frameworks".into(),
            send_in_pings: vec!["broken-site-report".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod webcompatreporting {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenedExtra {
        pub source: Option<String>,
    }

    impl ExtraKeys for OpenedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.opened
    ///
    /// Records the method for opening the webcompat reporting window.
    pub static opened: Lazy<EventMetric<OpenedExtra>> = Lazy::new(|| {
        EventMetric::new(3098.into(), CommonMetricData {
            name: "opened".into(),
            category: "webcompatreporting".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ReasonDropdownExtra {
        pub setting: Option<String>,
    }

    impl ExtraKeys for ReasonDropdownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["setting"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.setting.and_then(|val| map.insert("setting".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.reason_dropdown
    ///
    /// Record whether the user has a dropdown enabled + whether the dropdown menu is
    /// optional or mandatory.
    pub static reason_dropdown: Lazy<EventMetric<ReasonDropdownExtra>> = Lazy::new(|| {
        EventMetric::new(3099.into(), CommonMetricData {
            name: "reason_dropdown".into(),
            category: "webcompatreporting".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.send
    ///
    /// Recorded when a user selects the Send button to submit webcompat report data.
    pub static send: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3100.into(), CommonMetricData {
            name: "send".into(),
            category: "webcompatreporting".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.send_more_info
    ///
    /// Recorded when a user clicks on the Send More Info link in the reporting UI The
    /// user will be redirected to webcompat.com to submit a more comprehensive report.
    /// (This is only enabled on beta/nightly/pre-release channels).
    pub static send_more_info: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3101.into(), CommonMetricData {
            name: "send_more_info".into(),
            category: "webcompatreporting".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod characteristics {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.audio_devices
    ///
    /// A JSON object containing sample rate and max channel count of every audio
    /// device, and output latency of default device
    pub static audio_devices: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3102.into(), CommonMetricData {
            name: "audio_devices".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.audio_fingerprint
    ///
    /// Audio fingerprint of the user. A float number multiplied by 10e7.
    pub static audio_fingerprint: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3103.into(), CommonMetricData {
            name: "audio_fingerprint".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.avail_height
    ///
    /// Available height property
    pub static avail_height: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3104.into(), CommonMetricData {
            name: "avail_height".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.avail_width
    ///
    /// Available width property
    pub static avail_width: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3105.into(), CommonMetricData {
            name: "avail_width".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata1
    ///
    /// The base64 encoded form of an image rendered on a canvas. The image is a simple
    /// organge box and used as a control image
    pub static canvasdata1: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3106.into(), CommonMetricData {
            name: "canvasdata1".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata10
    ///
    /// The base64 encoded form of an image rendered on a canvas. The image is a font
    /// shipped with Firefox rendered with italics, rotation, and shadow-blur.
    pub static canvasdata10: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3107.into(), CommonMetricData {
            name: "canvasdata10".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata11_webgl
    ///
    /// The base64 encoded form of an image rendered on a WebGL canvas (instead of
    /// Canvas2D). IT is a RGB gradient cube.
    pub static canvasdata11_webgl: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3108.into(), CommonMetricData {
            name: "canvasdata11_webgl".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata12_fingerprintjs1
    ///
    /// The base64 encoded form of an image rendered on a canvas, it is a copy of
    /// fingerprintjs' text canvas
    pub static canvasdata12_fingerprintjs1: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3109.into(), CommonMetricData {
            name: "canvasdata12_fingerprintjs1".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata13_fingerprintjs2
    ///
    /// The base64 encoded form of an image rendered on a canvas, it is a copy of
    /// fingerprintjs' geometry canvas
    pub static canvasdata13_fingerprintjs2: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3110.into(), CommonMetricData {
            name: "canvasdata13_fingerprintjs2".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata2
    ///
    /// The base64 encoded form of an image rendered on a canvas. The image is a
    /// bordered triage, and used to test point interpolation
    pub static canvasdata2: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3111.into(), CommonMetricData {
            name: "canvasdata2".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata3
    ///
    /// The base64 encoded form of an image rendered on a canvas. The image is a
    /// stretched photographic image, used to test image operations.
    pub static canvasdata3: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3112.into(), CommonMetricData {
            name: "canvasdata3".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata4
    ///
    /// The base64 encoded form of an image rendered on a canvas. The image is two
    /// rotated, semi-transparenct overlapping squares, used to test transparency and
    /// point interpolation.
    pub static canvasdata4: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3113.into(), CommonMetricData {
            name: "canvasdata4".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata5
    ///
    /// The base64 encoded form of an image rendered on a canvas. The image is a local
    /// font rendered normally.
    pub static canvasdata5: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3114.into(), CommonMetricData {
            name: "canvasdata5".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata6
    ///
    /// The base64 encoded form of an image rendered on a canvas. The image is a local
    /// font rendered with italics, rotation, and shadow-blur.
    pub static canvasdata6: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3115.into(), CommonMetricData {
            name: "canvasdata6".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata7
    ///
    /// The base64 encoded form of an image rendered on a canvas. The image is a
    /// system-ui font rendered normally.
    pub static canvasdata7: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3116.into(), CommonMetricData {
            name: "canvasdata7".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata8
    ///
    /// The base64 encoded form of an image rendered on a canvas. The image is a
    /// system-ui font rendered with italics, rotation, and shadow-blur.
    pub static canvasdata8: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3117.into(), CommonMetricData {
            name: "canvasdata8".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata9
    ///
    /// The base64 encoded form of an image rendered on a canvas. The image is a font
    /// shipped with Firefox rendered normally.
    pub static canvasdata9: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3118.into(), CommonMetricData {
            name: "canvasdata9".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.changed_media_prefs
    ///
    /// Changed media prefs and their values.
    pub static changed_media_prefs: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3119.into(), CommonMetricData {
            name: "changed_media_prefs".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.client_identifier
    ///
    /// A unique identifier for a user, not the same as the normal Telemetry client_id,
    /// but needed so we can deduplicate reports and only take the most recent one per
    /// user.
    pub static client_identifier: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(3120.into(), CommonMetricData {
            name: "client_identifier".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["deletion-request".into(), "user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_accentcolor
    ///
    /// The CSS system-color Accentcolor.
    pub static color_accentcolor: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3121.into(), CommonMetricData {
            name: "color_accentcolor".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_accentcolortext
    ///
    /// The CSS system-color Accentcolortext.
    pub static color_accentcolortext: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3122.into(), CommonMetricData {
            name: "color_accentcolortext".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_canvas
    ///
    /// The CSS system-color Canvas.
    pub static color_canvas: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3123.into(), CommonMetricData {
            name: "color_canvas".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_canvastext
    ///
    /// The CSS system-color Canvastext.
    pub static color_canvastext: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3124.into(), CommonMetricData {
            name: "color_canvastext".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_depth
    ///
    /// The Color Depth reported by CSS
    pub static color_depth: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3125.into(), CommonMetricData {
            name: "color_depth".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_gamut
    ///
    /// The Color Gamut reported by CSS
    pub static color_gamut: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3126.into(), CommonMetricData {
            name: "color_gamut".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_highlight
    ///
    /// The CSS system-color Highlight.
    pub static color_highlight: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3127.into(), CommonMetricData {
            name: "color_highlight".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_highlighttext
    ///
    /// The CSS system-color Highlighttext.
    pub static color_highlighttext: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3128.into(), CommonMetricData {
            name: "color_highlighttext".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_scheme
    ///
    /// The Color Scheme used for Content, from ContentPrefs() Preference Sheet.
    pub static color_scheme: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3129.into(), CommonMetricData {
            name: "color_scheme".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_selecteditem
    ///
    /// The CSS system-color Selecteditem.
    pub static color_selecteditem: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3130.into(), CommonMetricData {
            name: "color_selecteditem".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_selecteditemtext
    ///
    /// The CSS system-color Selecteditemtext.
    pub static color_selecteditemtext: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3131.into(), CommonMetricData {
            name: "color_selecteditemtext".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_default_default_group
    ///
    /// The value of the font.default.<default language group> pref
    pub static font_default_default_group: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3132.into(), CommonMetricData {
            name: "font_default_default_group".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_default_modified
    ///
    /// The number of other modified font.default prefs.
    pub static font_default_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3133.into(), CommonMetricData {
            name: "font_default_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_default_western
    ///
    /// The value of the font.default.x-western pref
    pub static font_default_western: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3134.into(), CommonMetricData {
            name: "font_default_western".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_minimum_size_default_group
    ///
    /// The value of the font.minimum-size.<default language group> pref
    pub static font_minimum_size_default_group: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3135.into(), CommonMetricData {
            name: "font_minimum_size_default_group".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_minimum_size_modified
    ///
    /// The number of other modified font.minimum-size prefs.
    pub static font_minimum_size_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3136.into(), CommonMetricData {
            name: "font_minimum_size_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_minimum_size_western
    ///
    /// The value of the font.minimum-size.x-western pref
    pub static font_minimum_size_western: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3137.into(), CommonMetricData {
            name: "font_minimum_size_western".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_cursive_modified
    ///
    /// The number of modified font.name-list.cursive. prefs.
    pub static font_name_list_cursive_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3138.into(), CommonMetricData {
            name: "font_name_list_cursive_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_emoji_modified
    ///
    /// Whether the pref font.name-list.emoji was modified.
    pub static font_name_list_emoji_modified: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3139.into(), CommonMetricData {
            name: "font_name_list_emoji_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_monospace_modified
    ///
    /// The number of modified font.name-list.monospace. prefs.
    pub static font_name_list_monospace_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3140.into(), CommonMetricData {
            name: "font_name_list_monospace_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_sans_serif_modified
    ///
    /// The number of modified font.name-list.sans-serif. prefs.
    pub static font_name_list_sans_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3141.into(), CommonMetricData {
            name: "font_name_list_sans_serif_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_serif_modified
    ///
    /// The number of modified font.name-list.serif. prefs.
    pub static font_name_list_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3142.into(), CommonMetricData {
            name: "font_name_list_serif_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_monospace_default_group
    ///
    /// The value of the font.name.monospace.<default language group> pref
    pub static font_name_monospace_default_group: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3143.into(), CommonMetricData {
            name: "font_name_monospace_default_group".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_monospace_modified
    ///
    /// The number of other modified font.name.monospace prefs.
    pub static font_name_monospace_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3144.into(), CommonMetricData {
            name: "font_name_monospace_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_monospace_western
    ///
    /// The value of the font.name.monospace.x-western pref
    pub static font_name_monospace_western: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3145.into(), CommonMetricData {
            name: "font_name_monospace_western".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_sans_serif_default_group
    ///
    /// The value of the font.name.sans-serif.<default language group> pref
    pub static font_name_sans_serif_default_group: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3146.into(), CommonMetricData {
            name: "font_name_sans_serif_default_group".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_sans_serif_modified
    ///
    /// The number of other modified font.name.sans-serif prefs.
    pub static font_name_sans_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3147.into(), CommonMetricData {
            name: "font_name_sans_serif_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_sans_serif_western
    ///
    /// The value of the font.name.sans-serif.x-western pref
    pub static font_name_sans_serif_western: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3148.into(), CommonMetricData {
            name: "font_name_sans_serif_western".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_serif_default_group
    ///
    /// The value of the font.name.serif.<default language group> pref
    pub static font_name_serif_default_group: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3149.into(), CommonMetricData {
            name: "font_name_serif_default_group".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_serif_modified
    ///
    /// The number of other modified font.name.serif prefs.
    pub static font_name_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3150.into(), CommonMetricData {
            name: "font_name_serif_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_serif_western
    ///
    /// The value of the font.name.serif.x-western pref
    pub static font_name_serif_western: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3151.into(), CommonMetricData {
            name: "font_name_serif_western".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_monospace_default_group
    ///
    /// The value of the font.size.monospace.<default language group> pref
    pub static font_size_monospace_default_group: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3152.into(), CommonMetricData {
            name: "font_size_monospace_default_group".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_monospace_modified
    ///
    /// The number of other modified font.size.monospace prefs.
    pub static font_size_monospace_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3153.into(), CommonMetricData {
            name: "font_size_monospace_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_monospace_western
    ///
    /// The value of the font.size.monospace.x-western pref
    pub static font_size_monospace_western: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3154.into(), CommonMetricData {
            name: "font_size_monospace_western".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_variable_default_group
    ///
    /// The value of the font.size.variable.<default language group> pref
    pub static font_size_variable_default_group: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3155.into(), CommonMetricData {
            name: "font_size_variable_default_group".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_variable_modified
    ///
    /// The number of other modified font.size.variable prefs.
    pub static font_size_variable_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3156.into(), CommonMetricData {
            name: "font_size_variable_modified".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_variable_western
    ///
    /// The value of the font.size.variable.x-western pref
    pub static font_size_variable_western: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3157.into(), CommonMetricData {
            name: "font_size_variable_western".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gamepads
    ///
    /// The information of the gamepads inserted on the user device. Each string
    /// represents one gamepad. We use a JSON array to describe a gamepad, every value
    /// represents one property of the gamepad. Following are the details:
    ///   index 0: The ID of the game pad
    ///   index 1: Which hand for the gamepad.
    ///   index 2: Number of buttons
    ///   index 3: Number of axes
    ///   index 4: Number of haptics
    ///   index 5: Number of lights
    ///   index 6: Number of touches
    pub static gamepads: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(3158.into(), CommonMetricData {
            name: "gamepads".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.inner_height
    ///
    /// Inner height of user's browser.
    pub static inner_height: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3159.into(), CommonMetricData {
            name: "inner_height".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.inner_width
    ///
    /// Inner width of user's browser.
    pub static inner_width: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3160.into(), CommonMetricData {
            name: "inner_width".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.intl_locale
    ///
    /// Locale information provided by Intl
    pub static intl_locale: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3161.into(), CommonMetricData {
            name: "intl_locale".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.inverted_colors
    ///
    /// What LookAndFeel(InvertedColors) reports.
    pub static inverted_colors: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3162.into(), CommonMetricData {
            name: "inverted_colors".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.languages
    ///
    /// Languages the user set. Returns intl.accept_languages pref, if it is empty,
    /// returns the first matched OS's language or the default language.
    pub static languages: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3163.into(), CommonMetricData {
            name: "languages".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.math_ops
    ///
    /// Result of fingerprintable math operations
    pub static math_ops: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3164.into(), CommonMetricData {
            name: "math_ops".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.max_touch_points
    ///
    /// The number of touch points we will report to the web. On Android, this is based
    /// on Android's FEATURE_TOUCHSCREEN* constants - Mozilla caps this at 5 as Android
    /// stops distinguishing between numbers greater than 5.  On Windows this comes
    /// from the SM_MAXIMUMTOUCHES System Metric.
    pub static max_touch_points: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3165.into(), CommonMetricData {
            name: "max_touch_points".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_capabilities
    ///
    /// Which, if any, media types are not supported, and whether they can be run
    /// smoothly and power-efficiently.
    pub static media_capabilities: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3166.into(), CommonMetricData {
            name: "media_capabilities".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_devices
    ///
    /// A JSON object containing the number of audio input/output, video input and the
    /// number of unique group ids.
    pub static media_devices: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3167.into(), CommonMetricData {
            name: "media_devices".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.missing_fonts
    ///
    /// If a Font List is available for the user's platform, this string_list contains
    /// the fonts that are missing from the user's computer.
    pub static missing_fonts: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3168.into(), CommonMetricData {
            name: "missing_fonts".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.orientation_angle
    ///
    /// Orientation angle of the screen
    pub static orientation_angle: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3169.into(), CommonMetricData {
            name: "orientation_angle".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.outer_height
    ///
    /// Outer height of user's browser.
    pub static outer_height: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3170.into(), CommonMetricData {
            name: "outer_height".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.outer_width
    ///
    /// Outer width of user's browser.
    pub static outer_width: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3171.into(), CommonMetricData {
            name: "outer_width".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pixel_depth
    ///
    /// Screen pixel depth property
    pub static pixel_depth: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3172.into(), CommonMetricData {
            name: "pixel_depth".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pixel_ratio
    ///
    /// The value of window.devicePixelRatio multiplied by 100 to include some of the
    /// decimal places
    pub static pixel_ratio: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3173.into(), CommonMetricData {
            name: "pixel_ratio".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.posx
    ///
    /// window.screen.left value. Provides us the position of the browser and the width
    /// of any possible task/menu bar
    pub static posx: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3174.into(), CommonMetricData {
            name: "posx".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.posy
    ///
    /// window.screen.top value. Provides us the position of the browser and the height
    /// of any possible task/menu bar
    pub static posy: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3175.into(), CommonMetricData {
            name: "posy".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefers_contrast
    ///
    /// What Gecko_MediaFeatures_PrefersContrast reports for a ContentDocument
    pub static prefers_contrast: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3176.into(), CommonMetricData {
            name: "prefers_contrast".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefers_reduced_motion
    ///
    /// What LookAndFeel(PrefersReducedMotion) reports.
    pub static prefers_reduced_motion: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3177.into(), CommonMetricData {
            name: "prefers_reduced_motion".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefers_reduced_transparency
    ///
    /// What LookAndFeel(PrefersReducedTransparency) reports.
    pub static prefers_reduced_transparency: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3178.into(), CommonMetricData {
            name: "prefers_reduced_transparency".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_block_popups
    ///
    /// Block pop-up windows (The dom.disable_open_during_load pref)
    pub static prefs_block_popups: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3179.into(), CommonMetricData {
            name: "prefs_block_popups".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_browser_display_use_document_fonts
    ///
    /// Allow pages to choose their own fonts.
    pub static prefs_browser_display_use_document_fonts: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3180.into(), CommonMetricData {
            name: "prefs_browser_display_use_document_fonts".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_general_autoscroll
    ///
    /// Use autoscrolling
    pub static prefs_general_autoscroll: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3181.into(), CommonMetricData {
            name: "prefs_general_autoscroll".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_general_smoothscroll
    ///
    /// Use smooth scrolling
    pub static prefs_general_smoothscroll: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3182.into(), CommonMetricData {
            name: "prefs_general_smoothscroll".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_intl_accept_languages
    ///
    /// Value of the intl.accept_languages pref.
    pub static prefs_intl_accept_languages: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3183.into(), CommonMetricData {
            name: "prefs_intl_accept_languages".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_media_eme_enabled
    ///
    /// Value of the media.eme.enabled pref.
    pub static prefs_media_eme_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3184.into(), CommonMetricData {
            name: "prefs_media_eme_enabled".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_network_cookie_cookiebehavior
    ///
    /// Value of the network.cookie.cookieBehavior pref.
    pub static prefs_network_cookie_cookiebehavior: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3185.into(), CommonMetricData {
            name: "prefs_network_cookie_cookiebehavior".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_overlay_scrollbars
    ///
    /// Use overlay scrollbars (or otherwise "Always show scrollbars")
    pub static prefs_overlay_scrollbars: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3186.into(), CommonMetricData {
            name: "prefs_overlay_scrollbars".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_privacy_donottrackheader_enabled
    ///
    /// Sending "do not track" HTTP header
    pub static prefs_privacy_donottrackheader_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3187.into(), CommonMetricData {
            name: "prefs_privacy_donottrackheader_enabled".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_privacy_globalprivacycontrol_enabled
    ///
    /// Sending "global privacy control" HTTP header
    pub static prefs_privacy_globalprivacycontrol_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3188.into(), CommonMetricData {
            name: "prefs_privacy_globalprivacycontrol_enabled".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_zoom_text_only
    ///
    /// Text-only zoom enabled (vs. full-zoom)
    pub static prefs_zoom_text_only: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3189.into(), CommonMetricData {
            name: "prefs_zoom_text_only".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.processor_count
    ///
    /// Number of processors.
    pub static processor_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3190.into(), CommonMetricData {
            name: "processor_count".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.scalings
    ///
    /// Screen(s) scaling/zoom level
    pub static scalings: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3191.into(), CommonMetricData {
            name: "scalings".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.screen_height
    ///
    /// Height of the primary screen in pixels.
    pub static screen_height: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3192.into(), CommonMetricData {
            name: "screen_height".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.screen_orientation
    ///
    /// Orientation of the primary screen.
    pub static screen_orientation: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3193.into(), CommonMetricData {
            name: "screen_orientation".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.screen_width
    ///
    /// Width of the primary screen in pixels.
    pub static screen_width: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3194.into(), CommonMetricData {
            name: "screen_width".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.size_mode
    ///
    /// Whether window is maximized, minimized, normal or fullscreen
    pub static size_mode: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3195.into(), CommonMetricData {
            name: "size_mode".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.submission_schema
    ///
    /// An incrementing constant that represents the current schema/source of the data
    /// present in a ping. By referring to this value in a ping, one can know for
    /// certain the provenance of other data present in the ping, and what data may or
    /// may not be present.
    pub static submission_schema: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3196.into(), CommonMetricData {
            name: "submission_schema".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.system_locale
    ///
    /// The locale used by the host OS for localization.
    pub static system_locale: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3197.into(), CommonMetricData {
            name: "system_locale".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.target_frame_rate
    ///
    /// The target frame rate in frames-per-second.
    pub static target_frame_rate: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3198.into(), CommonMetricData {
            name: "target_frame_rate".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.text_anti_aliasing
    ///
    /// Font anti aliasing level
    pub static text_anti_aliasing: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3199.into(), CommonMetricData {
            name: "text_anti_aliasing".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.timezone
    ///
    /// The the current timezone of the system
    pub static timezone: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3200.into(), CommonMetricData {
            name: "timezone".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.use_document_colors
    ///
    /// This is the derived PreferenceSheet::Prefs::mUseDocumentColors value.
    pub static use_document_colors: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3201.into(), CommonMetricData {
            name: "use_document_colors".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.video_dynamic_range
    ///
    /// What LookAndFeel(VideoDynamicRange) reports. Note that CSSVideoDynamicRange has
    /// an additional dependency on Color Depth.
    pub static video_dynamic_range: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3202.into(), CommonMetricData {
            name: "video_dynamic_range".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices
    ///
    /// Available speechSynthesis voices.
    pub static voices: Lazy<TextMetric> = Lazy::new(|| {
        TextMetric::new(3203.into(), CommonMetricData {
            name: "voices".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.zoom_count
    ///
    /// Number of domains the users has a non-default zoom level.
    pub static zoom_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3204.into(), CommonMetricData {
            name: "zoom_count".into(),
            category: "characteristics".into(),
            send_in_pings: vec!["user-characteristics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod fingerprinting_protection {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from fingerprinting.protection.canvas_noise_calculate_time
    ///
    /// Counts how long to generate canvas random noises.
    pub static canvas_noise_calculate_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(3205.into(), CommonMetricData {
            name: "canvas_noise_calculate_time".into(),
            category: "fingerprinting.protection".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod search_engine_default {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangedExtra {
        pub change_source: Option<String>,
        pub new_display_name: Option<String>,
        pub new_engine_id: Option<String>,
        pub new_load_path: Option<String>,
        pub new_submission_url: Option<String>,
        pub previous_engine_id: Option<String>,
    }

    impl ExtraKeys for ChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["change_source", "new_display_name", "new_engine_id", "new_load_path", "new_submission_url", "previous_engine_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.change_source.and_then(|val| map.insert("change_source".into(), val.to_string()));
          self.new_display_name.and_then(|val| map.insert("new_display_name".into(), val.to_string()));
          self.new_engine_id.and_then(|val| map.insert("new_engine_id".into(), val.to_string()));
          self.new_load_path.and_then(|val| map.insert("new_load_path".into(), val.to_string()));
          self.new_submission_url.and_then(|val| map.insert("new_submission_url".into(), val.to_string()));
          self.previous_engine_id.and_then(|val| map.insert("previous_engine_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.changed
    ///
    /// Recorded when the default search engine is changed.
    pub static changed: Lazy<EventMetric<ChangedExtra>> = Lazy::new(|| {
        EventMetric::new(3206.into(), CommonMetricData {
            name: "changed".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.display_name
    ///
    /// The display name of the user's default engine.
    pub static display_name: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3207.into(), CommonMetricData {
            name: "display_name".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.engine_id
    ///
    /// The telemetry id of the search engine.
    /// For application provided engines, this is either supplied by the
    /// configuration or from the first part of the associated WebExtension Id.
    /// For other engines, this is `other-<extensionName>`.
    pub static engine_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3208.into(), CommonMetricData {
            name: "engine_id".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into(), "newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.load_path
    ///
    /// A path relating to where the search engine was installed/loaded from.
    /// For example:
    ///   `[addon]<extension id>` for a WebExtension based
    ///   engine.
    ///   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
    ///   engine.
    /// Note: this metric is truncated at 100 characters.
    pub static load_path: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3209.into(), CommonMetricData {
            name: "load_path".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.submission_url
    ///
    /// The submission URL of the default engine. This is only reported in the
    /// cases where:
    ///   The engine is an application provided engine.
    ///   The engine has the same name as an application provided engine.
    ///   The engine matches one of a specific list of well known search engines.
    pub static submission_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(3210.into(), CommonMetricData {
            name: "submission_url".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.verified
    ///
    /// The verified status of the search engine.
    /// For application provided engines, this will always be `default`.
    /// For other engines this will either be `verified` or `unverified` depending
    /// on if the loadPathHash is valid.
    pub static verified: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3211.into(), CommonMetricData {
            name: "verified".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod search_engine_private {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangedExtra {
        pub change_source: Option<String>,
        pub new_display_name: Option<String>,
        pub new_engine_id: Option<String>,
        pub new_load_path: Option<String>,
        pub new_submission_url: Option<String>,
        pub previous_engine_id: Option<String>,
    }

    impl ExtraKeys for ChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["change_source", "new_display_name", "new_engine_id", "new_load_path", "new_submission_url", "previous_engine_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.change_source.and_then(|val| map.insert("change_source".into(), val.to_string()));
          self.new_display_name.and_then(|val| map.insert("new_display_name".into(), val.to_string()));
          self.new_engine_id.and_then(|val| map.insert("new_engine_id".into(), val.to_string()));
          self.new_load_path.and_then(|val| map.insert("new_load_path".into(), val.to_string()));
          self.new_submission_url.and_then(|val| map.insert("new_submission_url".into(), val.to_string()));
          self.previous_engine_id.and_then(|val| map.insert("previous_engine_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.changed
    ///
    /// Recorded when the default search engine is changed
    pub static changed: Lazy<EventMetric<ChangedExtra>> = Lazy::new(|| {
        EventMetric::new(3212.into(), CommonMetricData {
            name: "changed".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.display_name
    ///
    /// The display name of the user's default engine.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static display_name: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3213.into(), CommonMetricData {
            name: "display_name".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.engine_id
    ///
    /// The telemetry id of the search engine.
    /// For application provided engines, this is either supplied by the
    /// configuration or from the first part of the associated WebExtension Id.
    /// For other engines, this is `other-<extensionName>`.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static engine_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3214.into(), CommonMetricData {
            name: "engine_id".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into(), "newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.load_path
    ///
    /// A path relating to where the search engine was installed/loaded from.
    /// For example:
    ///   `[addon]<extension id>` for a WebExtension based
    ///   engine.
    ///   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
    ///   engine.
    /// Note: this metric is truncated at 100 characters.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static load_path: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3215.into(), CommonMetricData {
            name: "load_path".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.submission_url
    ///
    /// The submission URL of the default engine. This is only reported in the
    /// cases where:
    ///   The engine is an application provided engine.
    ///   The engine has the same name as an application provided engine.
    ///   The engine matches one of a specific list of well known search engines.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static submission_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(3216.into(), CommonMetricData {
            name: "submission_url".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.verified
    ///
    /// The verified status of the search engine.
    /// For application provided engines, this will always be `default`.
    /// For other engines this will either be `verified` or `unverified` depending
    /// on if the loadPathHash is valid.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static verified: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3217.into(), CommonMetricData {
            name: "verified".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod search_service {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum InitializationStatusLabel {
        EFailedsettings = 0,
        EFailedfetchengines = 1,
        EFailedloadengines = 2,
        ESuccess = 3,
        __Other__,
    }
    impl From<u16> for InitializationStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFailedsettings,
                1 => Self::EFailedfetchengines,
                2 => Self::EFailedloadengines,
                3 => Self::ESuccess,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for InitializationStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFailedsettings => "failedSettings",
                Self::EFailedfetchengines => "failedFetchEngines",
                Self::EFailedloadengines => "failedLoadEngines",
                Self::ESuccess => "success",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.service.initialization_status
    ///
    /// Counts the type of initialization statuses on start up.
    /// failedSettings - failed loading and migrating the search settings file.
    /// failedFetchEngines - failed to load or parse the configuration from remote
    ///                      settings.
    /// failedLoadEngines - failed to create all the search engines from the
    ///                     configuration or user installed engines.
    /// success - search service successfully initialized.
    pub static initialization_status: Lazy<LabeledMetric<LabeledCounterMetric, InitializationStatusLabel>> = Lazy::new(|| {
        LabeledMetric::new(3218.into(), CommonMetricData {
            name: "initialization_status".into(),
            category: "search.service".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("failedFetchEngines"), ::std::borrow::Cow::from("failedLoadEngines"), ::std::borrow::Cow::from("failedSettings"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.service.startup_time
    ///
    /// The time duration it takes for the search service to start up.
    pub static startup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(3219.into(), CommonMetricData {
            name: "startup_time".into(),
            category: "search.service".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

}
pub mod shopping_product {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.invalid_ohttp_config
    ///
    /// OHTTP was configured for shopping but the config is invalid.
    pub static invalid_ohttp_config: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3220.into(), CommonMetricData {
            name: "invalid_ohttp_config".into(),
            category: "shopping_product".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.invalid_request
    ///
    /// An invalid JSON request was sent to the Fakespot API.
    pub static invalid_request: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3221.into(), CommonMetricData {
            name: "invalid_request".into(),
            category: "shopping_product".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.invalid_response
    ///
    /// An invalid JSON response was received from the Fakespot API.
    pub static invalid_response: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3222.into(), CommonMetricData {
            name: "invalid_response".into(),
            category: "shopping_product".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_aborted
    ///
    /// Request to the Fakespot API was aborted.
    pub static request_aborted: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3223.into(), CommonMetricData {
            name: "request_aborted".into(),
            category: "shopping_product".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_error
    ///
    /// There was an error requesting the Fakespot API.
    pub static request_error: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3224.into(), CommonMetricData {
            name: "request_error".into(),
            category: "shopping_product".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_failure
    ///
    /// There was a failure with the request to the Fakespot API.
    pub static request_failure: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3225.into(), CommonMetricData {
            name: "request_failure".into(),
            category: "shopping_product".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_retried
    ///
    /// Status returned a 500 error when requesting the Fakespot API
    /// and will be retried.
    pub static request_retried: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3226.into(), CommonMetricData {
            name: "request_retried".into(),
            category: "shopping_product".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_retries_failed
    ///
    /// Request still failed after the maxiumn number of
    /// retry events.
    pub static request_retries_failed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3227.into(), CommonMetricData {
            name: "request_retries_failed".into(),
            category: "shopping_product".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.server_failure
    ///
    /// There was a Fakespot API server issue that prevented
    /// the request from succeeding.
    pub static server_failure: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(3228.into(), CommonMetricData {
            name: "server_failure".into(),
            category: "shopping_product".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod dap {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ReportGenerationStatusLabel {
        ESuccess = 0,
        EFailure = 1,
        EAbort = 2,
        EHpkeLeaderFail = 3,
        EHpkeHelperFail = 4,
        __Other__,
    }
    impl From<u16> for ReportGenerationStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                2 => Self::EAbort,
                3 => Self::EHpkeLeaderFail,
                4 => Self::EHpkeHelperFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ReportGenerationStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::EAbort => "abort",
                Self::EHpkeLeaderFail => "hpke_leader_fail",
                Self::EHpkeHelperFail => "hpke_helper_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dap.report_generation_status
    ///
    /// The result of trying to generate a DAP report.
    pub static report_generation_status: Lazy<LabeledMetric<LabeledCounterMetric, ReportGenerationStatusLabel>> = Lazy::new(|| {
        LabeledMetric::new(3229.into(), CommonMetricData {
            name: "report_generation_status".into(),
            category: "dap".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("abort"), ::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("hpke_helper_fail"), ::std::borrow::Cow::from("hpke_leader_fail"), ::std::borrow::Cow::from("success")]))
    });

    #[repr(u16)]
    pub enum UploadStatusLabel {
        ESuccess = 0,
        EFailure = 1,
        EHttpError = 2,
        EHttp502 = 3,
        EAbort = 4,
        EAbortTimed = 5,
        EAbortShutdown = 6,
        __Other__,
    }
    impl From<u16> for UploadStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                2 => Self::EHttpError,
                3 => Self::EHttp502,
                4 => Self::EAbort,
                5 => Self::EAbortTimed,
                6 => Self::EAbortShutdown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for UploadStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::EHttpError => "http_error",
                Self::EHttp502 => "http_502",
                Self::EAbort => "abort",
                Self::EAbortTimed => "abort_timed",
                Self::EAbortShutdown => "abort_shutdown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dap.upload_status
    ///
    /// The result of trying to upload a report to the DAP server.
    pub static upload_status: Lazy<LabeledMetric<LabeledCounterMetric, UploadStatusLabel>> = Lazy::new(|| {
        LabeledMetric::new(3230.into(), CommonMetricData {
            name: "upload_status".into(),
            category: "dap".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("abort"), ::std::borrow::Cow::from("abort_shutdown"), ::std::borrow::Cow::from("abort_timed"), ::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("http_502"), ::std::borrow::Cow::from("http_error"), ::std::borrow::Cow::from("success")]))
    });

}
pub mod legacy_telemetry {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from legacy.telemetry.client_id
    ///
    /// The client_id according to Telemetry.
    /// Might not always have a value due to being too early for it to have
    /// loaded.
    /// Value may be the canary client id `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
    /// in pings near when the data upload pref is disabled (if Telemetry gets
    /// to go first), or between when a client_id has been removed and when it
    /// has been regenerated.
    /// Does not need to be sent in the Glean "deletion-request" ping.
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(3231.into(), CommonMetricData {
            name: "client_id".into(),
            category: "legacy.telemetry".into(),
            send_in_pings: vec!["baseline".into(), "events".into(), "metrics".into(), "newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod translations {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ErrorExtra {
        pub flow_id: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for ErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.error
    ///
    /// The specific translations error that caused a full_page translation failure.
    pub static error: Lazy<EventMetric<ErrorExtra>> = Lazy::new(|| {
        EventMetric::new(3232.into(), CommonMetricData {
            name: "error".into(),
            category: "translations".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from translations.error_rate
    ///
    /// The rate of failed translations requests.
    pub static error_rate: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(3233.into(), CommonMetricData {
            name: "error_rate".into(),
            category: "translations".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[repr(u16)]
    pub enum RequestCountLabel {
        EFullPage = 0,
        ESelect = 1,
        __Other__,
    }
    impl From<u16> for RequestCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFullPage,
                1 => Self::ESelect,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RequestCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFullPage => "full_page",
                Self::ESelect => "select",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.request_count
    ///
    /// The count of translation requests, along with their type.
    pub static request_count: Lazy<LabeledMetric<LabeledCounterMetric, RequestCountLabel>> = Lazy::new(|| {
        LabeledMetric::new(3234.into(), CommonMetricData {
            name: "request_count".into(),
            category: "translations".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("full_page"), ::std::borrow::Cow::from("select")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from translations.requests_count
    ///
    /// The count of translation requests.
    pub static requests_count: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(3235.into(), CommonMetricData {
            name: "requests_count".into(),
            category: "translations".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "error_rate".into(), category: "translations".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct RestorePageExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for RestorePageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.restore_page
    ///
    /// Triggers when the a restore-page event is triggered.
    pub static restore_page: Lazy<EventMetric<RestorePageExtra>> = Lazy::new(|| {
        EventMetric::new(3236.into(), CommonMetricData {
            name: "restore_page".into(),
            category: "translations".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TranslationRequestExtra {
        pub auto_translate: Option<bool>,
        pub document_language: Option<String>,
        pub flow_id: Option<String>,
        pub from_language: Option<String>,
        pub request_target: Option<String>,
        pub source_text_code_units: Option<u32>,
        pub source_text_word_count: Option<u32>,
        pub to_language: Option<String>,
        pub top_preferred_language: Option<String>,
    }

    impl ExtraKeys for TranslationRequestExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["auto_translate", "document_language", "flow_id", "from_language", "request_target", "source_text_code_units", "source_text_word_count", "to_language", "top_preferred_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.auto_translate.and_then(|val| map.insert("auto_translate".into(), val.to_string()));
          self.document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.request_target.and_then(|val| map.insert("request_target".into(), val.to_string()));
          self.source_text_code_units.and_then(|val| map.insert("source_text_code_units".into(), val.to_string()));
          self.source_text_word_count.and_then(|val| map.insert("source_text_word_count".into(), val.to_string()));
          self.to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          self.top_preferred_language.and_then(|val| map.insert("top_preferred_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.translation_request
    ///
    /// Triggers when a full-page translation request is sent.
    pub static translation_request: Lazy<EventMetric<TranslationRequestExtra>> = Lazy::new(|| {
        EventMetric::new(3237.into(), CommonMetricData {
            name: "translation_request".into(),
            category: "translations".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod translations_panel {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AboutTranslationsExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for AboutTranslationsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.about_translations
    ///
    /// Triggers when the about-translations menuitem is invoked in the full-page
    /// translations panel settings.
    pub static about_translations: Lazy<EventMetric<AboutTranslationsExtra>> = Lazy::new(|| {
        EventMetric::new(3238.into(), CommonMetricData {
            name: "about_translations".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AlwaysOfferTranslationsExtra {
        pub flow_id: Option<String>,
        pub toggled_on: Option<bool>,
    }

    impl ExtraKeys for AlwaysOfferTranslationsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.always_offer_translations
    ///
    /// Triggers when the always-offer-translations menuitem is invoked in the full-
    /// page translations panel seeings.
    pub static always_offer_translations: Lazy<EventMetric<AlwaysOfferTranslationsExtra>> = Lazy::new(|| {
        EventMetric::new(3239.into(), CommonMetricData {
            name: "always_offer_translations".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AlwaysTranslateLanguageExtra {
        pub flow_id: Option<String>,
        pub language: Option<String>,
        pub toggled_on: Option<bool>,
    }

    impl ExtraKeys for AlwaysTranslateLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.language.and_then(|val| map.insert("language".into(), val.to_string()));
          self.toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.always_translate_language
    ///
    /// Triggers when the always-translate-language menuitem is invoked in the full-
    /// page translations panel settings.
    pub static always_translate_language: Lazy<EventMetric<AlwaysTranslateLanguageExtra>> = Lazy::new(|| {
        EventMetric::new(3240.into(), CommonMetricData {
            name: "always_translate_language".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CancelButtonExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for CancelButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.cancel_button
    ///
    /// Triggers when the cancel button is invoked in the full-page translations panel.
    pub static cancel_button: Lazy<EventMetric<CancelButtonExtra>> = Lazy::new(|| {
        EventMetric::new(3241.into(), CommonMetricData {
            name: "cancel_button".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangeFromLanguageExtra {
        pub flow_id: Option<String>,
        pub language: Option<String>,
    }

    impl ExtraKeys for ChangeFromLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.language.and_then(|val| map.insert("language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.change_from_language
    ///
    /// Triggers when the from-language selected value is changed.
    pub static change_from_language: Lazy<EventMetric<ChangeFromLanguageExtra>> = Lazy::new(|| {
        EventMetric::new(3242.into(), CommonMetricData {
            name: "change_from_language".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangeSourceLanguageButtonExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for ChangeSourceLanguageButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.change_source_language_button
    ///
    /// Triggers when the change-source-language button is invoked in the full-page
    /// translations panel.
    pub static change_source_language_button: Lazy<EventMetric<ChangeSourceLanguageButtonExtra>> = Lazy::new(|| {
        EventMetric::new(3243.into(), CommonMetricData {
            name: "change_source_language_button".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangeToLanguageExtra {
        pub flow_id: Option<String>,
        pub language: Option<String>,
    }

    impl ExtraKeys for ChangeToLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.language.and_then(|val| map.insert("language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.change_to_language
    ///
    /// Triggers when the to-language selected value is changed.
    pub static change_to_language: Lazy<EventMetric<ChangeToLanguageExtra>> = Lazy::new(|| {
        EventMetric::new(3244.into(), CommonMetricData {
            name: "change_to_language".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CloseExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for CloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close
    ///
    /// Triggers when full-page translations panel is closed.
    pub static close: Lazy<EventMetric<CloseExtra>> = Lazy::new(|| {
        EventMetric::new(3245.into(), CommonMetricData {
            name: "close".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CloseFromLanguageMenuExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for CloseFromLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close_from_language_menu
    ///
    /// Triggers when the from-language dropdown is closed in the full-page
    /// translations panel.
    pub static close_from_language_menu: Lazy<EventMetric<CloseFromLanguageMenuExtra>> = Lazy::new(|| {
        EventMetric::new(3246.into(), CommonMetricData {
            name: "close_from_language_menu".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CloseSettingsMenuExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for CloseSettingsMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close_settings_menu
    ///
    /// Triggers when the settings menu is closed in the full-page translations panel.
    pub static close_settings_menu: Lazy<EventMetric<CloseSettingsMenuExtra>> = Lazy::new(|| {
        EventMetric::new(3247.into(), CommonMetricData {
            name: "close_settings_menu".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CloseToLanguageMenuExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for CloseToLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close_to_language_menu
    ///
    /// Triggers when the from-language dropdown is closed in the full-page
    /// translations panel.
    pub static close_to_language_menu: Lazy<EventMetric<CloseToLanguageMenuExtra>> = Lazy::new(|| {
        EventMetric::new(3248.into(), CommonMetricData {
            name: "close_to_language_menu".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct DismissErrorButtonExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for DismissErrorButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.dismiss_error_button
    ///
    /// Triggers when the dismiss-error button is invoked in the full-page translations
    /// panel.
    pub static dismiss_error_button: Lazy<EventMetric<DismissErrorButtonExtra>> = Lazy::new(|| {
        EventMetric::new(3249.into(), CommonMetricData {
            name: "dismiss_error_button".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct LearnMoreExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for LearnMoreExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.learn_more
    ///
    /// Triggers when the learn-more link is invoked in the full-page translations
    /// panel first interaction.
    pub static learn_more: Lazy<EventMetric<LearnMoreExtra>> = Lazy::new(|| {
        EventMetric::new(3250.into(), CommonMetricData {
            name: "learn_more".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ManageLanguagesExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for ManageLanguagesExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.manage_languages
    ///
    /// Triggers when the manage-languages menuitem is invoked in the full-page
    /// translations panel settings.
    pub static manage_languages: Lazy<EventMetric<ManageLanguagesExtra>> = Lazy::new(|| {
        EventMetric::new(3251.into(), CommonMetricData {
            name: "manage_languages".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct NeverTranslateLanguageExtra {
        pub flow_id: Option<String>,
        pub language: Option<String>,
        pub toggled_on: Option<bool>,
    }

    impl ExtraKeys for NeverTranslateLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.language.and_then(|val| map.insert("language".into(), val.to_string()));
          self.toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.never_translate_language
    ///
    /// Triggers when the never-translate-language menuitem is invoked in the full-page
    /// translations panel settings.
    pub static never_translate_language: Lazy<EventMetric<NeverTranslateLanguageExtra>> = Lazy::new(|| {
        EventMetric::new(3252.into(), CommonMetricData {
            name: "never_translate_language".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct NeverTranslateSiteExtra {
        pub flow_id: Option<String>,
        pub toggled_on: Option<bool>,
    }

    impl ExtraKeys for NeverTranslateSiteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.never_translate_site
    ///
    /// Triggers when the never-translate-site menuitem is invoked in the full-page
    /// translations panel settings.
    pub static never_translate_site: Lazy<EventMetric<NeverTranslateSiteExtra>> = Lazy::new(|| {
        EventMetric::new(3253.into(), CommonMetricData {
            name: "never_translate_site".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenExtra {
        pub auto_show: Option<bool>,
        pub document_language: Option<String>,
        pub flow_id: Option<String>,
        pub opened_from: Option<String>,
        pub view_name: Option<String>,
    }

    impl ExtraKeys for OpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["auto_show", "document_language", "flow_id", "opened_from", "view_name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.auto_show.and_then(|val| map.insert("auto_show".into(), val.to_string()));
          self.document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.opened_from.and_then(|val| map.insert("opened_from".into(), val.to_string()));
          self.view_name.and_then(|val| map.insert("view_name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open
    ///
    /// Triggers when the full-page translations panel is opened.
    pub static open: Lazy<EventMetric<OpenExtra>> = Lazy::new(|| {
        EventMetric::new(3254.into(), CommonMetricData {
            name: "open".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenFromLanguageMenuExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for OpenFromLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open_from_language_menu
    ///
    /// Triggers when the from-language dropdown is opened in the full-page
    /// translations panel.
    pub static open_from_language_menu: Lazy<EventMetric<OpenFromLanguageMenuExtra>> = Lazy::new(|| {
        EventMetric::new(3255.into(), CommonMetricData {
            name: "open_from_language_menu".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenSettingsMenuExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for OpenSettingsMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open_settings_menu
    ///
    /// Triggers when the settings menu is opened in the full-page translations panel.
    pub static open_settings_menu: Lazy<EventMetric<OpenSettingsMenuExtra>> = Lazy::new(|| {
        EventMetric::new(3256.into(), CommonMetricData {
            name: "open_settings_menu".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenToLanguageMenuExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for OpenToLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open_to_language_menu
    ///
    /// Triggers when the from-language dropdown is opened in the full-page
    /// translations panel.
    pub static open_to_language_menu: Lazy<EventMetric<OpenToLanguageMenuExtra>> = Lazy::new(|| {
        EventMetric::new(3257.into(), CommonMetricData {
            name: "open_to_language_menu".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct RestorePageButtonExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for RestorePageButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.restore_page_button
    ///
    /// Triggers when the restore-page button is invoked in the full-page translations
    /// panel.
    pub static restore_page_button: Lazy<EventMetric<RestorePageButtonExtra>> = Lazy::new(|| {
        EventMetric::new(3258.into(), CommonMetricData {
            name: "restore_page_button".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TranslateButtonExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for TranslateButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.translate_button
    ///
    /// Triggers when the translate button is invoked in the full-page translations
    /// panel.
    pub static translate_button: Lazy<EventMetric<TranslateButtonExtra>> = Lazy::new(|| {
        EventMetric::new(3259.into(), CommonMetricData {
            name: "translate_button".into(),
            category: "translations.panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod translations_select_translations_panel {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AboutTranslationsExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for AboutTranslationsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.about_translations
    ///
    /// Triggers when the about-translations menuitem is invoked in the select
    /// translations panel settings.
    pub static about_translations: Lazy<EventMetric<AboutTranslationsExtra>> = Lazy::new(|| {
        EventMetric::new(3260.into(), CommonMetricData {
            name: "about_translations".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CancelButtonExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for CancelButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.cancel_button
    ///
    /// Triggers when the cancel button is invoked in the select translations panel.
    pub static cancel_button: Lazy<EventMetric<CancelButtonExtra>> = Lazy::new(|| {
        EventMetric::new(3261.into(), CommonMetricData {
            name: "cancel_button".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangeFromLanguageExtra {
        pub document_language: Option<String>,
        pub flow_id: Option<String>,
        pub language: Option<String>,
        pub previous_language: Option<String>,
    }

    impl ExtraKeys for ChangeFromLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["document_language", "flow_id", "language", "previous_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.language.and_then(|val| map.insert("language".into(), val.to_string()));
          self.previous_language.and_then(|val| map.insert("previous_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.change_from_language
    ///
    /// Triggers when the from-language selected value is changed.
    pub static change_from_language: Lazy<EventMetric<ChangeFromLanguageExtra>> = Lazy::new(|| {
        EventMetric::new(3262.into(), CommonMetricData {
            name: "change_from_language".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangeToLanguageExtra {
        pub flow_id: Option<String>,
        pub language: Option<String>,
    }

    impl ExtraKeys for ChangeToLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.language.and_then(|val| map.insert("language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.change_to_language
    ///
    /// Triggers when the to-language selected value is changed.
    pub static change_to_language: Lazy<EventMetric<ChangeToLanguageExtra>> = Lazy::new(|| {
        EventMetric::new(3263.into(), CommonMetricData {
            name: "change_to_language".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CloseExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for CloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.close
    ///
    /// Triggers when the select translations panel is closed.
    pub static close: Lazy<EventMetric<CloseExtra>> = Lazy::new(|| {
        EventMetric::new(3264.into(), CommonMetricData {
            name: "close".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct CopyButtonExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for CopyButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.copy_button
    ///
    /// Triggers when the copy button is invoked in the select translations panel.
    pub static copy_button: Lazy<EventMetric<CopyButtonExtra>> = Lazy::new(|| {
        EventMetric::new(3265.into(), CommonMetricData {
            name: "copy_button".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct DoneButtonExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for DoneButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.done_button
    ///
    /// Triggers when the done button is invoked in the select translations panel.
    pub static done_button: Lazy<EventMetric<DoneButtonExtra>> = Lazy::new(|| {
        EventMetric::new(3266.into(), CommonMetricData {
            name: "done_button".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct InitializationFailureMessageExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for InitializationFailureMessageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.initialization_failure_message
    ///
    /// Triggers when the initialization-failure message is shown in the select
    /// translations panel.
    pub static initialization_failure_message: Lazy<EventMetric<InitializationFailureMessageExtra>> = Lazy::new(|| {
        EventMetric::new(3267.into(), CommonMetricData {
            name: "initialization_failure_message".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenExtra {
        pub document_language: Option<String>,
        pub flow_id: Option<String>,
        pub from_language: Option<String>,
        pub text_source: Option<String>,
        pub to_language: Option<String>,
        pub top_preferred_language: Option<String>,
    }

    impl ExtraKeys for OpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["document_language", "flow_id", "from_language", "text_source", "to_language", "top_preferred_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.text_source.and_then(|val| map.insert("text_source".into(), val.to_string()));
          self.to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          self.top_preferred_language.and_then(|val| map.insert("top_preferred_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.open
    ///
    /// Triggers when the select translations panel is opened.
    pub static open: Lazy<EventMetric<OpenExtra>> = Lazy::new(|| {
        EventMetric::new(3268.into(), CommonMetricData {
            name: "open".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenSettingsMenuExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for OpenSettingsMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.open_settings_menu
    ///
    /// Triggers when the settings menu is opened in the select translations panel.
    pub static open_settings_menu: Lazy<EventMetric<OpenSettingsMenuExtra>> = Lazy::new(|| {
        EventMetric::new(3269.into(), CommonMetricData {
            name: "open_settings_menu".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TranslateButtonExtra {
        pub detected_language: Option<String>,
        pub flow_id: Option<String>,
        pub from_language: Option<String>,
        pub to_language: Option<String>,
    }

    impl ExtraKeys for TranslateButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["detected_language", "flow_id", "from_language", "to_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.detected_language.and_then(|val| map.insert("detected_language".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translate_button
    ///
    /// Triggers when the translate button is invoked in the select translations panel.
    pub static translate_button: Lazy<EventMetric<TranslateButtonExtra>> = Lazy::new(|| {
        EventMetric::new(3270.into(), CommonMetricData {
            name: "translate_button".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TranslateFullPageButtonExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for TranslateFullPageButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translate_full_page_button
    ///
    /// Triggers when the translate-full-page button is invoked in the select
    /// translations panel.
    pub static translate_full_page_button: Lazy<EventMetric<TranslateFullPageButtonExtra>> = Lazy::new(|| {
        EventMetric::new(3271.into(), CommonMetricData {
            name: "translate_full_page_button".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TranslationFailureMessageExtra {
        pub flow_id: Option<String>,
        pub from_language: Option<String>,
        pub to_language: Option<String>,
    }

    impl ExtraKeys for TranslationFailureMessageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "from_language", "to_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translation_failure_message
    ///
    /// Triggers when the translation-failure message is shown in the select
    /// translations panel.
    pub static translation_failure_message: Lazy<EventMetric<TranslationFailureMessageExtra>> = Lazy::new(|| {
        EventMetric::new(3272.into(), CommonMetricData {
            name: "translation_failure_message".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TranslationSettingsExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for TranslationSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translation_settings
    ///
    /// Triggers when the translation-settings menuitem is invoked in the select
    /// translations panel settings.
    pub static translation_settings: Lazy<EventMetric<TranslationSettingsExtra>> = Lazy::new(|| {
        EventMetric::new(3273.into(), CommonMetricData {
            name: "translation_settings".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TryAgainButtonExtra {
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for TryAgainButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.try_again_button
    ///
    /// Triggers when the try-again button is invoked in the select translations panel.
    pub static try_again_button: Lazy<EventMetric<TryAgainButtonExtra>> = Lazy::new(|| {
        EventMetric::new(3274.into(), CommonMetricData {
            name: "try_again_button".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct UnsupportedLanguageMessageExtra {
        pub detected_language: Option<String>,
        pub document_language: Option<String>,
        pub flow_id: Option<String>,
    }

    impl ExtraKeys for UnsupportedLanguageMessageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["detected_language", "document_language", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.detected_language.and_then(|val| map.insert("detected_language".into(), val.to_string()));
          self.document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.unsupported_language_message
    ///
    /// Triggers when the unsupported-language message is shown in the select
    /// translations panel.
    pub static unsupported_language_message: Lazy<EventMetric<UnsupportedLanguageMessageExtra>> = Lazy::new(|| {
        EventMetric::new(3275.into(), CommonMetricData {
            name: "unsupported_language_message".into(),
            category: "translations.select_translations_panel".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod first_startup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.delete_tasks_time
    ///
    /// Number of milliseconds until TaskScheduler.deleteAllTasks resolved in
    /// FirstStartup.
    pub static delete_tasks_time: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3276.into(), CommonMetricData {
            name: "delete_tasks_time".into(),
            category: "first_startup".into(),
            send_in_pings: vec!["first-startup".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.elapsed
    ///
    /// Number of milliseconds the FirstStartup service took to run.
    pub static elapsed: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3277.into(), CommonMetricData {
            name: "elapsed".into(),
            category: "first_startup".into(),
            send_in_pings: vec!["first-startup".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.new_profile
    ///
    /// True if FirstStartup was initted after a new profile was just created. If
    /// false, this means that FirstStartup was initted with a pre-existing profile,
    /// which is a no-op.
    pub static new_profile: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3278.into(), CommonMetricData {
            name: "new_profile".into(),
            category: "first_startup".into(),
            send_in_pings: vec!["first-startup".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.normandy_init_time
    ///
    /// Number of milliseconds until Normandy.init resolved in FirstStartup.
    pub static normandy_init_time: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3279.into(), CommonMetricData {
            name: "normandy_init_time".into(),
            category: "first_startup".into(),
            send_in_pings: vec!["first-startup".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.status_code
    ///
    /// Status of the FirstStartup service, which runs
    /// post-install/early-startup in Firefox.
    pub static status_code: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(3280.into(), CommonMetricData {
            name: "status_code".into(),
            category: "first_startup".into(),
            send_in_pings: vec!["first-startup".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod notification {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from notification.action
    ///
    /// The action that the user took in response to the notification. Possible values
    /// currently include the following: * “dismissed-by-timeout” * “dismissed-to-
    /// action-center” * “dismissed-by-button” * “dismissed-by-application-hidden” *
    /// “make-firefox-default-button” * “toast-clicked”
    /// Many of the values correspond to buttons on the notification and should be
    /// pretty self explanatory, but a few are less so. * “dismissed-to-action-center”
    /// will be used if the user clicks the arrow in
    ///   the top right corner of the notification to dismiss it to the
    ///   action center.
    /// * “dismissed-by-application-hidden” is provided because that is a method of
    ///   dismissal that the notification API could give but, in practice, should
    ///   never be seen.
    /// * “dismissed-by-timeout” indicates that the user did not interact with the
    ///   notification and it timed out.
    pub static action: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3281.into(), CommonMetricData {
            name: "action".into(),
            category: "notification".into(),
            send_in_pings: vec!["default-agent".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from notification.show_success
    ///
    /// Whether a notification was shown or not. Possible value include "shown" and
    /// "error".
    pub static show_success: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3282.into(), CommonMetricData {
            name: "show_success".into(),
            category: "notification".into(),
            send_in_pings: vec!["default-agent".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod system {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from system.os_version
    ///
    /// The current Windows OS version, usually as a dotted quad ("x.y.z.w") with
    /// Windows Update Build Revision (UBR), but potentially as a dotted triple
    /// ("x.y.z") without UBR.
    pub static os_version: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3283.into(), CommonMetricData {
            name: "os_version".into(),
            category: "system".into(),
            send_in_pings: vec!["default-agent".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.previous_os_version
    ///
    /// The Windows OS version before it was changed to the current setting. The
    /// possible values are the same as for `system.os_version`.
    /// The OS does not keep track of the previous OS version, so the agent records
    /// this information itself. That means that it will be inaccurate until the first
    /// time the default is changed after the agent task begins running. Before then,
    /// the value of `previous_os_version` will be the same as `os_version`.
    /// This value is updated every time the Default Agent runs, so when the default
    /// browser is first changed the values for `os_version` and `previous_os_version`
    /// will be different. But on subsequent executions of the Default Agent, the two
    /// values will be the same.
    pub static previous_os_version: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3284.into(), CommonMetricData {
            name: "previous_os_version".into(),
            category: "system".into(),
            send_in_pings: vec!["default-agent".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod system_default {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from system_default.browser
    ///
    /// Which browser is currently set as the system default web browser. This is
    /// simply a string with the name of the browser binned to a fixed set of known
    /// browsers.
    /// Possible values currently include the following (from
    /// [DefaultBrowser.cpp](https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/defaultagent/DefaultBrowser.cpp)): * "error" *
    /// "" (unknown) * "firefox" * "chrome" * "edge" * "edge-chrome" * "ie" * "opera" *
    /// "brave" * "yandex" * "qq-browser" * "360-browser" * "sogou" * "duckduckgo"
    pub static browser: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3285.into(), CommonMetricData {
            name: "browser".into(),
            category: "system_default".into(),
            send_in_pings: vec!["default-agent".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from system_default.pdf_handler
    ///
    /// Which pdf handler is currently set as the system default handler. This is
    /// simply a string with the name of the handler binned to a fixed set of known
    /// handlers.
    /// Possible values currently include the following (from
    /// [DefaultPDF.cpp](https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/defaultagent/DefaultPDF.cpp)): * "Error" * ""
    /// (unknown) * "Firefox" * "Microsoft Edge" * "Google Chrome" * "Adobe Acrobat" *
    /// "WPS" * "Nitro" * "Foxit" * "PDF-XChange" * "Avast" * "Sumatra"
    pub static pdf_handler: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3286.into(), CommonMetricData {
            name: "pdf_handler".into(),
            category: "system_default".into(),
            send_in_pings: vec!["default-agent".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from system_default.previous_browser
    ///
    /// Which browser was set as the system default before it was changed to the
    /// current setting. The possible values are the same as for
    /// `system_default.browser`.
    /// The OS does not keep track of previous default settings, so the agent records
    /// this information itself. That means that it will be inaccurate until the first
    /// time the default is changed after the agent task begins running. Before then,
    /// the value of `previous_browser` will be the same as `browser`.
    /// This value is updated every time the Default Agent runs, so when the default
    /// browser is first changed the values for `browser` and `previous_browser` will
    /// be different. But on subsequent executions of the Default Agent, the two values
    /// will be the same.
    pub static previous_browser: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3287.into(), CommonMetricData {
            name: "previous_browser".into(),
            category: "system_default".into(),
            send_in_pings: vec!["default-agent".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod addons_manager {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct InstallExtra {
        pub addon_id: Option<String>,
        pub addon_type: Option<String>,
        pub download_time: Option<u32>,
        pub error: Option<String>,
        pub install_id: Option<String>,
        pub install_origins: Option<String>,
        pub num_strings: Option<u32>,
        pub source: Option<String>,
        pub source_method: Option<String>,
        pub step: Option<String>,
        pub updated_from: Option<String>,
    }

    impl ExtraKeys for InstallExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "download_time", "error", "install_id", "install_origins", "num_strings", "source", "source_method", "step", "updated_from"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.install_id.and_then(|val| map.insert("install_id".into(), val.to_string()));
          self.install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.source_method.and_then(|val| map.insert("source_method".into(), val.to_string()));
          self.step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install
    ///
    /// These events are recorded during the install and update flow for
    /// extensions and themes.
    pub static install: Lazy<EventMetric<InstallExtra>> = Lazy::new(|| {
        EventMetric::new(3288.into(), CommonMetricData {
            name: "install".into(),
            category: "addons_manager".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct InstallStatsExtra {
        pub addon_id: Option<String>,
        pub addon_type: Option<String>,
        pub taar_based: Option<String>,
        pub utm_campaign: Option<String>,
        pub utm_content: Option<String>,
        pub utm_medium: Option<String>,
        pub utm_source: Option<String>,
    }

    impl ExtraKeys for InstallStatsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats
    ///
    /// These events are recorded at the end of the install flow, but only
    /// when the source that originally triggered the add-on installation
    /// is "amo", "rtamo" or "disco".
    pub static install_stats: Lazy<EventMetric<InstallStatsExtra>> = Lazy::new(|| {
        EventMetric::new(3289.into(), CommonMetricData {
            name: "install_stats".into(),
            category: "addons_manager".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ManageExtra {
        pub addon_id: Option<String>,
        pub addon_type: Option<String>,
        pub method: Option<String>,
        pub num_strings: Option<u32>,
        pub source: Option<String>,
        pub source_method: Option<String>,
    }

    impl ExtraKeys for ManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "method", "num_strings", "source", "source_method"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.source_method.and_then(|val| map.insert("source_method".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.manage
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled.
    pub static manage: Lazy<EventMetric<ManageExtra>> = Lazy::new(|| {
        EventMetric::new(3290.into(), CommonMetricData {
            name: "manage".into(),
            category: "addons_manager".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ReportSuspiciousSiteExtra {
        pub suspicious_site: Option<String>,
    }

    impl ExtraKeys for ReportSuspiciousSiteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["suspicious_site"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.suspicious_site.and_then(|val| map.insert("suspicious_site".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.report_suspicious_site
    ///
    /// Sent when a user clicks "Report Suspicious Site" on the dropdown
    /// menu of the third-party xpinstall doorhanger.
    pub static report_suspicious_site: Lazy<EventMetric<ReportSuspiciousSiteExtra>> = Lazy::new(|| {
        EventMetric::new(3291.into(), CommonMetricData {
            name: "report_suspicious_site".into(),
            category: "addons_manager".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct UpdateExtra {
        pub addon_id: Option<String>,
        pub addon_type: Option<String>,
        pub download_time: Option<u32>,
        pub error: Option<String>,
        pub install_id: Option<String>,
        pub install_origins: Option<String>,
        pub num_strings: Option<u32>,
        pub source: Option<String>,
        pub source_method: Option<String>,
        pub step: Option<String>,
        pub updated_from: Option<String>,
    }

    impl ExtraKeys for UpdateExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "download_time", "error", "install_id", "install_origins", "num_strings", "source", "source_method", "step", "updated_from"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.install_id.and_then(|val| map.insert("install_id".into(), val.to_string()));
          self.install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.source_method.and_then(|val| map.insert("source_method".into(), val.to_string()));
          self.step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update
    ///
    /// These events are recorded during the install and update flow for
    /// extensions and themes.
    pub static update: Lazy<EventMetric<UpdateExtra>> = Lazy::new(|| {
        EventMetric::new(3292.into(), CommonMetricData {
            name: "update".into(),
            category: "addons_manager".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod blocklist {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AddonBlockChangeExtra {
        pub addon_version: Option<String>,
        pub blocklist_state: Option<String>,
        pub hours_since: Option<String>,
        pub mlbf_generation: Option<String>,
        pub mlbf_last_time: Option<String>,
        pub mlbf_source: Option<String>,
        pub object: Option<String>,
        pub signed_date: Option<String>,
        pub value: Option<String>,
    }

    impl ExtraKeys for AddonBlockChangeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_version", "blocklist_state", "hours_since", "mlbf_generation", "mlbf_last_time", "mlbf_source", "object", "signed_date", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.hours_since.and_then(|val| map.insert("hours_since".into(), val.to_string()));
          self.mlbf_generation.and_then(|val| map.insert("mlbf_generation".into(), val.to_string()));
          self.mlbf_last_time.and_then(|val| map.insert("mlbf_last_time".into(), val.to_string()));
          self.mlbf_source.and_then(|val| map.insert("mlbf_source".into(), val.to_string()));
          self.object.and_then(|val| map.insert("object".into(), val.to_string()));
          self.signed_date.and_then(|val| map.insert("signed_date".into(), val.to_string()));
          self.value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from blocklist.addon_block_change
    ///
    /// An add-on is blocked, or an installed add-on is unblocked. When an add-on
    /// install/update is blocked, its installation is aborted and the add-on is no
    /// longer listed in the activeAddons field of TelemetryEnvironment.
    pub static addon_block_change: Lazy<EventMetric<AddonBlockChangeExtra>> = Lazy::new(|| {
        EventMetric::new(3293.into(), CommonMetricData {
            name: "addon_block_change".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.last_modified_rs_addons_mblf
    ///
    /// Keep track of the last time the "addons-bloomfilters" remotesetting blocklist
    /// has been successfully updated.
    pub static last_modified_rs_addons_mblf: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(3294.into(), CommonMetricData {
            name: "last_modified_rs_addons_mblf".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_generation_time
    ///
    /// Keep track of the generation time of the addon blocklist's bloom filter. This
    /// marks the point in time until which signed add-ons are recognized by the
    /// selected bloom filter from the addons-bloomfilters collection.
    pub static mlbf_generation_time: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(3295.into(), CommonMetricData {
            name: "mlbf_generation_time".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_source
    ///
    /// The source of the RemoteSettings attachment that holds the bloom filter.
    /// Possible values are "dump_match", "cache_match",
    /// "remote_match","dump_fallback", "cache_fallback", "unknown". "dump_match",
    /// "cache_match" and "remote_match" are expected known-good values, and means that
    /// the loaded bloomfilter matches the blocklist record in the RemoteSettings
    /// collection. The prefix denotes the immediate source of the loaded data: "dump"
    /// means packaged with the application, "remote" means a freshly downloaded
    /// bloomfilter, "cache" means a previously downloaded bloomfilter. "dump_fallback"
    /// and "cache_fallback" means that the last known bloomfilter was used, despite it
    /// not matching the latest record in the RemoteSettings collection. In this case
    /// the outdated bloomfilter is used as a fallback (e.g. because the latest version
    /// cannot be downloaded). "unknown"  means that the bloomfilter cannot be loaded
    /// at all. This can happen if the blocklist is disabled via preferences or
    /// enterprise policies.
    pub static mlbf_source: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3296.into(), CommonMetricData {
            name: "mlbf_source".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_stash_time_newest
    ///
    /// Keep track of the timestamp of the most recent stash of the addons blocklist.
    pub static mlbf_stash_time_newest: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(3297.into(), CommonMetricData {
            name: "mlbf_stash_time_newest".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_stash_time_oldest
    ///
    /// Keep track of the timestamp of the oldest stash of the addons blocklist.
    pub static mlbf_stash_time_oldest: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(3298.into(), CommonMetricData {
            name: "mlbf_stash_time_oldest".into(),
            category: "blocklist".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod update {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from update.auto_download
    ///
    /// Per-installation preference "app.update.auto": whether to fetch and install
    /// updates without user intervention.
    pub static auto_download: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3299.into(), CommonMetricData {
            name: "auto_download".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.background_update
    ///
    /// Per-installation preference "app.update.background.enabled": whether to fetch
    /// and install updates in the background when Firefox is not running.
    pub static background_update: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3300.into(), CommonMetricData {
            name: "background_update".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_apply_updates
    ///
    /// Whether or not the Update Service can usually download and install updates. See
    /// `canUsuallyApplyUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_apply_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3301.into(), CommonMetricData {
            name: "can_usually_apply_updates".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_check_for_updates
    ///
    /// Whether or not the Update Service can usually check for updates. See
    /// `canUsuallyCheckForUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_check_for_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3302.into(), CommonMetricData {
            name: "can_usually_check_for_updates".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_stage_updates
    ///
    /// Whether the Update Service is usually able to stage updates. See
    /// `canUsuallyStageUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_stage_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3303.into(), CommonMetricData {
            name: "can_usually_stage_updates".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_use_bits
    ///
    /// On Windows, whether the Update Service can usually use BITS. See
    /// `canUsuallyUseBits` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_use_bits: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3304.into(), CommonMetricData {
            name: "can_usually_use_bits".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.channel
    ///
    /// The update channel.
    pub static channel: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3305.into(), CommonMetricData {
            name: "channel".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.enabled
    ///
    /// True when policies are disabled or when the "DisableAppUpdate" is not in
    /// effect.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3306.into(), CommonMetricData {
            name: "enabled".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.service_enabled
    ///
    /// Preference "app.update.service.enabled": whether the Mozilla Maintenance
    /// Service is enabled.
    pub static service_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(3307.into(), CommonMetricData {
            name: "service_enabled".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod gecko {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gecko.build_id
    ///
    /// The Buildid of the Gecko engine, example: 20200205124310 (Migrated from the
    /// geckoview metric of the same name).
    pub static build_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3308.into(), CommonMetricData {
            name: "build_id".into(),
            category: "gecko".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from gecko.version
    ///
    /// The version of the Gecko engine, example: 74.0a1 (Migrated from the geckoview
    /// metric of the same name).
    pub static version: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(3309.into(), CommonMetricData {
            name: "version".into(),
            category: "gecko".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::User,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod file_dialog {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct FallbackV2Extra {
        pub succeeded: Option<bool>,
        pub time_local: Option<u32>,
        pub time_remote: Option<u32>,
        pub where_local: Option<String>,
        pub where_remote: Option<String>,
        pub why_local: Option<String>,
        pub why_remote: Option<String>,
    }

    impl ExtraKeys for FallbackV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["succeeded", "time_local", "time_remote", "where_local", "where_remote", "why_local", "why_remote"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.succeeded.and_then(|val| map.insert("succeeded".into(), val.to_string()));
          self.time_local.and_then(|val| map.insert("time_local".into(), val.to_string()));
          self.time_remote.and_then(|val| map.insert("time_remote".into(), val.to_string()));
          self.where_local.and_then(|val| map.insert("where_local".into(), val.to_string()));
          self.where_remote.and_then(|val| map.insert("where_remote".into(), val.to_string()));
          self.why_local.and_then(|val| map.insert("why_local".into(), val.to_string()));
          self.why_remote.and_then(|val| map.insert("why_remote".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from file_dialog.fallback_v2
    ///
    /// Records the result of an attempt to open and use the out-of-process file dialog
    /// when the in-process file-dialog is available as a fallback.
    pub static fallback_v2: Lazy<EventMetric<FallbackV2Extra>> = Lazy::new(|| {
        EventMetric::new(3310.into(), CommonMetricData {
            name: "fallback_v2".into(),
            category: "file_dialog".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod timer_thread {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from timer_thread.timers_fired_per_wakeup
    ///
    /// How many timers were processed in a single wake-up of the Timer Thread.
    pub static timers_fired_per_wakeup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(3311.into(), CommonMetricData {
            name: "timers_fired_per_wakeup".into(),
            category: "timer_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 80, 20, HistogramType::Exponential)
    });

}

#[allow(dead_code)]
pub(crate) mod __glean_metric_maps {
    use std::collections::HashMap;

    use crate::metrics::extra_keys_len;
    use crate::private::*;
    use once_cell::sync::Lazy;

    pub static TIMING_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<TimingDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(108);
        map.insert(4.into(), &super::privacy_sanitize::load_time);
        map.insert(144.into(), &super::serp::categorization_duration);
        map.insert(223.into(), &super::performance_interaction::tab_switch_composite);
        map.insert(224.into(), &super::performance_interaction::keypress_present_latency);
        map.insert(225.into(), &super::performance_interaction::mouseup_click_present_latency);
        map.insert(226.into(), &super::performance_page::total_content_page_load);
        map.insert(227.into(), &super::performance_page::non_blank_paint);
        map.insert(2617.into(), &super::javascript_pageload::baseline_compile_time);
        map.insert(2618.into(), &super::javascript_pageload::delazification_time);
        map.insert(2619.into(), &super::javascript_pageload::execution_time);
        map.insert(2620.into(), &super::javascript_pageload::gc_time);
        map.insert(2621.into(), &super::javascript_pageload::parse_time);
        map.insert(2622.into(), &super::javascript_pageload::protect_time);
        map.insert(2623.into(), &super::javascript_pageload::xdr_encode_time);
        map.insert(2624.into(), &super::perf::largest_contentful_paint);
        map.insert(2625.into(), &super::perf::largest_contentful_paint_from_response_start);
        map.insert(2627.into(), &super::performance_pageload::fcp);
        map.insert(2628.into(), &super::performance_pageload::fcp_responsestart);
        map.insert(2629.into(), &super::performance_pageload::load_time);
        map.insert(2630.into(), &super::performance_pageload::load_time_responsestart);
        map.insert(2631.into(), &super::performance_pageload::async_sheet_load);
        map.insert(2632.into(), &super::performance_pageload::req_anim_frame_callback);
        map.insert(2633.into(), &super::performance_time::dom_complete);
        map.insert(2634.into(), &super::performance_time::dom_content_loaded_end);
        map.insert(2635.into(), &super::performance_time::dom_content_loaded_start);
        map.insert(2636.into(), &super::performance_time::dom_interactive);
        map.insert(2637.into(), &super::performance_time::load_event_end);
        map.insert(2638.into(), &super::performance_time::load_event_start);
        map.insert(2639.into(), &super::performance_time::response_start);
        map.insert(2643.into(), &super::httpsfirst::downgrade_time);
        map.insert(2644.into(), &super::httpsfirst::downgrade_time_schemeless);
        map.insert(2658.into(), &super::gfx::composite_time);
        map.insert(2659.into(), &super::gfx::scroll_present_latency);
        map.insert(2669.into(), &super::gfx_checkerboard::duration);
        map.insert(2671.into(), &super::gfx_checkerboard::potential_duration);
        map.insert(2673.into(), &super::gfx_content::full_paint_time);
        map.insert(2674.into(), &super::gfx_content::paint_time);
        map.insert(2692.into(), &super::paint::build_displaylist_time);
        map.insert(2693.into(), &super::wr::framebuild_time);
        map.insert(2694.into(), &super::wr::gpu_wait_time);
        map.insert(2695.into(), &super::wr::rasterize_blobs_time);
        map.insert(2696.into(), &super::wr::rasterize_glyphs_time);
        map.insert(2697.into(), &super::wr::renderer_time);
        map.insert(2698.into(), &super::wr::renderer_time_no_sc);
        map.insert(2699.into(), &super::wr::scenebuild_time);
        map.insert(2700.into(), &super::wr::sceneswap_time);
        map.insert(2701.into(), &super::wr::texture_cache_update_time);
        map.insert(2702.into(), &super::wr::time_to_frame_build);
        map.insert(2703.into(), &super::wr::time_to_render_start);
        map.insert(2723.into(), &super::javascript_gc::compact_time);
        map.insert(2724.into(), &super::javascript_gc::mark_roots_time);
        map.insert(2725.into(), &super::javascript_gc::mark_time);
        map.insert(2726.into(), &super::javascript_gc::minor_time);
        map.insert(2727.into(), &super::javascript_gc::prepare_time);
        map.insert(2728.into(), &super::javascript_gc::slice_time);
        map.insert(2729.into(), &super::javascript_gc::sweep_time);
        map.insert(2730.into(), &super::javascript_gc::total_time);
        map.insert(2733.into(), &super::performance_clone_deserialize::time);
        map.insert(2734.into(), &super::performance_responsiveness::req_anim_frame_callback);
        map.insert(2735.into(), &super::geckoview::content_process_lifetime);
        map.insert(2737.into(), &super::geckoview::page_load_progress_time);
        map.insert(2738.into(), &super::geckoview::page_load_time);
        map.insert(2739.into(), &super::geckoview::page_reload_time);
        map.insert(2741.into(), &super::geckoview::startup_runtime);
        map.insert(2752.into(), &super::networking::dns_failed_lookup_time);
        map.insert(2753.into(), &super::networking::dns_lookup_time);
        map.insert(2755.into(), &super::networking::dns_native_https_call_time);
        map.insert(2756.into(), &super::networking::dns_renewal_time);
        map.insert(2757.into(), &super::networking::dns_renewal_time_for_ttl);
        map.insert(2774.into(), &super::networking::http_channel_page_open_to_first_sent);
        map.insert(2775.into(), &super::networking::http_channel_page_open_to_first_sent_https_rr);
        map.insert(2776.into(), &super::networking::http_channel_sub_open_to_first_sent);
        map.insert(2777.into(), &super::networking::http_channel_sub_open_to_first_sent_https_rr);
        map.insert(2778.into(), &super::networking::http_content_cssloader_ondatafinished_to_onstop_delay);
        map.insert(2779.into(), &super::networking::http_content_html5parser_ondatafinished_to_onstop_delay);
        map.insert(2780.into(), &super::networking::http_content_ondatafinished_delay);
        map.insert(2781.into(), &super::networking::http_content_ondatafinished_to_onstop_delay);
        map.insert(2782.into(), &super::networking::http_content_onstart_delay);
        map.insert(2783.into(), &super::networking::http_content_onstop_delay);
        map.insert(2784.into(), &super::networking::http_onstart_suspend_total_time);
        map.insert(2796.into(), &super::networking::transaction_wait_time);
        map.insert(2797.into(), &super::networking::transaction_wait_time_https_rr);
        map.insert(2801.into(), &super::network::cache_hit_time);
        map.insert(2805.into(), &super::network::dns_end);
        map.insert(2806.into(), &super::network::dns_start);
        map.insert(2807.into(), &super::network::first_from_cache);
        map.insert(2808.into(), &super::network::font_download_end);
        map.insert(2809.into(), &super::network::tcp_connection);
        map.insert(2810.into(), &super::network::tls_handshake);
        map.insert(2811.into(), &super::cert_verifier::cert_trust_evaluation_time);
        map.insert(2832.into(), &super::bounce_tracking_protection::purge_duration);
        map.insert(2857.into(), &super::relevancy_classify::duration);
        map.insert(2931.into(), &super::extensions_apis_dnr::evaluate_rules_time);
        map.insert(2934.into(), &super::extensions_apis_dnr::startup_cache_read_time);
        map.insert(2936.into(), &super::extensions_apis_dnr::startup_cache_write_time);
        map.insert(2937.into(), &super::extensions_apis_dnr::validate_rules_time);
        map.insert(2945.into(), &super::extensions_timing::background_page_load);
        map.insert(2946.into(), &super::extensions_timing::browser_action_popup_open);
        map.insert(2947.into(), &super::extensions_timing::content_script_injection);
        map.insert(2949.into(), &super::extensions_timing::extension_startup);
        map.insert(2950.into(), &super::extensions_timing::page_action_popup_open);
        map.insert(2951.into(), &super::extensions_timing::storage_local_get_idb);
        map.insert(2952.into(), &super::extensions_timing::storage_local_set_idb);
        map.insert(2966.into(), &super::fog_ipc::flush_durations);
        map.insert(2993.into(), &super::test_only::what_time_is_it);
        map.insert(3004.into(), &super::test_only_ipc::a_timing_dist);
        map.insert(3205.into(), &super::fingerprinting_protection::canvas_noise_calculate_time);
        map.insert(3219.into(), &super::search_service::startup_time);
        map
    });

    pub static QUANTITY_MAP: Lazy<HashMap<MetricId, &Lazy<QuantityMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(122);
        map.insert(5.into(), &super::browser_backup::browser_extension_data_size);
        map.insert(6.into(), &super::browser_backup::cookies_size);
        map.insert(7.into(), &super::browser_backup::credentials_data_size);
        map.insert(8.into(), &super::browser_backup::extension_store_permissions_data_size);
        map.insert(9.into(), &super::browser_backup::extensions_json_size);
        map.insert(10.into(), &super::browser_backup::extensions_storage_size);
        map.insert(11.into(), &super::browser_backup::extensions_xpi_directory_size);
        map.insert(12.into(), &super::browser_backup::favicons_size);
        map.insert(13.into(), &super::browser_backup::form_history_size);
        map.insert(14.into(), &super::browser_backup::misc_data_size);
        map.insert(15.into(), &super::browser_backup::places_size);
        map.insert(16.into(), &super::browser_backup::preferences_size);
        map.insert(17.into(), &super::browser_backup::prof_d_disk_space);
        map.insert(18.into(), &super::browser_backup::security_data_size);
        map.insert(19.into(), &super::browser_backup::session_store_backups_directory_size);
        map.insert(20.into(), &super::browser_backup::session_store_size);
        map.insert(21.into(), &super::browser_backup::storage_sync_size);
        map.insert(33.into(), &super::background_update::targeting_env_firefox_version);
        map.insert(37.into(), &super::background_update::targeting_version);
        map.insert(52.into(), &super::messaging_system::event_screen_index);
        map.insert(109.into(), &super::top_sites::position);
        map.insert(118.into(), &super::topsites::rows);
        map.insert(121.into(), &super::topsites::sponsored_tiles_configured);
        map.insert(124.into(), &super::pocket_button::event_position);
        map.insert(129.into(), &super::pocket_button::profile_creation_date);
        map.insert(192.into(), &super::quick_suggest::position);
        map.insert(202.into(), &super::urlbar::pref_max_results);
        map.insert(209.into(), &super::browser_engagement::profile_count);
        map.insert(2666.into(), &super::gfx_adapter_primary::ram);
        map.insert(2681.into(), &super::gfx_display::count);
        map.insert(2682.into(), &super::gfx_display::primary_height);
        map.insert(2683.into(), &super::gfx_display::primary_width);
        map.insert(2690.into(), &super::gpu_process::total_launch_attempts);
        map.insert(2691.into(), &super::gpu_process::unstable_launch_attempts);
        map.insert(2813.into(), &super::cert_verifier::trust_obj_count);
        map.insert(2818.into(), &super::data_storage::alternate_services);
        map.insert(2819.into(), &super::data_storage::client_auth_remember_list);
        map.insert(2820.into(), &super::data_storage::site_security_service_state);
        map.insert(2833.into(), &super::background_tasks_rmdir_base::elapsed_ms);
        map.insert(2835.into(), &super::background_tasks_rmdir_base::removal_count);
        map.insert(2836.into(), &super::background_tasks_rmdir_base::retry_count);
        map.insert(2839.into(), &super::background_tasks_rmdir_base::suffix_removal_count);
        map.insert(2841.into(), &super::background_tasks_rmdir_http_cache::elapsed_ms);
        map.insert(2843.into(), &super::background_tasks_rmdir_http_cache::removal_count);
        map.insert(2844.into(), &super::background_tasks_rmdir_http_cache::retry_count);
        map.insert(2847.into(), &super::background_tasks_rmdir_http_cache::suffix_removal_count);
        map.insert(2849.into(), &super::background_tasks_rmdir_quota::elapsed_ms);
        map.insert(2851.into(), &super::background_tasks_rmdir_quota::removal_count);
        map.insert(2852.into(), &super::background_tasks_rmdir_quota::retry_count);
        map.insert(2855.into(), &super::background_tasks_rmdir_quota::suffix_removal_count);
        map.insert(2883.into(), &super::crash::event_loop_nesting_level);
        map.insert(2885.into(), &super::crash::gpu_process_launch);
        map.insert(2911.into(), &super::memory::available_commit);
        map.insert(2912.into(), &super::memory::available_physical);
        map.insert(2913.into(), &super::memory::available_swap);
        map.insert(2914.into(), &super::memory::available_virtual);
        map.insert(2915.into(), &super::memory::low_physical);
        map.insert(2916.into(), &super::memory::oom_allocation_size);
        map.insert(2917.into(), &super::memory::purgeable_physical);
        map.insert(2918.into(), &super::memory::system_use_percentage);
        map.insert(2919.into(), &super::memory::texture);
        map.insert(2920.into(), &super::memory::total_page_file);
        map.insert(2921.into(), &super::memory::total_physical);
        map.insert(2922.into(), &super::memory::total_virtual);
        map.insert(2927.into(), &super::extensions::startup_cache_write_bytelength);
        map.insert(2930.into(), &super::extensions_apis_dnr::evaluate_rules_count_max);
        map.insert(2943.into(), &super::extensions_quarantined_domains::listsize);
        map.insert(2954.into(), &super::formautofill_creditcards::autofill_profiles_count);
        map.insert(2964.into(), &super::fog::max_pings_per_minute);
        map.insert(2986.into(), &super::test_only::meaning_of_life);
        map.insert(3000.into(), &super::test_only_ipc::a_quantity);
        map.insert(3076.into(), &super::broken_site_report_browser_info_prefs::cookie_behavior);
        map.insert(3087.into(), &super::broken_site_report_browser_info_system::memory);
        map.insert(3103.into(), &super::characteristics::audio_fingerprint);
        map.insert(3104.into(), &super::characteristics::avail_height);
        map.insert(3105.into(), &super::characteristics::avail_width);
        map.insert(3121.into(), &super::characteristics::color_accentcolor);
        map.insert(3122.into(), &super::characteristics::color_accentcolortext);
        map.insert(3123.into(), &super::characteristics::color_canvas);
        map.insert(3124.into(), &super::characteristics::color_canvastext);
        map.insert(3125.into(), &super::characteristics::color_depth);
        map.insert(3126.into(), &super::characteristics::color_gamut);
        map.insert(3127.into(), &super::characteristics::color_highlight);
        map.insert(3128.into(), &super::characteristics::color_highlighttext);
        map.insert(3129.into(), &super::characteristics::color_scheme);
        map.insert(3130.into(), &super::characteristics::color_selecteditem);
        map.insert(3131.into(), &super::characteristics::color_selecteditemtext);
        map.insert(3133.into(), &super::characteristics::font_default_modified);
        map.insert(3136.into(), &super::characteristics::font_minimum_size_modified);
        map.insert(3138.into(), &super::characteristics::font_name_list_cursive_modified);
        map.insert(3140.into(), &super::characteristics::font_name_list_monospace_modified);
        map.insert(3141.into(), &super::characteristics::font_name_list_sans_serif_modified);
        map.insert(3142.into(), &super::characteristics::font_name_list_serif_modified);
        map.insert(3144.into(), &super::characteristics::font_name_monospace_modified);
        map.insert(3147.into(), &super::characteristics::font_name_sans_serif_modified);
        map.insert(3150.into(), &super::characteristics::font_name_serif_modified);
        map.insert(3153.into(), &super::characteristics::font_size_monospace_modified);
        map.insert(3156.into(), &super::characteristics::font_size_variable_modified);
        map.insert(3159.into(), &super::characteristics::inner_height);
        map.insert(3160.into(), &super::characteristics::inner_width);
        map.insert(3165.into(), &super::characteristics::max_touch_points);
        map.insert(3169.into(), &super::characteristics::orientation_angle);
        map.insert(3170.into(), &super::characteristics::outer_height);
        map.insert(3171.into(), &super::characteristics::outer_width);
        map.insert(3172.into(), &super::characteristics::pixel_depth);
        map.insert(3173.into(), &super::characteristics::pixel_ratio);
        map.insert(3174.into(), &super::characteristics::posx);
        map.insert(3175.into(), &super::characteristics::posy);
        map.insert(3176.into(), &super::characteristics::prefers_contrast);
        map.insert(3185.into(), &super::characteristics::prefs_network_cookie_cookiebehavior);
        map.insert(3190.into(), &super::characteristics::processor_count);
        map.insert(3192.into(), &super::characteristics::screen_height);
        map.insert(3193.into(), &super::characteristics::screen_orientation);
        map.insert(3194.into(), &super::characteristics::screen_width);
        map.insert(3195.into(), &super::characteristics::size_mode);
        map.insert(3196.into(), &super::characteristics::submission_schema);
        map.insert(3198.into(), &super::characteristics::target_frame_rate);
        map.insert(3204.into(), &super::characteristics::zoom_count);
        map.insert(3276.into(), &super::first_startup::delete_tasks_time);
        map.insert(3277.into(), &super::first_startup::elapsed);
        map.insert(3279.into(), &super::first_startup::normandy_init_time);
        map.insert(3280.into(), &super::first_startup::status_code);
        map
    });

    pub static STRING_LIST_MAP: Lazy<HashMap<MetricId, &Lazy<StringListMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(17);
        map.insert(22.into(), &super::background_update::reasons_to_not_update);
        map.insert(30.into(), &super::background_update::reasons);
        map.insert(31.into(), &super::background_update::states);
        map.insert(39.into(), &super::browser_migration::matched_extensions);
        map.insert(40.into(), &super::browser_migration::unmatched_extensions);
        map.insert(75.into(), &super::newtab::blocked_sponsors);
        map.insert(81.into(), &super::newtab::sov_allocation);
        map.insert(2906.into(), &super::dll_blocklist::list);
        map.insert(2908.into(), &super::environment::experimental_features);
        map.insert(2975.into(), &super::test_only::cheesy_string_list);
        map.insert(3002.into(), &super::test_only_ipc::a_string_list);
        map.insert(3067.into(), &super::broken_site_report_browser_info_app::default_locales);
        map.insert(3083.into(), &super::broken_site_report_browser_info_security::antispyware);
        map.insert(3084.into(), &super::broken_site_report_browser_info_security::antivirus);
        map.insert(3085.into(), &super::broken_site_report_browser_info_security::firewall);
        map.insert(3088.into(), &super::broken_site_report_tab_info::languages);
        map.insert(3158.into(), &super::characteristics::gamepads);
        map
    });

    pub static DATETIME_MAP: Lazy<HashMap<MetricId, &Lazy<DatetimeMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(12);
        map.insert(23.into(), &super::background_update::time_last_update_scheduled);
        map.insert(32.into(), &super::background_update::targeting_env_current_date);
        map.insert(34.into(), &super::background_update::targeting_env_profile_age);
        map.insert(98.into(), &super::pocket::fetch_timestamp);
        map.insert(101.into(), &super::pocket::newtab_creation_timestamp);
        map.insert(2898.into(), &super::crash::time);
        map.insert(2991.into(), &super::test_only::what_a_date);
        map.insert(2997.into(), &super::test_only_ipc::a_date);
        map.insert(3294.into(), &super::blocklist::last_modified_rs_addons_mblf);
        map.insert(3295.into(), &super::blocklist::mlbf_generation_time);
        map.insert(3297.into(), &super::blocklist::mlbf_stash_time_newest);
        map.insert(3298.into(), &super::blocklist::mlbf_stash_time_oldest);
        map
    });

    pub static BOOLEAN_MAP: Lazy<HashMap<MetricId, &Lazy<BooleanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(101);
        map.insert(24.into(), &super::background_update::automatic_restart_attempted);
        map.insert(25.into(), &super::background_update::automatic_restart_success);
        map.insert(27.into(), &super::background_update::exit_code_exception);
        map.insert(28.into(), &super::background_update::exit_code_success);
        map.insert(35.into(), &super::background_update::targeting_exception);
        map.insert(36.into(), &super::background_update::targeting_exists);
        map.insert(88.into(), &super::newtab::weather_enabled);
        map.insert(93.into(), &super::newtab_handoff_preference::enabled);
        map.insert(94.into(), &super::newtab_search::enabled);
        map.insert(97.into(), &super::pocket::enabled);
        map.insert(100.into(), &super::pocket::is_signed_in);
        map.insert(104.into(), &super::pocket::sponsored_stories_enabled);
        map.insert(115.into(), &super::topsites::enabled);
        map.insert(120.into(), &super::topsites::sponsored_enabled);
        map.insert(128.into(), &super::pocket_button::pocket_logged_in_status);
        map.insert(179.into(), &super::shopping_settings::auto_open_user_disabled);
        map.insert(180.into(), &super::shopping_settings::component_opted_out);
        map.insert(181.into(), &super::shopping_settings::disabled_ads);
        map.insert(182.into(), &super::shopping_settings::has_onboarded);
        map.insert(183.into(), &super::shopping_settings::nimbus_disabled_shopping);
        map.insert(188.into(), &super::quick_suggest::improve_suggest_experience);
        map.insert(189.into(), &super::quick_suggest::is_clicked);
        map.insert(197.into(), &super::quick_suggest::suggested_index_relative_to_group);
        map.insert(203.into(), &super::urlbar::pref_suggest_data_collection);
        map.insert(204.into(), &super::urlbar::pref_suggest_nonsponsored);
        map.insert(205.into(), &super::urlbar::pref_suggest_sponsored);
        map.insert(206.into(), &super::urlbar::pref_suggest_topsites);
        map.insert(212.into(), &super::installation_first_seen::admin_user);
        map.insert(213.into(), &super::installation_first_seen::default_path);
        map.insert(215.into(), &super::installation_first_seen::from_msi);
        map.insert(216.into(), &super::installation_first_seen::install_existed);
        map.insert(218.into(), &super::installation_first_seen::other_inst);
        map.insert(219.into(), &super::installation_first_seen::other_msix_inst);
        map.insert(220.into(), &super::installation_first_seen::profdir_existed);
        map.insert(221.into(), &super::installation_first_seen::silent);
        map.insert(2686.into(), &super::gfx_status::headless);
        map.insert(2828.into(), &super::bounce_tracking_protection::enabled_at_startup);
        map.insert(2829.into(), &super::bounce_tracking_protection::enabled_dry_run_mode_at_startup);
        map.insert(2837.into(), &super::background_tasks_rmdir_base::succeeded);
        map.insert(2838.into(), &super::background_tasks_rmdir_base::suffix_ever_failed);
        map.insert(2840.into(), &super::background_tasks_rmdir_base::was_first);
        map.insert(2845.into(), &super::background_tasks_rmdir_http_cache::succeeded);
        map.insert(2846.into(), &super::background_tasks_rmdir_http_cache::suffix_ever_failed);
        map.insert(2848.into(), &super::background_tasks_rmdir_http_cache::was_first);
        map.insert(2853.into(), &super::background_tasks_rmdir_quota::succeeded);
        map.insert(2854.into(), &super::background_tasks_rmdir_quota::suffix_ever_failed);
        map.insert(2856.into(), &super::background_tasks_rmdir_quota::was_first);
        map.insert(2869.into(), &super::cookie_banners::service_detect_only);
        map.insert(2887.into(), &super::crash::is_garbage_collecting);
        map.insert(2897.into(), &super::crash::startup);
        map.insert(2899.into(), &super::crash_windows::error_reporting);
        map.insert(2905.into(), &super::dll_blocklist::init_failed);
        map.insert(2907.into(), &super::dll_blocklist::user32_loaded_before);
        map.insert(2909.into(), &super::environment::headless_mode);
        map.insert(2928.into(), &super::extensions::use_remote_policy);
        map.insert(2929.into(), &super::extensions::use_remote_pref);
        map.insert(2961.into(), &super::fog::failed_idle_registration);
        map.insert(2972.into(), &super::test_only::can_we_flag_it);
        map.insert(2990.into(), &super::test_only::one_ping_one_bool);
        map.insert(2994.into(), &super::test_only_ipc::a_bool);
        map.insert(3069.into(), &super::broken_site_report_browser_info_app::fission_enabled);
        map.insert(3074.into(), &super::broken_site_report_browser_info_graphics::has_touch_screen);
        map.insert(3077.into(), &super::broken_site_report_browser_info_prefs::forced_accelerated_layers);
        map.insert(3078.into(), &super::broken_site_report_browser_info_prefs::global_privacy_control_enabled);
        map.insert(3079.into(), &super::broken_site_report_browser_info_prefs::installtrigger_enabled);
        map.insert(3080.into(), &super::broken_site_report_browser_info_prefs::opaque_response_blocking);
        map.insert(3081.into(), &super::broken_site_report_browser_info_prefs::resist_fingerprinting_enabled);
        map.insert(3082.into(), &super::broken_site_report_browser_info_prefs::software_webrender);
        map.insert(3086.into(), &super::broken_site_report_browser_info_system::is_tablet);
        map.insert(3091.into(), &super::broken_site_report_tab_info_antitracking::has_mixed_active_content_blocked);
        map.insert(3092.into(), &super::broken_site_report_tab_info_antitracking::has_mixed_display_content_blocked);
        map.insert(3093.into(), &super::broken_site_report_tab_info_antitracking::has_tracking_content_blocked);
        map.insert(3094.into(), &super::broken_site_report_tab_info_antitracking::is_private_browsing);
        map.insert(3095.into(), &super::broken_site_report_tab_info_frameworks::fastclick);
        map.insert(3096.into(), &super::broken_site_report_tab_info_frameworks::marfeel);
        map.insert(3097.into(), &super::broken_site_report_tab_info_frameworks::mobify);
        map.insert(3139.into(), &super::characteristics::font_name_list_emoji_modified);
        map.insert(3162.into(), &super::characteristics::inverted_colors);
        map.insert(3177.into(), &super::characteristics::prefers_reduced_motion);
        map.insert(3178.into(), &super::characteristics::prefers_reduced_transparency);
        map.insert(3179.into(), &super::characteristics::prefs_block_popups);
        map.insert(3180.into(), &super::characteristics::prefs_browser_display_use_document_fonts);
        map.insert(3181.into(), &super::characteristics::prefs_general_autoscroll);
        map.insert(3182.into(), &super::characteristics::prefs_general_smoothscroll);
        map.insert(3184.into(), &super::characteristics::prefs_media_eme_enabled);
        map.insert(3186.into(), &super::characteristics::prefs_overlay_scrollbars);
        map.insert(3187.into(), &super::characteristics::prefs_privacy_donottrackheader_enabled);
        map.insert(3188.into(), &super::characteristics::prefs_privacy_globalprivacycontrol_enabled);
        map.insert(3189.into(), &super::characteristics::prefs_zoom_text_only);
        map.insert(3201.into(), &super::characteristics::use_document_colors);
        map.insert(3202.into(), &super::characteristics::video_dynamic_range);
        map.insert(3278.into(), &super::first_startup::new_profile);
        map.insert(3282.into(), &super::notification::show_success);
        map.insert(3299.into(), &super::update::auto_download);
        map.insert(3300.into(), &super::update::background_update);
        map.insert(3301.into(), &super::update::can_usually_apply_updates);
        map.insert(3302.into(), &super::update::can_usually_check_for_updates);
        map.insert(3303.into(), &super::update::can_usually_stage_updates);
        map.insert(3304.into(), &super::update::can_usually_use_bits);
        map.insert(3306.into(), &super::update::enabled);
        map.insert(3307.into(), &super::update::service_enabled);
        map
    });

    pub static UUID_MAP: Lazy<HashMap<MetricId, &Lazy<UuidMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(12);
        map.insert(26.into(), &super::background_update::client_id);
        map.insert(42.into(), &super::messaging_system::browser_session_id);
        map.insert(44.into(), &super::messaging_system::client_id);
        map.insert(56.into(), &super::messaging_system::impression_id);
        map.insert(107.into(), &super::top_sites::context_id);
        map.insert(126.into(), &super::pocket_button::impression_id);
        map.insert(139.into(), &super::search_with::context_id);
        map.insert(186.into(), &super::quick_suggest::context_id);
        map.insert(2992.into(), &super::test_only::what_id_it);
        map.insert(3006.into(), &super::test_only_ipc::a_uuid);
        map.insert(3120.into(), &super::characteristics::client_identifier);
        map.insert(3231.into(), &super::legacy_telemetry::client_id);
        map
    });

    pub static STRING_MAP: Lazy<HashMap<MetricId, &Lazy<StringMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(115);
        map.insert(29.into(), &super::background_update::final_state);
        map.insert(41.into(), &super::messaging_system::addon_version);
        map.insert(43.into(), &super::messaging_system::bucket_id);
        map.insert(45.into(), &super::messaging_system::event);
        map.insert(48.into(), &super::messaging_system::event_page);
        map.insert(49.into(), &super::messaging_system::event_reason);
        map.insert(54.into(), &super::messaging_system::event_source);
        map.insert(58.into(), &super::messaging_system::locale);
        map.insert(60.into(), &super::messaging_system::ping_type);
        map.insert(61.into(), &super::messaging_system::source);
        map.insert(64.into(), &super::messaging_system_attribution::campaign);
        map.insert(65.into(), &super::messaging_system_attribution::content);
        map.insert(66.into(), &super::messaging_system_attribution::dlsource);
        map.insert(67.into(), &super::messaging_system_attribution::dltoken);
        map.insert(68.into(), &super::messaging_system_attribution::experiment);
        map.insert(69.into(), &super::messaging_system_attribution::medium);
        map.insert(70.into(), &super::messaging_system_attribution::msstoresignedin);
        map.insert(71.into(), &super::messaging_system_attribution::source);
        map.insert(72.into(), &super::messaging_system_attribution::ua);
        map.insert(74.into(), &super::messaging_system_attribution::variation);
        map.insert(77.into(), &super::newtab::homepage_category);
        map.insert(78.into(), &super::newtab::locale);
        map.insert(79.into(), &super::newtab::newtab_category);
        map.insert(106.into(), &super::top_sites::advertiser);
        map.insert(108.into(), &super::top_sites::ping_type);
        map.insert(111.into(), &super::top_sites::source);
        map.insert(112.into(), &super::top_sites::tile_id);
        map.insert(123.into(), &super::pocket_button::event_action);
        map.insert(125.into(), &super::pocket_button::event_source);
        map.insert(127.into(), &super::pocket_button::model);
        map.insert(184.into(), &super::quick_suggest::advertiser);
        map.insert(185.into(), &super::quick_suggest::block_id);
        map.insert(187.into(), &super::quick_suggest::iab_category);
        map.insert(190.into(), &super::quick_suggest::match_type);
        map.insert(191.into(), &super::quick_suggest::ping_type);
        map.insert(194.into(), &super::quick_suggest::request_id);
        map.insert(195.into(), &super::quick_suggest::source);
        map.insert(196.into(), &super::quick_suggest::suggested_index);
        map.insert(214.into(), &super::installation_first_seen::failure_reason);
        map.insert(217.into(), &super::installation_first_seen::installer_type);
        map.insert(222.into(), &super::installation_first_seen::version);
        map.insert(2660.into(), &super::gfx_adapter_primary::description);
        map.insert(2661.into(), &super::gfx_adapter_primary::device_id);
        map.insert(2662.into(), &super::gfx_adapter_primary::driver_date);
        map.insert(2663.into(), &super::gfx_adapter_primary::driver_files);
        map.insert(2664.into(), &super::gfx_adapter_primary::driver_vendor);
        map.insert(2665.into(), &super::gfx_adapter_primary::driver_version);
        map.insert(2667.into(), &super::gfx_adapter_primary::subsystem_id);
        map.insert(2668.into(), &super::gfx_adapter_primary::vendor_id);
        map.insert(2684.into(), &super::gfx_feature::webrender);
        map.insert(2685.into(), &super::gfx_status::compositor);
        map.insert(2687.into(), &super::gfx_status::last_compositor_gecko_version);
        map.insert(2689.into(), &super::gpu_process::feature_status);
        map.insert(2878.into(), &super::crash::app_build);
        map.insert(2879.into(), &super::crash::app_channel);
        map.insert(2880.into(), &super::crash::app_display_version);
        map.insert(2882.into(), &super::crash::background_task_name);
        map.insert(2884.into(), &super::crash::font_name);
        map.insert(2886.into(), &super::crash::ipc_channel_error);
        map.insert(2888.into(), &super::crash::main_thread_runnable_name);
        map.insert(2889.into(), &super::crash::minidump_sha256_hash);
        map.insert(2890.into(), &super::crash::moz_crash_reason);
        map.insert(2891.into(), &super::crash::process_type);
        map.insert(2892.into(), &super::crash::profiler_child_shutdown_phase);
        map.insert(2894.into(), &super::crash::remote_type);
        map.insert(2895.into(), &super::crash::shutdown_progress);
        map.insert(2900.into(), &super::crash_windows::file_dialog_error_code);
        map.insert(2923.into(), &super::windows::package_family_name);
        map.insert(2942.into(), &super::extensions_quarantined_domains::listhash);
        map.insert(2944.into(), &super::extensions_quarantined_domains::remotehash);
        map.insert(2974.into(), &super::test_only::cheesy_string);
        map.insert(3001.into(), &super::test_only_ipc::a_string);
        map.insert(3064.into(), &super::broken_site_report::breakage_category);
        map.insert(3070.into(), &super::broken_site_report_browser_info_graphics::device_pixel_ratio);
        map.insert(3090.into(), &super::broken_site_report_tab_info_antitracking::block_list);
        map.insert(3119.into(), &super::characteristics::changed_media_prefs);
        map.insert(3132.into(), &super::characteristics::font_default_default_group);
        map.insert(3134.into(), &super::characteristics::font_default_western);
        map.insert(3135.into(), &super::characteristics::font_minimum_size_default_group);
        map.insert(3137.into(), &super::characteristics::font_minimum_size_western);
        map.insert(3143.into(), &super::characteristics::font_name_monospace_default_group);
        map.insert(3145.into(), &super::characteristics::font_name_monospace_western);
        map.insert(3146.into(), &super::characteristics::font_name_sans_serif_default_group);
        map.insert(3148.into(), &super::characteristics::font_name_sans_serif_western);
        map.insert(3149.into(), &super::characteristics::font_name_serif_default_group);
        map.insert(3151.into(), &super::characteristics::font_name_serif_western);
        map.insert(3152.into(), &super::characteristics::font_size_monospace_default_group);
        map.insert(3154.into(), &super::characteristics::font_size_monospace_western);
        map.insert(3155.into(), &super::characteristics::font_size_variable_default_group);
        map.insert(3157.into(), &super::characteristics::font_size_variable_western);
        map.insert(3161.into(), &super::characteristics::intl_locale);
        map.insert(3163.into(), &super::characteristics::languages);
        map.insert(3183.into(), &super::characteristics::prefs_intl_accept_languages);
        map.insert(3191.into(), &super::characteristics::scalings);
        map.insert(3197.into(), &super::characteristics::system_locale);
        map.insert(3199.into(), &super::characteristics::text_anti_aliasing);
        map.insert(3200.into(), &super::characteristics::timezone);
        map.insert(3207.into(), &super::search_engine_default::display_name);
        map.insert(3208.into(), &super::search_engine_default::engine_id);
        map.insert(3209.into(), &super::search_engine_default::load_path);
        map.insert(3211.into(), &super::search_engine_default::verified);
        map.insert(3213.into(), &super::search_engine_private::display_name);
        map.insert(3214.into(), &super::search_engine_private::engine_id);
        map.insert(3215.into(), &super::search_engine_private::load_path);
        map.insert(3217.into(), &super::search_engine_private::verified);
        map.insert(3281.into(), &super::notification::action);
        map.insert(3283.into(), &super::system::os_version);
        map.insert(3284.into(), &super::system::previous_os_version);
        map.insert(3285.into(), &super::system_default::browser);
        map.insert(3286.into(), &super::system_default::pdf_handler);
        map.insert(3287.into(), &super::system_default::previous_browser);
        map.insert(3296.into(), &super::blocklist::mlbf_source);
        map.insert(3305.into(), &super::update::channel);
        map.insert(3308.into(), &super::gecko::build_id);
        map.insert(3309.into(), &super::gecko::version);
        map
    });

    pub static TEXT_MAP: Lazy<HashMap<MetricId, &Lazy<TextMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(34);
        map.insert(46.into(), &super::messaging_system::event_context);
        map.insert(50.into(), &super::messaging_system::event_screen_family);
        map.insert(51.into(), &super::messaging_system::event_screen_id);
        map.insert(53.into(), &super::messaging_system::event_screen_initials);
        map.insert(59.into(), &super::messaging_system::message_id);
        map.insert(103.into(), &super::pocket::shim);
        map.insert(122.into(), &super::topsites::sponsored_tiles_received);
        map.insert(3003.into(), &super::test_only_ipc::a_text);
        map.insert(3065.into(), &super::broken_site_report::description);
        map.insert(3068.into(), &super::broken_site_report_browser_info_app::default_useragent_string);
        map.insert(3071.into(), &super::broken_site_report_browser_info_graphics::devices_json);
        map.insert(3072.into(), &super::broken_site_report_browser_info_graphics::drivers_json);
        map.insert(3073.into(), &super::broken_site_report_browser_info_graphics::features_json);
        map.insert(3075.into(), &super::broken_site_report_browser_info_graphics::monitors_json);
        map.insert(3089.into(), &super::broken_site_report_tab_info::useragent_string);
        map.insert(3102.into(), &super::characteristics::audio_devices);
        map.insert(3106.into(), &super::characteristics::canvasdata1);
        map.insert(3107.into(), &super::characteristics::canvasdata10);
        map.insert(3108.into(), &super::characteristics::canvasdata11_webgl);
        map.insert(3109.into(), &super::characteristics::canvasdata12_fingerprintjs1);
        map.insert(3110.into(), &super::characteristics::canvasdata13_fingerprintjs2);
        map.insert(3111.into(), &super::characteristics::canvasdata2);
        map.insert(3112.into(), &super::characteristics::canvasdata3);
        map.insert(3113.into(), &super::characteristics::canvasdata4);
        map.insert(3114.into(), &super::characteristics::canvasdata5);
        map.insert(3115.into(), &super::characteristics::canvasdata6);
        map.insert(3116.into(), &super::characteristics::canvasdata7);
        map.insert(3117.into(), &super::characteristics::canvasdata8);
        map.insert(3118.into(), &super::characteristics::canvasdata9);
        map.insert(3164.into(), &super::characteristics::math_ops);
        map.insert(3166.into(), &super::characteristics::media_capabilities);
        map.insert(3167.into(), &super::characteristics::media_devices);
        map.insert(3168.into(), &super::characteristics::missing_fonts);
        map.insert(3203.into(), &super::characteristics::voices);
        map
    });

    pub static COUNTER_MAP: Lazy<HashMap<MetricId, &Lazy<CounterMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(2389);
        map.insert(47.into(), &super::messaging_system::event_context_parse_error);
        map.insert(55.into(), &super::messaging_system::glean_ping_for_ping_failures);
        map.insert(62.into(), &super::messaging_system::unknown_key_count);
        map.insert(151.into(), &super::shopping::product_page_visits);
        map.insert(208.into(), &super::browser_engagement::active_ticks);
        map.insert(210.into(), &super::browser_engagement::uri_count);
        map.insert(228.into(), &super::use_counter::content_documents_destroyed);
        map.insert(229.into(), &super::use_counter::dedicated_workers_destroyed);
        map.insert(230.into(), &super::use_counter::service_workers_destroyed);
        map.insert(231.into(), &super::use_counter::shared_workers_destroyed);
        map.insert(232.into(), &super::use_counter::top_level_content_documents_destroyed);
        map.insert(233.into(), &super::use_counter_css_doc::alignment_baseline);
        map.insert(234.into(), &super::use_counter_css_doc::background_repeat_x);
        map.insert(235.into(), &super::use_counter_css_doc::background_repeat_y);
        map.insert(236.into(), &super::use_counter_css_doc::baseline_shift);
        map.insert(237.into(), &super::use_counter_css_doc::buffered_rendering);
        map.insert(238.into(), &super::use_counter_css_doc::color_rendering);
        map.insert(239.into(), &super::use_counter_css_doc::css_accent_color);
        map.insert(240.into(), &super::use_counter_css_doc::css_align_content);
        map.insert(241.into(), &super::use_counter_css_doc::css_align_items);
        map.insert(242.into(), &super::use_counter_css_doc::css_align_self);
        map.insert(243.into(), &super::use_counter_css_doc::css_all);
        map.insert(244.into(), &super::use_counter_css_doc::css_anchor_name);
        map.insert(245.into(), &super::use_counter_css_doc::css_anchor_scope);
        map.insert(246.into(), &super::use_counter_css_doc::css_animation);
        map.insert(247.into(), &super::use_counter_css_doc::css_animation_composition);
        map.insert(248.into(), &super::use_counter_css_doc::css_animation_delay);
        map.insert(249.into(), &super::use_counter_css_doc::css_animation_direction);
        map.insert(250.into(), &super::use_counter_css_doc::css_animation_duration);
        map.insert(251.into(), &super::use_counter_css_doc::css_animation_fill_mode);
        map.insert(252.into(), &super::use_counter_css_doc::css_animation_iteration_count);
        map.insert(253.into(), &super::use_counter_css_doc::css_animation_name);
        map.insert(254.into(), &super::use_counter_css_doc::css_animation_play_state);
        map.insert(255.into(), &super::use_counter_css_doc::css_animation_timeline);
        map.insert(256.into(), &super::use_counter_css_doc::css_animation_timing_function);
        map.insert(257.into(), &super::use_counter_css_doc::css_appearance);
        map.insert(258.into(), &super::use_counter_css_doc::css_aspect_ratio);
        map.insert(259.into(), &super::use_counter_css_doc::css_backdrop_filter);
        map.insert(260.into(), &super::use_counter_css_doc::css_backface_visibility);
        map.insert(261.into(), &super::use_counter_css_doc::css_background);
        map.insert(262.into(), &super::use_counter_css_doc::css_background_attachment);
        map.insert(263.into(), &super::use_counter_css_doc::css_background_blend_mode);
        map.insert(264.into(), &super::use_counter_css_doc::css_background_clip);
        map.insert(265.into(), &super::use_counter_css_doc::css_background_color);
        map.insert(266.into(), &super::use_counter_css_doc::css_background_image);
        map.insert(267.into(), &super::use_counter_css_doc::css_background_origin);
        map.insert(268.into(), &super::use_counter_css_doc::css_background_position);
        map.insert(269.into(), &super::use_counter_css_doc::css_background_position_x);
        map.insert(270.into(), &super::use_counter_css_doc::css_background_position_y);
        map.insert(271.into(), &super::use_counter_css_doc::css_background_repeat);
        map.insert(272.into(), &super::use_counter_css_doc::css_background_size);
        map.insert(273.into(), &super::use_counter_css_doc::css_baseline_source);
        map.insert(274.into(), &super::use_counter_css_doc::css_block_size);
        map.insert(275.into(), &super::use_counter_css_doc::css_border);
        map.insert(276.into(), &super::use_counter_css_doc::css_border_block);
        map.insert(277.into(), &super::use_counter_css_doc::css_border_block_color);
        map.insert(278.into(), &super::use_counter_css_doc::css_border_block_end);
        map.insert(279.into(), &super::use_counter_css_doc::css_border_block_end_color);
        map.insert(280.into(), &super::use_counter_css_doc::css_border_block_end_style);
        map.insert(281.into(), &super::use_counter_css_doc::css_border_block_end_width);
        map.insert(282.into(), &super::use_counter_css_doc::css_border_block_start);
        map.insert(283.into(), &super::use_counter_css_doc::css_border_block_start_color);
        map.insert(284.into(), &super::use_counter_css_doc::css_border_block_start_style);
        map.insert(285.into(), &super::use_counter_css_doc::css_border_block_start_width);
        map.insert(286.into(), &super::use_counter_css_doc::css_border_block_style);
        map.insert(287.into(), &super::use_counter_css_doc::css_border_block_width);
        map.insert(288.into(), &super::use_counter_css_doc::css_border_bottom);
        map.insert(289.into(), &super::use_counter_css_doc::css_border_bottom_color);
        map.insert(290.into(), &super::use_counter_css_doc::css_border_bottom_left_radius);
        map.insert(291.into(), &super::use_counter_css_doc::css_border_bottom_right_radius);
        map.insert(292.into(), &super::use_counter_css_doc::css_border_bottom_style);
        map.insert(293.into(), &super::use_counter_css_doc::css_border_bottom_width);
        map.insert(294.into(), &super::use_counter_css_doc::css_border_collapse);
        map.insert(295.into(), &super::use_counter_css_doc::css_border_color);
        map.insert(296.into(), &super::use_counter_css_doc::css_border_end_end_radius);
        map.insert(297.into(), &super::use_counter_css_doc::css_border_end_start_radius);
        map.insert(298.into(), &super::use_counter_css_doc::css_border_image);
        map.insert(299.into(), &super::use_counter_css_doc::css_border_image_outset);
        map.insert(300.into(), &super::use_counter_css_doc::css_border_image_repeat);
        map.insert(301.into(), &super::use_counter_css_doc::css_border_image_slice);
        map.insert(302.into(), &super::use_counter_css_doc::css_border_image_source);
        map.insert(303.into(), &super::use_counter_css_doc::css_border_image_width);
        map.insert(304.into(), &super::use_counter_css_doc::css_border_inline);
        map.insert(305.into(), &super::use_counter_css_doc::css_border_inline_color);
        map.insert(306.into(), &super::use_counter_css_doc::css_border_inline_end);
        map.insert(307.into(), &super::use_counter_css_doc::css_border_inline_end_color);
        map.insert(308.into(), &super::use_counter_css_doc::css_border_inline_end_style);
        map.insert(309.into(), &super::use_counter_css_doc::css_border_inline_end_width);
        map.insert(310.into(), &super::use_counter_css_doc::css_border_inline_start);
        map.insert(311.into(), &super::use_counter_css_doc::css_border_inline_start_color);
        map.insert(312.into(), &super::use_counter_css_doc::css_border_inline_start_style);
        map.insert(313.into(), &super::use_counter_css_doc::css_border_inline_start_width);
        map.insert(314.into(), &super::use_counter_css_doc::css_border_inline_style);
        map.insert(315.into(), &super::use_counter_css_doc::css_border_inline_width);
        map.insert(316.into(), &super::use_counter_css_doc::css_border_left);
        map.insert(317.into(), &super::use_counter_css_doc::css_border_left_color);
        map.insert(318.into(), &super::use_counter_css_doc::css_border_left_style);
        map.insert(319.into(), &super::use_counter_css_doc::css_border_left_width);
        map.insert(320.into(), &super::use_counter_css_doc::css_border_radius);
        map.insert(321.into(), &super::use_counter_css_doc::css_border_right);
        map.insert(322.into(), &super::use_counter_css_doc::css_border_right_color);
        map.insert(323.into(), &super::use_counter_css_doc::css_border_right_style);
        map.insert(324.into(), &super::use_counter_css_doc::css_border_right_width);
        map.insert(325.into(), &super::use_counter_css_doc::css_border_spacing);
        map.insert(326.into(), &super::use_counter_css_doc::css_border_start_end_radius);
        map.insert(327.into(), &super::use_counter_css_doc::css_border_start_start_radius);
        map.insert(328.into(), &super::use_counter_css_doc::css_border_style);
        map.insert(329.into(), &super::use_counter_css_doc::css_border_top);
        map.insert(330.into(), &super::use_counter_css_doc::css_border_top_color);
        map.insert(331.into(), &super::use_counter_css_doc::css_border_top_left_radius);
        map.insert(332.into(), &super::use_counter_css_doc::css_border_top_right_radius);
        map.insert(333.into(), &super::use_counter_css_doc::css_border_top_style);
        map.insert(334.into(), &super::use_counter_css_doc::css_border_top_width);
        map.insert(335.into(), &super::use_counter_css_doc::css_border_width);
        map.insert(336.into(), &super::use_counter_css_doc::css_bottom);
        map.insert(337.into(), &super::use_counter_css_doc::css_box_decoration_break);
        map.insert(338.into(), &super::use_counter_css_doc::css_box_shadow);
        map.insert(339.into(), &super::use_counter_css_doc::css_box_sizing);
        map.insert(340.into(), &super::use_counter_css_doc::css_break_after);
        map.insert(341.into(), &super::use_counter_css_doc::css_break_before);
        map.insert(342.into(), &super::use_counter_css_doc::css_break_inside);
        map.insert(343.into(), &super::use_counter_css_doc::css_caption_side);
        map.insert(344.into(), &super::use_counter_css_doc::css_caret_color);
        map.insert(345.into(), &super::use_counter_css_doc::css_clear);
        map.insert(346.into(), &super::use_counter_css_doc::css_clip);
        map.insert(347.into(), &super::use_counter_css_doc::css_clip_path);
        map.insert(348.into(), &super::use_counter_css_doc::css_clip_rule);
        map.insert(349.into(), &super::use_counter_css_doc::css_color);
        map.insert(350.into(), &super::use_counter_css_doc::css_color_adjust);
        map.insert(351.into(), &super::use_counter_css_doc::css_color_interpolation);
        map.insert(352.into(), &super::use_counter_css_doc::css_color_interpolation_filters);
        map.insert(353.into(), &super::use_counter_css_doc::css_color_scheme);
        map.insert(354.into(), &super::use_counter_css_doc::css_column_count);
        map.insert(355.into(), &super::use_counter_css_doc::css_column_fill);
        map.insert(356.into(), &super::use_counter_css_doc::css_column_gap);
        map.insert(357.into(), &super::use_counter_css_doc::css_column_rule);
        map.insert(358.into(), &super::use_counter_css_doc::css_column_rule_color);
        map.insert(359.into(), &super::use_counter_css_doc::css_column_rule_style);
        map.insert(360.into(), &super::use_counter_css_doc::css_column_rule_width);
        map.insert(361.into(), &super::use_counter_css_doc::css_column_span);
        map.insert(362.into(), &super::use_counter_css_doc::css_column_width);
        map.insert(363.into(), &super::use_counter_css_doc::css_columns);
        map.insert(364.into(), &super::use_counter_css_doc::css_contain);
        map.insert(365.into(), &super::use_counter_css_doc::css_contain_intrinsic_block_size);
        map.insert(366.into(), &super::use_counter_css_doc::css_contain_intrinsic_height);
        map.insert(367.into(), &super::use_counter_css_doc::css_contain_intrinsic_inline_size);
        map.insert(368.into(), &super::use_counter_css_doc::css_contain_intrinsic_size);
        map.insert(369.into(), &super::use_counter_css_doc::css_contain_intrinsic_width);
        map.insert(370.into(), &super::use_counter_css_doc::css_container);
        map.insert(371.into(), &super::use_counter_css_doc::css_container_name);
        map.insert(372.into(), &super::use_counter_css_doc::css_container_type);
        map.insert(373.into(), &super::use_counter_css_doc::css_content);
        map.insert(374.into(), &super::use_counter_css_doc::css_content_visibility);
        map.insert(375.into(), &super::use_counter_css_doc::css_counter_increment);
        map.insert(376.into(), &super::use_counter_css_doc::css_counter_reset);
        map.insert(377.into(), &super::use_counter_css_doc::css_counter_set);
        map.insert(378.into(), &super::use_counter_css_doc::css_cursor);
        map.insert(379.into(), &super::use_counter_css_doc::css_cx);
        map.insert(380.into(), &super::use_counter_css_doc::css_cy);
        map.insert(381.into(), &super::use_counter_css_doc::css_d);
        map.insert(382.into(), &super::use_counter_css_doc::css_direction);
        map.insert(383.into(), &super::use_counter_css_doc::css_display);
        map.insert(384.into(), &super::use_counter_css_doc::css_dominant_baseline);
        map.insert(385.into(), &super::use_counter_css_doc::css_empty_cells);
        map.insert(386.into(), &super::use_counter_css_doc::css_fill);
        map.insert(387.into(), &super::use_counter_css_doc::css_fill_opacity);
        map.insert(388.into(), &super::use_counter_css_doc::css_fill_rule);
        map.insert(389.into(), &super::use_counter_css_doc::css_filter);
        map.insert(390.into(), &super::use_counter_css_doc::css_flex);
        map.insert(391.into(), &super::use_counter_css_doc::css_flex_basis);
        map.insert(392.into(), &super::use_counter_css_doc::css_flex_direction);
        map.insert(393.into(), &super::use_counter_css_doc::css_flex_flow);
        map.insert(394.into(), &super::use_counter_css_doc::css_flex_grow);
        map.insert(395.into(), &super::use_counter_css_doc::css_flex_shrink);
        map.insert(396.into(), &super::use_counter_css_doc::css_flex_wrap);
        map.insert(397.into(), &super::use_counter_css_doc::css_float);
        map.insert(398.into(), &super::use_counter_css_doc::css_flood_color);
        map.insert(399.into(), &super::use_counter_css_doc::css_flood_opacity);
        map.insert(400.into(), &super::use_counter_css_doc::css_font);
        map.insert(401.into(), &super::use_counter_css_doc::css_font_family);
        map.insert(402.into(), &super::use_counter_css_doc::css_font_feature_settings);
        map.insert(403.into(), &super::use_counter_css_doc::css_font_kerning);
        map.insert(404.into(), &super::use_counter_css_doc::css_font_language_override);
        map.insert(405.into(), &super::use_counter_css_doc::css_font_optical_sizing);
        map.insert(406.into(), &super::use_counter_css_doc::css_font_palette);
        map.insert(407.into(), &super::use_counter_css_doc::css_font_size);
        map.insert(408.into(), &super::use_counter_css_doc::css_font_size_adjust);
        map.insert(409.into(), &super::use_counter_css_doc::css_font_stretch);
        map.insert(410.into(), &super::use_counter_css_doc::css_font_style);
        map.insert(411.into(), &super::use_counter_css_doc::css_font_synthesis);
        map.insert(412.into(), &super::use_counter_css_doc::css_font_synthesis_position);
        map.insert(413.into(), &super::use_counter_css_doc::css_font_synthesis_small_caps);
        map.insert(414.into(), &super::use_counter_css_doc::css_font_synthesis_style);
        map.insert(415.into(), &super::use_counter_css_doc::css_font_synthesis_weight);
        map.insert(416.into(), &super::use_counter_css_doc::css_font_variant);
        map.insert(417.into(), &super::use_counter_css_doc::css_font_variant_alternates);
        map.insert(418.into(), &super::use_counter_css_doc::css_font_variant_caps);
        map.insert(419.into(), &super::use_counter_css_doc::css_font_variant_east_asian);
        map.insert(420.into(), &super::use_counter_css_doc::css_font_variant_emoji);
        map.insert(421.into(), &super::use_counter_css_doc::css_font_variant_ligatures);
        map.insert(422.into(), &super::use_counter_css_doc::css_font_variant_numeric);
        map.insert(423.into(), &super::use_counter_css_doc::css_font_variant_position);
        map.insert(424.into(), &super::use_counter_css_doc::css_font_variation_settings);
        map.insert(425.into(), &super::use_counter_css_doc::css_font_weight);
        map.insert(426.into(), &super::use_counter_css_doc::css_forced_color_adjust);
        map.insert(427.into(), &super::use_counter_css_doc::css_gap);
        map.insert(428.into(), &super::use_counter_css_doc::css_grid);
        map.insert(429.into(), &super::use_counter_css_doc::css_grid_area);
        map.insert(430.into(), &super::use_counter_css_doc::css_grid_auto_columns);
        map.insert(431.into(), &super::use_counter_css_doc::css_grid_auto_flow);
        map.insert(432.into(), &super::use_counter_css_doc::css_grid_auto_rows);
        map.insert(433.into(), &super::use_counter_css_doc::css_grid_column);
        map.insert(434.into(), &super::use_counter_css_doc::css_grid_column_end);
        map.insert(435.into(), &super::use_counter_css_doc::css_grid_column_gap);
        map.insert(436.into(), &super::use_counter_css_doc::css_grid_column_start);
        map.insert(437.into(), &super::use_counter_css_doc::css_grid_gap);
        map.insert(438.into(), &super::use_counter_css_doc::css_grid_row);
        map.insert(439.into(), &super::use_counter_css_doc::css_grid_row_end);
        map.insert(440.into(), &super::use_counter_css_doc::css_grid_row_gap);
        map.insert(441.into(), &super::use_counter_css_doc::css_grid_row_start);
        map.insert(442.into(), &super::use_counter_css_doc::css_grid_template);
        map.insert(443.into(), &super::use_counter_css_doc::css_grid_template_areas);
        map.insert(444.into(), &super::use_counter_css_doc::css_grid_template_columns);
        map.insert(445.into(), &super::use_counter_css_doc::css_grid_template_rows);
        map.insert(446.into(), &super::use_counter_css_doc::css_height);
        map.insert(447.into(), &super::use_counter_css_doc::css_hyphenate_character);
        map.insert(448.into(), &super::use_counter_css_doc::css_hyphens);
        map.insert(449.into(), &super::use_counter_css_doc::css_image_orientation);
        map.insert(450.into(), &super::use_counter_css_doc::css_image_rendering);
        map.insert(451.into(), &super::use_counter_css_doc::css_ime_mode);
        map.insert(452.into(), &super::use_counter_css_doc::css_initial_letter);
        map.insert(453.into(), &super::use_counter_css_doc::css_inline_size);
        map.insert(454.into(), &super::use_counter_css_doc::css_inset);
        map.insert(455.into(), &super::use_counter_css_doc::css_inset_area);
        map.insert(456.into(), &super::use_counter_css_doc::css_inset_block);
        map.insert(457.into(), &super::use_counter_css_doc::css_inset_block_end);
        map.insert(458.into(), &super::use_counter_css_doc::css_inset_block_start);
        map.insert(459.into(), &super::use_counter_css_doc::css_inset_inline);
        map.insert(460.into(), &super::use_counter_css_doc::css_inset_inline_end);
        map.insert(461.into(), &super::use_counter_css_doc::css_inset_inline_start);
        map.insert(462.into(), &super::use_counter_css_doc::css_isolation);
        map.insert(463.into(), &super::use_counter_css_doc::css_justify_content);
        map.insert(464.into(), &super::use_counter_css_doc::css_justify_items);
        map.insert(465.into(), &super::use_counter_css_doc::css_justify_self);
        map.insert(466.into(), &super::use_counter_css_doc::css_left);
        map.insert(467.into(), &super::use_counter_css_doc::css_letter_spacing);
        map.insert(468.into(), &super::use_counter_css_doc::css_lighting_color);
        map.insert(469.into(), &super::use_counter_css_doc::css_line_break);
        map.insert(470.into(), &super::use_counter_css_doc::css_line_height);
        map.insert(471.into(), &super::use_counter_css_doc::css_list_style);
        map.insert(472.into(), &super::use_counter_css_doc::css_list_style_image);
        map.insert(473.into(), &super::use_counter_css_doc::css_list_style_position);
        map.insert(474.into(), &super::use_counter_css_doc::css_list_style_type);
        map.insert(475.into(), &super::use_counter_css_doc::css_margin);
        map.insert(476.into(), &super::use_counter_css_doc::css_margin_block);
        map.insert(477.into(), &super::use_counter_css_doc::css_margin_block_end);
        map.insert(478.into(), &super::use_counter_css_doc::css_margin_block_start);
        map.insert(479.into(), &super::use_counter_css_doc::css_margin_bottom);
        map.insert(480.into(), &super::use_counter_css_doc::css_margin_inline);
        map.insert(481.into(), &super::use_counter_css_doc::css_margin_inline_end);
        map.insert(482.into(), &super::use_counter_css_doc::css_margin_inline_start);
        map.insert(483.into(), &super::use_counter_css_doc::css_margin_left);
        map.insert(484.into(), &super::use_counter_css_doc::css_margin_right);
        map.insert(485.into(), &super::use_counter_css_doc::css_margin_top);
        map.insert(486.into(), &super::use_counter_css_doc::css_marker);
        map.insert(487.into(), &super::use_counter_css_doc::css_marker_end);
        map.insert(488.into(), &super::use_counter_css_doc::css_marker_mid);
        map.insert(489.into(), &super::use_counter_css_doc::css_marker_start);
        map.insert(490.into(), &super::use_counter_css_doc::css_mask);
        map.insert(491.into(), &super::use_counter_css_doc::css_mask_clip);
        map.insert(492.into(), &super::use_counter_css_doc::css_mask_composite);
        map.insert(493.into(), &super::use_counter_css_doc::css_mask_image);
        map.insert(494.into(), &super::use_counter_css_doc::css_mask_mode);
        map.insert(495.into(), &super::use_counter_css_doc::css_mask_origin);
        map.insert(496.into(), &super::use_counter_css_doc::css_mask_position);
        map.insert(497.into(), &super::use_counter_css_doc::css_mask_position_x);
        map.insert(498.into(), &super::use_counter_css_doc::css_mask_position_y);
        map.insert(499.into(), &super::use_counter_css_doc::css_mask_repeat);
        map.insert(500.into(), &super::use_counter_css_doc::css_mask_size);
        map.insert(501.into(), &super::use_counter_css_doc::css_mask_type);
        map.insert(502.into(), &super::use_counter_css_doc::css_masonry_auto_flow);
        map.insert(503.into(), &super::use_counter_css_doc::css_math_depth);
        map.insert(504.into(), &super::use_counter_css_doc::css_math_style);
        map.insert(505.into(), &super::use_counter_css_doc::css_max_block_size);
        map.insert(506.into(), &super::use_counter_css_doc::css_max_height);
        map.insert(507.into(), &super::use_counter_css_doc::css_max_inline_size);
        map.insert(508.into(), &super::use_counter_css_doc::css_max_width);
        map.insert(509.into(), &super::use_counter_css_doc::css_min_block_size);
        map.insert(510.into(), &super::use_counter_css_doc::css_min_height);
        map.insert(511.into(), &super::use_counter_css_doc::css_min_inline_size);
        map.insert(512.into(), &super::use_counter_css_doc::css_min_width);
        map.insert(513.into(), &super::use_counter_css_doc::css_mix_blend_mode);
        map.insert(514.into(), &super::use_counter_css_doc::css_moz_animation);
        map.insert(515.into(), &super::use_counter_css_doc::css_moz_animation_delay);
        map.insert(516.into(), &super::use_counter_css_doc::css_moz_animation_direction);
        map.insert(517.into(), &super::use_counter_css_doc::css_moz_animation_duration);
        map.insert(518.into(), &super::use_counter_css_doc::css_moz_animation_fill_mode);
        map.insert(519.into(), &super::use_counter_css_doc::css_moz_animation_iteration_count);
        map.insert(520.into(), &super::use_counter_css_doc::css_moz_animation_name);
        map.insert(521.into(), &super::use_counter_css_doc::css_moz_animation_play_state);
        map.insert(522.into(), &super::use_counter_css_doc::css_moz_animation_timing_function);
        map.insert(523.into(), &super::use_counter_css_doc::css_moz_appearance);
        map.insert(524.into(), &super::use_counter_css_doc::css_moz_backface_visibility);
        map.insert(525.into(), &super::use_counter_css_doc::css_moz_border_end);
        map.insert(526.into(), &super::use_counter_css_doc::css_moz_border_end_color);
        map.insert(527.into(), &super::use_counter_css_doc::css_moz_border_end_style);
        map.insert(528.into(), &super::use_counter_css_doc::css_moz_border_end_width);
        map.insert(529.into(), &super::use_counter_css_doc::css_moz_border_image);
        map.insert(530.into(), &super::use_counter_css_doc::css_moz_border_start);
        map.insert(531.into(), &super::use_counter_css_doc::css_moz_border_start_color);
        map.insert(532.into(), &super::use_counter_css_doc::css_moz_border_start_style);
        map.insert(533.into(), &super::use_counter_css_doc::css_moz_border_start_width);
        map.insert(534.into(), &super::use_counter_css_doc::css_moz_box_align);
        map.insert(535.into(), &super::use_counter_css_doc::css_moz_box_collapse);
        map.insert(536.into(), &super::use_counter_css_doc::css_moz_box_direction);
        map.insert(537.into(), &super::use_counter_css_doc::css_moz_box_flex);
        map.insert(538.into(), &super::use_counter_css_doc::css_moz_box_ordinal_group);
        map.insert(539.into(), &super::use_counter_css_doc::css_moz_box_orient);
        map.insert(540.into(), &super::use_counter_css_doc::css_moz_box_pack);
        map.insert(541.into(), &super::use_counter_css_doc::css_moz_box_sizing);
        map.insert(542.into(), &super::use_counter_css_doc::css_moz_context_properties);
        map.insert(543.into(), &super::use_counter_css_doc::css_moz_control_character_visibility);
        map.insert(544.into(), &super::use_counter_css_doc::css_moz_default_appearance);
        map.insert(545.into(), &super::use_counter_css_doc::css_moz_float_edge);
        map.insert(546.into(), &super::use_counter_css_doc::css_moz_font_feature_settings);
        map.insert(547.into(), &super::use_counter_css_doc::css_moz_font_language_override);
        map.insert(548.into(), &super::use_counter_css_doc::css_moz_force_broken_image_icon);
        map.insert(549.into(), &super::use_counter_css_doc::css_moz_hyphens);
        map.insert(550.into(), &super::use_counter_css_doc::css_moz_inert);
        map.insert(551.into(), &super::use_counter_css_doc::css_moz_margin_end);
        map.insert(552.into(), &super::use_counter_css_doc::css_moz_margin_start);
        map.insert(553.into(), &super::use_counter_css_doc::css_moz_math_variant);
        map.insert(554.into(), &super::use_counter_css_doc::css_moz_min_font_size_ratio);
        map.insert(555.into(), &super::use_counter_css_doc::css_moz_orient);
        map.insert(556.into(), &super::use_counter_css_doc::css_moz_osx_font_smoothing);
        map.insert(557.into(), &super::use_counter_css_doc::css_moz_padding_end);
        map.insert(558.into(), &super::use_counter_css_doc::css_moz_padding_start);
        map.insert(559.into(), &super::use_counter_css_doc::css_moz_perspective);
        map.insert(560.into(), &super::use_counter_css_doc::css_moz_perspective_origin);
        map.insert(561.into(), &super::use_counter_css_doc::css_moz_subtree_hidden_only_visually);
        map.insert(562.into(), &super::use_counter_css_doc::css_moz_tab_size);
        map.insert(563.into(), &super::use_counter_css_doc::css_moz_text_size_adjust);
        map.insert(564.into(), &super::use_counter_css_doc::css_moz_theme);
        map.insert(565.into(), &super::use_counter_css_doc::css_moz_top_layer);
        map.insert(566.into(), &super::use_counter_css_doc::css_moz_transform);
        map.insert(567.into(), &super::use_counter_css_doc::css_moz_transform_origin);
        map.insert(568.into(), &super::use_counter_css_doc::css_moz_transform_style);
        map.insert(569.into(), &super::use_counter_css_doc::css_moz_transition);
        map.insert(570.into(), &super::use_counter_css_doc::css_moz_transition_delay);
        map.insert(571.into(), &super::use_counter_css_doc::css_moz_transition_duration);
        map.insert(572.into(), &super::use_counter_css_doc::css_moz_transition_property);
        map.insert(573.into(), &super::use_counter_css_doc::css_moz_transition_timing_function);
        map.insert(574.into(), &super::use_counter_css_doc::css_moz_user_focus);
        map.insert(575.into(), &super::use_counter_css_doc::css_moz_user_input);
        map.insert(576.into(), &super::use_counter_css_doc::css_moz_user_modify);
        map.insert(577.into(), &super::use_counter_css_doc::css_moz_user_select);
        map.insert(578.into(), &super::use_counter_css_doc::css_moz_window_dragging);
        map.insert(579.into(), &super::use_counter_css_doc::css_moz_window_input_region_margin);
        map.insert(580.into(), &super::use_counter_css_doc::css_moz_window_opacity);
        map.insert(581.into(), &super::use_counter_css_doc::css_moz_window_shadow);
        map.insert(582.into(), &super::use_counter_css_doc::css_moz_window_transform);
        map.insert(583.into(), &super::use_counter_css_doc::css_moz_window_transform_origin);
        map.insert(584.into(), &super::use_counter_css_doc::css_object_fit);
        map.insert(585.into(), &super::use_counter_css_doc::css_object_position);
        map.insert(586.into(), &super::use_counter_css_doc::css_offset);
        map.insert(587.into(), &super::use_counter_css_doc::css_offset_anchor);
        map.insert(588.into(), &super::use_counter_css_doc::css_offset_distance);
        map.insert(589.into(), &super::use_counter_css_doc::css_offset_path);
        map.insert(590.into(), &super::use_counter_css_doc::css_offset_position);
        map.insert(591.into(), &super::use_counter_css_doc::css_offset_rotate);
        map.insert(592.into(), &super::use_counter_css_doc::css_opacity);
        map.insert(593.into(), &super::use_counter_css_doc::css_order);
        map.insert(594.into(), &super::use_counter_css_doc::css_outline);
        map.insert(595.into(), &super::use_counter_css_doc::css_outline_color);
        map.insert(596.into(), &super::use_counter_css_doc::css_outline_offset);
        map.insert(597.into(), &super::use_counter_css_doc::css_outline_style);
        map.insert(598.into(), &super::use_counter_css_doc::css_outline_width);
        map.insert(599.into(), &super::use_counter_css_doc::css_overflow);
        map.insert(600.into(), &super::use_counter_css_doc::css_overflow_anchor);
        map.insert(601.into(), &super::use_counter_css_doc::css_overflow_block);
        map.insert(602.into(), &super::use_counter_css_doc::css_overflow_clip_box);
        map.insert(603.into(), &super::use_counter_css_doc::css_overflow_clip_box_block);
        map.insert(604.into(), &super::use_counter_css_doc::css_overflow_clip_box_inline);
        map.insert(605.into(), &super::use_counter_css_doc::css_overflow_clip_margin);
        map.insert(606.into(), &super::use_counter_css_doc::css_overflow_inline);
        map.insert(607.into(), &super::use_counter_css_doc::css_overflow_wrap);
        map.insert(608.into(), &super::use_counter_css_doc::css_overflow_x);
        map.insert(609.into(), &super::use_counter_css_doc::css_overflow_y);
        map.insert(610.into(), &super::use_counter_css_doc::css_overscroll_behavior);
        map.insert(611.into(), &super::use_counter_css_doc::css_overscroll_behavior_block);
        map.insert(612.into(), &super::use_counter_css_doc::css_overscroll_behavior_inline);
        map.insert(613.into(), &super::use_counter_css_doc::css_overscroll_behavior_x);
        map.insert(614.into(), &super::use_counter_css_doc::css_overscroll_behavior_y);
        map.insert(615.into(), &super::use_counter_css_doc::css_padding);
        map.insert(616.into(), &super::use_counter_css_doc::css_padding_block);
        map.insert(617.into(), &super::use_counter_css_doc::css_padding_block_end);
        map.insert(618.into(), &super::use_counter_css_doc::css_padding_block_start);
        map.insert(619.into(), &super::use_counter_css_doc::css_padding_bottom);
        map.insert(620.into(), &super::use_counter_css_doc::css_padding_inline);
        map.insert(621.into(), &super::use_counter_css_doc::css_padding_inline_end);
        map.insert(622.into(), &super::use_counter_css_doc::css_padding_inline_start);
        map.insert(623.into(), &super::use_counter_css_doc::css_padding_left);
        map.insert(624.into(), &super::use_counter_css_doc::css_padding_right);
        map.insert(625.into(), &super::use_counter_css_doc::css_padding_top);
        map.insert(626.into(), &super::use_counter_css_doc::css_page);
        map.insert(627.into(), &super::use_counter_css_doc::css_page_break_after);
        map.insert(628.into(), &super::use_counter_css_doc::css_page_break_before);
        map.insert(629.into(), &super::use_counter_css_doc::css_page_break_inside);
        map.insert(630.into(), &super::use_counter_css_doc::css_page_orientation);
        map.insert(631.into(), &super::use_counter_css_doc::css_paint_order);
        map.insert(632.into(), &super::use_counter_css_doc::css_perspective);
        map.insert(633.into(), &super::use_counter_css_doc::css_perspective_origin);
        map.insert(634.into(), &super::use_counter_css_doc::css_place_content);
        map.insert(635.into(), &super::use_counter_css_doc::css_place_items);
        map.insert(636.into(), &super::use_counter_css_doc::css_place_self);
        map.insert(637.into(), &super::use_counter_css_doc::css_pointer_events);
        map.insert(638.into(), &super::use_counter_css_doc::css_position);
        map.insert(639.into(), &super::use_counter_css_doc::css_position_anchor);
        map.insert(640.into(), &super::use_counter_css_doc::css_position_try_options);
        map.insert(641.into(), &super::use_counter_css_doc::css_position_try_order);
        map.insert(642.into(), &super::use_counter_css_doc::css_position_visibility);
        map.insert(643.into(), &super::use_counter_css_doc::css_print_color_adjust);
        map.insert(644.into(), &super::use_counter_css_doc::css_quotes);
        map.insert(645.into(), &super::use_counter_css_doc::css_r);
        map.insert(646.into(), &super::use_counter_css_doc::css_resize);
        map.insert(647.into(), &super::use_counter_css_doc::css_right);
        map.insert(648.into(), &super::use_counter_css_doc::css_rotate);
        map.insert(649.into(), &super::use_counter_css_doc::css_row_gap);
        map.insert(650.into(), &super::use_counter_css_doc::css_ruby_align);
        map.insert(651.into(), &super::use_counter_css_doc::css_ruby_position);
        map.insert(652.into(), &super::use_counter_css_doc::css_rx);
        map.insert(653.into(), &super::use_counter_css_doc::css_ry);
        map.insert(654.into(), &super::use_counter_css_doc::css_scale);
        map.insert(655.into(), &super::use_counter_css_doc::css_scroll_behavior);
        map.insert(656.into(), &super::use_counter_css_doc::css_scroll_margin);
        map.insert(657.into(), &super::use_counter_css_doc::css_scroll_margin_block);
        map.insert(658.into(), &super::use_counter_css_doc::css_scroll_margin_block_end);
        map.insert(659.into(), &super::use_counter_css_doc::css_scroll_margin_block_start);
        map.insert(660.into(), &super::use_counter_css_doc::css_scroll_margin_bottom);
        map.insert(661.into(), &super::use_counter_css_doc::css_scroll_margin_inline);
        map.insert(662.into(), &super::use_counter_css_doc::css_scroll_margin_inline_end);
        map.insert(663.into(), &super::use_counter_css_doc::css_scroll_margin_inline_start);
        map.insert(664.into(), &super::use_counter_css_doc::css_scroll_margin_left);
        map.insert(665.into(), &super::use_counter_css_doc::css_scroll_margin_right);
        map.insert(666.into(), &super::use_counter_css_doc::css_scroll_margin_top);
        map.insert(667.into(), &super::use_counter_css_doc::css_scroll_padding);
        map.insert(668.into(), &super::use_counter_css_doc::css_scroll_padding_block);
        map.insert(669.into(), &super::use_counter_css_doc::css_scroll_padding_block_end);
        map.insert(670.into(), &super::use_counter_css_doc::css_scroll_padding_block_start);
        map.insert(671.into(), &super::use_counter_css_doc::css_scroll_padding_bottom);
        map.insert(672.into(), &super::use_counter_css_doc::css_scroll_padding_inline);
        map.insert(673.into(), &super::use_counter_css_doc::css_scroll_padding_inline_end);
        map.insert(674.into(), &super::use_counter_css_doc::css_scroll_padding_inline_start);
        map.insert(675.into(), &super::use_counter_css_doc::css_scroll_padding_left);
        map.insert(676.into(), &super::use_counter_css_doc::css_scroll_padding_right);
        map.insert(677.into(), &super::use_counter_css_doc::css_scroll_padding_top);
        map.insert(678.into(), &super::use_counter_css_doc::css_scroll_snap_align);
        map.insert(679.into(), &super::use_counter_css_doc::css_scroll_snap_stop);
        map.insert(680.into(), &super::use_counter_css_doc::css_scroll_snap_type);
        map.insert(681.into(), &super::use_counter_css_doc::css_scroll_timeline);
        map.insert(682.into(), &super::use_counter_css_doc::css_scroll_timeline_axis);
        map.insert(683.into(), &super::use_counter_css_doc::css_scroll_timeline_name);
        map.insert(684.into(), &super::use_counter_css_doc::css_scrollbar_color);
        map.insert(685.into(), &super::use_counter_css_doc::css_scrollbar_gutter);
        map.insert(686.into(), &super::use_counter_css_doc::css_scrollbar_width);
        map.insert(687.into(), &super::use_counter_css_doc::css_shape_image_threshold);
        map.insert(688.into(), &super::use_counter_css_doc::css_shape_margin);
        map.insert(689.into(), &super::use_counter_css_doc::css_shape_outside);
        map.insert(690.into(), &super::use_counter_css_doc::css_shape_rendering);
        map.insert(691.into(), &super::use_counter_css_doc::css_size);
        map.insert(692.into(), &super::use_counter_css_doc::css_stop_color);
        map.insert(693.into(), &super::use_counter_css_doc::css_stop_opacity);
        map.insert(694.into(), &super::use_counter_css_doc::css_stroke);
        map.insert(695.into(), &super::use_counter_css_doc::css_stroke_dasharray);
        map.insert(696.into(), &super::use_counter_css_doc::css_stroke_dashoffset);
        map.insert(697.into(), &super::use_counter_css_doc::css_stroke_linecap);
        map.insert(698.into(), &super::use_counter_css_doc::css_stroke_linejoin);
        map.insert(699.into(), &super::use_counter_css_doc::css_stroke_miterlimit);
        map.insert(700.into(), &super::use_counter_css_doc::css_stroke_opacity);
        map.insert(701.into(), &super::use_counter_css_doc::css_stroke_width);
        map.insert(702.into(), &super::use_counter_css_doc::css_tab_size);
        map.insert(703.into(), &super::use_counter_css_doc::css_table_layout);
        map.insert(704.into(), &super::use_counter_css_doc::css_text_align);
        map.insert(705.into(), &super::use_counter_css_doc::css_text_align_last);
        map.insert(706.into(), &super::use_counter_css_doc::css_text_anchor);
        map.insert(707.into(), &super::use_counter_css_doc::css_text_combine_upright);
        map.insert(708.into(), &super::use_counter_css_doc::css_text_decoration);
        map.insert(709.into(), &super::use_counter_css_doc::css_text_decoration_color);
        map.insert(710.into(), &super::use_counter_css_doc::css_text_decoration_line);
        map.insert(711.into(), &super::use_counter_css_doc::css_text_decoration_skip_ink);
        map.insert(712.into(), &super::use_counter_css_doc::css_text_decoration_style);
        map.insert(713.into(), &super::use_counter_css_doc::css_text_decoration_thickness);
        map.insert(714.into(), &super::use_counter_css_doc::css_text_emphasis);
        map.insert(715.into(), &super::use_counter_css_doc::css_text_emphasis_color);
        map.insert(716.into(), &super::use_counter_css_doc::css_text_emphasis_position);
        map.insert(717.into(), &super::use_counter_css_doc::css_text_emphasis_style);
        map.insert(718.into(), &super::use_counter_css_doc::css_text_indent);
        map.insert(719.into(), &super::use_counter_css_doc::css_text_justify);
        map.insert(720.into(), &super::use_counter_css_doc::css_text_orientation);
        map.insert(721.into(), &super::use_counter_css_doc::css_text_overflow);
        map.insert(722.into(), &super::use_counter_css_doc::css_text_rendering);
        map.insert(723.into(), &super::use_counter_css_doc::css_text_shadow);
        map.insert(724.into(), &super::use_counter_css_doc::css_text_transform);
        map.insert(725.into(), &super::use_counter_css_doc::css_text_underline_offset);
        map.insert(726.into(), &super::use_counter_css_doc::css_text_underline_position);
        map.insert(727.into(), &super::use_counter_css_doc::css_text_wrap);
        map.insert(728.into(), &super::use_counter_css_doc::css_text_wrap_mode);
        map.insert(729.into(), &super::use_counter_css_doc::css_text_wrap_style);
        map.insert(730.into(), &super::use_counter_css_doc::css_top);
        map.insert(731.into(), &super::use_counter_css_doc::css_touch_action);
        map.insert(732.into(), &super::use_counter_css_doc::css_transform);
        map.insert(733.into(), &super::use_counter_css_doc::css_transform_box);
        map.insert(734.into(), &super::use_counter_css_doc::css_transform_origin);
        map.insert(735.into(), &super::use_counter_css_doc::css_transform_style);
        map.insert(736.into(), &super::use_counter_css_doc::css_transition);
        map.insert(737.into(), &super::use_counter_css_doc::css_transition_behavior);
        map.insert(738.into(), &super::use_counter_css_doc::css_transition_delay);
        map.insert(739.into(), &super::use_counter_css_doc::css_transition_duration);
        map.insert(740.into(), &super::use_counter_css_doc::css_transition_property);
        map.insert(741.into(), &super::use_counter_css_doc::css_transition_timing_function);
        map.insert(742.into(), &super::use_counter_css_doc::css_translate);
        map.insert(743.into(), &super::use_counter_css_doc::css_unicode_bidi);
        map.insert(744.into(), &super::use_counter_css_doc::css_user_select);
        map.insert(745.into(), &super::use_counter_css_doc::css_vector_effect);
        map.insert(746.into(), &super::use_counter_css_doc::css_vertical_align);
        map.insert(747.into(), &super::use_counter_css_doc::css_view_timeline);
        map.insert(748.into(), &super::use_counter_css_doc::css_view_timeline_axis);
        map.insert(749.into(), &super::use_counter_css_doc::css_view_timeline_inset);
        map.insert(750.into(), &super::use_counter_css_doc::css_view_timeline_name);
        map.insert(751.into(), &super::use_counter_css_doc::css_visibility);
        map.insert(752.into(), &super::use_counter_css_doc::css_webkit_align_content);
        map.insert(753.into(), &super::use_counter_css_doc::css_webkit_align_items);
        map.insert(754.into(), &super::use_counter_css_doc::css_webkit_align_self);
        map.insert(755.into(), &super::use_counter_css_doc::css_webkit_animation);
        map.insert(756.into(), &super::use_counter_css_doc::css_webkit_animation_delay);
        map.insert(757.into(), &super::use_counter_css_doc::css_webkit_animation_direction);
        map.insert(758.into(), &super::use_counter_css_doc::css_webkit_animation_duration);
        map.insert(759.into(), &super::use_counter_css_doc::css_webkit_animation_fill_mode);
        map.insert(760.into(), &super::use_counter_css_doc::css_webkit_animation_iteration_count);
        map.insert(761.into(), &super::use_counter_css_doc::css_webkit_animation_name);
        map.insert(762.into(), &super::use_counter_css_doc::css_webkit_animation_play_state);
        map.insert(763.into(), &super::use_counter_css_doc::css_webkit_animation_timing_function);
        map.insert(764.into(), &super::use_counter_css_doc::css_webkit_appearance);
        map.insert(765.into(), &super::use_counter_css_doc::css_webkit_backface_visibility);
        map.insert(766.into(), &super::use_counter_css_doc::css_webkit_background_clip);
        map.insert(767.into(), &super::use_counter_css_doc::css_webkit_background_origin);
        map.insert(768.into(), &super::use_counter_css_doc::css_webkit_background_size);
        map.insert(769.into(), &super::use_counter_css_doc::css_webkit_border_bottom_left_radius);
        map.insert(770.into(), &super::use_counter_css_doc::css_webkit_border_bottom_right_radius);
        map.insert(771.into(), &super::use_counter_css_doc::css_webkit_border_image);
        map.insert(772.into(), &super::use_counter_css_doc::css_webkit_border_radius);
        map.insert(773.into(), &super::use_counter_css_doc::css_webkit_border_top_left_radius);
        map.insert(774.into(), &super::use_counter_css_doc::css_webkit_border_top_right_radius);
        map.insert(775.into(), &super::use_counter_css_doc::css_webkit_box_align);
        map.insert(776.into(), &super::use_counter_css_doc::css_webkit_box_direction);
        map.insert(777.into(), &super::use_counter_css_doc::css_webkit_box_flex);
        map.insert(778.into(), &super::use_counter_css_doc::css_webkit_box_ordinal_group);
        map.insert(779.into(), &super::use_counter_css_doc::css_webkit_box_orient);
        map.insert(780.into(), &super::use_counter_css_doc::css_webkit_box_pack);
        map.insert(781.into(), &super::use_counter_css_doc::css_webkit_box_shadow);
        map.insert(782.into(), &super::use_counter_css_doc::css_webkit_box_sizing);
        map.insert(783.into(), &super::use_counter_css_doc::css_webkit_clip_path);
        map.insert(784.into(), &super::use_counter_css_doc::css_webkit_filter);
        map.insert(785.into(), &super::use_counter_css_doc::css_webkit_flex);
        map.insert(786.into(), &super::use_counter_css_doc::css_webkit_flex_basis);
        map.insert(787.into(), &super::use_counter_css_doc::css_webkit_flex_direction);
        map.insert(788.into(), &super::use_counter_css_doc::css_webkit_flex_flow);
        map.insert(789.into(), &super::use_counter_css_doc::css_webkit_flex_grow);
        map.insert(790.into(), &super::use_counter_css_doc::css_webkit_flex_shrink);
        map.insert(791.into(), &super::use_counter_css_doc::css_webkit_flex_wrap);
        map.insert(792.into(), &super::use_counter_css_doc::css_webkit_font_smoothing);
        map.insert(793.into(), &super::use_counter_css_doc::css_webkit_justify_content);
        map.insert(794.into(), &super::use_counter_css_doc::css_webkit_line_clamp);
        map.insert(795.into(), &super::use_counter_css_doc::css_webkit_mask);
        map.insert(796.into(), &super::use_counter_css_doc::css_webkit_mask_clip);
        map.insert(797.into(), &super::use_counter_css_doc::css_webkit_mask_composite);
        map.insert(798.into(), &super::use_counter_css_doc::css_webkit_mask_image);
        map.insert(799.into(), &super::use_counter_css_doc::css_webkit_mask_origin);
        map.insert(800.into(), &super::use_counter_css_doc::css_webkit_mask_position);
        map.insert(801.into(), &super::use_counter_css_doc::css_webkit_mask_position_x);
        map.insert(802.into(), &super::use_counter_css_doc::css_webkit_mask_position_y);
        map.insert(803.into(), &super::use_counter_css_doc::css_webkit_mask_repeat);
        map.insert(804.into(), &super::use_counter_css_doc::css_webkit_mask_size);
        map.insert(805.into(), &super::use_counter_css_doc::css_webkit_order);
        map.insert(806.into(), &super::use_counter_css_doc::css_webkit_perspective);
        map.insert(807.into(), &super::use_counter_css_doc::css_webkit_perspective_origin);
        map.insert(808.into(), &super::use_counter_css_doc::css_webkit_text_fill_color);
        map.insert(809.into(), &super::use_counter_css_doc::css_webkit_text_security);
        map.insert(810.into(), &super::use_counter_css_doc::css_webkit_text_size_adjust);
        map.insert(811.into(), &super::use_counter_css_doc::css_webkit_text_stroke);
        map.insert(812.into(), &super::use_counter_css_doc::css_webkit_text_stroke_color);
        map.insert(813.into(), &super::use_counter_css_doc::css_webkit_text_stroke_width);
        map.insert(814.into(), &super::use_counter_css_doc::css_webkit_transform);
        map.insert(815.into(), &super::use_counter_css_doc::css_webkit_transform_origin);
        map.insert(816.into(), &super::use_counter_css_doc::css_webkit_transform_style);
        map.insert(817.into(), &super::use_counter_css_doc::css_webkit_transition);
        map.insert(818.into(), &super::use_counter_css_doc::css_webkit_transition_delay);
        map.insert(819.into(), &super::use_counter_css_doc::css_webkit_transition_duration);
        map.insert(820.into(), &super::use_counter_css_doc::css_webkit_transition_property);
        map.insert(821.into(), &super::use_counter_css_doc::css_webkit_transition_timing_function);
        map.insert(822.into(), &super::use_counter_css_doc::css_webkit_user_select);
        map.insert(823.into(), &super::use_counter_css_doc::css_white_space);
        map.insert(824.into(), &super::use_counter_css_doc::css_white_space_collapse);
        map.insert(825.into(), &super::use_counter_css_doc::css_width);
        map.insert(826.into(), &super::use_counter_css_doc::css_will_change);
        map.insert(827.into(), &super::use_counter_css_doc::css_word_break);
        map.insert(828.into(), &super::use_counter_css_doc::css_word_spacing);
        map.insert(829.into(), &super::use_counter_css_doc::css_word_wrap);
        map.insert(830.into(), &super::use_counter_css_doc::css_writing_mode);
        map.insert(831.into(), &super::use_counter_css_doc::css_x);
        map.insert(832.into(), &super::use_counter_css_doc::css_x_lang);
        map.insert(833.into(), &super::use_counter_css_doc::css_x_span);
        map.insert(834.into(), &super::use_counter_css_doc::css_x_text_scale);
        map.insert(835.into(), &super::use_counter_css_doc::css_y);
        map.insert(836.into(), &super::use_counter_css_doc::css_z_index);
        map.insert(837.into(), &super::use_counter_css_doc::css_zoom);
        map.insert(838.into(), &super::use_counter_css_doc::max_zoom);
        map.insert(839.into(), &super::use_counter_css_doc::min_zoom);
        map.insert(840.into(), &super::use_counter_css_doc::orientation);
        map.insert(841.into(), &super::use_counter_css_doc::orphans);
        map.insert(842.into(), &super::use_counter_css_doc::speak);
        map.insert(843.into(), &super::use_counter_css_doc::text_size_adjust);
        map.insert(844.into(), &super::use_counter_css_doc::user_zoom);
        map.insert(845.into(), &super::use_counter_css_doc::webkit_app_region);
        map.insert(846.into(), &super::use_counter_css_doc::webkit_border_after);
        map.insert(847.into(), &super::use_counter_css_doc::webkit_border_after_color);
        map.insert(848.into(), &super::use_counter_css_doc::webkit_border_after_style);
        map.insert(849.into(), &super::use_counter_css_doc::webkit_border_after_width);
        map.insert(850.into(), &super::use_counter_css_doc::webkit_border_before);
        map.insert(851.into(), &super::use_counter_css_doc::webkit_border_before_color);
        map.insert(852.into(), &super::use_counter_css_doc::webkit_border_before_style);
        map.insert(853.into(), &super::use_counter_css_doc::webkit_border_before_width);
        map.insert(854.into(), &super::use_counter_css_doc::webkit_border_end);
        map.insert(855.into(), &super::use_counter_css_doc::webkit_border_end_color);
        map.insert(856.into(), &super::use_counter_css_doc::webkit_border_end_style);
        map.insert(857.into(), &super::use_counter_css_doc::webkit_border_end_width);
        map.insert(858.into(), &super::use_counter_css_doc::webkit_border_horizontal_spacing);
        map.insert(859.into(), &super::use_counter_css_doc::webkit_border_start);
        map.insert(860.into(), &super::use_counter_css_doc::webkit_border_start_color);
        map.insert(861.into(), &super::use_counter_css_doc::webkit_border_start_style);
        map.insert(862.into(), &super::use_counter_css_doc::webkit_border_start_width);
        map.insert(863.into(), &super::use_counter_css_doc::webkit_border_vertical_spacing);
        map.insert(864.into(), &super::use_counter_css_doc::webkit_box_decoration_break);
        map.insert(865.into(), &super::use_counter_css_doc::webkit_box_reflect);
        map.insert(866.into(), &super::use_counter_css_doc::webkit_column_break_after);
        map.insert(867.into(), &super::use_counter_css_doc::webkit_column_break_before);
        map.insert(868.into(), &super::use_counter_css_doc::webkit_column_break_inside);
        map.insert(869.into(), &super::use_counter_css_doc::webkit_column_count);
        map.insert(870.into(), &super::use_counter_css_doc::webkit_column_gap);
        map.insert(871.into(), &super::use_counter_css_doc::webkit_column_rule);
        map.insert(872.into(), &super::use_counter_css_doc::webkit_column_rule_color);
        map.insert(873.into(), &super::use_counter_css_doc::webkit_column_rule_style);
        map.insert(874.into(), &super::use_counter_css_doc::webkit_column_rule_width);
        map.insert(875.into(), &super::use_counter_css_doc::webkit_column_span);
        map.insert(876.into(), &super::use_counter_css_doc::webkit_column_width);
        map.insert(877.into(), &super::use_counter_css_doc::webkit_columns);
        map.insert(878.into(), &super::use_counter_css_doc::webkit_font_feature_settings);
        map.insert(879.into(), &super::use_counter_css_doc::webkit_font_size_delta);
        map.insert(880.into(), &super::use_counter_css_doc::webkit_highlight);
        map.insert(881.into(), &super::use_counter_css_doc::webkit_hyphenate_character);
        map.insert(882.into(), &super::use_counter_css_doc::webkit_line_break);
        map.insert(883.into(), &super::use_counter_css_doc::webkit_locale);
        map.insert(884.into(), &super::use_counter_css_doc::webkit_logical_height);
        map.insert(885.into(), &super::use_counter_css_doc::webkit_logical_width);
        map.insert(886.into(), &super::use_counter_css_doc::webkit_margin_after);
        map.insert(887.into(), &super::use_counter_css_doc::webkit_margin_after_collapse);
        map.insert(888.into(), &super::use_counter_css_doc::webkit_margin_before);
        map.insert(889.into(), &super::use_counter_css_doc::webkit_margin_before_collapse);
        map.insert(890.into(), &super::use_counter_css_doc::webkit_margin_bottom_collapse);
        map.insert(891.into(), &super::use_counter_css_doc::webkit_margin_collapse);
        map.insert(892.into(), &super::use_counter_css_doc::webkit_margin_end);
        map.insert(893.into(), &super::use_counter_css_doc::webkit_margin_start);
        map.insert(894.into(), &super::use_counter_css_doc::webkit_margin_top_collapse);
        map.insert(895.into(), &super::use_counter_css_doc::webkit_mask_box_image);
        map.insert(896.into(), &super::use_counter_css_doc::webkit_mask_box_image_outset);
        map.insert(897.into(), &super::use_counter_css_doc::webkit_mask_box_image_repeat);
        map.insert(898.into(), &super::use_counter_css_doc::webkit_mask_box_image_slice);
        map.insert(899.into(), &super::use_counter_css_doc::webkit_mask_box_image_source);
        map.insert(900.into(), &super::use_counter_css_doc::webkit_mask_box_image_width);
        map.insert(901.into(), &super::use_counter_css_doc::webkit_mask_repeat_x);
        map.insert(902.into(), &super::use_counter_css_doc::webkit_mask_repeat_y);
        map.insert(903.into(), &super::use_counter_css_doc::webkit_max_logical_height);
        map.insert(904.into(), &super::use_counter_css_doc::webkit_max_logical_width);
        map.insert(905.into(), &super::use_counter_css_doc::webkit_min_logical_height);
        map.insert(906.into(), &super::use_counter_css_doc::webkit_min_logical_width);
        map.insert(907.into(), &super::use_counter_css_doc::webkit_opacity);
        map.insert(908.into(), &super::use_counter_css_doc::webkit_padding_after);
        map.insert(909.into(), &super::use_counter_css_doc::webkit_padding_before);
        map.insert(910.into(), &super::use_counter_css_doc::webkit_padding_end);
        map.insert(911.into(), &super::use_counter_css_doc::webkit_padding_start);
        map.insert(912.into(), &super::use_counter_css_doc::webkit_perspective_origin_x);
        map.insert(913.into(), &super::use_counter_css_doc::webkit_perspective_origin_y);
        map.insert(914.into(), &super::use_counter_css_doc::webkit_print_color_adjust);
        map.insert(915.into(), &super::use_counter_css_doc::webkit_rtl_ordering);
        map.insert(916.into(), &super::use_counter_css_doc::webkit_ruby_position);
        map.insert(917.into(), &super::use_counter_css_doc::webkit_shape_image_threshold);
        map.insert(918.into(), &super::use_counter_css_doc::webkit_shape_margin);
        map.insert(919.into(), &super::use_counter_css_doc::webkit_shape_outside);
        map.insert(920.into(), &super::use_counter_css_doc::webkit_tap_highlight_color);
        map.insert(921.into(), &super::use_counter_css_doc::webkit_text_combine);
        map.insert(922.into(), &super::use_counter_css_doc::webkit_text_decorations_in_effect);
        map.insert(923.into(), &super::use_counter_css_doc::webkit_text_emphasis);
        map.insert(924.into(), &super::use_counter_css_doc::webkit_text_emphasis_color);
        map.insert(925.into(), &super::use_counter_css_doc::webkit_text_emphasis_position);
        map.insert(926.into(), &super::use_counter_css_doc::webkit_text_emphasis_style);
        map.insert(927.into(), &super::use_counter_css_doc::webkit_text_orientation);
        map.insert(928.into(), &super::use_counter_css_doc::webkit_transform_origin_x);
        map.insert(929.into(), &super::use_counter_css_doc::webkit_transform_origin_y);
        map.insert(930.into(), &super::use_counter_css_doc::webkit_transform_origin_z);
        map.insert(931.into(), &super::use_counter_css_doc::webkit_user_drag);
        map.insert(932.into(), &super::use_counter_css_doc::webkit_user_modify);
        map.insert(933.into(), &super::use_counter_css_doc::webkit_writing_mode);
        map.insert(934.into(), &super::use_counter_css_doc::widows);
        map.insert(935.into(), &super::use_counter_css_page::alignment_baseline);
        map.insert(936.into(), &super::use_counter_css_page::background_repeat_x);
        map.insert(937.into(), &super::use_counter_css_page::background_repeat_y);
        map.insert(938.into(), &super::use_counter_css_page::baseline_shift);
        map.insert(939.into(), &super::use_counter_css_page::buffered_rendering);
        map.insert(940.into(), &super::use_counter_css_page::color_rendering);
        map.insert(941.into(), &super::use_counter_css_page::css_accent_color);
        map.insert(942.into(), &super::use_counter_css_page::css_align_content);
        map.insert(943.into(), &super::use_counter_css_page::css_align_items);
        map.insert(944.into(), &super::use_counter_css_page::css_align_self);
        map.insert(945.into(), &super::use_counter_css_page::css_all);
        map.insert(946.into(), &super::use_counter_css_page::css_anchor_name);
        map.insert(947.into(), &super::use_counter_css_page::css_anchor_scope);
        map.insert(948.into(), &super::use_counter_css_page::css_animation);
        map.insert(949.into(), &super::use_counter_css_page::css_animation_composition);
        map.insert(950.into(), &super::use_counter_css_page::css_animation_delay);
        map.insert(951.into(), &super::use_counter_css_page::css_animation_direction);
        map.insert(952.into(), &super::use_counter_css_page::css_animation_duration);
        map.insert(953.into(), &super::use_counter_css_page::css_animation_fill_mode);
        map.insert(954.into(), &super::use_counter_css_page::css_animation_iteration_count);
        map.insert(955.into(), &super::use_counter_css_page::css_animation_name);
        map.insert(956.into(), &super::use_counter_css_page::css_animation_play_state);
        map.insert(957.into(), &super::use_counter_css_page::css_animation_timeline);
        map.insert(958.into(), &super::use_counter_css_page::css_animation_timing_function);
        map.insert(959.into(), &super::use_counter_css_page::css_appearance);
        map.insert(960.into(), &super::use_counter_css_page::css_aspect_ratio);
        map.insert(961.into(), &super::use_counter_css_page::css_backdrop_filter);
        map.insert(962.into(), &super::use_counter_css_page::css_backface_visibility);
        map.insert(963.into(), &super::use_counter_css_page::css_background);
        map.insert(964.into(), &super::use_counter_css_page::css_background_attachment);
        map.insert(965.into(), &super::use_counter_css_page::css_background_blend_mode);
        map.insert(966.into(), &super::use_counter_css_page::css_background_clip);
        map.insert(967.into(), &super::use_counter_css_page::css_background_color);
        map.insert(968.into(), &super::use_counter_css_page::css_background_image);
        map.insert(969.into(), &super::use_counter_css_page::css_background_origin);
        map.insert(970.into(), &super::use_counter_css_page::css_background_position);
        map.insert(971.into(), &super::use_counter_css_page::css_background_position_x);
        map.insert(972.into(), &super::use_counter_css_page::css_background_position_y);
        map.insert(973.into(), &super::use_counter_css_page::css_background_repeat);
        map.insert(974.into(), &super::use_counter_css_page::css_background_size);
        map.insert(975.into(), &super::use_counter_css_page::css_baseline_source);
        map.insert(976.into(), &super::use_counter_css_page::css_block_size);
        map.insert(977.into(), &super::use_counter_css_page::css_border);
        map.insert(978.into(), &super::use_counter_css_page::css_border_block);
        map.insert(979.into(), &super::use_counter_css_page::css_border_block_color);
        map.insert(980.into(), &super::use_counter_css_page::css_border_block_end);
        map.insert(981.into(), &super::use_counter_css_page::css_border_block_end_color);
        map.insert(982.into(), &super::use_counter_css_page::css_border_block_end_style);
        map.insert(983.into(), &super::use_counter_css_page::css_border_block_end_width);
        map.insert(984.into(), &super::use_counter_css_page::css_border_block_start);
        map.insert(985.into(), &super::use_counter_css_page::css_border_block_start_color);
        map.insert(986.into(), &super::use_counter_css_page::css_border_block_start_style);
        map.insert(987.into(), &super::use_counter_css_page::css_border_block_start_width);
        map.insert(988.into(), &super::use_counter_css_page::css_border_block_style);
        map.insert(989.into(), &super::use_counter_css_page::css_border_block_width);
        map.insert(990.into(), &super::use_counter_css_page::css_border_bottom);
        map.insert(991.into(), &super::use_counter_css_page::css_border_bottom_color);
        map.insert(992.into(), &super::use_counter_css_page::css_border_bottom_left_radius);
        map.insert(993.into(), &super::use_counter_css_page::css_border_bottom_right_radius);
        map.insert(994.into(), &super::use_counter_css_page::css_border_bottom_style);
        map.insert(995.into(), &super::use_counter_css_page::css_border_bottom_width);
        map.insert(996.into(), &super::use_counter_css_page::css_border_collapse);
        map.insert(997.into(), &super::use_counter_css_page::css_border_color);
        map.insert(998.into(), &super::use_counter_css_page::css_border_end_end_radius);
        map.insert(999.into(), &super::use_counter_css_page::css_border_end_start_radius);
        map.insert(1000.into(), &super::use_counter_css_page::css_border_image);
        map.insert(1001.into(), &super::use_counter_css_page::css_border_image_outset);
        map.insert(1002.into(), &super::use_counter_css_page::css_border_image_repeat);
        map.insert(1003.into(), &super::use_counter_css_page::css_border_image_slice);
        map.insert(1004.into(), &super::use_counter_css_page::css_border_image_source);
        map.insert(1005.into(), &super::use_counter_css_page::css_border_image_width);
        map.insert(1006.into(), &super::use_counter_css_page::css_border_inline);
        map.insert(1007.into(), &super::use_counter_css_page::css_border_inline_color);
        map.insert(1008.into(), &super::use_counter_css_page::css_border_inline_end);
        map.insert(1009.into(), &super::use_counter_css_page::css_border_inline_end_color);
        map.insert(1010.into(), &super::use_counter_css_page::css_border_inline_end_style);
        map.insert(1011.into(), &super::use_counter_css_page::css_border_inline_end_width);
        map.insert(1012.into(), &super::use_counter_css_page::css_border_inline_start);
        map.insert(1013.into(), &super::use_counter_css_page::css_border_inline_start_color);
        map.insert(1014.into(), &super::use_counter_css_page::css_border_inline_start_style);
        map.insert(1015.into(), &super::use_counter_css_page::css_border_inline_start_width);
        map.insert(1016.into(), &super::use_counter_css_page::css_border_inline_style);
        map.insert(1017.into(), &super::use_counter_css_page::css_border_inline_width);
        map.insert(1018.into(), &super::use_counter_css_page::css_border_left);
        map.insert(1019.into(), &super::use_counter_css_page::css_border_left_color);
        map.insert(1020.into(), &super::use_counter_css_page::css_border_left_style);
        map.insert(1021.into(), &super::use_counter_css_page::css_border_left_width);
        map.insert(1022.into(), &super::use_counter_css_page::css_border_radius);
        map.insert(1023.into(), &super::use_counter_css_page::css_border_right);
        map.insert(1024.into(), &super::use_counter_css_page::css_border_right_color);
        map.insert(1025.into(), &super::use_counter_css_page::css_border_right_style);
        map.insert(1026.into(), &super::use_counter_css_page::css_border_right_width);
        map.insert(1027.into(), &super::use_counter_css_page::css_border_spacing);
        map.insert(1028.into(), &super::use_counter_css_page::css_border_start_end_radius);
        map.insert(1029.into(), &super::use_counter_css_page::css_border_start_start_radius);
        map.insert(1030.into(), &super::use_counter_css_page::css_border_style);
        map.insert(1031.into(), &super::use_counter_css_page::css_border_top);
        map.insert(1032.into(), &super::use_counter_css_page::css_border_top_color);
        map.insert(1033.into(), &super::use_counter_css_page::css_border_top_left_radius);
        map.insert(1034.into(), &super::use_counter_css_page::css_border_top_right_radius);
        map.insert(1035.into(), &super::use_counter_css_page::css_border_top_style);
        map.insert(1036.into(), &super::use_counter_css_page::css_border_top_width);
        map.insert(1037.into(), &super::use_counter_css_page::css_border_width);
        map.insert(1038.into(), &super::use_counter_css_page::css_bottom);
        map.insert(1039.into(), &super::use_counter_css_page::css_box_decoration_break);
        map.insert(1040.into(), &super::use_counter_css_page::css_box_shadow);
        map.insert(1041.into(), &super::use_counter_css_page::css_box_sizing);
        map.insert(1042.into(), &super::use_counter_css_page::css_break_after);
        map.insert(1043.into(), &super::use_counter_css_page::css_break_before);
        map.insert(1044.into(), &super::use_counter_css_page::css_break_inside);
        map.insert(1045.into(), &super::use_counter_css_page::css_caption_side);
        map.insert(1046.into(), &super::use_counter_css_page::css_caret_color);
        map.insert(1047.into(), &super::use_counter_css_page::css_clear);
        map.insert(1048.into(), &super::use_counter_css_page::css_clip);
        map.insert(1049.into(), &super::use_counter_css_page::css_clip_path);
        map.insert(1050.into(), &super::use_counter_css_page::css_clip_rule);
        map.insert(1051.into(), &super::use_counter_css_page::css_color);
        map.insert(1052.into(), &super::use_counter_css_page::css_color_adjust);
        map.insert(1053.into(), &super::use_counter_css_page::css_color_interpolation);
        map.insert(1054.into(), &super::use_counter_css_page::css_color_interpolation_filters);
        map.insert(1055.into(), &super::use_counter_css_page::css_color_scheme);
        map.insert(1056.into(), &super::use_counter_css_page::css_column_count);
        map.insert(1057.into(), &super::use_counter_css_page::css_column_fill);
        map.insert(1058.into(), &super::use_counter_css_page::css_column_gap);
        map.insert(1059.into(), &super::use_counter_css_page::css_column_rule);
        map.insert(1060.into(), &super::use_counter_css_page::css_column_rule_color);
        map.insert(1061.into(), &super::use_counter_css_page::css_column_rule_style);
        map.insert(1062.into(), &super::use_counter_css_page::css_column_rule_width);
        map.insert(1063.into(), &super::use_counter_css_page::css_column_span);
        map.insert(1064.into(), &super::use_counter_css_page::css_column_width);
        map.insert(1065.into(), &super::use_counter_css_page::css_columns);
        map.insert(1066.into(), &super::use_counter_css_page::css_contain);
        map.insert(1067.into(), &super::use_counter_css_page::css_contain_intrinsic_block_size);
        map.insert(1068.into(), &super::use_counter_css_page::css_contain_intrinsic_height);
        map.insert(1069.into(), &super::use_counter_css_page::css_contain_intrinsic_inline_size);
        map.insert(1070.into(), &super::use_counter_css_page::css_contain_intrinsic_size);
        map.insert(1071.into(), &super::use_counter_css_page::css_contain_intrinsic_width);
        map.insert(1072.into(), &super::use_counter_css_page::css_container);
        map.insert(1073.into(), &super::use_counter_css_page::css_container_name);
        map.insert(1074.into(), &super::use_counter_css_page::css_container_type);
        map.insert(1075.into(), &super::use_counter_css_page::css_content);
        map.insert(1076.into(), &super::use_counter_css_page::css_content_visibility);
        map.insert(1077.into(), &super::use_counter_css_page::css_counter_increment);
        map.insert(1078.into(), &super::use_counter_css_page::css_counter_reset);
        map.insert(1079.into(), &super::use_counter_css_page::css_counter_set);
        map.insert(1080.into(), &super::use_counter_css_page::css_cursor);
        map.insert(1081.into(), &super::use_counter_css_page::css_cx);
        map.insert(1082.into(), &super::use_counter_css_page::css_cy);
        map.insert(1083.into(), &super::use_counter_css_page::css_d);
        map.insert(1084.into(), &super::use_counter_css_page::css_direction);
        map.insert(1085.into(), &super::use_counter_css_page::css_display);
        map.insert(1086.into(), &super::use_counter_css_page::css_dominant_baseline);
        map.insert(1087.into(), &super::use_counter_css_page::css_empty_cells);
        map.insert(1088.into(), &super::use_counter_css_page::css_fill);
        map.insert(1089.into(), &super::use_counter_css_page::css_fill_opacity);
        map.insert(1090.into(), &super::use_counter_css_page::css_fill_rule);
        map.insert(1091.into(), &super::use_counter_css_page::css_filter);
        map.insert(1092.into(), &super::use_counter_css_page::css_flex);
        map.insert(1093.into(), &super::use_counter_css_page::css_flex_basis);
        map.insert(1094.into(), &super::use_counter_css_page::css_flex_direction);
        map.insert(1095.into(), &super::use_counter_css_page::css_flex_flow);
        map.insert(1096.into(), &super::use_counter_css_page::css_flex_grow);
        map.insert(1097.into(), &super::use_counter_css_page::css_flex_shrink);
        map.insert(1098.into(), &super::use_counter_css_page::css_flex_wrap);
        map.insert(1099.into(), &super::use_counter_css_page::css_float);
        map.insert(1100.into(), &super::use_counter_css_page::css_flood_color);
        map.insert(1101.into(), &super::use_counter_css_page::css_flood_opacity);
        map.insert(1102.into(), &super::use_counter_css_page::css_font);
        map.insert(1103.into(), &super::use_counter_css_page::css_font_family);
        map.insert(1104.into(), &super::use_counter_css_page::css_font_feature_settings);
        map.insert(1105.into(), &super::use_counter_css_page::css_font_kerning);
        map.insert(1106.into(), &super::use_counter_css_page::css_font_language_override);
        map.insert(1107.into(), &super::use_counter_css_page::css_font_optical_sizing);
        map.insert(1108.into(), &super::use_counter_css_page::css_font_palette);
        map.insert(1109.into(), &super::use_counter_css_page::css_font_size);
        map.insert(1110.into(), &super::use_counter_css_page::css_font_size_adjust);
        map.insert(1111.into(), &super::use_counter_css_page::css_font_stretch);
        map.insert(1112.into(), &super::use_counter_css_page::css_font_style);
        map.insert(1113.into(), &super::use_counter_css_page::css_font_synthesis);
        map.insert(1114.into(), &super::use_counter_css_page::css_font_synthesis_position);
        map.insert(1115.into(), &super::use_counter_css_page::css_font_synthesis_small_caps);
        map.insert(1116.into(), &super::use_counter_css_page::css_font_synthesis_style);
        map.insert(1117.into(), &super::use_counter_css_page::css_font_synthesis_weight);
        map.insert(1118.into(), &super::use_counter_css_page::css_font_variant);
        map.insert(1119.into(), &super::use_counter_css_page::css_font_variant_alternates);
        map.insert(1120.into(), &super::use_counter_css_page::css_font_variant_caps);
        map.insert(1121.into(), &super::use_counter_css_page::css_font_variant_east_asian);
        map.insert(1122.into(), &super::use_counter_css_page::css_font_variant_emoji);
        map.insert(1123.into(), &super::use_counter_css_page::css_font_variant_ligatures);
        map.insert(1124.into(), &super::use_counter_css_page::css_font_variant_numeric);
        map.insert(1125.into(), &super::use_counter_css_page::css_font_variant_position);
        map.insert(1126.into(), &super::use_counter_css_page::css_font_variation_settings);
        map.insert(1127.into(), &super::use_counter_css_page::css_font_weight);
        map.insert(1128.into(), &super::use_counter_css_page::css_forced_color_adjust);
        map.insert(1129.into(), &super::use_counter_css_page::css_gap);
        map.insert(1130.into(), &super::use_counter_css_page::css_grid);
        map.insert(1131.into(), &super::use_counter_css_page::css_grid_area);
        map.insert(1132.into(), &super::use_counter_css_page::css_grid_auto_columns);
        map.insert(1133.into(), &super::use_counter_css_page::css_grid_auto_flow);
        map.insert(1134.into(), &super::use_counter_css_page::css_grid_auto_rows);
        map.insert(1135.into(), &super::use_counter_css_page::css_grid_column);
        map.insert(1136.into(), &super::use_counter_css_page::css_grid_column_end);
        map.insert(1137.into(), &super::use_counter_css_page::css_grid_column_gap);
        map.insert(1138.into(), &super::use_counter_css_page::css_grid_column_start);
        map.insert(1139.into(), &super::use_counter_css_page::css_grid_gap);
        map.insert(1140.into(), &super::use_counter_css_page::css_grid_row);
        map.insert(1141.into(), &super::use_counter_css_page::css_grid_row_end);
        map.insert(1142.into(), &super::use_counter_css_page::css_grid_row_gap);
        map.insert(1143.into(), &super::use_counter_css_page::css_grid_row_start);
        map.insert(1144.into(), &super::use_counter_css_page::css_grid_template);
        map.insert(1145.into(), &super::use_counter_css_page::css_grid_template_areas);
        map.insert(1146.into(), &super::use_counter_css_page::css_grid_template_columns);
        map.insert(1147.into(), &super::use_counter_css_page::css_grid_template_rows);
        map.insert(1148.into(), &super::use_counter_css_page::css_height);
        map.insert(1149.into(), &super::use_counter_css_page::css_hyphenate_character);
        map.insert(1150.into(), &super::use_counter_css_page::css_hyphens);
        map.insert(1151.into(), &super::use_counter_css_page::css_image_orientation);
        map.insert(1152.into(), &super::use_counter_css_page::css_image_rendering);
        map.insert(1153.into(), &super::use_counter_css_page::css_ime_mode);
        map.insert(1154.into(), &super::use_counter_css_page::css_initial_letter);
        map.insert(1155.into(), &super::use_counter_css_page::css_inline_size);
        map.insert(1156.into(), &super::use_counter_css_page::css_inset);
        map.insert(1157.into(), &super::use_counter_css_page::css_inset_area);
        map.insert(1158.into(), &super::use_counter_css_page::css_inset_block);
        map.insert(1159.into(), &super::use_counter_css_page::css_inset_block_end);
        map.insert(1160.into(), &super::use_counter_css_page::css_inset_block_start);
        map.insert(1161.into(), &super::use_counter_css_page::css_inset_inline);
        map.insert(1162.into(), &super::use_counter_css_page::css_inset_inline_end);
        map.insert(1163.into(), &super::use_counter_css_page::css_inset_inline_start);
        map.insert(1164.into(), &super::use_counter_css_page::css_isolation);
        map.insert(1165.into(), &super::use_counter_css_page::css_justify_content);
        map.insert(1166.into(), &super::use_counter_css_page::css_justify_items);
        map.insert(1167.into(), &super::use_counter_css_page::css_justify_self);
        map.insert(1168.into(), &super::use_counter_css_page::css_left);
        map.insert(1169.into(), &super::use_counter_css_page::css_letter_spacing);
        map.insert(1170.into(), &super::use_counter_css_page::css_lighting_color);
        map.insert(1171.into(), &super::use_counter_css_page::css_line_break);
        map.insert(1172.into(), &super::use_counter_css_page::css_line_height);
        map.insert(1173.into(), &super::use_counter_css_page::css_list_style);
        map.insert(1174.into(), &super::use_counter_css_page::css_list_style_image);
        map.insert(1175.into(), &super::use_counter_css_page::css_list_style_position);
        map.insert(1176.into(), &super::use_counter_css_page::css_list_style_type);
        map.insert(1177.into(), &super::use_counter_css_page::css_margin);
        map.insert(1178.into(), &super::use_counter_css_page::css_margin_block);
        map.insert(1179.into(), &super::use_counter_css_page::css_margin_block_end);
        map.insert(1180.into(), &super::use_counter_css_page::css_margin_block_start);
        map.insert(1181.into(), &super::use_counter_css_page::css_margin_bottom);
        map.insert(1182.into(), &super::use_counter_css_page::css_margin_inline);
        map.insert(1183.into(), &super::use_counter_css_page::css_margin_inline_end);
        map.insert(1184.into(), &super::use_counter_css_page::css_margin_inline_start);
        map.insert(1185.into(), &super::use_counter_css_page::css_margin_left);
        map.insert(1186.into(), &super::use_counter_css_page::css_margin_right);
        map.insert(1187.into(), &super::use_counter_css_page::css_margin_top);
        map.insert(1188.into(), &super::use_counter_css_page::css_marker);
        map.insert(1189.into(), &super::use_counter_css_page::css_marker_end);
        map.insert(1190.into(), &super::use_counter_css_page::css_marker_mid);
        map.insert(1191.into(), &super::use_counter_css_page::css_marker_start);
        map.insert(1192.into(), &super::use_counter_css_page::css_mask);
        map.insert(1193.into(), &super::use_counter_css_page::css_mask_clip);
        map.insert(1194.into(), &super::use_counter_css_page::css_mask_composite);
        map.insert(1195.into(), &super::use_counter_css_page::css_mask_image);
        map.insert(1196.into(), &super::use_counter_css_page::css_mask_mode);
        map.insert(1197.into(), &super::use_counter_css_page::css_mask_origin);
        map.insert(1198.into(), &super::use_counter_css_page::css_mask_position);
        map.insert(1199.into(), &super::use_counter_css_page::css_mask_position_x);
        map.insert(1200.into(), &super::use_counter_css_page::css_mask_position_y);
        map.insert(1201.into(), &super::use_counter_css_page::css_mask_repeat);
        map.insert(1202.into(), &super::use_counter_css_page::css_mask_size);
        map.insert(1203.into(), &super::use_counter_css_page::css_mask_type);
        map.insert(1204.into(), &super::use_counter_css_page::css_masonry_auto_flow);
        map.insert(1205.into(), &super::use_counter_css_page::css_math_depth);
        map.insert(1206.into(), &super::use_counter_css_page::css_math_style);
        map.insert(1207.into(), &super::use_counter_css_page::css_max_block_size);
        map.insert(1208.into(), &super::use_counter_css_page::css_max_height);
        map.insert(1209.into(), &super::use_counter_css_page::css_max_inline_size);
        map.insert(1210.into(), &super::use_counter_css_page::css_max_width);
        map.insert(1211.into(), &super::use_counter_css_page::css_min_block_size);
        map.insert(1212.into(), &super::use_counter_css_page::css_min_height);
        map.insert(1213.into(), &super::use_counter_css_page::css_min_inline_size);
        map.insert(1214.into(), &super::use_counter_css_page::css_min_width);
        map.insert(1215.into(), &super::use_counter_css_page::css_mix_blend_mode);
        map.insert(1216.into(), &super::use_counter_css_page::css_moz_animation);
        map.insert(1217.into(), &super::use_counter_css_page::css_moz_animation_delay);
        map.insert(1218.into(), &super::use_counter_css_page::css_moz_animation_direction);
        map.insert(1219.into(), &super::use_counter_css_page::css_moz_animation_duration);
        map.insert(1220.into(), &super::use_counter_css_page::css_moz_animation_fill_mode);
        map.insert(1221.into(), &super::use_counter_css_page::css_moz_animation_iteration_count);
        map.insert(1222.into(), &super::use_counter_css_page::css_moz_animation_name);
        map.insert(1223.into(), &super::use_counter_css_page::css_moz_animation_play_state);
        map.insert(1224.into(), &super::use_counter_css_page::css_moz_animation_timing_function);
        map.insert(1225.into(), &super::use_counter_css_page::css_moz_appearance);
        map.insert(1226.into(), &super::use_counter_css_page::css_moz_backface_visibility);
        map.insert(1227.into(), &super::use_counter_css_page::css_moz_border_end);
        map.insert(1228.into(), &super::use_counter_css_page::css_moz_border_end_color);
        map.insert(1229.into(), &super::use_counter_css_page::css_moz_border_end_style);
        map.insert(1230.into(), &super::use_counter_css_page::css_moz_border_end_width);
        map.insert(1231.into(), &super::use_counter_css_page::css_moz_border_image);
        map.insert(1232.into(), &super::use_counter_css_page::css_moz_border_start);
        map.insert(1233.into(), &super::use_counter_css_page::css_moz_border_start_color);
        map.insert(1234.into(), &super::use_counter_css_page::css_moz_border_start_style);
        map.insert(1235.into(), &super::use_counter_css_page::css_moz_border_start_width);
        map.insert(1236.into(), &super::use_counter_css_page::css_moz_box_align);
        map.insert(1237.into(), &super::use_counter_css_page::css_moz_box_collapse);
        map.insert(1238.into(), &super::use_counter_css_page::css_moz_box_direction);
        map.insert(1239.into(), &super::use_counter_css_page::css_moz_box_flex);
        map.insert(1240.into(), &super::use_counter_css_page::css_moz_box_ordinal_group);
        map.insert(1241.into(), &super::use_counter_css_page::css_moz_box_orient);
        map.insert(1242.into(), &super::use_counter_css_page::css_moz_box_pack);
        map.insert(1243.into(), &super::use_counter_css_page::css_moz_box_sizing);
        map.insert(1244.into(), &super::use_counter_css_page::css_moz_context_properties);
        map.insert(1245.into(), &super::use_counter_css_page::css_moz_control_character_visibility);
        map.insert(1246.into(), &super::use_counter_css_page::css_moz_default_appearance);
        map.insert(1247.into(), &super::use_counter_css_page::css_moz_float_edge);
        map.insert(1248.into(), &super::use_counter_css_page::css_moz_font_feature_settings);
        map.insert(1249.into(), &super::use_counter_css_page::css_moz_font_language_override);
        map.insert(1250.into(), &super::use_counter_css_page::css_moz_force_broken_image_icon);
        map.insert(1251.into(), &super::use_counter_css_page::css_moz_hyphens);
        map.insert(1252.into(), &super::use_counter_css_page::css_moz_inert);
        map.insert(1253.into(), &super::use_counter_css_page::css_moz_margin_end);
        map.insert(1254.into(), &super::use_counter_css_page::css_moz_margin_start);
        map.insert(1255.into(), &super::use_counter_css_page::css_moz_math_variant);
        map.insert(1256.into(), &super::use_counter_css_page::css_moz_min_font_size_ratio);
        map.insert(1257.into(), &super::use_counter_css_page::css_moz_orient);
        map.insert(1258.into(), &super::use_counter_css_page::css_moz_osx_font_smoothing);
        map.insert(1259.into(), &super::use_counter_css_page::css_moz_padding_end);
        map.insert(1260.into(), &super::use_counter_css_page::css_moz_padding_start);
        map.insert(1261.into(), &super::use_counter_css_page::css_moz_perspective);
        map.insert(1262.into(), &super::use_counter_css_page::css_moz_perspective_origin);
        map.insert(1263.into(), &super::use_counter_css_page::css_moz_subtree_hidden_only_visually);
        map.insert(1264.into(), &super::use_counter_css_page::css_moz_tab_size);
        map.insert(1265.into(), &super::use_counter_css_page::css_moz_text_size_adjust);
        map.insert(1266.into(), &super::use_counter_css_page::css_moz_theme);
        map.insert(1267.into(), &super::use_counter_css_page::css_moz_top_layer);
        map.insert(1268.into(), &super::use_counter_css_page::css_moz_transform);
        map.insert(1269.into(), &super::use_counter_css_page::css_moz_transform_origin);
        map.insert(1270.into(), &super::use_counter_css_page::css_moz_transform_style);
        map.insert(1271.into(), &super::use_counter_css_page::css_moz_transition);
        map.insert(1272.into(), &super::use_counter_css_page::css_moz_transition_delay);
        map.insert(1273.into(), &super::use_counter_css_page::css_moz_transition_duration);
        map.insert(1274.into(), &super::use_counter_css_page::css_moz_transition_property);
        map.insert(1275.into(), &super::use_counter_css_page::css_moz_transition_timing_function);
        map.insert(1276.into(), &super::use_counter_css_page::css_moz_user_focus);
        map.insert(1277.into(), &super::use_counter_css_page::css_moz_user_input);
        map.insert(1278.into(), &super::use_counter_css_page::css_moz_user_modify);
        map.insert(1279.into(), &super::use_counter_css_page::css_moz_user_select);
        map.insert(1280.into(), &super::use_counter_css_page::css_moz_window_dragging);
        map.insert(1281.into(), &super::use_counter_css_page::css_moz_window_input_region_margin);
        map.insert(1282.into(), &super::use_counter_css_page::css_moz_window_opacity);
        map.insert(1283.into(), &super::use_counter_css_page::css_moz_window_shadow);
        map.insert(1284.into(), &super::use_counter_css_page::css_moz_window_transform);
        map.insert(1285.into(), &super::use_counter_css_page::css_moz_window_transform_origin);
        map.insert(1286.into(), &super::use_counter_css_page::css_object_fit);
        map.insert(1287.into(), &super::use_counter_css_page::css_object_position);
        map.insert(1288.into(), &super::use_counter_css_page::css_offset);
        map.insert(1289.into(), &super::use_counter_css_page::css_offset_anchor);
        map.insert(1290.into(), &super::use_counter_css_page::css_offset_distance);
        map.insert(1291.into(), &super::use_counter_css_page::css_offset_path);
        map.insert(1292.into(), &super::use_counter_css_page::css_offset_position);
        map.insert(1293.into(), &super::use_counter_css_page::css_offset_rotate);
        map.insert(1294.into(), &super::use_counter_css_page::css_opacity);
        map.insert(1295.into(), &super::use_counter_css_page::css_order);
        map.insert(1296.into(), &super::use_counter_css_page::css_outline);
        map.insert(1297.into(), &super::use_counter_css_page::css_outline_color);
        map.insert(1298.into(), &super::use_counter_css_page::css_outline_offset);
        map.insert(1299.into(), &super::use_counter_css_page::css_outline_style);
        map.insert(1300.into(), &super::use_counter_css_page::css_outline_width);
        map.insert(1301.into(), &super::use_counter_css_page::css_overflow);
        map.insert(1302.into(), &super::use_counter_css_page::css_overflow_anchor);
        map.insert(1303.into(), &super::use_counter_css_page::css_overflow_block);
        map.insert(1304.into(), &super::use_counter_css_page::css_overflow_clip_box);
        map.insert(1305.into(), &super::use_counter_css_page::css_overflow_clip_box_block);
        map.insert(1306.into(), &super::use_counter_css_page::css_overflow_clip_box_inline);
        map.insert(1307.into(), &super::use_counter_css_page::css_overflow_clip_margin);
        map.insert(1308.into(), &super::use_counter_css_page::css_overflow_inline);
        map.insert(1309.into(), &super::use_counter_css_page::css_overflow_wrap);
        map.insert(1310.into(), &super::use_counter_css_page::css_overflow_x);
        map.insert(1311.into(), &super::use_counter_css_page::css_overflow_y);
        map.insert(1312.into(), &super::use_counter_css_page::css_overscroll_behavior);
        map.insert(1313.into(), &super::use_counter_css_page::css_overscroll_behavior_block);
        map.insert(1314.into(), &super::use_counter_css_page::css_overscroll_behavior_inline);
        map.insert(1315.into(), &super::use_counter_css_page::css_overscroll_behavior_x);
        map.insert(1316.into(), &super::use_counter_css_page::css_overscroll_behavior_y);
        map.insert(1317.into(), &super::use_counter_css_page::css_padding);
        map.insert(1318.into(), &super::use_counter_css_page::css_padding_block);
        map.insert(1319.into(), &super::use_counter_css_page::css_padding_block_end);
        map.insert(1320.into(), &super::use_counter_css_page::css_padding_block_start);
        map.insert(1321.into(), &super::use_counter_css_page::css_padding_bottom);
        map.insert(1322.into(), &super::use_counter_css_page::css_padding_inline);
        map.insert(1323.into(), &super::use_counter_css_page::css_padding_inline_end);
        map.insert(1324.into(), &super::use_counter_css_page::css_padding_inline_start);
        map.insert(1325.into(), &super::use_counter_css_page::css_padding_left);
        map.insert(1326.into(), &super::use_counter_css_page::css_padding_right);
        map.insert(1327.into(), &super::use_counter_css_page::css_padding_top);
        map.insert(1328.into(), &super::use_counter_css_page::css_page);
        map.insert(1329.into(), &super::use_counter_css_page::css_page_break_after);
        map.insert(1330.into(), &super::use_counter_css_page::css_page_break_before);
        map.insert(1331.into(), &super::use_counter_css_page::css_page_break_inside);
        map.insert(1332.into(), &super::use_counter_css_page::css_page_orientation);
        map.insert(1333.into(), &super::use_counter_css_page::css_paint_order);
        map.insert(1334.into(), &super::use_counter_css_page::css_perspective);
        map.insert(1335.into(), &super::use_counter_css_page::css_perspective_origin);
        map.insert(1336.into(), &super::use_counter_css_page::css_place_content);
        map.insert(1337.into(), &super::use_counter_css_page::css_place_items);
        map.insert(1338.into(), &super::use_counter_css_page::css_place_self);
        map.insert(1339.into(), &super::use_counter_css_page::css_pointer_events);
        map.insert(1340.into(), &super::use_counter_css_page::css_position);
        map.insert(1341.into(), &super::use_counter_css_page::css_position_anchor);
        map.insert(1342.into(), &super::use_counter_css_page::css_position_try_options);
        map.insert(1343.into(), &super::use_counter_css_page::css_position_try_order);
        map.insert(1344.into(), &super::use_counter_css_page::css_position_visibility);
        map.insert(1345.into(), &super::use_counter_css_page::css_print_color_adjust);
        map.insert(1346.into(), &super::use_counter_css_page::css_quotes);
        map.insert(1347.into(), &super::use_counter_css_page::css_r);
        map.insert(1348.into(), &super::use_counter_css_page::css_resize);
        map.insert(1349.into(), &super::use_counter_css_page::css_right);
        map.insert(1350.into(), &super::use_counter_css_page::css_rotate);
        map.insert(1351.into(), &super::use_counter_css_page::css_row_gap);
        map.insert(1352.into(), &super::use_counter_css_page::css_ruby_align);
        map.insert(1353.into(), &super::use_counter_css_page::css_ruby_position);
        map.insert(1354.into(), &super::use_counter_css_page::css_rx);
        map.insert(1355.into(), &super::use_counter_css_page::css_ry);
        map.insert(1356.into(), &super::use_counter_css_page::css_scale);
        map.insert(1357.into(), &super::use_counter_css_page::css_scroll_behavior);
        map.insert(1358.into(), &super::use_counter_css_page::css_scroll_margin);
        map.insert(1359.into(), &super::use_counter_css_page::css_scroll_margin_block);
        map.insert(1360.into(), &super::use_counter_css_page::css_scroll_margin_block_end);
        map.insert(1361.into(), &super::use_counter_css_page::css_scroll_margin_block_start);
        map.insert(1362.into(), &super::use_counter_css_page::css_scroll_margin_bottom);
        map.insert(1363.into(), &super::use_counter_css_page::css_scroll_margin_inline);
        map.insert(1364.into(), &super::use_counter_css_page::css_scroll_margin_inline_end);
        map.insert(1365.into(), &super::use_counter_css_page::css_scroll_margin_inline_start);
        map.insert(1366.into(), &super::use_counter_css_page::css_scroll_margin_left);
        map.insert(1367.into(), &super::use_counter_css_page::css_scroll_margin_right);
        map.insert(1368.into(), &super::use_counter_css_page::css_scroll_margin_top);
        map.insert(1369.into(), &super::use_counter_css_page::css_scroll_padding);
        map.insert(1370.into(), &super::use_counter_css_page::css_scroll_padding_block);
        map.insert(1371.into(), &super::use_counter_css_page::css_scroll_padding_block_end);
        map.insert(1372.into(), &super::use_counter_css_page::css_scroll_padding_block_start);
        map.insert(1373.into(), &super::use_counter_css_page::css_scroll_padding_bottom);
        map.insert(1374.into(), &super::use_counter_css_page::css_scroll_padding_inline);
        map.insert(1375.into(), &super::use_counter_css_page::css_scroll_padding_inline_end);
        map.insert(1376.into(), &super::use_counter_css_page::css_scroll_padding_inline_start);
        map.insert(1377.into(), &super::use_counter_css_page::css_scroll_padding_left);
        map.insert(1378.into(), &super::use_counter_css_page::css_scroll_padding_right);
        map.insert(1379.into(), &super::use_counter_css_page::css_scroll_padding_top);
        map.insert(1380.into(), &super::use_counter_css_page::css_scroll_snap_align);
        map.insert(1381.into(), &super::use_counter_css_page::css_scroll_snap_stop);
        map.insert(1382.into(), &super::use_counter_css_page::css_scroll_snap_type);
        map.insert(1383.into(), &super::use_counter_css_page::css_scroll_timeline);
        map.insert(1384.into(), &super::use_counter_css_page::css_scroll_timeline_axis);
        map.insert(1385.into(), &super::use_counter_css_page::css_scroll_timeline_name);
        map.insert(1386.into(), &super::use_counter_css_page::css_scrollbar_color);
        map.insert(1387.into(), &super::use_counter_css_page::css_scrollbar_gutter);
        map.insert(1388.into(), &super::use_counter_css_page::css_scrollbar_width);
        map.insert(1389.into(), &super::use_counter_css_page::css_shape_image_threshold);
        map.insert(1390.into(), &super::use_counter_css_page::css_shape_margin);
        map.insert(1391.into(), &super::use_counter_css_page::css_shape_outside);
        map.insert(1392.into(), &super::use_counter_css_page::css_shape_rendering);
        map.insert(1393.into(), &super::use_counter_css_page::css_size);
        map.insert(1394.into(), &super::use_counter_css_page::css_stop_color);
        map.insert(1395.into(), &super::use_counter_css_page::css_stop_opacity);
        map.insert(1396.into(), &super::use_counter_css_page::css_stroke);
        map.insert(1397.into(), &super::use_counter_css_page::css_stroke_dasharray);
        map.insert(1398.into(), &super::use_counter_css_page::css_stroke_dashoffset);
        map.insert(1399.into(), &super::use_counter_css_page::css_stroke_linecap);
        map.insert(1400.into(), &super::use_counter_css_page::css_stroke_linejoin);
        map.insert(1401.into(), &super::use_counter_css_page::css_stroke_miterlimit);
        map.insert(1402.into(), &super::use_counter_css_page::css_stroke_opacity);
        map.insert(1403.into(), &super::use_counter_css_page::css_stroke_width);
        map.insert(1404.into(), &super::use_counter_css_page::css_tab_size);
        map.insert(1405.into(), &super::use_counter_css_page::css_table_layout);
        map.insert(1406.into(), &super::use_counter_css_page::css_text_align);
        map.insert(1407.into(), &super::use_counter_css_page::css_text_align_last);
        map.insert(1408.into(), &super::use_counter_css_page::css_text_anchor);
        map.insert(1409.into(), &super::use_counter_css_page::css_text_combine_upright);
        map.insert(1410.into(), &super::use_counter_css_page::css_text_decoration);
        map.insert(1411.into(), &super::use_counter_css_page::css_text_decoration_color);
        map.insert(1412.into(), &super::use_counter_css_page::css_text_decoration_line);
        map.insert(1413.into(), &super::use_counter_css_page::css_text_decoration_skip_ink);
        map.insert(1414.into(), &super::use_counter_css_page::css_text_decoration_style);
        map.insert(1415.into(), &super::use_counter_css_page::css_text_decoration_thickness);
        map.insert(1416.into(), &super::use_counter_css_page::css_text_emphasis);
        map.insert(1417.into(), &super::use_counter_css_page::css_text_emphasis_color);
        map.insert(1418.into(), &super::use_counter_css_page::css_text_emphasis_position);
        map.insert(1419.into(), &super::use_counter_css_page::css_text_emphasis_style);
        map.insert(1420.into(), &super::use_counter_css_page::css_text_indent);
        map.insert(1421.into(), &super::use_counter_css_page::css_text_justify);
        map.insert(1422.into(), &super::use_counter_css_page::css_text_orientation);
        map.insert(1423.into(), &super::use_counter_css_page::css_text_overflow);
        map.insert(1424.into(), &super::use_counter_css_page::css_text_rendering);
        map.insert(1425.into(), &super::use_counter_css_page::css_text_shadow);
        map.insert(1426.into(), &super::use_counter_css_page::css_text_transform);
        map.insert(1427.into(), &super::use_counter_css_page::css_text_underline_offset);
        map.insert(1428.into(), &super::use_counter_css_page::css_text_underline_position);
        map.insert(1429.into(), &super::use_counter_css_page::css_text_wrap);
        map.insert(1430.into(), &super::use_counter_css_page::css_text_wrap_mode);
        map.insert(1431.into(), &super::use_counter_css_page::css_text_wrap_style);
        map.insert(1432.into(), &super::use_counter_css_page::css_top);
        map.insert(1433.into(), &super::use_counter_css_page::css_touch_action);
        map.insert(1434.into(), &super::use_counter_css_page::css_transform);
        map.insert(1435.into(), &super::use_counter_css_page::css_transform_box);
        map.insert(1436.into(), &super::use_counter_css_page::css_transform_origin);
        map.insert(1437.into(), &super::use_counter_css_page::css_transform_style);
        map.insert(1438.into(), &super::use_counter_css_page::css_transition);
        map.insert(1439.into(), &super::use_counter_css_page::css_transition_behavior);
        map.insert(1440.into(), &super::use_counter_css_page::css_transition_delay);
        map.insert(1441.into(), &super::use_counter_css_page::css_transition_duration);
        map.insert(1442.into(), &super::use_counter_css_page::css_transition_property);
        map.insert(1443.into(), &super::use_counter_css_page::css_transition_timing_function);
        map.insert(1444.into(), &super::use_counter_css_page::css_translate);
        map.insert(1445.into(), &super::use_counter_css_page::css_unicode_bidi);
        map.insert(1446.into(), &super::use_counter_css_page::css_user_select);
        map.insert(1447.into(), &super::use_counter_css_page::css_vector_effect);
        map.insert(1448.into(), &super::use_counter_css_page::css_vertical_align);
        map.insert(1449.into(), &super::use_counter_css_page::css_view_timeline);
        map.insert(1450.into(), &super::use_counter_css_page::css_view_timeline_axis);
        map.insert(1451.into(), &super::use_counter_css_page::css_view_timeline_inset);
        map.insert(1452.into(), &super::use_counter_css_page::css_view_timeline_name);
        map.insert(1453.into(), &super::use_counter_css_page::css_visibility);
        map.insert(1454.into(), &super::use_counter_css_page::css_webkit_align_content);
        map.insert(1455.into(), &super::use_counter_css_page::css_webkit_align_items);
        map.insert(1456.into(), &super::use_counter_css_page::css_webkit_align_self);
        map.insert(1457.into(), &super::use_counter_css_page::css_webkit_animation);
        map.insert(1458.into(), &super::use_counter_css_page::css_webkit_animation_delay);
        map.insert(1459.into(), &super::use_counter_css_page::css_webkit_animation_direction);
        map.insert(1460.into(), &super::use_counter_css_page::css_webkit_animation_duration);
        map.insert(1461.into(), &super::use_counter_css_page::css_webkit_animation_fill_mode);
        map.insert(1462.into(), &super::use_counter_css_page::css_webkit_animation_iteration_count);
        map.insert(1463.into(), &super::use_counter_css_page::css_webkit_animation_name);
        map.insert(1464.into(), &super::use_counter_css_page::css_webkit_animation_play_state);
        map.insert(1465.into(), &super::use_counter_css_page::css_webkit_animation_timing_function);
        map.insert(1466.into(), &super::use_counter_css_page::css_webkit_appearance);
        map.insert(1467.into(), &super::use_counter_css_page::css_webkit_backface_visibility);
        map.insert(1468.into(), &super::use_counter_css_page::css_webkit_background_clip);
        map.insert(1469.into(), &super::use_counter_css_page::css_webkit_background_origin);
        map.insert(1470.into(), &super::use_counter_css_page::css_webkit_background_size);
        map.insert(1471.into(), &super::use_counter_css_page::css_webkit_border_bottom_left_radius);
        map.insert(1472.into(), &super::use_counter_css_page::css_webkit_border_bottom_right_radius);
        map.insert(1473.into(), &super::use_counter_css_page::css_webkit_border_image);
        map.insert(1474.into(), &super::use_counter_css_page::css_webkit_border_radius);
        map.insert(1475.into(), &super::use_counter_css_page::css_webkit_border_top_left_radius);
        map.insert(1476.into(), &super::use_counter_css_page::css_webkit_border_top_right_radius);
        map.insert(1477.into(), &super::use_counter_css_page::css_webkit_box_align);
        map.insert(1478.into(), &super::use_counter_css_page::css_webkit_box_direction);
        map.insert(1479.into(), &super::use_counter_css_page::css_webkit_box_flex);
        map.insert(1480.into(), &super::use_counter_css_page::css_webkit_box_ordinal_group);
        map.insert(1481.into(), &super::use_counter_css_page::css_webkit_box_orient);
        map.insert(1482.into(), &super::use_counter_css_page::css_webkit_box_pack);
        map.insert(1483.into(), &super::use_counter_css_page::css_webkit_box_shadow);
        map.insert(1484.into(), &super::use_counter_css_page::css_webkit_box_sizing);
        map.insert(1485.into(), &super::use_counter_css_page::css_webkit_clip_path);
        map.insert(1486.into(), &super::use_counter_css_page::css_webkit_filter);
        map.insert(1487.into(), &super::use_counter_css_page::css_webkit_flex);
        map.insert(1488.into(), &super::use_counter_css_page::css_webkit_flex_basis);
        map.insert(1489.into(), &super::use_counter_css_page::css_webkit_flex_direction);
        map.insert(1490.into(), &super::use_counter_css_page::css_webkit_flex_flow);
        map.insert(1491.into(), &super::use_counter_css_page::css_webkit_flex_grow);
        map.insert(1492.into(), &super::use_counter_css_page::css_webkit_flex_shrink);
        map.insert(1493.into(), &super::use_counter_css_page::css_webkit_flex_wrap);
        map.insert(1494.into(), &super::use_counter_css_page::css_webkit_font_smoothing);
        map.insert(1495.into(), &super::use_counter_css_page::css_webkit_justify_content);
        map.insert(1496.into(), &super::use_counter_css_page::css_webkit_line_clamp);
        map.insert(1497.into(), &super::use_counter_css_page::css_webkit_mask);
        map.insert(1498.into(), &super::use_counter_css_page::css_webkit_mask_clip);
        map.insert(1499.into(), &super::use_counter_css_page::css_webkit_mask_composite);
        map.insert(1500.into(), &super::use_counter_css_page::css_webkit_mask_image);
        map.insert(1501.into(), &super::use_counter_css_page::css_webkit_mask_origin);
        map.insert(1502.into(), &super::use_counter_css_page::css_webkit_mask_position);
        map.insert(1503.into(), &super::use_counter_css_page::css_webkit_mask_position_x);
        map.insert(1504.into(), &super::use_counter_css_page::css_webkit_mask_position_y);
        map.insert(1505.into(), &super::use_counter_css_page::css_webkit_mask_repeat);
        map.insert(1506.into(), &super::use_counter_css_page::css_webkit_mask_size);
        map.insert(1507.into(), &super::use_counter_css_page::css_webkit_order);
        map.insert(1508.into(), &super::use_counter_css_page::css_webkit_perspective);
        map.insert(1509.into(), &super::use_counter_css_page::css_webkit_perspective_origin);
        map.insert(1510.into(), &super::use_counter_css_page::css_webkit_text_fill_color);
        map.insert(1511.into(), &super::use_counter_css_page::css_webkit_text_security);
        map.insert(1512.into(), &super::use_counter_css_page::css_webkit_text_size_adjust);
        map.insert(1513.into(), &super::use_counter_css_page::css_webkit_text_stroke);
        map.insert(1514.into(), &super::use_counter_css_page::css_webkit_text_stroke_color);
        map.insert(1515.into(), &super::use_counter_css_page::css_webkit_text_stroke_width);
        map.insert(1516.into(), &super::use_counter_css_page::css_webkit_transform);
        map.insert(1517.into(), &super::use_counter_css_page::css_webkit_transform_origin);
        map.insert(1518.into(), &super::use_counter_css_page::css_webkit_transform_style);
        map.insert(1519.into(), &super::use_counter_css_page::css_webkit_transition);
        map.insert(1520.into(), &super::use_counter_css_page::css_webkit_transition_delay);
        map.insert(1521.into(), &super::use_counter_css_page::css_webkit_transition_duration);
        map.insert(1522.into(), &super::use_counter_css_page::css_webkit_transition_property);
        map.insert(1523.into(), &super::use_counter_css_page::css_webkit_transition_timing_function);
        map.insert(1524.into(), &super::use_counter_css_page::css_webkit_user_select);
        map.insert(1525.into(), &super::use_counter_css_page::css_white_space);
        map.insert(1526.into(), &super::use_counter_css_page::css_white_space_collapse);
        map.insert(1527.into(), &super::use_counter_css_page::css_width);
        map.insert(1528.into(), &super::use_counter_css_page::css_will_change);
        map.insert(1529.into(), &super::use_counter_css_page::css_word_break);
        map.insert(1530.into(), &super::use_counter_css_page::css_word_spacing);
        map.insert(1531.into(), &super::use_counter_css_page::css_word_wrap);
        map.insert(1532.into(), &super::use_counter_css_page::css_writing_mode);
        map.insert(1533.into(), &super::use_counter_css_page::css_x);
        map.insert(1534.into(), &super::use_counter_css_page::css_x_lang);
        map.insert(1535.into(), &super::use_counter_css_page::css_x_span);
        map.insert(1536.into(), &super::use_counter_css_page::css_x_text_scale);
        map.insert(1537.into(), &super::use_counter_css_page::css_y);
        map.insert(1538.into(), &super::use_counter_css_page::css_z_index);
        map.insert(1539.into(), &super::use_counter_css_page::css_zoom);
        map.insert(1540.into(), &super::use_counter_css_page::max_zoom);
        map.insert(1541.into(), &super::use_counter_css_page::min_zoom);
        map.insert(1542.into(), &super::use_counter_css_page::orientation);
        map.insert(1543.into(), &super::use_counter_css_page::orphans);
        map.insert(1544.into(), &super::use_counter_css_page::speak);
        map.insert(1545.into(), &super::use_counter_css_page::text_size_adjust);
        map.insert(1546.into(), &super::use_counter_css_page::user_zoom);
        map.insert(1547.into(), &super::use_counter_css_page::webkit_app_region);
        map.insert(1548.into(), &super::use_counter_css_page::webkit_border_after);
        map.insert(1549.into(), &super::use_counter_css_page::webkit_border_after_color);
        map.insert(1550.into(), &super::use_counter_css_page::webkit_border_after_style);
        map.insert(1551.into(), &super::use_counter_css_page::webkit_border_after_width);
        map.insert(1552.into(), &super::use_counter_css_page::webkit_border_before);
        map.insert(1553.into(), &super::use_counter_css_page::webkit_border_before_color);
        map.insert(1554.into(), &super::use_counter_css_page::webkit_border_before_style);
        map.insert(1555.into(), &super::use_counter_css_page::webkit_border_before_width);
        map.insert(1556.into(), &super::use_counter_css_page::webkit_border_end);
        map.insert(1557.into(), &super::use_counter_css_page::webkit_border_end_color);
        map.insert(1558.into(), &super::use_counter_css_page::webkit_border_end_style);
        map.insert(1559.into(), &super::use_counter_css_page::webkit_border_end_width);
        map.insert(1560.into(), &super::use_counter_css_page::webkit_border_horizontal_spacing);
        map.insert(1561.into(), &super::use_counter_css_page::webkit_border_start);
        map.insert(1562.into(), &super::use_counter_css_page::webkit_border_start_color);
        map.insert(1563.into(), &super::use_counter_css_page::webkit_border_start_style);
        map.insert(1564.into(), &super::use_counter_css_page::webkit_border_start_width);
        map.insert(1565.into(), &super::use_counter_css_page::webkit_border_vertical_spacing);
        map.insert(1566.into(), &super::use_counter_css_page::webkit_box_decoration_break);
        map.insert(1567.into(), &super::use_counter_css_page::webkit_box_reflect);
        map.insert(1568.into(), &super::use_counter_css_page::webkit_column_break_after);
        map.insert(1569.into(), &super::use_counter_css_page::webkit_column_break_before);
        map.insert(1570.into(), &super::use_counter_css_page::webkit_column_break_inside);
        map.insert(1571.into(), &super::use_counter_css_page::webkit_column_count);
        map.insert(1572.into(), &super::use_counter_css_page::webkit_column_gap);
        map.insert(1573.into(), &super::use_counter_css_page::webkit_column_rule);
        map.insert(1574.into(), &super::use_counter_css_page::webkit_column_rule_color);
        map.insert(1575.into(), &super::use_counter_css_page::webkit_column_rule_style);
        map.insert(1576.into(), &super::use_counter_css_page::webkit_column_rule_width);
        map.insert(1577.into(), &super::use_counter_css_page::webkit_column_span);
        map.insert(1578.into(), &super::use_counter_css_page::webkit_column_width);
        map.insert(1579.into(), &super::use_counter_css_page::webkit_columns);
        map.insert(1580.into(), &super::use_counter_css_page::webkit_font_feature_settings);
        map.insert(1581.into(), &super::use_counter_css_page::webkit_font_size_delta);
        map.insert(1582.into(), &super::use_counter_css_page::webkit_highlight);
        map.insert(1583.into(), &super::use_counter_css_page::webkit_hyphenate_character);
        map.insert(1584.into(), &super::use_counter_css_page::webkit_line_break);
        map.insert(1585.into(), &super::use_counter_css_page::webkit_locale);
        map.insert(1586.into(), &super::use_counter_css_page::webkit_logical_height);
        map.insert(1587.into(), &super::use_counter_css_page::webkit_logical_width);
        map.insert(1588.into(), &super::use_counter_css_page::webkit_margin_after);
        map.insert(1589.into(), &super::use_counter_css_page::webkit_margin_after_collapse);
        map.insert(1590.into(), &super::use_counter_css_page::webkit_margin_before);
        map.insert(1591.into(), &super::use_counter_css_page::webkit_margin_before_collapse);
        map.insert(1592.into(), &super::use_counter_css_page::webkit_margin_bottom_collapse);
        map.insert(1593.into(), &super::use_counter_css_page::webkit_margin_collapse);
        map.insert(1594.into(), &super::use_counter_css_page::webkit_margin_end);
        map.insert(1595.into(), &super::use_counter_css_page::webkit_margin_start);
        map.insert(1596.into(), &super::use_counter_css_page::webkit_margin_top_collapse);
        map.insert(1597.into(), &super::use_counter_css_page::webkit_mask_box_image);
        map.insert(1598.into(), &super::use_counter_css_page::webkit_mask_box_image_outset);
        map.insert(1599.into(), &super::use_counter_css_page::webkit_mask_box_image_repeat);
        map.insert(1600.into(), &super::use_counter_css_page::webkit_mask_box_image_slice);
        map.insert(1601.into(), &super::use_counter_css_page::webkit_mask_box_image_source);
        map.insert(1602.into(), &super::use_counter_css_page::webkit_mask_box_image_width);
        map.insert(1603.into(), &super::use_counter_css_page::webkit_mask_repeat_x);
        map.insert(1604.into(), &super::use_counter_css_page::webkit_mask_repeat_y);
        map.insert(1605.into(), &super::use_counter_css_page::webkit_max_logical_height);
        map.insert(1606.into(), &super::use_counter_css_page::webkit_max_logical_width);
        map.insert(1607.into(), &super::use_counter_css_page::webkit_min_logical_height);
        map.insert(1608.into(), &super::use_counter_css_page::webkit_min_logical_width);
        map.insert(1609.into(), &super::use_counter_css_page::webkit_opacity);
        map.insert(1610.into(), &super::use_counter_css_page::webkit_padding_after);
        map.insert(1611.into(), &super::use_counter_css_page::webkit_padding_before);
        map.insert(1612.into(), &super::use_counter_css_page::webkit_padding_end);
        map.insert(1613.into(), &super::use_counter_css_page::webkit_padding_start);
        map.insert(1614.into(), &super::use_counter_css_page::webkit_perspective_origin_x);
        map.insert(1615.into(), &super::use_counter_css_page::webkit_perspective_origin_y);
        map.insert(1616.into(), &super::use_counter_css_page::webkit_print_color_adjust);
        map.insert(1617.into(), &super::use_counter_css_page::webkit_rtl_ordering);
        map.insert(1618.into(), &super::use_counter_css_page::webkit_ruby_position);
        map.insert(1619.into(), &super::use_counter_css_page::webkit_shape_image_threshold);
        map.insert(1620.into(), &super::use_counter_css_page::webkit_shape_margin);
        map.insert(1621.into(), &super::use_counter_css_page::webkit_shape_outside);
        map.insert(1622.into(), &super::use_counter_css_page::webkit_tap_highlight_color);
        map.insert(1623.into(), &super::use_counter_css_page::webkit_text_combine);
        map.insert(1624.into(), &super::use_counter_css_page::webkit_text_decorations_in_effect);
        map.insert(1625.into(), &super::use_counter_css_page::webkit_text_emphasis);
        map.insert(1626.into(), &super::use_counter_css_page::webkit_text_emphasis_color);
        map.insert(1627.into(), &super::use_counter_css_page::webkit_text_emphasis_position);
        map.insert(1628.into(), &super::use_counter_css_page::webkit_text_emphasis_style);
        map.insert(1629.into(), &super::use_counter_css_page::webkit_text_orientation);
        map.insert(1630.into(), &super::use_counter_css_page::webkit_transform_origin_x);
        map.insert(1631.into(), &super::use_counter_css_page::webkit_transform_origin_y);
        map.insert(1632.into(), &super::use_counter_css_page::webkit_transform_origin_z);
        map.insert(1633.into(), &super::use_counter_css_page::webkit_user_drag);
        map.insert(1634.into(), &super::use_counter_css_page::webkit_user_modify);
        map.insert(1635.into(), &super::use_counter_css_page::webkit_writing_mode);
        map.insert(1636.into(), &super::use_counter_css_page::widows);
        map.insert(1637.into(), &super::use_counter_deprecated_ops_doc::ambient_light_event);
        map.insert(1638.into(), &super::use_counter_deprecated_ops_doc::app_cache);
        map.insert(1639.into(), &super::use_counter_deprecated_ops_doc::components);
        map.insert(1640.into(), &super::use_counter_deprecated_ops_doc::create_image_bitmap_canvas_rendering_context2_d);
        map.insert(1641.into(), &super::use_counter_deprecated_ops_doc::deprecated_testing_attribute);
        map.insert(1642.into(), &super::use_counter_deprecated_ops_doc::deprecated_testing_interface);
        map.insert(1643.into(), &super::use_counter_deprecated_ops_doc::deprecated_testing_method);
        map.insert(1644.into(), &super::use_counter_deprecated_ops_doc::document_release_capture);
        map.insert(1645.into(), &super::use_counter_deprecated_ops_doc::domattr_modified);
        map.insert(1646.into(), &super::use_counter_deprecated_ops_doc::domcharacter_data_modified);
        map.insert(1647.into(), &super::use_counter_deprecated_ops_doc::domnode_inserted);
        map.insert(1648.into(), &super::use_counter_deprecated_ops_doc::domnode_inserted_into_document);
        map.insert(1649.into(), &super::use_counter_deprecated_ops_doc::domnode_removed);
        map.insert(1650.into(), &super::use_counter_deprecated_ops_doc::domnode_removed_from_document);
        map.insert(1651.into(), &super::use_counter_deprecated_ops_doc::domquad_bounds_attr);
        map.insert(1652.into(), &super::use_counter_deprecated_ops_doc::domsubtree_modified);
        map.insert(1653.into(), &super::use_counter_deprecated_ops_doc::draw_window_canvas_rendering_context2_d);
        map.insert(1654.into(), &super::use_counter_deprecated_ops_doc::element_release_capture);
        map.insert(1655.into(), &super::use_counter_deprecated_ops_doc::element_set_capture);
        map.insert(1656.into(), &super::use_counter_deprecated_ops_doc::external__add_search_provider);
        map.insert(1657.into(), &super::use_counter_deprecated_ops_doc::form_submission_untrusted_event);
        map.insert(1658.into(), &super::use_counter_deprecated_ops_doc::idbobject_store_create_index_locale);
        map.insert(1659.into(), &super::use_counter_deprecated_ops_doc::idbopen_dboptions__storage_type);
        map.insert(1660.into(), &super::use_counter_deprecated_ops_doc::image_bitmap_rendering_context__transfer_image_bitmap);
        map.insert(1661.into(), &super::use_counter_deprecated_ops_doc::import_xulinto_content);
        map.insert(1662.into(), &super::use_counter_deprecated_ops_doc::init_mouse_event);
        map.insert(1663.into(), &super::use_counter_deprecated_ops_doc::init_nsmouse_event);
        map.insert(1664.into(), &super::use_counter_deprecated_ops_doc::install_trigger_deprecated);
        map.insert(1665.into(), &super::use_counter_deprecated_ops_doc::install_trigger_install_deprecated);
        map.insert(1666.into(), &super::use_counter_deprecated_ops_doc::lenient_setter);
        map.insert(1667.into(), &super::use_counter_deprecated_ops_doc::lenient_this);
        map.insert(1668.into(), &super::use_counter_deprecated_ops_doc::math_ml__deprecated_math_space_value2);
        map.insert(1669.into(), &super::use_counter_deprecated_ops_doc::math_ml__deprecated_math_variant);
        map.insert(1670.into(), &super::use_counter_deprecated_ops_doc::math_ml__deprecated_stixgeneral_operator_stretching);
        map.insert(1671.into(), &super::use_counter_deprecated_ops_doc::motion_event);
        map.insert(1672.into(), &super::use_counter_deprecated_ops_doc::mouse_event__moz_pressure);
        map.insert(1673.into(), &super::use_counter_deprecated_ops_doc::moz_input_source);
        map.insert(1674.into(), &super::use_counter_deprecated_ops_doc::moz_request_full_screen_deprecated_prefix);
        map.insert(1675.into(), &super::use_counter_deprecated_ops_doc::mozfullscreenchange_deprecated_prefix);
        map.insert(1676.into(), &super::use_counter_deprecated_ops_doc::mozfullscreenerror_deprecated_prefix);
        map.insert(1677.into(), &super::use_counter_deprecated_ops_doc::navigator_get_user_media);
        map.insert(1678.into(), &super::use_counter_deprecated_ops_doc::node_iterator_detach);
        map.insert(1679.into(), &super::use_counter_deprecated_ops_doc::offscreen_canvas_to_blob);
        map.insert(1680.into(), &super::use_counter_deprecated_ops_doc::orientation_event);
        map.insert(1681.into(), &super::use_counter_deprecated_ops_doc::proximity_event);
        map.insert(1682.into(), &super::use_counter_deprecated_ops_doc::rtcpeer_connection_get_streams);
        map.insert(1683.into(), &super::use_counter_deprecated_ops_doc::size_to_content);
        map.insert(1684.into(), &super::use_counter_deprecated_ops_doc::svgdeselect_all);
        map.insert(1685.into(), &super::use_counter_deprecated_ops_doc::svgfarthest_viewport_element);
        map.insert(1686.into(), &super::use_counter_deprecated_ops_doc::svgnearest_viewport_element);
        map.insert(1687.into(), &super::use_counter_deprecated_ops_doc::sync_xmlhttp_request_deprecated);
        map.insert(1688.into(), &super::use_counter_deprecated_ops_doc::use_of_capture_events);
        map.insert(1689.into(), &super::use_counter_deprecated_ops_doc::use_of_release_events);
        map.insert(1690.into(), &super::use_counter_deprecated_ops_doc::webrtc_deprecated_prefix);
        map.insert(1691.into(), &super::use_counter_deprecated_ops_doc::window__cc_ontrollers);
        map.insert(1692.into(), &super::use_counter_deprecated_ops_doc::window_content_untrusted);
        map.insert(1693.into(), &super::use_counter_deprecated_ops_page::ambient_light_event);
        map.insert(1694.into(), &super::use_counter_deprecated_ops_page::app_cache);
        map.insert(1695.into(), &super::use_counter_deprecated_ops_page::components);
        map.insert(1696.into(), &super::use_counter_deprecated_ops_page::create_image_bitmap_canvas_rendering_context2_d);
        map.insert(1697.into(), &super::use_counter_deprecated_ops_page::deprecated_testing_attribute);
        map.insert(1698.into(), &super::use_counter_deprecated_ops_page::deprecated_testing_interface);
        map.insert(1699.into(), &super::use_counter_deprecated_ops_page::deprecated_testing_method);
        map.insert(1700.into(), &super::use_counter_deprecated_ops_page::document_release_capture);
        map.insert(1701.into(), &super::use_counter_deprecated_ops_page::domattr_modified);
        map.insert(1702.into(), &super::use_counter_deprecated_ops_page::domcharacter_data_modified);
        map.insert(1703.into(), &super::use_counter_deprecated_ops_page::domnode_inserted);
        map.insert(1704.into(), &super::use_counter_deprecated_ops_page::domnode_inserted_into_document);
        map.insert(1705.into(), &super::use_counter_deprecated_ops_page::domnode_removed);
        map.insert(1706.into(), &super::use_counter_deprecated_ops_page::domnode_removed_from_document);
        map.insert(1707.into(), &super::use_counter_deprecated_ops_page::domquad_bounds_attr);
        map.insert(1708.into(), &super::use_counter_deprecated_ops_page::domsubtree_modified);
        map.insert(1709.into(), &super::use_counter_deprecated_ops_page::draw_window_canvas_rendering_context2_d);
        map.insert(1710.into(), &super::use_counter_deprecated_ops_page::element_release_capture);
        map.insert(1711.into(), &super::use_counter_deprecated_ops_page::element_set_capture);
        map.insert(1712.into(), &super::use_counter_deprecated_ops_page::external__add_search_provider);
        map.insert(1713.into(), &super::use_counter_deprecated_ops_page::form_submission_untrusted_event);
        map.insert(1714.into(), &super::use_counter_deprecated_ops_page::idbobject_store_create_index_locale);
        map.insert(1715.into(), &super::use_counter_deprecated_ops_page::idbopen_dboptions__storage_type);
        map.insert(1716.into(), &super::use_counter_deprecated_ops_page::image_bitmap_rendering_context__transfer_image_bitmap);
        map.insert(1717.into(), &super::use_counter_deprecated_ops_page::import_xulinto_content);
        map.insert(1718.into(), &super::use_counter_deprecated_ops_page::init_mouse_event);
        map.insert(1719.into(), &super::use_counter_deprecated_ops_page::init_nsmouse_event);
        map.insert(1720.into(), &super::use_counter_deprecated_ops_page::install_trigger_deprecated);
        map.insert(1721.into(), &super::use_counter_deprecated_ops_page::install_trigger_install_deprecated);
        map.insert(1722.into(), &super::use_counter_deprecated_ops_page::lenient_setter);
        map.insert(1723.into(), &super::use_counter_deprecated_ops_page::lenient_this);
        map.insert(1724.into(), &super::use_counter_deprecated_ops_page::math_ml__deprecated_math_space_value2);
        map.insert(1725.into(), &super::use_counter_deprecated_ops_page::math_ml__deprecated_math_variant);
        map.insert(1726.into(), &super::use_counter_deprecated_ops_page::math_ml__deprecated_stixgeneral_operator_stretching);
        map.insert(1727.into(), &super::use_counter_deprecated_ops_page::motion_event);
        map.insert(1728.into(), &super::use_counter_deprecated_ops_page::mouse_event__moz_pressure);
        map.insert(1729.into(), &super::use_counter_deprecated_ops_page::moz_input_source);
        map.insert(1730.into(), &super::use_counter_deprecated_ops_page::moz_request_full_screen_deprecated_prefix);
        map.insert(1731.into(), &super::use_counter_deprecated_ops_page::mozfullscreenchange_deprecated_prefix);
        map.insert(1732.into(), &super::use_counter_deprecated_ops_page::mozfullscreenerror_deprecated_prefix);
        map.insert(1733.into(), &super::use_counter_deprecated_ops_page::navigator_get_user_media);
        map.insert(1734.into(), &super::use_counter_deprecated_ops_page::node_iterator_detach);
        map.insert(1735.into(), &super::use_counter_deprecated_ops_page::offscreen_canvas_to_blob);
        map.insert(1736.into(), &super::use_counter_deprecated_ops_page::orientation_event);
        map.insert(1737.into(), &super::use_counter_deprecated_ops_page::proximity_event);
        map.insert(1738.into(), &super::use_counter_deprecated_ops_page::rtcpeer_connection_get_streams);
        map.insert(1739.into(), &super::use_counter_deprecated_ops_page::size_to_content);
        map.insert(1740.into(), &super::use_counter_deprecated_ops_page::svgdeselect_all);
        map.insert(1741.into(), &super::use_counter_deprecated_ops_page::svgfarthest_viewport_element);
        map.insert(1742.into(), &super::use_counter_deprecated_ops_page::svgnearest_viewport_element);
        map.insert(1743.into(), &super::use_counter_deprecated_ops_page::sync_xmlhttp_request_deprecated);
        map.insert(1744.into(), &super::use_counter_deprecated_ops_page::use_of_capture_events);
        map.insert(1745.into(), &super::use_counter_deprecated_ops_page::use_of_release_events);
        map.insert(1746.into(), &super::use_counter_deprecated_ops_page::webrtc_deprecated_prefix);
        map.insert(1747.into(), &super::use_counter_deprecated_ops_page::window__cc_ontrollers);
        map.insert(1748.into(), &super::use_counter_deprecated_ops_page::window_content_untrusted);
        map.insert(1749.into(), &super::use_counter_doc::clipboard_read);
        map.insert(1750.into(), &super::use_counter_doc::clipboard_readtext);
        map.insert(1751.into(), &super::use_counter_doc::clipboard_write);
        map.insert(1752.into(), &super::use_counter_doc::console_assert);
        map.insert(1753.into(), &super::use_counter_doc::console_clear);
        map.insert(1754.into(), &super::use_counter_doc::console_count);
        map.insert(1755.into(), &super::use_counter_doc::console_countreset);
        map.insert(1756.into(), &super::use_counter_doc::console_debug);
        map.insert(1757.into(), &super::use_counter_doc::console_dir);
        map.insert(1758.into(), &super::use_counter_doc::console_dirxml);
        map.insert(1759.into(), &super::use_counter_doc::console_error);
        map.insert(1760.into(), &super::use_counter_doc::console_exception);
        map.insert(1761.into(), &super::use_counter_doc::console_group);
        map.insert(1762.into(), &super::use_counter_doc::console_groupcollapsed);
        map.insert(1763.into(), &super::use_counter_doc::console_groupend);
        map.insert(1764.into(), &super::use_counter_doc::console_info);
        map.insert(1765.into(), &super::use_counter_doc::console_log);
        map.insert(1766.into(), &super::use_counter_doc::console_profile);
        map.insert(1767.into(), &super::use_counter_doc::console_profileend);
        map.insert(1768.into(), &super::use_counter_doc::console_table);
        map.insert(1769.into(), &super::use_counter_doc::console_time);
        map.insert(1770.into(), &super::use_counter_doc::console_timeend);
        map.insert(1771.into(), &super::use_counter_doc::console_timelog);
        map.insert(1772.into(), &super::use_counter_doc::console_timestamp);
        map.insert(1773.into(), &super::use_counter_doc::console_trace);
        map.insert(1774.into(), &super::use_counter_doc::console_warn);
        map.insert(1775.into(), &super::use_counter_doc::customelementregistry_define);
        map.insert(1776.into(), &super::use_counter_doc::customized_builtin);
        map.insert(1777.into(), &super::use_counter_doc::datatransfer_addelement);
        map.insert(1778.into(), &super::use_counter_doc::datatransfer_mozcleardataat);
        map.insert(1779.into(), &super::use_counter_doc::datatransfer_mozcursor_getter);
        map.insert(1780.into(), &super::use_counter_doc::datatransfer_mozcursor_setter);
        map.insert(1781.into(), &super::use_counter_doc::datatransfer_mozgetdataat);
        map.insert(1782.into(), &super::use_counter_doc::datatransfer_mozitemcount_getter);
        map.insert(1783.into(), &super::use_counter_doc::datatransfer_mozitemcount_setter);
        map.insert(1784.into(), &super::use_counter_doc::datatransfer_mozsetdataat);
        map.insert(1785.into(), &super::use_counter_doc::datatransfer_mozsourcenode_getter);
        map.insert(1786.into(), &super::use_counter_doc::datatransfer_mozsourcenode_setter);
        map.insert(1787.into(), &super::use_counter_doc::datatransfer_moztypesat);
        map.insert(1788.into(), &super::use_counter_doc::datatransfer_mozusercancelled_getter);
        map.insert(1789.into(), &super::use_counter_doc::datatransfer_mozusercancelled_setter);
        map.insert(1790.into(), &super::use_counter_doc::datatransferitem_webkitgetasentry);
        map.insert(1791.into(), &super::use_counter_doc::document_caretrangefrompoint);
        map.insert(1792.into(), &super::use_counter_doc::document_exec_command_content_read_only);
        map.insert(1793.into(), &super::use_counter_doc::document_exitpictureinpicture);
        map.insert(1794.into(), &super::use_counter_doc::document_featurepolicy);
        map.insert(1795.into(), &super::use_counter_doc::document_mozsetimageelement);
        map.insert(1796.into(), &super::use_counter_doc::document_onbeforecopy);
        map.insert(1797.into(), &super::use_counter_doc::document_onbeforecut);
        map.insert(1798.into(), &super::use_counter_doc::document_onbeforepaste);
        map.insert(1799.into(), &super::use_counter_doc::document_oncancel);
        map.insert(1800.into(), &super::use_counter_doc::document_onfreeze);
        map.insert(1801.into(), &super::use_counter_doc::document_onmousewheel);
        map.insert(1802.into(), &super::use_counter_doc::document_onresume);
        map.insert(1803.into(), &super::use_counter_doc::document_onsearch);
        map.insert(1804.into(), &super::use_counter_doc::document_onwebkitfullscreenchange);
        map.insert(1805.into(), &super::use_counter_doc::document_onwebkitfullscreenerror);
        map.insert(1806.into(), &super::use_counter_doc::document_open);
        map.insert(1807.into(), &super::use_counter_doc::document_pictureinpictureelement);
        map.insert(1808.into(), &super::use_counter_doc::document_pictureinpictureenabled);
        map.insert(1809.into(), &super::use_counter_doc::document_query_command_state_or_value_content_read_only);
        map.insert(1810.into(), &super::use_counter_doc::document_query_command_state_or_value_insert_br_on_return);
        map.insert(1811.into(), &super::use_counter_doc::document_query_command_supported_or_enabled_content_read_only);
        map.insert(1812.into(), &super::use_counter_doc::document_query_command_supported_or_enabled_insert_br_on_return);
        map.insert(1813.into(), &super::use_counter_doc::document_registerelement);
        map.insert(1814.into(), &super::use_counter_doc::document_wasdiscarded);
        map.insert(1815.into(), &super::use_counter_doc::document_webkitcancelfullscreen);
        map.insert(1816.into(), &super::use_counter_doc::document_webkitcurrentfullscreenelement);
        map.insert(1817.into(), &super::use_counter_doc::document_webkitexitfullscreen);
        map.insert(1818.into(), &super::use_counter_doc::document_webkitfullscreenelement);
        map.insert(1819.into(), &super::use_counter_doc::document_webkitfullscreenenabled);
        map.insert(1820.into(), &super::use_counter_doc::document_webkithidden);
        map.insert(1821.into(), &super::use_counter_doc::document_webkitisfullscreen);
        map.insert(1822.into(), &super::use_counter_doc::document_webkitvisibilitystate);
        map.insert(1823.into(), &super::use_counter_doc::document_xmlencoding);
        map.insert(1824.into(), &super::use_counter_doc::document_xmlstandalone);
        map.insert(1825.into(), &super::use_counter_doc::document_xmlversion);
        map.insert(1826.into(), &super::use_counter_doc::domparser_parsefromstring);
        map.insert(1827.into(), &super::use_counter_doc::element_attachshadow);
        map.insert(1828.into(), &super::use_counter_doc::element_computedstylemap);
        map.insert(1829.into(), &super::use_counter_doc::element_onmousewheel);
        map.insert(1830.into(), &super::use_counter_doc::element_releasecapture);
        map.insert(1831.into(), &super::use_counter_doc::element_releasepointercapture);
        map.insert(1832.into(), &super::use_counter_doc::element_scrollintoviewifneeded);
        map.insert(1833.into(), &super::use_counter_doc::element_setcapture);
        map.insert(1834.into(), &super::use_counter_doc::element_sethtml);
        map.insert(1835.into(), &super::use_counter_doc::element_setpointercapture);
        map.insert(1836.into(), &super::use_counter_doc::enumerate_devices_insec);
        map.insert(1837.into(), &super::use_counter_doc::enumerate_devices_unfocused);
        map.insert(1838.into(), &super::use_counter_doc::fe_blend);
        map.insert(1839.into(), &super::use_counter_doc::fe_color_matrix);
        map.insert(1840.into(), &super::use_counter_doc::fe_component_transfer);
        map.insert(1841.into(), &super::use_counter_doc::fe_composite);
        map.insert(1842.into(), &super::use_counter_doc::fe_convolve_matrix);
        map.insert(1843.into(), &super::use_counter_doc::fe_diffuse_lighting);
        map.insert(1844.into(), &super::use_counter_doc::fe_displacement_map);
        map.insert(1845.into(), &super::use_counter_doc::fe_flood);
        map.insert(1846.into(), &super::use_counter_doc::fe_gaussian_blur);
        map.insert(1847.into(), &super::use_counter_doc::fe_image);
        map.insert(1848.into(), &super::use_counter_doc::fe_merge);
        map.insert(1849.into(), &super::use_counter_doc::fe_morphology);
        map.insert(1850.into(), &super::use_counter_doc::fe_offset);
        map.insert(1851.into(), &super::use_counter_doc::fe_specular_lighting);
        map.insert(1852.into(), &super::use_counter_doc::fe_tile);
        map.insert(1853.into(), &super::use_counter_doc::fe_turbulence);
        map.insert(1854.into(), &super::use_counter_doc::filtered_cross_origin_iframe);
        map.insert(1855.into(), &super::use_counter_doc::get_user_media_insec);
        map.insert(1856.into(), &super::use_counter_doc::get_user_media_unfocused);
        map.insert(1857.into(), &super::use_counter_doc::htmlbuttonelement_popovertargetaction);
        map.insert(1858.into(), &super::use_counter_doc::htmlbuttonelement_popovertargetelement);
        map.insert(1859.into(), &super::use_counter_doc::htmldialogelement_show);
        map.insert(1860.into(), &super::use_counter_doc::htmldocument_named_getter_hit);
        map.insert(1861.into(), &super::use_counter_doc::htmlelement_attributestylemap);
        map.insert(1862.into(), &super::use_counter_doc::htmlelement_hidepopover);
        map.insert(1863.into(), &super::use_counter_doc::htmlelement_popover);
        map.insert(1864.into(), &super::use_counter_doc::htmlelement_showpopover);
        map.insert(1865.into(), &super::use_counter_doc::htmlelement_togglepopover);
        map.insert(1866.into(), &super::use_counter_doc::htmliframeelement_loading);
        map.insert(1867.into(), &super::use_counter_doc::htmlinputelement_capture);
        map.insert(1868.into(), &super::use_counter_doc::htmlinputelement_incremental);
        map.insert(1869.into(), &super::use_counter_doc::htmlinputelement_onsearch);
        map.insert(1870.into(), &super::use_counter_doc::htmlinputelement_popovertargetaction);
        map.insert(1871.into(), &super::use_counter_doc::htmlinputelement_popovertargetelement);
        map.insert(1872.into(), &super::use_counter_doc::htmlinputelement_webkitdirectory);
        map.insert(1873.into(), &super::use_counter_doc::htmlinputelement_webkitentries);
        map.insert(1874.into(), &super::use_counter_doc::htmlmediaelement_disableremoteplayback);
        map.insert(1875.into(), &super::use_counter_doc::htmlmediaelement_remote);
        map.insert(1876.into(), &super::use_counter_doc::htmlvideoelement_cancelvideoframecallback);
        map.insert(1877.into(), &super::use_counter_doc::htmlvideoelement_disablepictureinpicture);
        map.insert(1878.into(), &super::use_counter_doc::htmlvideoelement_onenterpictureinpicture);
        map.insert(1879.into(), &super::use_counter_doc::htmlvideoelement_onleavepictureinpicture);
        map.insert(1880.into(), &super::use_counter_doc::htmlvideoelement_playsinline);
        map.insert(1881.into(), &super::use_counter_doc::htmlvideoelement_requestpictureinpicture);
        map.insert(1882.into(), &super::use_counter_doc::htmlvideoelement_requestvideoframecallback);
        map.insert(1883.into(), &super::use_counter_doc::imagedata_colorspace);
        map.insert(1884.into(), &super::use_counter_doc::js_asmjs);
        map.insert(1885.into(), &super::use_counter_doc::js_subclassing_array_type_2);
        map.insert(1886.into(), &super::use_counter_doc::js_subclassing_array_type_3);
        map.insert(1887.into(), &super::use_counter_doc::js_subclassing_arraybuffer_type_3);
        map.insert(1888.into(), &super::use_counter_doc::js_subclassing_promise_type_2);
        map.insert(1889.into(), &super::use_counter_doc::js_subclassing_promise_type_3);
        map.insert(1890.into(), &super::use_counter_doc::js_subclassing_regexp_type_3);
        map.insert(1891.into(), &super::use_counter_doc::js_subclassing_regexp_type_4);
        map.insert(1892.into(), &super::use_counter_doc::js_subclassing_sharedarraybuffer_type_3);
        map.insert(1893.into(), &super::use_counter_doc::js_subclassing_typedarray_type_2);
        map.insert(1894.into(), &super::use_counter_doc::js_subclassing_typedarray_type_3);
        map.insert(1895.into(), &super::use_counter_doc::js_wasm);
        map.insert(1896.into(), &super::use_counter_doc::js_wasm_legacy_exceptions);
        map.insert(1897.into(), &super::use_counter_doc::location_ancestororigins);
        map.insert(1898.into(), &super::use_counter_doc::mediadevices_enumeratedevices);
        map.insert(1899.into(), &super::use_counter_doc::mediadevices_getdisplaymedia);
        map.insert(1900.into(), &super::use_counter_doc::mediadevices_getusermedia);
        map.insert(1901.into(), &super::use_counter_doc::mixed_content_not_upgraded_audio_failure);
        map.insert(1902.into(), &super::use_counter_doc::mixed_content_not_upgraded_audio_success);
        map.insert(1903.into(), &super::use_counter_doc::mixed_content_not_upgraded_image_failure);
        map.insert(1904.into(), &super::use_counter_doc::mixed_content_not_upgraded_image_success);
        map.insert(1905.into(), &super::use_counter_doc::mixed_content_not_upgraded_video_failure);
        map.insert(1906.into(), &super::use_counter_doc::mixed_content_not_upgraded_video_success);
        map.insert(1907.into(), &super::use_counter_doc::mixed_content_upgraded_audio_failure);
        map.insert(1908.into(), &super::use_counter_doc::mixed_content_upgraded_audio_success);
        map.insert(1909.into(), &super::use_counter_doc::mixed_content_upgraded_image_failure);
        map.insert(1910.into(), &super::use_counter_doc::mixed_content_upgraded_image_success);
        map.insert(1911.into(), &super::use_counter_doc::mixed_content_upgraded_video_failure);
        map.insert(1912.into(), &super::use_counter_doc::mixed_content_upgraded_video_success);
        map.insert(1913.into(), &super::use_counter_doc::moz_get_user_media_insec);
        map.insert(1914.into(), &super::use_counter_doc::navigator_canshare);
        map.insert(1915.into(), &super::use_counter_doc::navigator_clearappbadge);
        map.insert(1916.into(), &super::use_counter_doc::navigator_mozgetusermedia);
        map.insert(1917.into(), &super::use_counter_doc::navigator_setappbadge);
        map.insert(1918.into(), &super::use_counter_doc::navigator_share);
        map.insert(1919.into(), &super::use_counter_doc::navigator_useractivation);
        map.insert(1920.into(), &super::use_counter_doc::navigator_wakelock);
        map.insert(1921.into(), &super::use_counter_doc::ondommousescroll);
        map.insert(1922.into(), &super::use_counter_doc::onmozmousepixelscroll);
        map.insert(1923.into(), &super::use_counter_doc::onoverflow);
        map.insert(1924.into(), &super::use_counter_doc::onunderflow);
        map.insert(1925.into(), &super::use_counter_doc::percentage_stroke_width_in_svg);
        map.insert(1926.into(), &super::use_counter_doc::percentage_stroke_width_in_svgtext);
        map.insert(1927.into(), &super::use_counter_doc::private_browsing_caches_delete);
        map.insert(1928.into(), &super::use_counter_doc::private_browsing_caches_has);
        map.insert(1929.into(), &super::use_counter_doc::private_browsing_caches_keys);
        map.insert(1930.into(), &super::use_counter_doc::private_browsing_caches_match);
        map.insert(1931.into(), &super::use_counter_doc::private_browsing_caches_open);
        map.insert(1932.into(), &super::use_counter_doc::private_browsing_idbfactory_delete_database);
        map.insert(1933.into(), &super::use_counter_doc::private_browsing_idbfactory_open);
        map.insert(1934.into(), &super::use_counter_doc::private_browsing_navigator_service_worker);
        map.insert(1935.into(), &super::use_counter_doc::pushmanager_subscribe);
        map.insert(1936.into(), &super::use_counter_doc::pushsubscription_unsubscribe);
        map.insert(1937.into(), &super::use_counter_doc::range_createcontextualfragment);
        map.insert(1938.into(), &super::use_counter_doc::sanitizer_constructor);
        map.insert(1939.into(), &super::use_counter_doc::sanitizer_sanitize);
        map.insert(1940.into(), &super::use_counter_doc::scheduler_posttask);
        map.insert(1941.into(), &super::use_counter_doc::shadowroot_pictureinpictureelement);
        map.insert(1942.into(), &super::use_counter_doc::svgsvgelement_currentscale_getter);
        map.insert(1943.into(), &super::use_counter_doc::svgsvgelement_currentscale_setter);
        map.insert(1944.into(), &super::use_counter_doc::svgsvgelement_getelementbyid);
        map.insert(1945.into(), &super::use_counter_doc::window_absoluteorientationsensor);
        map.insert(1946.into(), &super::use_counter_doc::window_accelerometer);
        map.insert(1947.into(), &super::use_counter_doc::window_backgroundfetchmanager);
        map.insert(1948.into(), &super::use_counter_doc::window_backgroundfetchrecord);
        map.insert(1949.into(), &super::use_counter_doc::window_backgroundfetchregistration);
        map.insert(1950.into(), &super::use_counter_doc::window_beforeinstallpromptevent);
        map.insert(1951.into(), &super::use_counter_doc::window_bluetooth);
        map.insert(1952.into(), &super::use_counter_doc::window_bluetoothcharacteristicproperties);
        map.insert(1953.into(), &super::use_counter_doc::window_bluetoothdevice);
        map.insert(1954.into(), &super::use_counter_doc::window_bluetoothremotegattcharacteristic);
        map.insert(1955.into(), &super::use_counter_doc::window_bluetoothremotegattdescriptor);
        map.insert(1956.into(), &super::use_counter_doc::window_bluetoothremotegattserver);
        map.insert(1957.into(), &super::use_counter_doc::window_bluetoothremotegattservice);
        map.insert(1958.into(), &super::use_counter_doc::window_bluetoothuuid);
        map.insert(1959.into(), &super::use_counter_doc::window_canvascapturemediastreamtrack);
        map.insert(1960.into(), &super::use_counter_doc::window_chrome);
        map.insert(1961.into(), &super::use_counter_doc::window_clipboarditem);
        map.insert(1962.into(), &super::use_counter_doc::window_cssimagevalue);
        map.insert(1963.into(), &super::use_counter_doc::window_csskeywordvalue);
        map.insert(1964.into(), &super::use_counter_doc::window_cssmathclamp);
        map.insert(1965.into(), &super::use_counter_doc::window_cssmathinvert);
        map.insert(1966.into(), &super::use_counter_doc::window_cssmathmax);
        map.insert(1967.into(), &super::use_counter_doc::window_cssmathmin);
        map.insert(1968.into(), &super::use_counter_doc::window_cssmathnegate);
        map.insert(1969.into(), &super::use_counter_doc::window_cssmathproduct);
        map.insert(1970.into(), &super::use_counter_doc::window_cssmathsum);
        map.insert(1971.into(), &super::use_counter_doc::window_cssmathvalue);
        map.insert(1972.into(), &super::use_counter_doc::window_cssmatrixcomponent);
        map.insert(1973.into(), &super::use_counter_doc::window_cssnumericarray);
        map.insert(1974.into(), &super::use_counter_doc::window_cssnumericvalue);
        map.insert(1975.into(), &super::use_counter_doc::window_cssperspective);
        map.insert(1976.into(), &super::use_counter_doc::window_csspositionvalue);
        map.insert(1977.into(), &super::use_counter_doc::window_csspropertyrule);
        map.insert(1978.into(), &super::use_counter_doc::window_cssrotate);
        map.insert(1979.into(), &super::use_counter_doc::window_cssscale);
        map.insert(1980.into(), &super::use_counter_doc::window_cssskew);
        map.insert(1981.into(), &super::use_counter_doc::window_cssskewx);
        map.insert(1982.into(), &super::use_counter_doc::window_cssskewy);
        map.insert(1983.into(), &super::use_counter_doc::window_cssstylevalue);
        map.insert(1984.into(), &super::use_counter_doc::window_csstransformcomponent);
        map.insert(1985.into(), &super::use_counter_doc::window_csstransformvalue);
        map.insert(1986.into(), &super::use_counter_doc::window_csstranslate);
        map.insert(1987.into(), &super::use_counter_doc::window_cssunitvalue);
        map.insert(1988.into(), &super::use_counter_doc::window_cssunparsedvalue);
        map.insert(1989.into(), &super::use_counter_doc::window_cssvariablereferencevalue);
        map.insert(1990.into(), &super::use_counter_doc::window_defaultstatus);
        map.insert(1991.into(), &super::use_counter_doc::window_devicemotioneventacceleration);
        map.insert(1992.into(), &super::use_counter_doc::window_devicemotioneventrotationrate);
        map.insert(1993.into(), &super::use_counter_doc::window_domerror);
        map.insert(1994.into(), &super::use_counter_doc::window_encodedvideochunk);
        map.insert(1995.into(), &super::use_counter_doc::window_enterpictureinpictureevent);
        map.insert(1996.into(), &super::use_counter_doc::window_external);
        map.insert(1997.into(), &super::use_counter_doc::window_federatedcredential);
        map.insert(1998.into(), &super::use_counter_doc::window_gyroscope);
        map.insert(1999.into(), &super::use_counter_doc::window_htmlcontentelement);
        map.insert(2000.into(), &super::use_counter_doc::window_htmlshadowelement);
        map.insert(2001.into(), &super::use_counter_doc::window_imagecapture);
        map.insert(2002.into(), &super::use_counter_doc::window_inputdevicecapabilities);
        map.insert(2003.into(), &super::use_counter_doc::window_inputdeviceinfo);
        map.insert(2004.into(), &super::use_counter_doc::window_keyboard);
        map.insert(2005.into(), &super::use_counter_doc::window_keyboardlayoutmap);
        map.insert(2006.into(), &super::use_counter_doc::window_linearaccelerationsensor);
        map.insert(2007.into(), &super::use_counter_doc::window_mediasettingsrange);
        map.insert(2008.into(), &super::use_counter_doc::window_midiaccess);
        map.insert(2009.into(), &super::use_counter_doc::window_midiconnectionevent);
        map.insert(2010.into(), &super::use_counter_doc::window_midiinput);
        map.insert(2011.into(), &super::use_counter_doc::window_midiinputmap);
        map.insert(2012.into(), &super::use_counter_doc::window_midimessageevent);
        map.insert(2013.into(), &super::use_counter_doc::window_midioutput);
        map.insert(2014.into(), &super::use_counter_doc::window_midioutputmap);
        map.insert(2015.into(), &super::use_counter_doc::window_midiport);
        map.insert(2016.into(), &super::use_counter_doc::window_networkinformation);
        map.insert(2017.into(), &super::use_counter_doc::window_offscreenbuffering);
        map.insert(2018.into(), &super::use_counter_doc::window_onbeforeinstallprompt);
        map.insert(2019.into(), &super::use_counter_doc::window_oncancel);
        map.insert(2020.into(), &super::use_counter_doc::window_onmousewheel);
        map.insert(2021.into(), &super::use_counter_doc::window_onorientationchange);
        map.insert(2022.into(), &super::use_counter_doc::window_onsearch);
        map.insert(2023.into(), &super::use_counter_doc::window_onselectionchange);
        map.insert(2024.into(), &super::use_counter_doc::window_open_empty_url);
        map.insert(2025.into(), &super::use_counter_doc::window_opendatabase);
        map.insert(2026.into(), &super::use_counter_doc::window_orientation);
        map.insert(2027.into(), &super::use_counter_doc::window_orientationsensor);
        map.insert(2028.into(), &super::use_counter_doc::window_overconstrainederror);
        map.insert(2029.into(), &super::use_counter_doc::window_passwordcredential);
        map.insert(2030.into(), &super::use_counter_doc::window_paymentaddress);
        map.insert(2031.into(), &super::use_counter_doc::window_paymentinstruments);
        map.insert(2032.into(), &super::use_counter_doc::window_paymentmanager);
        map.insert(2033.into(), &super::use_counter_doc::window_paymentmethodchangeevent);
        map.insert(2034.into(), &super::use_counter_doc::window_paymentrequest);
        map.insert(2035.into(), &super::use_counter_doc::window_paymentrequestupdateevent);
        map.insert(2036.into(), &super::use_counter_doc::window_paymentresponse);
        map.insert(2037.into(), &super::use_counter_doc::window_performancelongtasktiming);
        map.insert(2038.into(), &super::use_counter_doc::window_photocapabilities);
        map.insert(2039.into(), &super::use_counter_doc::window_pictureinpictureevent);
        map.insert(2040.into(), &super::use_counter_doc::window_pictureinpicturewindow);
        map.insert(2041.into(), &super::use_counter_doc::window_presentation);
        map.insert(2042.into(), &super::use_counter_doc::window_presentationavailability);
        map.insert(2043.into(), &super::use_counter_doc::window_presentationconnection);
        map.insert(2044.into(), &super::use_counter_doc::window_presentationconnectionavailableevent);
        map.insert(2045.into(), &super::use_counter_doc::window_presentationconnectioncloseevent);
        map.insert(2046.into(), &super::use_counter_doc::window_presentationconnectionlist);
        map.insert(2047.into(), &super::use_counter_doc::window_presentationreceiver);
        map.insert(2048.into(), &super::use_counter_doc::window_presentationrequest);
        map.insert(2049.into(), &super::use_counter_doc::window_relativeorientationsensor);
        map.insert(2050.into(), &super::use_counter_doc::window_remoteplayback);
        map.insert(2051.into(), &super::use_counter_doc::window_report);
        map.insert(2052.into(), &super::use_counter_doc::window_reportbody);
        map.insert(2053.into(), &super::use_counter_doc::window_reportingobserver);
        map.insert(2054.into(), &super::use_counter_doc::window_rtcerror);
        map.insert(2055.into(), &super::use_counter_doc::window_rtcerrorevent);
        map.insert(2056.into(), &super::use_counter_doc::window_rtcicetransport);
        map.insert(2057.into(), &super::use_counter_doc::window_rtcpeerconnectioniceerrorevent);
        map.insert(2058.into(), &super::use_counter_doc::window_sensor);
        map.insert(2059.into(), &super::use_counter_doc::window_sensorerrorevent);
        map.insert(2060.into(), &super::use_counter_doc::window_sidebar_getter);
        map.insert(2061.into(), &super::use_counter_doc::window_sidebar_setter);
        map.insert(2062.into(), &super::use_counter_doc::window_speechrecognitionalternative);
        map.insert(2063.into(), &super::use_counter_doc::window_speechrecognitionresult);
        map.insert(2064.into(), &super::use_counter_doc::window_speechrecognitionresultlist);
        map.insert(2065.into(), &super::use_counter_doc::window_stylemedia);
        map.insert(2066.into(), &super::use_counter_doc::window_stylepropertymap);
        map.insert(2067.into(), &super::use_counter_doc::window_stylepropertymapreadonly);
        map.insert(2068.into(), &super::use_counter_doc::window_svgdiscardelement);
        map.insert(2069.into(), &super::use_counter_doc::window_syncmanager);
        map.insert(2070.into(), &super::use_counter_doc::window_taskattributiontiming);
        map.insert(2071.into(), &super::use_counter_doc::window_textevent);
        map.insert(2072.into(), &super::use_counter_doc::window_touch);
        map.insert(2073.into(), &super::use_counter_doc::window_touchevent);
        map.insert(2074.into(), &super::use_counter_doc::window_touchlist);
        map.insert(2075.into(), &super::use_counter_doc::window_usb);
        map.insert(2076.into(), &super::use_counter_doc::window_usbalternateinterface);
        map.insert(2077.into(), &super::use_counter_doc::window_usbconfiguration);
        map.insert(2078.into(), &super::use_counter_doc::window_usbconnectionevent);
        map.insert(2079.into(), &super::use_counter_doc::window_usbdevice);
        map.insert(2080.into(), &super::use_counter_doc::window_usbendpoint);
        map.insert(2081.into(), &super::use_counter_doc::window_usbinterface);
        map.insert(2082.into(), &super::use_counter_doc::window_usbintransferresult);
        map.insert(2083.into(), &super::use_counter_doc::window_usbisochronousintransferpacket);
        map.insert(2084.into(), &super::use_counter_doc::window_usbisochronousintransferresult);
        map.insert(2085.into(), &super::use_counter_doc::window_usbisochronousouttransferpacket);
        map.insert(2086.into(), &super::use_counter_doc::window_usbisochronousouttransferresult);
        map.insert(2087.into(), &super::use_counter_doc::window_usbouttransferresult);
        map.insert(2088.into(), &super::use_counter_doc::window_useractivation);
        map.insert(2089.into(), &super::use_counter_doc::window_videocolorspace);
        map.insert(2090.into(), &super::use_counter_doc::window_videodecoder);
        map.insert(2091.into(), &super::use_counter_doc::window_videoencoder);
        map.insert(2092.into(), &super::use_counter_doc::window_videoframe);
        map.insert(2093.into(), &super::use_counter_doc::window_wakelock);
        map.insert(2094.into(), &super::use_counter_doc::window_wakelocksentinel);
        map.insert(2095.into(), &super::use_counter_doc::window_webkitcancelanimationframe);
        map.insert(2096.into(), &super::use_counter_doc::window_webkitmediastream);
        map.insert(2097.into(), &super::use_counter_doc::window_webkitmutationobserver);
        map.insert(2098.into(), &super::use_counter_doc::window_webkitrequestanimationframe);
        map.insert(2099.into(), &super::use_counter_doc::window_webkitrequestfilesystem);
        map.insert(2100.into(), &super::use_counter_doc::window_webkitresolvelocalfilesystemurl);
        map.insert(2101.into(), &super::use_counter_doc::window_webkitrtcpeerconnection);
        map.insert(2102.into(), &super::use_counter_doc::window_webkitspeechgrammar);
        map.insert(2103.into(), &super::use_counter_doc::window_webkitspeechgrammarlist);
        map.insert(2104.into(), &super::use_counter_doc::window_webkitspeechrecognition);
        map.insert(2105.into(), &super::use_counter_doc::window_webkitspeechrecognitionerror);
        map.insert(2106.into(), &super::use_counter_doc::window_webkitspeechrecognitionevent);
        map.insert(2107.into(), &super::use_counter_doc::window_webkitstorageinfo);
        map.insert(2108.into(), &super::use_counter_doc::workernavigator_permissions);
        map.insert(2109.into(), &super::use_counter_doc::wr_filter_fallback);
        map.insert(2110.into(), &super::use_counter_doc::xslstylesheet);
        map.insert(2111.into(), &super::use_counter_doc::xsltprocessor_constructor);
        map.insert(2112.into(), &super::use_counter_doc::you_tube_flash_embed);
        map.insert(2113.into(), &super::use_counter_page::clipboard_read);
        map.insert(2114.into(), &super::use_counter_page::clipboard_readtext);
        map.insert(2115.into(), &super::use_counter_page::clipboard_write);
        map.insert(2116.into(), &super::use_counter_page::console_assert);
        map.insert(2117.into(), &super::use_counter_page::console_clear);
        map.insert(2118.into(), &super::use_counter_page::console_count);
        map.insert(2119.into(), &super::use_counter_page::console_countreset);
        map.insert(2120.into(), &super::use_counter_page::console_debug);
        map.insert(2121.into(), &super::use_counter_page::console_dir);
        map.insert(2122.into(), &super::use_counter_page::console_dirxml);
        map.insert(2123.into(), &super::use_counter_page::console_error);
        map.insert(2124.into(), &super::use_counter_page::console_exception);
        map.insert(2125.into(), &super::use_counter_page::console_group);
        map.insert(2126.into(), &super::use_counter_page::console_groupcollapsed);
        map.insert(2127.into(), &super::use_counter_page::console_groupend);
        map.insert(2128.into(), &super::use_counter_page::console_info);
        map.insert(2129.into(), &super::use_counter_page::console_log);
        map.insert(2130.into(), &super::use_counter_page::console_profile);
        map.insert(2131.into(), &super::use_counter_page::console_profileend);
        map.insert(2132.into(), &super::use_counter_page::console_table);
        map.insert(2133.into(), &super::use_counter_page::console_time);
        map.insert(2134.into(), &super::use_counter_page::console_timeend);
        map.insert(2135.into(), &super::use_counter_page::console_timelog);
        map.insert(2136.into(), &super::use_counter_page::console_timestamp);
        map.insert(2137.into(), &super::use_counter_page::console_trace);
        map.insert(2138.into(), &super::use_counter_page::console_warn);
        map.insert(2139.into(), &super::use_counter_page::customelementregistry_define);
        map.insert(2140.into(), &super::use_counter_page::customized_builtin);
        map.insert(2141.into(), &super::use_counter_page::datatransfer_addelement);
        map.insert(2142.into(), &super::use_counter_page::datatransfer_mozcleardataat);
        map.insert(2143.into(), &super::use_counter_page::datatransfer_mozcursor_getter);
        map.insert(2144.into(), &super::use_counter_page::datatransfer_mozcursor_setter);
        map.insert(2145.into(), &super::use_counter_page::datatransfer_mozgetdataat);
        map.insert(2146.into(), &super::use_counter_page::datatransfer_mozitemcount_getter);
        map.insert(2147.into(), &super::use_counter_page::datatransfer_mozitemcount_setter);
        map.insert(2148.into(), &super::use_counter_page::datatransfer_mozsetdataat);
        map.insert(2149.into(), &super::use_counter_page::datatransfer_mozsourcenode_getter);
        map.insert(2150.into(), &super::use_counter_page::datatransfer_mozsourcenode_setter);
        map.insert(2151.into(), &super::use_counter_page::datatransfer_moztypesat);
        map.insert(2152.into(), &super::use_counter_page::datatransfer_mozusercancelled_getter);
        map.insert(2153.into(), &super::use_counter_page::datatransfer_mozusercancelled_setter);
        map.insert(2154.into(), &super::use_counter_page::datatransferitem_webkitgetasentry);
        map.insert(2155.into(), &super::use_counter_page::document_caretrangefrompoint);
        map.insert(2156.into(), &super::use_counter_page::document_exec_command_content_read_only);
        map.insert(2157.into(), &super::use_counter_page::document_exitpictureinpicture);
        map.insert(2158.into(), &super::use_counter_page::document_featurepolicy);
        map.insert(2159.into(), &super::use_counter_page::document_mozsetimageelement);
        map.insert(2160.into(), &super::use_counter_page::document_onbeforecopy);
        map.insert(2161.into(), &super::use_counter_page::document_onbeforecut);
        map.insert(2162.into(), &super::use_counter_page::document_onbeforepaste);
        map.insert(2163.into(), &super::use_counter_page::document_oncancel);
        map.insert(2164.into(), &super::use_counter_page::document_onfreeze);
        map.insert(2165.into(), &super::use_counter_page::document_onmousewheel);
        map.insert(2166.into(), &super::use_counter_page::document_onresume);
        map.insert(2167.into(), &super::use_counter_page::document_onsearch);
        map.insert(2168.into(), &super::use_counter_page::document_onwebkitfullscreenchange);
        map.insert(2169.into(), &super::use_counter_page::document_onwebkitfullscreenerror);
        map.insert(2170.into(), &super::use_counter_page::document_open);
        map.insert(2171.into(), &super::use_counter_page::document_pictureinpictureelement);
        map.insert(2172.into(), &super::use_counter_page::document_pictureinpictureenabled);
        map.insert(2173.into(), &super::use_counter_page::document_query_command_state_or_value_content_read_only);
        map.insert(2174.into(), &super::use_counter_page::document_query_command_state_or_value_insert_br_on_return);
        map.insert(2175.into(), &super::use_counter_page::document_query_command_supported_or_enabled_content_read_only);
        map.insert(2176.into(), &super::use_counter_page::document_query_command_supported_or_enabled_insert_br_on_return);
        map.insert(2177.into(), &super::use_counter_page::document_registerelement);
        map.insert(2178.into(), &super::use_counter_page::document_wasdiscarded);
        map.insert(2179.into(), &super::use_counter_page::document_webkitcancelfullscreen);
        map.insert(2180.into(), &super::use_counter_page::document_webkitcurrentfullscreenelement);
        map.insert(2181.into(), &super::use_counter_page::document_webkitexitfullscreen);
        map.insert(2182.into(), &super::use_counter_page::document_webkitfullscreenelement);
        map.insert(2183.into(), &super::use_counter_page::document_webkitfullscreenenabled);
        map.insert(2184.into(), &super::use_counter_page::document_webkithidden);
        map.insert(2185.into(), &super::use_counter_page::document_webkitisfullscreen);
        map.insert(2186.into(), &super::use_counter_page::document_webkitvisibilitystate);
        map.insert(2187.into(), &super::use_counter_page::document_xmlencoding);
        map.insert(2188.into(), &super::use_counter_page::document_xmlstandalone);
        map.insert(2189.into(), &super::use_counter_page::document_xmlversion);
        map.insert(2190.into(), &super::use_counter_page::domparser_parsefromstring);
        map.insert(2191.into(), &super::use_counter_page::element_attachshadow);
        map.insert(2192.into(), &super::use_counter_page::element_computedstylemap);
        map.insert(2193.into(), &super::use_counter_page::element_onmousewheel);
        map.insert(2194.into(), &super::use_counter_page::element_releasecapture);
        map.insert(2195.into(), &super::use_counter_page::element_releasepointercapture);
        map.insert(2196.into(), &super::use_counter_page::element_scrollintoviewifneeded);
        map.insert(2197.into(), &super::use_counter_page::element_setcapture);
        map.insert(2198.into(), &super::use_counter_page::element_sethtml);
        map.insert(2199.into(), &super::use_counter_page::element_setpointercapture);
        map.insert(2200.into(), &super::use_counter_page::enumerate_devices_insec);
        map.insert(2201.into(), &super::use_counter_page::enumerate_devices_unfocused);
        map.insert(2202.into(), &super::use_counter_page::fe_blend);
        map.insert(2203.into(), &super::use_counter_page::fe_color_matrix);
        map.insert(2204.into(), &super::use_counter_page::fe_component_transfer);
        map.insert(2205.into(), &super::use_counter_page::fe_composite);
        map.insert(2206.into(), &super::use_counter_page::fe_convolve_matrix);
        map.insert(2207.into(), &super::use_counter_page::fe_diffuse_lighting);
        map.insert(2208.into(), &super::use_counter_page::fe_displacement_map);
        map.insert(2209.into(), &super::use_counter_page::fe_flood);
        map.insert(2210.into(), &super::use_counter_page::fe_gaussian_blur);
        map.insert(2211.into(), &super::use_counter_page::fe_image);
        map.insert(2212.into(), &super::use_counter_page::fe_merge);
        map.insert(2213.into(), &super::use_counter_page::fe_morphology);
        map.insert(2214.into(), &super::use_counter_page::fe_offset);
        map.insert(2215.into(), &super::use_counter_page::fe_specular_lighting);
        map.insert(2216.into(), &super::use_counter_page::fe_tile);
        map.insert(2217.into(), &super::use_counter_page::fe_turbulence);
        map.insert(2218.into(), &super::use_counter_page::filtered_cross_origin_iframe);
        map.insert(2219.into(), &super::use_counter_page::get_user_media_insec);
        map.insert(2220.into(), &super::use_counter_page::get_user_media_unfocused);
        map.insert(2221.into(), &super::use_counter_page::htmlbuttonelement_popovertargetaction);
        map.insert(2222.into(), &super::use_counter_page::htmlbuttonelement_popovertargetelement);
        map.insert(2223.into(), &super::use_counter_page::htmldialogelement_show);
        map.insert(2224.into(), &super::use_counter_page::htmldocument_named_getter_hit);
        map.insert(2225.into(), &super::use_counter_page::htmlelement_attributestylemap);
        map.insert(2226.into(), &super::use_counter_page::htmlelement_hidepopover);
        map.insert(2227.into(), &super::use_counter_page::htmlelement_popover);
        map.insert(2228.into(), &super::use_counter_page::htmlelement_showpopover);
        map.insert(2229.into(), &super::use_counter_page::htmlelement_togglepopover);
        map.insert(2230.into(), &super::use_counter_page::htmliframeelement_loading);
        map.insert(2231.into(), &super::use_counter_page::htmlinputelement_capture);
        map.insert(2232.into(), &super::use_counter_page::htmlinputelement_incremental);
        map.insert(2233.into(), &super::use_counter_page::htmlinputelement_onsearch);
        map.insert(2234.into(), &super::use_counter_page::htmlinputelement_popovertargetaction);
        map.insert(2235.into(), &super::use_counter_page::htmlinputelement_popovertargetelement);
        map.insert(2236.into(), &super::use_counter_page::htmlinputelement_webkitdirectory);
        map.insert(2237.into(), &super::use_counter_page::htmlinputelement_webkitentries);
        map.insert(2238.into(), &super::use_counter_page::htmlmediaelement_disableremoteplayback);
        map.insert(2239.into(), &super::use_counter_page::htmlmediaelement_remote);
        map.insert(2240.into(), &super::use_counter_page::htmlvideoelement_cancelvideoframecallback);
        map.insert(2241.into(), &super::use_counter_page::htmlvideoelement_disablepictureinpicture);
        map.insert(2242.into(), &super::use_counter_page::htmlvideoelement_onenterpictureinpicture);
        map.insert(2243.into(), &super::use_counter_page::htmlvideoelement_onleavepictureinpicture);
        map.insert(2244.into(), &super::use_counter_page::htmlvideoelement_playsinline);
        map.insert(2245.into(), &super::use_counter_page::htmlvideoelement_requestpictureinpicture);
        map.insert(2246.into(), &super::use_counter_page::htmlvideoelement_requestvideoframecallback);
        map.insert(2247.into(), &super::use_counter_page::imagedata_colorspace);
        map.insert(2248.into(), &super::use_counter_page::js_asmjs);
        map.insert(2249.into(), &super::use_counter_page::js_subclassing_array_type_2);
        map.insert(2250.into(), &super::use_counter_page::js_subclassing_array_type_3);
        map.insert(2251.into(), &super::use_counter_page::js_subclassing_arraybuffer_type_3);
        map.insert(2252.into(), &super::use_counter_page::js_subclassing_promise_type_2);
        map.insert(2253.into(), &super::use_counter_page::js_subclassing_promise_type_3);
        map.insert(2254.into(), &super::use_counter_page::js_subclassing_regexp_type_3);
        map.insert(2255.into(), &super::use_counter_page::js_subclassing_regexp_type_4);
        map.insert(2256.into(), &super::use_counter_page::js_subclassing_sharedarraybuffer_type_3);
        map.insert(2257.into(), &super::use_counter_page::js_subclassing_typedarray_type_2);
        map.insert(2258.into(), &super::use_counter_page::js_subclassing_typedarray_type_3);
        map.insert(2259.into(), &super::use_counter_page::js_wasm);
        map.insert(2260.into(), &super::use_counter_page::js_wasm_legacy_exceptions);
        map.insert(2261.into(), &super::use_counter_page::location_ancestororigins);
        map.insert(2262.into(), &super::use_counter_page::mediadevices_enumeratedevices);
        map.insert(2263.into(), &super::use_counter_page::mediadevices_getdisplaymedia);
        map.insert(2264.into(), &super::use_counter_page::mediadevices_getusermedia);
        map.insert(2265.into(), &super::use_counter_page::mixed_content_not_upgraded_audio_failure);
        map.insert(2266.into(), &super::use_counter_page::mixed_content_not_upgraded_audio_success);
        map.insert(2267.into(), &super::use_counter_page::mixed_content_not_upgraded_image_failure);
        map.insert(2268.into(), &super::use_counter_page::mixed_content_not_upgraded_image_success);
        map.insert(2269.into(), &super::use_counter_page::mixed_content_not_upgraded_video_failure);
        map.insert(2270.into(), &super::use_counter_page::mixed_content_not_upgraded_video_success);
        map.insert(2271.into(), &super::use_counter_page::mixed_content_upgraded_audio_failure);
        map.insert(2272.into(), &super::use_counter_page::mixed_content_upgraded_audio_success);
        map.insert(2273.into(), &super::use_counter_page::mixed_content_upgraded_image_failure);
        map.insert(2274.into(), &super::use_counter_page::mixed_content_upgraded_image_success);
        map.insert(2275.into(), &super::use_counter_page::mixed_content_upgraded_video_failure);
        map.insert(2276.into(), &super::use_counter_page::mixed_content_upgraded_video_success);
        map.insert(2277.into(), &super::use_counter_page::moz_get_user_media_insec);
        map.insert(2278.into(), &super::use_counter_page::navigator_canshare);
        map.insert(2279.into(), &super::use_counter_page::navigator_clearappbadge);
        map.insert(2280.into(), &super::use_counter_page::navigator_mozgetusermedia);
        map.insert(2281.into(), &super::use_counter_page::navigator_setappbadge);
        map.insert(2282.into(), &super::use_counter_page::navigator_share);
        map.insert(2283.into(), &super::use_counter_page::navigator_useractivation);
        map.insert(2284.into(), &super::use_counter_page::navigator_wakelock);
        map.insert(2285.into(), &super::use_counter_page::ondommousescroll);
        map.insert(2286.into(), &super::use_counter_page::onmozmousepixelscroll);
        map.insert(2287.into(), &super::use_counter_page::onoverflow);
        map.insert(2288.into(), &super::use_counter_page::onunderflow);
        map.insert(2289.into(), &super::use_counter_page::percentage_stroke_width_in_svg);
        map.insert(2290.into(), &super::use_counter_page::percentage_stroke_width_in_svgtext);
        map.insert(2291.into(), &super::use_counter_page::private_browsing_caches_delete);
        map.insert(2292.into(), &super::use_counter_page::private_browsing_caches_has);
        map.insert(2293.into(), &super::use_counter_page::private_browsing_caches_keys);
        map.insert(2294.into(), &super::use_counter_page::private_browsing_caches_match);
        map.insert(2295.into(), &super::use_counter_page::private_browsing_caches_open);
        map.insert(2296.into(), &super::use_counter_page::private_browsing_idbfactory_delete_database);
        map.insert(2297.into(), &super::use_counter_page::private_browsing_idbfactory_open);
        map.insert(2298.into(), &super::use_counter_page::private_browsing_navigator_service_worker);
        map.insert(2299.into(), &super::use_counter_page::pushmanager_subscribe);
        map.insert(2300.into(), &super::use_counter_page::pushsubscription_unsubscribe);
        map.insert(2301.into(), &super::use_counter_page::range_createcontextualfragment);
        map.insert(2302.into(), &super::use_counter_page::sanitizer_constructor);
        map.insert(2303.into(), &super::use_counter_page::sanitizer_sanitize);
        map.insert(2304.into(), &super::use_counter_page::scheduler_posttask);
        map.insert(2305.into(), &super::use_counter_page::shadowroot_pictureinpictureelement);
        map.insert(2306.into(), &super::use_counter_page::svgsvgelement_currentscale_getter);
        map.insert(2307.into(), &super::use_counter_page::svgsvgelement_currentscale_setter);
        map.insert(2308.into(), &super::use_counter_page::svgsvgelement_getelementbyid);
        map.insert(2309.into(), &super::use_counter_page::window_absoluteorientationsensor);
        map.insert(2310.into(), &super::use_counter_page::window_accelerometer);
        map.insert(2311.into(), &super::use_counter_page::window_backgroundfetchmanager);
        map.insert(2312.into(), &super::use_counter_page::window_backgroundfetchrecord);
        map.insert(2313.into(), &super::use_counter_page::window_backgroundfetchregistration);
        map.insert(2314.into(), &super::use_counter_page::window_beforeinstallpromptevent);
        map.insert(2315.into(), &super::use_counter_page::window_bluetooth);
        map.insert(2316.into(), &super::use_counter_page::window_bluetoothcharacteristicproperties);
        map.insert(2317.into(), &super::use_counter_page::window_bluetoothdevice);
        map.insert(2318.into(), &super::use_counter_page::window_bluetoothremotegattcharacteristic);
        map.insert(2319.into(), &super::use_counter_page::window_bluetoothremotegattdescriptor);
        map.insert(2320.into(), &super::use_counter_page::window_bluetoothremotegattserver);
        map.insert(2321.into(), &super::use_counter_page::window_bluetoothremotegattservice);
        map.insert(2322.into(), &super::use_counter_page::window_bluetoothuuid);
        map.insert(2323.into(), &super::use_counter_page::window_canvascapturemediastreamtrack);
        map.insert(2324.into(), &super::use_counter_page::window_chrome);
        map.insert(2325.into(), &super::use_counter_page::window_clipboarditem);
        map.insert(2326.into(), &super::use_counter_page::window_cssimagevalue);
        map.insert(2327.into(), &super::use_counter_page::window_csskeywordvalue);
        map.insert(2328.into(), &super::use_counter_page::window_cssmathclamp);
        map.insert(2329.into(), &super::use_counter_page::window_cssmathinvert);
        map.insert(2330.into(), &super::use_counter_page::window_cssmathmax);
        map.insert(2331.into(), &super::use_counter_page::window_cssmathmin);
        map.insert(2332.into(), &super::use_counter_page::window_cssmathnegate);
        map.insert(2333.into(), &super::use_counter_page::window_cssmathproduct);
        map.insert(2334.into(), &super::use_counter_page::window_cssmathsum);
        map.insert(2335.into(), &super::use_counter_page::window_cssmathvalue);
        map.insert(2336.into(), &super::use_counter_page::window_cssmatrixcomponent);
        map.insert(2337.into(), &super::use_counter_page::window_cssnumericarray);
        map.insert(2338.into(), &super::use_counter_page::window_cssnumericvalue);
        map.insert(2339.into(), &super::use_counter_page::window_cssperspective);
        map.insert(2340.into(), &super::use_counter_page::window_csspositionvalue);
        map.insert(2341.into(), &super::use_counter_page::window_csspropertyrule);
        map.insert(2342.into(), &super::use_counter_page::window_cssrotate);
        map.insert(2343.into(), &super::use_counter_page::window_cssscale);
        map.insert(2344.into(), &super::use_counter_page::window_cssskew);
        map.insert(2345.into(), &super::use_counter_page::window_cssskewx);
        map.insert(2346.into(), &super::use_counter_page::window_cssskewy);
        map.insert(2347.into(), &super::use_counter_page::window_cssstylevalue);
        map.insert(2348.into(), &super::use_counter_page::window_csstransformcomponent);
        map.insert(2349.into(), &super::use_counter_page::window_csstransformvalue);
        map.insert(2350.into(), &super::use_counter_page::window_csstranslate);
        map.insert(2351.into(), &super::use_counter_page::window_cssunitvalue);
        map.insert(2352.into(), &super::use_counter_page::window_cssunparsedvalue);
        map.insert(2353.into(), &super::use_counter_page::window_cssvariablereferencevalue);
        map.insert(2354.into(), &super::use_counter_page::window_defaultstatus);
        map.insert(2355.into(), &super::use_counter_page::window_devicemotioneventacceleration);
        map.insert(2356.into(), &super::use_counter_page::window_devicemotioneventrotationrate);
        map.insert(2357.into(), &super::use_counter_page::window_domerror);
        map.insert(2358.into(), &super::use_counter_page::window_encodedvideochunk);
        map.insert(2359.into(), &super::use_counter_page::window_enterpictureinpictureevent);
        map.insert(2360.into(), &super::use_counter_page::window_external);
        map.insert(2361.into(), &super::use_counter_page::window_federatedcredential);
        map.insert(2362.into(), &super::use_counter_page::window_gyroscope);
        map.insert(2363.into(), &super::use_counter_page::window_htmlcontentelement);
        map.insert(2364.into(), &super::use_counter_page::window_htmlshadowelement);
        map.insert(2365.into(), &super::use_counter_page::window_imagecapture);
        map.insert(2366.into(), &super::use_counter_page::window_inputdevicecapabilities);
        map.insert(2367.into(), &super::use_counter_page::window_inputdeviceinfo);
        map.insert(2368.into(), &super::use_counter_page::window_keyboard);
        map.insert(2369.into(), &super::use_counter_page::window_keyboardlayoutmap);
        map.insert(2370.into(), &super::use_counter_page::window_linearaccelerationsensor);
        map.insert(2371.into(), &super::use_counter_page::window_mediasettingsrange);
        map.insert(2372.into(), &super::use_counter_page::window_midiaccess);
        map.insert(2373.into(), &super::use_counter_page::window_midiconnectionevent);
        map.insert(2374.into(), &super::use_counter_page::window_midiinput);
        map.insert(2375.into(), &super::use_counter_page::window_midiinputmap);
        map.insert(2376.into(), &super::use_counter_page::window_midimessageevent);
        map.insert(2377.into(), &super::use_counter_page::window_midioutput);
        map.insert(2378.into(), &super::use_counter_page::window_midioutputmap);
        map.insert(2379.into(), &super::use_counter_page::window_midiport);
        map.insert(2380.into(), &super::use_counter_page::window_networkinformation);
        map.insert(2381.into(), &super::use_counter_page::window_offscreenbuffering);
        map.insert(2382.into(), &super::use_counter_page::window_onbeforeinstallprompt);
        map.insert(2383.into(), &super::use_counter_page::window_oncancel);
        map.insert(2384.into(), &super::use_counter_page::window_onmousewheel);
        map.insert(2385.into(), &super::use_counter_page::window_onorientationchange);
        map.insert(2386.into(), &super::use_counter_page::window_onsearch);
        map.insert(2387.into(), &super::use_counter_page::window_onselectionchange);
        map.insert(2388.into(), &super::use_counter_page::window_open_empty_url);
        map.insert(2389.into(), &super::use_counter_page::window_opendatabase);
        map.insert(2390.into(), &super::use_counter_page::window_orientation);
        map.insert(2391.into(), &super::use_counter_page::window_orientationsensor);
        map.insert(2392.into(), &super::use_counter_page::window_overconstrainederror);
        map.insert(2393.into(), &super::use_counter_page::window_passwordcredential);
        map.insert(2394.into(), &super::use_counter_page::window_paymentaddress);
        map.insert(2395.into(), &super::use_counter_page::window_paymentinstruments);
        map.insert(2396.into(), &super::use_counter_page::window_paymentmanager);
        map.insert(2397.into(), &super::use_counter_page::window_paymentmethodchangeevent);
        map.insert(2398.into(), &super::use_counter_page::window_paymentrequest);
        map.insert(2399.into(), &super::use_counter_page::window_paymentrequestupdateevent);
        map.insert(2400.into(), &super::use_counter_page::window_paymentresponse);
        map.insert(2401.into(), &super::use_counter_page::window_performancelongtasktiming);
        map.insert(2402.into(), &super::use_counter_page::window_photocapabilities);
        map.insert(2403.into(), &super::use_counter_page::window_pictureinpictureevent);
        map.insert(2404.into(), &super::use_counter_page::window_pictureinpicturewindow);
        map.insert(2405.into(), &super::use_counter_page::window_presentation);
        map.insert(2406.into(), &super::use_counter_page::window_presentationavailability);
        map.insert(2407.into(), &super::use_counter_page::window_presentationconnection);
        map.insert(2408.into(), &super::use_counter_page::window_presentationconnectionavailableevent);
        map.insert(2409.into(), &super::use_counter_page::window_presentationconnectioncloseevent);
        map.insert(2410.into(), &super::use_counter_page::window_presentationconnectionlist);
        map.insert(2411.into(), &super::use_counter_page::window_presentationreceiver);
        map.insert(2412.into(), &super::use_counter_page::window_presentationrequest);
        map.insert(2413.into(), &super::use_counter_page::window_relativeorientationsensor);
        map.insert(2414.into(), &super::use_counter_page::window_remoteplayback);
        map.insert(2415.into(), &super::use_counter_page::window_report);
        map.insert(2416.into(), &super::use_counter_page::window_reportbody);
        map.insert(2417.into(), &super::use_counter_page::window_reportingobserver);
        map.insert(2418.into(), &super::use_counter_page::window_rtcerror);
        map.insert(2419.into(), &super::use_counter_page::window_rtcerrorevent);
        map.insert(2420.into(), &super::use_counter_page::window_rtcicetransport);
        map.insert(2421.into(), &super::use_counter_page::window_rtcpeerconnectioniceerrorevent);
        map.insert(2422.into(), &super::use_counter_page::window_sensor);
        map.insert(2423.into(), &super::use_counter_page::window_sensorerrorevent);
        map.insert(2424.into(), &super::use_counter_page::window_sidebar_getter);
        map.insert(2425.into(), &super::use_counter_page::window_sidebar_setter);
        map.insert(2426.into(), &super::use_counter_page::window_speechrecognitionalternative);
        map.insert(2427.into(), &super::use_counter_page::window_speechrecognitionresult);
        map.insert(2428.into(), &super::use_counter_page::window_speechrecognitionresultlist);
        map.insert(2429.into(), &super::use_counter_page::window_stylemedia);
        map.insert(2430.into(), &super::use_counter_page::window_stylepropertymap);
        map.insert(2431.into(), &super::use_counter_page::window_stylepropertymapreadonly);
        map.insert(2432.into(), &super::use_counter_page::window_svgdiscardelement);
        map.insert(2433.into(), &super::use_counter_page::window_syncmanager);
        map.insert(2434.into(), &super::use_counter_page::window_taskattributiontiming);
        map.insert(2435.into(), &super::use_counter_page::window_textevent);
        map.insert(2436.into(), &super::use_counter_page::window_touch);
        map.insert(2437.into(), &super::use_counter_page::window_touchevent);
        map.insert(2438.into(), &super::use_counter_page::window_touchlist);
        map.insert(2439.into(), &super::use_counter_page::window_usb);
        map.insert(2440.into(), &super::use_counter_page::window_usbalternateinterface);
        map.insert(2441.into(), &super::use_counter_page::window_usbconfiguration);
        map.insert(2442.into(), &super::use_counter_page::window_usbconnectionevent);
        map.insert(2443.into(), &super::use_counter_page::window_usbdevice);
        map.insert(2444.into(), &super::use_counter_page::window_usbendpoint);
        map.insert(2445.into(), &super::use_counter_page::window_usbinterface);
        map.insert(2446.into(), &super::use_counter_page::window_usbintransferresult);
        map.insert(2447.into(), &super::use_counter_page::window_usbisochronousintransferpacket);
        map.insert(2448.into(), &super::use_counter_page::window_usbisochronousintransferresult);
        map.insert(2449.into(), &super::use_counter_page::window_usbisochronousouttransferpacket);
        map.insert(2450.into(), &super::use_counter_page::window_usbisochronousouttransferresult);
        map.insert(2451.into(), &super::use_counter_page::window_usbouttransferresult);
        map.insert(2452.into(), &super::use_counter_page::window_useractivation);
        map.insert(2453.into(), &super::use_counter_page::window_videocolorspace);
        map.insert(2454.into(), &super::use_counter_page::window_videodecoder);
        map.insert(2455.into(), &super::use_counter_page::window_videoencoder);
        map.insert(2456.into(), &super::use_counter_page::window_videoframe);
        map.insert(2457.into(), &super::use_counter_page::window_wakelock);
        map.insert(2458.into(), &super::use_counter_page::window_wakelocksentinel);
        map.insert(2459.into(), &super::use_counter_page::window_webkitcancelanimationframe);
        map.insert(2460.into(), &super::use_counter_page::window_webkitmediastream);
        map.insert(2461.into(), &super::use_counter_page::window_webkitmutationobserver);
        map.insert(2462.into(), &super::use_counter_page::window_webkitrequestanimationframe);
        map.insert(2463.into(), &super::use_counter_page::window_webkitrequestfilesystem);
        map.insert(2464.into(), &super::use_counter_page::window_webkitresolvelocalfilesystemurl);
        map.insert(2465.into(), &super::use_counter_page::window_webkitrtcpeerconnection);
        map.insert(2466.into(), &super::use_counter_page::window_webkitspeechgrammar);
        map.insert(2467.into(), &super::use_counter_page::window_webkitspeechgrammarlist);
        map.insert(2468.into(), &super::use_counter_page::window_webkitspeechrecognition);
        map.insert(2469.into(), &super::use_counter_page::window_webkitspeechrecognitionerror);
        map.insert(2470.into(), &super::use_counter_page::window_webkitspeechrecognitionevent);
        map.insert(2471.into(), &super::use_counter_page::window_webkitstorageinfo);
        map.insert(2472.into(), &super::use_counter_page::workernavigator_permissions);
        map.insert(2473.into(), &super::use_counter_page::wr_filter_fallback);
        map.insert(2474.into(), &super::use_counter_page::xslstylesheet);
        map.insert(2475.into(), &super::use_counter_page::xsltprocessor_constructor);
        map.insert(2476.into(), &super::use_counter_page::you_tube_flash_embed);
        map.insert(2477.into(), &super::use_counter_worker_dedicated::console_assert);
        map.insert(2478.into(), &super::use_counter_worker_dedicated::console_clear);
        map.insert(2479.into(), &super::use_counter_worker_dedicated::console_count);
        map.insert(2480.into(), &super::use_counter_worker_dedicated::console_countreset);
        map.insert(2481.into(), &super::use_counter_worker_dedicated::console_debug);
        map.insert(2482.into(), &super::use_counter_worker_dedicated::console_dir);
        map.insert(2483.into(), &super::use_counter_worker_dedicated::console_dirxml);
        map.insert(2484.into(), &super::use_counter_worker_dedicated::console_error);
        map.insert(2485.into(), &super::use_counter_worker_dedicated::console_exception);
        map.insert(2486.into(), &super::use_counter_worker_dedicated::console_group);
        map.insert(2487.into(), &super::use_counter_worker_dedicated::console_groupcollapsed);
        map.insert(2488.into(), &super::use_counter_worker_dedicated::console_groupend);
        map.insert(2489.into(), &super::use_counter_worker_dedicated::console_info);
        map.insert(2490.into(), &super::use_counter_worker_dedicated::console_log);
        map.insert(2491.into(), &super::use_counter_worker_dedicated::console_profile);
        map.insert(2492.into(), &super::use_counter_worker_dedicated::console_profileend);
        map.insert(2493.into(), &super::use_counter_worker_dedicated::console_table);
        map.insert(2494.into(), &super::use_counter_worker_dedicated::console_time);
        map.insert(2495.into(), &super::use_counter_worker_dedicated::console_timeend);
        map.insert(2496.into(), &super::use_counter_worker_dedicated::console_timelog);
        map.insert(2497.into(), &super::use_counter_worker_dedicated::console_timestamp);
        map.insert(2498.into(), &super::use_counter_worker_dedicated::console_trace);
        map.insert(2499.into(), &super::use_counter_worker_dedicated::console_warn);
        map.insert(2500.into(), &super::use_counter_worker_dedicated::private_browsing_caches_delete);
        map.insert(2501.into(), &super::use_counter_worker_dedicated::private_browsing_caches_has);
        map.insert(2502.into(), &super::use_counter_worker_dedicated::private_browsing_caches_keys);
        map.insert(2503.into(), &super::use_counter_worker_dedicated::private_browsing_caches_match);
        map.insert(2504.into(), &super::use_counter_worker_dedicated::private_browsing_caches_open);
        map.insert(2505.into(), &super::use_counter_worker_dedicated::private_browsing_idbfactory_delete_database);
        map.insert(2506.into(), &super::use_counter_worker_dedicated::private_browsing_idbfactory_open);
        map.insert(2507.into(), &super::use_counter_worker_dedicated::pushmanager_subscribe);
        map.insert(2508.into(), &super::use_counter_worker_dedicated::pushsubscription_unsubscribe);
        map.insert(2509.into(), &super::use_counter_worker_dedicated::scheduler_posttask);
        map.insert(2510.into(), &super::use_counter_worker_service::console_assert);
        map.insert(2511.into(), &super::use_counter_worker_service::console_clear);
        map.insert(2512.into(), &super::use_counter_worker_service::console_count);
        map.insert(2513.into(), &super::use_counter_worker_service::console_countreset);
        map.insert(2514.into(), &super::use_counter_worker_service::console_debug);
        map.insert(2515.into(), &super::use_counter_worker_service::console_dir);
        map.insert(2516.into(), &super::use_counter_worker_service::console_dirxml);
        map.insert(2517.into(), &super::use_counter_worker_service::console_error);
        map.insert(2518.into(), &super::use_counter_worker_service::console_exception);
        map.insert(2519.into(), &super::use_counter_worker_service::console_group);
        map.insert(2520.into(), &super::use_counter_worker_service::console_groupcollapsed);
        map.insert(2521.into(), &super::use_counter_worker_service::console_groupend);
        map.insert(2522.into(), &super::use_counter_worker_service::console_info);
        map.insert(2523.into(), &super::use_counter_worker_service::console_log);
        map.insert(2524.into(), &super::use_counter_worker_service::console_profile);
        map.insert(2525.into(), &super::use_counter_worker_service::console_profileend);
        map.insert(2526.into(), &super::use_counter_worker_service::console_table);
        map.insert(2527.into(), &super::use_counter_worker_service::console_time);
        map.insert(2528.into(), &super::use_counter_worker_service::console_timeend);
        map.insert(2529.into(), &super::use_counter_worker_service::console_timelog);
        map.insert(2530.into(), &super::use_counter_worker_service::console_timestamp);
        map.insert(2531.into(), &super::use_counter_worker_service::console_trace);
        map.insert(2532.into(), &super::use_counter_worker_service::console_warn);
        map.insert(2533.into(), &super::use_counter_worker_service::private_browsing_caches_delete);
        map.insert(2534.into(), &super::use_counter_worker_service::private_browsing_caches_has);
        map.insert(2535.into(), &super::use_counter_worker_service::private_browsing_caches_keys);
        map.insert(2536.into(), &super::use_counter_worker_service::private_browsing_caches_match);
        map.insert(2537.into(), &super::use_counter_worker_service::private_browsing_caches_open);
        map.insert(2538.into(), &super::use_counter_worker_service::private_browsing_idbfactory_delete_database);
        map.insert(2539.into(), &super::use_counter_worker_service::private_browsing_idbfactory_open);
        map.insert(2540.into(), &super::use_counter_worker_service::pushmanager_subscribe);
        map.insert(2541.into(), &super::use_counter_worker_service::pushsubscription_unsubscribe);
        map.insert(2542.into(), &super::use_counter_worker_service::scheduler_posttask);
        map.insert(2543.into(), &super::use_counter_worker_shared::console_assert);
        map.insert(2544.into(), &super::use_counter_worker_shared::console_clear);
        map.insert(2545.into(), &super::use_counter_worker_shared::console_count);
        map.insert(2546.into(), &super::use_counter_worker_shared::console_countreset);
        map.insert(2547.into(), &super::use_counter_worker_shared::console_debug);
        map.insert(2548.into(), &super::use_counter_worker_shared::console_dir);
        map.insert(2549.into(), &super::use_counter_worker_shared::console_dirxml);
        map.insert(2550.into(), &super::use_counter_worker_shared::console_error);
        map.insert(2551.into(), &super::use_counter_worker_shared::console_exception);
        map.insert(2552.into(), &super::use_counter_worker_shared::console_group);
        map.insert(2553.into(), &super::use_counter_worker_shared::console_groupcollapsed);
        map.insert(2554.into(), &super::use_counter_worker_shared::console_groupend);
        map.insert(2555.into(), &super::use_counter_worker_shared::console_info);
        map.insert(2556.into(), &super::use_counter_worker_shared::console_log);
        map.insert(2557.into(), &super::use_counter_worker_shared::console_profile);
        map.insert(2558.into(), &super::use_counter_worker_shared::console_profileend);
        map.insert(2559.into(), &super::use_counter_worker_shared::console_table);
        map.insert(2560.into(), &super::use_counter_worker_shared::console_time);
        map.insert(2561.into(), &super::use_counter_worker_shared::console_timeend);
        map.insert(2562.into(), &super::use_counter_worker_shared::console_timelog);
        map.insert(2563.into(), &super::use_counter_worker_shared::console_timestamp);
        map.insert(2564.into(), &super::use_counter_worker_shared::console_trace);
        map.insert(2565.into(), &super::use_counter_worker_shared::console_warn);
        map.insert(2566.into(), &super::use_counter_worker_shared::private_browsing_caches_delete);
        map.insert(2567.into(), &super::use_counter_worker_shared::private_browsing_caches_has);
        map.insert(2568.into(), &super::use_counter_worker_shared::private_browsing_caches_keys);
        map.insert(2569.into(), &super::use_counter_worker_shared::private_browsing_caches_match);
        map.insert(2570.into(), &super::use_counter_worker_shared::private_browsing_caches_open);
        map.insert(2571.into(), &super::use_counter_worker_shared::private_browsing_idbfactory_delete_database);
        map.insert(2572.into(), &super::use_counter_worker_shared::private_browsing_idbfactory_open);
        map.insert(2573.into(), &super::use_counter_worker_shared::pushmanager_subscribe);
        map.insert(2574.into(), &super::use_counter_worker_shared::pushsubscription_unsubscribe);
        map.insert(2575.into(), &super::use_counter_worker_shared::scheduler_posttask);
        map.insert(2581.into(), &super::hls::canplay_requested);
        map.insert(2582.into(), &super::hls::canplay_supported);
        map.insert(2649.into(), &super::httpsfirst::upgraded);
        map.insert(2650.into(), &super::httpsfirst::upgraded_schemeless);
        map.insert(2652.into(), &super::webauthn_create::failure);
        map.insert(2653.into(), &super::webauthn_create::passkey);
        map.insert(2654.into(), &super::webauthn_create::success);
        map.insert(2656.into(), &super::webauthn_get::failure);
        map.insert(2657.into(), &super::webauthn_get::success);
        map.insert(2789.into(), &super::networking::residual_cache_folder_count);
        map.insert(2831.into(), &super::bounce_tracking_protection::purge_count_classified_tracker);
        map.insert(2860.into(), &super::cookie_banners::cookie_injection_fail);
        map.insert(2902.into(), &super::crash_submission::failure);
        map.insert(2903.into(), &super::crash_submission::pending);
        map.insert(2904.into(), &super::crash_submission::success);
        map.insert(2963.into(), &super::fog::inits_during_shutdown);
        map.insert(2967.into(), &super::fog_ipc::flush_failures);
        map.insert(2968.into(), &super::fog_ipc::replay_failures);
        map.insert(2969.into(), &super::fog_ipc::shutdown_registration_failures);
        map.insert(2970.into(), &super::test_only::bad_code);
        map.insert(2995.into(), &super::test_only_ipc::a_counter);
        map.insert(3014.into(), &super::test_only_jog::a_counter);
        map.insert(3030.into(), &super::pdfjs::used);
        map.insert(3032.into(), &super::pdfjs_editing_highlight::color_changed);
        map.insert(3033.into(), &super::pdfjs_editing_highlight::deleted);
        map.insert(3034.into(), &super::pdfjs_editing_highlight::edited);
        map.insert(3038.into(), &super::pdfjs_editing_highlight::print);
        map.insert(3039.into(), &super::pdfjs_editing_highlight::save);
        map.insert(3041.into(), &super::pdfjs_editing_highlight::thickness_changed);
        map.insert(3042.into(), &super::pdfjs_editing_highlight::toggle_visibility);
        map.insert(3043.into(), &super::power::cpu_time_bogus_values);
        map.insert(3047.into(), &super::power::gpu_time_bogus_values);
        map.insert(3049.into(), &super::power::total_cpu_time_ms);
        map.insert(3050.into(), &super::power::total_gpu_time_ms);
        map.insert(3051.into(), &super::power::total_thread_wakeups);
        map
    });

    pub static URL_MAP: Lazy<HashMap<MetricId, &Lazy<UrlMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(7);
        map.insert(110.into(), &super::top_sites::reporting_url);
        map.insert(140.into(), &super::search_with::reporting_url);
        map.insert(193.into(), &super::quick_suggest::reporting_url);
        map.insert(3005.into(), &super::test_only_ipc::a_url);
        map.insert(3066.into(), &super::broken_site_report::url);
        map.insert(3210.into(), &super::search_engine_default::submission_url);
        map.insert(3216.into(), &super::search_engine_private::submission_url);
        map
    });

    pub static CUSTOM_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<CustomDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(47);
        map.insert(2576.into(), &super::geolocation::accuracy);
        map.insert(2670.into(), &super::gfx_checkerboard::peak_pixel_count);
        map.insert(2672.into(), &super::gfx_checkerboard::severity);
        map.insert(2675.into(), &super::gfx_content_frame_time::from_paint);
        map.insert(2676.into(), &super::gfx_content_frame_time::from_vsync);
        map.insert(2678.into(), &super::gfx_content_frame_time::with_svg);
        map.insert(2679.into(), &super::gfx_content_frame_time::without_resource_upload);
        map.insert(2680.into(), &super::gfx_content_frame_time::without_upload);
        map.insert(2731.into(), &super::performance_clone_deserialize::items);
        map.insert(2736.into(), &super::geckoview::document_site_origins);
        map.insert(2740.into(), &super::geckoview::per_document_site_origins);
        map.insert(2742.into(), &super::networking::cookie_access_fixup_diff);
        map.insert(2743.into(), &super::networking::cookie_count_part_by_key);
        map.insert(2744.into(), &super::networking::cookie_count_partitioned);
        map.insert(2745.into(), &super::networking::cookie_count_total);
        map.insert(2746.into(), &super::networking::cookie_count_unpart_by_key);
        map.insert(2747.into(), &super::networking::cookie_count_unpartitioned);
        map.insert(2748.into(), &super::networking::cookie_creation_fixup_diff);
        map.insert(2749.into(), &super::networking::cookie_purge_entry_max);
        map.insert(2750.into(), &super::networking::cookie_purge_max);
        map.insert(2758.into(), &super::networking::http_1_download_throughput);
        map.insert(2759.into(), &super::networking::http_1_upload_throughput);
        map.insert(2760.into(), &super::networking::http_1_upload_throughput_100);
        map.insert(2761.into(), &super::networking::http_1_upload_throughput_10_50);
        map.insert(2762.into(), &super::networking::http_1_upload_throughput_50_100);
        map.insert(2763.into(), &super::networking::http_2_download_throughput);
        map.insert(2764.into(), &super::networking::http_2_upload_throughput);
        map.insert(2765.into(), &super::networking::http_2_upload_throughput_100);
        map.insert(2766.into(), &super::networking::http_2_upload_throughput_10_50);
        map.insert(2767.into(), &super::networking::http_2_upload_throughput_50_100);
        map.insert(2768.into(), &super::networking::http_3_download_throughput);
        map.insert(2769.into(), &super::networking::http_3_upload_throughput);
        map.insert(2770.into(), &super::networking::http_3_upload_throughput_100);
        map.insert(2771.into(), &super::networking::http_3_upload_throughput_10_50);
        map.insert(2772.into(), &super::networking::http_3_upload_throughput_50_100);
        map.insert(2814.into(), &super::cert_compression::brotli_saved_bytes);
        map.insert(2817.into(), &super::cert_compression::zlib_saved_bytes);
        map.insert(2870.into(), &super::cookie_banners_click::query_selector_run_count_per_window_frame);
        map.insert(2871.into(), &super::cookie_banners_click::query_selector_run_count_per_window_top_level);
        map.insert(2872.into(), &super::cookie_banners_click::query_selector_run_duration_per_window_frame);
        map.insert(2873.into(), &super::cookie_banners_click::query_selector_run_duration_per_window_top_level);
        map.insert(2948.into(), &super::extensions_timing::event_page_running_time);
        map.insert(2996.into(), &super::test_only_ipc::a_custom_dist);
        map.insert(3029.into(), &super::pdfjs::time_to_view);
        map.insert(3040.into(), &super::pdfjs_editing_highlight::thickness);
        map.insert(3053.into(), &super::power_battery::percentage_when_user_active);
        map.insert(3311.into(), &super::timer_thread::timers_fired_per_wakeup);
        map
    });

    pub static DENOMINATOR_MAP: Lazy<HashMap<MetricId, &Lazy<DenominatorMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(8);
        map.insert(2596.into(), &super::rtcrtpsender::count);
        map.insert(2597.into(), &super::rtcrtpsender::count_setparameters_compat);
        map.insert(2645.into(), &super::httpsfirst::downgraded);
        map.insert(2648.into(), &super::httpsfirst::downgraded_schemeless);
        map.insert(2791.into(), &super::networking::set_cookie);
        map.insert(2821.into(), &super::tls::certificate_verifications);
        map.insert(3008.into(), &super::test_only_ipc::an_external_denominator);
        map.insert(3235.into(), &super::translations::requests_count);
        map
    });

    pub static NUMERATOR_MAP: Lazy<HashMap<MetricId, &Lazy<NumeratorMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(23);
        map.insert(2598.into(), &super::rtcrtpsender::used_sendencodings);
        map.insert(2602.into(), &super::rtcrtpsender_setparameters::fail_length_changed);
        map.insert(2603.into(), &super::rtcrtpsender_setparameters::fail_no_encodings);
        map.insert(2604.into(), &super::rtcrtpsender_setparameters::fail_no_getparameters);
        map.insert(2605.into(), &super::rtcrtpsender_setparameters::fail_no_transactionid);
        map.insert(2606.into(), &super::rtcrtpsender_setparameters::fail_other);
        map.insert(2607.into(), &super::rtcrtpsender_setparameters::fail_rid_changed);
        map.insert(2608.into(), &super::rtcrtpsender_setparameters::fail_stale_transactionid);
        map.insert(2609.into(), &super::rtcrtpsender_setparameters::warn_length_changed);
        map.insert(2610.into(), &super::rtcrtpsender_setparameters::warn_no_getparameters);
        map.insert(2611.into(), &super::rtcrtpsender_setparameters::warn_no_transactionid);
        map.insert(2646.into(), &super::httpsfirst::downgraded_on_timer);
        map.insert(2647.into(), &super::httpsfirst::downgraded_on_timer_schemeless);
        map.insert(2792.into(), &super::networking::set_cookie_foreign);
        map.insert(2793.into(), &super::networking::set_cookie_foreign_partitioned);
        map.insert(2794.into(), &super::networking::set_cookie_partitioned);
        map.insert(2823.into(), &super::verification_used_cert_from::built_in_roots_module);
        map.insert(2824.into(), &super::verification_used_cert_from::nss_cert_db);
        map.insert(2825.into(), &super::verification_used_cert_from::preloaded_intermediates);
        map.insert(2826.into(), &super::verification_used_cert_from::third_party_certificates);
        map.insert(2827.into(), &super::verification_used_cert_from::tls_handshake);
        map.insert(3013.into(), &super::test_only_ipc::rate_with_external_denominator);
        map.insert(3233.into(), &super::translations::error_rate);
        map
    });

    pub static MEMORY_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<MemoryDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(6);
        map.insert(2732.into(), &super::performance_clone_deserialize::size);
        map.insert(2933.into(), &super::extensions_apis_dnr::startup_cache_read_size);
        map.insert(2935.into(), &super::extensions_apis_dnr::startup_cache_write_size);
        map.insert(2965.into(), &super::fog_ipc::buffer_sizes);
        map.insert(2977.into(), &super::test_only::do_you_remember);
        map.insert(2999.into(), &super::test_only_ipc::a_memory_dist);
        map
    });

    pub static RATE_MAP: Lazy<HashMap<MetricId, &Lazy<RateMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(2);
        map.insert(2876.into(), &super::cookie_banners_cmp::ratio_handled_by_cmp_rule);
        map.insert(3011.into(), &super::test_only_ipc::irate);
        map
    });

    pub static TIMESPAN_MAP: Lazy<HashMap<MetricId, &Lazy<TimespanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(6);
        map.insert(2910.into(), &super::environment::uptime);
        map.insert(2925.into(), &super::extensions::startup_cache_load_time);
        map.insert(2962.into(), &super::fog::initialization);
        map.insert(2973.into(), &super::test_only::can_we_time_it);
        map.insert(2987.into(), &super::test_only::mirror_time);
        map.insert(2988.into(), &super::test_only::mirror_time_nanos);
        map
    });


    pub(crate) fn set_object_by_id(metric_id: u32, value: String) -> Result<(), ()> {
        match metric_id {
          2881 => {
              super::crash::async_shutdown_timeout.set_string(value);
              Ok(())
          }
          2893 => {
              super::crash::quota_manager_shutdown_timeout.set_string(value);
              Ok(())
          }
          2896 => {
              super::crash::stack_traces.set_string(value);
              Ok(())
          }
          2971 => {
              super::test_only::balloons.set_string(value);
              Ok(())
          }
          2976 => {
              super::test_only::crash_stack.set_string(value);
              Ok(())
          }
           _ => Err(()),
        }
    }

    /// Wrapper to get the currently stored object for object metric as a string.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns the recorded object serialized as a JSON string or `None` if nothing stored.
    ///
    /// # Panics
    ///
    /// Panics if no object by the given metric ID could be found.
    pub(crate) fn object_test_get_value(metric_id: u32, ping_name: Option<String>) -> Option<String> {
        match metric_id {
           2881 => super::crash::async_shutdown_timeout.test_get_value_as_str(ping_name.as_deref()),
           2893 => super::crash::quota_manager_shutdown_timeout.test_get_value_as_str(ping_name.as_deref()),
           2896 => super::crash::stack_traces.test_get_value_as_str(ping_name.as_deref()),
           2971 => super::test_only::balloons.test_get_value_as_str(ping_name.as_deref()),
           2976 => super::test_only::crash_stack.test_get_value_as_str(ping_name.as_deref()),
           _ => panic!("No object for metric id {}", metric_id),
        }
    }

    /// Check the provided object for errors.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    ///
    /// # Returns
    ///
    /// Returns a string for the recorded error or `None`.
    ///
    /// # Panics
    ///
    /// Panics if no object by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn object_test_get_error(metric_id: u32) -> Option<String> {
        #[cfg(feature = "with_gecko")]
        match metric_id {
           2881 => test_get_errors!(super::crash::async_shutdown_timeout),
           2893 => test_get_errors!(super::crash::quota_manager_shutdown_timeout),
           2896 => test_get_errors!(super::crash::stack_traces),
           2971 => test_get_errors!(super::test_only::balloons),
           2976 => test_get_errors!(super::test_only::crash_stack),
           _ => panic!("No object for metric id {}", metric_id),
        }

        #[cfg(not(feature = "with_gecko"))]
        {
            return None;
        }
    }

    /// Wrapper to record an event based on its metric ID.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `extra`     - An map of (extra key id, string) pairs.
    ///                 The map will be decoded into the appropriate `ExtraKeys` type.
    /// # Returns
    ///
    /// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
    /// or an `EventRecordingError::InvalidId` if no event by that ID exists
    /// or an `EventRecordingError::InvalidExtraKey` if the `extra` map could not be deserialized.
    pub(crate) fn record_event_by_id(metric_id: u32, extra: HashMap<String, String>) -> Result<(), EventRecordingError> {
        match metric_id {
          1 => {
              assert!(
                  extra_keys_len(&super::privacy_sanitize::clear) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::privacy_sanitize::clear.record_raw(extra);
              Ok(())
          }
          2 => {
              assert!(
                  extra_keys_len(&super::privacy_sanitize::clearing_time_span_selected) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::privacy_sanitize::clearing_time_span_selected.record_raw(extra);
              Ok(())
          }
          3 => {
              assert!(
                  extra_keys_len(&super::privacy_sanitize::dialog_open) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::privacy_sanitize::dialog_open.record_raw(extra);
              Ok(())
          }
          38 => {
              assert!(
                  extra_keys_len(&super::browser_launched_to_handle::system_notification) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::browser_launched_to_handle::system_notification.record_raw(extra);
              Ok(())
          }
          76 => {
              assert!(
                  extra_keys_len(&super::newtab::closed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::closed.record_raw(extra);
              Ok(())
          }
          80 => {
              assert!(
                  extra_keys_len(&super::newtab::opened) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::opened.record_raw(extra);
              Ok(())
          }
          82 => {
              assert!(
                  extra_keys_len(&super::newtab::tooltip_click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::tooltip_click.record_raw(extra);
              Ok(())
          }
          83 => {
              assert!(
                  extra_keys_len(&super::newtab::wallpaper_category_click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::wallpaper_category_click.record_raw(extra);
              Ok(())
          }
          84 => {
              assert!(
                  extra_keys_len(&super::newtab::wallpaper_click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::wallpaper_click.record_raw(extra);
              Ok(())
          }
          85 => {
              assert!(
                  extra_keys_len(&super::newtab::wallpaper_highlight_cta_click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::wallpaper_highlight_cta_click.record_raw(extra);
              Ok(())
          }
          86 => {
              assert!(
                  extra_keys_len(&super::newtab::wallpaper_highlight_dismissed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::wallpaper_highlight_dismissed.record_raw(extra);
              Ok(())
          }
          87 => {
              assert!(
                  extra_keys_len(&super::newtab::weather_change_display) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::weather_change_display.record_raw(extra);
              Ok(())
          }
          89 => {
              assert!(
                  extra_keys_len(&super::newtab::weather_impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::weather_impression.record_raw(extra);
              Ok(())
          }
          90 => {
              assert!(
                  extra_keys_len(&super::newtab::weather_load_error) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::weather_load_error.record_raw(extra);
              Ok(())
          }
          91 => {
              assert!(
                  extra_keys_len(&super::newtab::weather_location_selected) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::weather_location_selected.record_raw(extra);
              Ok(())
          }
          92 => {
              assert!(
                  extra_keys_len(&super::newtab::weather_open_provider_url) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::weather_open_provider_url.record_raw(extra);
              Ok(())
          }
          95 => {
              assert!(
                  extra_keys_len(&super::newtab_search::issued) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab_search::issued.record_raw(extra);
              Ok(())
          }
          96 => {
              assert!(
                  extra_keys_len(&super::pocket::click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::click.record_raw(extra);
              Ok(())
          }
          99 => {
              assert!(
                  extra_keys_len(&super::pocket::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::impression.record_raw(extra);
              Ok(())
          }
          102 => {
              assert!(
                  extra_keys_len(&super::pocket::save) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::save.record_raw(extra);
              Ok(())
          }
          105 => {
              assert!(
                  extra_keys_len(&super::pocket::topic_click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::topic_click.record_raw(extra);
              Ok(())
          }
          113 => {
              assert!(
                  extra_keys_len(&super::topsites::click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::topsites::click.record_raw(extra);
              Ok(())
          }
          114 => {
              assert!(
                  extra_keys_len(&super::topsites::dismiss) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::topsites::dismiss.record_raw(extra);
              Ok(())
          }
          116 => {
              assert!(
                  extra_keys_len(&super::topsites::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::topsites::impression.record_raw(extra);
              Ok(())
          }
          117 => {
              assert!(
                  extra_keys_len(&super::topsites::pref_changed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::topsites::pref_changed.record_raw(extra);
              Ok(())
          }
          119 => {
              assert!(
                  extra_keys_len(&super::topsites::show_privacy_click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::topsites::show_privacy_click.record_raw(extra);
              Ok(())
          }
          130 => {
              assert!(
                  extra_keys_len(&super::privacy_ui_fpp_click::checkbox) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::privacy_ui_fpp_click::checkbox.record_raw(extra);
              Ok(())
          }
          131 => {
              assert!(
                  extra_keys_len(&super::privacy_ui_fpp_click::menu) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::privacy_ui_fpp_click::menu.record_raw(extra);
              Ok(())
          }
          132 => {
              assert!(
                  extra_keys_len(&super::private_browsing_reset_pbm::confirm_panel) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::private_browsing_reset_pbm::confirm_panel.record_raw(extra);
              Ok(())
          }
          133 => {
              assert!(
                  extra_keys_len(&super::private_browsing_reset_pbm::reset_action) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::private_browsing_reset_pbm::reset_action.record_raw(extra);
              Ok(())
          }
          136 => {
              assert!(
                  extra_keys_len(&super::protocolhandler_mailto::visit) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::protocolhandler_mailto::visit.record_raw(extra);
              Ok(())
          }
          137 => {
              assert!(
                  extra_keys_len(&super::newtab_search_ad::click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab_search_ad::click.record_raw(extra);
              Ok(())
          }
          138 => {
              assert!(
                  extra_keys_len(&super::newtab_search_ad::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab_search_ad::impression.record_raw(extra);
              Ok(())
          }
          141 => {
              assert!(
                  extra_keys_len(&super::serp::abandonment) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::serp::abandonment.record_raw(extra);
              Ok(())
          }
          142 => {
              assert!(
                  extra_keys_len(&super::serp::ad_impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::serp::ad_impression.record_raw(extra);
              Ok(())
          }
          143 => {
              assert!(
                  extra_keys_len(&super::serp::categorization) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::serp::categorization.record_raw(extra);
              Ok(())
          }
          145 => {
              assert!(
                  extra_keys_len(&super::serp::engagement) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::serp::engagement.record_raw(extra);
              Ok(())
          }
          146 => {
              assert!(
                  extra_keys_len(&super::serp::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::serp::impression.record_raw(extra);
              Ok(())
          }
          147 => {
              assert!(
                  extra_keys_len(&super::shopping::address_bar_feature_callout_displayed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::address_bar_feature_callout_displayed.record_raw(extra);
              Ok(())
          }
          148 => {
              assert!(
                  extra_keys_len(&super::shopping::address_bar_icon_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::address_bar_icon_clicked.record_raw(extra);
              Ok(())
          }
          149 => {
              assert!(
                  extra_keys_len(&super::shopping::address_bar_icon_displayed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::address_bar_icon_displayed.record_raw(extra);
              Ok(())
          }
          150 => {
              assert!(
                  extra_keys_len(&super::shopping::ads_exposure) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::ads_exposure.record_raw(extra);
              Ok(())
          }
          152 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_ads_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_ads_clicked.record_raw(extra);
              Ok(())
          }
          153 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_ads_impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_ads_impression.record_raw(extra);
              Ok(())
          }
          154 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_ads_placement) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_ads_placement.record_raw(extra);
              Ok(())
          }
          155 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_ads_setting_toggled) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_ads_setting_toggled.record_raw(extra);
              Ok(())
          }
          156 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_analyze_reviews_none_available_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_analyze_reviews_none_available_clicked.record_raw(extra);
              Ok(())
          }
          157 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_auto_open_setting_toggled) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_auto_open_setting_toggled.record_raw(extra);
              Ok(())
          }
          158 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_closed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_closed.record_raw(extra);
              Ok(())
          }
          159 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_displayed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_displayed.record_raw(extra);
              Ok(())
          }
          160 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_learn_more_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_learn_more_clicked.record_raw(extra);
              Ok(())
          }
          161 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_no_ads_available) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_no_ads_available.record_raw(extra);
              Ok(())
          }
          162 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_no_review_reliability_available) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_no_review_reliability_available.record_raw(extra);
              Ok(())
          }
          163 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_no_thanks_button_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_no_thanks_button_clicked.record_raw(extra);
              Ok(())
          }
          164 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_not_now_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_not_now_clicked.record_raw(extra);
              Ok(())
          }
          165 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_onboarding_displayed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_onboarding_displayed.record_raw(extra);
              Ok(())
          }
          166 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_opt_in_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_opt_in_clicked.record_raw(extra);
              Ok(())
          }
          167 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_opt_out_button_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_opt_out_button_clicked.record_raw(extra);
              Ok(())
          }
          168 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_powered_by_fakespot_link_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_powered_by_fakespot_link_clicked.record_raw(extra);
              Ok(())
          }
          169 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_reactivated_button_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_reactivated_button_clicked.record_raw(extra);
              Ok(())
          }
          170 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_reanalyze_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_reanalyze_clicked.record_raw(extra);
              Ok(())
          }
          171 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_settings_expand_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_settings_expand_clicked.record_raw(extra);
              Ok(())
          }
          172 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_show_more_reviews_button_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_show_more_reviews_button_clicked.record_raw(extra);
              Ok(())
          }
          173 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_show_privacy_policy_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_show_privacy_policy_clicked.record_raw(extra);
              Ok(())
          }
          174 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_show_quality_explainer_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_show_quality_explainer_clicked.record_raw(extra);
              Ok(())
          }
          175 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_show_quality_explainer_url_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_show_quality_explainer_url_clicked.record_raw(extra);
              Ok(())
          }
          176 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_show_terms_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_show_terms_clicked.record_raw(extra);
              Ok(())
          }
          177 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_stale_analysis_shown) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_stale_analysis_shown.record_raw(extra);
              Ok(())
          }
          178 => {
              assert!(
                  extra_keys_len(&super::shopping::surface_yes_keep_closed_button_clicked) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping::surface_yes_keep_closed_button_clicked.record_raw(extra);
              Ok(())
          }
          198 => {
              assert!(
                  extra_keys_len(&super::urlbar::abandonment) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::abandonment.record_raw(extra);
              Ok(())
          }
          199 => {
              assert!(
                  extra_keys_len(&super::urlbar::engagement) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::engagement.record_raw(extra);
              Ok(())
          }
          200 => {
              assert!(
                  extra_keys_len(&super::urlbar::exposure) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::exposure.record_raw(extra);
              Ok(())
          }
          201 => {
              assert!(
                  extra_keys_len(&super::urlbar::potential_exposure) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::potential_exposure.record_raw(extra);
              Ok(())
          }
          207 => {
              assert!(
                  extra_keys_len(&super::urlbar::quick_suggest_contextual_opt_in) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::quick_suggest_contextual_opt_in.record_raw(extra);
              Ok(())
          }
          211 => {
              assert!(
                  extra_keys_len(&super::browser_usage::interaction) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::browser_usage::interaction.record_raw(extra);
              Ok(())
          }
          2580 => {
              assert!(
                  extra_keys_len(&super::mediadrm::eme_playback) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::mediadrm::eme_playback.record_raw(extra);
              Ok(())
          }
          2583 => {
              assert!(
                  extra_keys_len(&super::hls::media_load) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::hls::media_load.record_raw(extra);
              Ok(())
          }
          2588 => {
              assert!(
                  extra_keys_len(&super::media_playback::first_frame_loaded) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::media_playback::first_frame_loaded.record_raw(extra);
              Ok(())
          }
          2590 => {
              assert!(
                  extra_keys_len(&super::mfcdm::eme_playback) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::mfcdm::eme_playback.record_raw(extra);
              Ok(())
          }
          2591 => {
              assert!(
                  extra_keys_len(&super::mfcdm::error) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::mfcdm::error.record_raw(extra);
              Ok(())
          }
          2626 => {
              assert!(
                  extra_keys_len(&super::perf::page_load) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::perf::page_load.record_raw(extra);
              Ok(())
          }
          2834 => {
              assert!(
                  extra_keys_len(&super::background_tasks_rmdir_base::metric_base) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::background_tasks_rmdir_base::metric_base.record_raw(extra);
              Ok(())
          }
          2842 => {
              assert!(
                  extra_keys_len(&super::background_tasks_rmdir_http_cache::metric_base) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::background_tasks_rmdir_http_cache::metric_base.record_raw(extra);
              Ok(())
          }
          2850 => {
              assert!(
                  extra_keys_len(&super::background_tasks_rmdir_quota::metric_base) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::background_tasks_rmdir_quota::metric_base.record_raw(extra);
              Ok(())
          }
          2858 => {
              assert!(
                  extra_keys_len(&super::relevancy_classify::fail) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::relevancy_classify::fail.record_raw(extra);
              Ok(())
          }
          2859 => {
              assert!(
                  extra_keys_len(&super::relevancy_classify::succeed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::relevancy_classify::succeed.record_raw(extra);
              Ok(())
          }
          2862 => {
              assert!(
                  extra_keys_len(&super::cookie_banners::google_gdpr_choice_cookie_event) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::cookie_banners::google_gdpr_choice_cookie_event.record_raw(extra);
              Ok(())
          }
          2863 => {
              assert!(
                  extra_keys_len(&super::cookie_banners::google_gdpr_choice_cookie_event_pbm) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::cookie_banners::google_gdpr_choice_cookie_event_pbm.record_raw(extra);
              Ok(())
          }
          2866 => {
              assert!(
                  extra_keys_len(&super::cookie_banners::reload) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::cookie_banners::reload.record_raw(extra);
              Ok(())
          }
          2940 => {
              assert!(
                  extra_keys_len(&super::extensions_data::migrate_result) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::extensions_data::migrate_result.record_raw(extra);
              Ok(())
          }
          2941 => {
              assert!(
                  extra_keys_len(&super::extensions_data::storage_local_error) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::extensions_data::storage_local_error.record_raw(extra);
              Ok(())
          }
          2955 => {
              assert!(
                  extra_keys_len(&super::formautofill_creditcards::form_cleared) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::formautofill_creditcards::form_cleared.record_raw(extra);
              Ok(())
          }
          2956 => {
              assert!(
                  extra_keys_len(&super::formautofill_creditcards::form_detected) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::formautofill_creditcards::form_detected.record_raw(extra);
              Ok(())
          }
          2957 => {
              assert!(
                  extra_keys_len(&super::formautofill_creditcards::form_filled) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::formautofill_creditcards::form_filled.record_raw(extra);
              Ok(())
          }
          2958 => {
              assert!(
                  extra_keys_len(&super::formautofill_creditcards::form_filled_modified) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::formautofill_creditcards::form_filled_modified.record_raw(extra);
              Ok(())
          }
          2959 => {
              assert!(
                  extra_keys_len(&super::formautofill_creditcards::form_popup_shown) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::formautofill_creditcards::form_popup_shown.record_raw(extra);
              Ok(())
          }
          2960 => {
              assert!(
                  extra_keys_len(&super::formautofill_creditcards::form_submitted) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::formautofill_creditcards::form_submitted.record_raw(extra);
              Ok(())
          }
          3007 => {
              assert!(
                  extra_keys_len(&super::test_only_ipc::an_event) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_ipc::an_event.record_raw(extra);
              Ok(())
          }
          3010 => {
              assert!(
                  extra_keys_len(&super::test_only_ipc::event_with_extra) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_ipc::event_with_extra.record_raw(extra);
              Ok(())
          }
          3012 => {
              assert!(
                  extra_keys_len(&super::test_only_ipc::no_extra_event) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_ipc::no_extra_event.record_raw(extra);
              Ok(())
          }
          3015 => {
              assert!(
                  extra_keys_len(&super::test_only_jog::an_event) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_jog::an_event.record_raw(extra);
              Ok(())
          }
          3016 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::enroll_failed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::enroll_failed.record_raw(extra);
              Ok(())
          }
          3017 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::enrollment) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::enrollment.record_raw(extra);
              Ok(())
          }
          3018 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::enrollment_status) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::enrollment_status.record_raw(extra);
              Ok(())
          }
          3019 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::exposure) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::exposure.record_raw(extra);
              Ok(())
          }
          3020 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::is_ready) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::is_ready.record_raw(extra);
              Ok(())
          }
          3021 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::unenroll_failed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::unenroll_failed.record_raw(extra);
              Ok(())
          }
          3022 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::unenrollment) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::unenrollment.record_raw(extra);
              Ok(())
          }
          3023 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::validation_failed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::validation_failed.record_raw(extra);
              Ok(())
          }
          3098 => {
              assert!(
                  extra_keys_len(&super::webcompatreporting::opened) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::webcompatreporting::opened.record_raw(extra);
              Ok(())
          }
          3099 => {
              assert!(
                  extra_keys_len(&super::webcompatreporting::reason_dropdown) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::webcompatreporting::reason_dropdown.record_raw(extra);
              Ok(())
          }
          3100 => {
              assert!(
                  extra_keys_len(&super::webcompatreporting::send) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::webcompatreporting::send.record_raw(extra);
              Ok(())
          }
          3101 => {
              assert!(
                  extra_keys_len(&super::webcompatreporting::send_more_info) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::webcompatreporting::send_more_info.record_raw(extra);
              Ok(())
          }
          3206 => {
              assert!(
                  extra_keys_len(&super::search_engine_default::changed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::search_engine_default::changed.record_raw(extra);
              Ok(())
          }
          3212 => {
              assert!(
                  extra_keys_len(&super::search_engine_private::changed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::search_engine_private::changed.record_raw(extra);
              Ok(())
          }
          3220 => {
              assert!(
                  extra_keys_len(&super::shopping_product::invalid_ohttp_config) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping_product::invalid_ohttp_config.record_raw(extra);
              Ok(())
          }
          3221 => {
              assert!(
                  extra_keys_len(&super::shopping_product::invalid_request) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping_product::invalid_request.record_raw(extra);
              Ok(())
          }
          3222 => {
              assert!(
                  extra_keys_len(&super::shopping_product::invalid_response) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping_product::invalid_response.record_raw(extra);
              Ok(())
          }
          3223 => {
              assert!(
                  extra_keys_len(&super::shopping_product::request_aborted) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping_product::request_aborted.record_raw(extra);
              Ok(())
          }
          3224 => {
              assert!(
                  extra_keys_len(&super::shopping_product::request_error) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping_product::request_error.record_raw(extra);
              Ok(())
          }
          3225 => {
              assert!(
                  extra_keys_len(&super::shopping_product::request_failure) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping_product::request_failure.record_raw(extra);
              Ok(())
          }
          3226 => {
              assert!(
                  extra_keys_len(&super::shopping_product::request_retried) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping_product::request_retried.record_raw(extra);
              Ok(())
          }
          3227 => {
              assert!(
                  extra_keys_len(&super::shopping_product::request_retries_failed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping_product::request_retries_failed.record_raw(extra);
              Ok(())
          }
          3228 => {
              assert!(
                  extra_keys_len(&super::shopping_product::server_failure) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::shopping_product::server_failure.record_raw(extra);
              Ok(())
          }
          3232 => {
              assert!(
                  extra_keys_len(&super::translations::error) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations::error.record_raw(extra);
              Ok(())
          }
          3236 => {
              assert!(
                  extra_keys_len(&super::translations::restore_page) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations::restore_page.record_raw(extra);
              Ok(())
          }
          3237 => {
              assert!(
                  extra_keys_len(&super::translations::translation_request) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations::translation_request.record_raw(extra);
              Ok(())
          }
          3238 => {
              assert!(
                  extra_keys_len(&super::translations_panel::about_translations) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::about_translations.record_raw(extra);
              Ok(())
          }
          3239 => {
              assert!(
                  extra_keys_len(&super::translations_panel::always_offer_translations) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::always_offer_translations.record_raw(extra);
              Ok(())
          }
          3240 => {
              assert!(
                  extra_keys_len(&super::translations_panel::always_translate_language) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::always_translate_language.record_raw(extra);
              Ok(())
          }
          3241 => {
              assert!(
                  extra_keys_len(&super::translations_panel::cancel_button) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::cancel_button.record_raw(extra);
              Ok(())
          }
          3242 => {
              assert!(
                  extra_keys_len(&super::translations_panel::change_from_language) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::change_from_language.record_raw(extra);
              Ok(())
          }
          3243 => {
              assert!(
                  extra_keys_len(&super::translations_panel::change_source_language_button) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::change_source_language_button.record_raw(extra);
              Ok(())
          }
          3244 => {
              assert!(
                  extra_keys_len(&super::translations_panel::change_to_language) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::change_to_language.record_raw(extra);
              Ok(())
          }
          3245 => {
              assert!(
                  extra_keys_len(&super::translations_panel::close) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::close.record_raw(extra);
              Ok(())
          }
          3246 => {
              assert!(
                  extra_keys_len(&super::translations_panel::close_from_language_menu) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::close_from_language_menu.record_raw(extra);
              Ok(())
          }
          3247 => {
              assert!(
                  extra_keys_len(&super::translations_panel::close_settings_menu) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::close_settings_menu.record_raw(extra);
              Ok(())
          }
          3248 => {
              assert!(
                  extra_keys_len(&super::translations_panel::close_to_language_menu) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::close_to_language_menu.record_raw(extra);
              Ok(())
          }
          3249 => {
              assert!(
                  extra_keys_len(&super::translations_panel::dismiss_error_button) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::dismiss_error_button.record_raw(extra);
              Ok(())
          }
          3250 => {
              assert!(
                  extra_keys_len(&super::translations_panel::learn_more) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::learn_more.record_raw(extra);
              Ok(())
          }
          3251 => {
              assert!(
                  extra_keys_len(&super::translations_panel::manage_languages) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::manage_languages.record_raw(extra);
              Ok(())
          }
          3252 => {
              assert!(
                  extra_keys_len(&super::translations_panel::never_translate_language) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::never_translate_language.record_raw(extra);
              Ok(())
          }
          3253 => {
              assert!(
                  extra_keys_len(&super::translations_panel::never_translate_site) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::never_translate_site.record_raw(extra);
              Ok(())
          }
          3254 => {
              assert!(
                  extra_keys_len(&super::translations_panel::open) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::open.record_raw(extra);
              Ok(())
          }
          3255 => {
              assert!(
                  extra_keys_len(&super::translations_panel::open_from_language_menu) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::open_from_language_menu.record_raw(extra);
              Ok(())
          }
          3256 => {
              assert!(
                  extra_keys_len(&super::translations_panel::open_settings_menu) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::open_settings_menu.record_raw(extra);
              Ok(())
          }
          3257 => {
              assert!(
                  extra_keys_len(&super::translations_panel::open_to_language_menu) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::open_to_language_menu.record_raw(extra);
              Ok(())
          }
          3258 => {
              assert!(
                  extra_keys_len(&super::translations_panel::restore_page_button) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::restore_page_button.record_raw(extra);
              Ok(())
          }
          3259 => {
              assert!(
                  extra_keys_len(&super::translations_panel::translate_button) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_panel::translate_button.record_raw(extra);
              Ok(())
          }
          3260 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::about_translations) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::about_translations.record_raw(extra);
              Ok(())
          }
          3261 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::cancel_button) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::cancel_button.record_raw(extra);
              Ok(())
          }
          3262 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::change_from_language) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::change_from_language.record_raw(extra);
              Ok(())
          }
          3263 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::change_to_language) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::change_to_language.record_raw(extra);
              Ok(())
          }
          3264 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::close) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::close.record_raw(extra);
              Ok(())
          }
          3265 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::copy_button) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::copy_button.record_raw(extra);
              Ok(())
          }
          3266 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::done_button) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::done_button.record_raw(extra);
              Ok(())
          }
          3267 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::initialization_failure_message) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::initialization_failure_message.record_raw(extra);
              Ok(())
          }
          3268 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::open) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::open.record_raw(extra);
              Ok(())
          }
          3269 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::open_settings_menu) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::open_settings_menu.record_raw(extra);
              Ok(())
          }
          3270 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::translate_button) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::translate_button.record_raw(extra);
              Ok(())
          }
          3271 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::translate_full_page_button) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::translate_full_page_button.record_raw(extra);
              Ok(())
          }
          3272 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::translation_failure_message) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::translation_failure_message.record_raw(extra);
              Ok(())
          }
          3273 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::translation_settings) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::translation_settings.record_raw(extra);
              Ok(())
          }
          3274 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::try_again_button) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::try_again_button.record_raw(extra);
              Ok(())
          }
          3275 => {
              assert!(
                  extra_keys_len(&super::translations_select_translations_panel::unsupported_language_message) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::translations_select_translations_panel::unsupported_language_message.record_raw(extra);
              Ok(())
          }
          3288 => {
              assert!(
                  extra_keys_len(&super::addons_manager::install) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::addons_manager::install.record_raw(extra);
              Ok(())
          }
          3289 => {
              assert!(
                  extra_keys_len(&super::addons_manager::install_stats) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::addons_manager::install_stats.record_raw(extra);
              Ok(())
          }
          3290 => {
              assert!(
                  extra_keys_len(&super::addons_manager::manage) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::addons_manager::manage.record_raw(extra);
              Ok(())
          }
          3291 => {
              assert!(
                  extra_keys_len(&super::addons_manager::report_suspicious_site) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::addons_manager::report_suspicious_site.record_raw(extra);
              Ok(())
          }
          3292 => {
              assert!(
                  extra_keys_len(&super::addons_manager::update) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::addons_manager::update.record_raw(extra);
              Ok(())
          }
          3293 => {
              assert!(
                  extra_keys_len(&super::blocklist::addon_block_change) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::blocklist::addon_block_change.record_raw(extra);
              Ok(())
          }
          3310 => {
              assert!(
                  extra_keys_len(&super::file_dialog::fallback_v2) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::file_dialog::fallback_v2.record_raw(extra);
              Ok(())
          }
           _ => Err(EventRecordingError::InvalidId),
        }
    }

    /// Wrapper to record an event based on its metric ID, with a provided timestamp.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `timestamp` - The time at which this event was recorded.
    /// * `extra`     - An map of (extra key id, string) pairs.
    ///                 The map will be decoded into the appropriate `ExtraKeys` type.
    /// # Returns
    ///
    /// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
    /// or an `EventRecordingError::InvalidId` if no event by that ID exists
    /// or an `EventRecordingError::InvalidExtraKey` if the event doesn't take extra pairs,
    /// but some are passed in.
    pub(crate) fn record_event_by_id_with_time(metric_id: MetricId, timestamp: u64, extra: HashMap<String, String>) -> Result<(), EventRecordingError> {
        match metric_id {
          MetricId(1) => {
              if extra_keys_len(&super::privacy_sanitize::clear) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_sanitize::clear.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2) => {
              if extra_keys_len(&super::privacy_sanitize::clearing_time_span_selected) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_sanitize::clearing_time_span_selected.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3) => {
              if extra_keys_len(&super::privacy_sanitize::dialog_open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_sanitize::dialog_open.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(38) => {
              if extra_keys_len(&super::browser_launched_to_handle::system_notification) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_launched_to_handle::system_notification.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(76) => {
              if extra_keys_len(&super::newtab::closed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::closed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(80) => {
              if extra_keys_len(&super::newtab::opened) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::opened.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(82) => {
              if extra_keys_len(&super::newtab::tooltip_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::tooltip_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(83) => {
              if extra_keys_len(&super::newtab::wallpaper_category_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_category_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(84) => {
              if extra_keys_len(&super::newtab::wallpaper_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(85) => {
              if extra_keys_len(&super::newtab::wallpaper_highlight_cta_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_highlight_cta_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(86) => {
              if extra_keys_len(&super::newtab::wallpaper_highlight_dismissed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_highlight_dismissed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(87) => {
              if extra_keys_len(&super::newtab::weather_change_display) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_change_display.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(89) => {
              if extra_keys_len(&super::newtab::weather_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(90) => {
              if extra_keys_len(&super::newtab::weather_load_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_load_error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(91) => {
              if extra_keys_len(&super::newtab::weather_location_selected) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_location_selected.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(92) => {
              if extra_keys_len(&super::newtab::weather_open_provider_url) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_open_provider_url.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(95) => {
              if extra_keys_len(&super::newtab_search::issued) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search::issued.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(96) => {
              if extra_keys_len(&super::pocket::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(99) => {
              if extra_keys_len(&super::pocket::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(102) => {
              if extra_keys_len(&super::pocket::save) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::save.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(105) => {
              if extra_keys_len(&super::pocket::topic_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::topic_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(113) => {
              if extra_keys_len(&super::topsites::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(114) => {
              if extra_keys_len(&super::topsites::dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(116) => {
              if extra_keys_len(&super::topsites::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(117) => {
              if extra_keys_len(&super::topsites::pref_changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::pref_changed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(119) => {
              if extra_keys_len(&super::topsites::show_privacy_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::show_privacy_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(130) => {
              if extra_keys_len(&super::privacy_ui_fpp_click::checkbox) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_ui_fpp_click::checkbox.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(131) => {
              if extra_keys_len(&super::privacy_ui_fpp_click::menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_ui_fpp_click::menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(132) => {
              if extra_keys_len(&super::private_browsing_reset_pbm::confirm_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::private_browsing_reset_pbm::confirm_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(133) => {
              if extra_keys_len(&super::private_browsing_reset_pbm::reset_action) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::private_browsing_reset_pbm::reset_action.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(136) => {
              if extra_keys_len(&super::protocolhandler_mailto::visit) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::protocolhandler_mailto::visit.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(137) => {
              if extra_keys_len(&super::newtab_search_ad::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search_ad::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(138) => {
              if extra_keys_len(&super::newtab_search_ad::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search_ad::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(141) => {
              if extra_keys_len(&super::serp::abandonment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::abandonment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(142) => {
              if extra_keys_len(&super::serp::ad_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::ad_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(143) => {
              if extra_keys_len(&super::serp::categorization) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::categorization.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(145) => {
              if extra_keys_len(&super::serp::engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(146) => {
              if extra_keys_len(&super::serp::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(147) => {
              if extra_keys_len(&super::shopping::address_bar_feature_callout_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::address_bar_feature_callout_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(148) => {
              if extra_keys_len(&super::shopping::address_bar_icon_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::address_bar_icon_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(149) => {
              if extra_keys_len(&super::shopping::address_bar_icon_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::address_bar_icon_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(150) => {
              if extra_keys_len(&super::shopping::ads_exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::ads_exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(152) => {
              if extra_keys_len(&super::shopping::surface_ads_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(153) => {
              if extra_keys_len(&super::shopping::surface_ads_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(154) => {
              if extra_keys_len(&super::shopping::surface_ads_placement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_placement.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(155) => {
              if extra_keys_len(&super::shopping::surface_ads_setting_toggled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_setting_toggled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(156) => {
              if extra_keys_len(&super::shopping::surface_analyze_reviews_none_available_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_analyze_reviews_none_available_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(157) => {
              if extra_keys_len(&super::shopping::surface_auto_open_setting_toggled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_auto_open_setting_toggled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(158) => {
              if extra_keys_len(&super::shopping::surface_closed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_closed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(159) => {
              if extra_keys_len(&super::shopping::surface_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(160) => {
              if extra_keys_len(&super::shopping::surface_learn_more_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_learn_more_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(161) => {
              if extra_keys_len(&super::shopping::surface_no_ads_available) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_no_ads_available.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(162) => {
              if extra_keys_len(&super::shopping::surface_no_review_reliability_available) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_no_review_reliability_available.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(163) => {
              if extra_keys_len(&super::shopping::surface_no_thanks_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_no_thanks_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(164) => {
              if extra_keys_len(&super::shopping::surface_not_now_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_not_now_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(165) => {
              if extra_keys_len(&super::shopping::surface_onboarding_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_onboarding_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(166) => {
              if extra_keys_len(&super::shopping::surface_opt_in_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_opt_in_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(167) => {
              if extra_keys_len(&super::shopping::surface_opt_out_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_opt_out_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(168) => {
              if extra_keys_len(&super::shopping::surface_powered_by_fakespot_link_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_powered_by_fakespot_link_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(169) => {
              if extra_keys_len(&super::shopping::surface_reactivated_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_reactivated_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(170) => {
              if extra_keys_len(&super::shopping::surface_reanalyze_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_reanalyze_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(171) => {
              if extra_keys_len(&super::shopping::surface_settings_expand_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_settings_expand_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(172) => {
              if extra_keys_len(&super::shopping::surface_show_more_reviews_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_more_reviews_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(173) => {
              if extra_keys_len(&super::shopping::surface_show_privacy_policy_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_privacy_policy_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(174) => {
              if extra_keys_len(&super::shopping::surface_show_quality_explainer_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_quality_explainer_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(175) => {
              if extra_keys_len(&super::shopping::surface_show_quality_explainer_url_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_quality_explainer_url_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(176) => {
              if extra_keys_len(&super::shopping::surface_show_terms_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_terms_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(177) => {
              if extra_keys_len(&super::shopping::surface_stale_analysis_shown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_stale_analysis_shown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(178) => {
              if extra_keys_len(&super::shopping::surface_yes_keep_closed_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_yes_keep_closed_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(198) => {
              if extra_keys_len(&super::urlbar::abandonment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::abandonment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(199) => {
              if extra_keys_len(&super::urlbar::engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(200) => {
              if extra_keys_len(&super::urlbar::exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(201) => {
              if extra_keys_len(&super::urlbar::potential_exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::potential_exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(207) => {
              if extra_keys_len(&super::urlbar::quick_suggest_contextual_opt_in) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::quick_suggest_contextual_opt_in.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(211) => {
              if extra_keys_len(&super::browser_usage::interaction) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_usage::interaction.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2580) => {
              if extra_keys_len(&super::mediadrm::eme_playback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::mediadrm::eme_playback.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2583) => {
              if extra_keys_len(&super::hls::media_load) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::hls::media_load.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2588) => {
              if extra_keys_len(&super::media_playback::first_frame_loaded) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::media_playback::first_frame_loaded.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2590) => {
              if extra_keys_len(&super::mfcdm::eme_playback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::mfcdm::eme_playback.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2591) => {
              if extra_keys_len(&super::mfcdm::error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::mfcdm::error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2626) => {
              if extra_keys_len(&super::perf::page_load) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::perf::page_load.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2834) => {
              if extra_keys_len(&super::background_tasks_rmdir_base::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_base::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2842) => {
              if extra_keys_len(&super::background_tasks_rmdir_http_cache::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_http_cache::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2850) => {
              if extra_keys_len(&super::background_tasks_rmdir_quota::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_quota::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2858) => {
              if extra_keys_len(&super::relevancy_classify::fail) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relevancy_classify::fail.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2859) => {
              if extra_keys_len(&super::relevancy_classify::succeed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relevancy_classify::succeed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2862) => {
              if extra_keys_len(&super::cookie_banners::google_gdpr_choice_cookie_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::cookie_banners::google_gdpr_choice_cookie_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2863) => {
              if extra_keys_len(&super::cookie_banners::google_gdpr_choice_cookie_event_pbm) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::cookie_banners::google_gdpr_choice_cookie_event_pbm.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2866) => {
              if extra_keys_len(&super::cookie_banners::reload) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::cookie_banners::reload.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2940) => {
              if extra_keys_len(&super::extensions_data::migrate_result) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::extensions_data::migrate_result.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2941) => {
              if extra_keys_len(&super::extensions_data::storage_local_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::extensions_data::storage_local_error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2955) => {
              if extra_keys_len(&super::formautofill_creditcards::form_cleared) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_cleared.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2956) => {
              if extra_keys_len(&super::formautofill_creditcards::form_detected) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_detected.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2957) => {
              if extra_keys_len(&super::formautofill_creditcards::form_filled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_filled.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2958) => {
              if extra_keys_len(&super::formautofill_creditcards::form_filled_modified) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_filled_modified.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2959) => {
              if extra_keys_len(&super::formautofill_creditcards::form_popup_shown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_popup_shown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(2960) => {
              if extra_keys_len(&super::formautofill_creditcards::form_submitted) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_creditcards::form_submitted.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3007) => {
              if extra_keys_len(&super::test_only_ipc::an_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::an_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3010) => {
              if extra_keys_len(&super::test_only_ipc::event_with_extra) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::event_with_extra.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3012) => {
              if extra_keys_len(&super::test_only_ipc::no_extra_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::no_extra_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3015) => {
              if extra_keys_len(&super::test_only_jog::an_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_jog::an_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3016) => {
              if extra_keys_len(&super::nimbus_events::enroll_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enroll_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3017) => {
              if extra_keys_len(&super::nimbus_events::enrollment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enrollment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3018) => {
              if extra_keys_len(&super::nimbus_events::enrollment_status) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enrollment_status.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3019) => {
              if extra_keys_len(&super::nimbus_events::exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3020) => {
              if extra_keys_len(&super::nimbus_events::is_ready) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::is_ready.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3021) => {
              if extra_keys_len(&super::nimbus_events::unenroll_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::unenroll_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3022) => {
              if extra_keys_len(&super::nimbus_events::unenrollment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::unenrollment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3023) => {
              if extra_keys_len(&super::nimbus_events::validation_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::validation_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3098) => {
              if extra_keys_len(&super::webcompatreporting::opened) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::opened.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3099) => {
              if extra_keys_len(&super::webcompatreporting::reason_dropdown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::reason_dropdown.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3100) => {
              if extra_keys_len(&super::webcompatreporting::send) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::send.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3101) => {
              if extra_keys_len(&super::webcompatreporting::send_more_info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::send_more_info.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3206) => {
              if extra_keys_len(&super::search_engine_default::changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::search_engine_default::changed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3212) => {
              if extra_keys_len(&super::search_engine_private::changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::search_engine_private::changed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3220) => {
              if extra_keys_len(&super::shopping_product::invalid_ohttp_config) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::invalid_ohttp_config.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3221) => {
              if extra_keys_len(&super::shopping_product::invalid_request) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::invalid_request.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3222) => {
              if extra_keys_len(&super::shopping_product::invalid_response) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::invalid_response.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3223) => {
              if extra_keys_len(&super::shopping_product::request_aborted) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_aborted.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3224) => {
              if extra_keys_len(&super::shopping_product::request_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3225) => {
              if extra_keys_len(&super::shopping_product::request_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3226) => {
              if extra_keys_len(&super::shopping_product::request_retried) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_retried.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3227) => {
              if extra_keys_len(&super::shopping_product::request_retries_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_retries_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3228) => {
              if extra_keys_len(&super::shopping_product::server_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::server_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3232) => {
              if extra_keys_len(&super::translations::error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::error.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3236) => {
              if extra_keys_len(&super::translations::restore_page) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::restore_page.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3237) => {
              if extra_keys_len(&super::translations::translation_request) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::translation_request.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3238) => {
              if extra_keys_len(&super::translations_panel::about_translations) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::about_translations.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3239) => {
              if extra_keys_len(&super::translations_panel::always_offer_translations) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::always_offer_translations.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3240) => {
              if extra_keys_len(&super::translations_panel::always_translate_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::always_translate_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3241) => {
              if extra_keys_len(&super::translations_panel::cancel_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::cancel_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3242) => {
              if extra_keys_len(&super::translations_panel::change_from_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::change_from_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3243) => {
              if extra_keys_len(&super::translations_panel::change_source_language_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::change_source_language_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3244) => {
              if extra_keys_len(&super::translations_panel::change_to_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::change_to_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3245) => {
              if extra_keys_len(&super::translations_panel::close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3246) => {
              if extra_keys_len(&super::translations_panel::close_from_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close_from_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3247) => {
              if extra_keys_len(&super::translations_panel::close_settings_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close_settings_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3248) => {
              if extra_keys_len(&super::translations_panel::close_to_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close_to_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3249) => {
              if extra_keys_len(&super::translations_panel::dismiss_error_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::dismiss_error_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3250) => {
              if extra_keys_len(&super::translations_panel::learn_more) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::learn_more.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3251) => {
              if extra_keys_len(&super::translations_panel::manage_languages) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::manage_languages.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3252) => {
              if extra_keys_len(&super::translations_panel::never_translate_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::never_translate_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3253) => {
              if extra_keys_len(&super::translations_panel::never_translate_site) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::never_translate_site.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3254) => {
              if extra_keys_len(&super::translations_panel::open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3255) => {
              if extra_keys_len(&super::translations_panel::open_from_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open_from_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3256) => {
              if extra_keys_len(&super::translations_panel::open_settings_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open_settings_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3257) => {
              if extra_keys_len(&super::translations_panel::open_to_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open_to_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3258) => {
              if extra_keys_len(&super::translations_panel::restore_page_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::restore_page_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3259) => {
              if extra_keys_len(&super::translations_panel::translate_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::translate_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3260) => {
              if extra_keys_len(&super::translations_select_translations_panel::about_translations) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::about_translations.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3261) => {
              if extra_keys_len(&super::translations_select_translations_panel::cancel_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::cancel_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3262) => {
              if extra_keys_len(&super::translations_select_translations_panel::change_from_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::change_from_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3263) => {
              if extra_keys_len(&super::translations_select_translations_panel::change_to_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::change_to_language.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3264) => {
              if extra_keys_len(&super::translations_select_translations_panel::close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::close.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3265) => {
              if extra_keys_len(&super::translations_select_translations_panel::copy_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::copy_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3266) => {
              if extra_keys_len(&super::translations_select_translations_panel::done_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::done_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3267) => {
              if extra_keys_len(&super::translations_select_translations_panel::initialization_failure_message) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::initialization_failure_message.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3268) => {
              if extra_keys_len(&super::translations_select_translations_panel::open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::open.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3269) => {
              if extra_keys_len(&super::translations_select_translations_panel::open_settings_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::open_settings_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3270) => {
              if extra_keys_len(&super::translations_select_translations_panel::translate_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translate_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3271) => {
              if extra_keys_len(&super::translations_select_translations_panel::translate_full_page_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translate_full_page_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3272) => {
              if extra_keys_len(&super::translations_select_translations_panel::translation_failure_message) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translation_failure_message.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3273) => {
              if extra_keys_len(&super::translations_select_translations_panel::translation_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translation_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3274) => {
              if extra_keys_len(&super::translations_select_translations_panel::try_again_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::try_again_button.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3275) => {
              if extra_keys_len(&super::translations_select_translations_panel::unsupported_language_message) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::unsupported_language_message.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3288) => {
              if extra_keys_len(&super::addons_manager::install) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3289) => {
              if extra_keys_len(&super::addons_manager::install_stats) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3290) => {
              if extra_keys_len(&super::addons_manager::manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::manage.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3291) => {
              if extra_keys_len(&super::addons_manager::report_suspicious_site) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::report_suspicious_site.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3292) => {
              if extra_keys_len(&super::addons_manager::update) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3293) => {
              if extra_keys_len(&super::blocklist::addon_block_change) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::blocklist::addon_block_change.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(3310) => {
              if extra_keys_len(&super::file_dialog::fallback_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::file_dialog::fallback_v2.record_with_time(timestamp, extra);
              Ok(())
          }
           _ => Err(EventRecordingError::InvalidId),
        }
    }

    /// Wrapper to get the currently stored events for event metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns the recorded events or `None` if nothing stored.
    ///
    /// # Panics
    ///
    /// Panics if no event by the given metric ID could be found.
    pub(crate) fn event_test_get_value_wrapper(metric_id: u32, ping_name: Option<String>) -> Option<Vec<RecordedEvent>> {
        match metric_id {
           1 => super::privacy_sanitize::clear.test_get_value(ping_name.as_deref()),
           2 => super::privacy_sanitize::clearing_time_span_selected.test_get_value(ping_name.as_deref()),
           3 => super::privacy_sanitize::dialog_open.test_get_value(ping_name.as_deref()),
           38 => super::browser_launched_to_handle::system_notification.test_get_value(ping_name.as_deref()),
           76 => super::newtab::closed.test_get_value(ping_name.as_deref()),
           80 => super::newtab::opened.test_get_value(ping_name.as_deref()),
           82 => super::newtab::tooltip_click.test_get_value(ping_name.as_deref()),
           83 => super::newtab::wallpaper_category_click.test_get_value(ping_name.as_deref()),
           84 => super::newtab::wallpaper_click.test_get_value(ping_name.as_deref()),
           85 => super::newtab::wallpaper_highlight_cta_click.test_get_value(ping_name.as_deref()),
           86 => super::newtab::wallpaper_highlight_dismissed.test_get_value(ping_name.as_deref()),
           87 => super::newtab::weather_change_display.test_get_value(ping_name.as_deref()),
           89 => super::newtab::weather_impression.test_get_value(ping_name.as_deref()),
           90 => super::newtab::weather_load_error.test_get_value(ping_name.as_deref()),
           91 => super::newtab::weather_location_selected.test_get_value(ping_name.as_deref()),
           92 => super::newtab::weather_open_provider_url.test_get_value(ping_name.as_deref()),
           95 => super::newtab_search::issued.test_get_value(ping_name.as_deref()),
           96 => super::pocket::click.test_get_value(ping_name.as_deref()),
           99 => super::pocket::impression.test_get_value(ping_name.as_deref()),
           102 => super::pocket::save.test_get_value(ping_name.as_deref()),
           105 => super::pocket::topic_click.test_get_value(ping_name.as_deref()),
           113 => super::topsites::click.test_get_value(ping_name.as_deref()),
           114 => super::topsites::dismiss.test_get_value(ping_name.as_deref()),
           116 => super::topsites::impression.test_get_value(ping_name.as_deref()),
           117 => super::topsites::pref_changed.test_get_value(ping_name.as_deref()),
           119 => super::topsites::show_privacy_click.test_get_value(ping_name.as_deref()),
           130 => super::privacy_ui_fpp_click::checkbox.test_get_value(ping_name.as_deref()),
           131 => super::privacy_ui_fpp_click::menu.test_get_value(ping_name.as_deref()),
           132 => super::private_browsing_reset_pbm::confirm_panel.test_get_value(ping_name.as_deref()),
           133 => super::private_browsing_reset_pbm::reset_action.test_get_value(ping_name.as_deref()),
           136 => super::protocolhandler_mailto::visit.test_get_value(ping_name.as_deref()),
           137 => super::newtab_search_ad::click.test_get_value(ping_name.as_deref()),
           138 => super::newtab_search_ad::impression.test_get_value(ping_name.as_deref()),
           141 => super::serp::abandonment.test_get_value(ping_name.as_deref()),
           142 => super::serp::ad_impression.test_get_value(ping_name.as_deref()),
           143 => super::serp::categorization.test_get_value(ping_name.as_deref()),
           145 => super::serp::engagement.test_get_value(ping_name.as_deref()),
           146 => super::serp::impression.test_get_value(ping_name.as_deref()),
           147 => super::shopping::address_bar_feature_callout_displayed.test_get_value(ping_name.as_deref()),
           148 => super::shopping::address_bar_icon_clicked.test_get_value(ping_name.as_deref()),
           149 => super::shopping::address_bar_icon_displayed.test_get_value(ping_name.as_deref()),
           150 => super::shopping::ads_exposure.test_get_value(ping_name.as_deref()),
           152 => super::shopping::surface_ads_clicked.test_get_value(ping_name.as_deref()),
           153 => super::shopping::surface_ads_impression.test_get_value(ping_name.as_deref()),
           154 => super::shopping::surface_ads_placement.test_get_value(ping_name.as_deref()),
           155 => super::shopping::surface_ads_setting_toggled.test_get_value(ping_name.as_deref()),
           156 => super::shopping::surface_analyze_reviews_none_available_clicked.test_get_value(ping_name.as_deref()),
           157 => super::shopping::surface_auto_open_setting_toggled.test_get_value(ping_name.as_deref()),
           158 => super::shopping::surface_closed.test_get_value(ping_name.as_deref()),
           159 => super::shopping::surface_displayed.test_get_value(ping_name.as_deref()),
           160 => super::shopping::surface_learn_more_clicked.test_get_value(ping_name.as_deref()),
           161 => super::shopping::surface_no_ads_available.test_get_value(ping_name.as_deref()),
           162 => super::shopping::surface_no_review_reliability_available.test_get_value(ping_name.as_deref()),
           163 => super::shopping::surface_no_thanks_button_clicked.test_get_value(ping_name.as_deref()),
           164 => super::shopping::surface_not_now_clicked.test_get_value(ping_name.as_deref()),
           165 => super::shopping::surface_onboarding_displayed.test_get_value(ping_name.as_deref()),
           166 => super::shopping::surface_opt_in_clicked.test_get_value(ping_name.as_deref()),
           167 => super::shopping::surface_opt_out_button_clicked.test_get_value(ping_name.as_deref()),
           168 => super::shopping::surface_powered_by_fakespot_link_clicked.test_get_value(ping_name.as_deref()),
           169 => super::shopping::surface_reactivated_button_clicked.test_get_value(ping_name.as_deref()),
           170 => super::shopping::surface_reanalyze_clicked.test_get_value(ping_name.as_deref()),
           171 => super::shopping::surface_settings_expand_clicked.test_get_value(ping_name.as_deref()),
           172 => super::shopping::surface_show_more_reviews_button_clicked.test_get_value(ping_name.as_deref()),
           173 => super::shopping::surface_show_privacy_policy_clicked.test_get_value(ping_name.as_deref()),
           174 => super::shopping::surface_show_quality_explainer_clicked.test_get_value(ping_name.as_deref()),
           175 => super::shopping::surface_show_quality_explainer_url_clicked.test_get_value(ping_name.as_deref()),
           176 => super::shopping::surface_show_terms_clicked.test_get_value(ping_name.as_deref()),
           177 => super::shopping::surface_stale_analysis_shown.test_get_value(ping_name.as_deref()),
           178 => super::shopping::surface_yes_keep_closed_button_clicked.test_get_value(ping_name.as_deref()),
           198 => super::urlbar::abandonment.test_get_value(ping_name.as_deref()),
           199 => super::urlbar::engagement.test_get_value(ping_name.as_deref()),
           200 => super::urlbar::exposure.test_get_value(ping_name.as_deref()),
           201 => super::urlbar::potential_exposure.test_get_value(ping_name.as_deref()),
           207 => super::urlbar::quick_suggest_contextual_opt_in.test_get_value(ping_name.as_deref()),
           211 => super::browser_usage::interaction.test_get_value(ping_name.as_deref()),
           2580 => super::mediadrm::eme_playback.test_get_value(ping_name.as_deref()),
           2583 => super::hls::media_load.test_get_value(ping_name.as_deref()),
           2588 => super::media_playback::first_frame_loaded.test_get_value(ping_name.as_deref()),
           2590 => super::mfcdm::eme_playback.test_get_value(ping_name.as_deref()),
           2591 => super::mfcdm::error.test_get_value(ping_name.as_deref()),
           2626 => super::perf::page_load.test_get_value(ping_name.as_deref()),
           2834 => super::background_tasks_rmdir_base::metric_base.test_get_value(ping_name.as_deref()),
           2842 => super::background_tasks_rmdir_http_cache::metric_base.test_get_value(ping_name.as_deref()),
           2850 => super::background_tasks_rmdir_quota::metric_base.test_get_value(ping_name.as_deref()),
           2858 => super::relevancy_classify::fail.test_get_value(ping_name.as_deref()),
           2859 => super::relevancy_classify::succeed.test_get_value(ping_name.as_deref()),
           2862 => super::cookie_banners::google_gdpr_choice_cookie_event.test_get_value(ping_name.as_deref()),
           2863 => super::cookie_banners::google_gdpr_choice_cookie_event_pbm.test_get_value(ping_name.as_deref()),
           2866 => super::cookie_banners::reload.test_get_value(ping_name.as_deref()),
           2940 => super::extensions_data::migrate_result.test_get_value(ping_name.as_deref()),
           2941 => super::extensions_data::storage_local_error.test_get_value(ping_name.as_deref()),
           2955 => super::formautofill_creditcards::form_cleared.test_get_value(ping_name.as_deref()),
           2956 => super::formautofill_creditcards::form_detected.test_get_value(ping_name.as_deref()),
           2957 => super::formautofill_creditcards::form_filled.test_get_value(ping_name.as_deref()),
           2958 => super::formautofill_creditcards::form_filled_modified.test_get_value(ping_name.as_deref()),
           2959 => super::formautofill_creditcards::form_popup_shown.test_get_value(ping_name.as_deref()),
           2960 => super::formautofill_creditcards::form_submitted.test_get_value(ping_name.as_deref()),
           3007 => super::test_only_ipc::an_event.test_get_value(ping_name.as_deref()),
           3010 => super::test_only_ipc::event_with_extra.test_get_value(ping_name.as_deref()),
           3012 => super::test_only_ipc::no_extra_event.test_get_value(ping_name.as_deref()),
           3015 => super::test_only_jog::an_event.test_get_value(ping_name.as_deref()),
           3016 => super::nimbus_events::enroll_failed.test_get_value(ping_name.as_deref()),
           3017 => super::nimbus_events::enrollment.test_get_value(ping_name.as_deref()),
           3018 => super::nimbus_events::enrollment_status.test_get_value(ping_name.as_deref()),
           3019 => super::nimbus_events::exposure.test_get_value(ping_name.as_deref()),
           3020 => super::nimbus_events::is_ready.test_get_value(ping_name.as_deref()),
           3021 => super::nimbus_events::unenroll_failed.test_get_value(ping_name.as_deref()),
           3022 => super::nimbus_events::unenrollment.test_get_value(ping_name.as_deref()),
           3023 => super::nimbus_events::validation_failed.test_get_value(ping_name.as_deref()),
           3098 => super::webcompatreporting::opened.test_get_value(ping_name.as_deref()),
           3099 => super::webcompatreporting::reason_dropdown.test_get_value(ping_name.as_deref()),
           3100 => super::webcompatreporting::send.test_get_value(ping_name.as_deref()),
           3101 => super::webcompatreporting::send_more_info.test_get_value(ping_name.as_deref()),
           3206 => super::search_engine_default::changed.test_get_value(ping_name.as_deref()),
           3212 => super::search_engine_private::changed.test_get_value(ping_name.as_deref()),
           3220 => super::shopping_product::invalid_ohttp_config.test_get_value(ping_name.as_deref()),
           3221 => super::shopping_product::invalid_request.test_get_value(ping_name.as_deref()),
           3222 => super::shopping_product::invalid_response.test_get_value(ping_name.as_deref()),
           3223 => super::shopping_product::request_aborted.test_get_value(ping_name.as_deref()),
           3224 => super::shopping_product::request_error.test_get_value(ping_name.as_deref()),
           3225 => super::shopping_product::request_failure.test_get_value(ping_name.as_deref()),
           3226 => super::shopping_product::request_retried.test_get_value(ping_name.as_deref()),
           3227 => super::shopping_product::request_retries_failed.test_get_value(ping_name.as_deref()),
           3228 => super::shopping_product::server_failure.test_get_value(ping_name.as_deref()),
           3232 => super::translations::error.test_get_value(ping_name.as_deref()),
           3236 => super::translations::restore_page.test_get_value(ping_name.as_deref()),
           3237 => super::translations::translation_request.test_get_value(ping_name.as_deref()),
           3238 => super::translations_panel::about_translations.test_get_value(ping_name.as_deref()),
           3239 => super::translations_panel::always_offer_translations.test_get_value(ping_name.as_deref()),
           3240 => super::translations_panel::always_translate_language.test_get_value(ping_name.as_deref()),
           3241 => super::translations_panel::cancel_button.test_get_value(ping_name.as_deref()),
           3242 => super::translations_panel::change_from_language.test_get_value(ping_name.as_deref()),
           3243 => super::translations_panel::change_source_language_button.test_get_value(ping_name.as_deref()),
           3244 => super::translations_panel::change_to_language.test_get_value(ping_name.as_deref()),
           3245 => super::translations_panel::close.test_get_value(ping_name.as_deref()),
           3246 => super::translations_panel::close_from_language_menu.test_get_value(ping_name.as_deref()),
           3247 => super::translations_panel::close_settings_menu.test_get_value(ping_name.as_deref()),
           3248 => super::translations_panel::close_to_language_menu.test_get_value(ping_name.as_deref()),
           3249 => super::translations_panel::dismiss_error_button.test_get_value(ping_name.as_deref()),
           3250 => super::translations_panel::learn_more.test_get_value(ping_name.as_deref()),
           3251 => super::translations_panel::manage_languages.test_get_value(ping_name.as_deref()),
           3252 => super::translations_panel::never_translate_language.test_get_value(ping_name.as_deref()),
           3253 => super::translations_panel::never_translate_site.test_get_value(ping_name.as_deref()),
           3254 => super::translations_panel::open.test_get_value(ping_name.as_deref()),
           3255 => super::translations_panel::open_from_language_menu.test_get_value(ping_name.as_deref()),
           3256 => super::translations_panel::open_settings_menu.test_get_value(ping_name.as_deref()),
           3257 => super::translations_panel::open_to_language_menu.test_get_value(ping_name.as_deref()),
           3258 => super::translations_panel::restore_page_button.test_get_value(ping_name.as_deref()),
           3259 => super::translations_panel::translate_button.test_get_value(ping_name.as_deref()),
           3260 => super::translations_select_translations_panel::about_translations.test_get_value(ping_name.as_deref()),
           3261 => super::translations_select_translations_panel::cancel_button.test_get_value(ping_name.as_deref()),
           3262 => super::translations_select_translations_panel::change_from_language.test_get_value(ping_name.as_deref()),
           3263 => super::translations_select_translations_panel::change_to_language.test_get_value(ping_name.as_deref()),
           3264 => super::translations_select_translations_panel::close.test_get_value(ping_name.as_deref()),
           3265 => super::translations_select_translations_panel::copy_button.test_get_value(ping_name.as_deref()),
           3266 => super::translations_select_translations_panel::done_button.test_get_value(ping_name.as_deref()),
           3267 => super::translations_select_translations_panel::initialization_failure_message.test_get_value(ping_name.as_deref()),
           3268 => super::translations_select_translations_panel::open.test_get_value(ping_name.as_deref()),
           3269 => super::translations_select_translations_panel::open_settings_menu.test_get_value(ping_name.as_deref()),
           3270 => super::translations_select_translations_panel::translate_button.test_get_value(ping_name.as_deref()),
           3271 => super::translations_select_translations_panel::translate_full_page_button.test_get_value(ping_name.as_deref()),
           3272 => super::translations_select_translations_panel::translation_failure_message.test_get_value(ping_name.as_deref()),
           3273 => super::translations_select_translations_panel::translation_settings.test_get_value(ping_name.as_deref()),
           3274 => super::translations_select_translations_panel::try_again_button.test_get_value(ping_name.as_deref()),
           3275 => super::translations_select_translations_panel::unsupported_language_message.test_get_value(ping_name.as_deref()),
           3288 => super::addons_manager::install.test_get_value(ping_name.as_deref()),
           3289 => super::addons_manager::install_stats.test_get_value(ping_name.as_deref()),
           3290 => super::addons_manager::manage.test_get_value(ping_name.as_deref()),
           3291 => super::addons_manager::report_suspicious_site.test_get_value(ping_name.as_deref()),
           3292 => super::addons_manager::update.test_get_value(ping_name.as_deref()),
           3293 => super::blocklist::addon_block_change.test_get_value(ping_name.as_deref()),
           3310 => super::file_dialog::fallback_v2.test_get_value(ping_name.as_deref()),
           _ => panic!("No event for metric id {}", metric_id),
        }
    }

    /// Check the provided event for errors.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns a string for the recorded error or `None`.
    ///
    /// # Panics
    ///
    /// Panics if no event by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn event_test_get_error(metric_id: u32) -> Option<String> {
        #[cfg(feature = "with_gecko")]
        match metric_id {
           1 => test_get_errors!(super::privacy_sanitize::clear),
           2 => test_get_errors!(super::privacy_sanitize::clearing_time_span_selected),
           3 => test_get_errors!(super::privacy_sanitize::dialog_open),
           38 => test_get_errors!(super::browser_launched_to_handle::system_notification),
           76 => test_get_errors!(super::newtab::closed),
           80 => test_get_errors!(super::newtab::opened),
           82 => test_get_errors!(super::newtab::tooltip_click),
           83 => test_get_errors!(super::newtab::wallpaper_category_click),
           84 => test_get_errors!(super::newtab::wallpaper_click),
           85 => test_get_errors!(super::newtab::wallpaper_highlight_cta_click),
           86 => test_get_errors!(super::newtab::wallpaper_highlight_dismissed),
           87 => test_get_errors!(super::newtab::weather_change_display),
           89 => test_get_errors!(super::newtab::weather_impression),
           90 => test_get_errors!(super::newtab::weather_load_error),
           91 => test_get_errors!(super::newtab::weather_location_selected),
           92 => test_get_errors!(super::newtab::weather_open_provider_url),
           95 => test_get_errors!(super::newtab_search::issued),
           96 => test_get_errors!(super::pocket::click),
           99 => test_get_errors!(super::pocket::impression),
           102 => test_get_errors!(super::pocket::save),
           105 => test_get_errors!(super::pocket::topic_click),
           113 => test_get_errors!(super::topsites::click),
           114 => test_get_errors!(super::topsites::dismiss),
           116 => test_get_errors!(super::topsites::impression),
           117 => test_get_errors!(super::topsites::pref_changed),
           119 => test_get_errors!(super::topsites::show_privacy_click),
           130 => test_get_errors!(super::privacy_ui_fpp_click::checkbox),
           131 => test_get_errors!(super::privacy_ui_fpp_click::menu),
           132 => test_get_errors!(super::private_browsing_reset_pbm::confirm_panel),
           133 => test_get_errors!(super::private_browsing_reset_pbm::reset_action),
           136 => test_get_errors!(super::protocolhandler_mailto::visit),
           137 => test_get_errors!(super::newtab_search_ad::click),
           138 => test_get_errors!(super::newtab_search_ad::impression),
           141 => test_get_errors!(super::serp::abandonment),
           142 => test_get_errors!(super::serp::ad_impression),
           143 => test_get_errors!(super::serp::categorization),
           145 => test_get_errors!(super::serp::engagement),
           146 => test_get_errors!(super::serp::impression),
           147 => test_get_errors!(super::shopping::address_bar_feature_callout_displayed),
           148 => test_get_errors!(super::shopping::address_bar_icon_clicked),
           149 => test_get_errors!(super::shopping::address_bar_icon_displayed),
           150 => test_get_errors!(super::shopping::ads_exposure),
           152 => test_get_errors!(super::shopping::surface_ads_clicked),
           153 => test_get_errors!(super::shopping::surface_ads_impression),
           154 => test_get_errors!(super::shopping::surface_ads_placement),
           155 => test_get_errors!(super::shopping::surface_ads_setting_toggled),
           156 => test_get_errors!(super::shopping::surface_analyze_reviews_none_available_clicked),
           157 => test_get_errors!(super::shopping::surface_auto_open_setting_toggled),
           158 => test_get_errors!(super::shopping::surface_closed),
           159 => test_get_errors!(super::shopping::surface_displayed),
           160 => test_get_errors!(super::shopping::surface_learn_more_clicked),
           161 => test_get_errors!(super::shopping::surface_no_ads_available),
           162 => test_get_errors!(super::shopping::surface_no_review_reliability_available),
           163 => test_get_errors!(super::shopping::surface_no_thanks_button_clicked),
           164 => test_get_errors!(super::shopping::surface_not_now_clicked),
           165 => test_get_errors!(super::shopping::surface_onboarding_displayed),
           166 => test_get_errors!(super::shopping::surface_opt_in_clicked),
           167 => test_get_errors!(super::shopping::surface_opt_out_button_clicked),
           168 => test_get_errors!(super::shopping::surface_powered_by_fakespot_link_clicked),
           169 => test_get_errors!(super::shopping::surface_reactivated_button_clicked),
           170 => test_get_errors!(super::shopping::surface_reanalyze_clicked),
           171 => test_get_errors!(super::shopping::surface_settings_expand_clicked),
           172 => test_get_errors!(super::shopping::surface_show_more_reviews_button_clicked),
           173 => test_get_errors!(super::shopping::surface_show_privacy_policy_clicked),
           174 => test_get_errors!(super::shopping::surface_show_quality_explainer_clicked),
           175 => test_get_errors!(super::shopping::surface_show_quality_explainer_url_clicked),
           176 => test_get_errors!(super::shopping::surface_show_terms_clicked),
           177 => test_get_errors!(super::shopping::surface_stale_analysis_shown),
           178 => test_get_errors!(super::shopping::surface_yes_keep_closed_button_clicked),
           198 => test_get_errors!(super::urlbar::abandonment),
           199 => test_get_errors!(super::urlbar::engagement),
           200 => test_get_errors!(super::urlbar::exposure),
           201 => test_get_errors!(super::urlbar::potential_exposure),
           207 => test_get_errors!(super::urlbar::quick_suggest_contextual_opt_in),
           211 => test_get_errors!(super::browser_usage::interaction),
           2580 => test_get_errors!(super::mediadrm::eme_playback),
           2583 => test_get_errors!(super::hls::media_load),
           2588 => test_get_errors!(super::media_playback::first_frame_loaded),
           2590 => test_get_errors!(super::mfcdm::eme_playback),
           2591 => test_get_errors!(super::mfcdm::error),
           2626 => test_get_errors!(super::perf::page_load),
           2834 => test_get_errors!(super::background_tasks_rmdir_base::metric_base),
           2842 => test_get_errors!(super::background_tasks_rmdir_http_cache::metric_base),
           2850 => test_get_errors!(super::background_tasks_rmdir_quota::metric_base),
           2858 => test_get_errors!(super::relevancy_classify::fail),
           2859 => test_get_errors!(super::relevancy_classify::succeed),
           2862 => test_get_errors!(super::cookie_banners::google_gdpr_choice_cookie_event),
           2863 => test_get_errors!(super::cookie_banners::google_gdpr_choice_cookie_event_pbm),
           2866 => test_get_errors!(super::cookie_banners::reload),
           2940 => test_get_errors!(super::extensions_data::migrate_result),
           2941 => test_get_errors!(super::extensions_data::storage_local_error),
           2955 => test_get_errors!(super::formautofill_creditcards::form_cleared),
           2956 => test_get_errors!(super::formautofill_creditcards::form_detected),
           2957 => test_get_errors!(super::formautofill_creditcards::form_filled),
           2958 => test_get_errors!(super::formautofill_creditcards::form_filled_modified),
           2959 => test_get_errors!(super::formautofill_creditcards::form_popup_shown),
           2960 => test_get_errors!(super::formautofill_creditcards::form_submitted),
           3007 => test_get_errors!(super::test_only_ipc::an_event),
           3010 => test_get_errors!(super::test_only_ipc::event_with_extra),
           3012 => test_get_errors!(super::test_only_ipc::no_extra_event),
           3015 => test_get_errors!(super::test_only_jog::an_event),
           3016 => test_get_errors!(super::nimbus_events::enroll_failed),
           3017 => test_get_errors!(super::nimbus_events::enrollment),
           3018 => test_get_errors!(super::nimbus_events::enrollment_status),
           3019 => test_get_errors!(super::nimbus_events::exposure),
           3020 => test_get_errors!(super::nimbus_events::is_ready),
           3021 => test_get_errors!(super::nimbus_events::unenroll_failed),
           3022 => test_get_errors!(super::nimbus_events::unenrollment),
           3023 => test_get_errors!(super::nimbus_events::validation_failed),
           3098 => test_get_errors!(super::webcompatreporting::opened),
           3099 => test_get_errors!(super::webcompatreporting::reason_dropdown),
           3100 => test_get_errors!(super::webcompatreporting::send),
           3101 => test_get_errors!(super::webcompatreporting::send_more_info),
           3206 => test_get_errors!(super::search_engine_default::changed),
           3212 => test_get_errors!(super::search_engine_private::changed),
           3220 => test_get_errors!(super::shopping_product::invalid_ohttp_config),
           3221 => test_get_errors!(super::shopping_product::invalid_request),
           3222 => test_get_errors!(super::shopping_product::invalid_response),
           3223 => test_get_errors!(super::shopping_product::request_aborted),
           3224 => test_get_errors!(super::shopping_product::request_error),
           3225 => test_get_errors!(super::shopping_product::request_failure),
           3226 => test_get_errors!(super::shopping_product::request_retried),
           3227 => test_get_errors!(super::shopping_product::request_retries_failed),
           3228 => test_get_errors!(super::shopping_product::server_failure),
           3232 => test_get_errors!(super::translations::error),
           3236 => test_get_errors!(super::translations::restore_page),
           3237 => test_get_errors!(super::translations::translation_request),
           3238 => test_get_errors!(super::translations_panel::about_translations),
           3239 => test_get_errors!(super::translations_panel::always_offer_translations),
           3240 => test_get_errors!(super::translations_panel::always_translate_language),
           3241 => test_get_errors!(super::translations_panel::cancel_button),
           3242 => test_get_errors!(super::translations_panel::change_from_language),
           3243 => test_get_errors!(super::translations_panel::change_source_language_button),
           3244 => test_get_errors!(super::translations_panel::change_to_language),
           3245 => test_get_errors!(super::translations_panel::close),
           3246 => test_get_errors!(super::translations_panel::close_from_language_menu),
           3247 => test_get_errors!(super::translations_panel::close_settings_menu),
           3248 => test_get_errors!(super::translations_panel::close_to_language_menu),
           3249 => test_get_errors!(super::translations_panel::dismiss_error_button),
           3250 => test_get_errors!(super::translations_panel::learn_more),
           3251 => test_get_errors!(super::translations_panel::manage_languages),
           3252 => test_get_errors!(super::translations_panel::never_translate_language),
           3253 => test_get_errors!(super::translations_panel::never_translate_site),
           3254 => test_get_errors!(super::translations_panel::open),
           3255 => test_get_errors!(super::translations_panel::open_from_language_menu),
           3256 => test_get_errors!(super::translations_panel::open_settings_menu),
           3257 => test_get_errors!(super::translations_panel::open_to_language_menu),
           3258 => test_get_errors!(super::translations_panel::restore_page_button),
           3259 => test_get_errors!(super::translations_panel::translate_button),
           3260 => test_get_errors!(super::translations_select_translations_panel::about_translations),
           3261 => test_get_errors!(super::translations_select_translations_panel::cancel_button),
           3262 => test_get_errors!(super::translations_select_translations_panel::change_from_language),
           3263 => test_get_errors!(super::translations_select_translations_panel::change_to_language),
           3264 => test_get_errors!(super::translations_select_translations_panel::close),
           3265 => test_get_errors!(super::translations_select_translations_panel::copy_button),
           3266 => test_get_errors!(super::translations_select_translations_panel::done_button),
           3267 => test_get_errors!(super::translations_select_translations_panel::initialization_failure_message),
           3268 => test_get_errors!(super::translations_select_translations_panel::open),
           3269 => test_get_errors!(super::translations_select_translations_panel::open_settings_menu),
           3270 => test_get_errors!(super::translations_select_translations_panel::translate_button),
           3271 => test_get_errors!(super::translations_select_translations_panel::translate_full_page_button),
           3272 => test_get_errors!(super::translations_select_translations_panel::translation_failure_message),
           3273 => test_get_errors!(super::translations_select_translations_panel::translation_settings),
           3274 => test_get_errors!(super::translations_select_translations_panel::try_again_button),
           3275 => test_get_errors!(super::translations_select_translations_panel::unsupported_language_message),
           3288 => test_get_errors!(super::addons_manager::install),
           3289 => test_get_errors!(super::addons_manager::install_stats),
           3290 => test_get_errors!(super::addons_manager::manage),
           3291 => test_get_errors!(super::addons_manager::report_suspicious_site),
           3292 => test_get_errors!(super::addons_manager::update),
           3293 => test_get_errors!(super::blocklist::addon_block_change),
           3310 => test_get_errors!(super::file_dialog::fallback_v2),
           _ => panic!("No event for metric id {}", metric_id),
        }

        #[cfg(not(feature = "with_gecko"))]
        {
            return None;
        }
    }

    /// Gets the submetric from the specified labeled_counter metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the counter submetric.
    ///
    /// # Returns
    ///
    /// Returns the counter submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_counter by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_counter_get(metric_id: u32, label: &str) -> LabeledCounterMetric {
        match metric_id {
            57 => super::messaging_system::invalid_nested_data.get(label),
            63 => super::messaging_system::unknown_keys.get(label),
            73 => super::messaging_system_attribution::unknown_keys.get(label),
            134 => super::protocolhandler_mailto::handler_prompt_shown.get(label),
            135 => super::protocolhandler_mailto::prompt_clicked.get(label),
            2577 => super::geolocation::fallback.get(label),
            2579 => super::geolocation::request_result.get(label),
            2584 => super::gmp::update_xml_fetch_result.get(label),
            2585 => super::media_audio::backend.get(label),
            2586 => super::media_audio::init_failure.get(label),
            2589 => super::media_playback::not_supported_video_per_mime_type.get(label),
            2592 => super::codec_stats::audio_preferred_codec.get(label),
            2593 => super::codec_stats::other_fec_signaled.get(label),
            2594 => super::codec_stats::ulpfec_negotiated.get(label),
            2595 => super::codec_stats::video_preferred_codec.get(label),
            2599 => super::rtcrtpsender_setparameters::blame_length_changed.get(label),
            2600 => super::rtcrtpsender_setparameters::blame_no_getparameters.get(label),
            2601 => super::rtcrtpsender_setparameters::blame_no_transactionid.get(label),
            2612 => super::webrtcdtls::cipher.get(label),
            2613 => super::webrtcdtls::client_handshake_result.get(label),
            2614 => super::webrtcdtls::protocol_version.get(label),
            2615 => super::webrtcdtls::server_handshake_result.get(label),
            2616 => super::webrtcdtls::srtp_cipher.get(label),
            2640 => super::private_attribution::database.get(label),
            2641 => super::private_attribution::measure_conversion.get(label),
            2642 => super::private_attribution::save_impression.get(label),
            2651 => super::webauthn_create::authenticator_attachment.get(label),
            2655 => super::webauthn_get::authenticator_attachment.get(label),
            2677 => super::gfx_content_frame_time::reason.get(label),
            2688 => super::gpu_process::crash_fallbacks.get(label),
            2704 => super::avif::a1lx.get(label),
            2705 => super::avif::a1op.get(label),
            2706 => super::avif::alpha.get(label),
            2707 => super::avif::aom_decode_error.get(label),
            2708 => super::avif::bit_depth.get(label),
            2709 => super::avif::cicp_cp.get(label),
            2710 => super::avif::cicp_mc.get(label),
            2711 => super::avif::cicp_tc.get(label),
            2712 => super::avif::clap.get(label),
            2713 => super::avif::colr.get(label),
            2714 => super::avif::decode_result.get(label),
            2715 => super::avif::decoder.get(label),
            2716 => super::avif::grid.get(label),
            2717 => super::avif::ipro.get(label),
            2718 => super::avif::ispe.get(label),
            2719 => super::avif::lsel.get(label),
            2720 => super::avif::pasp.get(label),
            2721 => super::avif::pixi.get(label),
            2722 => super::avif::yuv_color_space.get(label),
            2751 => super::networking::cookie_timestamp_fixed_count.get(label),
            2754 => super::networking::dns_native_count.get(label),
            2773 => super::networking::http_channel_onstart_success_https_rr.get(label),
            2785 => super::networking::http_response_version.get(label),
            2786 => super::networking::https_rr_presented.get(label),
            2787 => super::networking::https_upgrade_with_https_rr.get(label),
            2788 => super::networking::proxy_info_type.get(label),
            2790 => super::networking::residual_cache_folder_removal.get(label),
            2795 => super::networking::speculative_connect_outcome.get(label),
            2798 => super::networking::trr_request_count.get(label),
            2799 => super::netwerk::early_hints.get(label),
            2800 => super::netwerk::eh_link_type.get(label),
            2802 => super::network::cors_authorization_header.get(label),
            2803 => super::network::data_size_pb_per_type.get(label),
            2804 => super::network::data_size_per_type.get(label),
            2812 => super::cert_verifier::crlite_status.get(label),
            2815 => super::cert_compression::failures.get(label),
            2816 => super::cert_compression::used.get(label),
            2822 => super::tls::xyber_intolerance_reason.get(label),
            2830 => super::bounce_tracking_protection::purge_count.get(label),
            2867 => super::cookie_banners::rule_lookup_by_domain.get(label),
            2868 => super::cookie_banners::rule_lookup_by_load.get(label),
            2874 => super::cookie_banners_click::result.get(label),
            2875 => super::cookie_banners_cmp::detected_cmp.get(label),
            2877 => super::cookie_banners_cmp::result.get(label),
            2901 => super::crash_submission::collector_errors.get(label),
            2924 => super::extensions::process_event.get(label),
            2926 => super::extensions::startup_cache_read_errors.get(label),
            2932 => super::extensions_apis_dnr::startup_cache_entries.get(label),
            2938 => super::extensions_counters::browser_action_preload_result.get(label),
            2939 => super::extensions_counters::event_page_idle_result.get(label),
            2953 => super::formautofill::form_submission_heuristic.get(label),
            2980 => super::test_only::mabels_bathroom_counters.get(label),
            2981 => super::test_only::mabels_kitchen_counters.get(label),
            2983 => super::test_only::mabels_labeled_counters.get(label),
            2998 => super::test_only_ipc::a_labeled_counter.get(label),
            3009 => super::test_only_ipc::another_labeled_counter.get(label),
            3024 => super::pwmgr::form_autofill_result.get(label),
            3025 => super::pdfjs::buttons.get(label),
            3026 => super::pdfjs::editing.get(label),
            3027 => super::pdfjs::geckoview.get(label),
            3028 => super::pdfjs::stamp.get(label),
            3031 => super::pdfjs_editing_highlight::color.get(label),
            3035 => super::pdfjs_editing_highlight::kind.get(label),
            3036 => super::pdfjs_editing_highlight::method.get(label),
            3037 => super::pdfjs_editing_highlight::number_of_colors.get(label),
            3044 => super::power::cpu_time_per_process_type_ms.get(label),
            3045 => super::power::cpu_time_per_tracker_type_ms.get(label),
            3046 => super::power::energy_per_process_type.get(label),
            3048 => super::power::gpu_time_per_process_type_ms.get(label),
            3052 => super::power::wakeups_per_process_type.get(label),
            3054 => super::power_cpu_ms_per_thread::content_background.get(label),
            3055 => super::power_cpu_ms_per_thread::content_foreground.get(label),
            3056 => super::power_cpu_ms_per_thread::gpu_process.get(label),
            3057 => super::power_cpu_ms_per_thread::parent_active.get(label),
            3058 => super::power_cpu_ms_per_thread::parent_inactive.get(label),
            3059 => super::power_wakeups_per_thread::content_background.get(label),
            3060 => super::power_wakeups_per_thread::content_foreground.get(label),
            3061 => super::power_wakeups_per_thread::gpu_process.get(label),
            3062 => super::power_wakeups_per_thread::parent_active.get(label),
            3063 => super::power_wakeups_per_thread::parent_inactive.get(label),
            3218 => super::search_service::initialization_status.get(label),
            3229 => super::dap::report_generation_status.get(label),
            3230 => super::dap::upload_status.get(label),
            3234 => super::translations::request_count.get(label),
            _ => panic!("No labeled_counter for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_counter metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the counter submetric.
    ///
    /// # Returns
    ///
    /// Returns the counter submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_counter by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_counter_enum_get(metric_id: u32, label_enum: u16) -> LabeledCounterMetric {
        match metric_id {
            134 => super::protocolhandler_mailto::handler_prompt_shown.get(labeled_enum_to_str(metric_id, label_enum)),
            135 => super::protocolhandler_mailto::prompt_clicked.get(labeled_enum_to_str(metric_id, label_enum)),
            2577 => super::geolocation::fallback.get(labeled_enum_to_str(metric_id, label_enum)),
            2579 => super::geolocation::request_result.get(labeled_enum_to_str(metric_id, label_enum)),
            2584 => super::gmp::update_xml_fetch_result.get(labeled_enum_to_str(metric_id, label_enum)),
            2585 => super::media_audio::backend.get(labeled_enum_to_str(metric_id, label_enum)),
            2586 => super::media_audio::init_failure.get(labeled_enum_to_str(metric_id, label_enum)),
            2594 => super::codec_stats::ulpfec_negotiated.get(labeled_enum_to_str(metric_id, label_enum)),
            2640 => super::private_attribution::database.get(labeled_enum_to_str(metric_id, label_enum)),
            2641 => super::private_attribution::measure_conversion.get(labeled_enum_to_str(metric_id, label_enum)),
            2642 => super::private_attribution::save_impression.get(labeled_enum_to_str(metric_id, label_enum)),
            2651 => super::webauthn_create::authenticator_attachment.get(labeled_enum_to_str(metric_id, label_enum)),
            2655 => super::webauthn_get::authenticator_attachment.get(labeled_enum_to_str(metric_id, label_enum)),
            2677 => super::gfx_content_frame_time::reason.get(labeled_enum_to_str(metric_id, label_enum)),
            2688 => super::gpu_process::crash_fallbacks.get(labeled_enum_to_str(metric_id, label_enum)),
            2704 => super::avif::a1lx.get(labeled_enum_to_str(metric_id, label_enum)),
            2705 => super::avif::a1op.get(labeled_enum_to_str(metric_id, label_enum)),
            2706 => super::avif::alpha.get(labeled_enum_to_str(metric_id, label_enum)),
            2707 => super::avif::aom_decode_error.get(labeled_enum_to_str(metric_id, label_enum)),
            2708 => super::avif::bit_depth.get(labeled_enum_to_str(metric_id, label_enum)),
            2709 => super::avif::cicp_cp.get(labeled_enum_to_str(metric_id, label_enum)),
            2710 => super::avif::cicp_mc.get(labeled_enum_to_str(metric_id, label_enum)),
            2711 => super::avif::cicp_tc.get(labeled_enum_to_str(metric_id, label_enum)),
            2712 => super::avif::clap.get(labeled_enum_to_str(metric_id, label_enum)),
            2713 => super::avif::colr.get(labeled_enum_to_str(metric_id, label_enum)),
            2714 => super::avif::decode_result.get(labeled_enum_to_str(metric_id, label_enum)),
            2715 => super::avif::decoder.get(labeled_enum_to_str(metric_id, label_enum)),
            2716 => super::avif::grid.get(labeled_enum_to_str(metric_id, label_enum)),
            2717 => super::avif::ipro.get(labeled_enum_to_str(metric_id, label_enum)),
            2718 => super::avif::ispe.get(labeled_enum_to_str(metric_id, label_enum)),
            2719 => super::avif::lsel.get(labeled_enum_to_str(metric_id, label_enum)),
            2720 => super::avif::pasp.get(labeled_enum_to_str(metric_id, label_enum)),
            2721 => super::avif::pixi.get(labeled_enum_to_str(metric_id, label_enum)),
            2722 => super::avif::yuv_color_space.get(labeled_enum_to_str(metric_id, label_enum)),
            2751 => super::networking::cookie_timestamp_fixed_count.get(labeled_enum_to_str(metric_id, label_enum)),
            2754 => super::networking::dns_native_count.get(labeled_enum_to_str(metric_id, label_enum)),
            2773 => super::networking::http_channel_onstart_success_https_rr.get(labeled_enum_to_str(metric_id, label_enum)),
            2785 => super::networking::http_response_version.get(labeled_enum_to_str(metric_id, label_enum)),
            2786 => super::networking::https_rr_presented.get(labeled_enum_to_str(metric_id, label_enum)),
            2787 => super::networking::https_upgrade_with_https_rr.get(labeled_enum_to_str(metric_id, label_enum)),
            2788 => super::networking::proxy_info_type.get(labeled_enum_to_str(metric_id, label_enum)),
            2790 => super::networking::residual_cache_folder_removal.get(labeled_enum_to_str(metric_id, label_enum)),
            2795 => super::networking::speculative_connect_outcome.get(labeled_enum_to_str(metric_id, label_enum)),
            2798 => super::networking::trr_request_count.get(labeled_enum_to_str(metric_id, label_enum)),
            2799 => super::netwerk::early_hints.get(labeled_enum_to_str(metric_id, label_enum)),
            2800 => super::netwerk::eh_link_type.get(labeled_enum_to_str(metric_id, label_enum)),
            2802 => super::network::cors_authorization_header.get(labeled_enum_to_str(metric_id, label_enum)),
            2803 => super::network::data_size_pb_per_type.get(labeled_enum_to_str(metric_id, label_enum)),
            2804 => super::network::data_size_per_type.get(labeled_enum_to_str(metric_id, label_enum)),
            2812 => super::cert_verifier::crlite_status.get(labeled_enum_to_str(metric_id, label_enum)),
            2815 => super::cert_compression::failures.get(labeled_enum_to_str(metric_id, label_enum)),
            2816 => super::cert_compression::used.get(labeled_enum_to_str(metric_id, label_enum)),
            2822 => super::tls::xyber_intolerance_reason.get(labeled_enum_to_str(metric_id, label_enum)),
            2830 => super::bounce_tracking_protection::purge_count.get(labeled_enum_to_str(metric_id, label_enum)),
            2867 => super::cookie_banners::rule_lookup_by_domain.get(labeled_enum_to_str(metric_id, label_enum)),
            2868 => super::cookie_banners::rule_lookup_by_load.get(labeled_enum_to_str(metric_id, label_enum)),
            2874 => super::cookie_banners_click::result.get(labeled_enum_to_str(metric_id, label_enum)),
            2877 => super::cookie_banners_cmp::result.get(labeled_enum_to_str(metric_id, label_enum)),
            2924 => super::extensions::process_event.get(labeled_enum_to_str(metric_id, label_enum)),
            2932 => super::extensions_apis_dnr::startup_cache_entries.get(labeled_enum_to_str(metric_id, label_enum)),
            2938 => super::extensions_counters::browser_action_preload_result.get(labeled_enum_to_str(metric_id, label_enum)),
            2939 => super::extensions_counters::event_page_idle_result.get(labeled_enum_to_str(metric_id, label_enum)),
            2953 => super::formautofill::form_submission_heuristic.get(labeled_enum_to_str(metric_id, label_enum)),
            2983 => super::test_only::mabels_labeled_counters.get(labeled_enum_to_str(metric_id, label_enum)),
            3024 => super::pwmgr::form_autofill_result.get(labeled_enum_to_str(metric_id, label_enum)),
            3025 => super::pdfjs::buttons.get(labeled_enum_to_str(metric_id, label_enum)),
            3026 => super::pdfjs::editing.get(labeled_enum_to_str(metric_id, label_enum)),
            3027 => super::pdfjs::geckoview.get(labeled_enum_to_str(metric_id, label_enum)),
            3028 => super::pdfjs::stamp.get(labeled_enum_to_str(metric_id, label_enum)),
            3031 => super::pdfjs_editing_highlight::color.get(labeled_enum_to_str(metric_id, label_enum)),
            3035 => super::pdfjs_editing_highlight::kind.get(labeled_enum_to_str(metric_id, label_enum)),
            3036 => super::pdfjs_editing_highlight::method.get(labeled_enum_to_str(metric_id, label_enum)),
            3037 => super::pdfjs_editing_highlight::number_of_colors.get(labeled_enum_to_str(metric_id, label_enum)),
            3044 => super::power::cpu_time_per_process_type_ms.get(labeled_enum_to_str(metric_id, label_enum)),
            3045 => super::power::cpu_time_per_tracker_type_ms.get(labeled_enum_to_str(metric_id, label_enum)),
            3046 => super::power::energy_per_process_type.get(labeled_enum_to_str(metric_id, label_enum)),
            3048 => super::power::gpu_time_per_process_type_ms.get(labeled_enum_to_str(metric_id, label_enum)),
            3052 => super::power::wakeups_per_process_type.get(labeled_enum_to_str(metric_id, label_enum)),
            3054 => super::power_cpu_ms_per_thread::content_background.get(labeled_enum_to_str(metric_id, label_enum)),
            3055 => super::power_cpu_ms_per_thread::content_foreground.get(labeled_enum_to_str(metric_id, label_enum)),
            3056 => super::power_cpu_ms_per_thread::gpu_process.get(labeled_enum_to_str(metric_id, label_enum)),
            3057 => super::power_cpu_ms_per_thread::parent_active.get(labeled_enum_to_str(metric_id, label_enum)),
            3058 => super::power_cpu_ms_per_thread::parent_inactive.get(labeled_enum_to_str(metric_id, label_enum)),
            3059 => super::power_wakeups_per_thread::content_background.get(labeled_enum_to_str(metric_id, label_enum)),
            3060 => super::power_wakeups_per_thread::content_foreground.get(labeled_enum_to_str(metric_id, label_enum)),
            3061 => super::power_wakeups_per_thread::gpu_process.get(labeled_enum_to_str(metric_id, label_enum)),
            3062 => super::power_wakeups_per_thread::parent_active.get(labeled_enum_to_str(metric_id, label_enum)),
            3063 => super::power_wakeups_per_thread::parent_inactive.get(labeled_enum_to_str(metric_id, label_enum)),
            3218 => super::search_service::initialization_status.get(labeled_enum_to_str(metric_id, label_enum)),
            3229 => super::dap::report_generation_status.get(labeled_enum_to_str(metric_id, label_enum)),
            3230 => super::dap::upload_status.get(labeled_enum_to_str(metric_id, label_enum)),
            3234 => super::translations::request_count.get(labeled_enum_to_str(metric_id, label_enum)),
            _ => panic!("No labeled_counter for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_boolean metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the boolean submetric.
    ///
    /// # Returns
    ///
    /// Returns the boolean submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_boolean by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_boolean_get(metric_id: u32, label: &str) -> LabeledBooleanMetric {
        match metric_id {
            2578 => super::geolocation::linux_provider.get(label),
            2587 => super::media_playback::device_hardware_decoder_support.get(label),
            2864 => super::cookie_banners::normal_window_service_mode.get(label),
            2865 => super::cookie_banners::private_window_service_mode.get(label),
            2984 => super::test_only::mabels_like_balloons.get(label),
            2985 => super::test_only::mabels_like_labeled_balloons.get(label),
            2989 => super::test_only::mirrors_for_labeled_bools.get(label),
            _ => panic!("No labeled_boolean for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_boolean metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the boolean submetric.
    ///
    /// # Returns
    ///
    /// Returns the boolean submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_boolean by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_boolean_enum_get(metric_id: u32, label_enum: u16) -> LabeledBooleanMetric {
        match metric_id {
            2578 => super::geolocation::linux_provider.get(labeled_enum_to_str(metric_id, label_enum)),
            2587 => super::media_playback::device_hardware_decoder_support.get(labeled_enum_to_str(metric_id, label_enum)),
            2864 => super::cookie_banners::normal_window_service_mode.get(labeled_enum_to_str(metric_id, label_enum)),
            2865 => super::cookie_banners::private_window_service_mode.get(labeled_enum_to_str(metric_id, label_enum)),
            2985 => super::test_only::mabels_like_labeled_balloons.get(labeled_enum_to_str(metric_id, label_enum)),
            _ => panic!("No labeled_boolean for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_string metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the string submetric.
    ///
    /// # Returns
    ///
    /// Returns the string submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_string by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_string_get(metric_id: u32, label: &str) -> LabeledStringMetric {
        match metric_id {
            2861 => super::cookie_banners::google_gdpr_choice_cookie.get(label),
            2978 => super::test_only::mabels_balloon_labels.get(label),
            2979 => super::test_only::mabels_balloon_strings.get(label),
            2982 => super::test_only::mabels_label_maker.get(label),
            _ => panic!("No labeled_string for metric id {}", metric_id),
        }
    }

    /// Gets the submetric from the specified labeled_string metric, by enum.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label_enum` - The label enum identifying the string submetric.
    ///
    /// # Returns
    ///
    /// Returns the string submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_string by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_string_enum_get(metric_id: u32, label_enum: u16) -> LabeledStringMetric {
        match metric_id {
            2978 => super::test_only::mabels_balloon_labels.get(labeled_enum_to_str(metric_id, label_enum)),
            _ => panic!("No labeled_string for metric id {}", metric_id),
        }
    }

    pub(crate) fn labeled_enum_to_str(metric_id: u32, label: u16) -> &'static str {
        match metric_id {
            134 => super::protocolhandler_mailto::HandlerPromptShownLabel::from(label).into(),
            135 => super::protocolhandler_mailto::PromptClickedLabel::from(label).into(),
            2577 => super::geolocation::FallbackLabel::from(label).into(),
            2578 => super::geolocation::LinuxProviderLabel::from(label).into(),
            2579 => super::geolocation::RequestResultLabel::from(label).into(),
            2584 => super::gmp::UpdateXmlFetchResultLabel::from(label).into(),
            2585 => super::media_audio::BackendLabel::from(label).into(),
            2586 => super::media_audio::InitFailureLabel::from(label).into(),
            2587 => super::media_playback::DeviceHardwareDecoderSupportLabel::from(label).into(),
            2594 => super::codec_stats::UlpfecNegotiatedLabel::from(label).into(),
            2640 => super::private_attribution::DatabaseLabel::from(label).into(),
            2641 => super::private_attribution::MeasureConversionLabel::from(label).into(),
            2642 => super::private_attribution::SaveImpressionLabel::from(label).into(),
            2651 => super::webauthn_create::AuthenticatorAttachmentLabel::from(label).into(),
            2655 => super::webauthn_get::AuthenticatorAttachmentLabel::from(label).into(),
            2677 => super::gfx_content_frame_time::ReasonLabel::from(label).into(),
            2688 => super::gpu_process::CrashFallbacksLabel::from(label).into(),
            2704 => super::avif::A1lxLabel::from(label).into(),
            2705 => super::avif::A1opLabel::from(label).into(),
            2706 => super::avif::AlphaLabel::from(label).into(),
            2707 => super::avif::AomDecodeErrorLabel::from(label).into(),
            2708 => super::avif::BitDepthLabel::from(label).into(),
            2709 => super::avif::CicpCpLabel::from(label).into(),
            2710 => super::avif::CicpMcLabel::from(label).into(),
            2711 => super::avif::CicpTcLabel::from(label).into(),
            2712 => super::avif::ClapLabel::from(label).into(),
            2713 => super::avif::ColrLabel::from(label).into(),
            2714 => super::avif::DecodeResultLabel::from(label).into(),
            2715 => super::avif::DecoderLabel::from(label).into(),
            2716 => super::avif::GridLabel::from(label).into(),
            2717 => super::avif::IproLabel::from(label).into(),
            2718 => super::avif::IspeLabel::from(label).into(),
            2719 => super::avif::LselLabel::from(label).into(),
            2720 => super::avif::PaspLabel::from(label).into(),
            2721 => super::avif::PixiLabel::from(label).into(),
            2722 => super::avif::YuvColorSpaceLabel::from(label).into(),
            2751 => super::networking::CookieTimestampFixedCountLabel::from(label).into(),
            2754 => super::networking::DnsNativeCountLabel::from(label).into(),
            2773 => super::networking::HttpChannelOnstartSuccessHttpsRrLabel::from(label).into(),
            2785 => super::networking::HttpResponseVersionLabel::from(label).into(),
            2786 => super::networking::HttpsRrPresentedLabel::from(label).into(),
            2787 => super::networking::HttpsUpgradeWithHttpsRrLabel::from(label).into(),
            2788 => super::networking::ProxyInfoTypeLabel::from(label).into(),
            2790 => super::networking::ResidualCacheFolderRemovalLabel::from(label).into(),
            2795 => super::networking::SpeculativeConnectOutcomeLabel::from(label).into(),
            2798 => super::networking::TrrRequestCountLabel::from(label).into(),
            2799 => super::netwerk::EarlyHintsLabel::from(label).into(),
            2800 => super::netwerk::EhLinkTypeLabel::from(label).into(),
            2802 => super::network::CorsAuthorizationHeaderLabel::from(label).into(),
            2803 => super::network::DataSizePbPerTypeLabel::from(label).into(),
            2804 => super::network::DataSizePerTypeLabel::from(label).into(),
            2812 => super::cert_verifier::CrliteStatusLabel::from(label).into(),
            2815 => super::cert_compression::FailuresLabel::from(label).into(),
            2816 => super::cert_compression::UsedLabel::from(label).into(),
            2822 => super::tls::XyberIntoleranceReasonLabel::from(label).into(),
            2830 => super::bounce_tracking_protection::PurgeCountLabel::from(label).into(),
            2864 => super::cookie_banners::NormalWindowServiceModeLabel::from(label).into(),
            2865 => super::cookie_banners::PrivateWindowServiceModeLabel::from(label).into(),
            2867 => super::cookie_banners::RuleLookupByDomainLabel::from(label).into(),
            2868 => super::cookie_banners::RuleLookupByLoadLabel::from(label).into(),
            2874 => super::cookie_banners_click::ResultLabel::from(label).into(),
            2877 => super::cookie_banners_cmp::ResultLabel::from(label).into(),
            2924 => super::extensions::ProcessEventLabel::from(label).into(),
            2932 => super::extensions_apis_dnr::StartupCacheEntriesLabel::from(label).into(),
            2938 => super::extensions_counters::BrowserActionPreloadResultLabel::from(label).into(),
            2939 => super::extensions_counters::EventPageIdleResultLabel::from(label).into(),
            2953 => super::formautofill::FormSubmissionHeuristicLabel::from(label).into(),
            2978 => super::test_only::MabelsBalloonLabelsLabel::from(label).into(),
            2983 => super::test_only::MabelsLabeledCountersLabel::from(label).into(),
            2985 => super::test_only::MabelsLikeLabeledBalloonsLabel::from(label).into(),
            3024 => super::pwmgr::FormAutofillResultLabel::from(label).into(),
            3025 => super::pdfjs::ButtonsLabel::from(label).into(),
            3026 => super::pdfjs::EditingLabel::from(label).into(),
            3027 => super::pdfjs::GeckoviewLabel::from(label).into(),
            3028 => super::pdfjs::StampLabel::from(label).into(),
            3031 => super::pdfjs_editing_highlight::ColorLabel::from(label).into(),
            3035 => super::pdfjs_editing_highlight::KindLabel::from(label).into(),
            3036 => super::pdfjs_editing_highlight::MethodLabel::from(label).into(),
            3037 => super::pdfjs_editing_highlight::NumberOfColorsLabel::from(label).into(),
            3044 => super::power::CpuTimePerProcessTypeMsLabel::from(label).into(),
            3045 => super::power::CpuTimePerTrackerTypeMsLabel::from(label).into(),
            3046 => super::power::EnergyPerProcessTypeLabel::from(label).into(),
            3048 => super::power::GpuTimePerProcessTypeMsLabel::from(label).into(),
            3052 => super::power::WakeupsPerProcessTypeLabel::from(label).into(),
            3054 => super::power_cpu_ms_per_thread::ContentBackgroundLabel::from(label).into(),
            3055 => super::power_cpu_ms_per_thread::ContentForegroundLabel::from(label).into(),
            3056 => super::power_cpu_ms_per_thread::GpuProcessLabel::from(label).into(),
            3057 => super::power_cpu_ms_per_thread::ParentActiveLabel::from(label).into(),
            3058 => super::power_cpu_ms_per_thread::ParentInactiveLabel::from(label).into(),
            3059 => super::power_wakeups_per_thread::ContentBackgroundLabel::from(label).into(),
            3060 => super::power_wakeups_per_thread::ContentForegroundLabel::from(label).into(),
            3061 => super::power_wakeups_per_thread::GpuProcessLabel::from(label).into(),
            3062 => super::power_wakeups_per_thread::ParentActiveLabel::from(label).into(),
            3063 => super::power_wakeups_per_thread::ParentInactiveLabel::from(label).into(),
            3218 => super::search_service::InitializationStatusLabel::from(label).into(),
            3229 => super::dap::ReportGenerationStatusLabel::from(label).into(),
            3230 => super::dap::UploadStatusLabel::from(label).into(),
            3234 => super::translations::RequestCountLabel::from(label).into(),
            _ => panic!("Can't turn label enum to string for metric {} which isn't a labeled metric with static labels", metric_id),
        }
    }

    pub(crate) mod submetric_maps {
        use std::sync::{
          atomic::AtomicU32,
          RwLock,
        };
        use super::*;

        pub(crate) const SUBMETRIC_BIT: u32 = 25;
        pub(crate) static NEXT_LABELED_SUBMETRIC_ID: AtomicU32 = AtomicU32::new((1 << SUBMETRIC_BIT) + 1);
        pub(crate) static LABELED_METRICS_TO_IDS: Lazy<RwLock<HashMap<(u32, String), u32>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub(crate) static LABELED_ENUMS_TO_IDS: Lazy<RwLock<HashMap<(u32, u16), u32>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );

        pub static BOOLEAN_MAP: Lazy<RwLock<HashMap<MetricId, LabeledBooleanMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static STRING_MAP: Lazy<RwLock<HashMap<MetricId, LabeledStringMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static COUNTER_MAP: Lazy<RwLock<HashMap<MetricId, LabeledCounterMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
    }
}

